// SPDX-FileCopyrightText: © 2023 Tenstorrent Inc.
//
// SPDX-License-Identifier: Apache-2.0
////////////////////////////////////////////////////////////////////////
// File generated by
// ${ROOT}/src/meta/regspecs/src/genCfgRegs.py
// from
// ${ROOT}/src/meta/regspecs/yaml/local_regs_per_exu.yaml
//
// Constants for Tensix registers
//
////////////////////////////////////////////////////////////////////////

#pragma once

#define CFG_STATE_SIZE 56
#define THD_STATE_SIZE 68

////////////////////////////////////////////////////////////////////////
// Registers for THREAD
////////////////////////////////////////////////////////////////////////

#define THREAD_CFGREG_BASE_ADDR32 0

#define CFG_STATE_ID_StateID_ADDR32 0
#define CFG_STATE_ID_StateID_SHAMT 0
#define CFG_STATE_ID_StateID_MASK 0x1
#define CFG_STATE_ID_StateID_RMW CFG_STATE_ID_StateID_ADDR32, CFG_STATE_ID_StateID_SHAMT, CFG_STATE_ID_StateID_MASK

#define DEST_TARGET_REG_CFG_MATH_Offset_ADDR32 1
#define DEST_TARGET_REG_CFG_MATH_Offset_SHAMT 0
#define DEST_TARGET_REG_CFG_MATH_Offset_MASK 0xfff
#define DEST_TARGET_REG_CFG_MATH_Offset_RMW \
    DEST_TARGET_REG_CFG_MATH_Offset_ADDR32, DEST_TARGET_REG_CFG_MATH_Offset_SHAMT, DEST_TARGET_REG_CFG_MATH_Offset_MASK

#define DISABLE_IMPLIED_SRCA_FMT_Base_ADDR32 2
#define DISABLE_IMPLIED_SRCA_FMT_Base_SHAMT 0
#define DISABLE_IMPLIED_SRCA_FMT_Base_MASK 0x1
#define DISABLE_IMPLIED_SRCA_FMT_Base_RMW \
    DISABLE_IMPLIED_SRCA_FMT_Base_ADDR32, DISABLE_IMPLIED_SRCA_FMT_Base_SHAMT, DISABLE_IMPLIED_SRCA_FMT_Base_MASK

#define DISABLE_IMPLIED_SRCB_FMT_Base_ADDR32 3
#define DISABLE_IMPLIED_SRCB_FMT_Base_SHAMT 0
#define DISABLE_IMPLIED_SRCB_FMT_Base_MASK 0x1
#define DISABLE_IMPLIED_SRCB_FMT_Base_RMW \
    DISABLE_IMPLIED_SRCB_FMT_Base_ADDR32, DISABLE_IMPLIED_SRCB_FMT_Base_SHAMT, DISABLE_IMPLIED_SRCB_FMT_Base_MASK

#define SFPU_DEST_FMT_Enable_ADDR32 4
#define SFPU_DEST_FMT_Enable_SHAMT 0
#define SFPU_DEST_FMT_Enable_MASK 0x1
#define SFPU_DEST_FMT_Enable_RMW SFPU_DEST_FMT_Enable_ADDR32, SFPU_DEST_FMT_Enable_SHAMT, SFPU_DEST_FMT_Enable_MASK

#define SFPU_DEST_FMT_Base_ADDR32 4
#define SFPU_DEST_FMT_Base_SHAMT 1
#define SFPU_DEST_FMT_Base_MASK 0x1e
#define SFPU_DEST_FMT_Base_RMW SFPU_DEST_FMT_Base_ADDR32, SFPU_DEST_FMT_Base_SHAMT, SFPU_DEST_FMT_Base_MASK

#define SRCA_SET_Base_ADDR32 5
#define SRCA_SET_Base_SHAMT 0
#define SRCA_SET_Base_MASK 0x3
#define SRCA_SET_Base_RMW SRCA_SET_Base_ADDR32, SRCA_SET_Base_SHAMT, SRCA_SET_Base_MASK

#define SRCA_SET_SetOvrdWithAddr_ADDR32 5
#define SRCA_SET_SetOvrdWithAddr_SHAMT 2
#define SRCA_SET_SetOvrdWithAddr_MASK 0x4
#define SRCA_SET_SetOvrdWithAddr_RMW \
    SRCA_SET_SetOvrdWithAddr_ADDR32, SRCA_SET_SetOvrdWithAddr_SHAMT, SRCA_SET_SetOvrdWithAddr_MASK

#define SRCB_SET_Base_ADDR32 6
#define SRCB_SET_Base_SHAMT 0
#define SRCB_SET_Base_MASK 0x3
#define SRCB_SET_Base_RMW SRCB_SET_Base_ADDR32, SRCB_SET_Base_SHAMT, SRCB_SET_Base_MASK

#define CLR_DVALID_SrcA_Disable_ADDR32 7
#define CLR_DVALID_SrcA_Disable_SHAMT 0
#define CLR_DVALID_SrcA_Disable_MASK 0x1
#define CLR_DVALID_SrcA_Disable_RMW \
    CLR_DVALID_SrcA_Disable_ADDR32, CLR_DVALID_SrcA_Disable_SHAMT, CLR_DVALID_SrcA_Disable_MASK

#define CLR_DVALID_SrcB_Disable_ADDR32 7
#define CLR_DVALID_SrcB_Disable_SHAMT 1
#define CLR_DVALID_SrcB_Disable_MASK 0x2
#define CLR_DVALID_SrcB_Disable_RMW \
    CLR_DVALID_SrcB_Disable_ADDR32, CLR_DVALID_SrcB_Disable_SHAMT, CLR_DVALID_SrcB_Disable_MASK

#define SCBD_BANK_MASK_32b_Enable_ADDR32 8
#define SCBD_BANK_MASK_32b_Enable_SHAMT 0
#define SCBD_BANK_MASK_32b_Enable_MASK 0x1
#define SCBD_BANK_MASK_32b_Enable_RMW \
    SCBD_BANK_MASK_32b_Enable_ADDR32, SCBD_BANK_MASK_32b_Enable_SHAMT, SCBD_BANK_MASK_32b_Enable_MASK

#define PACK_SCBD_BANK_MASK_32b_Enable_ADDR32 9
#define PACK_SCBD_BANK_MASK_32b_Enable_SHAMT 0
#define PACK_SCBD_BANK_MASK_32b_Enable_MASK 0x1
#define PACK_SCBD_BANK_MASK_32b_Enable_RMW \
    PACK_SCBD_BANK_MASK_32b_Enable_ADDR32, PACK_SCBD_BANK_MASK_32b_Enable_SHAMT, PACK_SCBD_BANK_MASK_32b_Enable_MASK

#define UNPACK_SCBD_BANK_MASK_32b_Enable_ADDR32 10
#define UNPACK_SCBD_BANK_MASK_32b_Enable_SHAMT 0
#define UNPACK_SCBD_BANK_MASK_32b_Enable_MASK 0x1
#define UNPACK_SCBD_BANK_MASK_32b_Enable_RMW                                         \
    UNPACK_SCBD_BANK_MASK_32b_Enable_ADDR32, UNPACK_SCBD_BANK_MASK_32b_Enable_SHAMT, \
        UNPACK_SCBD_BANK_MASK_32b_Enable_MASK

#define FIDELITY_BASE_Phase_ADDR32 11
#define FIDELITY_BASE_Phase_SHAMT 0
#define FIDELITY_BASE_Phase_MASK 0x3
#define FIDELITY_BASE_Phase_RMW FIDELITY_BASE_Phase_ADDR32, FIDELITY_BASE_Phase_SHAMT, FIDELITY_BASE_Phase_MASK

#define ADDR_MOD_AB_SEC0_SrcAIncr_ADDR32 12
#define ADDR_MOD_AB_SEC0_SrcAIncr_SHAMT 0
#define ADDR_MOD_AB_SEC0_SrcAIncr_MASK 0x3f
#define ADDR_MOD_AB_SEC0_SrcAIncr_RMW \
    ADDR_MOD_AB_SEC0_SrcAIncr_ADDR32, ADDR_MOD_AB_SEC0_SrcAIncr_SHAMT, ADDR_MOD_AB_SEC0_SrcAIncr_MASK

#define ADDR_MOD_AB_SEC0_SrcACR_ADDR32 12
#define ADDR_MOD_AB_SEC0_SrcACR_SHAMT 6
#define ADDR_MOD_AB_SEC0_SrcACR_MASK 0x40
#define ADDR_MOD_AB_SEC0_SrcACR_RMW \
    ADDR_MOD_AB_SEC0_SrcACR_ADDR32, ADDR_MOD_AB_SEC0_SrcACR_SHAMT, ADDR_MOD_AB_SEC0_SrcACR_MASK

#define ADDR_MOD_AB_SEC0_SrcAClear_ADDR32 12
#define ADDR_MOD_AB_SEC0_SrcAClear_SHAMT 7
#define ADDR_MOD_AB_SEC0_SrcAClear_MASK 0x80
#define ADDR_MOD_AB_SEC0_SrcAClear_RMW \
    ADDR_MOD_AB_SEC0_SrcAClear_ADDR32, ADDR_MOD_AB_SEC0_SrcAClear_SHAMT, ADDR_MOD_AB_SEC0_SrcAClear_MASK

#define ADDR_MOD_AB_SEC0_SrcBIncr_ADDR32 12
#define ADDR_MOD_AB_SEC0_SrcBIncr_SHAMT 8
#define ADDR_MOD_AB_SEC0_SrcBIncr_MASK 0x3f00
#define ADDR_MOD_AB_SEC0_SrcBIncr_RMW \
    ADDR_MOD_AB_SEC0_SrcBIncr_ADDR32, ADDR_MOD_AB_SEC0_SrcBIncr_SHAMT, ADDR_MOD_AB_SEC0_SrcBIncr_MASK

#define ADDR_MOD_AB_SEC0_SrcBCR_ADDR32 12
#define ADDR_MOD_AB_SEC0_SrcBCR_SHAMT 14
#define ADDR_MOD_AB_SEC0_SrcBCR_MASK 0x4000
#define ADDR_MOD_AB_SEC0_SrcBCR_RMW \
    ADDR_MOD_AB_SEC0_SrcBCR_ADDR32, ADDR_MOD_AB_SEC0_SrcBCR_SHAMT, ADDR_MOD_AB_SEC0_SrcBCR_MASK

#define ADDR_MOD_AB_SEC0_SrcBClear_ADDR32 12
#define ADDR_MOD_AB_SEC0_SrcBClear_SHAMT 15
#define ADDR_MOD_AB_SEC0_SrcBClear_MASK 0x8000
#define ADDR_MOD_AB_SEC0_SrcBClear_RMW \
    ADDR_MOD_AB_SEC0_SrcBClear_ADDR32, ADDR_MOD_AB_SEC0_SrcBClear_SHAMT, ADDR_MOD_AB_SEC0_SrcBClear_MASK

#define ADDR_MOD_AB_SEC1_SrcAIncr_ADDR32 13
#define ADDR_MOD_AB_SEC1_SrcAIncr_SHAMT 0
#define ADDR_MOD_AB_SEC1_SrcAIncr_MASK 0x3f
#define ADDR_MOD_AB_SEC1_SrcAIncr_RMW \
    ADDR_MOD_AB_SEC1_SrcAIncr_ADDR32, ADDR_MOD_AB_SEC1_SrcAIncr_SHAMT, ADDR_MOD_AB_SEC1_SrcAIncr_MASK

#define ADDR_MOD_AB_SEC1_SrcACR_ADDR32 13
#define ADDR_MOD_AB_SEC1_SrcACR_SHAMT 6
#define ADDR_MOD_AB_SEC1_SrcACR_MASK 0x40
#define ADDR_MOD_AB_SEC1_SrcACR_RMW \
    ADDR_MOD_AB_SEC1_SrcACR_ADDR32, ADDR_MOD_AB_SEC1_SrcACR_SHAMT, ADDR_MOD_AB_SEC1_SrcACR_MASK

#define ADDR_MOD_AB_SEC1_SrcAClear_ADDR32 13
#define ADDR_MOD_AB_SEC1_SrcAClear_SHAMT 7
#define ADDR_MOD_AB_SEC1_SrcAClear_MASK 0x80
#define ADDR_MOD_AB_SEC1_SrcAClear_RMW \
    ADDR_MOD_AB_SEC1_SrcAClear_ADDR32, ADDR_MOD_AB_SEC1_SrcAClear_SHAMT, ADDR_MOD_AB_SEC1_SrcAClear_MASK

#define ADDR_MOD_AB_SEC1_SrcBIncr_ADDR32 13
#define ADDR_MOD_AB_SEC1_SrcBIncr_SHAMT 8
#define ADDR_MOD_AB_SEC1_SrcBIncr_MASK 0x3f00
#define ADDR_MOD_AB_SEC1_SrcBIncr_RMW \
    ADDR_MOD_AB_SEC1_SrcBIncr_ADDR32, ADDR_MOD_AB_SEC1_SrcBIncr_SHAMT, ADDR_MOD_AB_SEC1_SrcBIncr_MASK

#define ADDR_MOD_AB_SEC1_SrcBCR_ADDR32 13
#define ADDR_MOD_AB_SEC1_SrcBCR_SHAMT 14
#define ADDR_MOD_AB_SEC1_SrcBCR_MASK 0x4000
#define ADDR_MOD_AB_SEC1_SrcBCR_RMW \
    ADDR_MOD_AB_SEC1_SrcBCR_ADDR32, ADDR_MOD_AB_SEC1_SrcBCR_SHAMT, ADDR_MOD_AB_SEC1_SrcBCR_MASK

#define ADDR_MOD_AB_SEC1_SrcBClear_ADDR32 13
#define ADDR_MOD_AB_SEC1_SrcBClear_SHAMT 15
#define ADDR_MOD_AB_SEC1_SrcBClear_MASK 0x8000
#define ADDR_MOD_AB_SEC1_SrcBClear_RMW \
    ADDR_MOD_AB_SEC1_SrcBClear_ADDR32, ADDR_MOD_AB_SEC1_SrcBClear_SHAMT, ADDR_MOD_AB_SEC1_SrcBClear_MASK

#define ADDR_MOD_AB_SEC2_SrcAIncr_ADDR32 14
#define ADDR_MOD_AB_SEC2_SrcAIncr_SHAMT 0
#define ADDR_MOD_AB_SEC2_SrcAIncr_MASK 0x3f
#define ADDR_MOD_AB_SEC2_SrcAIncr_RMW \
    ADDR_MOD_AB_SEC2_SrcAIncr_ADDR32, ADDR_MOD_AB_SEC2_SrcAIncr_SHAMT, ADDR_MOD_AB_SEC2_SrcAIncr_MASK

#define ADDR_MOD_AB_SEC2_SrcACR_ADDR32 14
#define ADDR_MOD_AB_SEC2_SrcACR_SHAMT 6
#define ADDR_MOD_AB_SEC2_SrcACR_MASK 0x40
#define ADDR_MOD_AB_SEC2_SrcACR_RMW \
    ADDR_MOD_AB_SEC2_SrcACR_ADDR32, ADDR_MOD_AB_SEC2_SrcACR_SHAMT, ADDR_MOD_AB_SEC2_SrcACR_MASK

#define ADDR_MOD_AB_SEC2_SrcAClear_ADDR32 14
#define ADDR_MOD_AB_SEC2_SrcAClear_SHAMT 7
#define ADDR_MOD_AB_SEC2_SrcAClear_MASK 0x80
#define ADDR_MOD_AB_SEC2_SrcAClear_RMW \
    ADDR_MOD_AB_SEC2_SrcAClear_ADDR32, ADDR_MOD_AB_SEC2_SrcAClear_SHAMT, ADDR_MOD_AB_SEC2_SrcAClear_MASK

#define ADDR_MOD_AB_SEC2_SrcBIncr_ADDR32 14
#define ADDR_MOD_AB_SEC2_SrcBIncr_SHAMT 8
#define ADDR_MOD_AB_SEC2_SrcBIncr_MASK 0x3f00
#define ADDR_MOD_AB_SEC2_SrcBIncr_RMW \
    ADDR_MOD_AB_SEC2_SrcBIncr_ADDR32, ADDR_MOD_AB_SEC2_SrcBIncr_SHAMT, ADDR_MOD_AB_SEC2_SrcBIncr_MASK

#define ADDR_MOD_AB_SEC2_SrcBCR_ADDR32 14
#define ADDR_MOD_AB_SEC2_SrcBCR_SHAMT 14
#define ADDR_MOD_AB_SEC2_SrcBCR_MASK 0x4000
#define ADDR_MOD_AB_SEC2_SrcBCR_RMW \
    ADDR_MOD_AB_SEC2_SrcBCR_ADDR32, ADDR_MOD_AB_SEC2_SrcBCR_SHAMT, ADDR_MOD_AB_SEC2_SrcBCR_MASK

#define ADDR_MOD_AB_SEC2_SrcBClear_ADDR32 14
#define ADDR_MOD_AB_SEC2_SrcBClear_SHAMT 15
#define ADDR_MOD_AB_SEC2_SrcBClear_MASK 0x8000
#define ADDR_MOD_AB_SEC2_SrcBClear_RMW \
    ADDR_MOD_AB_SEC2_SrcBClear_ADDR32, ADDR_MOD_AB_SEC2_SrcBClear_SHAMT, ADDR_MOD_AB_SEC2_SrcBClear_MASK

#define ADDR_MOD_AB_SEC3_SrcAIncr_ADDR32 15
#define ADDR_MOD_AB_SEC3_SrcAIncr_SHAMT 0
#define ADDR_MOD_AB_SEC3_SrcAIncr_MASK 0x3f
#define ADDR_MOD_AB_SEC3_SrcAIncr_RMW \
    ADDR_MOD_AB_SEC3_SrcAIncr_ADDR32, ADDR_MOD_AB_SEC3_SrcAIncr_SHAMT, ADDR_MOD_AB_SEC3_SrcAIncr_MASK

#define ADDR_MOD_AB_SEC3_SrcACR_ADDR32 15
#define ADDR_MOD_AB_SEC3_SrcACR_SHAMT 6
#define ADDR_MOD_AB_SEC3_SrcACR_MASK 0x40
#define ADDR_MOD_AB_SEC3_SrcACR_RMW \
    ADDR_MOD_AB_SEC3_SrcACR_ADDR32, ADDR_MOD_AB_SEC3_SrcACR_SHAMT, ADDR_MOD_AB_SEC3_SrcACR_MASK

#define ADDR_MOD_AB_SEC3_SrcAClear_ADDR32 15
#define ADDR_MOD_AB_SEC3_SrcAClear_SHAMT 7
#define ADDR_MOD_AB_SEC3_SrcAClear_MASK 0x80
#define ADDR_MOD_AB_SEC3_SrcAClear_RMW \
    ADDR_MOD_AB_SEC3_SrcAClear_ADDR32, ADDR_MOD_AB_SEC3_SrcAClear_SHAMT, ADDR_MOD_AB_SEC3_SrcAClear_MASK

#define ADDR_MOD_AB_SEC3_SrcBIncr_ADDR32 15
#define ADDR_MOD_AB_SEC3_SrcBIncr_SHAMT 8
#define ADDR_MOD_AB_SEC3_SrcBIncr_MASK 0x3f00
#define ADDR_MOD_AB_SEC3_SrcBIncr_RMW \
    ADDR_MOD_AB_SEC3_SrcBIncr_ADDR32, ADDR_MOD_AB_SEC3_SrcBIncr_SHAMT, ADDR_MOD_AB_SEC3_SrcBIncr_MASK

#define ADDR_MOD_AB_SEC3_SrcBCR_ADDR32 15
#define ADDR_MOD_AB_SEC3_SrcBCR_SHAMT 14
#define ADDR_MOD_AB_SEC3_SrcBCR_MASK 0x4000
#define ADDR_MOD_AB_SEC3_SrcBCR_RMW \
    ADDR_MOD_AB_SEC3_SrcBCR_ADDR32, ADDR_MOD_AB_SEC3_SrcBCR_SHAMT, ADDR_MOD_AB_SEC3_SrcBCR_MASK

#define ADDR_MOD_AB_SEC3_SrcBClear_ADDR32 15
#define ADDR_MOD_AB_SEC3_SrcBClear_SHAMT 15
#define ADDR_MOD_AB_SEC3_SrcBClear_MASK 0x8000
#define ADDR_MOD_AB_SEC3_SrcBClear_RMW \
    ADDR_MOD_AB_SEC3_SrcBClear_ADDR32, ADDR_MOD_AB_SEC3_SrcBClear_SHAMT, ADDR_MOD_AB_SEC3_SrcBClear_MASK

#define ADDR_MOD_AB_SEC4_SrcAIncr_ADDR32 16
#define ADDR_MOD_AB_SEC4_SrcAIncr_SHAMT 0
#define ADDR_MOD_AB_SEC4_SrcAIncr_MASK 0x3f
#define ADDR_MOD_AB_SEC4_SrcAIncr_RMW \
    ADDR_MOD_AB_SEC4_SrcAIncr_ADDR32, ADDR_MOD_AB_SEC4_SrcAIncr_SHAMT, ADDR_MOD_AB_SEC4_SrcAIncr_MASK

#define ADDR_MOD_AB_SEC4_SrcACR_ADDR32 16
#define ADDR_MOD_AB_SEC4_SrcACR_SHAMT 6
#define ADDR_MOD_AB_SEC4_SrcACR_MASK 0x40
#define ADDR_MOD_AB_SEC4_SrcACR_RMW \
    ADDR_MOD_AB_SEC4_SrcACR_ADDR32, ADDR_MOD_AB_SEC4_SrcACR_SHAMT, ADDR_MOD_AB_SEC4_SrcACR_MASK

#define ADDR_MOD_AB_SEC4_SrcAClear_ADDR32 16
#define ADDR_MOD_AB_SEC4_SrcAClear_SHAMT 7
#define ADDR_MOD_AB_SEC4_SrcAClear_MASK 0x80
#define ADDR_MOD_AB_SEC4_SrcAClear_RMW \
    ADDR_MOD_AB_SEC4_SrcAClear_ADDR32, ADDR_MOD_AB_SEC4_SrcAClear_SHAMT, ADDR_MOD_AB_SEC4_SrcAClear_MASK

#define ADDR_MOD_AB_SEC4_SrcBIncr_ADDR32 16
#define ADDR_MOD_AB_SEC4_SrcBIncr_SHAMT 8
#define ADDR_MOD_AB_SEC4_SrcBIncr_MASK 0x3f00
#define ADDR_MOD_AB_SEC4_SrcBIncr_RMW \
    ADDR_MOD_AB_SEC4_SrcBIncr_ADDR32, ADDR_MOD_AB_SEC4_SrcBIncr_SHAMT, ADDR_MOD_AB_SEC4_SrcBIncr_MASK

#define ADDR_MOD_AB_SEC4_SrcBCR_ADDR32 16
#define ADDR_MOD_AB_SEC4_SrcBCR_SHAMT 14
#define ADDR_MOD_AB_SEC4_SrcBCR_MASK 0x4000
#define ADDR_MOD_AB_SEC4_SrcBCR_RMW \
    ADDR_MOD_AB_SEC4_SrcBCR_ADDR32, ADDR_MOD_AB_SEC4_SrcBCR_SHAMT, ADDR_MOD_AB_SEC4_SrcBCR_MASK

#define ADDR_MOD_AB_SEC4_SrcBClear_ADDR32 16
#define ADDR_MOD_AB_SEC4_SrcBClear_SHAMT 15
#define ADDR_MOD_AB_SEC4_SrcBClear_MASK 0x8000
#define ADDR_MOD_AB_SEC4_SrcBClear_RMW \
    ADDR_MOD_AB_SEC4_SrcBClear_ADDR32, ADDR_MOD_AB_SEC4_SrcBClear_SHAMT, ADDR_MOD_AB_SEC4_SrcBClear_MASK

#define ADDR_MOD_AB_SEC5_SrcAIncr_ADDR32 17
#define ADDR_MOD_AB_SEC5_SrcAIncr_SHAMT 0
#define ADDR_MOD_AB_SEC5_SrcAIncr_MASK 0x3f
#define ADDR_MOD_AB_SEC5_SrcAIncr_RMW \
    ADDR_MOD_AB_SEC5_SrcAIncr_ADDR32, ADDR_MOD_AB_SEC5_SrcAIncr_SHAMT, ADDR_MOD_AB_SEC5_SrcAIncr_MASK

#define ADDR_MOD_AB_SEC5_SrcACR_ADDR32 17
#define ADDR_MOD_AB_SEC5_SrcACR_SHAMT 6
#define ADDR_MOD_AB_SEC5_SrcACR_MASK 0x40
#define ADDR_MOD_AB_SEC5_SrcACR_RMW \
    ADDR_MOD_AB_SEC5_SrcACR_ADDR32, ADDR_MOD_AB_SEC5_SrcACR_SHAMT, ADDR_MOD_AB_SEC5_SrcACR_MASK

#define ADDR_MOD_AB_SEC5_SrcAClear_ADDR32 17
#define ADDR_MOD_AB_SEC5_SrcAClear_SHAMT 7
#define ADDR_MOD_AB_SEC5_SrcAClear_MASK 0x80
#define ADDR_MOD_AB_SEC5_SrcAClear_RMW \
    ADDR_MOD_AB_SEC5_SrcAClear_ADDR32, ADDR_MOD_AB_SEC5_SrcAClear_SHAMT, ADDR_MOD_AB_SEC5_SrcAClear_MASK

#define ADDR_MOD_AB_SEC5_SrcBIncr_ADDR32 17
#define ADDR_MOD_AB_SEC5_SrcBIncr_SHAMT 8
#define ADDR_MOD_AB_SEC5_SrcBIncr_MASK 0x3f00
#define ADDR_MOD_AB_SEC5_SrcBIncr_RMW \
    ADDR_MOD_AB_SEC5_SrcBIncr_ADDR32, ADDR_MOD_AB_SEC5_SrcBIncr_SHAMT, ADDR_MOD_AB_SEC5_SrcBIncr_MASK

#define ADDR_MOD_AB_SEC5_SrcBCR_ADDR32 17
#define ADDR_MOD_AB_SEC5_SrcBCR_SHAMT 14
#define ADDR_MOD_AB_SEC5_SrcBCR_MASK 0x4000
#define ADDR_MOD_AB_SEC5_SrcBCR_RMW \
    ADDR_MOD_AB_SEC5_SrcBCR_ADDR32, ADDR_MOD_AB_SEC5_SrcBCR_SHAMT, ADDR_MOD_AB_SEC5_SrcBCR_MASK

#define ADDR_MOD_AB_SEC5_SrcBClear_ADDR32 17
#define ADDR_MOD_AB_SEC5_SrcBClear_SHAMT 15
#define ADDR_MOD_AB_SEC5_SrcBClear_MASK 0x8000
#define ADDR_MOD_AB_SEC5_SrcBClear_RMW \
    ADDR_MOD_AB_SEC5_SrcBClear_ADDR32, ADDR_MOD_AB_SEC5_SrcBClear_SHAMT, ADDR_MOD_AB_SEC5_SrcBClear_MASK

#define ADDR_MOD_AB_SEC6_SrcAIncr_ADDR32 18
#define ADDR_MOD_AB_SEC6_SrcAIncr_SHAMT 0
#define ADDR_MOD_AB_SEC6_SrcAIncr_MASK 0x3f
#define ADDR_MOD_AB_SEC6_SrcAIncr_RMW \
    ADDR_MOD_AB_SEC6_SrcAIncr_ADDR32, ADDR_MOD_AB_SEC6_SrcAIncr_SHAMT, ADDR_MOD_AB_SEC6_SrcAIncr_MASK

#define ADDR_MOD_AB_SEC6_SrcACR_ADDR32 18
#define ADDR_MOD_AB_SEC6_SrcACR_SHAMT 6
#define ADDR_MOD_AB_SEC6_SrcACR_MASK 0x40
#define ADDR_MOD_AB_SEC6_SrcACR_RMW \
    ADDR_MOD_AB_SEC6_SrcACR_ADDR32, ADDR_MOD_AB_SEC6_SrcACR_SHAMT, ADDR_MOD_AB_SEC6_SrcACR_MASK

#define ADDR_MOD_AB_SEC6_SrcAClear_ADDR32 18
#define ADDR_MOD_AB_SEC6_SrcAClear_SHAMT 7
#define ADDR_MOD_AB_SEC6_SrcAClear_MASK 0x80
#define ADDR_MOD_AB_SEC6_SrcAClear_RMW \
    ADDR_MOD_AB_SEC6_SrcAClear_ADDR32, ADDR_MOD_AB_SEC6_SrcAClear_SHAMT, ADDR_MOD_AB_SEC6_SrcAClear_MASK

#define ADDR_MOD_AB_SEC6_SrcBIncr_ADDR32 18
#define ADDR_MOD_AB_SEC6_SrcBIncr_SHAMT 8
#define ADDR_MOD_AB_SEC6_SrcBIncr_MASK 0x3f00
#define ADDR_MOD_AB_SEC6_SrcBIncr_RMW \
    ADDR_MOD_AB_SEC6_SrcBIncr_ADDR32, ADDR_MOD_AB_SEC6_SrcBIncr_SHAMT, ADDR_MOD_AB_SEC6_SrcBIncr_MASK

#define ADDR_MOD_AB_SEC6_SrcBCR_ADDR32 18
#define ADDR_MOD_AB_SEC6_SrcBCR_SHAMT 14
#define ADDR_MOD_AB_SEC6_SrcBCR_MASK 0x4000
#define ADDR_MOD_AB_SEC6_SrcBCR_RMW \
    ADDR_MOD_AB_SEC6_SrcBCR_ADDR32, ADDR_MOD_AB_SEC6_SrcBCR_SHAMT, ADDR_MOD_AB_SEC6_SrcBCR_MASK

#define ADDR_MOD_AB_SEC6_SrcBClear_ADDR32 18
#define ADDR_MOD_AB_SEC6_SrcBClear_SHAMT 15
#define ADDR_MOD_AB_SEC6_SrcBClear_MASK 0x8000
#define ADDR_MOD_AB_SEC6_SrcBClear_RMW \
    ADDR_MOD_AB_SEC6_SrcBClear_ADDR32, ADDR_MOD_AB_SEC6_SrcBClear_SHAMT, ADDR_MOD_AB_SEC6_SrcBClear_MASK

#define ADDR_MOD_AB_SEC7_SrcAIncr_ADDR32 19
#define ADDR_MOD_AB_SEC7_SrcAIncr_SHAMT 0
#define ADDR_MOD_AB_SEC7_SrcAIncr_MASK 0x3f
#define ADDR_MOD_AB_SEC7_SrcAIncr_RMW \
    ADDR_MOD_AB_SEC7_SrcAIncr_ADDR32, ADDR_MOD_AB_SEC7_SrcAIncr_SHAMT, ADDR_MOD_AB_SEC7_SrcAIncr_MASK

#define ADDR_MOD_AB_SEC7_SrcACR_ADDR32 19
#define ADDR_MOD_AB_SEC7_SrcACR_SHAMT 6
#define ADDR_MOD_AB_SEC7_SrcACR_MASK 0x40
#define ADDR_MOD_AB_SEC7_SrcACR_RMW \
    ADDR_MOD_AB_SEC7_SrcACR_ADDR32, ADDR_MOD_AB_SEC7_SrcACR_SHAMT, ADDR_MOD_AB_SEC7_SrcACR_MASK

#define ADDR_MOD_AB_SEC7_SrcAClear_ADDR32 19
#define ADDR_MOD_AB_SEC7_SrcAClear_SHAMT 7
#define ADDR_MOD_AB_SEC7_SrcAClear_MASK 0x80
#define ADDR_MOD_AB_SEC7_SrcAClear_RMW \
    ADDR_MOD_AB_SEC7_SrcAClear_ADDR32, ADDR_MOD_AB_SEC7_SrcAClear_SHAMT, ADDR_MOD_AB_SEC7_SrcAClear_MASK

#define ADDR_MOD_AB_SEC7_SrcBIncr_ADDR32 19
#define ADDR_MOD_AB_SEC7_SrcBIncr_SHAMT 8
#define ADDR_MOD_AB_SEC7_SrcBIncr_MASK 0x3f00
#define ADDR_MOD_AB_SEC7_SrcBIncr_RMW \
    ADDR_MOD_AB_SEC7_SrcBIncr_ADDR32, ADDR_MOD_AB_SEC7_SrcBIncr_SHAMT, ADDR_MOD_AB_SEC7_SrcBIncr_MASK

#define ADDR_MOD_AB_SEC7_SrcBCR_ADDR32 19
#define ADDR_MOD_AB_SEC7_SrcBCR_SHAMT 14
#define ADDR_MOD_AB_SEC7_SrcBCR_MASK 0x4000
#define ADDR_MOD_AB_SEC7_SrcBCR_RMW \
    ADDR_MOD_AB_SEC7_SrcBCR_ADDR32, ADDR_MOD_AB_SEC7_SrcBCR_SHAMT, ADDR_MOD_AB_SEC7_SrcBCR_MASK

#define ADDR_MOD_AB_SEC7_SrcBClear_ADDR32 19
#define ADDR_MOD_AB_SEC7_SrcBClear_SHAMT 15
#define ADDR_MOD_AB_SEC7_SrcBClear_MASK 0x8000
#define ADDR_MOD_AB_SEC7_SrcBClear_RMW \
    ADDR_MOD_AB_SEC7_SrcBClear_ADDR32, ADDR_MOD_AB_SEC7_SrcBClear_SHAMT, ADDR_MOD_AB_SEC7_SrcBClear_MASK

#define ADDR_MOD_AB2_SEC0_SrcAIncr_ADDR32 20
#define ADDR_MOD_AB2_SEC0_SrcAIncr_SHAMT 0
#define ADDR_MOD_AB2_SEC0_SrcAIncr_MASK 0x1
#define ADDR_MOD_AB2_SEC0_SrcAIncr_RMW \
    ADDR_MOD_AB2_SEC0_SrcAIncr_ADDR32, ADDR_MOD_AB2_SEC0_SrcAIncr_SHAMT, ADDR_MOD_AB2_SEC0_SrcAIncr_MASK

#define ADDR_MOD_AB2_SEC0_SrcBIncr_ADDR32 20
#define ADDR_MOD_AB2_SEC0_SrcBIncr_SHAMT 1
#define ADDR_MOD_AB2_SEC0_SrcBIncr_MASK 0x2
#define ADDR_MOD_AB2_SEC0_SrcBIncr_RMW \
    ADDR_MOD_AB2_SEC0_SrcBIncr_ADDR32, ADDR_MOD_AB2_SEC0_SrcBIncr_SHAMT, ADDR_MOD_AB2_SEC0_SrcBIncr_MASK

#define ADDR_MOD_AB2_SEC1_SrcAIncr_ADDR32 21
#define ADDR_MOD_AB2_SEC1_SrcAIncr_SHAMT 0
#define ADDR_MOD_AB2_SEC1_SrcAIncr_MASK 0x1
#define ADDR_MOD_AB2_SEC1_SrcAIncr_RMW \
    ADDR_MOD_AB2_SEC1_SrcAIncr_ADDR32, ADDR_MOD_AB2_SEC1_SrcAIncr_SHAMT, ADDR_MOD_AB2_SEC1_SrcAIncr_MASK

#define ADDR_MOD_AB2_SEC1_SrcBIncr_ADDR32 21
#define ADDR_MOD_AB2_SEC1_SrcBIncr_SHAMT 1
#define ADDR_MOD_AB2_SEC1_SrcBIncr_MASK 0x2
#define ADDR_MOD_AB2_SEC1_SrcBIncr_RMW \
    ADDR_MOD_AB2_SEC1_SrcBIncr_ADDR32, ADDR_MOD_AB2_SEC1_SrcBIncr_SHAMT, ADDR_MOD_AB2_SEC1_SrcBIncr_MASK

#define ADDR_MOD_AB2_SEC2_SrcAIncr_ADDR32 22
#define ADDR_MOD_AB2_SEC2_SrcAIncr_SHAMT 0
#define ADDR_MOD_AB2_SEC2_SrcAIncr_MASK 0x1
#define ADDR_MOD_AB2_SEC2_SrcAIncr_RMW \
    ADDR_MOD_AB2_SEC2_SrcAIncr_ADDR32, ADDR_MOD_AB2_SEC2_SrcAIncr_SHAMT, ADDR_MOD_AB2_SEC2_SrcAIncr_MASK

#define ADDR_MOD_AB2_SEC2_SrcBIncr_ADDR32 22
#define ADDR_MOD_AB2_SEC2_SrcBIncr_SHAMT 1
#define ADDR_MOD_AB2_SEC2_SrcBIncr_MASK 0x2
#define ADDR_MOD_AB2_SEC2_SrcBIncr_RMW \
    ADDR_MOD_AB2_SEC2_SrcBIncr_ADDR32, ADDR_MOD_AB2_SEC2_SrcBIncr_SHAMT, ADDR_MOD_AB2_SEC2_SrcBIncr_MASK

#define ADDR_MOD_AB2_SEC3_SrcAIncr_ADDR32 23
#define ADDR_MOD_AB2_SEC3_SrcAIncr_SHAMT 0
#define ADDR_MOD_AB2_SEC3_SrcAIncr_MASK 0x1
#define ADDR_MOD_AB2_SEC3_SrcAIncr_RMW \
    ADDR_MOD_AB2_SEC3_SrcAIncr_ADDR32, ADDR_MOD_AB2_SEC3_SrcAIncr_SHAMT, ADDR_MOD_AB2_SEC3_SrcAIncr_MASK

#define ADDR_MOD_AB2_SEC3_SrcBIncr_ADDR32 23
#define ADDR_MOD_AB2_SEC3_SrcBIncr_SHAMT 1
#define ADDR_MOD_AB2_SEC3_SrcBIncr_MASK 0x2
#define ADDR_MOD_AB2_SEC3_SrcBIncr_RMW \
    ADDR_MOD_AB2_SEC3_SrcBIncr_ADDR32, ADDR_MOD_AB2_SEC3_SrcBIncr_SHAMT, ADDR_MOD_AB2_SEC3_SrcBIncr_MASK

#define ADDR_MOD_AB2_SEC4_SrcAIncr_ADDR32 24
#define ADDR_MOD_AB2_SEC4_SrcAIncr_SHAMT 0
#define ADDR_MOD_AB2_SEC4_SrcAIncr_MASK 0x1
#define ADDR_MOD_AB2_SEC4_SrcAIncr_RMW \
    ADDR_MOD_AB2_SEC4_SrcAIncr_ADDR32, ADDR_MOD_AB2_SEC4_SrcAIncr_SHAMT, ADDR_MOD_AB2_SEC4_SrcAIncr_MASK

#define ADDR_MOD_AB2_SEC4_SrcBIncr_ADDR32 24
#define ADDR_MOD_AB2_SEC4_SrcBIncr_SHAMT 1
#define ADDR_MOD_AB2_SEC4_SrcBIncr_MASK 0x2
#define ADDR_MOD_AB2_SEC4_SrcBIncr_RMW \
    ADDR_MOD_AB2_SEC4_SrcBIncr_ADDR32, ADDR_MOD_AB2_SEC4_SrcBIncr_SHAMT, ADDR_MOD_AB2_SEC4_SrcBIncr_MASK

#define ADDR_MOD_AB2_SEC5_SrcAIncr_ADDR32 25
#define ADDR_MOD_AB2_SEC5_SrcAIncr_SHAMT 0
#define ADDR_MOD_AB2_SEC5_SrcAIncr_MASK 0x1
#define ADDR_MOD_AB2_SEC5_SrcAIncr_RMW \
    ADDR_MOD_AB2_SEC5_SrcAIncr_ADDR32, ADDR_MOD_AB2_SEC5_SrcAIncr_SHAMT, ADDR_MOD_AB2_SEC5_SrcAIncr_MASK

#define ADDR_MOD_AB2_SEC5_SrcBIncr_ADDR32 25
#define ADDR_MOD_AB2_SEC5_SrcBIncr_SHAMT 1
#define ADDR_MOD_AB2_SEC5_SrcBIncr_MASK 0x2
#define ADDR_MOD_AB2_SEC5_SrcBIncr_RMW \
    ADDR_MOD_AB2_SEC5_SrcBIncr_ADDR32, ADDR_MOD_AB2_SEC5_SrcBIncr_SHAMT, ADDR_MOD_AB2_SEC5_SrcBIncr_MASK

#define ADDR_MOD_AB2_SEC6_SrcAIncr_ADDR32 26
#define ADDR_MOD_AB2_SEC6_SrcAIncr_SHAMT 0
#define ADDR_MOD_AB2_SEC6_SrcAIncr_MASK 0x1
#define ADDR_MOD_AB2_SEC6_SrcAIncr_RMW \
    ADDR_MOD_AB2_SEC6_SrcAIncr_ADDR32, ADDR_MOD_AB2_SEC6_SrcAIncr_SHAMT, ADDR_MOD_AB2_SEC6_SrcAIncr_MASK

#define ADDR_MOD_AB2_SEC6_SrcBIncr_ADDR32 26
#define ADDR_MOD_AB2_SEC6_SrcBIncr_SHAMT 1
#define ADDR_MOD_AB2_SEC6_SrcBIncr_MASK 0x2
#define ADDR_MOD_AB2_SEC6_SrcBIncr_RMW \
    ADDR_MOD_AB2_SEC6_SrcBIncr_ADDR32, ADDR_MOD_AB2_SEC6_SrcBIncr_SHAMT, ADDR_MOD_AB2_SEC6_SrcBIncr_MASK

#define ADDR_MOD_AB2_SEC7_SrcAIncr_ADDR32 27
#define ADDR_MOD_AB2_SEC7_SrcAIncr_SHAMT 0
#define ADDR_MOD_AB2_SEC7_SrcAIncr_MASK 0x1
#define ADDR_MOD_AB2_SEC7_SrcAIncr_RMW \
    ADDR_MOD_AB2_SEC7_SrcAIncr_ADDR32, ADDR_MOD_AB2_SEC7_SrcAIncr_SHAMT, ADDR_MOD_AB2_SEC7_SrcAIncr_MASK

#define ADDR_MOD_AB2_SEC7_SrcBIncr_ADDR32 27
#define ADDR_MOD_AB2_SEC7_SrcBIncr_SHAMT 1
#define ADDR_MOD_AB2_SEC7_SrcBIncr_MASK 0x2
#define ADDR_MOD_AB2_SEC7_SrcBIncr_RMW \
    ADDR_MOD_AB2_SEC7_SrcBIncr_ADDR32, ADDR_MOD_AB2_SEC7_SrcBIncr_SHAMT, ADDR_MOD_AB2_SEC7_SrcBIncr_MASK

#define ADDR_MOD_DST_SEC0_DestIncr_ADDR32 28
#define ADDR_MOD_DST_SEC0_DestIncr_SHAMT 0
#define ADDR_MOD_DST_SEC0_DestIncr_MASK 0x3ff
#define ADDR_MOD_DST_SEC0_DestIncr_RMW \
    ADDR_MOD_DST_SEC0_DestIncr_ADDR32, ADDR_MOD_DST_SEC0_DestIncr_SHAMT, ADDR_MOD_DST_SEC0_DestIncr_MASK

#define ADDR_MOD_DST_SEC0_DestCR_ADDR32 28
#define ADDR_MOD_DST_SEC0_DestCR_SHAMT 10
#define ADDR_MOD_DST_SEC0_DestCR_MASK 0x400
#define ADDR_MOD_DST_SEC0_DestCR_RMW \
    ADDR_MOD_DST_SEC0_DestCR_ADDR32, ADDR_MOD_DST_SEC0_DestCR_SHAMT, ADDR_MOD_DST_SEC0_DestCR_MASK

#define ADDR_MOD_DST_SEC0_DestClear_ADDR32 28
#define ADDR_MOD_DST_SEC0_DestClear_SHAMT 11
#define ADDR_MOD_DST_SEC0_DestClear_MASK 0x800
#define ADDR_MOD_DST_SEC0_DestClear_RMW \
    ADDR_MOD_DST_SEC0_DestClear_ADDR32, ADDR_MOD_DST_SEC0_DestClear_SHAMT, ADDR_MOD_DST_SEC0_DestClear_MASK

#define ADDR_MOD_DST_SEC0_DestCToCR_ADDR32 28
#define ADDR_MOD_DST_SEC0_DestCToCR_SHAMT 12
#define ADDR_MOD_DST_SEC0_DestCToCR_MASK 0x1000
#define ADDR_MOD_DST_SEC0_DestCToCR_RMW \
    ADDR_MOD_DST_SEC0_DestCToCR_ADDR32, ADDR_MOD_DST_SEC0_DestCToCR_SHAMT, ADDR_MOD_DST_SEC0_DestCToCR_MASK

#define ADDR_MOD_DST_SEC0_FidelityIncr_ADDR32 28
#define ADDR_MOD_DST_SEC0_FidelityIncr_SHAMT 13
#define ADDR_MOD_DST_SEC0_FidelityIncr_MASK 0x6000
#define ADDR_MOD_DST_SEC0_FidelityIncr_RMW \
    ADDR_MOD_DST_SEC0_FidelityIncr_ADDR32, ADDR_MOD_DST_SEC0_FidelityIncr_SHAMT, ADDR_MOD_DST_SEC0_FidelityIncr_MASK

#define ADDR_MOD_DST_SEC0_FidelityClear_ADDR32 28
#define ADDR_MOD_DST_SEC0_FidelityClear_SHAMT 15
#define ADDR_MOD_DST_SEC0_FidelityClear_MASK 0x8000
#define ADDR_MOD_DST_SEC0_FidelityClear_RMW \
    ADDR_MOD_DST_SEC0_FidelityClear_ADDR32, ADDR_MOD_DST_SEC0_FidelityClear_SHAMT, ADDR_MOD_DST_SEC0_FidelityClear_MASK

#define ADDR_MOD_DST_SEC1_DestIncr_ADDR32 29
#define ADDR_MOD_DST_SEC1_DestIncr_SHAMT 0
#define ADDR_MOD_DST_SEC1_DestIncr_MASK 0x3ff
#define ADDR_MOD_DST_SEC1_DestIncr_RMW \
    ADDR_MOD_DST_SEC1_DestIncr_ADDR32, ADDR_MOD_DST_SEC1_DestIncr_SHAMT, ADDR_MOD_DST_SEC1_DestIncr_MASK

#define ADDR_MOD_DST_SEC1_DestCR_ADDR32 29
#define ADDR_MOD_DST_SEC1_DestCR_SHAMT 10
#define ADDR_MOD_DST_SEC1_DestCR_MASK 0x400
#define ADDR_MOD_DST_SEC1_DestCR_RMW \
    ADDR_MOD_DST_SEC1_DestCR_ADDR32, ADDR_MOD_DST_SEC1_DestCR_SHAMT, ADDR_MOD_DST_SEC1_DestCR_MASK

#define ADDR_MOD_DST_SEC1_DestClear_ADDR32 29
#define ADDR_MOD_DST_SEC1_DestClear_SHAMT 11
#define ADDR_MOD_DST_SEC1_DestClear_MASK 0x800
#define ADDR_MOD_DST_SEC1_DestClear_RMW \
    ADDR_MOD_DST_SEC1_DestClear_ADDR32, ADDR_MOD_DST_SEC1_DestClear_SHAMT, ADDR_MOD_DST_SEC1_DestClear_MASK

#define ADDR_MOD_DST_SEC1_DestCToCR_ADDR32 29
#define ADDR_MOD_DST_SEC1_DestCToCR_SHAMT 12
#define ADDR_MOD_DST_SEC1_DestCToCR_MASK 0x1000
#define ADDR_MOD_DST_SEC1_DestCToCR_RMW \
    ADDR_MOD_DST_SEC1_DestCToCR_ADDR32, ADDR_MOD_DST_SEC1_DestCToCR_SHAMT, ADDR_MOD_DST_SEC1_DestCToCR_MASK

#define ADDR_MOD_DST_SEC1_FidelityIncr_ADDR32 29
#define ADDR_MOD_DST_SEC1_FidelityIncr_SHAMT 13
#define ADDR_MOD_DST_SEC1_FidelityIncr_MASK 0x6000
#define ADDR_MOD_DST_SEC1_FidelityIncr_RMW \
    ADDR_MOD_DST_SEC1_FidelityIncr_ADDR32, ADDR_MOD_DST_SEC1_FidelityIncr_SHAMT, ADDR_MOD_DST_SEC1_FidelityIncr_MASK

#define ADDR_MOD_DST_SEC1_FidelityClear_ADDR32 29
#define ADDR_MOD_DST_SEC1_FidelityClear_SHAMT 15
#define ADDR_MOD_DST_SEC1_FidelityClear_MASK 0x8000
#define ADDR_MOD_DST_SEC1_FidelityClear_RMW \
    ADDR_MOD_DST_SEC1_FidelityClear_ADDR32, ADDR_MOD_DST_SEC1_FidelityClear_SHAMT, ADDR_MOD_DST_SEC1_FidelityClear_MASK

#define ADDR_MOD_DST_SEC2_DestIncr_ADDR32 30
#define ADDR_MOD_DST_SEC2_DestIncr_SHAMT 0
#define ADDR_MOD_DST_SEC2_DestIncr_MASK 0x3ff
#define ADDR_MOD_DST_SEC2_DestIncr_RMW \
    ADDR_MOD_DST_SEC2_DestIncr_ADDR32, ADDR_MOD_DST_SEC2_DestIncr_SHAMT, ADDR_MOD_DST_SEC2_DestIncr_MASK

#define ADDR_MOD_DST_SEC2_DestCR_ADDR32 30
#define ADDR_MOD_DST_SEC2_DestCR_SHAMT 10
#define ADDR_MOD_DST_SEC2_DestCR_MASK 0x400
#define ADDR_MOD_DST_SEC2_DestCR_RMW \
    ADDR_MOD_DST_SEC2_DestCR_ADDR32, ADDR_MOD_DST_SEC2_DestCR_SHAMT, ADDR_MOD_DST_SEC2_DestCR_MASK

#define ADDR_MOD_DST_SEC2_DestClear_ADDR32 30
#define ADDR_MOD_DST_SEC2_DestClear_SHAMT 11
#define ADDR_MOD_DST_SEC2_DestClear_MASK 0x800
#define ADDR_MOD_DST_SEC2_DestClear_RMW \
    ADDR_MOD_DST_SEC2_DestClear_ADDR32, ADDR_MOD_DST_SEC2_DestClear_SHAMT, ADDR_MOD_DST_SEC2_DestClear_MASK

#define ADDR_MOD_DST_SEC2_DestCToCR_ADDR32 30
#define ADDR_MOD_DST_SEC2_DestCToCR_SHAMT 12
#define ADDR_MOD_DST_SEC2_DestCToCR_MASK 0x1000
#define ADDR_MOD_DST_SEC2_DestCToCR_RMW \
    ADDR_MOD_DST_SEC2_DestCToCR_ADDR32, ADDR_MOD_DST_SEC2_DestCToCR_SHAMT, ADDR_MOD_DST_SEC2_DestCToCR_MASK

#define ADDR_MOD_DST_SEC2_FidelityIncr_ADDR32 30
#define ADDR_MOD_DST_SEC2_FidelityIncr_SHAMT 13
#define ADDR_MOD_DST_SEC2_FidelityIncr_MASK 0x6000
#define ADDR_MOD_DST_SEC2_FidelityIncr_RMW \
    ADDR_MOD_DST_SEC2_FidelityIncr_ADDR32, ADDR_MOD_DST_SEC2_FidelityIncr_SHAMT, ADDR_MOD_DST_SEC2_FidelityIncr_MASK

#define ADDR_MOD_DST_SEC2_FidelityClear_ADDR32 30
#define ADDR_MOD_DST_SEC2_FidelityClear_SHAMT 15
#define ADDR_MOD_DST_SEC2_FidelityClear_MASK 0x8000
#define ADDR_MOD_DST_SEC2_FidelityClear_RMW \
    ADDR_MOD_DST_SEC2_FidelityClear_ADDR32, ADDR_MOD_DST_SEC2_FidelityClear_SHAMT, ADDR_MOD_DST_SEC2_FidelityClear_MASK

#define ADDR_MOD_DST_SEC3_DestIncr_ADDR32 31
#define ADDR_MOD_DST_SEC3_DestIncr_SHAMT 0
#define ADDR_MOD_DST_SEC3_DestIncr_MASK 0x3ff
#define ADDR_MOD_DST_SEC3_DestIncr_RMW \
    ADDR_MOD_DST_SEC3_DestIncr_ADDR32, ADDR_MOD_DST_SEC3_DestIncr_SHAMT, ADDR_MOD_DST_SEC3_DestIncr_MASK

#define ADDR_MOD_DST_SEC3_DestCR_ADDR32 31
#define ADDR_MOD_DST_SEC3_DestCR_SHAMT 10
#define ADDR_MOD_DST_SEC3_DestCR_MASK 0x400
#define ADDR_MOD_DST_SEC3_DestCR_RMW \
    ADDR_MOD_DST_SEC3_DestCR_ADDR32, ADDR_MOD_DST_SEC3_DestCR_SHAMT, ADDR_MOD_DST_SEC3_DestCR_MASK

#define ADDR_MOD_DST_SEC3_DestClear_ADDR32 31
#define ADDR_MOD_DST_SEC3_DestClear_SHAMT 11
#define ADDR_MOD_DST_SEC3_DestClear_MASK 0x800
#define ADDR_MOD_DST_SEC3_DestClear_RMW \
    ADDR_MOD_DST_SEC3_DestClear_ADDR32, ADDR_MOD_DST_SEC3_DestClear_SHAMT, ADDR_MOD_DST_SEC3_DestClear_MASK

#define ADDR_MOD_DST_SEC3_DestCToCR_ADDR32 31
#define ADDR_MOD_DST_SEC3_DestCToCR_SHAMT 12
#define ADDR_MOD_DST_SEC3_DestCToCR_MASK 0x1000
#define ADDR_MOD_DST_SEC3_DestCToCR_RMW \
    ADDR_MOD_DST_SEC3_DestCToCR_ADDR32, ADDR_MOD_DST_SEC3_DestCToCR_SHAMT, ADDR_MOD_DST_SEC3_DestCToCR_MASK

#define ADDR_MOD_DST_SEC3_FidelityIncr_ADDR32 31
#define ADDR_MOD_DST_SEC3_FidelityIncr_SHAMT 13
#define ADDR_MOD_DST_SEC3_FidelityIncr_MASK 0x6000
#define ADDR_MOD_DST_SEC3_FidelityIncr_RMW \
    ADDR_MOD_DST_SEC3_FidelityIncr_ADDR32, ADDR_MOD_DST_SEC3_FidelityIncr_SHAMT, ADDR_MOD_DST_SEC3_FidelityIncr_MASK

#define ADDR_MOD_DST_SEC3_FidelityClear_ADDR32 31
#define ADDR_MOD_DST_SEC3_FidelityClear_SHAMT 15
#define ADDR_MOD_DST_SEC3_FidelityClear_MASK 0x8000
#define ADDR_MOD_DST_SEC3_FidelityClear_RMW \
    ADDR_MOD_DST_SEC3_FidelityClear_ADDR32, ADDR_MOD_DST_SEC3_FidelityClear_SHAMT, ADDR_MOD_DST_SEC3_FidelityClear_MASK

#define ADDR_MOD_DST_SEC4_DestIncr_ADDR32 32
#define ADDR_MOD_DST_SEC4_DestIncr_SHAMT 0
#define ADDR_MOD_DST_SEC4_DestIncr_MASK 0x3ff
#define ADDR_MOD_DST_SEC4_DestIncr_RMW \
    ADDR_MOD_DST_SEC4_DestIncr_ADDR32, ADDR_MOD_DST_SEC4_DestIncr_SHAMT, ADDR_MOD_DST_SEC4_DestIncr_MASK

#define ADDR_MOD_DST_SEC4_DestCR_ADDR32 32
#define ADDR_MOD_DST_SEC4_DestCR_SHAMT 10
#define ADDR_MOD_DST_SEC4_DestCR_MASK 0x400
#define ADDR_MOD_DST_SEC4_DestCR_RMW \
    ADDR_MOD_DST_SEC4_DestCR_ADDR32, ADDR_MOD_DST_SEC4_DestCR_SHAMT, ADDR_MOD_DST_SEC4_DestCR_MASK

#define ADDR_MOD_DST_SEC4_DestClear_ADDR32 32
#define ADDR_MOD_DST_SEC4_DestClear_SHAMT 11
#define ADDR_MOD_DST_SEC4_DestClear_MASK 0x800
#define ADDR_MOD_DST_SEC4_DestClear_RMW \
    ADDR_MOD_DST_SEC4_DestClear_ADDR32, ADDR_MOD_DST_SEC4_DestClear_SHAMT, ADDR_MOD_DST_SEC4_DestClear_MASK

#define ADDR_MOD_DST_SEC4_DestCToCR_ADDR32 32
#define ADDR_MOD_DST_SEC4_DestCToCR_SHAMT 12
#define ADDR_MOD_DST_SEC4_DestCToCR_MASK 0x1000
#define ADDR_MOD_DST_SEC4_DestCToCR_RMW \
    ADDR_MOD_DST_SEC4_DestCToCR_ADDR32, ADDR_MOD_DST_SEC4_DestCToCR_SHAMT, ADDR_MOD_DST_SEC4_DestCToCR_MASK

#define ADDR_MOD_DST_SEC4_FidelityIncr_ADDR32 32
#define ADDR_MOD_DST_SEC4_FidelityIncr_SHAMT 13
#define ADDR_MOD_DST_SEC4_FidelityIncr_MASK 0x6000
#define ADDR_MOD_DST_SEC4_FidelityIncr_RMW \
    ADDR_MOD_DST_SEC4_FidelityIncr_ADDR32, ADDR_MOD_DST_SEC4_FidelityIncr_SHAMT, ADDR_MOD_DST_SEC4_FidelityIncr_MASK

#define ADDR_MOD_DST_SEC4_FidelityClear_ADDR32 32
#define ADDR_MOD_DST_SEC4_FidelityClear_SHAMT 15
#define ADDR_MOD_DST_SEC4_FidelityClear_MASK 0x8000
#define ADDR_MOD_DST_SEC4_FidelityClear_RMW \
    ADDR_MOD_DST_SEC4_FidelityClear_ADDR32, ADDR_MOD_DST_SEC4_FidelityClear_SHAMT, ADDR_MOD_DST_SEC4_FidelityClear_MASK

#define ADDR_MOD_DST_SEC5_DestIncr_ADDR32 33
#define ADDR_MOD_DST_SEC5_DestIncr_SHAMT 0
#define ADDR_MOD_DST_SEC5_DestIncr_MASK 0x3ff
#define ADDR_MOD_DST_SEC5_DestIncr_RMW \
    ADDR_MOD_DST_SEC5_DestIncr_ADDR32, ADDR_MOD_DST_SEC5_DestIncr_SHAMT, ADDR_MOD_DST_SEC5_DestIncr_MASK

#define ADDR_MOD_DST_SEC5_DestCR_ADDR32 33
#define ADDR_MOD_DST_SEC5_DestCR_SHAMT 10
#define ADDR_MOD_DST_SEC5_DestCR_MASK 0x400
#define ADDR_MOD_DST_SEC5_DestCR_RMW \
    ADDR_MOD_DST_SEC5_DestCR_ADDR32, ADDR_MOD_DST_SEC5_DestCR_SHAMT, ADDR_MOD_DST_SEC5_DestCR_MASK

#define ADDR_MOD_DST_SEC5_DestClear_ADDR32 33
#define ADDR_MOD_DST_SEC5_DestClear_SHAMT 11
#define ADDR_MOD_DST_SEC5_DestClear_MASK 0x800
#define ADDR_MOD_DST_SEC5_DestClear_RMW \
    ADDR_MOD_DST_SEC5_DestClear_ADDR32, ADDR_MOD_DST_SEC5_DestClear_SHAMT, ADDR_MOD_DST_SEC5_DestClear_MASK

#define ADDR_MOD_DST_SEC5_DestCToCR_ADDR32 33
#define ADDR_MOD_DST_SEC5_DestCToCR_SHAMT 12
#define ADDR_MOD_DST_SEC5_DestCToCR_MASK 0x1000
#define ADDR_MOD_DST_SEC5_DestCToCR_RMW \
    ADDR_MOD_DST_SEC5_DestCToCR_ADDR32, ADDR_MOD_DST_SEC5_DestCToCR_SHAMT, ADDR_MOD_DST_SEC5_DestCToCR_MASK

#define ADDR_MOD_DST_SEC5_FidelityIncr_ADDR32 33
#define ADDR_MOD_DST_SEC5_FidelityIncr_SHAMT 13
#define ADDR_MOD_DST_SEC5_FidelityIncr_MASK 0x6000
#define ADDR_MOD_DST_SEC5_FidelityIncr_RMW \
    ADDR_MOD_DST_SEC5_FidelityIncr_ADDR32, ADDR_MOD_DST_SEC5_FidelityIncr_SHAMT, ADDR_MOD_DST_SEC5_FidelityIncr_MASK

#define ADDR_MOD_DST_SEC5_FidelityClear_ADDR32 33
#define ADDR_MOD_DST_SEC5_FidelityClear_SHAMT 15
#define ADDR_MOD_DST_SEC5_FidelityClear_MASK 0x8000
#define ADDR_MOD_DST_SEC5_FidelityClear_RMW \
    ADDR_MOD_DST_SEC5_FidelityClear_ADDR32, ADDR_MOD_DST_SEC5_FidelityClear_SHAMT, ADDR_MOD_DST_SEC5_FidelityClear_MASK

#define ADDR_MOD_DST_SEC6_DestIncr_ADDR32 34
#define ADDR_MOD_DST_SEC6_DestIncr_SHAMT 0
#define ADDR_MOD_DST_SEC6_DestIncr_MASK 0x3ff
#define ADDR_MOD_DST_SEC6_DestIncr_RMW \
    ADDR_MOD_DST_SEC6_DestIncr_ADDR32, ADDR_MOD_DST_SEC6_DestIncr_SHAMT, ADDR_MOD_DST_SEC6_DestIncr_MASK

#define ADDR_MOD_DST_SEC6_DestCR_ADDR32 34
#define ADDR_MOD_DST_SEC6_DestCR_SHAMT 10
#define ADDR_MOD_DST_SEC6_DestCR_MASK 0x400
#define ADDR_MOD_DST_SEC6_DestCR_RMW \
    ADDR_MOD_DST_SEC6_DestCR_ADDR32, ADDR_MOD_DST_SEC6_DestCR_SHAMT, ADDR_MOD_DST_SEC6_DestCR_MASK

#define ADDR_MOD_DST_SEC6_DestClear_ADDR32 34
#define ADDR_MOD_DST_SEC6_DestClear_SHAMT 11
#define ADDR_MOD_DST_SEC6_DestClear_MASK 0x800
#define ADDR_MOD_DST_SEC6_DestClear_RMW \
    ADDR_MOD_DST_SEC6_DestClear_ADDR32, ADDR_MOD_DST_SEC6_DestClear_SHAMT, ADDR_MOD_DST_SEC6_DestClear_MASK

#define ADDR_MOD_DST_SEC6_DestCToCR_ADDR32 34
#define ADDR_MOD_DST_SEC6_DestCToCR_SHAMT 12
#define ADDR_MOD_DST_SEC6_DestCToCR_MASK 0x1000
#define ADDR_MOD_DST_SEC6_DestCToCR_RMW \
    ADDR_MOD_DST_SEC6_DestCToCR_ADDR32, ADDR_MOD_DST_SEC6_DestCToCR_SHAMT, ADDR_MOD_DST_SEC6_DestCToCR_MASK

#define ADDR_MOD_DST_SEC6_FidelityIncr_ADDR32 34
#define ADDR_MOD_DST_SEC6_FidelityIncr_SHAMT 13
#define ADDR_MOD_DST_SEC6_FidelityIncr_MASK 0x6000
#define ADDR_MOD_DST_SEC6_FidelityIncr_RMW \
    ADDR_MOD_DST_SEC6_FidelityIncr_ADDR32, ADDR_MOD_DST_SEC6_FidelityIncr_SHAMT, ADDR_MOD_DST_SEC6_FidelityIncr_MASK

#define ADDR_MOD_DST_SEC6_FidelityClear_ADDR32 34
#define ADDR_MOD_DST_SEC6_FidelityClear_SHAMT 15
#define ADDR_MOD_DST_SEC6_FidelityClear_MASK 0x8000
#define ADDR_MOD_DST_SEC6_FidelityClear_RMW \
    ADDR_MOD_DST_SEC6_FidelityClear_ADDR32, ADDR_MOD_DST_SEC6_FidelityClear_SHAMT, ADDR_MOD_DST_SEC6_FidelityClear_MASK

#define ADDR_MOD_DST_SEC7_DestIncr_ADDR32 35
#define ADDR_MOD_DST_SEC7_DestIncr_SHAMT 0
#define ADDR_MOD_DST_SEC7_DestIncr_MASK 0x3ff
#define ADDR_MOD_DST_SEC7_DestIncr_RMW \
    ADDR_MOD_DST_SEC7_DestIncr_ADDR32, ADDR_MOD_DST_SEC7_DestIncr_SHAMT, ADDR_MOD_DST_SEC7_DestIncr_MASK

#define ADDR_MOD_DST_SEC7_DestCR_ADDR32 35
#define ADDR_MOD_DST_SEC7_DestCR_SHAMT 10
#define ADDR_MOD_DST_SEC7_DestCR_MASK 0x400
#define ADDR_MOD_DST_SEC7_DestCR_RMW \
    ADDR_MOD_DST_SEC7_DestCR_ADDR32, ADDR_MOD_DST_SEC7_DestCR_SHAMT, ADDR_MOD_DST_SEC7_DestCR_MASK

#define ADDR_MOD_DST_SEC7_DestClear_ADDR32 35
#define ADDR_MOD_DST_SEC7_DestClear_SHAMT 11
#define ADDR_MOD_DST_SEC7_DestClear_MASK 0x800
#define ADDR_MOD_DST_SEC7_DestClear_RMW \
    ADDR_MOD_DST_SEC7_DestClear_ADDR32, ADDR_MOD_DST_SEC7_DestClear_SHAMT, ADDR_MOD_DST_SEC7_DestClear_MASK

#define ADDR_MOD_DST_SEC7_DestCToCR_ADDR32 35
#define ADDR_MOD_DST_SEC7_DestCToCR_SHAMT 12
#define ADDR_MOD_DST_SEC7_DestCToCR_MASK 0x1000
#define ADDR_MOD_DST_SEC7_DestCToCR_RMW \
    ADDR_MOD_DST_SEC7_DestCToCR_ADDR32, ADDR_MOD_DST_SEC7_DestCToCR_SHAMT, ADDR_MOD_DST_SEC7_DestCToCR_MASK

#define ADDR_MOD_DST_SEC7_FidelityIncr_ADDR32 35
#define ADDR_MOD_DST_SEC7_FidelityIncr_SHAMT 13
#define ADDR_MOD_DST_SEC7_FidelityIncr_MASK 0x6000
#define ADDR_MOD_DST_SEC7_FidelityIncr_RMW \
    ADDR_MOD_DST_SEC7_FidelityIncr_ADDR32, ADDR_MOD_DST_SEC7_FidelityIncr_SHAMT, ADDR_MOD_DST_SEC7_FidelityIncr_MASK

#define ADDR_MOD_DST_SEC7_FidelityClear_ADDR32 35
#define ADDR_MOD_DST_SEC7_FidelityClear_SHAMT 15
#define ADDR_MOD_DST_SEC7_FidelityClear_MASK 0x8000
#define ADDR_MOD_DST_SEC7_FidelityClear_RMW \
    ADDR_MOD_DST_SEC7_FidelityClear_ADDR32, ADDR_MOD_DST_SEC7_FidelityClear_SHAMT, ADDR_MOD_DST_SEC7_FidelityClear_MASK

#define SFPU_STACK_Incr_ADDR32 36
#define SFPU_STACK_Incr_SHAMT 0
#define SFPU_STACK_Incr_MASK 0x3ff
#define SFPU_STACK_Incr_RMW SFPU_STACK_Incr_ADDR32, SFPU_STACK_Incr_SHAMT, SFPU_STACK_Incr_MASK

#define ADDR_MOD_PACK_SEC0_YsrcIncr_ADDR32 37
#define ADDR_MOD_PACK_SEC0_YsrcIncr_SHAMT 0
#define ADDR_MOD_PACK_SEC0_YsrcIncr_MASK 0xf
#define ADDR_MOD_PACK_SEC0_YsrcIncr_RMW \
    ADDR_MOD_PACK_SEC0_YsrcIncr_ADDR32, ADDR_MOD_PACK_SEC0_YsrcIncr_SHAMT, ADDR_MOD_PACK_SEC0_YsrcIncr_MASK

#define ADDR_MOD_PACK_SEC0_YsrcCR_ADDR32 37
#define ADDR_MOD_PACK_SEC0_YsrcCR_SHAMT 4
#define ADDR_MOD_PACK_SEC0_YsrcCR_MASK 0x10
#define ADDR_MOD_PACK_SEC0_YsrcCR_RMW \
    ADDR_MOD_PACK_SEC0_YsrcCR_ADDR32, ADDR_MOD_PACK_SEC0_YsrcCR_SHAMT, ADDR_MOD_PACK_SEC0_YsrcCR_MASK

#define ADDR_MOD_PACK_SEC0_YsrcClear_ADDR32 37
#define ADDR_MOD_PACK_SEC0_YsrcClear_SHAMT 5
#define ADDR_MOD_PACK_SEC0_YsrcClear_MASK 0x20
#define ADDR_MOD_PACK_SEC0_YsrcClear_RMW \
    ADDR_MOD_PACK_SEC0_YsrcClear_ADDR32, ADDR_MOD_PACK_SEC0_YsrcClear_SHAMT, ADDR_MOD_PACK_SEC0_YsrcClear_MASK

#define ADDR_MOD_PACK_SEC0_YdstIncr_ADDR32 37
#define ADDR_MOD_PACK_SEC0_YdstIncr_SHAMT 6
#define ADDR_MOD_PACK_SEC0_YdstIncr_MASK 0x3c0
#define ADDR_MOD_PACK_SEC0_YdstIncr_RMW \
    ADDR_MOD_PACK_SEC0_YdstIncr_ADDR32, ADDR_MOD_PACK_SEC0_YdstIncr_SHAMT, ADDR_MOD_PACK_SEC0_YdstIncr_MASK

#define ADDR_MOD_PACK_SEC0_YdstCR_ADDR32 37
#define ADDR_MOD_PACK_SEC0_YdstCR_SHAMT 10
#define ADDR_MOD_PACK_SEC0_YdstCR_MASK 0x400
#define ADDR_MOD_PACK_SEC0_YdstCR_RMW \
    ADDR_MOD_PACK_SEC0_YdstCR_ADDR32, ADDR_MOD_PACK_SEC0_YdstCR_SHAMT, ADDR_MOD_PACK_SEC0_YdstCR_MASK

#define ADDR_MOD_PACK_SEC0_YdstClear_ADDR32 37
#define ADDR_MOD_PACK_SEC0_YdstClear_SHAMT 11
#define ADDR_MOD_PACK_SEC0_YdstClear_MASK 0x800
#define ADDR_MOD_PACK_SEC0_YdstClear_RMW \
    ADDR_MOD_PACK_SEC0_YdstClear_ADDR32, ADDR_MOD_PACK_SEC0_YdstClear_SHAMT, ADDR_MOD_PACK_SEC0_YdstClear_MASK

#define ADDR_MOD_PACK_SEC0_ZsrcIncr_ADDR32 37
#define ADDR_MOD_PACK_SEC0_ZsrcIncr_SHAMT 12
#define ADDR_MOD_PACK_SEC0_ZsrcIncr_MASK 0x1000
#define ADDR_MOD_PACK_SEC0_ZsrcIncr_RMW \
    ADDR_MOD_PACK_SEC0_ZsrcIncr_ADDR32, ADDR_MOD_PACK_SEC0_ZsrcIncr_SHAMT, ADDR_MOD_PACK_SEC0_ZsrcIncr_MASK

#define ADDR_MOD_PACK_SEC0_ZsrcClear_ADDR32 37
#define ADDR_MOD_PACK_SEC0_ZsrcClear_SHAMT 13
#define ADDR_MOD_PACK_SEC0_ZsrcClear_MASK 0x2000
#define ADDR_MOD_PACK_SEC0_ZsrcClear_RMW \
    ADDR_MOD_PACK_SEC0_ZsrcClear_ADDR32, ADDR_MOD_PACK_SEC0_ZsrcClear_SHAMT, ADDR_MOD_PACK_SEC0_ZsrcClear_MASK

#define ADDR_MOD_PACK_SEC0_ZdstIncr_ADDR32 37
#define ADDR_MOD_PACK_SEC0_ZdstIncr_SHAMT 14
#define ADDR_MOD_PACK_SEC0_ZdstIncr_MASK 0x4000
#define ADDR_MOD_PACK_SEC0_ZdstIncr_RMW \
    ADDR_MOD_PACK_SEC0_ZdstIncr_ADDR32, ADDR_MOD_PACK_SEC0_ZdstIncr_SHAMT, ADDR_MOD_PACK_SEC0_ZdstIncr_MASK

#define ADDR_MOD_PACK_SEC0_ZdstClear_ADDR32 37
#define ADDR_MOD_PACK_SEC0_ZdstClear_SHAMT 15
#define ADDR_MOD_PACK_SEC0_ZdstClear_MASK 0x8000
#define ADDR_MOD_PACK_SEC0_ZdstClear_RMW \
    ADDR_MOD_PACK_SEC0_ZdstClear_ADDR32, ADDR_MOD_PACK_SEC0_ZdstClear_SHAMT, ADDR_MOD_PACK_SEC0_ZdstClear_MASK

#define ADDR_MOD_PACK_SEC1_YsrcIncr_ADDR32 38
#define ADDR_MOD_PACK_SEC1_YsrcIncr_SHAMT 0
#define ADDR_MOD_PACK_SEC1_YsrcIncr_MASK 0xf
#define ADDR_MOD_PACK_SEC1_YsrcIncr_RMW \
    ADDR_MOD_PACK_SEC1_YsrcIncr_ADDR32, ADDR_MOD_PACK_SEC1_YsrcIncr_SHAMT, ADDR_MOD_PACK_SEC1_YsrcIncr_MASK

#define ADDR_MOD_PACK_SEC1_YsrcCR_ADDR32 38
#define ADDR_MOD_PACK_SEC1_YsrcCR_SHAMT 4
#define ADDR_MOD_PACK_SEC1_YsrcCR_MASK 0x10
#define ADDR_MOD_PACK_SEC1_YsrcCR_RMW \
    ADDR_MOD_PACK_SEC1_YsrcCR_ADDR32, ADDR_MOD_PACK_SEC1_YsrcCR_SHAMT, ADDR_MOD_PACK_SEC1_YsrcCR_MASK

#define ADDR_MOD_PACK_SEC1_YsrcClear_ADDR32 38
#define ADDR_MOD_PACK_SEC1_YsrcClear_SHAMT 5
#define ADDR_MOD_PACK_SEC1_YsrcClear_MASK 0x20
#define ADDR_MOD_PACK_SEC1_YsrcClear_RMW \
    ADDR_MOD_PACK_SEC1_YsrcClear_ADDR32, ADDR_MOD_PACK_SEC1_YsrcClear_SHAMT, ADDR_MOD_PACK_SEC1_YsrcClear_MASK

#define ADDR_MOD_PACK_SEC1_YdstIncr_ADDR32 38
#define ADDR_MOD_PACK_SEC1_YdstIncr_SHAMT 6
#define ADDR_MOD_PACK_SEC1_YdstIncr_MASK 0x3c0
#define ADDR_MOD_PACK_SEC1_YdstIncr_RMW \
    ADDR_MOD_PACK_SEC1_YdstIncr_ADDR32, ADDR_MOD_PACK_SEC1_YdstIncr_SHAMT, ADDR_MOD_PACK_SEC1_YdstIncr_MASK

#define ADDR_MOD_PACK_SEC1_YdstCR_ADDR32 38
#define ADDR_MOD_PACK_SEC1_YdstCR_SHAMT 10
#define ADDR_MOD_PACK_SEC1_YdstCR_MASK 0x400
#define ADDR_MOD_PACK_SEC1_YdstCR_RMW \
    ADDR_MOD_PACK_SEC1_YdstCR_ADDR32, ADDR_MOD_PACK_SEC1_YdstCR_SHAMT, ADDR_MOD_PACK_SEC1_YdstCR_MASK

#define ADDR_MOD_PACK_SEC1_YdstClear_ADDR32 38
#define ADDR_MOD_PACK_SEC1_YdstClear_SHAMT 11
#define ADDR_MOD_PACK_SEC1_YdstClear_MASK 0x800
#define ADDR_MOD_PACK_SEC1_YdstClear_RMW \
    ADDR_MOD_PACK_SEC1_YdstClear_ADDR32, ADDR_MOD_PACK_SEC1_YdstClear_SHAMT, ADDR_MOD_PACK_SEC1_YdstClear_MASK

#define ADDR_MOD_PACK_SEC1_ZsrcIncr_ADDR32 38
#define ADDR_MOD_PACK_SEC1_ZsrcIncr_SHAMT 12
#define ADDR_MOD_PACK_SEC1_ZsrcIncr_MASK 0x1000
#define ADDR_MOD_PACK_SEC1_ZsrcIncr_RMW \
    ADDR_MOD_PACK_SEC1_ZsrcIncr_ADDR32, ADDR_MOD_PACK_SEC1_ZsrcIncr_SHAMT, ADDR_MOD_PACK_SEC1_ZsrcIncr_MASK

#define ADDR_MOD_PACK_SEC1_ZsrcClear_ADDR32 38
#define ADDR_MOD_PACK_SEC1_ZsrcClear_SHAMT 13
#define ADDR_MOD_PACK_SEC1_ZsrcClear_MASK 0x2000
#define ADDR_MOD_PACK_SEC1_ZsrcClear_RMW \
    ADDR_MOD_PACK_SEC1_ZsrcClear_ADDR32, ADDR_MOD_PACK_SEC1_ZsrcClear_SHAMT, ADDR_MOD_PACK_SEC1_ZsrcClear_MASK

#define ADDR_MOD_PACK_SEC1_ZdstIncr_ADDR32 38
#define ADDR_MOD_PACK_SEC1_ZdstIncr_SHAMT 14
#define ADDR_MOD_PACK_SEC1_ZdstIncr_MASK 0x4000
#define ADDR_MOD_PACK_SEC1_ZdstIncr_RMW \
    ADDR_MOD_PACK_SEC1_ZdstIncr_ADDR32, ADDR_MOD_PACK_SEC1_ZdstIncr_SHAMT, ADDR_MOD_PACK_SEC1_ZdstIncr_MASK

#define ADDR_MOD_PACK_SEC1_ZdstClear_ADDR32 38
#define ADDR_MOD_PACK_SEC1_ZdstClear_SHAMT 15
#define ADDR_MOD_PACK_SEC1_ZdstClear_MASK 0x8000
#define ADDR_MOD_PACK_SEC1_ZdstClear_RMW \
    ADDR_MOD_PACK_SEC1_ZdstClear_ADDR32, ADDR_MOD_PACK_SEC1_ZdstClear_SHAMT, ADDR_MOD_PACK_SEC1_ZdstClear_MASK

#define ADDR_MOD_PACK_SEC2_YsrcIncr_ADDR32 39
#define ADDR_MOD_PACK_SEC2_YsrcIncr_SHAMT 0
#define ADDR_MOD_PACK_SEC2_YsrcIncr_MASK 0xf
#define ADDR_MOD_PACK_SEC2_YsrcIncr_RMW \
    ADDR_MOD_PACK_SEC2_YsrcIncr_ADDR32, ADDR_MOD_PACK_SEC2_YsrcIncr_SHAMT, ADDR_MOD_PACK_SEC2_YsrcIncr_MASK

#define ADDR_MOD_PACK_SEC2_YsrcCR_ADDR32 39
#define ADDR_MOD_PACK_SEC2_YsrcCR_SHAMT 4
#define ADDR_MOD_PACK_SEC2_YsrcCR_MASK 0x10
#define ADDR_MOD_PACK_SEC2_YsrcCR_RMW \
    ADDR_MOD_PACK_SEC2_YsrcCR_ADDR32, ADDR_MOD_PACK_SEC2_YsrcCR_SHAMT, ADDR_MOD_PACK_SEC2_YsrcCR_MASK

#define ADDR_MOD_PACK_SEC2_YsrcClear_ADDR32 39
#define ADDR_MOD_PACK_SEC2_YsrcClear_SHAMT 5
#define ADDR_MOD_PACK_SEC2_YsrcClear_MASK 0x20
#define ADDR_MOD_PACK_SEC2_YsrcClear_RMW \
    ADDR_MOD_PACK_SEC2_YsrcClear_ADDR32, ADDR_MOD_PACK_SEC2_YsrcClear_SHAMT, ADDR_MOD_PACK_SEC2_YsrcClear_MASK

#define ADDR_MOD_PACK_SEC2_YdstIncr_ADDR32 39
#define ADDR_MOD_PACK_SEC2_YdstIncr_SHAMT 6
#define ADDR_MOD_PACK_SEC2_YdstIncr_MASK 0x3c0
#define ADDR_MOD_PACK_SEC2_YdstIncr_RMW \
    ADDR_MOD_PACK_SEC2_YdstIncr_ADDR32, ADDR_MOD_PACK_SEC2_YdstIncr_SHAMT, ADDR_MOD_PACK_SEC2_YdstIncr_MASK

#define ADDR_MOD_PACK_SEC2_YdstCR_ADDR32 39
#define ADDR_MOD_PACK_SEC2_YdstCR_SHAMT 10
#define ADDR_MOD_PACK_SEC2_YdstCR_MASK 0x400
#define ADDR_MOD_PACK_SEC2_YdstCR_RMW \
    ADDR_MOD_PACK_SEC2_YdstCR_ADDR32, ADDR_MOD_PACK_SEC2_YdstCR_SHAMT, ADDR_MOD_PACK_SEC2_YdstCR_MASK

#define ADDR_MOD_PACK_SEC2_YdstClear_ADDR32 39
#define ADDR_MOD_PACK_SEC2_YdstClear_SHAMT 11
#define ADDR_MOD_PACK_SEC2_YdstClear_MASK 0x800
#define ADDR_MOD_PACK_SEC2_YdstClear_RMW \
    ADDR_MOD_PACK_SEC2_YdstClear_ADDR32, ADDR_MOD_PACK_SEC2_YdstClear_SHAMT, ADDR_MOD_PACK_SEC2_YdstClear_MASK

#define ADDR_MOD_PACK_SEC2_ZsrcIncr_ADDR32 39
#define ADDR_MOD_PACK_SEC2_ZsrcIncr_SHAMT 12
#define ADDR_MOD_PACK_SEC2_ZsrcIncr_MASK 0x1000
#define ADDR_MOD_PACK_SEC2_ZsrcIncr_RMW \
    ADDR_MOD_PACK_SEC2_ZsrcIncr_ADDR32, ADDR_MOD_PACK_SEC2_ZsrcIncr_SHAMT, ADDR_MOD_PACK_SEC2_ZsrcIncr_MASK

#define ADDR_MOD_PACK_SEC2_ZsrcClear_ADDR32 39
#define ADDR_MOD_PACK_SEC2_ZsrcClear_SHAMT 13
#define ADDR_MOD_PACK_SEC2_ZsrcClear_MASK 0x2000
#define ADDR_MOD_PACK_SEC2_ZsrcClear_RMW \
    ADDR_MOD_PACK_SEC2_ZsrcClear_ADDR32, ADDR_MOD_PACK_SEC2_ZsrcClear_SHAMT, ADDR_MOD_PACK_SEC2_ZsrcClear_MASK

#define ADDR_MOD_PACK_SEC2_ZdstIncr_ADDR32 39
#define ADDR_MOD_PACK_SEC2_ZdstIncr_SHAMT 14
#define ADDR_MOD_PACK_SEC2_ZdstIncr_MASK 0x4000
#define ADDR_MOD_PACK_SEC2_ZdstIncr_RMW \
    ADDR_MOD_PACK_SEC2_ZdstIncr_ADDR32, ADDR_MOD_PACK_SEC2_ZdstIncr_SHAMT, ADDR_MOD_PACK_SEC2_ZdstIncr_MASK

#define ADDR_MOD_PACK_SEC2_ZdstClear_ADDR32 39
#define ADDR_MOD_PACK_SEC2_ZdstClear_SHAMT 15
#define ADDR_MOD_PACK_SEC2_ZdstClear_MASK 0x8000
#define ADDR_MOD_PACK_SEC2_ZdstClear_RMW \
    ADDR_MOD_PACK_SEC2_ZdstClear_ADDR32, ADDR_MOD_PACK_SEC2_ZdstClear_SHAMT, ADDR_MOD_PACK_SEC2_ZdstClear_MASK

#define ADDR_MOD_PACK_SEC3_YsrcIncr_ADDR32 40
#define ADDR_MOD_PACK_SEC3_YsrcIncr_SHAMT 0
#define ADDR_MOD_PACK_SEC3_YsrcIncr_MASK 0xf
#define ADDR_MOD_PACK_SEC3_YsrcIncr_RMW \
    ADDR_MOD_PACK_SEC3_YsrcIncr_ADDR32, ADDR_MOD_PACK_SEC3_YsrcIncr_SHAMT, ADDR_MOD_PACK_SEC3_YsrcIncr_MASK

#define ADDR_MOD_PACK_SEC3_YsrcCR_ADDR32 40
#define ADDR_MOD_PACK_SEC3_YsrcCR_SHAMT 4
#define ADDR_MOD_PACK_SEC3_YsrcCR_MASK 0x10
#define ADDR_MOD_PACK_SEC3_YsrcCR_RMW \
    ADDR_MOD_PACK_SEC3_YsrcCR_ADDR32, ADDR_MOD_PACK_SEC3_YsrcCR_SHAMT, ADDR_MOD_PACK_SEC3_YsrcCR_MASK

#define ADDR_MOD_PACK_SEC3_YsrcClear_ADDR32 40
#define ADDR_MOD_PACK_SEC3_YsrcClear_SHAMT 5
#define ADDR_MOD_PACK_SEC3_YsrcClear_MASK 0x20
#define ADDR_MOD_PACK_SEC3_YsrcClear_RMW \
    ADDR_MOD_PACK_SEC3_YsrcClear_ADDR32, ADDR_MOD_PACK_SEC3_YsrcClear_SHAMT, ADDR_MOD_PACK_SEC3_YsrcClear_MASK

#define ADDR_MOD_PACK_SEC3_YdstIncr_ADDR32 40
#define ADDR_MOD_PACK_SEC3_YdstIncr_SHAMT 6
#define ADDR_MOD_PACK_SEC3_YdstIncr_MASK 0x3c0
#define ADDR_MOD_PACK_SEC3_YdstIncr_RMW \
    ADDR_MOD_PACK_SEC3_YdstIncr_ADDR32, ADDR_MOD_PACK_SEC3_YdstIncr_SHAMT, ADDR_MOD_PACK_SEC3_YdstIncr_MASK

#define ADDR_MOD_PACK_SEC3_YdstCR_ADDR32 40
#define ADDR_MOD_PACK_SEC3_YdstCR_SHAMT 10
#define ADDR_MOD_PACK_SEC3_YdstCR_MASK 0x400
#define ADDR_MOD_PACK_SEC3_YdstCR_RMW \
    ADDR_MOD_PACK_SEC3_YdstCR_ADDR32, ADDR_MOD_PACK_SEC3_YdstCR_SHAMT, ADDR_MOD_PACK_SEC3_YdstCR_MASK

#define ADDR_MOD_PACK_SEC3_YdstClear_ADDR32 40
#define ADDR_MOD_PACK_SEC3_YdstClear_SHAMT 11
#define ADDR_MOD_PACK_SEC3_YdstClear_MASK 0x800
#define ADDR_MOD_PACK_SEC3_YdstClear_RMW \
    ADDR_MOD_PACK_SEC3_YdstClear_ADDR32, ADDR_MOD_PACK_SEC3_YdstClear_SHAMT, ADDR_MOD_PACK_SEC3_YdstClear_MASK

#define ADDR_MOD_PACK_SEC3_ZsrcIncr_ADDR32 40
#define ADDR_MOD_PACK_SEC3_ZsrcIncr_SHAMT 12
#define ADDR_MOD_PACK_SEC3_ZsrcIncr_MASK 0x1000
#define ADDR_MOD_PACK_SEC3_ZsrcIncr_RMW \
    ADDR_MOD_PACK_SEC3_ZsrcIncr_ADDR32, ADDR_MOD_PACK_SEC3_ZsrcIncr_SHAMT, ADDR_MOD_PACK_SEC3_ZsrcIncr_MASK

#define ADDR_MOD_PACK_SEC3_ZsrcClear_ADDR32 40
#define ADDR_MOD_PACK_SEC3_ZsrcClear_SHAMT 13
#define ADDR_MOD_PACK_SEC3_ZsrcClear_MASK 0x2000
#define ADDR_MOD_PACK_SEC3_ZsrcClear_RMW \
    ADDR_MOD_PACK_SEC3_ZsrcClear_ADDR32, ADDR_MOD_PACK_SEC3_ZsrcClear_SHAMT, ADDR_MOD_PACK_SEC3_ZsrcClear_MASK

#define ADDR_MOD_PACK_SEC3_ZdstIncr_ADDR32 40
#define ADDR_MOD_PACK_SEC3_ZdstIncr_SHAMT 14
#define ADDR_MOD_PACK_SEC3_ZdstIncr_MASK 0x4000
#define ADDR_MOD_PACK_SEC3_ZdstIncr_RMW \
    ADDR_MOD_PACK_SEC3_ZdstIncr_ADDR32, ADDR_MOD_PACK_SEC3_ZdstIncr_SHAMT, ADDR_MOD_PACK_SEC3_ZdstIncr_MASK

#define ADDR_MOD_PACK_SEC3_ZdstClear_ADDR32 40
#define ADDR_MOD_PACK_SEC3_ZdstClear_SHAMT 15
#define ADDR_MOD_PACK_SEC3_ZdstClear_MASK 0x8000
#define ADDR_MOD_PACK_SEC3_ZdstClear_RMW \
    ADDR_MOD_PACK_SEC3_ZdstClear_ADDR32, ADDR_MOD_PACK_SEC3_ZdstClear_SHAMT, ADDR_MOD_PACK_SEC3_ZdstClear_MASK

#define UNPACK_MISC_CFG_CfgContextOffset_0_ADDR32 41
#define UNPACK_MISC_CFG_CfgContextOffset_0_SHAMT 0
#define UNPACK_MISC_CFG_CfgContextOffset_0_MASK 0xf
#define UNPACK_MISC_CFG_CfgContextOffset_0_RMW                                           \
    UNPACK_MISC_CFG_CfgContextOffset_0_ADDR32, UNPACK_MISC_CFG_CfgContextOffset_0_SHAMT, \
        UNPACK_MISC_CFG_CfgContextOffset_0_MASK

#define UNPACK_MISC_CFG_CfgContextCntReset_0_ADDR32 41
#define UNPACK_MISC_CFG_CfgContextCntReset_0_SHAMT 4
#define UNPACK_MISC_CFG_CfgContextCntReset_0_MASK 0x10
#define UNPACK_MISC_CFG_CfgContextCntReset_0_RMW                                             \
    UNPACK_MISC_CFG_CfgContextCntReset_0_ADDR32, UNPACK_MISC_CFG_CfgContextCntReset_0_SHAMT, \
        UNPACK_MISC_CFG_CfgContextCntReset_0_MASK

#define UNPACK_MISC_CFG_CfgContextCntInc_0_ADDR32 41
#define UNPACK_MISC_CFG_CfgContextCntInc_0_SHAMT 5
#define UNPACK_MISC_CFG_CfgContextCntInc_0_MASK 0x20
#define UNPACK_MISC_CFG_CfgContextCntInc_0_RMW                                           \
    UNPACK_MISC_CFG_CfgContextCntInc_0_ADDR32, UNPACK_MISC_CFG_CfgContextCntInc_0_SHAMT, \
        UNPACK_MISC_CFG_CfgContextCntInc_0_MASK

#define UNPACK_MISC_CFG_CfgContextOffset_1_ADDR32 41
#define UNPACK_MISC_CFG_CfgContextOffset_1_SHAMT 8
#define UNPACK_MISC_CFG_CfgContextOffset_1_MASK 0xf00
#define UNPACK_MISC_CFG_CfgContextOffset_1_RMW                                           \
    UNPACK_MISC_CFG_CfgContextOffset_1_ADDR32, UNPACK_MISC_CFG_CfgContextOffset_1_SHAMT, \
        UNPACK_MISC_CFG_CfgContextOffset_1_MASK

#define UNPACK_MISC_CFG_CfgContextCntReset_1_ADDR32 41
#define UNPACK_MISC_CFG_CfgContextCntReset_1_SHAMT 12
#define UNPACK_MISC_CFG_CfgContextCntReset_1_MASK 0x1000
#define UNPACK_MISC_CFG_CfgContextCntReset_1_RMW                                             \
    UNPACK_MISC_CFG_CfgContextCntReset_1_ADDR32, UNPACK_MISC_CFG_CfgContextCntReset_1_SHAMT, \
        UNPACK_MISC_CFG_CfgContextCntReset_1_MASK

#define UNPACK_MISC_CFG_CfgContextCntInc_1_ADDR32 41
#define UNPACK_MISC_CFG_CfgContextCntInc_1_SHAMT 13
#define UNPACK_MISC_CFG_CfgContextCntInc_1_MASK 0x2000
#define UNPACK_MISC_CFG_CfgContextCntInc_1_RMW                                           \
    UNPACK_MISC_CFG_CfgContextCntInc_1_ADDR32, UNPACK_MISC_CFG_CfgContextCntInc_1_SHAMT, \
        UNPACK_MISC_CFG_CfgContextCntInc_1_MASK

#define UNPACK_MISC_CFG_CfgContextCntReset_metadata_ADDR32 41
#define UNPACK_MISC_CFG_CfgContextCntReset_metadata_SHAMT 14
#define UNPACK_MISC_CFG_CfgContextCntReset_metadata_MASK 0x4000
#define UNPACK_MISC_CFG_CfgContextCntReset_metadata_RMW                                                    \
    UNPACK_MISC_CFG_CfgContextCntReset_metadata_ADDR32, UNPACK_MISC_CFG_CfgContextCntReset_metadata_SHAMT, \
        UNPACK_MISC_CFG_CfgContextCntReset_metadata_MASK

#define UNPACK_MISC_CFG_CfgContextCntReset_metadata_zstart_ADDR32 41
#define UNPACK_MISC_CFG_CfgContextCntReset_metadata_zstart_SHAMT 15
#define UNPACK_MISC_CFG_CfgContextCntReset_metadata_zstart_MASK 0x8000
#define UNPACK_MISC_CFG_CfgContextCntReset_metadata_zstart_RMW    \
    UNPACK_MISC_CFG_CfgContextCntReset_metadata_zstart_ADDR32,    \
        UNPACK_MISC_CFG_CfgContextCntReset_metadata_zstart_SHAMT, \
        UNPACK_MISC_CFG_CfgContextCntReset_metadata_zstart_MASK

#define NOC_OVERLAY_MSG_CLEAR_StreamId_0_ADDR32 42
#define NOC_OVERLAY_MSG_CLEAR_StreamId_0_SHAMT 0
#define NOC_OVERLAY_MSG_CLEAR_StreamId_0_MASK 0x3f
#define NOC_OVERLAY_MSG_CLEAR_StreamId_0_RMW                                         \
    NOC_OVERLAY_MSG_CLEAR_StreamId_0_ADDR32, NOC_OVERLAY_MSG_CLEAR_StreamId_0_SHAMT, \
        NOC_OVERLAY_MSG_CLEAR_StreamId_0_MASK

#define NOC_OVERLAY_MSG_CLEAR_MsgNum_0_ADDR32 42
#define NOC_OVERLAY_MSG_CLEAR_MsgNum_0_SHAMT 8
#define NOC_OVERLAY_MSG_CLEAR_MsgNum_0_MASK 0x700
#define NOC_OVERLAY_MSG_CLEAR_MsgNum_0_RMW \
    NOC_OVERLAY_MSG_CLEAR_MsgNum_0_ADDR32, NOC_OVERLAY_MSG_CLEAR_MsgNum_0_SHAMT, NOC_OVERLAY_MSG_CLEAR_MsgNum_0_MASK

#define NOC_OVERLAY_MSG_CLEAR_StreamId_1_ADDR32 43
#define NOC_OVERLAY_MSG_CLEAR_StreamId_1_SHAMT 0
#define NOC_OVERLAY_MSG_CLEAR_StreamId_1_MASK 0x3f
#define NOC_OVERLAY_MSG_CLEAR_StreamId_1_RMW                                         \
    NOC_OVERLAY_MSG_CLEAR_StreamId_1_ADDR32, NOC_OVERLAY_MSG_CLEAR_StreamId_1_SHAMT, \
        NOC_OVERLAY_MSG_CLEAR_StreamId_1_MASK

#define NOC_OVERLAY_MSG_CLEAR_MsgNum_1_ADDR32 43
#define NOC_OVERLAY_MSG_CLEAR_MsgNum_1_SHAMT 8
#define NOC_OVERLAY_MSG_CLEAR_MsgNum_1_MASK 0x700
#define NOC_OVERLAY_MSG_CLEAR_MsgNum_1_RMW \
    NOC_OVERLAY_MSG_CLEAR_MsgNum_1_ADDR32, NOC_OVERLAY_MSG_CLEAR_MsgNum_1_SHAMT, NOC_OVERLAY_MSG_CLEAR_MsgNum_1_MASK

#define PERF_CNT_CMD_Cmd0Start_ADDR32 44
#define PERF_CNT_CMD_Cmd0Start_SHAMT 0
#define PERF_CNT_CMD_Cmd0Start_MASK 0x1
#define PERF_CNT_CMD_Cmd0Start_RMW \
    PERF_CNT_CMD_Cmd0Start_ADDR32, PERF_CNT_CMD_Cmd0Start_SHAMT, PERF_CNT_CMD_Cmd0Start_MASK

#define PERF_CNT_CMD_Cmd0Stop_ADDR32 44
#define PERF_CNT_CMD_Cmd0Stop_SHAMT 1
#define PERF_CNT_CMD_Cmd0Stop_MASK 0x2
#define PERF_CNT_CMD_Cmd0Stop_RMW PERF_CNT_CMD_Cmd0Stop_ADDR32, PERF_CNT_CMD_Cmd0Stop_SHAMT, PERF_CNT_CMD_Cmd0Stop_MASK

#define PERF_CNT_CMD_Cmd1Start_ADDR32 44
#define PERF_CNT_CMD_Cmd1Start_SHAMT 2
#define PERF_CNT_CMD_Cmd1Start_MASK 0x4
#define PERF_CNT_CMD_Cmd1Start_RMW \
    PERF_CNT_CMD_Cmd1Start_ADDR32, PERF_CNT_CMD_Cmd1Start_SHAMT, PERF_CNT_CMD_Cmd1Start_MASK

#define PERF_CNT_CMD_Cmd1Stop_ADDR32 44
#define PERF_CNT_CMD_Cmd1Stop_SHAMT 3
#define PERF_CNT_CMD_Cmd1Stop_MASK 0x8
#define PERF_CNT_CMD_Cmd1Stop_RMW PERF_CNT_CMD_Cmd1Stop_ADDR32, PERF_CNT_CMD_Cmd1Stop_SHAMT, PERF_CNT_CMD_Cmd1Stop_MASK

#define PERF_CNT_CMD_Cmd2Start_ADDR32 44
#define PERF_CNT_CMD_Cmd2Start_SHAMT 4
#define PERF_CNT_CMD_Cmd2Start_MASK 0x10
#define PERF_CNT_CMD_Cmd2Start_RMW \
    PERF_CNT_CMD_Cmd2Start_ADDR32, PERF_CNT_CMD_Cmd2Start_SHAMT, PERF_CNT_CMD_Cmd2Start_MASK

#define PERF_CNT_CMD_Cmd2Stop_ADDR32 44
#define PERF_CNT_CMD_Cmd2Stop_SHAMT 5
#define PERF_CNT_CMD_Cmd2Stop_MASK 0x20
#define PERF_CNT_CMD_Cmd2Stop_RMW PERF_CNT_CMD_Cmd2Stop_ADDR32, PERF_CNT_CMD_Cmd2Stop_SHAMT, PERF_CNT_CMD_Cmd2Stop_MASK

#define PERF_CNT_CMD_Cmd3Start_ADDR32 44
#define PERF_CNT_CMD_Cmd3Start_SHAMT 6
#define PERF_CNT_CMD_Cmd3Start_MASK 0x40
#define PERF_CNT_CMD_Cmd3Start_RMW \
    PERF_CNT_CMD_Cmd3Start_ADDR32, PERF_CNT_CMD_Cmd3Start_SHAMT, PERF_CNT_CMD_Cmd3Start_MASK

#define PERF_CNT_CMD_Cmd3Stop_ADDR32 44
#define PERF_CNT_CMD_Cmd3Stop_SHAMT 7
#define PERF_CNT_CMD_Cmd3Stop_MASK 0x80
#define PERF_CNT_CMD_Cmd3Stop_RMW PERF_CNT_CMD_Cmd3Stop_ADDR32, PERF_CNT_CMD_Cmd3Stop_SHAMT, PERF_CNT_CMD_Cmd3Stop_MASK

#define ENABLE_ACC_STATS_Enable_ADDR32 45
#define ENABLE_ACC_STATS_Enable_SHAMT 0
#define ENABLE_ACC_STATS_Enable_MASK 0x1
#define ENABLE_ACC_STATS_Enable_RMW \
    ENABLE_ACC_STATS_Enable_ADDR32, ENABLE_ACC_STATS_Enable_SHAMT, ENABLE_ACC_STATS_Enable_MASK

#define FPU_BIAS_SEL_Pointer_ADDR32 46
#define FPU_BIAS_SEL_Pointer_SHAMT 0
#define FPU_BIAS_SEL_Pointer_MASK 0x1
#define FPU_BIAS_SEL_Pointer_RMW FPU_BIAS_SEL_Pointer_ADDR32, FPU_BIAS_SEL_Pointer_SHAMT, FPU_BIAS_SEL_Pointer_MASK

#define ADDR_MOD_BIAS_SEC0_BiasIncr_ADDR32 47
#define ADDR_MOD_BIAS_SEC0_BiasIncr_SHAMT 0
#define ADDR_MOD_BIAS_SEC0_BiasIncr_MASK 0xf
#define ADDR_MOD_BIAS_SEC0_BiasIncr_RMW \
    ADDR_MOD_BIAS_SEC0_BiasIncr_ADDR32, ADDR_MOD_BIAS_SEC0_BiasIncr_SHAMT, ADDR_MOD_BIAS_SEC0_BiasIncr_MASK

#define ADDR_MOD_BIAS_SEC0_BiasClear_ADDR32 47
#define ADDR_MOD_BIAS_SEC0_BiasClear_SHAMT 4
#define ADDR_MOD_BIAS_SEC0_BiasClear_MASK 0x10
#define ADDR_MOD_BIAS_SEC0_BiasClear_RMW \
    ADDR_MOD_BIAS_SEC0_BiasClear_ADDR32, ADDR_MOD_BIAS_SEC0_BiasClear_SHAMT, ADDR_MOD_BIAS_SEC0_BiasClear_MASK

#define ADDR_MOD_BIAS_SEC1_BiasIncr_ADDR32 48
#define ADDR_MOD_BIAS_SEC1_BiasIncr_SHAMT 0
#define ADDR_MOD_BIAS_SEC1_BiasIncr_MASK 0xf
#define ADDR_MOD_BIAS_SEC1_BiasIncr_RMW \
    ADDR_MOD_BIAS_SEC1_BiasIncr_ADDR32, ADDR_MOD_BIAS_SEC1_BiasIncr_SHAMT, ADDR_MOD_BIAS_SEC1_BiasIncr_MASK

#define ADDR_MOD_BIAS_SEC1_BiasClear_ADDR32 48
#define ADDR_MOD_BIAS_SEC1_BiasClear_SHAMT 4
#define ADDR_MOD_BIAS_SEC1_BiasClear_MASK 0x10
#define ADDR_MOD_BIAS_SEC1_BiasClear_RMW \
    ADDR_MOD_BIAS_SEC1_BiasClear_ADDR32, ADDR_MOD_BIAS_SEC1_BiasClear_SHAMT, ADDR_MOD_BIAS_SEC1_BiasClear_MASK

#define ADDR_MOD_BIAS_SEC2_BiasIncr_ADDR32 49
#define ADDR_MOD_BIAS_SEC2_BiasIncr_SHAMT 0
#define ADDR_MOD_BIAS_SEC2_BiasIncr_MASK 0xf
#define ADDR_MOD_BIAS_SEC2_BiasIncr_RMW \
    ADDR_MOD_BIAS_SEC2_BiasIncr_ADDR32, ADDR_MOD_BIAS_SEC2_BiasIncr_SHAMT, ADDR_MOD_BIAS_SEC2_BiasIncr_MASK

#define ADDR_MOD_BIAS_SEC2_BiasClear_ADDR32 49
#define ADDR_MOD_BIAS_SEC2_BiasClear_SHAMT 4
#define ADDR_MOD_BIAS_SEC2_BiasClear_MASK 0x10
#define ADDR_MOD_BIAS_SEC2_BiasClear_RMW \
    ADDR_MOD_BIAS_SEC2_BiasClear_ADDR32, ADDR_MOD_BIAS_SEC2_BiasClear_SHAMT, ADDR_MOD_BIAS_SEC2_BiasClear_MASK

#define ADDR_MOD_BIAS_SEC3_BiasIncr_ADDR32 50
#define ADDR_MOD_BIAS_SEC3_BiasIncr_SHAMT 0
#define ADDR_MOD_BIAS_SEC3_BiasIncr_MASK 0xf
#define ADDR_MOD_BIAS_SEC3_BiasIncr_RMW \
    ADDR_MOD_BIAS_SEC3_BiasIncr_ADDR32, ADDR_MOD_BIAS_SEC3_BiasIncr_SHAMT, ADDR_MOD_BIAS_SEC3_BiasIncr_MASK

#define ADDR_MOD_BIAS_SEC3_BiasClear_ADDR32 50
#define ADDR_MOD_BIAS_SEC3_BiasClear_SHAMT 4
#define ADDR_MOD_BIAS_SEC3_BiasClear_MASK 0x10
#define ADDR_MOD_BIAS_SEC3_BiasClear_RMW \
    ADDR_MOD_BIAS_SEC3_BiasClear_ADDR32, ADDR_MOD_BIAS_SEC3_BiasClear_SHAMT, ADDR_MOD_BIAS_SEC3_BiasClear_MASK

#define ADDR_MOD_BIAS_SEC4_BiasIncr_ADDR32 51
#define ADDR_MOD_BIAS_SEC4_BiasIncr_SHAMT 0
#define ADDR_MOD_BIAS_SEC4_BiasIncr_MASK 0xf
#define ADDR_MOD_BIAS_SEC4_BiasIncr_RMW \
    ADDR_MOD_BIAS_SEC4_BiasIncr_ADDR32, ADDR_MOD_BIAS_SEC4_BiasIncr_SHAMT, ADDR_MOD_BIAS_SEC4_BiasIncr_MASK

#define ADDR_MOD_BIAS_SEC4_BiasClear_ADDR32 51
#define ADDR_MOD_BIAS_SEC4_BiasClear_SHAMT 4
#define ADDR_MOD_BIAS_SEC4_BiasClear_MASK 0x10
#define ADDR_MOD_BIAS_SEC4_BiasClear_RMW \
    ADDR_MOD_BIAS_SEC4_BiasClear_ADDR32, ADDR_MOD_BIAS_SEC4_BiasClear_SHAMT, ADDR_MOD_BIAS_SEC4_BiasClear_MASK

#define ADDR_MOD_BIAS_SEC5_BiasIncr_ADDR32 52
#define ADDR_MOD_BIAS_SEC5_BiasIncr_SHAMT 0
#define ADDR_MOD_BIAS_SEC5_BiasIncr_MASK 0xf
#define ADDR_MOD_BIAS_SEC5_BiasIncr_RMW \
    ADDR_MOD_BIAS_SEC5_BiasIncr_ADDR32, ADDR_MOD_BIAS_SEC5_BiasIncr_SHAMT, ADDR_MOD_BIAS_SEC5_BiasIncr_MASK

#define ADDR_MOD_BIAS_SEC5_BiasClear_ADDR32 52
#define ADDR_MOD_BIAS_SEC5_BiasClear_SHAMT 4
#define ADDR_MOD_BIAS_SEC5_BiasClear_MASK 0x10
#define ADDR_MOD_BIAS_SEC5_BiasClear_RMW \
    ADDR_MOD_BIAS_SEC5_BiasClear_ADDR32, ADDR_MOD_BIAS_SEC5_BiasClear_SHAMT, ADDR_MOD_BIAS_SEC5_BiasClear_MASK

#define ADDR_MOD_BIAS_SEC6_BiasIncr_ADDR32 53
#define ADDR_MOD_BIAS_SEC6_BiasIncr_SHAMT 0
#define ADDR_MOD_BIAS_SEC6_BiasIncr_MASK 0xf
#define ADDR_MOD_BIAS_SEC6_BiasIncr_RMW \
    ADDR_MOD_BIAS_SEC6_BiasIncr_ADDR32, ADDR_MOD_BIAS_SEC6_BiasIncr_SHAMT, ADDR_MOD_BIAS_SEC6_BiasIncr_MASK

#define ADDR_MOD_BIAS_SEC6_BiasClear_ADDR32 53
#define ADDR_MOD_BIAS_SEC6_BiasClear_SHAMT 4
#define ADDR_MOD_BIAS_SEC6_BiasClear_MASK 0x10
#define ADDR_MOD_BIAS_SEC6_BiasClear_RMW \
    ADDR_MOD_BIAS_SEC6_BiasClear_ADDR32, ADDR_MOD_BIAS_SEC6_BiasClear_SHAMT, ADDR_MOD_BIAS_SEC6_BiasClear_MASK

#define ADDR_MOD_BIAS_SEC7_BiasIncr_ADDR32 54
#define ADDR_MOD_BIAS_SEC7_BiasIncr_SHAMT 0
#define ADDR_MOD_BIAS_SEC7_BiasIncr_MASK 0xf
#define ADDR_MOD_BIAS_SEC7_BiasIncr_RMW \
    ADDR_MOD_BIAS_SEC7_BiasIncr_ADDR32, ADDR_MOD_BIAS_SEC7_BiasIncr_SHAMT, ADDR_MOD_BIAS_SEC7_BiasIncr_MASK

#define ADDR_MOD_BIAS_SEC7_BiasClear_ADDR32 54
#define ADDR_MOD_BIAS_SEC7_BiasClear_SHAMT 4
#define ADDR_MOD_BIAS_SEC7_BiasClear_MASK 0x10
#define ADDR_MOD_BIAS_SEC7_BiasClear_RMW \
    ADDR_MOD_BIAS_SEC7_BiasClear_ADDR32, ADDR_MOD_BIAS_SEC7_BiasClear_SHAMT, ADDR_MOD_BIAS_SEC7_BiasClear_MASK

#define FP16A_FORCE_Enable_ADDR32 55
#define FP16A_FORCE_Enable_SHAMT 0
#define FP16A_FORCE_Enable_MASK 0x1
#define FP16A_FORCE_Enable_RMW FP16A_FORCE_Enable_ADDR32, FP16A_FORCE_Enable_SHAMT, FP16A_FORCE_Enable_MASK

#define TENSIX_TRISC_SYNC_TrackGlobalCfg_ADDR32 56
#define TENSIX_TRISC_SYNC_TrackGlobalCfg_SHAMT 0
#define TENSIX_TRISC_SYNC_TrackGlobalCfg_MASK 0x1
#define TENSIX_TRISC_SYNC_TrackGlobalCfg_RMW                                         \
    TENSIX_TRISC_SYNC_TrackGlobalCfg_ADDR32, TENSIX_TRISC_SYNC_TrackGlobalCfg_SHAMT, \
        TENSIX_TRISC_SYNC_TrackGlobalCfg_MASK

#define TENSIX_TRISC_SYNC_EnSubdividedCfgForUnpacr_ADDR32 56
#define TENSIX_TRISC_SYNC_EnSubdividedCfgForUnpacr_SHAMT 1
#define TENSIX_TRISC_SYNC_EnSubdividedCfgForUnpacr_MASK 0x2
#define TENSIX_TRISC_SYNC_EnSubdividedCfgForUnpacr_RMW                                                   \
    TENSIX_TRISC_SYNC_EnSubdividedCfgForUnpacr_ADDR32, TENSIX_TRISC_SYNC_EnSubdividedCfgForUnpacr_SHAMT, \
        TENSIX_TRISC_SYNC_EnSubdividedCfgForUnpacr_MASK

#define TENSIX_TRISC_SYNC_TrackGPR_ADDR32 56
#define TENSIX_TRISC_SYNC_TrackGPR_SHAMT 2
#define TENSIX_TRISC_SYNC_TrackGPR_MASK 0x4
#define TENSIX_TRISC_SYNC_TrackGPR_RMW \
    TENSIX_TRISC_SYNC_TrackGPR_ADDR32, TENSIX_TRISC_SYNC_TrackGPR_SHAMT, TENSIX_TRISC_SYNC_TrackGPR_MASK

#define TENSIX_TRISC_SYNC_TrackTDMARegs_ADDR32 56
#define TENSIX_TRISC_SYNC_TrackTDMARegs_SHAMT 3
#define TENSIX_TRISC_SYNC_TrackTDMARegs_MASK 0x8
#define TENSIX_TRISC_SYNC_TrackTDMARegs_RMW \
    TENSIX_TRISC_SYNC_TrackTDMARegs_ADDR32, TENSIX_TRISC_SYNC_TrackTDMARegs_SHAMT, TENSIX_TRISC_SYNC_TrackTDMARegs_MASK

#define TENSIX_TRISC_SYNC_TrackTensixInstructions_ADDR32 56
#define TENSIX_TRISC_SYNC_TrackTensixInstructions_SHAMT 4
#define TENSIX_TRISC_SYNC_TrackTensixInstructions_MASK 0x10
#define TENSIX_TRISC_SYNC_TrackTensixInstructions_RMW                                                  \
    TENSIX_TRISC_SYNC_TrackTensixInstructions_ADDR32, TENSIX_TRISC_SYNC_TrackTensixInstructions_SHAMT, \
        TENSIX_TRISC_SYNC_TrackTensixInstructions_MASK

#define STREAMWAIT_PHASE_HI_Val_ADDR32 57
#define STREAMWAIT_PHASE_HI_Val_SHAMT 0
#define STREAMWAIT_PHASE_HI_Val_MASK 0x3ff
#define STREAMWAIT_PHASE_HI_Val_RMW \
    STREAMWAIT_PHASE_HI_Val_ADDR32, STREAMWAIT_PHASE_HI_Val_SHAMT, STREAMWAIT_PHASE_HI_Val_MASK

#define STREAMWAIT_NUM_MSGS_HI_Val_ADDR32 58
#define STREAMWAIT_NUM_MSGS_HI_Val_SHAMT 0
#define STREAMWAIT_NUM_MSGS_HI_Val_MASK 0x7f
#define STREAMWAIT_NUM_MSGS_HI_Val_RMW \
    STREAMWAIT_NUM_MSGS_HI_Val_ADDR32, STREAMWAIT_NUM_MSGS_HI_Val_SHAMT, STREAMWAIT_NUM_MSGS_HI_Val_MASK

#define STREAM_ID_SYNC_SEC0_BankSel_ADDR32 59
#define STREAM_ID_SYNC_SEC0_BankSel_SHAMT 0
#define STREAM_ID_SYNC_SEC0_BankSel_MASK 0x3f
#define STREAM_ID_SYNC_SEC0_BankSel_RMW \
    STREAM_ID_SYNC_SEC0_BankSel_ADDR32, STREAM_ID_SYNC_SEC0_BankSel_SHAMT, STREAM_ID_SYNC_SEC0_BankSel_MASK

#define STREAM_ID_SYNC_SEC1_BankSel_ADDR32 60
#define STREAM_ID_SYNC_SEC1_BankSel_SHAMT 0
#define STREAM_ID_SYNC_SEC1_BankSel_MASK 0x3f
#define STREAM_ID_SYNC_SEC1_BankSel_RMW \
    STREAM_ID_SYNC_SEC1_BankSel_ADDR32, STREAM_ID_SYNC_SEC1_BankSel_SHAMT, STREAM_ID_SYNC_SEC1_BankSel_MASK

#define STREAM_ID_SYNC_SEC2_BankSel_ADDR32 61
#define STREAM_ID_SYNC_SEC2_BankSel_SHAMT 0
#define STREAM_ID_SYNC_SEC2_BankSel_MASK 0x3f
#define STREAM_ID_SYNC_SEC2_BankSel_RMW \
    STREAM_ID_SYNC_SEC2_BankSel_ADDR32, STREAM_ID_SYNC_SEC2_BankSel_SHAMT, STREAM_ID_SYNC_SEC2_BankSel_MASK

#define STREAM_ID_SYNC_SEC3_BankSel_ADDR32 62
#define STREAM_ID_SYNC_SEC3_BankSel_SHAMT 0
#define STREAM_ID_SYNC_SEC3_BankSel_MASK 0x3f
#define STREAM_ID_SYNC_SEC3_BankSel_RMW \
    STREAM_ID_SYNC_SEC3_BankSel_ADDR32, STREAM_ID_SYNC_SEC3_BankSel_SHAMT, STREAM_ID_SYNC_SEC3_BankSel_MASK

#define STREAM_ID_TRISC_SEC0_BankSel_ADDR32 63
#define STREAM_ID_TRISC_SEC0_BankSel_SHAMT 0
#define STREAM_ID_TRISC_SEC0_BankSel_MASK 0x3f
#define STREAM_ID_TRISC_SEC0_BankSel_RMW \
    STREAM_ID_TRISC_SEC0_BankSel_ADDR32, STREAM_ID_TRISC_SEC0_BankSel_SHAMT, STREAM_ID_TRISC_SEC0_BankSel_MASK

#define STREAM_ID_TRISC_SEC1_BankSel_ADDR32 64
#define STREAM_ID_TRISC_SEC1_BankSel_SHAMT 0
#define STREAM_ID_TRISC_SEC1_BankSel_MASK 0x3f
#define STREAM_ID_TRISC_SEC1_BankSel_RMW \
    STREAM_ID_TRISC_SEC1_BankSel_ADDR32, STREAM_ID_TRISC_SEC1_BankSel_SHAMT, STREAM_ID_TRISC_SEC1_BankSel_MASK

#define STREAM_ID_TRISC_SEC2_BankSel_ADDR32 65
#define STREAM_ID_TRISC_SEC2_BankSel_SHAMT 0
#define STREAM_ID_TRISC_SEC2_BankSel_MASK 0x3f
#define STREAM_ID_TRISC_SEC2_BankSel_RMW \
    STREAM_ID_TRISC_SEC2_BankSel_ADDR32, STREAM_ID_TRISC_SEC2_BankSel_SHAMT, STREAM_ID_TRISC_SEC2_BankSel_MASK

#define STREAM_ID_TRISC_SEC3_BankSel_ADDR32 66
#define STREAM_ID_TRISC_SEC3_BankSel_SHAMT 0
#define STREAM_ID_TRISC_SEC3_BankSel_MASK 0x3f
#define STREAM_ID_TRISC_SEC3_BankSel_RMW \
    STREAM_ID_TRISC_SEC3_BankSel_ADDR32, STREAM_ID_TRISC_SEC3_BankSel_SHAMT, STREAM_ID_TRISC_SEC3_BankSel_MASK

#define TENSIX_CSR_CONFIG_RawBusyStatus_ADDR32 67
#define TENSIX_CSR_CONFIG_RawBusyStatus_SHAMT 0
#define TENSIX_CSR_CONFIG_RawBusyStatus_MASK 0x1
#define TENSIX_CSR_CONFIG_RawBusyStatus_RMW \
    TENSIX_CSR_CONFIG_RawBusyStatus_ADDR32, TENSIX_CSR_CONFIG_RawBusyStatus_SHAMT, TENSIX_CSR_CONFIG_RawBusyStatus_MASK

////////////////////////////////////////////////////////////////////////
// Registers for ALU
////////////////////////////////////////////////////////////////////////

#define ALU_CFGREG_BASE_ADDR32 0

#define ALU_FORMAT_SPEC_REG_SrcA_val_ADDR32 0
#define ALU_FORMAT_SPEC_REG_SrcA_val_SHAMT 0
#define ALU_FORMAT_SPEC_REG_SrcA_val_MASK 0xf
#define ALU_FORMAT_SPEC_REG_SrcA_val_RMW \
    ALU_FORMAT_SPEC_REG_SrcA_val_ADDR32, ALU_FORMAT_SPEC_REG_SrcA_val_SHAMT, ALU_FORMAT_SPEC_REG_SrcA_val_MASK

#define ALU_FORMAT_SPEC_REG_SrcA_override_ADDR32 0
#define ALU_FORMAT_SPEC_REG_SrcA_override_SHAMT 4
#define ALU_FORMAT_SPEC_REG_SrcA_override_MASK 0x10
#define ALU_FORMAT_SPEC_REG_SrcA_override_RMW                                          \
    ALU_FORMAT_SPEC_REG_SrcA_override_ADDR32, ALU_FORMAT_SPEC_REG_SrcA_override_SHAMT, \
        ALU_FORMAT_SPEC_REG_SrcA_override_MASK

#define ALU_FORMAT_SPEC_REG_SrcB_val_ADDR32 0
#define ALU_FORMAT_SPEC_REG_SrcB_val_SHAMT 5
#define ALU_FORMAT_SPEC_REG_SrcB_val_MASK 0x1e0
#define ALU_FORMAT_SPEC_REG_SrcB_val_RMW \
    ALU_FORMAT_SPEC_REG_SrcB_val_ADDR32, ALU_FORMAT_SPEC_REG_SrcB_val_SHAMT, ALU_FORMAT_SPEC_REG_SrcB_val_MASK

#define ALU_FORMAT_SPEC_REG_SrcB_override_ADDR32 0
#define ALU_FORMAT_SPEC_REG_SrcB_override_SHAMT 9
#define ALU_FORMAT_SPEC_REG_SrcB_override_MASK 0x200
#define ALU_FORMAT_SPEC_REG_SrcB_override_RMW                                          \
    ALU_FORMAT_SPEC_REG_SrcB_override_ADDR32, ALU_FORMAT_SPEC_REG_SrcB_override_SHAMT, \
        ALU_FORMAT_SPEC_REG_SrcB_override_MASK

#define ALU_FORMAT_SPEC_REG_Dstacc_val_ADDR32 0
#define ALU_FORMAT_SPEC_REG_Dstacc_val_SHAMT 10
#define ALU_FORMAT_SPEC_REG_Dstacc_val_MASK 0x3c00
#define ALU_FORMAT_SPEC_REG_Dstacc_val_RMW \
    ALU_FORMAT_SPEC_REG_Dstacc_val_ADDR32, ALU_FORMAT_SPEC_REG_Dstacc_val_SHAMT, ALU_FORMAT_SPEC_REG_Dstacc_val_MASK

#define ALU_FORMAT_SPEC_REG_Dstacc_override_ADDR32 0
#define ALU_FORMAT_SPEC_REG_Dstacc_override_SHAMT 14
#define ALU_FORMAT_SPEC_REG_Dstacc_override_MASK 0x4000
#define ALU_FORMAT_SPEC_REG_Dstacc_override_RMW                                            \
    ALU_FORMAT_SPEC_REG_Dstacc_override_ADDR32, ALU_FORMAT_SPEC_REG_Dstacc_override_SHAMT, \
        ALU_FORMAT_SPEC_REG_Dstacc_override_MASK

#define ALU_ROUNDING_MODE_Fpu_srnd_en_ADDR32 1
#define ALU_ROUNDING_MODE_Fpu_srnd_en_SHAMT 0
#define ALU_ROUNDING_MODE_Fpu_srnd_en_MASK 0x1
#define ALU_ROUNDING_MODE_Fpu_srnd_en_RMW \
    ALU_ROUNDING_MODE_Fpu_srnd_en_ADDR32, ALU_ROUNDING_MODE_Fpu_srnd_en_SHAMT, ALU_ROUNDING_MODE_Fpu_srnd_en_MASK

#define ALU_ROUNDING_MODE_Gasket_srnd_en_ADDR32 1
#define ALU_ROUNDING_MODE_Gasket_srnd_en_SHAMT 1
#define ALU_ROUNDING_MODE_Gasket_srnd_en_MASK 0x2
#define ALU_ROUNDING_MODE_Gasket_srnd_en_RMW                                         \
    ALU_ROUNDING_MODE_Gasket_srnd_en_ADDR32, ALU_ROUNDING_MODE_Gasket_srnd_en_SHAMT, \
        ALU_ROUNDING_MODE_Gasket_srnd_en_MASK

#define ALU_ROUNDING_MODE_Packer_srnd_en_ADDR32 1
#define ALU_ROUNDING_MODE_Packer_srnd_en_SHAMT 2
#define ALU_ROUNDING_MODE_Packer_srnd_en_MASK 0x4
#define ALU_ROUNDING_MODE_Packer_srnd_en_RMW                                         \
    ALU_ROUNDING_MODE_Packer_srnd_en_ADDR32, ALU_ROUNDING_MODE_Packer_srnd_en_SHAMT, \
        ALU_ROUNDING_MODE_Packer_srnd_en_MASK

#define ALU_ROUNDING_MODE_Padding_ADDR32 1
#define ALU_ROUNDING_MODE_Padding_SHAMT 3
#define ALU_ROUNDING_MODE_Padding_MASK 0x1ff8
#define ALU_ROUNDING_MODE_Padding_RMW \
    ALU_ROUNDING_MODE_Padding_ADDR32, ALU_ROUNDING_MODE_Padding_SHAMT, ALU_ROUNDING_MODE_Padding_MASK

#define ALU_ROUNDING_MODE_GS_LF_ADDR32 1
#define ALU_ROUNDING_MODE_GS_LF_SHAMT 13
#define ALU_ROUNDING_MODE_GS_LF_MASK 0x2000
#define ALU_ROUNDING_MODE_GS_LF_RMW \
    ALU_ROUNDING_MODE_GS_LF_ADDR32, ALU_ROUNDING_MODE_GS_LF_SHAMT, ALU_ROUNDING_MODE_GS_LF_MASK

#define ALU_ROUNDING_MODE_Bfp8_HF_ADDR32 1
#define ALU_ROUNDING_MODE_Bfp8_HF_SHAMT 14
#define ALU_ROUNDING_MODE_Bfp8_HF_MASK 0x4000
#define ALU_ROUNDING_MODE_Bfp8_HF_RMW \
    ALU_ROUNDING_MODE_Bfp8_HF_ADDR32, ALU_ROUNDING_MODE_Bfp8_HF_SHAMT, ALU_ROUNDING_MODE_Bfp8_HF_MASK

#define ALU_FORMAT_SPEC_REG0_SrcAUnsigned_ADDR32 1
#define ALU_FORMAT_SPEC_REG0_SrcAUnsigned_SHAMT 15
#define ALU_FORMAT_SPEC_REG0_SrcAUnsigned_MASK 0x8000
#define ALU_FORMAT_SPEC_REG0_SrcAUnsigned_RMW                                          \
    ALU_FORMAT_SPEC_REG0_SrcAUnsigned_ADDR32, ALU_FORMAT_SPEC_REG0_SrcAUnsigned_SHAMT, \
        ALU_FORMAT_SPEC_REG0_SrcAUnsigned_MASK

#define ALU_FORMAT_SPEC_REG0_SrcBUnsigned_ADDR32 1
#define ALU_FORMAT_SPEC_REG0_SrcBUnsigned_SHAMT 16
#define ALU_FORMAT_SPEC_REG0_SrcBUnsigned_MASK 0x10000
#define ALU_FORMAT_SPEC_REG0_SrcBUnsigned_RMW                                          \
    ALU_FORMAT_SPEC_REG0_SrcBUnsigned_ADDR32, ALU_FORMAT_SPEC_REG0_SrcBUnsigned_SHAMT, \
        ALU_FORMAT_SPEC_REG0_SrcBUnsigned_MASK

#define ALU_FORMAT_SPEC_REG0_SrcA_ADDR32 1
#define ALU_FORMAT_SPEC_REG0_SrcA_SHAMT 17
#define ALU_FORMAT_SPEC_REG0_SrcA_MASK 0x1e0000
#define ALU_FORMAT_SPEC_REG0_SrcA_RMW \
    ALU_FORMAT_SPEC_REG0_SrcA_ADDR32, ALU_FORMAT_SPEC_REG0_SrcA_SHAMT, ALU_FORMAT_SPEC_REG0_SrcA_MASK

#define ALU_FORMAT_SPEC_REG1_SrcB_ADDR32 1
#define ALU_FORMAT_SPEC_REG1_SrcB_SHAMT 21
#define ALU_FORMAT_SPEC_REG1_SrcB_MASK 0x1e00000
#define ALU_FORMAT_SPEC_REG1_SrcB_RMW \
    ALU_FORMAT_SPEC_REG1_SrcB_ADDR32, ALU_FORMAT_SPEC_REG1_SrcB_SHAMT, ALU_FORMAT_SPEC_REG1_SrcB_MASK

#define ALU_FORMAT_SPEC_REG2_Dstacc_ADDR32 1
#define ALU_FORMAT_SPEC_REG2_Dstacc_SHAMT 25
#define ALU_FORMAT_SPEC_REG2_Dstacc_MASK 0x1e000000
#define ALU_FORMAT_SPEC_REG2_Dstacc_RMW \
    ALU_FORMAT_SPEC_REG2_Dstacc_ADDR32, ALU_FORMAT_SPEC_REG2_Dstacc_SHAMT, ALU_FORMAT_SPEC_REG2_Dstacc_MASK

#define ALU_ACC_CTRL_Fp32_enabled_ADDR32 1
#define ALU_ACC_CTRL_Fp32_enabled_SHAMT 29
#define ALU_ACC_CTRL_Fp32_enabled_MASK 0x20000000
#define ALU_ACC_CTRL_Fp32_enabled_RMW \
    ALU_ACC_CTRL_Fp32_enabled_ADDR32, ALU_ACC_CTRL_Fp32_enabled_SHAMT, ALU_ACC_CTRL_Fp32_enabled_MASK

#define ALU_ACC_CTRL_SFPU_Fp32_enabled_ADDR32 1
#define ALU_ACC_CTRL_SFPU_Fp32_enabled_SHAMT 30
#define ALU_ACC_CTRL_SFPU_Fp32_enabled_MASK 0x40000000
#define ALU_ACC_CTRL_SFPU_Fp32_enabled_RMW \
    ALU_ACC_CTRL_SFPU_Fp32_enabled_ADDR32, ALU_ACC_CTRL_SFPU_Fp32_enabled_SHAMT, ALU_ACC_CTRL_SFPU_Fp32_enabled_MASK

#define ALU_ACC_CTRL_INT8_math_enabled_ADDR32 1
#define ALU_ACC_CTRL_INT8_math_enabled_SHAMT 31
#define ALU_ACC_CTRL_INT8_math_enabled_MASK 0x80000000
#define ALU_ACC_CTRL_INT8_math_enabled_RMW \
    ALU_ACC_CTRL_INT8_math_enabled_ADDR32, ALU_ACC_CTRL_INT8_math_enabled_SHAMT, ALU_ACC_CTRL_INT8_math_enabled_MASK

#define ALU_ACC_CTRL_Zero_Flag_disabled_src_ADDR32 2
#define ALU_ACC_CTRL_Zero_Flag_disabled_src_SHAMT 0
#define ALU_ACC_CTRL_Zero_Flag_disabled_src_MASK 0x1
#define ALU_ACC_CTRL_Zero_Flag_disabled_src_RMW                                            \
    ALU_ACC_CTRL_Zero_Flag_disabled_src_ADDR32, ALU_ACC_CTRL_Zero_Flag_disabled_src_SHAMT, \
        ALU_ACC_CTRL_Zero_Flag_disabled_src_MASK

#define ALU_ACC_CTRL_Zero_Flag_disabled_dst_ADDR32 2
#define ALU_ACC_CTRL_Zero_Flag_disabled_dst_SHAMT 1
#define ALU_ACC_CTRL_Zero_Flag_disabled_dst_MASK 0x2
#define ALU_ACC_CTRL_Zero_Flag_disabled_dst_RMW                                            \
    ALU_ACC_CTRL_Zero_Flag_disabled_dst_ADDR32, ALU_ACC_CTRL_Zero_Flag_disabled_dst_SHAMT, \
        ALU_ACC_CTRL_Zero_Flag_disabled_dst_MASK

#define STACC_RELU_ApplyRelu_ADDR32 2
#define STACC_RELU_ApplyRelu_SHAMT 2
#define STACC_RELU_ApplyRelu_MASK 0x3c
#define STACC_RELU_ApplyRelu_RMW STACC_RELU_ApplyRelu_ADDR32, STACC_RELU_ApplyRelu_SHAMT, STACC_RELU_ApplyRelu_MASK

#define STACC_RELU_ReluThreshold_ADDR32 2
#define STACC_RELU_ReluThreshold_SHAMT 6
#define STACC_RELU_ReluThreshold_MASK 0x3fffc0
#define STACC_RELU_ReluThreshold_RMW \
    STACC_RELU_ReluThreshold_ADDR32, STACC_RELU_ReluThreshold_SHAMT, STACC_RELU_ReluThreshold_MASK

#define DISABLE_RISC_BP_Disable_main_ADDR32 2
#define DISABLE_RISC_BP_Disable_main_SHAMT 22
#define DISABLE_RISC_BP_Disable_main_MASK 0x400000
#define DISABLE_RISC_BP_Disable_main_RMW \
    DISABLE_RISC_BP_Disable_main_ADDR32, DISABLE_RISC_BP_Disable_main_SHAMT, DISABLE_RISC_BP_Disable_main_MASK

#define DISABLE_RISC_BP_Disable_trisc_ADDR32 2
#define DISABLE_RISC_BP_Disable_trisc_SHAMT 23
#define DISABLE_RISC_BP_Disable_trisc_MASK 0x3800000
#define DISABLE_RISC_BP_Disable_trisc_RMW \
    DISABLE_RISC_BP_Disable_trisc_ADDR32, DISABLE_RISC_BP_Disable_trisc_SHAMT, DISABLE_RISC_BP_Disable_trisc_MASK

#define DISABLE_RISC_BP_Disable_ncrisc_ADDR32 2
#define DISABLE_RISC_BP_Disable_ncrisc_SHAMT 26
#define DISABLE_RISC_BP_Disable_ncrisc_MASK 0x4000000
#define DISABLE_RISC_BP_Disable_ncrisc_RMW \
    DISABLE_RISC_BP_Disable_ncrisc_ADDR32, DISABLE_RISC_BP_Disable_ncrisc_SHAMT, DISABLE_RISC_BP_Disable_ncrisc_MASK

#define DISABLE_RISC_BP_Disable_bmp_clear_main_ADDR32 2
#define DISABLE_RISC_BP_Disable_bmp_clear_main_SHAMT 27
#define DISABLE_RISC_BP_Disable_bmp_clear_main_MASK 0x8000000
#define DISABLE_RISC_BP_Disable_bmp_clear_main_RMW                                               \
    DISABLE_RISC_BP_Disable_bmp_clear_main_ADDR32, DISABLE_RISC_BP_Disable_bmp_clear_main_SHAMT, \
        DISABLE_RISC_BP_Disable_bmp_clear_main_MASK

#define DISABLE_RISC_BP_Disable_bmp_clear_trisc_ADDR32 2
#define DISABLE_RISC_BP_Disable_bmp_clear_trisc_SHAMT 28
#define DISABLE_RISC_BP_Disable_bmp_clear_trisc_MASK 0x70000000
#define DISABLE_RISC_BP_Disable_bmp_clear_trisc_RMW                                                \
    DISABLE_RISC_BP_Disable_bmp_clear_trisc_ADDR32, DISABLE_RISC_BP_Disable_bmp_clear_trisc_SHAMT, \
        DISABLE_RISC_BP_Disable_bmp_clear_trisc_MASK

#define DISABLE_RISC_BP_Disable_bmp_clear_ncrisc_ADDR32 2
#define DISABLE_RISC_BP_Disable_bmp_clear_ncrisc_SHAMT 31
#define DISABLE_RISC_BP_Disable_bmp_clear_ncrisc_MASK 0x80000000
#define DISABLE_RISC_BP_Disable_bmp_clear_ncrisc_RMW                                                 \
    DISABLE_RISC_BP_Disable_bmp_clear_ncrisc_ADDR32, DISABLE_RISC_BP_Disable_bmp_clear_ncrisc_SHAMT, \
        DISABLE_RISC_BP_Disable_bmp_clear_ncrisc_MASK

#define ECC_SCRUBBER_Enable_ADDR32 3
#define ECC_SCRUBBER_Enable_SHAMT 0
#define ECC_SCRUBBER_Enable_MASK 0x1
#define ECC_SCRUBBER_Enable_RMW ECC_SCRUBBER_Enable_ADDR32, ECC_SCRUBBER_Enable_SHAMT, ECC_SCRUBBER_Enable_MASK

#define ECC_SCRUBBER_Scrub_On_Error_ADDR32 3
#define ECC_SCRUBBER_Scrub_On_Error_SHAMT 1
#define ECC_SCRUBBER_Scrub_On_Error_MASK 0x2
#define ECC_SCRUBBER_Scrub_On_Error_RMW \
    ECC_SCRUBBER_Scrub_On_Error_ADDR32, ECC_SCRUBBER_Scrub_On_Error_SHAMT, ECC_SCRUBBER_Scrub_On_Error_MASK

#define ECC_SCRUBBER_Scrub_On_Error_Immediately_ADDR32 3
#define ECC_SCRUBBER_Scrub_On_Error_Immediately_SHAMT 2
#define ECC_SCRUBBER_Scrub_On_Error_Immediately_MASK 0x4
#define ECC_SCRUBBER_Scrub_On_Error_Immediately_RMW                                                \
    ECC_SCRUBBER_Scrub_On_Error_Immediately_ADDR32, ECC_SCRUBBER_Scrub_On_Error_Immediately_SHAMT, \
        ECC_SCRUBBER_Scrub_On_Error_Immediately_MASK

#define ECC_SCRUBBER_Delay_ADDR32 3
#define ECC_SCRUBBER_Delay_SHAMT 3
#define ECC_SCRUBBER_Delay_MASK 0x3ff8
#define ECC_SCRUBBER_Delay_RMW ECC_SCRUBBER_Delay_ADDR32, ECC_SCRUBBER_Delay_SHAMT, ECC_SCRUBBER_Delay_MASK

#define RISC_DEST_ACCESS_CTRL_SEC0_no_swizzle_ADDR32 3
#define RISC_DEST_ACCESS_CTRL_SEC0_no_swizzle_SHAMT 14
#define RISC_DEST_ACCESS_CTRL_SEC0_no_swizzle_MASK 0x4000
#define RISC_DEST_ACCESS_CTRL_SEC0_no_swizzle_RMW                                              \
    RISC_DEST_ACCESS_CTRL_SEC0_no_swizzle_ADDR32, RISC_DEST_ACCESS_CTRL_SEC0_no_swizzle_SHAMT, \
        RISC_DEST_ACCESS_CTRL_SEC0_no_swizzle_MASK

#define RISC_DEST_ACCESS_CTRL_SEC0_unsigned_int_ADDR32 3
#define RISC_DEST_ACCESS_CTRL_SEC0_unsigned_int_SHAMT 15
#define RISC_DEST_ACCESS_CTRL_SEC0_unsigned_int_MASK 0x8000
#define RISC_DEST_ACCESS_CTRL_SEC0_unsigned_int_RMW                                                \
    RISC_DEST_ACCESS_CTRL_SEC0_unsigned_int_ADDR32, RISC_DEST_ACCESS_CTRL_SEC0_unsigned_int_SHAMT, \
        RISC_DEST_ACCESS_CTRL_SEC0_unsigned_int_MASK

#define RISC_DEST_ACCESS_CTRL_SEC0_fmt_ADDR32 3
#define RISC_DEST_ACCESS_CTRL_SEC0_fmt_SHAMT 16
#define RISC_DEST_ACCESS_CTRL_SEC0_fmt_MASK 0x70000
#define RISC_DEST_ACCESS_CTRL_SEC0_fmt_RMW \
    RISC_DEST_ACCESS_CTRL_SEC0_fmt_ADDR32, RISC_DEST_ACCESS_CTRL_SEC0_fmt_SHAMT, RISC_DEST_ACCESS_CTRL_SEC0_fmt_MASK

#define RISC_DEST_ACCESS_CTRL_SEC1_no_swizzle_ADDR32 3
#define RISC_DEST_ACCESS_CTRL_SEC1_no_swizzle_SHAMT 19
#define RISC_DEST_ACCESS_CTRL_SEC1_no_swizzle_MASK 0x80000
#define RISC_DEST_ACCESS_CTRL_SEC1_no_swizzle_RMW                                              \
    RISC_DEST_ACCESS_CTRL_SEC1_no_swizzle_ADDR32, RISC_DEST_ACCESS_CTRL_SEC1_no_swizzle_SHAMT, \
        RISC_DEST_ACCESS_CTRL_SEC1_no_swizzle_MASK

#define RISC_DEST_ACCESS_CTRL_SEC1_unsigned_int_ADDR32 3
#define RISC_DEST_ACCESS_CTRL_SEC1_unsigned_int_SHAMT 20
#define RISC_DEST_ACCESS_CTRL_SEC1_unsigned_int_MASK 0x100000
#define RISC_DEST_ACCESS_CTRL_SEC1_unsigned_int_RMW                                                \
    RISC_DEST_ACCESS_CTRL_SEC1_unsigned_int_ADDR32, RISC_DEST_ACCESS_CTRL_SEC1_unsigned_int_SHAMT, \
        RISC_DEST_ACCESS_CTRL_SEC1_unsigned_int_MASK

#define RISC_DEST_ACCESS_CTRL_SEC1_fmt_ADDR32 3
#define RISC_DEST_ACCESS_CTRL_SEC1_fmt_SHAMT 21
#define RISC_DEST_ACCESS_CTRL_SEC1_fmt_MASK 0xe00000
#define RISC_DEST_ACCESS_CTRL_SEC1_fmt_RMW \
    RISC_DEST_ACCESS_CTRL_SEC1_fmt_ADDR32, RISC_DEST_ACCESS_CTRL_SEC1_fmt_SHAMT, RISC_DEST_ACCESS_CTRL_SEC1_fmt_MASK

#define RISC_DEST_ACCESS_CTRL_SEC2_no_swizzle_ADDR32 3
#define RISC_DEST_ACCESS_CTRL_SEC2_no_swizzle_SHAMT 24
#define RISC_DEST_ACCESS_CTRL_SEC2_no_swizzle_MASK 0x1000000
#define RISC_DEST_ACCESS_CTRL_SEC2_no_swizzle_RMW                                              \
    RISC_DEST_ACCESS_CTRL_SEC2_no_swizzle_ADDR32, RISC_DEST_ACCESS_CTRL_SEC2_no_swizzle_SHAMT, \
        RISC_DEST_ACCESS_CTRL_SEC2_no_swizzle_MASK

#define RISC_DEST_ACCESS_CTRL_SEC2_unsigned_int_ADDR32 3
#define RISC_DEST_ACCESS_CTRL_SEC2_unsigned_int_SHAMT 25
#define RISC_DEST_ACCESS_CTRL_SEC2_unsigned_int_MASK 0x2000000
#define RISC_DEST_ACCESS_CTRL_SEC2_unsigned_int_RMW                                                \
    RISC_DEST_ACCESS_CTRL_SEC2_unsigned_int_ADDR32, RISC_DEST_ACCESS_CTRL_SEC2_unsigned_int_SHAMT, \
        RISC_DEST_ACCESS_CTRL_SEC2_unsigned_int_MASK

#define RISC_DEST_ACCESS_CTRL_SEC2_fmt_ADDR32 3
#define RISC_DEST_ACCESS_CTRL_SEC2_fmt_SHAMT 26
#define RISC_DEST_ACCESS_CTRL_SEC2_fmt_MASK 0x1c000000
#define RISC_DEST_ACCESS_CTRL_SEC2_fmt_RMW \
    RISC_DEST_ACCESS_CTRL_SEC2_fmt_ADDR32, RISC_DEST_ACCESS_CTRL_SEC2_fmt_SHAMT, RISC_DEST_ACCESS_CTRL_SEC2_fmt_MASK

#define STATE_RESET_EN_ADDR32 4
#define STATE_RESET_EN_SHAMT 0
#define STATE_RESET_EN_MASK 0x1
#define STATE_RESET_EN_RMW STATE_RESET_EN_ADDR32, STATE_RESET_EN_SHAMT, STATE_RESET_EN_MASK

#define DEST_OFFSET_Enable_ADDR32 5
#define DEST_OFFSET_Enable_SHAMT 0
#define DEST_OFFSET_Enable_MASK 0x1
#define DEST_OFFSET_Enable_RMW DEST_OFFSET_Enable_ADDR32, DEST_OFFSET_Enable_SHAMT, DEST_OFFSET_Enable_MASK

#define DEST_REGW_BASE_Base_ADDR32 6
#define DEST_REGW_BASE_Base_SHAMT 0
#define DEST_REGW_BASE_Base_MASK 0xffff
#define DEST_REGW_BASE_Base_RMW DEST_REGW_BASE_Base_ADDR32, DEST_REGW_BASE_Base_SHAMT, DEST_REGW_BASE_Base_MASK

#define DEST_SP_BASE_Base_ADDR32 7
#define DEST_SP_BASE_Base_SHAMT 0
#define DEST_SP_BASE_Base_MASK 0xffff
#define DEST_SP_BASE_Base_RMW DEST_SP_BASE_Base_ADDR32, DEST_SP_BASE_Base_SHAMT, DEST_SP_BASE_Base_MASK

#define INT_DESCALE_Enable_ADDR32 8
#define INT_DESCALE_Enable_SHAMT 0
#define INT_DESCALE_Enable_MASK 0x1
#define INT_DESCALE_Enable_RMW INT_DESCALE_Enable_ADDR32, INT_DESCALE_Enable_SHAMT, INT_DESCALE_Enable_MASK

#define INT_DESCALE_Mode_ADDR32 8
#define INT_DESCALE_Mode_SHAMT 1
#define INT_DESCALE_Mode_MASK 0x2
#define INT_DESCALE_Mode_RMW INT_DESCALE_Mode_ADDR32, INT_DESCALE_Mode_SHAMT, INT_DESCALE_Mode_MASK

////////////////////////////////////////////////////////////////////////
// Registers for PACK0
////////////////////////////////////////////////////////////////////////

#define PACK0_CFGREG_BASE_ADDR32 12

#define PCK0_ADDR_CTRL_XY_REG_0_Xstride_ADDR32 12
#define PCK0_ADDR_CTRL_XY_REG_0_Xstride_SHAMT 0
#define PCK0_ADDR_CTRL_XY_REG_0_Xstride_MASK 0xffff
#define PCK0_ADDR_CTRL_XY_REG_0_Xstride_RMW \
    PCK0_ADDR_CTRL_XY_REG_0_Xstride_ADDR32, PCK0_ADDR_CTRL_XY_REG_0_Xstride_SHAMT, PCK0_ADDR_CTRL_XY_REG_0_Xstride_MASK

#define PCK0_ADDR_CTRL_XY_REG_0_Ystride_ADDR32 12
#define PCK0_ADDR_CTRL_XY_REG_0_Ystride_SHAMT 16
#define PCK0_ADDR_CTRL_XY_REG_0_Ystride_MASK 0xffff0000
#define PCK0_ADDR_CTRL_XY_REG_0_Ystride_RMW \
    PCK0_ADDR_CTRL_XY_REG_0_Ystride_ADDR32, PCK0_ADDR_CTRL_XY_REG_0_Ystride_SHAMT, PCK0_ADDR_CTRL_XY_REG_0_Ystride_MASK

#define PCK0_ADDR_CTRL_ZW_REG_0_Zstride_ADDR32 13
#define PCK0_ADDR_CTRL_ZW_REG_0_Zstride_SHAMT 0
#define PCK0_ADDR_CTRL_ZW_REG_0_Zstride_MASK 0xffff
#define PCK0_ADDR_CTRL_ZW_REG_0_Zstride_RMW \
    PCK0_ADDR_CTRL_ZW_REG_0_Zstride_ADDR32, PCK0_ADDR_CTRL_ZW_REG_0_Zstride_SHAMT, PCK0_ADDR_CTRL_ZW_REG_0_Zstride_MASK

#define PCK0_ADDR_CTRL_ZW_REG_0_Wstride_ADDR32 13
#define PCK0_ADDR_CTRL_ZW_REG_0_Wstride_SHAMT 16
#define PCK0_ADDR_CTRL_ZW_REG_0_Wstride_MASK 0xffff0000
#define PCK0_ADDR_CTRL_ZW_REG_0_Wstride_RMW \
    PCK0_ADDR_CTRL_ZW_REG_0_Wstride_ADDR32, PCK0_ADDR_CTRL_ZW_REG_0_Wstride_SHAMT, PCK0_ADDR_CTRL_ZW_REG_0_Wstride_MASK

#define PCK0_ADDR_CTRL_XY_REG_1_Xstride_ADDR32 14
#define PCK0_ADDR_CTRL_XY_REG_1_Xstride_SHAMT 0
#define PCK0_ADDR_CTRL_XY_REG_1_Xstride_MASK 0xffff
#define PCK0_ADDR_CTRL_XY_REG_1_Xstride_RMW \
    PCK0_ADDR_CTRL_XY_REG_1_Xstride_ADDR32, PCK0_ADDR_CTRL_XY_REG_1_Xstride_SHAMT, PCK0_ADDR_CTRL_XY_REG_1_Xstride_MASK

#define PCK0_ADDR_CTRL_XY_REG_1_Ystride_ADDR32 14
#define PCK0_ADDR_CTRL_XY_REG_1_Ystride_SHAMT 16
#define PCK0_ADDR_CTRL_XY_REG_1_Ystride_MASK 0xffff0000
#define PCK0_ADDR_CTRL_XY_REG_1_Ystride_RMW \
    PCK0_ADDR_CTRL_XY_REG_1_Ystride_ADDR32, PCK0_ADDR_CTRL_XY_REG_1_Ystride_SHAMT, PCK0_ADDR_CTRL_XY_REG_1_Ystride_MASK

#define PCK0_ADDR_CTRL_ZW_REG_1_Zstride_ADDR32 15
#define PCK0_ADDR_CTRL_ZW_REG_1_Zstride_SHAMT 0
#define PCK0_ADDR_CTRL_ZW_REG_1_Zstride_MASK 0xffff
#define PCK0_ADDR_CTRL_ZW_REG_1_Zstride_RMW \
    PCK0_ADDR_CTRL_ZW_REG_1_Zstride_ADDR32, PCK0_ADDR_CTRL_ZW_REG_1_Zstride_SHAMT, PCK0_ADDR_CTRL_ZW_REG_1_Zstride_MASK

#define PCK0_ADDR_CTRL_ZW_REG_1_Wstride_ADDR32 15
#define PCK0_ADDR_CTRL_ZW_REG_1_Wstride_SHAMT 16
#define PCK0_ADDR_CTRL_ZW_REG_1_Wstride_MASK 0xffff0000
#define PCK0_ADDR_CTRL_ZW_REG_1_Wstride_RMW \
    PCK0_ADDR_CTRL_ZW_REG_1_Wstride_ADDR32, PCK0_ADDR_CTRL_ZW_REG_1_Wstride_SHAMT, PCK0_ADDR_CTRL_ZW_REG_1_Wstride_MASK

#define PCK0_ADDR_BASE_REG_0_Base_ADDR32 16
#define PCK0_ADDR_BASE_REG_0_Base_SHAMT 0
#define PCK0_ADDR_BASE_REG_0_Base_MASK 0x3ffff
#define PCK0_ADDR_BASE_REG_0_Base_RMW \
    PCK0_ADDR_BASE_REG_0_Base_ADDR32, PCK0_ADDR_BASE_REG_0_Base_SHAMT, PCK0_ADDR_BASE_REG_0_Base_MASK

#define PCK0_ADDR_BASE_REG_1_Base_ADDR32 17
#define PCK0_ADDR_BASE_REG_1_Base_SHAMT 0
#define PCK0_ADDR_BASE_REG_1_Base_MASK 0x3ffff
#define PCK0_ADDR_BASE_REG_1_Base_RMW \
    PCK0_ADDR_BASE_REG_1_Base_ADDR32, PCK0_ADDR_BASE_REG_1_Base_SHAMT, PCK0_ADDR_BASE_REG_1_Base_MASK

#define PCK_DEST_RD_CTRL_Read_32b_data_ADDR32 18
#define PCK_DEST_RD_CTRL_Read_32b_data_SHAMT 0
#define PCK_DEST_RD_CTRL_Read_32b_data_MASK 0x1
#define PCK_DEST_RD_CTRL_Read_32b_data_RMW \
    PCK_DEST_RD_CTRL_Read_32b_data_ADDR32, PCK_DEST_RD_CTRL_Read_32b_data_SHAMT, PCK_DEST_RD_CTRL_Read_32b_data_MASK

#define PCK_DEST_RD_CTRL_Read_unsigned_ADDR32 18
#define PCK_DEST_RD_CTRL_Read_unsigned_SHAMT 1
#define PCK_DEST_RD_CTRL_Read_unsigned_MASK 0x2
#define PCK_DEST_RD_CTRL_Read_unsigned_RMW \
    PCK_DEST_RD_CTRL_Read_unsigned_ADDR32, PCK_DEST_RD_CTRL_Read_unsigned_SHAMT, PCK_DEST_RD_CTRL_Read_unsigned_MASK

#define PCK_DEST_RD_CTRL_Read_int8_ADDR32 18
#define PCK_DEST_RD_CTRL_Read_int8_SHAMT 2
#define PCK_DEST_RD_CTRL_Read_int8_MASK 0x4
#define PCK_DEST_RD_CTRL_Read_int8_RMW \
    PCK_DEST_RD_CTRL_Read_int8_ADDR32, PCK_DEST_RD_CTRL_Read_int8_SHAMT, PCK_DEST_RD_CTRL_Read_int8_MASK

#define PCK_DEST_RD_CTRL_Round_10b_mant_ADDR32 18
#define PCK_DEST_RD_CTRL_Round_10b_mant_SHAMT 3
#define PCK_DEST_RD_CTRL_Round_10b_mant_MASK 0x8
#define PCK_DEST_RD_CTRL_Round_10b_mant_RMW \
    PCK_DEST_RD_CTRL_Round_10b_mant_ADDR32, PCK_DEST_RD_CTRL_Round_10b_mant_SHAMT, PCK_DEST_RD_CTRL_Round_10b_mant_MASK

#define PCK_EDGE_TILE_FACE_SET_SELECT_select_ADDR32 19
#define PCK_EDGE_TILE_FACE_SET_SELECT_select_SHAMT 0
#define PCK_EDGE_TILE_FACE_SET_SELECT_select_MASK 0xff
#define PCK_EDGE_TILE_FACE_SET_SELECT_select_RMW                                             \
    PCK_EDGE_TILE_FACE_SET_SELECT_select_ADDR32, PCK_EDGE_TILE_FACE_SET_SELECT_select_SHAMT, \
        PCK_EDGE_TILE_FACE_SET_SELECT_select_MASK

#define PCK_EDGE_TILE_FACE_SET_SELECT_enable_ADDR32 19
#define PCK_EDGE_TILE_FACE_SET_SELECT_enable_SHAMT 8
#define PCK_EDGE_TILE_FACE_SET_SELECT_enable_MASK 0x100
#define PCK_EDGE_TILE_FACE_SET_SELECT_enable_RMW                                             \
    PCK_EDGE_TILE_FACE_SET_SELECT_enable_ADDR32, PCK_EDGE_TILE_FACE_SET_SELECT_enable_SHAMT, \
        PCK_EDGE_TILE_FACE_SET_SELECT_enable_MASK

#define TILE_ROW_SET_MAPPING_0_row_set_mapping_0_ADDR32 20
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_0_SHAMT 0
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_0_MASK 0x3
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_0_RMW                                                 \
    TILE_ROW_SET_MAPPING_0_row_set_mapping_0_ADDR32, TILE_ROW_SET_MAPPING_0_row_set_mapping_0_SHAMT, \
        TILE_ROW_SET_MAPPING_0_row_set_mapping_0_MASK

#define TILE_ROW_SET_MAPPING_0_row_set_mapping_1_ADDR32 20
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_1_SHAMT 2
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_1_MASK 0xc
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_1_RMW                                                 \
    TILE_ROW_SET_MAPPING_0_row_set_mapping_1_ADDR32, TILE_ROW_SET_MAPPING_0_row_set_mapping_1_SHAMT, \
        TILE_ROW_SET_MAPPING_0_row_set_mapping_1_MASK

#define TILE_ROW_SET_MAPPING_0_row_set_mapping_2_ADDR32 20
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_2_SHAMT 4
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_2_MASK 0x30
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_2_RMW                                                 \
    TILE_ROW_SET_MAPPING_0_row_set_mapping_2_ADDR32, TILE_ROW_SET_MAPPING_0_row_set_mapping_2_SHAMT, \
        TILE_ROW_SET_MAPPING_0_row_set_mapping_2_MASK

#define TILE_ROW_SET_MAPPING_0_row_set_mapping_3_ADDR32 20
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_3_SHAMT 6
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_3_MASK 0xc0
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_3_RMW                                                 \
    TILE_ROW_SET_MAPPING_0_row_set_mapping_3_ADDR32, TILE_ROW_SET_MAPPING_0_row_set_mapping_3_SHAMT, \
        TILE_ROW_SET_MAPPING_0_row_set_mapping_3_MASK

#define TILE_ROW_SET_MAPPING_0_row_set_mapping_4_ADDR32 20
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_4_SHAMT 8
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_4_MASK 0x300
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_4_RMW                                                 \
    TILE_ROW_SET_MAPPING_0_row_set_mapping_4_ADDR32, TILE_ROW_SET_MAPPING_0_row_set_mapping_4_SHAMT, \
        TILE_ROW_SET_MAPPING_0_row_set_mapping_4_MASK

#define TILE_ROW_SET_MAPPING_0_row_set_mapping_5_ADDR32 20
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_5_SHAMT 10
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_5_MASK 0xc00
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_5_RMW                                                 \
    TILE_ROW_SET_MAPPING_0_row_set_mapping_5_ADDR32, TILE_ROW_SET_MAPPING_0_row_set_mapping_5_SHAMT, \
        TILE_ROW_SET_MAPPING_0_row_set_mapping_5_MASK

#define TILE_ROW_SET_MAPPING_0_row_set_mapping_6_ADDR32 20
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_6_SHAMT 12
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_6_MASK 0x3000
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_6_RMW                                                 \
    TILE_ROW_SET_MAPPING_0_row_set_mapping_6_ADDR32, TILE_ROW_SET_MAPPING_0_row_set_mapping_6_SHAMT, \
        TILE_ROW_SET_MAPPING_0_row_set_mapping_6_MASK

#define TILE_ROW_SET_MAPPING_0_row_set_mapping_7_ADDR32 20
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_7_SHAMT 14
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_7_MASK 0xc000
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_7_RMW                                                 \
    TILE_ROW_SET_MAPPING_0_row_set_mapping_7_ADDR32, TILE_ROW_SET_MAPPING_0_row_set_mapping_7_SHAMT, \
        TILE_ROW_SET_MAPPING_0_row_set_mapping_7_MASK

#define TILE_ROW_SET_MAPPING_0_row_set_mapping_8_ADDR32 20
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_8_SHAMT 16
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_8_MASK 0x30000
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_8_RMW                                                 \
    TILE_ROW_SET_MAPPING_0_row_set_mapping_8_ADDR32, TILE_ROW_SET_MAPPING_0_row_set_mapping_8_SHAMT, \
        TILE_ROW_SET_MAPPING_0_row_set_mapping_8_MASK

#define TILE_ROW_SET_MAPPING_0_row_set_mapping_9_ADDR32 20
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_9_SHAMT 18
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_9_MASK 0xc0000
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_9_RMW                                                 \
    TILE_ROW_SET_MAPPING_0_row_set_mapping_9_ADDR32, TILE_ROW_SET_MAPPING_0_row_set_mapping_9_SHAMT, \
        TILE_ROW_SET_MAPPING_0_row_set_mapping_9_MASK

#define TILE_ROW_SET_MAPPING_0_row_set_mapping_10_ADDR32 20
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_10_SHAMT 20
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_10_MASK 0x300000
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_10_RMW                                                  \
    TILE_ROW_SET_MAPPING_0_row_set_mapping_10_ADDR32, TILE_ROW_SET_MAPPING_0_row_set_mapping_10_SHAMT, \
        TILE_ROW_SET_MAPPING_0_row_set_mapping_10_MASK

#define TILE_ROW_SET_MAPPING_0_row_set_mapping_11_ADDR32 20
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_11_SHAMT 22
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_11_MASK 0xc00000
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_11_RMW                                                  \
    TILE_ROW_SET_MAPPING_0_row_set_mapping_11_ADDR32, TILE_ROW_SET_MAPPING_0_row_set_mapping_11_SHAMT, \
        TILE_ROW_SET_MAPPING_0_row_set_mapping_11_MASK

#define TILE_ROW_SET_MAPPING_0_row_set_mapping_12_ADDR32 20
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_12_SHAMT 24
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_12_MASK 0x3000000
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_12_RMW                                                  \
    TILE_ROW_SET_MAPPING_0_row_set_mapping_12_ADDR32, TILE_ROW_SET_MAPPING_0_row_set_mapping_12_SHAMT, \
        TILE_ROW_SET_MAPPING_0_row_set_mapping_12_MASK

#define TILE_ROW_SET_MAPPING_0_row_set_mapping_13_ADDR32 20
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_13_SHAMT 26
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_13_MASK 0xc000000
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_13_RMW                                                  \
    TILE_ROW_SET_MAPPING_0_row_set_mapping_13_ADDR32, TILE_ROW_SET_MAPPING_0_row_set_mapping_13_SHAMT, \
        TILE_ROW_SET_MAPPING_0_row_set_mapping_13_MASK

#define TILE_ROW_SET_MAPPING_0_row_set_mapping_14_ADDR32 20
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_14_SHAMT 28
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_14_MASK 0x30000000
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_14_RMW                                                  \
    TILE_ROW_SET_MAPPING_0_row_set_mapping_14_ADDR32, TILE_ROW_SET_MAPPING_0_row_set_mapping_14_SHAMT, \
        TILE_ROW_SET_MAPPING_0_row_set_mapping_14_MASK

#define TILE_ROW_SET_MAPPING_0_row_set_mapping_15_ADDR32 20
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_15_SHAMT 30
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_15_MASK 0xc0000000
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_15_RMW                                                  \
    TILE_ROW_SET_MAPPING_0_row_set_mapping_15_ADDR32, TILE_ROW_SET_MAPPING_0_row_set_mapping_15_SHAMT, \
        TILE_ROW_SET_MAPPING_0_row_set_mapping_15_MASK

#define TILE_ROW_SET_MAPPING_1_row_set_mapping_0_ADDR32 21
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_0_SHAMT 0
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_0_MASK 0x3
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_0_RMW                                                 \
    TILE_ROW_SET_MAPPING_1_row_set_mapping_0_ADDR32, TILE_ROW_SET_MAPPING_1_row_set_mapping_0_SHAMT, \
        TILE_ROW_SET_MAPPING_1_row_set_mapping_0_MASK

#define TILE_ROW_SET_MAPPING_1_row_set_mapping_1_ADDR32 21
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_1_SHAMT 2
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_1_MASK 0xc
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_1_RMW                                                 \
    TILE_ROW_SET_MAPPING_1_row_set_mapping_1_ADDR32, TILE_ROW_SET_MAPPING_1_row_set_mapping_1_SHAMT, \
        TILE_ROW_SET_MAPPING_1_row_set_mapping_1_MASK

#define TILE_ROW_SET_MAPPING_1_row_set_mapping_2_ADDR32 21
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_2_SHAMT 4
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_2_MASK 0x30
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_2_RMW                                                 \
    TILE_ROW_SET_MAPPING_1_row_set_mapping_2_ADDR32, TILE_ROW_SET_MAPPING_1_row_set_mapping_2_SHAMT, \
        TILE_ROW_SET_MAPPING_1_row_set_mapping_2_MASK

#define TILE_ROW_SET_MAPPING_1_row_set_mapping_3_ADDR32 21
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_3_SHAMT 6
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_3_MASK 0xc0
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_3_RMW                                                 \
    TILE_ROW_SET_MAPPING_1_row_set_mapping_3_ADDR32, TILE_ROW_SET_MAPPING_1_row_set_mapping_3_SHAMT, \
        TILE_ROW_SET_MAPPING_1_row_set_mapping_3_MASK

#define TILE_ROW_SET_MAPPING_1_row_set_mapping_4_ADDR32 21
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_4_SHAMT 8
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_4_MASK 0x300
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_4_RMW                                                 \
    TILE_ROW_SET_MAPPING_1_row_set_mapping_4_ADDR32, TILE_ROW_SET_MAPPING_1_row_set_mapping_4_SHAMT, \
        TILE_ROW_SET_MAPPING_1_row_set_mapping_4_MASK

#define TILE_ROW_SET_MAPPING_1_row_set_mapping_5_ADDR32 21
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_5_SHAMT 10
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_5_MASK 0xc00
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_5_RMW                                                 \
    TILE_ROW_SET_MAPPING_1_row_set_mapping_5_ADDR32, TILE_ROW_SET_MAPPING_1_row_set_mapping_5_SHAMT, \
        TILE_ROW_SET_MAPPING_1_row_set_mapping_5_MASK

#define TILE_ROW_SET_MAPPING_1_row_set_mapping_6_ADDR32 21
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_6_SHAMT 12
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_6_MASK 0x3000
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_6_RMW                                                 \
    TILE_ROW_SET_MAPPING_1_row_set_mapping_6_ADDR32, TILE_ROW_SET_MAPPING_1_row_set_mapping_6_SHAMT, \
        TILE_ROW_SET_MAPPING_1_row_set_mapping_6_MASK

#define TILE_ROW_SET_MAPPING_1_row_set_mapping_7_ADDR32 21
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_7_SHAMT 14
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_7_MASK 0xc000
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_7_RMW                                                 \
    TILE_ROW_SET_MAPPING_1_row_set_mapping_7_ADDR32, TILE_ROW_SET_MAPPING_1_row_set_mapping_7_SHAMT, \
        TILE_ROW_SET_MAPPING_1_row_set_mapping_7_MASK

#define TILE_ROW_SET_MAPPING_1_row_set_mapping_8_ADDR32 21
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_8_SHAMT 16
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_8_MASK 0x30000
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_8_RMW                                                 \
    TILE_ROW_SET_MAPPING_1_row_set_mapping_8_ADDR32, TILE_ROW_SET_MAPPING_1_row_set_mapping_8_SHAMT, \
        TILE_ROW_SET_MAPPING_1_row_set_mapping_8_MASK

#define TILE_ROW_SET_MAPPING_1_row_set_mapping_9_ADDR32 21
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_9_SHAMT 18
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_9_MASK 0xc0000
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_9_RMW                                                 \
    TILE_ROW_SET_MAPPING_1_row_set_mapping_9_ADDR32, TILE_ROW_SET_MAPPING_1_row_set_mapping_9_SHAMT, \
        TILE_ROW_SET_MAPPING_1_row_set_mapping_9_MASK

#define TILE_ROW_SET_MAPPING_1_row_set_mapping_10_ADDR32 21
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_10_SHAMT 20
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_10_MASK 0x300000
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_10_RMW                                                  \
    TILE_ROW_SET_MAPPING_1_row_set_mapping_10_ADDR32, TILE_ROW_SET_MAPPING_1_row_set_mapping_10_SHAMT, \
        TILE_ROW_SET_MAPPING_1_row_set_mapping_10_MASK

#define TILE_ROW_SET_MAPPING_1_row_set_mapping_11_ADDR32 21
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_11_SHAMT 22
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_11_MASK 0xc00000
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_11_RMW                                                  \
    TILE_ROW_SET_MAPPING_1_row_set_mapping_11_ADDR32, TILE_ROW_SET_MAPPING_1_row_set_mapping_11_SHAMT, \
        TILE_ROW_SET_MAPPING_1_row_set_mapping_11_MASK

#define TILE_ROW_SET_MAPPING_1_row_set_mapping_12_ADDR32 21
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_12_SHAMT 24
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_12_MASK 0x3000000
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_12_RMW                                                  \
    TILE_ROW_SET_MAPPING_1_row_set_mapping_12_ADDR32, TILE_ROW_SET_MAPPING_1_row_set_mapping_12_SHAMT, \
        TILE_ROW_SET_MAPPING_1_row_set_mapping_12_MASK

#define TILE_ROW_SET_MAPPING_1_row_set_mapping_13_ADDR32 21
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_13_SHAMT 26
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_13_MASK 0xc000000
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_13_RMW                                                  \
    TILE_ROW_SET_MAPPING_1_row_set_mapping_13_ADDR32, TILE_ROW_SET_MAPPING_1_row_set_mapping_13_SHAMT, \
        TILE_ROW_SET_MAPPING_1_row_set_mapping_13_MASK

#define TILE_ROW_SET_MAPPING_1_row_set_mapping_14_ADDR32 21
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_14_SHAMT 28
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_14_MASK 0x30000000
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_14_RMW                                                  \
    TILE_ROW_SET_MAPPING_1_row_set_mapping_14_ADDR32, TILE_ROW_SET_MAPPING_1_row_set_mapping_14_SHAMT, \
        TILE_ROW_SET_MAPPING_1_row_set_mapping_14_MASK

#define TILE_ROW_SET_MAPPING_1_row_set_mapping_15_ADDR32 21
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_15_SHAMT 30
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_15_MASK 0xc0000000
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_15_RMW                                                  \
    TILE_ROW_SET_MAPPING_1_row_set_mapping_15_ADDR32, TILE_ROW_SET_MAPPING_1_row_set_mapping_15_SHAMT, \
        TILE_ROW_SET_MAPPING_1_row_set_mapping_15_MASK

#define TILE_ROW_SET_MAPPING_2_row_set_mapping_0_ADDR32 22
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_0_SHAMT 0
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_0_MASK 0x3
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_0_RMW                                                 \
    TILE_ROW_SET_MAPPING_2_row_set_mapping_0_ADDR32, TILE_ROW_SET_MAPPING_2_row_set_mapping_0_SHAMT, \
        TILE_ROW_SET_MAPPING_2_row_set_mapping_0_MASK

#define TILE_ROW_SET_MAPPING_2_row_set_mapping_1_ADDR32 22
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_1_SHAMT 2
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_1_MASK 0xc
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_1_RMW                                                 \
    TILE_ROW_SET_MAPPING_2_row_set_mapping_1_ADDR32, TILE_ROW_SET_MAPPING_2_row_set_mapping_1_SHAMT, \
        TILE_ROW_SET_MAPPING_2_row_set_mapping_1_MASK

#define TILE_ROW_SET_MAPPING_2_row_set_mapping_2_ADDR32 22
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_2_SHAMT 4
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_2_MASK 0x30
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_2_RMW                                                 \
    TILE_ROW_SET_MAPPING_2_row_set_mapping_2_ADDR32, TILE_ROW_SET_MAPPING_2_row_set_mapping_2_SHAMT, \
        TILE_ROW_SET_MAPPING_2_row_set_mapping_2_MASK

#define TILE_ROW_SET_MAPPING_2_row_set_mapping_3_ADDR32 22
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_3_SHAMT 6
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_3_MASK 0xc0
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_3_RMW                                                 \
    TILE_ROW_SET_MAPPING_2_row_set_mapping_3_ADDR32, TILE_ROW_SET_MAPPING_2_row_set_mapping_3_SHAMT, \
        TILE_ROW_SET_MAPPING_2_row_set_mapping_3_MASK

#define TILE_ROW_SET_MAPPING_2_row_set_mapping_4_ADDR32 22
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_4_SHAMT 8
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_4_MASK 0x300
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_4_RMW                                                 \
    TILE_ROW_SET_MAPPING_2_row_set_mapping_4_ADDR32, TILE_ROW_SET_MAPPING_2_row_set_mapping_4_SHAMT, \
        TILE_ROW_SET_MAPPING_2_row_set_mapping_4_MASK

#define TILE_ROW_SET_MAPPING_2_row_set_mapping_5_ADDR32 22
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_5_SHAMT 10
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_5_MASK 0xc00
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_5_RMW                                                 \
    TILE_ROW_SET_MAPPING_2_row_set_mapping_5_ADDR32, TILE_ROW_SET_MAPPING_2_row_set_mapping_5_SHAMT, \
        TILE_ROW_SET_MAPPING_2_row_set_mapping_5_MASK

#define TILE_ROW_SET_MAPPING_2_row_set_mapping_6_ADDR32 22
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_6_SHAMT 12
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_6_MASK 0x3000
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_6_RMW                                                 \
    TILE_ROW_SET_MAPPING_2_row_set_mapping_6_ADDR32, TILE_ROW_SET_MAPPING_2_row_set_mapping_6_SHAMT, \
        TILE_ROW_SET_MAPPING_2_row_set_mapping_6_MASK

#define TILE_ROW_SET_MAPPING_2_row_set_mapping_7_ADDR32 22
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_7_SHAMT 14
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_7_MASK 0xc000
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_7_RMW                                                 \
    TILE_ROW_SET_MAPPING_2_row_set_mapping_7_ADDR32, TILE_ROW_SET_MAPPING_2_row_set_mapping_7_SHAMT, \
        TILE_ROW_SET_MAPPING_2_row_set_mapping_7_MASK

#define TILE_ROW_SET_MAPPING_2_row_set_mapping_8_ADDR32 22
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_8_SHAMT 16
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_8_MASK 0x30000
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_8_RMW                                                 \
    TILE_ROW_SET_MAPPING_2_row_set_mapping_8_ADDR32, TILE_ROW_SET_MAPPING_2_row_set_mapping_8_SHAMT, \
        TILE_ROW_SET_MAPPING_2_row_set_mapping_8_MASK

#define TILE_ROW_SET_MAPPING_2_row_set_mapping_9_ADDR32 22
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_9_SHAMT 18
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_9_MASK 0xc0000
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_9_RMW                                                 \
    TILE_ROW_SET_MAPPING_2_row_set_mapping_9_ADDR32, TILE_ROW_SET_MAPPING_2_row_set_mapping_9_SHAMT, \
        TILE_ROW_SET_MAPPING_2_row_set_mapping_9_MASK

#define TILE_ROW_SET_MAPPING_2_row_set_mapping_10_ADDR32 22
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_10_SHAMT 20
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_10_MASK 0x300000
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_10_RMW                                                  \
    TILE_ROW_SET_MAPPING_2_row_set_mapping_10_ADDR32, TILE_ROW_SET_MAPPING_2_row_set_mapping_10_SHAMT, \
        TILE_ROW_SET_MAPPING_2_row_set_mapping_10_MASK

#define TILE_ROW_SET_MAPPING_2_row_set_mapping_11_ADDR32 22
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_11_SHAMT 22
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_11_MASK 0xc00000
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_11_RMW                                                  \
    TILE_ROW_SET_MAPPING_2_row_set_mapping_11_ADDR32, TILE_ROW_SET_MAPPING_2_row_set_mapping_11_SHAMT, \
        TILE_ROW_SET_MAPPING_2_row_set_mapping_11_MASK

#define TILE_ROW_SET_MAPPING_2_row_set_mapping_12_ADDR32 22
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_12_SHAMT 24
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_12_MASK 0x3000000
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_12_RMW                                                  \
    TILE_ROW_SET_MAPPING_2_row_set_mapping_12_ADDR32, TILE_ROW_SET_MAPPING_2_row_set_mapping_12_SHAMT, \
        TILE_ROW_SET_MAPPING_2_row_set_mapping_12_MASK

#define TILE_ROW_SET_MAPPING_2_row_set_mapping_13_ADDR32 22
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_13_SHAMT 26
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_13_MASK 0xc000000
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_13_RMW                                                  \
    TILE_ROW_SET_MAPPING_2_row_set_mapping_13_ADDR32, TILE_ROW_SET_MAPPING_2_row_set_mapping_13_SHAMT, \
        TILE_ROW_SET_MAPPING_2_row_set_mapping_13_MASK

#define TILE_ROW_SET_MAPPING_2_row_set_mapping_14_ADDR32 22
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_14_SHAMT 28
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_14_MASK 0x30000000
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_14_RMW                                                  \
    TILE_ROW_SET_MAPPING_2_row_set_mapping_14_ADDR32, TILE_ROW_SET_MAPPING_2_row_set_mapping_14_SHAMT, \
        TILE_ROW_SET_MAPPING_2_row_set_mapping_14_MASK

#define TILE_ROW_SET_MAPPING_2_row_set_mapping_15_ADDR32 22
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_15_SHAMT 30
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_15_MASK 0xc0000000
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_15_RMW                                                  \
    TILE_ROW_SET_MAPPING_2_row_set_mapping_15_ADDR32, TILE_ROW_SET_MAPPING_2_row_set_mapping_15_SHAMT, \
        TILE_ROW_SET_MAPPING_2_row_set_mapping_15_MASK

#define TILE_ROW_SET_MAPPING_3_row_set_mapping_0_ADDR32 23
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_0_SHAMT 0
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_0_MASK 0x3
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_0_RMW                                                 \
    TILE_ROW_SET_MAPPING_3_row_set_mapping_0_ADDR32, TILE_ROW_SET_MAPPING_3_row_set_mapping_0_SHAMT, \
        TILE_ROW_SET_MAPPING_3_row_set_mapping_0_MASK

#define TILE_ROW_SET_MAPPING_3_row_set_mapping_1_ADDR32 23
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_1_SHAMT 2
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_1_MASK 0xc
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_1_RMW                                                 \
    TILE_ROW_SET_MAPPING_3_row_set_mapping_1_ADDR32, TILE_ROW_SET_MAPPING_3_row_set_mapping_1_SHAMT, \
        TILE_ROW_SET_MAPPING_3_row_set_mapping_1_MASK

#define TILE_ROW_SET_MAPPING_3_row_set_mapping_2_ADDR32 23
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_2_SHAMT 4
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_2_MASK 0x30
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_2_RMW                                                 \
    TILE_ROW_SET_MAPPING_3_row_set_mapping_2_ADDR32, TILE_ROW_SET_MAPPING_3_row_set_mapping_2_SHAMT, \
        TILE_ROW_SET_MAPPING_3_row_set_mapping_2_MASK

#define TILE_ROW_SET_MAPPING_3_row_set_mapping_3_ADDR32 23
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_3_SHAMT 6
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_3_MASK 0xc0
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_3_RMW                                                 \
    TILE_ROW_SET_MAPPING_3_row_set_mapping_3_ADDR32, TILE_ROW_SET_MAPPING_3_row_set_mapping_3_SHAMT, \
        TILE_ROW_SET_MAPPING_3_row_set_mapping_3_MASK

#define TILE_ROW_SET_MAPPING_3_row_set_mapping_4_ADDR32 23
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_4_SHAMT 8
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_4_MASK 0x300
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_4_RMW                                                 \
    TILE_ROW_SET_MAPPING_3_row_set_mapping_4_ADDR32, TILE_ROW_SET_MAPPING_3_row_set_mapping_4_SHAMT, \
        TILE_ROW_SET_MAPPING_3_row_set_mapping_4_MASK

#define TILE_ROW_SET_MAPPING_3_row_set_mapping_5_ADDR32 23
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_5_SHAMT 10
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_5_MASK 0xc00
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_5_RMW                                                 \
    TILE_ROW_SET_MAPPING_3_row_set_mapping_5_ADDR32, TILE_ROW_SET_MAPPING_3_row_set_mapping_5_SHAMT, \
        TILE_ROW_SET_MAPPING_3_row_set_mapping_5_MASK

#define TILE_ROW_SET_MAPPING_3_row_set_mapping_6_ADDR32 23
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_6_SHAMT 12
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_6_MASK 0x3000
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_6_RMW                                                 \
    TILE_ROW_SET_MAPPING_3_row_set_mapping_6_ADDR32, TILE_ROW_SET_MAPPING_3_row_set_mapping_6_SHAMT, \
        TILE_ROW_SET_MAPPING_3_row_set_mapping_6_MASK

#define TILE_ROW_SET_MAPPING_3_row_set_mapping_7_ADDR32 23
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_7_SHAMT 14
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_7_MASK 0xc000
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_7_RMW                                                 \
    TILE_ROW_SET_MAPPING_3_row_set_mapping_7_ADDR32, TILE_ROW_SET_MAPPING_3_row_set_mapping_7_SHAMT, \
        TILE_ROW_SET_MAPPING_3_row_set_mapping_7_MASK

#define TILE_ROW_SET_MAPPING_3_row_set_mapping_8_ADDR32 23
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_8_SHAMT 16
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_8_MASK 0x30000
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_8_RMW                                                 \
    TILE_ROW_SET_MAPPING_3_row_set_mapping_8_ADDR32, TILE_ROW_SET_MAPPING_3_row_set_mapping_8_SHAMT, \
        TILE_ROW_SET_MAPPING_3_row_set_mapping_8_MASK

#define TILE_ROW_SET_MAPPING_3_row_set_mapping_9_ADDR32 23
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_9_SHAMT 18
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_9_MASK 0xc0000
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_9_RMW                                                 \
    TILE_ROW_SET_MAPPING_3_row_set_mapping_9_ADDR32, TILE_ROW_SET_MAPPING_3_row_set_mapping_9_SHAMT, \
        TILE_ROW_SET_MAPPING_3_row_set_mapping_9_MASK

#define TILE_ROW_SET_MAPPING_3_row_set_mapping_10_ADDR32 23
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_10_SHAMT 20
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_10_MASK 0x300000
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_10_RMW                                                  \
    TILE_ROW_SET_MAPPING_3_row_set_mapping_10_ADDR32, TILE_ROW_SET_MAPPING_3_row_set_mapping_10_SHAMT, \
        TILE_ROW_SET_MAPPING_3_row_set_mapping_10_MASK

#define TILE_ROW_SET_MAPPING_3_row_set_mapping_11_ADDR32 23
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_11_SHAMT 22
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_11_MASK 0xc00000
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_11_RMW                                                  \
    TILE_ROW_SET_MAPPING_3_row_set_mapping_11_ADDR32, TILE_ROW_SET_MAPPING_3_row_set_mapping_11_SHAMT, \
        TILE_ROW_SET_MAPPING_3_row_set_mapping_11_MASK

#define TILE_ROW_SET_MAPPING_3_row_set_mapping_12_ADDR32 23
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_12_SHAMT 24
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_12_MASK 0x3000000
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_12_RMW                                                  \
    TILE_ROW_SET_MAPPING_3_row_set_mapping_12_ADDR32, TILE_ROW_SET_MAPPING_3_row_set_mapping_12_SHAMT, \
        TILE_ROW_SET_MAPPING_3_row_set_mapping_12_MASK

#define TILE_ROW_SET_MAPPING_3_row_set_mapping_13_ADDR32 23
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_13_SHAMT 26
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_13_MASK 0xc000000
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_13_RMW                                                  \
    TILE_ROW_SET_MAPPING_3_row_set_mapping_13_ADDR32, TILE_ROW_SET_MAPPING_3_row_set_mapping_13_SHAMT, \
        TILE_ROW_SET_MAPPING_3_row_set_mapping_13_MASK

#define TILE_ROW_SET_MAPPING_3_row_set_mapping_14_ADDR32 23
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_14_SHAMT 28
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_14_MASK 0x30000000
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_14_RMW                                                  \
    TILE_ROW_SET_MAPPING_3_row_set_mapping_14_ADDR32, TILE_ROW_SET_MAPPING_3_row_set_mapping_14_SHAMT, \
        TILE_ROW_SET_MAPPING_3_row_set_mapping_14_MASK

#define TILE_ROW_SET_MAPPING_3_row_set_mapping_15_ADDR32 23
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_15_SHAMT 30
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_15_MASK 0xc0000000
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_15_RMW                                                  \
    TILE_ROW_SET_MAPPING_3_row_set_mapping_15_ADDR32, TILE_ROW_SET_MAPPING_3_row_set_mapping_15_SHAMT, \
        TILE_ROW_SET_MAPPING_3_row_set_mapping_15_MASK

#define PCK_EDGE_OFFSET_SEC0_mask_ADDR32 24
#define PCK_EDGE_OFFSET_SEC0_mask_SHAMT 0
#define PCK_EDGE_OFFSET_SEC0_mask_MASK 0xffff
#define PCK_EDGE_OFFSET_SEC0_mask_RMW \
    PCK_EDGE_OFFSET_SEC0_mask_ADDR32, PCK_EDGE_OFFSET_SEC0_mask_SHAMT, PCK_EDGE_OFFSET_SEC0_mask_MASK

#define PCK_EDGE_MODE_mode_ADDR32 24
#define PCK_EDGE_MODE_mode_SHAMT 16
#define PCK_EDGE_MODE_mode_MASK 0x10000
#define PCK_EDGE_MODE_mode_RMW PCK_EDGE_MODE_mode_ADDR32, PCK_EDGE_MODE_mode_SHAMT, PCK_EDGE_MODE_mode_MASK

#define PCK_EDGE_TILE_ROW_SET_SELECT_select_ADDR32 24
#define PCK_EDGE_TILE_ROW_SET_SELECT_select_SHAMT 17
#define PCK_EDGE_TILE_ROW_SET_SELECT_select_MASK 0x1fe0000
#define PCK_EDGE_TILE_ROW_SET_SELECT_select_RMW                                            \
    PCK_EDGE_TILE_ROW_SET_SELECT_select_ADDR32, PCK_EDGE_TILE_ROW_SET_SELECT_select_SHAMT, \
        PCK_EDGE_TILE_ROW_SET_SELECT_select_MASK

#define PCK_EDGE_OFFSET_SEC1_mask_ADDR32 25
#define PCK_EDGE_OFFSET_SEC1_mask_SHAMT 0
#define PCK_EDGE_OFFSET_SEC1_mask_MASK 0xffff
#define PCK_EDGE_OFFSET_SEC1_mask_RMW \
    PCK_EDGE_OFFSET_SEC1_mask_ADDR32, PCK_EDGE_OFFSET_SEC1_mask_SHAMT, PCK_EDGE_OFFSET_SEC1_mask_MASK

#define PCK_EDGE_OFFSET_SEC2_mask_ADDR32 26
#define PCK_EDGE_OFFSET_SEC2_mask_SHAMT 0
#define PCK_EDGE_OFFSET_SEC2_mask_MASK 0xffff
#define PCK_EDGE_OFFSET_SEC2_mask_RMW \
    PCK_EDGE_OFFSET_SEC2_mask_ADDR32, PCK_EDGE_OFFSET_SEC2_mask_SHAMT, PCK_EDGE_OFFSET_SEC2_mask_MASK

#define PCK_EDGE_OFFSET_SEC3_mask_ADDR32 27
#define PCK_EDGE_OFFSET_SEC3_mask_SHAMT 0
#define PCK_EDGE_OFFSET_SEC3_mask_MASK 0xffff
#define PCK_EDGE_OFFSET_SEC3_mask_RMW \
    PCK_EDGE_OFFSET_SEC3_mask_ADDR32, PCK_EDGE_OFFSET_SEC3_mask_SHAMT, PCK_EDGE_OFFSET_SEC3_mask_MASK

#define PACK_COUNTERS_SEC0_pack_per_xy_plane_ADDR32 28
#define PACK_COUNTERS_SEC0_pack_per_xy_plane_SHAMT 0
#define PACK_COUNTERS_SEC0_pack_per_xy_plane_MASK 0xff
#define PACK_COUNTERS_SEC0_pack_per_xy_plane_RMW                                             \
    PACK_COUNTERS_SEC0_pack_per_xy_plane_ADDR32, PACK_COUNTERS_SEC0_pack_per_xy_plane_SHAMT, \
        PACK_COUNTERS_SEC0_pack_per_xy_plane_MASK

#define PACK_COUNTERS_SEC0_pack_reads_per_xy_plane_ADDR32 28
#define PACK_COUNTERS_SEC0_pack_reads_per_xy_plane_SHAMT 8
#define PACK_COUNTERS_SEC0_pack_reads_per_xy_plane_MASK 0xff00
#define PACK_COUNTERS_SEC0_pack_reads_per_xy_plane_RMW                                                   \
    PACK_COUNTERS_SEC0_pack_reads_per_xy_plane_ADDR32, PACK_COUNTERS_SEC0_pack_reads_per_xy_plane_SHAMT, \
        PACK_COUNTERS_SEC0_pack_reads_per_xy_plane_MASK

#define PACK_COUNTERS_SEC0_pack_xys_per_tile_ADDR32 28
#define PACK_COUNTERS_SEC0_pack_xys_per_tile_SHAMT 16
#define PACK_COUNTERS_SEC0_pack_xys_per_tile_MASK 0x7f0000
#define PACK_COUNTERS_SEC0_pack_xys_per_tile_RMW                                             \
    PACK_COUNTERS_SEC0_pack_xys_per_tile_ADDR32, PACK_COUNTERS_SEC0_pack_xys_per_tile_SHAMT, \
        PACK_COUNTERS_SEC0_pack_xys_per_tile_MASK

#define PACK_COUNTERS_SEC0_pack_yz_transposed_ADDR32 28
#define PACK_COUNTERS_SEC0_pack_yz_transposed_SHAMT 23
#define PACK_COUNTERS_SEC0_pack_yz_transposed_MASK 0x800000
#define PACK_COUNTERS_SEC0_pack_yz_transposed_RMW                                              \
    PACK_COUNTERS_SEC0_pack_yz_transposed_ADDR32, PACK_COUNTERS_SEC0_pack_yz_transposed_SHAMT, \
        PACK_COUNTERS_SEC0_pack_yz_transposed_MASK

#define PACK_COUNTERS_SEC0_auto_ctxt_inc_xys_cnt_ADDR32 28
#define PACK_COUNTERS_SEC0_auto_ctxt_inc_xys_cnt_SHAMT 24
#define PACK_COUNTERS_SEC0_auto_ctxt_inc_xys_cnt_MASK 0xff000000
#define PACK_COUNTERS_SEC0_auto_ctxt_inc_xys_cnt_RMW                                                 \
    PACK_COUNTERS_SEC0_auto_ctxt_inc_xys_cnt_ADDR32, PACK_COUNTERS_SEC0_auto_ctxt_inc_xys_cnt_SHAMT, \
        PACK_COUNTERS_SEC0_auto_ctxt_inc_xys_cnt_MASK

#define PACK_COUNTERS_SEC1_pack_per_xy_plane_ADDR32 29
#define PACK_COUNTERS_SEC1_pack_per_xy_plane_SHAMT 0
#define PACK_COUNTERS_SEC1_pack_per_xy_plane_MASK 0xff
#define PACK_COUNTERS_SEC1_pack_per_xy_plane_RMW                                             \
    PACK_COUNTERS_SEC1_pack_per_xy_plane_ADDR32, PACK_COUNTERS_SEC1_pack_per_xy_plane_SHAMT, \
        PACK_COUNTERS_SEC1_pack_per_xy_plane_MASK

#define PACK_COUNTERS_SEC1_pack_reads_per_xy_plane_ADDR32 29
#define PACK_COUNTERS_SEC1_pack_reads_per_xy_plane_SHAMT 8
#define PACK_COUNTERS_SEC1_pack_reads_per_xy_plane_MASK 0xff00
#define PACK_COUNTERS_SEC1_pack_reads_per_xy_plane_RMW                                                   \
    PACK_COUNTERS_SEC1_pack_reads_per_xy_plane_ADDR32, PACK_COUNTERS_SEC1_pack_reads_per_xy_plane_SHAMT, \
        PACK_COUNTERS_SEC1_pack_reads_per_xy_plane_MASK

#define PACK_COUNTERS_SEC1_pack_xys_per_tile_ADDR32 29
#define PACK_COUNTERS_SEC1_pack_xys_per_tile_SHAMT 16
#define PACK_COUNTERS_SEC1_pack_xys_per_tile_MASK 0x7f0000
#define PACK_COUNTERS_SEC1_pack_xys_per_tile_RMW                                             \
    PACK_COUNTERS_SEC1_pack_xys_per_tile_ADDR32, PACK_COUNTERS_SEC1_pack_xys_per_tile_SHAMT, \
        PACK_COUNTERS_SEC1_pack_xys_per_tile_MASK

#define PACK_COUNTERS_SEC1_pack_yz_transposed_ADDR32 29
#define PACK_COUNTERS_SEC1_pack_yz_transposed_SHAMT 23
#define PACK_COUNTERS_SEC1_pack_yz_transposed_MASK 0x800000
#define PACK_COUNTERS_SEC1_pack_yz_transposed_RMW                                              \
    PACK_COUNTERS_SEC1_pack_yz_transposed_ADDR32, PACK_COUNTERS_SEC1_pack_yz_transposed_SHAMT, \
        PACK_COUNTERS_SEC1_pack_yz_transposed_MASK

#define PACK_COUNTERS_SEC1_auto_ctxt_inc_xys_cnt_ADDR32 29
#define PACK_COUNTERS_SEC1_auto_ctxt_inc_xys_cnt_SHAMT 24
#define PACK_COUNTERS_SEC1_auto_ctxt_inc_xys_cnt_MASK 0xff000000
#define PACK_COUNTERS_SEC1_auto_ctxt_inc_xys_cnt_RMW                                                 \
    PACK_COUNTERS_SEC1_auto_ctxt_inc_xys_cnt_ADDR32, PACK_COUNTERS_SEC1_auto_ctxt_inc_xys_cnt_SHAMT, \
        PACK_COUNTERS_SEC1_auto_ctxt_inc_xys_cnt_MASK

#define PACK_COUNTERS_SEC2_pack_per_xy_plane_ADDR32 30
#define PACK_COUNTERS_SEC2_pack_per_xy_plane_SHAMT 0
#define PACK_COUNTERS_SEC2_pack_per_xy_plane_MASK 0xff
#define PACK_COUNTERS_SEC2_pack_per_xy_plane_RMW                                             \
    PACK_COUNTERS_SEC2_pack_per_xy_plane_ADDR32, PACK_COUNTERS_SEC2_pack_per_xy_plane_SHAMT, \
        PACK_COUNTERS_SEC2_pack_per_xy_plane_MASK

#define PACK_COUNTERS_SEC2_pack_reads_per_xy_plane_ADDR32 30
#define PACK_COUNTERS_SEC2_pack_reads_per_xy_plane_SHAMT 8
#define PACK_COUNTERS_SEC2_pack_reads_per_xy_plane_MASK 0xff00
#define PACK_COUNTERS_SEC2_pack_reads_per_xy_plane_RMW                                                   \
    PACK_COUNTERS_SEC2_pack_reads_per_xy_plane_ADDR32, PACK_COUNTERS_SEC2_pack_reads_per_xy_plane_SHAMT, \
        PACK_COUNTERS_SEC2_pack_reads_per_xy_plane_MASK

#define PACK_COUNTERS_SEC2_pack_xys_per_tile_ADDR32 30
#define PACK_COUNTERS_SEC2_pack_xys_per_tile_SHAMT 16
#define PACK_COUNTERS_SEC2_pack_xys_per_tile_MASK 0x7f0000
#define PACK_COUNTERS_SEC2_pack_xys_per_tile_RMW                                             \
    PACK_COUNTERS_SEC2_pack_xys_per_tile_ADDR32, PACK_COUNTERS_SEC2_pack_xys_per_tile_SHAMT, \
        PACK_COUNTERS_SEC2_pack_xys_per_tile_MASK

#define PACK_COUNTERS_SEC2_pack_yz_transposed_ADDR32 30
#define PACK_COUNTERS_SEC2_pack_yz_transposed_SHAMT 23
#define PACK_COUNTERS_SEC2_pack_yz_transposed_MASK 0x800000
#define PACK_COUNTERS_SEC2_pack_yz_transposed_RMW                                              \
    PACK_COUNTERS_SEC2_pack_yz_transposed_ADDR32, PACK_COUNTERS_SEC2_pack_yz_transposed_SHAMT, \
        PACK_COUNTERS_SEC2_pack_yz_transposed_MASK

#define PACK_COUNTERS_SEC2_auto_ctxt_inc_xys_cnt_ADDR32 30
#define PACK_COUNTERS_SEC2_auto_ctxt_inc_xys_cnt_SHAMT 24
#define PACK_COUNTERS_SEC2_auto_ctxt_inc_xys_cnt_MASK 0xff000000
#define PACK_COUNTERS_SEC2_auto_ctxt_inc_xys_cnt_RMW                                                 \
    PACK_COUNTERS_SEC2_auto_ctxt_inc_xys_cnt_ADDR32, PACK_COUNTERS_SEC2_auto_ctxt_inc_xys_cnt_SHAMT, \
        PACK_COUNTERS_SEC2_auto_ctxt_inc_xys_cnt_MASK

#define PACK_COUNTERS_SEC3_pack_per_xy_plane_ADDR32 31
#define PACK_COUNTERS_SEC3_pack_per_xy_plane_SHAMT 0
#define PACK_COUNTERS_SEC3_pack_per_xy_plane_MASK 0xff
#define PACK_COUNTERS_SEC3_pack_per_xy_plane_RMW                                             \
    PACK_COUNTERS_SEC3_pack_per_xy_plane_ADDR32, PACK_COUNTERS_SEC3_pack_per_xy_plane_SHAMT, \
        PACK_COUNTERS_SEC3_pack_per_xy_plane_MASK

#define PACK_COUNTERS_SEC3_pack_reads_per_xy_plane_ADDR32 31
#define PACK_COUNTERS_SEC3_pack_reads_per_xy_plane_SHAMT 8
#define PACK_COUNTERS_SEC3_pack_reads_per_xy_plane_MASK 0xff00
#define PACK_COUNTERS_SEC3_pack_reads_per_xy_plane_RMW                                                   \
    PACK_COUNTERS_SEC3_pack_reads_per_xy_plane_ADDR32, PACK_COUNTERS_SEC3_pack_reads_per_xy_plane_SHAMT, \
        PACK_COUNTERS_SEC3_pack_reads_per_xy_plane_MASK

#define PACK_COUNTERS_SEC3_pack_xys_per_tile_ADDR32 31
#define PACK_COUNTERS_SEC3_pack_xys_per_tile_SHAMT 16
#define PACK_COUNTERS_SEC3_pack_xys_per_tile_MASK 0x7f0000
#define PACK_COUNTERS_SEC3_pack_xys_per_tile_RMW                                             \
    PACK_COUNTERS_SEC3_pack_xys_per_tile_ADDR32, PACK_COUNTERS_SEC3_pack_xys_per_tile_SHAMT, \
        PACK_COUNTERS_SEC3_pack_xys_per_tile_MASK

#define PACK_COUNTERS_SEC3_pack_yz_transposed_ADDR32 31
#define PACK_COUNTERS_SEC3_pack_yz_transposed_SHAMT 23
#define PACK_COUNTERS_SEC3_pack_yz_transposed_MASK 0x800000
#define PACK_COUNTERS_SEC3_pack_yz_transposed_RMW                                              \
    PACK_COUNTERS_SEC3_pack_yz_transposed_ADDR32, PACK_COUNTERS_SEC3_pack_yz_transposed_SHAMT, \
        PACK_COUNTERS_SEC3_pack_yz_transposed_MASK

#define PACK_COUNTERS_SEC3_auto_ctxt_inc_xys_cnt_ADDR32 31
#define PACK_COUNTERS_SEC3_auto_ctxt_inc_xys_cnt_SHAMT 24
#define PACK_COUNTERS_SEC3_auto_ctxt_inc_xys_cnt_MASK 0xff000000
#define PACK_COUNTERS_SEC3_auto_ctxt_inc_xys_cnt_RMW                                                 \
    PACK_COUNTERS_SEC3_auto_ctxt_inc_xys_cnt_ADDR32, PACK_COUNTERS_SEC3_auto_ctxt_inc_xys_cnt_SHAMT, \
        PACK_COUNTERS_SEC3_auto_ctxt_inc_xys_cnt_MASK

#define PACK_CONCAT_MASK_SEC0_pack_concat_mask_ADDR32 32
#define PACK_CONCAT_MASK_SEC0_pack_concat_mask_SHAMT 0
#define PACK_CONCAT_MASK_SEC0_pack_concat_mask_MASK 0xffff
#define PACK_CONCAT_MASK_SEC0_pack_concat_mask_RMW                                               \
    PACK_CONCAT_MASK_SEC0_pack_concat_mask_ADDR32, PACK_CONCAT_MASK_SEC0_pack_concat_mask_SHAMT, \
        PACK_CONCAT_MASK_SEC0_pack_concat_mask_MASK

#define PACK_CONCAT_MASK_SEC1_pack_concat_mask_ADDR32 33
#define PACK_CONCAT_MASK_SEC1_pack_concat_mask_SHAMT 0
#define PACK_CONCAT_MASK_SEC1_pack_concat_mask_MASK 0xffff
#define PACK_CONCAT_MASK_SEC1_pack_concat_mask_RMW                                               \
    PACK_CONCAT_MASK_SEC1_pack_concat_mask_ADDR32, PACK_CONCAT_MASK_SEC1_pack_concat_mask_SHAMT, \
        PACK_CONCAT_MASK_SEC1_pack_concat_mask_MASK

#define PACK_CONCAT_MASK_SEC2_pack_concat_mask_ADDR32 34
#define PACK_CONCAT_MASK_SEC2_pack_concat_mask_SHAMT 0
#define PACK_CONCAT_MASK_SEC2_pack_concat_mask_MASK 0xffff
#define PACK_CONCAT_MASK_SEC2_pack_concat_mask_RMW                                               \
    PACK_CONCAT_MASK_SEC2_pack_concat_mask_ADDR32, PACK_CONCAT_MASK_SEC2_pack_concat_mask_SHAMT, \
        PACK_CONCAT_MASK_SEC2_pack_concat_mask_MASK

#define PACK_CONCAT_MASK_SEC3_pack_concat_mask_ADDR32 35
#define PACK_CONCAT_MASK_SEC3_pack_concat_mask_SHAMT 0
#define PACK_CONCAT_MASK_SEC3_pack_concat_mask_MASK 0xffff
#define PACK_CONCAT_MASK_SEC3_pack_concat_mask_RMW                                               \
    PACK_CONCAT_MASK_SEC3_pack_concat_mask_ADDR32, PACK_CONCAT_MASK_SEC3_pack_concat_mask_SHAMT, \
        PACK_CONCAT_MASK_SEC3_pack_concat_mask_MASK

#define TILE_FACE_SET_MAPPING_0_face_set_mapping_0_ADDR32 36
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_0_SHAMT 0
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_0_MASK 0x3
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_0_RMW                                                   \
    TILE_FACE_SET_MAPPING_0_face_set_mapping_0_ADDR32, TILE_FACE_SET_MAPPING_0_face_set_mapping_0_SHAMT, \
        TILE_FACE_SET_MAPPING_0_face_set_mapping_0_MASK

#define TILE_FACE_SET_MAPPING_0_face_set_mapping_1_ADDR32 36
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_1_SHAMT 2
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_1_MASK 0xc
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_1_RMW                                                   \
    TILE_FACE_SET_MAPPING_0_face_set_mapping_1_ADDR32, TILE_FACE_SET_MAPPING_0_face_set_mapping_1_SHAMT, \
        TILE_FACE_SET_MAPPING_0_face_set_mapping_1_MASK

#define TILE_FACE_SET_MAPPING_0_face_set_mapping_2_ADDR32 36
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_2_SHAMT 4
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_2_MASK 0x30
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_2_RMW                                                   \
    TILE_FACE_SET_MAPPING_0_face_set_mapping_2_ADDR32, TILE_FACE_SET_MAPPING_0_face_set_mapping_2_SHAMT, \
        TILE_FACE_SET_MAPPING_0_face_set_mapping_2_MASK

#define TILE_FACE_SET_MAPPING_0_face_set_mapping_3_ADDR32 36
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_3_SHAMT 6
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_3_MASK 0xc0
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_3_RMW                                                   \
    TILE_FACE_SET_MAPPING_0_face_set_mapping_3_ADDR32, TILE_FACE_SET_MAPPING_0_face_set_mapping_3_SHAMT, \
        TILE_FACE_SET_MAPPING_0_face_set_mapping_3_MASK

#define TILE_FACE_SET_MAPPING_0_face_set_mapping_4_ADDR32 36
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_4_SHAMT 8
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_4_MASK 0x300
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_4_RMW                                                   \
    TILE_FACE_SET_MAPPING_0_face_set_mapping_4_ADDR32, TILE_FACE_SET_MAPPING_0_face_set_mapping_4_SHAMT, \
        TILE_FACE_SET_MAPPING_0_face_set_mapping_4_MASK

#define TILE_FACE_SET_MAPPING_0_face_set_mapping_5_ADDR32 36
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_5_SHAMT 10
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_5_MASK 0xc00
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_5_RMW                                                   \
    TILE_FACE_SET_MAPPING_0_face_set_mapping_5_ADDR32, TILE_FACE_SET_MAPPING_0_face_set_mapping_5_SHAMT, \
        TILE_FACE_SET_MAPPING_0_face_set_mapping_5_MASK

#define TILE_FACE_SET_MAPPING_0_face_set_mapping_6_ADDR32 36
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_6_SHAMT 12
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_6_MASK 0x3000
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_6_RMW                                                   \
    TILE_FACE_SET_MAPPING_0_face_set_mapping_6_ADDR32, TILE_FACE_SET_MAPPING_0_face_set_mapping_6_SHAMT, \
        TILE_FACE_SET_MAPPING_0_face_set_mapping_6_MASK

#define TILE_FACE_SET_MAPPING_0_face_set_mapping_7_ADDR32 36
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_7_SHAMT 14
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_7_MASK 0xc000
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_7_RMW                                                   \
    TILE_FACE_SET_MAPPING_0_face_set_mapping_7_ADDR32, TILE_FACE_SET_MAPPING_0_face_set_mapping_7_SHAMT, \
        TILE_FACE_SET_MAPPING_0_face_set_mapping_7_MASK

#define TILE_FACE_SET_MAPPING_0_face_set_mapping_8_ADDR32 36
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_8_SHAMT 16
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_8_MASK 0x30000
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_8_RMW                                                   \
    TILE_FACE_SET_MAPPING_0_face_set_mapping_8_ADDR32, TILE_FACE_SET_MAPPING_0_face_set_mapping_8_SHAMT, \
        TILE_FACE_SET_MAPPING_0_face_set_mapping_8_MASK

#define TILE_FACE_SET_MAPPING_0_face_set_mapping_9_ADDR32 36
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_9_SHAMT 18
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_9_MASK 0xc0000
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_9_RMW                                                   \
    TILE_FACE_SET_MAPPING_0_face_set_mapping_9_ADDR32, TILE_FACE_SET_MAPPING_0_face_set_mapping_9_SHAMT, \
        TILE_FACE_SET_MAPPING_0_face_set_mapping_9_MASK

#define TILE_FACE_SET_MAPPING_0_face_set_mapping_10_ADDR32 36
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_10_SHAMT 20
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_10_MASK 0x300000
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_10_RMW                                                    \
    TILE_FACE_SET_MAPPING_0_face_set_mapping_10_ADDR32, TILE_FACE_SET_MAPPING_0_face_set_mapping_10_SHAMT, \
        TILE_FACE_SET_MAPPING_0_face_set_mapping_10_MASK

#define TILE_FACE_SET_MAPPING_0_face_set_mapping_11_ADDR32 36
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_11_SHAMT 22
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_11_MASK 0xc00000
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_11_RMW                                                    \
    TILE_FACE_SET_MAPPING_0_face_set_mapping_11_ADDR32, TILE_FACE_SET_MAPPING_0_face_set_mapping_11_SHAMT, \
        TILE_FACE_SET_MAPPING_0_face_set_mapping_11_MASK

#define TILE_FACE_SET_MAPPING_0_face_set_mapping_12_ADDR32 36
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_12_SHAMT 24
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_12_MASK 0x3000000
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_12_RMW                                                    \
    TILE_FACE_SET_MAPPING_0_face_set_mapping_12_ADDR32, TILE_FACE_SET_MAPPING_0_face_set_mapping_12_SHAMT, \
        TILE_FACE_SET_MAPPING_0_face_set_mapping_12_MASK

#define TILE_FACE_SET_MAPPING_0_face_set_mapping_13_ADDR32 36
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_13_SHAMT 26
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_13_MASK 0xc000000
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_13_RMW                                                    \
    TILE_FACE_SET_MAPPING_0_face_set_mapping_13_ADDR32, TILE_FACE_SET_MAPPING_0_face_set_mapping_13_SHAMT, \
        TILE_FACE_SET_MAPPING_0_face_set_mapping_13_MASK

#define TILE_FACE_SET_MAPPING_0_face_set_mapping_14_ADDR32 36
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_14_SHAMT 28
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_14_MASK 0x30000000
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_14_RMW                                                    \
    TILE_FACE_SET_MAPPING_0_face_set_mapping_14_ADDR32, TILE_FACE_SET_MAPPING_0_face_set_mapping_14_SHAMT, \
        TILE_FACE_SET_MAPPING_0_face_set_mapping_14_MASK

#define TILE_FACE_SET_MAPPING_0_face_set_mapping_15_ADDR32 36
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_15_SHAMT 30
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_15_MASK 0xc0000000
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_15_RMW                                                    \
    TILE_FACE_SET_MAPPING_0_face_set_mapping_15_ADDR32, TILE_FACE_SET_MAPPING_0_face_set_mapping_15_SHAMT, \
        TILE_FACE_SET_MAPPING_0_face_set_mapping_15_MASK

#define TILE_FACE_SET_MAPPING_1_face_set_mapping_0_ADDR32 37
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_0_SHAMT 0
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_0_MASK 0x3
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_0_RMW                                                   \
    TILE_FACE_SET_MAPPING_1_face_set_mapping_0_ADDR32, TILE_FACE_SET_MAPPING_1_face_set_mapping_0_SHAMT, \
        TILE_FACE_SET_MAPPING_1_face_set_mapping_0_MASK

#define TILE_FACE_SET_MAPPING_1_face_set_mapping_1_ADDR32 37
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_1_SHAMT 2
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_1_MASK 0xc
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_1_RMW                                                   \
    TILE_FACE_SET_MAPPING_1_face_set_mapping_1_ADDR32, TILE_FACE_SET_MAPPING_1_face_set_mapping_1_SHAMT, \
        TILE_FACE_SET_MAPPING_1_face_set_mapping_1_MASK

#define TILE_FACE_SET_MAPPING_1_face_set_mapping_2_ADDR32 37
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_2_SHAMT 4
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_2_MASK 0x30
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_2_RMW                                                   \
    TILE_FACE_SET_MAPPING_1_face_set_mapping_2_ADDR32, TILE_FACE_SET_MAPPING_1_face_set_mapping_2_SHAMT, \
        TILE_FACE_SET_MAPPING_1_face_set_mapping_2_MASK

#define TILE_FACE_SET_MAPPING_1_face_set_mapping_3_ADDR32 37
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_3_SHAMT 6
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_3_MASK 0xc0
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_3_RMW                                                   \
    TILE_FACE_SET_MAPPING_1_face_set_mapping_3_ADDR32, TILE_FACE_SET_MAPPING_1_face_set_mapping_3_SHAMT, \
        TILE_FACE_SET_MAPPING_1_face_set_mapping_3_MASK

#define TILE_FACE_SET_MAPPING_1_face_set_mapping_4_ADDR32 37
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_4_SHAMT 8
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_4_MASK 0x300
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_4_RMW                                                   \
    TILE_FACE_SET_MAPPING_1_face_set_mapping_4_ADDR32, TILE_FACE_SET_MAPPING_1_face_set_mapping_4_SHAMT, \
        TILE_FACE_SET_MAPPING_1_face_set_mapping_4_MASK

#define TILE_FACE_SET_MAPPING_1_face_set_mapping_5_ADDR32 37
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_5_SHAMT 10
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_5_MASK 0xc00
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_5_RMW                                                   \
    TILE_FACE_SET_MAPPING_1_face_set_mapping_5_ADDR32, TILE_FACE_SET_MAPPING_1_face_set_mapping_5_SHAMT, \
        TILE_FACE_SET_MAPPING_1_face_set_mapping_5_MASK

#define TILE_FACE_SET_MAPPING_1_face_set_mapping_6_ADDR32 37
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_6_SHAMT 12
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_6_MASK 0x3000
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_6_RMW                                                   \
    TILE_FACE_SET_MAPPING_1_face_set_mapping_6_ADDR32, TILE_FACE_SET_MAPPING_1_face_set_mapping_6_SHAMT, \
        TILE_FACE_SET_MAPPING_1_face_set_mapping_6_MASK

#define TILE_FACE_SET_MAPPING_1_face_set_mapping_7_ADDR32 37
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_7_SHAMT 14
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_7_MASK 0xc000
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_7_RMW                                                   \
    TILE_FACE_SET_MAPPING_1_face_set_mapping_7_ADDR32, TILE_FACE_SET_MAPPING_1_face_set_mapping_7_SHAMT, \
        TILE_FACE_SET_MAPPING_1_face_set_mapping_7_MASK

#define TILE_FACE_SET_MAPPING_1_face_set_mapping_8_ADDR32 37
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_8_SHAMT 16
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_8_MASK 0x30000
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_8_RMW                                                   \
    TILE_FACE_SET_MAPPING_1_face_set_mapping_8_ADDR32, TILE_FACE_SET_MAPPING_1_face_set_mapping_8_SHAMT, \
        TILE_FACE_SET_MAPPING_1_face_set_mapping_8_MASK

#define TILE_FACE_SET_MAPPING_1_face_set_mapping_9_ADDR32 37
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_9_SHAMT 18
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_9_MASK 0xc0000
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_9_RMW                                                   \
    TILE_FACE_SET_MAPPING_1_face_set_mapping_9_ADDR32, TILE_FACE_SET_MAPPING_1_face_set_mapping_9_SHAMT, \
        TILE_FACE_SET_MAPPING_1_face_set_mapping_9_MASK

#define TILE_FACE_SET_MAPPING_1_face_set_mapping_10_ADDR32 37
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_10_SHAMT 20
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_10_MASK 0x300000
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_10_RMW                                                    \
    TILE_FACE_SET_MAPPING_1_face_set_mapping_10_ADDR32, TILE_FACE_SET_MAPPING_1_face_set_mapping_10_SHAMT, \
        TILE_FACE_SET_MAPPING_1_face_set_mapping_10_MASK

#define TILE_FACE_SET_MAPPING_1_face_set_mapping_11_ADDR32 37
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_11_SHAMT 22
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_11_MASK 0xc00000
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_11_RMW                                                    \
    TILE_FACE_SET_MAPPING_1_face_set_mapping_11_ADDR32, TILE_FACE_SET_MAPPING_1_face_set_mapping_11_SHAMT, \
        TILE_FACE_SET_MAPPING_1_face_set_mapping_11_MASK

#define TILE_FACE_SET_MAPPING_1_face_set_mapping_12_ADDR32 37
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_12_SHAMT 24
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_12_MASK 0x3000000
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_12_RMW                                                    \
    TILE_FACE_SET_MAPPING_1_face_set_mapping_12_ADDR32, TILE_FACE_SET_MAPPING_1_face_set_mapping_12_SHAMT, \
        TILE_FACE_SET_MAPPING_1_face_set_mapping_12_MASK

#define TILE_FACE_SET_MAPPING_1_face_set_mapping_13_ADDR32 37
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_13_SHAMT 26
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_13_MASK 0xc000000
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_13_RMW                                                    \
    TILE_FACE_SET_MAPPING_1_face_set_mapping_13_ADDR32, TILE_FACE_SET_MAPPING_1_face_set_mapping_13_SHAMT, \
        TILE_FACE_SET_MAPPING_1_face_set_mapping_13_MASK

#define TILE_FACE_SET_MAPPING_1_face_set_mapping_14_ADDR32 37
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_14_SHAMT 28
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_14_MASK 0x30000000
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_14_RMW                                                    \
    TILE_FACE_SET_MAPPING_1_face_set_mapping_14_ADDR32, TILE_FACE_SET_MAPPING_1_face_set_mapping_14_SHAMT, \
        TILE_FACE_SET_MAPPING_1_face_set_mapping_14_MASK

#define TILE_FACE_SET_MAPPING_1_face_set_mapping_15_ADDR32 37
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_15_SHAMT 30
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_15_MASK 0xc0000000
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_15_RMW                                                    \
    TILE_FACE_SET_MAPPING_1_face_set_mapping_15_ADDR32, TILE_FACE_SET_MAPPING_1_face_set_mapping_15_SHAMT, \
        TILE_FACE_SET_MAPPING_1_face_set_mapping_15_MASK

#define TILE_FACE_SET_MAPPING_2_face_set_mapping_0_ADDR32 38
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_0_SHAMT 0
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_0_MASK 0x3
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_0_RMW                                                   \
    TILE_FACE_SET_MAPPING_2_face_set_mapping_0_ADDR32, TILE_FACE_SET_MAPPING_2_face_set_mapping_0_SHAMT, \
        TILE_FACE_SET_MAPPING_2_face_set_mapping_0_MASK

#define TILE_FACE_SET_MAPPING_2_face_set_mapping_1_ADDR32 38
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_1_SHAMT 2
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_1_MASK 0xc
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_1_RMW                                                   \
    TILE_FACE_SET_MAPPING_2_face_set_mapping_1_ADDR32, TILE_FACE_SET_MAPPING_2_face_set_mapping_1_SHAMT, \
        TILE_FACE_SET_MAPPING_2_face_set_mapping_1_MASK

#define TILE_FACE_SET_MAPPING_2_face_set_mapping_2_ADDR32 38
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_2_SHAMT 4
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_2_MASK 0x30
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_2_RMW                                                   \
    TILE_FACE_SET_MAPPING_2_face_set_mapping_2_ADDR32, TILE_FACE_SET_MAPPING_2_face_set_mapping_2_SHAMT, \
        TILE_FACE_SET_MAPPING_2_face_set_mapping_2_MASK

#define TILE_FACE_SET_MAPPING_2_face_set_mapping_3_ADDR32 38
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_3_SHAMT 6
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_3_MASK 0xc0
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_3_RMW                                                   \
    TILE_FACE_SET_MAPPING_2_face_set_mapping_3_ADDR32, TILE_FACE_SET_MAPPING_2_face_set_mapping_3_SHAMT, \
        TILE_FACE_SET_MAPPING_2_face_set_mapping_3_MASK

#define TILE_FACE_SET_MAPPING_2_face_set_mapping_4_ADDR32 38
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_4_SHAMT 8
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_4_MASK 0x300
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_4_RMW                                                   \
    TILE_FACE_SET_MAPPING_2_face_set_mapping_4_ADDR32, TILE_FACE_SET_MAPPING_2_face_set_mapping_4_SHAMT, \
        TILE_FACE_SET_MAPPING_2_face_set_mapping_4_MASK

#define TILE_FACE_SET_MAPPING_2_face_set_mapping_5_ADDR32 38
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_5_SHAMT 10
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_5_MASK 0xc00
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_5_RMW                                                   \
    TILE_FACE_SET_MAPPING_2_face_set_mapping_5_ADDR32, TILE_FACE_SET_MAPPING_2_face_set_mapping_5_SHAMT, \
        TILE_FACE_SET_MAPPING_2_face_set_mapping_5_MASK

#define TILE_FACE_SET_MAPPING_2_face_set_mapping_6_ADDR32 38
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_6_SHAMT 12
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_6_MASK 0x3000
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_6_RMW                                                   \
    TILE_FACE_SET_MAPPING_2_face_set_mapping_6_ADDR32, TILE_FACE_SET_MAPPING_2_face_set_mapping_6_SHAMT, \
        TILE_FACE_SET_MAPPING_2_face_set_mapping_6_MASK

#define TILE_FACE_SET_MAPPING_2_face_set_mapping_7_ADDR32 38
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_7_SHAMT 14
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_7_MASK 0xc000
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_7_RMW                                                   \
    TILE_FACE_SET_MAPPING_2_face_set_mapping_7_ADDR32, TILE_FACE_SET_MAPPING_2_face_set_mapping_7_SHAMT, \
        TILE_FACE_SET_MAPPING_2_face_set_mapping_7_MASK

#define TILE_FACE_SET_MAPPING_2_face_set_mapping_8_ADDR32 38
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_8_SHAMT 16
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_8_MASK 0x30000
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_8_RMW                                                   \
    TILE_FACE_SET_MAPPING_2_face_set_mapping_8_ADDR32, TILE_FACE_SET_MAPPING_2_face_set_mapping_8_SHAMT, \
        TILE_FACE_SET_MAPPING_2_face_set_mapping_8_MASK

#define TILE_FACE_SET_MAPPING_2_face_set_mapping_9_ADDR32 38
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_9_SHAMT 18
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_9_MASK 0xc0000
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_9_RMW                                                   \
    TILE_FACE_SET_MAPPING_2_face_set_mapping_9_ADDR32, TILE_FACE_SET_MAPPING_2_face_set_mapping_9_SHAMT, \
        TILE_FACE_SET_MAPPING_2_face_set_mapping_9_MASK

#define TILE_FACE_SET_MAPPING_2_face_set_mapping_10_ADDR32 38
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_10_SHAMT 20
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_10_MASK 0x300000
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_10_RMW                                                    \
    TILE_FACE_SET_MAPPING_2_face_set_mapping_10_ADDR32, TILE_FACE_SET_MAPPING_2_face_set_mapping_10_SHAMT, \
        TILE_FACE_SET_MAPPING_2_face_set_mapping_10_MASK

#define TILE_FACE_SET_MAPPING_2_face_set_mapping_11_ADDR32 38
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_11_SHAMT 22
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_11_MASK 0xc00000
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_11_RMW                                                    \
    TILE_FACE_SET_MAPPING_2_face_set_mapping_11_ADDR32, TILE_FACE_SET_MAPPING_2_face_set_mapping_11_SHAMT, \
        TILE_FACE_SET_MAPPING_2_face_set_mapping_11_MASK

#define TILE_FACE_SET_MAPPING_2_face_set_mapping_12_ADDR32 38
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_12_SHAMT 24
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_12_MASK 0x3000000
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_12_RMW                                                    \
    TILE_FACE_SET_MAPPING_2_face_set_mapping_12_ADDR32, TILE_FACE_SET_MAPPING_2_face_set_mapping_12_SHAMT, \
        TILE_FACE_SET_MAPPING_2_face_set_mapping_12_MASK

#define TILE_FACE_SET_MAPPING_2_face_set_mapping_13_ADDR32 38
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_13_SHAMT 26
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_13_MASK 0xc000000
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_13_RMW                                                    \
    TILE_FACE_SET_MAPPING_2_face_set_mapping_13_ADDR32, TILE_FACE_SET_MAPPING_2_face_set_mapping_13_SHAMT, \
        TILE_FACE_SET_MAPPING_2_face_set_mapping_13_MASK

#define TILE_FACE_SET_MAPPING_2_face_set_mapping_14_ADDR32 38
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_14_SHAMT 28
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_14_MASK 0x30000000
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_14_RMW                                                    \
    TILE_FACE_SET_MAPPING_2_face_set_mapping_14_ADDR32, TILE_FACE_SET_MAPPING_2_face_set_mapping_14_SHAMT, \
        TILE_FACE_SET_MAPPING_2_face_set_mapping_14_MASK

#define TILE_FACE_SET_MAPPING_2_face_set_mapping_15_ADDR32 38
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_15_SHAMT 30
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_15_MASK 0xc0000000
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_15_RMW                                                    \
    TILE_FACE_SET_MAPPING_2_face_set_mapping_15_ADDR32, TILE_FACE_SET_MAPPING_2_face_set_mapping_15_SHAMT, \
        TILE_FACE_SET_MAPPING_2_face_set_mapping_15_MASK

#define TILE_FACE_SET_MAPPING_3_face_set_mapping_0_ADDR32 39
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_0_SHAMT 0
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_0_MASK 0x3
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_0_RMW                                                   \
    TILE_FACE_SET_MAPPING_3_face_set_mapping_0_ADDR32, TILE_FACE_SET_MAPPING_3_face_set_mapping_0_SHAMT, \
        TILE_FACE_SET_MAPPING_3_face_set_mapping_0_MASK

#define TILE_FACE_SET_MAPPING_3_face_set_mapping_1_ADDR32 39
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_1_SHAMT 2
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_1_MASK 0xc
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_1_RMW                                                   \
    TILE_FACE_SET_MAPPING_3_face_set_mapping_1_ADDR32, TILE_FACE_SET_MAPPING_3_face_set_mapping_1_SHAMT, \
        TILE_FACE_SET_MAPPING_3_face_set_mapping_1_MASK

#define TILE_FACE_SET_MAPPING_3_face_set_mapping_2_ADDR32 39
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_2_SHAMT 4
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_2_MASK 0x30
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_2_RMW                                                   \
    TILE_FACE_SET_MAPPING_3_face_set_mapping_2_ADDR32, TILE_FACE_SET_MAPPING_3_face_set_mapping_2_SHAMT, \
        TILE_FACE_SET_MAPPING_3_face_set_mapping_2_MASK

#define TILE_FACE_SET_MAPPING_3_face_set_mapping_3_ADDR32 39
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_3_SHAMT 6
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_3_MASK 0xc0
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_3_RMW                                                   \
    TILE_FACE_SET_MAPPING_3_face_set_mapping_3_ADDR32, TILE_FACE_SET_MAPPING_3_face_set_mapping_3_SHAMT, \
        TILE_FACE_SET_MAPPING_3_face_set_mapping_3_MASK

#define TILE_FACE_SET_MAPPING_3_face_set_mapping_4_ADDR32 39
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_4_SHAMT 8
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_4_MASK 0x300
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_4_RMW                                                   \
    TILE_FACE_SET_MAPPING_3_face_set_mapping_4_ADDR32, TILE_FACE_SET_MAPPING_3_face_set_mapping_4_SHAMT, \
        TILE_FACE_SET_MAPPING_3_face_set_mapping_4_MASK

#define TILE_FACE_SET_MAPPING_3_face_set_mapping_5_ADDR32 39
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_5_SHAMT 10
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_5_MASK 0xc00
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_5_RMW                                                   \
    TILE_FACE_SET_MAPPING_3_face_set_mapping_5_ADDR32, TILE_FACE_SET_MAPPING_3_face_set_mapping_5_SHAMT, \
        TILE_FACE_SET_MAPPING_3_face_set_mapping_5_MASK

#define TILE_FACE_SET_MAPPING_3_face_set_mapping_6_ADDR32 39
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_6_SHAMT 12
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_6_MASK 0x3000
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_6_RMW                                                   \
    TILE_FACE_SET_MAPPING_3_face_set_mapping_6_ADDR32, TILE_FACE_SET_MAPPING_3_face_set_mapping_6_SHAMT, \
        TILE_FACE_SET_MAPPING_3_face_set_mapping_6_MASK

#define TILE_FACE_SET_MAPPING_3_face_set_mapping_7_ADDR32 39
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_7_SHAMT 14
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_7_MASK 0xc000
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_7_RMW                                                   \
    TILE_FACE_SET_MAPPING_3_face_set_mapping_7_ADDR32, TILE_FACE_SET_MAPPING_3_face_set_mapping_7_SHAMT, \
        TILE_FACE_SET_MAPPING_3_face_set_mapping_7_MASK

#define TILE_FACE_SET_MAPPING_3_face_set_mapping_8_ADDR32 39
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_8_SHAMT 16
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_8_MASK 0x30000
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_8_RMW                                                   \
    TILE_FACE_SET_MAPPING_3_face_set_mapping_8_ADDR32, TILE_FACE_SET_MAPPING_3_face_set_mapping_8_SHAMT, \
        TILE_FACE_SET_MAPPING_3_face_set_mapping_8_MASK

#define TILE_FACE_SET_MAPPING_3_face_set_mapping_9_ADDR32 39
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_9_SHAMT 18
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_9_MASK 0xc0000
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_9_RMW                                                   \
    TILE_FACE_SET_MAPPING_3_face_set_mapping_9_ADDR32, TILE_FACE_SET_MAPPING_3_face_set_mapping_9_SHAMT, \
        TILE_FACE_SET_MAPPING_3_face_set_mapping_9_MASK

#define TILE_FACE_SET_MAPPING_3_face_set_mapping_10_ADDR32 39
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_10_SHAMT 20
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_10_MASK 0x300000
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_10_RMW                                                    \
    TILE_FACE_SET_MAPPING_3_face_set_mapping_10_ADDR32, TILE_FACE_SET_MAPPING_3_face_set_mapping_10_SHAMT, \
        TILE_FACE_SET_MAPPING_3_face_set_mapping_10_MASK

#define TILE_FACE_SET_MAPPING_3_face_set_mapping_11_ADDR32 39
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_11_SHAMT 22
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_11_MASK 0xc00000
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_11_RMW                                                    \
    TILE_FACE_SET_MAPPING_3_face_set_mapping_11_ADDR32, TILE_FACE_SET_MAPPING_3_face_set_mapping_11_SHAMT, \
        TILE_FACE_SET_MAPPING_3_face_set_mapping_11_MASK

#define TILE_FACE_SET_MAPPING_3_face_set_mapping_12_ADDR32 39
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_12_SHAMT 24
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_12_MASK 0x3000000
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_12_RMW                                                    \
    TILE_FACE_SET_MAPPING_3_face_set_mapping_12_ADDR32, TILE_FACE_SET_MAPPING_3_face_set_mapping_12_SHAMT, \
        TILE_FACE_SET_MAPPING_3_face_set_mapping_12_MASK

#define TILE_FACE_SET_MAPPING_3_face_set_mapping_13_ADDR32 39
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_13_SHAMT 26
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_13_MASK 0xc000000
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_13_RMW                                                    \
    TILE_FACE_SET_MAPPING_3_face_set_mapping_13_ADDR32, TILE_FACE_SET_MAPPING_3_face_set_mapping_13_SHAMT, \
        TILE_FACE_SET_MAPPING_3_face_set_mapping_13_MASK

#define TILE_FACE_SET_MAPPING_3_face_set_mapping_14_ADDR32 39
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_14_SHAMT 28
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_14_MASK 0x30000000
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_14_RMW                                                    \
    TILE_FACE_SET_MAPPING_3_face_set_mapping_14_ADDR32, TILE_FACE_SET_MAPPING_3_face_set_mapping_14_SHAMT, \
        TILE_FACE_SET_MAPPING_3_face_set_mapping_14_MASK

#define TILE_FACE_SET_MAPPING_3_face_set_mapping_15_ADDR32 39
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_15_SHAMT 30
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_15_MASK 0xc0000000
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_15_RMW                                                    \
    TILE_FACE_SET_MAPPING_3_face_set_mapping_15_ADDR32, TILE_FACE_SET_MAPPING_3_face_set_mapping_15_SHAMT, \
        TILE_FACE_SET_MAPPING_3_face_set_mapping_15_MASK

#define PACK_GLOBAL_CFG_CTL_pack_disable_fast_tile_end_drain_ADDR32 40
#define PACK_GLOBAL_CFG_CTL_pack_disable_fast_tile_end_drain_SHAMT 0
#define PACK_GLOBAL_CFG_CTL_pack_disable_fast_tile_end_drain_MASK 0x1
#define PACK_GLOBAL_CFG_CTL_pack_disable_fast_tile_end_drain_RMW    \
    PACK_GLOBAL_CFG_CTL_pack_disable_fast_tile_end_drain_ADDR32,    \
        PACK_GLOBAL_CFG_CTL_pack_disable_fast_tile_end_drain_SHAMT, \
        PACK_GLOBAL_CFG_CTL_pack_disable_fast_tile_end_drain_MASK

////////////////////////////////////////////////////////////////////////
// Registers for UNPACK0
////////////////////////////////////////////////////////////////////////

#define UNPACK0_CFGREG_BASE_ADDR32 44

#define UNP0_ADDR_CTRL_XY_REG_0_Xstride_ADDR32 44
#define UNP0_ADDR_CTRL_XY_REG_0_Xstride_SHAMT 0
#define UNP0_ADDR_CTRL_XY_REG_0_Xstride_MASK 0xffff
#define UNP0_ADDR_CTRL_XY_REG_0_Xstride_RMW \
    UNP0_ADDR_CTRL_XY_REG_0_Xstride_ADDR32, UNP0_ADDR_CTRL_XY_REG_0_Xstride_SHAMT, UNP0_ADDR_CTRL_XY_REG_0_Xstride_MASK

#define UNP0_ADDR_CTRL_XY_REG_0_Ystride_ADDR32 44
#define UNP0_ADDR_CTRL_XY_REG_0_Ystride_SHAMT 16
#define UNP0_ADDR_CTRL_XY_REG_0_Ystride_MASK 0xffff0000
#define UNP0_ADDR_CTRL_XY_REG_0_Ystride_RMW \
    UNP0_ADDR_CTRL_XY_REG_0_Ystride_ADDR32, UNP0_ADDR_CTRL_XY_REG_0_Ystride_SHAMT, UNP0_ADDR_CTRL_XY_REG_0_Ystride_MASK

#define UNP0_ADDR_CTRL_ZW_REG_0_Zstride_ADDR32 45
#define UNP0_ADDR_CTRL_ZW_REG_0_Zstride_SHAMT 0
#define UNP0_ADDR_CTRL_ZW_REG_0_Zstride_MASK 0xffff
#define UNP0_ADDR_CTRL_ZW_REG_0_Zstride_RMW \
    UNP0_ADDR_CTRL_ZW_REG_0_Zstride_ADDR32, UNP0_ADDR_CTRL_ZW_REG_0_Zstride_SHAMT, UNP0_ADDR_CTRL_ZW_REG_0_Zstride_MASK

#define UNP0_ADDR_CTRL_ZW_REG_0_Wstride_ADDR32 45
#define UNP0_ADDR_CTRL_ZW_REG_0_Wstride_SHAMT 16
#define UNP0_ADDR_CTRL_ZW_REG_0_Wstride_MASK 0xffff0000
#define UNP0_ADDR_CTRL_ZW_REG_0_Wstride_RMW \
    UNP0_ADDR_CTRL_ZW_REG_0_Wstride_ADDR32, UNP0_ADDR_CTRL_ZW_REG_0_Wstride_SHAMT, UNP0_ADDR_CTRL_ZW_REG_0_Wstride_MASK

#define UNP1_ADDR_CTRL_XY_REG_0_Xstride_ADDR32 46
#define UNP1_ADDR_CTRL_XY_REG_0_Xstride_SHAMT 0
#define UNP1_ADDR_CTRL_XY_REG_0_Xstride_MASK 0xffff
#define UNP1_ADDR_CTRL_XY_REG_0_Xstride_RMW \
    UNP1_ADDR_CTRL_XY_REG_0_Xstride_ADDR32, UNP1_ADDR_CTRL_XY_REG_0_Xstride_SHAMT, UNP1_ADDR_CTRL_XY_REG_0_Xstride_MASK

#define UNP1_ADDR_CTRL_XY_REG_0_Ystride_ADDR32 46
#define UNP1_ADDR_CTRL_XY_REG_0_Ystride_SHAMT 16
#define UNP1_ADDR_CTRL_XY_REG_0_Ystride_MASK 0xffff0000
#define UNP1_ADDR_CTRL_XY_REG_0_Ystride_RMW \
    UNP1_ADDR_CTRL_XY_REG_0_Ystride_ADDR32, UNP1_ADDR_CTRL_XY_REG_0_Ystride_SHAMT, UNP1_ADDR_CTRL_XY_REG_0_Ystride_MASK

#define UNP1_ADDR_CTRL_ZW_REG_0_Zstride_ADDR32 47
#define UNP1_ADDR_CTRL_ZW_REG_0_Zstride_SHAMT 0
#define UNP1_ADDR_CTRL_ZW_REG_0_Zstride_MASK 0xffff
#define UNP1_ADDR_CTRL_ZW_REG_0_Zstride_RMW \
    UNP1_ADDR_CTRL_ZW_REG_0_Zstride_ADDR32, UNP1_ADDR_CTRL_ZW_REG_0_Zstride_SHAMT, UNP1_ADDR_CTRL_ZW_REG_0_Zstride_MASK

#define UNP1_ADDR_CTRL_ZW_REG_0_Wstride_ADDR32 47
#define UNP1_ADDR_CTRL_ZW_REG_0_Wstride_SHAMT 16
#define UNP1_ADDR_CTRL_ZW_REG_0_Wstride_MASK 0xffff0000
#define UNP1_ADDR_CTRL_ZW_REG_0_Wstride_RMW \
    UNP1_ADDR_CTRL_ZW_REG_0_Wstride_ADDR32, UNP1_ADDR_CTRL_ZW_REG_0_Wstride_SHAMT, UNP1_ADDR_CTRL_ZW_REG_0_Wstride_MASK

#define UNP0_ADDR_BASE_REG_0_Base_ADDR32 48
#define UNP0_ADDR_BASE_REG_0_Base_SHAMT 0
#define UNP0_ADDR_BASE_REG_0_Base_MASK 0x3ffff
#define UNP0_ADDR_BASE_REG_0_Base_RMW \
    UNP0_ADDR_BASE_REG_0_Base_ADDR32, UNP0_ADDR_BASE_REG_0_Base_SHAMT, UNP0_ADDR_BASE_REG_0_Base_MASK

#define UNP0_ADDR_BASE_REG_1_Base_ADDR32 49
#define UNP0_ADDR_BASE_REG_1_Base_SHAMT 0
#define UNP0_ADDR_BASE_REG_1_Base_MASK 0x3ffff
#define UNP0_ADDR_BASE_REG_1_Base_RMW \
    UNP0_ADDR_BASE_REG_1_Base_ADDR32, UNP0_ADDR_BASE_REG_1_Base_SHAMT, UNP0_ADDR_BASE_REG_1_Base_MASK

#define UNP0_FORCED_SHARED_EXP_shared_exp_ADDR32 50
#define UNP0_FORCED_SHARED_EXP_shared_exp_SHAMT 0
#define UNP0_FORCED_SHARED_EXP_shared_exp_MASK 0xff
#define UNP0_FORCED_SHARED_EXP_shared_exp_RMW                                          \
    UNP0_FORCED_SHARED_EXP_shared_exp_ADDR32, UNP0_FORCED_SHARED_EXP_shared_exp_SHAMT, \
        UNP0_FORCED_SHARED_EXP_shared_exp_MASK

#define UNP0_ADD_DEST_ADDR_CNTR_add_dest_addr_cntr_ADDR32 50
#define UNP0_ADD_DEST_ADDR_CNTR_add_dest_addr_cntr_SHAMT 8
#define UNP0_ADD_DEST_ADDR_CNTR_add_dest_addr_cntr_MASK 0x100
#define UNP0_ADD_DEST_ADDR_CNTR_add_dest_addr_cntr_RMW                                                   \
    UNP0_ADD_DEST_ADDR_CNTR_add_dest_addr_cntr_ADDR32, UNP0_ADD_DEST_ADDR_CNTR_add_dest_addr_cntr_SHAMT, \
        UNP0_ADD_DEST_ADDR_CNTR_add_dest_addr_cntr_MASK

#define UNP0_BLOBS_Y_START_CNTX_01_blobs_y_start_ADDR32 51
#define UNP0_BLOBS_Y_START_CNTX_01_blobs_y_start_SHAMT 0
#define UNP0_BLOBS_Y_START_CNTX_01_blobs_y_start_MASK 0xffffffff
#define UNP0_BLOBS_Y_START_CNTX_01_blobs_y_start_RMW                                                 \
    UNP0_BLOBS_Y_START_CNTX_01_blobs_y_start_ADDR32, UNP0_BLOBS_Y_START_CNTX_01_blobs_y_start_SHAMT, \
        UNP0_BLOBS_Y_START_CNTX_01_blobs_y_start_MASK

#define UNP0_BLOBS_Y_START_CNTX_23_blobs_y_start_ADDR32 52
#define UNP0_BLOBS_Y_START_CNTX_23_blobs_y_start_SHAMT 0
#define UNP0_BLOBS_Y_START_CNTX_23_blobs_y_start_MASK 0xffffffff
#define UNP0_BLOBS_Y_START_CNTX_23_blobs_y_start_RMW                                                 \
    UNP0_BLOBS_Y_START_CNTX_23_blobs_y_start_ADDR32, UNP0_BLOBS_Y_START_CNTX_23_blobs_y_start_SHAMT, \
        UNP0_BLOBS_Y_START_CNTX_23_blobs_y_start_MASK

#define UNP0_NOP_REG_CLR_VAL_nop_reg_clr_val_ADDR32 53
#define UNP0_NOP_REG_CLR_VAL_nop_reg_clr_val_SHAMT 0
#define UNP0_NOP_REG_CLR_VAL_nop_reg_clr_val_MASK 0xffffffff
#define UNP0_NOP_REG_CLR_VAL_nop_reg_clr_val_RMW                                             \
    UNP0_NOP_REG_CLR_VAL_nop_reg_clr_val_ADDR32, UNP0_NOP_REG_CLR_VAL_nop_reg_clr_val_SHAMT, \
        UNP0_NOP_REG_CLR_VAL_nop_reg_clr_val_MASK

////////////////////////////////////////////////////////////////////////
// Registers for UNPACK1
////////////////////////////////////////////////////////////////////////

#define UNPACK1_CFGREG_BASE_ADDR32 56

#define UNP0_ADDR_CTRL_XY_REG_1_Xstride_ADDR32 56
#define UNP0_ADDR_CTRL_XY_REG_1_Xstride_SHAMT 0
#define UNP0_ADDR_CTRL_XY_REG_1_Xstride_MASK 0xffff
#define UNP0_ADDR_CTRL_XY_REG_1_Xstride_RMW \
    UNP0_ADDR_CTRL_XY_REG_1_Xstride_ADDR32, UNP0_ADDR_CTRL_XY_REG_1_Xstride_SHAMT, UNP0_ADDR_CTRL_XY_REG_1_Xstride_MASK

#define UNP0_ADDR_CTRL_XY_REG_1_Ystride_ADDR32 56
#define UNP0_ADDR_CTRL_XY_REG_1_Ystride_SHAMT 16
#define UNP0_ADDR_CTRL_XY_REG_1_Ystride_MASK 0xffff0000
#define UNP0_ADDR_CTRL_XY_REG_1_Ystride_RMW \
    UNP0_ADDR_CTRL_XY_REG_1_Ystride_ADDR32, UNP0_ADDR_CTRL_XY_REG_1_Ystride_SHAMT, UNP0_ADDR_CTRL_XY_REG_1_Ystride_MASK

#define UNP0_ADDR_CTRL_ZW_REG_1_Zstride_ADDR32 57
#define UNP0_ADDR_CTRL_ZW_REG_1_Zstride_SHAMT 0
#define UNP0_ADDR_CTRL_ZW_REG_1_Zstride_MASK 0xffff
#define UNP0_ADDR_CTRL_ZW_REG_1_Zstride_RMW \
    UNP0_ADDR_CTRL_ZW_REG_1_Zstride_ADDR32, UNP0_ADDR_CTRL_ZW_REG_1_Zstride_SHAMT, UNP0_ADDR_CTRL_ZW_REG_1_Zstride_MASK

#define UNP0_ADDR_CTRL_ZW_REG_1_Wstride_ADDR32 57
#define UNP0_ADDR_CTRL_ZW_REG_1_Wstride_SHAMT 16
#define UNP0_ADDR_CTRL_ZW_REG_1_Wstride_MASK 0xffff0000
#define UNP0_ADDR_CTRL_ZW_REG_1_Wstride_RMW \
    UNP0_ADDR_CTRL_ZW_REG_1_Wstride_ADDR32, UNP0_ADDR_CTRL_ZW_REG_1_Wstride_SHAMT, UNP0_ADDR_CTRL_ZW_REG_1_Wstride_MASK

#define UNP1_ADDR_CTRL_XY_REG_1_Xstride_ADDR32 58
#define UNP1_ADDR_CTRL_XY_REG_1_Xstride_SHAMT 0
#define UNP1_ADDR_CTRL_XY_REG_1_Xstride_MASK 0xffff
#define UNP1_ADDR_CTRL_XY_REG_1_Xstride_RMW \
    UNP1_ADDR_CTRL_XY_REG_1_Xstride_ADDR32, UNP1_ADDR_CTRL_XY_REG_1_Xstride_SHAMT, UNP1_ADDR_CTRL_XY_REG_1_Xstride_MASK

#define UNP1_ADDR_CTRL_XY_REG_1_Ystride_ADDR32 58
#define UNP1_ADDR_CTRL_XY_REG_1_Ystride_SHAMT 16
#define UNP1_ADDR_CTRL_XY_REG_1_Ystride_MASK 0xffff0000
#define UNP1_ADDR_CTRL_XY_REG_1_Ystride_RMW \
    UNP1_ADDR_CTRL_XY_REG_1_Ystride_ADDR32, UNP1_ADDR_CTRL_XY_REG_1_Ystride_SHAMT, UNP1_ADDR_CTRL_XY_REG_1_Ystride_MASK

#define UNP1_ADDR_CTRL_ZW_REG_1_Zstride_ADDR32 59
#define UNP1_ADDR_CTRL_ZW_REG_1_Zstride_SHAMT 0
#define UNP1_ADDR_CTRL_ZW_REG_1_Zstride_MASK 0xffff
#define UNP1_ADDR_CTRL_ZW_REG_1_Zstride_RMW \
    UNP1_ADDR_CTRL_ZW_REG_1_Zstride_ADDR32, UNP1_ADDR_CTRL_ZW_REG_1_Zstride_SHAMT, UNP1_ADDR_CTRL_ZW_REG_1_Zstride_MASK

#define UNP1_ADDR_CTRL_ZW_REG_1_Wstride_ADDR32 59
#define UNP1_ADDR_CTRL_ZW_REG_1_Wstride_SHAMT 16
#define UNP1_ADDR_CTRL_ZW_REG_1_Wstride_MASK 0xffff0000
#define UNP1_ADDR_CTRL_ZW_REG_1_Wstride_RMW \
    UNP1_ADDR_CTRL_ZW_REG_1_Wstride_ADDR32, UNP1_ADDR_CTRL_ZW_REG_1_Wstride_SHAMT, UNP1_ADDR_CTRL_ZW_REG_1_Wstride_MASK

#define UNP1_ADDR_BASE_REG_0_Base_ADDR32 60
#define UNP1_ADDR_BASE_REG_0_Base_SHAMT 0
#define UNP1_ADDR_BASE_REG_0_Base_MASK 0x3ffff
#define UNP1_ADDR_BASE_REG_0_Base_RMW \
    UNP1_ADDR_BASE_REG_0_Base_ADDR32, UNP1_ADDR_BASE_REG_0_Base_SHAMT, UNP1_ADDR_BASE_REG_0_Base_MASK

#define UNP1_ADDR_BASE_REG_1_Base_ADDR32 61
#define UNP1_ADDR_BASE_REG_1_Base_SHAMT 0
#define UNP1_ADDR_BASE_REG_1_Base_MASK 0x3ffff
#define UNP1_ADDR_BASE_REG_1_Base_RMW \
    UNP1_ADDR_BASE_REG_1_Base_ADDR32, UNP1_ADDR_BASE_REG_1_Base_SHAMT, UNP1_ADDR_BASE_REG_1_Base_MASK

#define UNP1_FORCED_SHARED_EXP_shared_exp_ADDR32 62
#define UNP1_FORCED_SHARED_EXP_shared_exp_SHAMT 0
#define UNP1_FORCED_SHARED_EXP_shared_exp_MASK 0xff
#define UNP1_FORCED_SHARED_EXP_shared_exp_RMW                                          \
    UNP1_FORCED_SHARED_EXP_shared_exp_ADDR32, UNP1_FORCED_SHARED_EXP_shared_exp_SHAMT, \
        UNP1_FORCED_SHARED_EXP_shared_exp_MASK

#define UNP1_ADD_DEST_ADDR_CNTR_add_dest_addr_cntr_ADDR32 62
#define UNP1_ADD_DEST_ADDR_CNTR_add_dest_addr_cntr_SHAMT 8
#define UNP1_ADD_DEST_ADDR_CNTR_add_dest_addr_cntr_MASK 0x100
#define UNP1_ADD_DEST_ADDR_CNTR_add_dest_addr_cntr_RMW                                                   \
    UNP1_ADD_DEST_ADDR_CNTR_add_dest_addr_cntr_ADDR32, UNP1_ADD_DEST_ADDR_CNTR_add_dest_addr_cntr_SHAMT, \
        UNP1_ADD_DEST_ADDR_CNTR_add_dest_addr_cntr_MASK

#define UNP1_NOP_REG_CLR_VAL_nop_reg_clr_val_ADDR32 63
#define UNP1_NOP_REG_CLR_VAL_nop_reg_clr_val_SHAMT 0
#define UNP1_NOP_REG_CLR_VAL_nop_reg_clr_val_MASK 0xffffffff
#define UNP1_NOP_REG_CLR_VAL_nop_reg_clr_val_RMW                                             \
    UNP1_NOP_REG_CLR_VAL_nop_reg_clr_val_ADDR32, UNP1_NOP_REG_CLR_VAL_nop_reg_clr_val_SHAMT, \
        UNP1_NOP_REG_CLR_VAL_nop_reg_clr_val_MASK

////////////////////////////////////////////////////////////////////////
// Registers for THCON
////////////////////////////////////////////////////////////////////////

#define THCON_CFGREG_BASE_ADDR32 64

#define THCON_SEC0_REG0_TileDescriptor_ADDR32 64
#define THCON_SEC0_REG0_TileDescriptor_SHAMT 0
#define THCON_SEC0_REG0_TileDescriptor_MASK 0xffffffffffffffffffffffffffffffff
#define THCON_SEC0_REG0_TileDescriptor_RMW \
    THCON_SEC0_REG0_TileDescriptor_ADDR32, THCON_SEC0_REG0_TileDescriptor_SHAMT, THCON_SEC0_REG0_TileDescriptor_MASK

#define THCON_SEC0_REG1_Row_start_section_size_ADDR32 68
#define THCON_SEC0_REG1_Row_start_section_size_SHAMT 0
#define THCON_SEC0_REG1_Row_start_section_size_MASK 0xffff
#define THCON_SEC0_REG1_Row_start_section_size_RMW                                               \
    THCON_SEC0_REG1_Row_start_section_size_ADDR32, THCON_SEC0_REG1_Row_start_section_size_SHAMT, \
        THCON_SEC0_REG1_Row_start_section_size_MASK

#define THCON_SEC0_REG1_Exp_section_size_ADDR32 68
#define THCON_SEC0_REG1_Exp_section_size_SHAMT 16
#define THCON_SEC0_REG1_Exp_section_size_MASK 0xffff0000
#define THCON_SEC0_REG1_Exp_section_size_RMW                                         \
    THCON_SEC0_REG1_Exp_section_size_ADDR32, THCON_SEC0_REG1_Exp_section_size_SHAMT, \
        THCON_SEC0_REG1_Exp_section_size_MASK

#define THCON_SEC0_REG1_L1_Dest_addr_ADDR32 69
#define THCON_SEC0_REG1_L1_Dest_addr_SHAMT 0
#define THCON_SEC0_REG1_L1_Dest_addr_MASK 0xffffffff
#define THCON_SEC0_REG1_L1_Dest_addr_RMW \
    THCON_SEC0_REG1_L1_Dest_addr_ADDR32, THCON_SEC0_REG1_L1_Dest_addr_SHAMT, THCON_SEC0_REG1_L1_Dest_addr_MASK

#define THCON_SEC0_REG1_Disable_zero_compress_ADDR32 70
#define THCON_SEC0_REG1_Disable_zero_compress_SHAMT 0
#define THCON_SEC0_REG1_Disable_zero_compress_MASK 0x1
#define THCON_SEC0_REG1_Disable_zero_compress_RMW                                              \
    THCON_SEC0_REG1_Disable_zero_compress_ADDR32, THCON_SEC0_REG1_Disable_zero_compress_SHAMT, \
        THCON_SEC0_REG1_Disable_zero_compress_MASK

#define THCON_SEC0_REG1_Add_l1_dest_addr_offset_ADDR32 70
#define THCON_SEC0_REG1_Add_l1_dest_addr_offset_SHAMT 1
#define THCON_SEC0_REG1_Add_l1_dest_addr_offset_MASK 0x2
#define THCON_SEC0_REG1_Add_l1_dest_addr_offset_RMW                                                \
    THCON_SEC0_REG1_Add_l1_dest_addr_offset_ADDR32, THCON_SEC0_REG1_Add_l1_dest_addr_offset_SHAMT, \
        THCON_SEC0_REG1_Add_l1_dest_addr_offset_MASK

#define THCON_SEC0_REG1_Disable_pack_zero_flags_ADDR32 70
#define THCON_SEC0_REG1_Disable_pack_zero_flags_SHAMT 2
#define THCON_SEC0_REG1_Disable_pack_zero_flags_MASK 0x4
#define THCON_SEC0_REG1_Disable_pack_zero_flags_RMW                                                \
    THCON_SEC0_REG1_Disable_pack_zero_flags_ADDR32, THCON_SEC0_REG1_Disable_pack_zero_flags_SHAMT, \
        THCON_SEC0_REG1_Disable_pack_zero_flags_MASK

#define THCON_SEC0_REG1_ovrd_default_throttle_mode_ADDR32 70
#define THCON_SEC0_REG1_ovrd_default_throttle_mode_SHAMT 3
#define THCON_SEC0_REG1_ovrd_default_throttle_mode_MASK 0x8
#define THCON_SEC0_REG1_ovrd_default_throttle_mode_RMW                                                   \
    THCON_SEC0_REG1_ovrd_default_throttle_mode_ADDR32, THCON_SEC0_REG1_ovrd_default_throttle_mode_SHAMT, \
        THCON_SEC0_REG1_ovrd_default_throttle_mode_MASK

#define THCON_SEC0_REG1_Out_data_format_ADDR32 70
#define THCON_SEC0_REG1_Out_data_format_SHAMT 4
#define THCON_SEC0_REG1_Out_data_format_MASK 0xf0
#define THCON_SEC0_REG1_Out_data_format_RMW \
    THCON_SEC0_REG1_Out_data_format_ADDR32, THCON_SEC0_REG1_Out_data_format_SHAMT, THCON_SEC0_REG1_Out_data_format_MASK

#define THCON_SEC0_REG1_In_data_format_ADDR32 70
#define THCON_SEC0_REG1_In_data_format_SHAMT 8
#define THCON_SEC0_REG1_In_data_format_MASK 0xf00
#define THCON_SEC0_REG1_In_data_format_RMW \
    THCON_SEC0_REG1_In_data_format_ADDR32, THCON_SEC0_REG1_In_data_format_SHAMT, THCON_SEC0_REG1_In_data_format_MASK

#define THCON_SEC0_REG1_Dis_shared_exp_assembler_ADDR32 70
#define THCON_SEC0_REG1_Dis_shared_exp_assembler_SHAMT 12
#define THCON_SEC0_REG1_Dis_shared_exp_assembler_MASK 0x1000
#define THCON_SEC0_REG1_Dis_shared_exp_assembler_RMW                                                 \
    THCON_SEC0_REG1_Dis_shared_exp_assembler_ADDR32, THCON_SEC0_REG1_Dis_shared_exp_assembler_SHAMT, \
        THCON_SEC0_REG1_Dis_shared_exp_assembler_MASK

#define THCON_SEC0_REG1_Auto_set_last_pacr_intf_sel_ADDR32 70
#define THCON_SEC0_REG1_Auto_set_last_pacr_intf_sel_SHAMT 13
#define THCON_SEC0_REG1_Auto_set_last_pacr_intf_sel_MASK 0x2000
#define THCON_SEC0_REG1_Auto_set_last_pacr_intf_sel_RMW                                                    \
    THCON_SEC0_REG1_Auto_set_last_pacr_intf_sel_ADDR32, THCON_SEC0_REG1_Auto_set_last_pacr_intf_sel_SHAMT, \
        THCON_SEC0_REG1_Auto_set_last_pacr_intf_sel_MASK

#define THCON_SEC0_REG1_Enable_out_fifo_ADDR32 70
#define THCON_SEC0_REG1_Enable_out_fifo_SHAMT 14
#define THCON_SEC0_REG1_Enable_out_fifo_MASK 0x4000
#define THCON_SEC0_REG1_Enable_out_fifo_RMW \
    THCON_SEC0_REG1_Enable_out_fifo_ADDR32, THCON_SEC0_REG1_Enable_out_fifo_SHAMT, THCON_SEC0_REG1_Enable_out_fifo_MASK

#define THCON_SEC0_REG1_Sub_l1_tile_header_size_ADDR32 70
#define THCON_SEC0_REG1_Sub_l1_tile_header_size_SHAMT 15
#define THCON_SEC0_REG1_Sub_l1_tile_header_size_MASK 0x8000
#define THCON_SEC0_REG1_Sub_l1_tile_header_size_RMW                                                \
    THCON_SEC0_REG1_Sub_l1_tile_header_size_ADDR32, THCON_SEC0_REG1_Sub_l1_tile_header_size_SHAMT, \
        THCON_SEC0_REG1_Sub_l1_tile_header_size_MASK

#define THCON_SEC0_REG1_Source_interface_selection_ADDR32 70
#define THCON_SEC0_REG1_Source_interface_selection_SHAMT 16
#define THCON_SEC0_REG1_Source_interface_selection_MASK 0x10000
#define THCON_SEC0_REG1_Source_interface_selection_RMW                                                   \
    THCON_SEC0_REG1_Source_interface_selection_ADDR32, THCON_SEC0_REG1_Source_interface_selection_SHAMT, \
        THCON_SEC0_REG1_Source_interface_selection_MASK

#define THCON_SEC0_REG1_pack_start_intf_pos_ADDR32 70
#define THCON_SEC0_REG1_pack_start_intf_pos_SHAMT 17
#define THCON_SEC0_REG1_pack_start_intf_pos_MASK 0x1e0000
#define THCON_SEC0_REG1_pack_start_intf_pos_RMW                                            \
    THCON_SEC0_REG1_pack_start_intf_pos_ADDR32, THCON_SEC0_REG1_pack_start_intf_pos_SHAMT, \
        THCON_SEC0_REG1_pack_start_intf_pos_MASK

#define THCON_SEC0_REG1_All_pack_disable_zero_compress_ovrd_ADDR32 70
#define THCON_SEC0_REG1_All_pack_disable_zero_compress_ovrd_SHAMT 21
#define THCON_SEC0_REG1_All_pack_disable_zero_compress_ovrd_MASK 0x200000
#define THCON_SEC0_REG1_All_pack_disable_zero_compress_ovrd_RMW    \
    THCON_SEC0_REG1_All_pack_disable_zero_compress_ovrd_ADDR32,    \
        THCON_SEC0_REG1_All_pack_disable_zero_compress_ovrd_SHAMT, \
        THCON_SEC0_REG1_All_pack_disable_zero_compress_ovrd_MASK

#define THCON_SEC0_REG1_Add_tile_header_size_ADDR32 70
#define THCON_SEC0_REG1_Add_tile_header_size_SHAMT 22
#define THCON_SEC0_REG1_Add_tile_header_size_MASK 0x400000
#define THCON_SEC0_REG1_Add_tile_header_size_RMW                                             \
    THCON_SEC0_REG1_Add_tile_header_size_ADDR32, THCON_SEC0_REG1_Add_tile_header_size_SHAMT, \
        THCON_SEC0_REG1_Add_tile_header_size_MASK

#define THCON_SEC0_REG1_pack_dis_y_pos_start_offset_ADDR32 70
#define THCON_SEC0_REG1_pack_dis_y_pos_start_offset_SHAMT 23
#define THCON_SEC0_REG1_pack_dis_y_pos_start_offset_MASK 0x800000
#define THCON_SEC0_REG1_pack_dis_y_pos_start_offset_RMW                                                    \
    THCON_SEC0_REG1_pack_dis_y_pos_start_offset_ADDR32, THCON_SEC0_REG1_pack_dis_y_pos_start_offset_SHAMT, \
        THCON_SEC0_REG1_pack_dis_y_pos_start_offset_MASK

#define THCON_SEC0_REG1_L1_source_addr_ADDR32 70
#define THCON_SEC0_REG1_L1_source_addr_SHAMT 24
#define THCON_SEC0_REG1_L1_source_addr_MASK 0xff000000
#define THCON_SEC0_REG1_L1_source_addr_RMW \
    THCON_SEC0_REG1_L1_source_addr_ADDR32, THCON_SEC0_REG1_L1_source_addr_SHAMT, THCON_SEC0_REG1_L1_source_addr_MASK

#define THCON_SEC0_REG1_Downsample_mask_ADDR32 71
#define THCON_SEC0_REG1_Downsample_mask_SHAMT 0
#define THCON_SEC0_REG1_Downsample_mask_MASK 0xffff
#define THCON_SEC0_REG1_Downsample_mask_RMW \
    THCON_SEC0_REG1_Downsample_mask_ADDR32, THCON_SEC0_REG1_Downsample_mask_SHAMT, THCON_SEC0_REG1_Downsample_mask_MASK

#define THCON_SEC0_REG1_Downsample_rate_ADDR32 71
#define THCON_SEC0_REG1_Downsample_rate_SHAMT 16
#define THCON_SEC0_REG1_Downsample_rate_MASK 0x70000
#define THCON_SEC0_REG1_Downsample_rate_RMW \
    THCON_SEC0_REG1_Downsample_rate_ADDR32, THCON_SEC0_REG1_Downsample_rate_SHAMT, THCON_SEC0_REG1_Downsample_rate_MASK

#define THCON_SEC0_REG1_Pack_L1_Acc_ADDR32 71
#define THCON_SEC0_REG1_Pack_L1_Acc_SHAMT 19
#define THCON_SEC0_REG1_Pack_L1_Acc_MASK 0x80000
#define THCON_SEC0_REG1_Pack_L1_Acc_RMW \
    THCON_SEC0_REG1_Pack_L1_Acc_ADDR32, THCON_SEC0_REG1_Pack_L1_Acc_SHAMT, THCON_SEC0_REG1_Pack_L1_Acc_MASK

#define THCON_SEC0_REG1_Exp_threshold_en_ADDR32 71
#define THCON_SEC0_REG1_Exp_threshold_en_SHAMT 20
#define THCON_SEC0_REG1_Exp_threshold_en_MASK 0x100000
#define THCON_SEC0_REG1_Exp_threshold_en_RMW                                         \
    THCON_SEC0_REG1_Exp_threshold_en_ADDR32, THCON_SEC0_REG1_Exp_threshold_en_SHAMT, \
        THCON_SEC0_REG1_Exp_threshold_en_MASK

#define THCON_SEC0_REG1_Unp_LF8_4b_exp_ADDR32 71
#define THCON_SEC0_REG1_Unp_LF8_4b_exp_SHAMT 22
#define THCON_SEC0_REG1_Unp_LF8_4b_exp_MASK 0x400000
#define THCON_SEC0_REG1_Unp_LF8_4b_exp_RMW \
    THCON_SEC0_REG1_Unp_LF8_4b_exp_ADDR32, THCON_SEC0_REG1_Unp_LF8_4b_exp_SHAMT, THCON_SEC0_REG1_Unp_LF8_4b_exp_MASK

#define THCON_SEC0_REG1_Pac_LF8_4b_exp_ADDR32 71
#define THCON_SEC0_REG1_Pac_LF8_4b_exp_SHAMT 23
#define THCON_SEC0_REG1_Pac_LF8_4b_exp_MASK 0x800000
#define THCON_SEC0_REG1_Pac_LF8_4b_exp_RMW \
    THCON_SEC0_REG1_Pac_LF8_4b_exp_ADDR32, THCON_SEC0_REG1_Pac_LF8_4b_exp_SHAMT, THCON_SEC0_REG1_Pac_LF8_4b_exp_MASK

#define THCON_SEC0_REG1_Exp_threshold_ADDR32 71
#define THCON_SEC0_REG1_Exp_threshold_SHAMT 24
#define THCON_SEC0_REG1_Exp_threshold_MASK 0xff000000
#define THCON_SEC0_REG1_Exp_threshold_RMW \
    THCON_SEC0_REG1_Exp_threshold_ADDR32, THCON_SEC0_REG1_Exp_threshold_SHAMT, THCON_SEC0_REG1_Exp_threshold_MASK

#define THCON_SEC0_REG2_Out_data_format_ADDR32 72
#define THCON_SEC0_REG2_Out_data_format_SHAMT 0
#define THCON_SEC0_REG2_Out_data_format_MASK 0xf
#define THCON_SEC0_REG2_Out_data_format_RMW \
    THCON_SEC0_REG2_Out_data_format_ADDR32, THCON_SEC0_REG2_Out_data_format_SHAMT, THCON_SEC0_REG2_Out_data_format_MASK

#define THCON_SEC0_REG2_Throttle_mode_ADDR32 72
#define THCON_SEC0_REG2_Throttle_mode_SHAMT 4
#define THCON_SEC0_REG2_Throttle_mode_MASK 0x30
#define THCON_SEC0_REG2_Throttle_mode_RMW \
    THCON_SEC0_REG2_Throttle_mode_ADDR32, THCON_SEC0_REG2_Throttle_mode_SHAMT, THCON_SEC0_REG2_Throttle_mode_MASK

#define THCON_SEC0_REG2_Context_count_ADDR32 72
#define THCON_SEC0_REG2_Context_count_SHAMT 6
#define THCON_SEC0_REG2_Context_count_MASK 0xc0
#define THCON_SEC0_REG2_Context_count_RMW \
    THCON_SEC0_REG2_Context_count_ADDR32, THCON_SEC0_REG2_Context_count_SHAMT, THCON_SEC0_REG2_Context_count_MASK

#define THCON_SEC0_REG2_Haloize_mode_ADDR32 72
#define THCON_SEC0_REG2_Haloize_mode_SHAMT 8
#define THCON_SEC0_REG2_Haloize_mode_MASK 0x100
#define THCON_SEC0_REG2_Haloize_mode_RMW \
    THCON_SEC0_REG2_Haloize_mode_ADDR32, THCON_SEC0_REG2_Haloize_mode_SHAMT, THCON_SEC0_REG2_Haloize_mode_MASK

#define THCON_SEC0_REG2_Tileize_mode_ADDR32 72
#define THCON_SEC0_REG2_Tileize_mode_SHAMT 9
#define THCON_SEC0_REG2_Tileize_mode_MASK 0x200
#define THCON_SEC0_REG2_Tileize_mode_RMW \
    THCON_SEC0_REG2_Tileize_mode_ADDR32, THCON_SEC0_REG2_Tileize_mode_SHAMT, THCON_SEC0_REG2_Tileize_mode_MASK

#define THCON_SEC0_REG2_Unpack_Src_Reg_Set_Upd_ADDR32 72
#define THCON_SEC0_REG2_Unpack_Src_Reg_Set_Upd_SHAMT 10
#define THCON_SEC0_REG2_Unpack_Src_Reg_Set_Upd_MASK 0x400
#define THCON_SEC0_REG2_Unpack_Src_Reg_Set_Upd_RMW                                               \
    THCON_SEC0_REG2_Unpack_Src_Reg_Set_Upd_ADDR32, THCON_SEC0_REG2_Unpack_Src_Reg_Set_Upd_SHAMT, \
        THCON_SEC0_REG2_Unpack_Src_Reg_Set_Upd_MASK

#define THCON_SEC0_REG2_Unpack_If_Sel_ADDR32 72
#define THCON_SEC0_REG2_Unpack_If_Sel_SHAMT 11
#define THCON_SEC0_REG2_Unpack_If_Sel_MASK 0x800
#define THCON_SEC0_REG2_Unpack_If_Sel_RMW \
    THCON_SEC0_REG2_Unpack_If_Sel_ADDR32, THCON_SEC0_REG2_Unpack_If_Sel_SHAMT, THCON_SEC0_REG2_Unpack_If_Sel_MASK

#define THCON_SEC0_REG2_Upsample_rate_ADDR32 72
#define THCON_SEC0_REG2_Upsample_rate_SHAMT 12
#define THCON_SEC0_REG2_Upsample_rate_MASK 0x3000
#define THCON_SEC0_REG2_Upsample_rate_RMW \
    THCON_SEC0_REG2_Upsample_rate_ADDR32, THCON_SEC0_REG2_Upsample_rate_SHAMT, THCON_SEC0_REG2_Upsample_rate_MASK

#define THCON_SEC0_REG2_Ovrd_data_format_ADDR32 72
#define THCON_SEC0_REG2_Ovrd_data_format_SHAMT 14
#define THCON_SEC0_REG2_Ovrd_data_format_MASK 0x4000
#define THCON_SEC0_REG2_Ovrd_data_format_RMW                                         \
    THCON_SEC0_REG2_Ovrd_data_format_ADDR32, THCON_SEC0_REG2_Ovrd_data_format_SHAMT, \
        THCON_SEC0_REG2_Ovrd_data_format_MASK

#define THCON_SEC0_REG2_Upsample_and_interleave_ADDR32 72
#define THCON_SEC0_REG2_Upsample_and_interleave_SHAMT 15
#define THCON_SEC0_REG2_Upsample_and_interleave_MASK 0x8000
#define THCON_SEC0_REG2_Upsample_and_interleave_RMW                                                \
    THCON_SEC0_REG2_Upsample_and_interleave_ADDR32, THCON_SEC0_REG2_Upsample_and_interleave_SHAMT, \
        THCON_SEC0_REG2_Upsample_and_interleave_MASK

#define THCON_SEC0_REG2_Shift_amount_cntx0_ADDR32 72
#define THCON_SEC0_REG2_Shift_amount_cntx0_SHAMT 16
#define THCON_SEC0_REG2_Shift_amount_cntx0_MASK 0xf0000
#define THCON_SEC0_REG2_Shift_amount_cntx0_RMW                                           \
    THCON_SEC0_REG2_Shift_amount_cntx0_ADDR32, THCON_SEC0_REG2_Shift_amount_cntx0_SHAMT, \
        THCON_SEC0_REG2_Shift_amount_cntx0_MASK

#define THCON_SEC0_REG2_Shift_amount_cntx1_ADDR32 72
#define THCON_SEC0_REG2_Shift_amount_cntx1_SHAMT 20
#define THCON_SEC0_REG2_Shift_amount_cntx1_MASK 0xf00000
#define THCON_SEC0_REG2_Shift_amount_cntx1_RMW                                           \
    THCON_SEC0_REG2_Shift_amount_cntx1_ADDR32, THCON_SEC0_REG2_Shift_amount_cntx1_SHAMT, \
        THCON_SEC0_REG2_Shift_amount_cntx1_MASK

#define THCON_SEC0_REG2_Shift_amount_cntx2_ADDR32 72
#define THCON_SEC0_REG2_Shift_amount_cntx2_SHAMT 24
#define THCON_SEC0_REG2_Shift_amount_cntx2_MASK 0xf000000
#define THCON_SEC0_REG2_Shift_amount_cntx2_RMW                                           \
    THCON_SEC0_REG2_Shift_amount_cntx2_ADDR32, THCON_SEC0_REG2_Shift_amount_cntx2_SHAMT, \
        THCON_SEC0_REG2_Shift_amount_cntx2_MASK

#define THCON_SEC0_REG2_Shift_amount_cntx3_ADDR32 72
#define THCON_SEC0_REG2_Shift_amount_cntx3_SHAMT 28
#define THCON_SEC0_REG2_Shift_amount_cntx3_MASK 0xf0000000
#define THCON_SEC0_REG2_Shift_amount_cntx3_RMW                                           \
    THCON_SEC0_REG2_Shift_amount_cntx3_ADDR32, THCON_SEC0_REG2_Shift_amount_cntx3_SHAMT, \
        THCON_SEC0_REG2_Shift_amount_cntx3_MASK

#define THCON_SEC0_REG2_Disable_zero_compress_cntx0_ADDR32 73
#define THCON_SEC0_REG2_Disable_zero_compress_cntx0_SHAMT 0
#define THCON_SEC0_REG2_Disable_zero_compress_cntx0_MASK 0x1
#define THCON_SEC0_REG2_Disable_zero_compress_cntx0_RMW                                                    \
    THCON_SEC0_REG2_Disable_zero_compress_cntx0_ADDR32, THCON_SEC0_REG2_Disable_zero_compress_cntx0_SHAMT, \
        THCON_SEC0_REG2_Disable_zero_compress_cntx0_MASK

#define THCON_SEC0_REG2_Disable_zero_compress_cntx1_ADDR32 73
#define THCON_SEC0_REG2_Disable_zero_compress_cntx1_SHAMT 1
#define THCON_SEC0_REG2_Disable_zero_compress_cntx1_MASK 0x2
#define THCON_SEC0_REG2_Disable_zero_compress_cntx1_RMW                                                    \
    THCON_SEC0_REG2_Disable_zero_compress_cntx1_ADDR32, THCON_SEC0_REG2_Disable_zero_compress_cntx1_SHAMT, \
        THCON_SEC0_REG2_Disable_zero_compress_cntx1_MASK

#define THCON_SEC0_REG2_Disable_zero_compress_cntx2_ADDR32 73
#define THCON_SEC0_REG2_Disable_zero_compress_cntx2_SHAMT 2
#define THCON_SEC0_REG2_Disable_zero_compress_cntx2_MASK 0x4
#define THCON_SEC0_REG2_Disable_zero_compress_cntx2_RMW                                                    \
    THCON_SEC0_REG2_Disable_zero_compress_cntx2_ADDR32, THCON_SEC0_REG2_Disable_zero_compress_cntx2_SHAMT, \
        THCON_SEC0_REG2_Disable_zero_compress_cntx2_MASK

#define THCON_SEC0_REG2_Disable_zero_compress_cntx3_ADDR32 73
#define THCON_SEC0_REG2_Disable_zero_compress_cntx3_SHAMT 3
#define THCON_SEC0_REG2_Disable_zero_compress_cntx3_MASK 0x8
#define THCON_SEC0_REG2_Disable_zero_compress_cntx3_RMW                                                    \
    THCON_SEC0_REG2_Disable_zero_compress_cntx3_ADDR32, THCON_SEC0_REG2_Disable_zero_compress_cntx3_SHAMT, \
        THCON_SEC0_REG2_Disable_zero_compress_cntx3_MASK

#define THCON_SEC0_REG2_Unpack_if_sel_cntx0_ADDR32 73
#define THCON_SEC0_REG2_Unpack_if_sel_cntx0_SHAMT 4
#define THCON_SEC0_REG2_Unpack_if_sel_cntx0_MASK 0x10
#define THCON_SEC0_REG2_Unpack_if_sel_cntx0_RMW                                            \
    THCON_SEC0_REG2_Unpack_if_sel_cntx0_ADDR32, THCON_SEC0_REG2_Unpack_if_sel_cntx0_SHAMT, \
        THCON_SEC0_REG2_Unpack_if_sel_cntx0_MASK

#define THCON_SEC0_REG2_Unpack_if_sel_cntx1_ADDR32 73
#define THCON_SEC0_REG2_Unpack_if_sel_cntx1_SHAMT 5
#define THCON_SEC0_REG2_Unpack_if_sel_cntx1_MASK 0x20
#define THCON_SEC0_REG2_Unpack_if_sel_cntx1_RMW                                            \
    THCON_SEC0_REG2_Unpack_if_sel_cntx1_ADDR32, THCON_SEC0_REG2_Unpack_if_sel_cntx1_SHAMT, \
        THCON_SEC0_REG2_Unpack_if_sel_cntx1_MASK

#define THCON_SEC0_REG2_Unpack_if_sel_cntx2_ADDR32 73
#define THCON_SEC0_REG2_Unpack_if_sel_cntx2_SHAMT 6
#define THCON_SEC0_REG2_Unpack_if_sel_cntx2_MASK 0x40
#define THCON_SEC0_REG2_Unpack_if_sel_cntx2_RMW                                            \
    THCON_SEC0_REG2_Unpack_if_sel_cntx2_ADDR32, THCON_SEC0_REG2_Unpack_if_sel_cntx2_SHAMT, \
        THCON_SEC0_REG2_Unpack_if_sel_cntx2_MASK

#define THCON_SEC0_REG2_Unpack_if_sel_cntx3_ADDR32 73
#define THCON_SEC0_REG2_Unpack_if_sel_cntx3_SHAMT 7
#define THCON_SEC0_REG2_Unpack_if_sel_cntx3_MASK 0x80
#define THCON_SEC0_REG2_Unpack_if_sel_cntx3_RMW                                            \
    THCON_SEC0_REG2_Unpack_if_sel_cntx3_ADDR32, THCON_SEC0_REG2_Unpack_if_sel_cntx3_SHAMT, \
        THCON_SEC0_REG2_Unpack_if_sel_cntx3_MASK

#define THCON_SEC0_REG2_Force_shared_exp_ADDR32 73
#define THCON_SEC0_REG2_Force_shared_exp_SHAMT 8
#define THCON_SEC0_REG2_Force_shared_exp_MASK 0x100
#define THCON_SEC0_REG2_Force_shared_exp_RMW                                         \
    THCON_SEC0_REG2_Force_shared_exp_ADDR32, THCON_SEC0_REG2_Force_shared_exp_SHAMT, \
        THCON_SEC0_REG2_Force_shared_exp_MASK

#define THCON_SEC0_REG2_Context_count_non_log2_ADDR32 73
#define THCON_SEC0_REG2_Context_count_non_log2_SHAMT 9
#define THCON_SEC0_REG2_Context_count_non_log2_MASK 0xe00
#define THCON_SEC0_REG2_Context_count_non_log2_RMW                                               \
    THCON_SEC0_REG2_Context_count_non_log2_ADDR32, THCON_SEC0_REG2_Context_count_non_log2_SHAMT, \
        THCON_SEC0_REG2_Context_count_non_log2_MASK

#define THCON_SEC0_REG2_Context_count_non_log2_en_ADDR32 73
#define THCON_SEC0_REG2_Context_count_non_log2_en_SHAMT 12
#define THCON_SEC0_REG2_Context_count_non_log2_en_MASK 0x1000
#define THCON_SEC0_REG2_Context_count_non_log2_en_RMW                                                  \
    THCON_SEC0_REG2_Context_count_non_log2_en_ADDR32, THCON_SEC0_REG2_Context_count_non_log2_en_SHAMT, \
        THCON_SEC0_REG2_Context_count_non_log2_en_MASK

#define THCON_SEC0_REG2_Disable_zero_compress_cntx4_ADDR32 73
#define THCON_SEC0_REG2_Disable_zero_compress_cntx4_SHAMT 16
#define THCON_SEC0_REG2_Disable_zero_compress_cntx4_MASK 0x10000
#define THCON_SEC0_REG2_Disable_zero_compress_cntx4_RMW                                                    \
    THCON_SEC0_REG2_Disable_zero_compress_cntx4_ADDR32, THCON_SEC0_REG2_Disable_zero_compress_cntx4_SHAMT, \
        THCON_SEC0_REG2_Disable_zero_compress_cntx4_MASK

#define THCON_SEC0_REG2_Disable_zero_compress_cntx5_ADDR32 73
#define THCON_SEC0_REG2_Disable_zero_compress_cntx5_SHAMT 17
#define THCON_SEC0_REG2_Disable_zero_compress_cntx5_MASK 0x20000
#define THCON_SEC0_REG2_Disable_zero_compress_cntx5_RMW                                                    \
    THCON_SEC0_REG2_Disable_zero_compress_cntx5_ADDR32, THCON_SEC0_REG2_Disable_zero_compress_cntx5_SHAMT, \
        THCON_SEC0_REG2_Disable_zero_compress_cntx5_MASK

#define THCON_SEC0_REG2_Disable_zero_compress_cntx6_ADDR32 73
#define THCON_SEC0_REG2_Disable_zero_compress_cntx6_SHAMT 18
#define THCON_SEC0_REG2_Disable_zero_compress_cntx6_MASK 0x40000
#define THCON_SEC0_REG2_Disable_zero_compress_cntx6_RMW                                                    \
    THCON_SEC0_REG2_Disable_zero_compress_cntx6_ADDR32, THCON_SEC0_REG2_Disable_zero_compress_cntx6_SHAMT, \
        THCON_SEC0_REG2_Disable_zero_compress_cntx6_MASK

#define THCON_SEC0_REG2_Disable_zero_compress_cntx7_ADDR32 73
#define THCON_SEC0_REG2_Disable_zero_compress_cntx7_SHAMT 19
#define THCON_SEC0_REG2_Disable_zero_compress_cntx7_MASK 0x80000
#define THCON_SEC0_REG2_Disable_zero_compress_cntx7_RMW                                                    \
    THCON_SEC0_REG2_Disable_zero_compress_cntx7_ADDR32, THCON_SEC0_REG2_Disable_zero_compress_cntx7_SHAMT, \
        THCON_SEC0_REG2_Disable_zero_compress_cntx7_MASK

#define THCON_SEC0_REG2_Unpack_if_sel_cntx4_ADDR32 73
#define THCON_SEC0_REG2_Unpack_if_sel_cntx4_SHAMT 20
#define THCON_SEC0_REG2_Unpack_if_sel_cntx4_MASK 0x100000
#define THCON_SEC0_REG2_Unpack_if_sel_cntx4_RMW                                            \
    THCON_SEC0_REG2_Unpack_if_sel_cntx4_ADDR32, THCON_SEC0_REG2_Unpack_if_sel_cntx4_SHAMT, \
        THCON_SEC0_REG2_Unpack_if_sel_cntx4_MASK

#define THCON_SEC0_REG2_Unpack_if_sel_cntx5_ADDR32 73
#define THCON_SEC0_REG2_Unpack_if_sel_cntx5_SHAMT 21
#define THCON_SEC0_REG2_Unpack_if_sel_cntx5_MASK 0x200000
#define THCON_SEC0_REG2_Unpack_if_sel_cntx5_RMW                                            \
    THCON_SEC0_REG2_Unpack_if_sel_cntx5_ADDR32, THCON_SEC0_REG2_Unpack_if_sel_cntx5_SHAMT, \
        THCON_SEC0_REG2_Unpack_if_sel_cntx5_MASK

#define THCON_SEC0_REG2_Unpack_if_sel_cntx6_ADDR32 73
#define THCON_SEC0_REG2_Unpack_if_sel_cntx6_SHAMT 22
#define THCON_SEC0_REG2_Unpack_if_sel_cntx6_MASK 0x400000
#define THCON_SEC0_REG2_Unpack_if_sel_cntx6_RMW                                            \
    THCON_SEC0_REG2_Unpack_if_sel_cntx6_ADDR32, THCON_SEC0_REG2_Unpack_if_sel_cntx6_SHAMT, \
        THCON_SEC0_REG2_Unpack_if_sel_cntx6_MASK

#define THCON_SEC0_REG2_Unpack_if_sel_cntx7_ADDR32 73
#define THCON_SEC0_REG2_Unpack_if_sel_cntx7_SHAMT 23
#define THCON_SEC0_REG2_Unpack_if_sel_cntx7_MASK 0x800000
#define THCON_SEC0_REG2_Unpack_if_sel_cntx7_RMW                                            \
    THCON_SEC0_REG2_Unpack_if_sel_cntx7_ADDR32, THCON_SEC0_REG2_Unpack_if_sel_cntx7_SHAMT, \
        THCON_SEC0_REG2_Unpack_if_sel_cntx7_MASK

#define THCON_SEC0_REG2_Metadata_x_end_ADDR32 73
#define THCON_SEC0_REG2_Metadata_x_end_SHAMT 24
#define THCON_SEC0_REG2_Metadata_x_end_MASK 0xff000000
#define THCON_SEC0_REG2_Metadata_x_end_RMW \
    THCON_SEC0_REG2_Metadata_x_end_ADDR32, THCON_SEC0_REG2_Metadata_x_end_SHAMT, THCON_SEC0_REG2_Metadata_x_end_MASK

#define THCON_SEC0_REG2_Unpack_limit_address_ADDR32 74
#define THCON_SEC0_REG2_Unpack_limit_address_SHAMT 0
#define THCON_SEC0_REG2_Unpack_limit_address_MASK 0x1ffff
#define THCON_SEC0_REG2_Unpack_limit_address_RMW                                             \
    THCON_SEC0_REG2_Unpack_limit_address_ADDR32, THCON_SEC0_REG2_Unpack_limit_address_SHAMT, \
        THCON_SEC0_REG2_Unpack_limit_address_MASK

#define THCON_SEC0_REG2_Unpack_fifo_size_ADDR32 75
#define THCON_SEC0_REG2_Unpack_fifo_size_SHAMT 0
#define THCON_SEC0_REG2_Unpack_fifo_size_MASK 0x1ffff
#define THCON_SEC0_REG2_Unpack_fifo_size_RMW                                         \
    THCON_SEC0_REG2_Unpack_fifo_size_ADDR32, THCON_SEC0_REG2_Unpack_fifo_size_SHAMT, \
        THCON_SEC0_REG2_Unpack_fifo_size_MASK

#define THCON_SEC0_REG3_Base_address_ADDR32 76
#define THCON_SEC0_REG3_Base_address_SHAMT 0
#define THCON_SEC0_REG3_Base_address_MASK 0xffffffff
#define THCON_SEC0_REG3_Base_address_RMW \
    THCON_SEC0_REG3_Base_address_ADDR32, THCON_SEC0_REG3_Base_address_SHAMT, THCON_SEC0_REG3_Base_address_MASK

#define THCON_SEC0_REG3_Base_cntx1_address_ADDR32 77
#define THCON_SEC0_REG3_Base_cntx1_address_SHAMT 0
#define THCON_SEC0_REG3_Base_cntx1_address_MASK 0xffffffff
#define THCON_SEC0_REG3_Base_cntx1_address_RMW                                           \
    THCON_SEC0_REG3_Base_cntx1_address_ADDR32, THCON_SEC0_REG3_Base_cntx1_address_SHAMT, \
        THCON_SEC0_REG3_Base_cntx1_address_MASK

#define THCON_SEC0_REG3_Base_cntx2_address_ADDR32 78
#define THCON_SEC0_REG3_Base_cntx2_address_SHAMT 0
#define THCON_SEC0_REG3_Base_cntx2_address_MASK 0xffffffff
#define THCON_SEC0_REG3_Base_cntx2_address_RMW                                           \
    THCON_SEC0_REG3_Base_cntx2_address_ADDR32, THCON_SEC0_REG3_Base_cntx2_address_SHAMT, \
        THCON_SEC0_REG3_Base_cntx2_address_MASK

#define THCON_SEC0_REG3_Base_cntx3_address_ADDR32 79
#define THCON_SEC0_REG3_Base_cntx3_address_SHAMT 0
#define THCON_SEC0_REG3_Base_cntx3_address_MASK 0xffffffff
#define THCON_SEC0_REG3_Base_cntx3_address_RMW                                           \
    THCON_SEC0_REG3_Base_cntx3_address_ADDR32, THCON_SEC0_REG3_Base_cntx3_address_SHAMT, \
        THCON_SEC0_REG3_Base_cntx3_address_MASK

#define THCON_SEC0_REG4_Base_cntx4_address_ADDR32 80
#define THCON_SEC0_REG4_Base_cntx4_address_SHAMT 0
#define THCON_SEC0_REG4_Base_cntx4_address_MASK 0xffffffff
#define THCON_SEC0_REG4_Base_cntx4_address_RMW                                           \
    THCON_SEC0_REG4_Base_cntx4_address_ADDR32, THCON_SEC0_REG4_Base_cntx4_address_SHAMT, \
        THCON_SEC0_REG4_Base_cntx4_address_MASK

#define THCON_SEC0_REG4_Base_cntx5_address_ADDR32 81
#define THCON_SEC0_REG4_Base_cntx5_address_SHAMT 0
#define THCON_SEC0_REG4_Base_cntx5_address_MASK 0xffffffff
#define THCON_SEC0_REG4_Base_cntx5_address_RMW                                           \
    THCON_SEC0_REG4_Base_cntx5_address_ADDR32, THCON_SEC0_REG4_Base_cntx5_address_SHAMT, \
        THCON_SEC0_REG4_Base_cntx5_address_MASK

#define THCON_SEC0_REG4_Base_cntx6_address_ADDR32 82
#define THCON_SEC0_REG4_Base_cntx6_address_SHAMT 0
#define THCON_SEC0_REG4_Base_cntx6_address_MASK 0xffffffff
#define THCON_SEC0_REG4_Base_cntx6_address_RMW                                           \
    THCON_SEC0_REG4_Base_cntx6_address_ADDR32, THCON_SEC0_REG4_Base_cntx6_address_SHAMT, \
        THCON_SEC0_REG4_Base_cntx6_address_MASK

#define THCON_SEC0_REG4_Base_cntx7_address_ADDR32 83
#define THCON_SEC0_REG4_Base_cntx7_address_SHAMT 0
#define THCON_SEC0_REG4_Base_cntx7_address_MASK 0xffffffff
#define THCON_SEC0_REG4_Base_cntx7_address_RMW                                           \
    THCON_SEC0_REG4_Base_cntx7_address_ADDR32, THCON_SEC0_REG4_Base_cntx7_address_SHAMT, \
        THCON_SEC0_REG4_Base_cntx7_address_MASK

#define THCON_SEC0_REG5_Dest_cntx0_address_ADDR32 84
#define THCON_SEC0_REG5_Dest_cntx0_address_SHAMT 0
#define THCON_SEC0_REG5_Dest_cntx0_address_MASK 0xffff
#define THCON_SEC0_REG5_Dest_cntx0_address_RMW                                           \
    THCON_SEC0_REG5_Dest_cntx0_address_ADDR32, THCON_SEC0_REG5_Dest_cntx0_address_SHAMT, \
        THCON_SEC0_REG5_Dest_cntx0_address_MASK

#define THCON_SEC0_REG5_Dest_cntx1_address_ADDR32 84
#define THCON_SEC0_REG5_Dest_cntx1_address_SHAMT 16
#define THCON_SEC0_REG5_Dest_cntx1_address_MASK 0xffff0000
#define THCON_SEC0_REG5_Dest_cntx1_address_RMW                                           \
    THCON_SEC0_REG5_Dest_cntx1_address_ADDR32, THCON_SEC0_REG5_Dest_cntx1_address_SHAMT, \
        THCON_SEC0_REG5_Dest_cntx1_address_MASK

#define THCON_SEC0_REG5_Dest_cntx2_address_ADDR32 85
#define THCON_SEC0_REG5_Dest_cntx2_address_SHAMT 0
#define THCON_SEC0_REG5_Dest_cntx2_address_MASK 0xffff
#define THCON_SEC0_REG5_Dest_cntx2_address_RMW                                           \
    THCON_SEC0_REG5_Dest_cntx2_address_ADDR32, THCON_SEC0_REG5_Dest_cntx2_address_SHAMT, \
        THCON_SEC0_REG5_Dest_cntx2_address_MASK

#define THCON_SEC0_REG5_Dest_cntx3_address_ADDR32 85
#define THCON_SEC0_REG5_Dest_cntx3_address_SHAMT 16
#define THCON_SEC0_REG5_Dest_cntx3_address_MASK 0xffff0000
#define THCON_SEC0_REG5_Dest_cntx3_address_RMW                                           \
    THCON_SEC0_REG5_Dest_cntx3_address_ADDR32, THCON_SEC0_REG5_Dest_cntx3_address_SHAMT, \
        THCON_SEC0_REG5_Dest_cntx3_address_MASK

#define THCON_SEC0_REG5_Tile_x_dim_cntx0_ADDR32 86
#define THCON_SEC0_REG5_Tile_x_dim_cntx0_SHAMT 0
#define THCON_SEC0_REG5_Tile_x_dim_cntx0_MASK 0xffff
#define THCON_SEC0_REG5_Tile_x_dim_cntx0_RMW                                         \
    THCON_SEC0_REG5_Tile_x_dim_cntx0_ADDR32, THCON_SEC0_REG5_Tile_x_dim_cntx0_SHAMT, \
        THCON_SEC0_REG5_Tile_x_dim_cntx0_MASK

#define THCON_SEC0_REG5_Tile_x_dim_cntx1_ADDR32 86
#define THCON_SEC0_REG5_Tile_x_dim_cntx1_SHAMT 16
#define THCON_SEC0_REG5_Tile_x_dim_cntx1_MASK 0xffff0000
#define THCON_SEC0_REG5_Tile_x_dim_cntx1_RMW                                         \
    THCON_SEC0_REG5_Tile_x_dim_cntx1_ADDR32, THCON_SEC0_REG5_Tile_x_dim_cntx1_SHAMT, \
        THCON_SEC0_REG5_Tile_x_dim_cntx1_MASK

#define THCON_SEC0_REG5_Tile_x_dim_cntx2_ADDR32 87
#define THCON_SEC0_REG5_Tile_x_dim_cntx2_SHAMT 0
#define THCON_SEC0_REG5_Tile_x_dim_cntx2_MASK 0xffff
#define THCON_SEC0_REG5_Tile_x_dim_cntx2_RMW                                         \
    THCON_SEC0_REG5_Tile_x_dim_cntx2_ADDR32, THCON_SEC0_REG5_Tile_x_dim_cntx2_SHAMT, \
        THCON_SEC0_REG5_Tile_x_dim_cntx2_MASK

#define THCON_SEC0_REG5_Tile_x_dim_cntx3_ADDR32 87
#define THCON_SEC0_REG5_Tile_x_dim_cntx3_SHAMT 16
#define THCON_SEC0_REG5_Tile_x_dim_cntx3_MASK 0xffff0000
#define THCON_SEC0_REG5_Tile_x_dim_cntx3_RMW                                         \
    THCON_SEC0_REG5_Tile_x_dim_cntx3_ADDR32, THCON_SEC0_REG5_Tile_x_dim_cntx3_SHAMT, \
        THCON_SEC0_REG5_Tile_x_dim_cntx3_MASK

#define THCON_SEC0_REG6_Source_address_ADDR32 88
#define THCON_SEC0_REG6_Source_address_SHAMT 0
#define THCON_SEC0_REG6_Source_address_MASK 0xffffffff
#define THCON_SEC0_REG6_Source_address_RMW \
    THCON_SEC0_REG6_Source_address_ADDR32, THCON_SEC0_REG6_Source_address_SHAMT, THCON_SEC0_REG6_Source_address_MASK

#define THCON_SEC0_REG6_Destination_address_ADDR32 89
#define THCON_SEC0_REG6_Destination_address_SHAMT 0
#define THCON_SEC0_REG6_Destination_address_MASK 0xffffffff
#define THCON_SEC0_REG6_Destination_address_RMW                                            \
    THCON_SEC0_REG6_Destination_address_ADDR32, THCON_SEC0_REG6_Destination_address_SHAMT, \
        THCON_SEC0_REG6_Destination_address_MASK

#define THCON_SEC0_REG6_Buffer_size_ADDR32 90
#define THCON_SEC0_REG6_Buffer_size_SHAMT 0
#define THCON_SEC0_REG6_Buffer_size_MASK 0x3fffffff
#define THCON_SEC0_REG6_Buffer_size_RMW \
    THCON_SEC0_REG6_Buffer_size_ADDR32, THCON_SEC0_REG6_Buffer_size_SHAMT, THCON_SEC0_REG6_Buffer_size_MASK

#define THCON_SEC0_REG6_Transfer_direction_ADDR32 90
#define THCON_SEC0_REG6_Transfer_direction_SHAMT 30
#define THCON_SEC0_REG6_Transfer_direction_MASK 0xc0000000
#define THCON_SEC0_REG6_Transfer_direction_RMW                                           \
    THCON_SEC0_REG6_Transfer_direction_ADDR32, THCON_SEC0_REG6_Transfer_direction_SHAMT, \
        THCON_SEC0_REG6_Transfer_direction_MASK

#define THCON_SEC0_REG6_Metadata_misc_ADDR32 91
#define THCON_SEC0_REG6_Metadata_misc_SHAMT 0
#define THCON_SEC0_REG6_Metadata_misc_MASK 0xffffffff
#define THCON_SEC0_REG6_Metadata_misc_RMW \
    THCON_SEC0_REG6_Metadata_misc_ADDR32, THCON_SEC0_REG6_Metadata_misc_SHAMT, THCON_SEC0_REG6_Metadata_misc_MASK

#define THCON_SEC0_REG7_Offset_address_ADDR32 92
#define THCON_SEC0_REG7_Offset_address_SHAMT 0
#define THCON_SEC0_REG7_Offset_address_MASK 0xffff
#define THCON_SEC0_REG7_Offset_address_RMW \
    THCON_SEC0_REG7_Offset_address_ADDR32, THCON_SEC0_REG7_Offset_address_SHAMT, THCON_SEC0_REG7_Offset_address_MASK

#define THCON_SEC0_REG7_Unpack_data_format_cntx0_ADDR32 92
#define THCON_SEC0_REG7_Unpack_data_format_cntx0_SHAMT 16
#define THCON_SEC0_REG7_Unpack_data_format_cntx0_MASK 0xf0000
#define THCON_SEC0_REG7_Unpack_data_format_cntx0_RMW                                                 \
    THCON_SEC0_REG7_Unpack_data_format_cntx0_ADDR32, THCON_SEC0_REG7_Unpack_data_format_cntx0_SHAMT, \
        THCON_SEC0_REG7_Unpack_data_format_cntx0_MASK

#define THCON_SEC0_REG7_Unpack_out_data_format_cntx0_ADDR32 92
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx0_SHAMT 20
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx0_MASK 0xf00000
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx0_RMW                                                     \
    THCON_SEC0_REG7_Unpack_out_data_format_cntx0_ADDR32, THCON_SEC0_REG7_Unpack_out_data_format_cntx0_SHAMT, \
        THCON_SEC0_REG7_Unpack_out_data_format_cntx0_MASK

#define THCON_SEC0_REG7_Unpack_data_format_cntx4_ADDR32 92
#define THCON_SEC0_REG7_Unpack_data_format_cntx4_SHAMT 24
#define THCON_SEC0_REG7_Unpack_data_format_cntx4_MASK 0xf000000
#define THCON_SEC0_REG7_Unpack_data_format_cntx4_RMW                                                 \
    THCON_SEC0_REG7_Unpack_data_format_cntx4_ADDR32, THCON_SEC0_REG7_Unpack_data_format_cntx4_SHAMT, \
        THCON_SEC0_REG7_Unpack_data_format_cntx4_MASK

#define THCON_SEC0_REG7_Unpack_out_data_format_cntx4_ADDR32 92
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx4_SHAMT 28
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx4_MASK 0xf0000000
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx4_RMW                                                     \
    THCON_SEC0_REG7_Unpack_out_data_format_cntx4_ADDR32, THCON_SEC0_REG7_Unpack_out_data_format_cntx4_SHAMT, \
        THCON_SEC0_REG7_Unpack_out_data_format_cntx4_MASK

#define THCON_SEC0_REG7_Offset_cntx1_address_ADDR32 93
#define THCON_SEC0_REG7_Offset_cntx1_address_SHAMT 0
#define THCON_SEC0_REG7_Offset_cntx1_address_MASK 0xffff
#define THCON_SEC0_REG7_Offset_cntx1_address_RMW                                             \
    THCON_SEC0_REG7_Offset_cntx1_address_ADDR32, THCON_SEC0_REG7_Offset_cntx1_address_SHAMT, \
        THCON_SEC0_REG7_Offset_cntx1_address_MASK

#define THCON_SEC0_REG7_Unpack_data_format_cntx1_ADDR32 93
#define THCON_SEC0_REG7_Unpack_data_format_cntx1_SHAMT 16
#define THCON_SEC0_REG7_Unpack_data_format_cntx1_MASK 0xf0000
#define THCON_SEC0_REG7_Unpack_data_format_cntx1_RMW                                                 \
    THCON_SEC0_REG7_Unpack_data_format_cntx1_ADDR32, THCON_SEC0_REG7_Unpack_data_format_cntx1_SHAMT, \
        THCON_SEC0_REG7_Unpack_data_format_cntx1_MASK

#define THCON_SEC0_REG7_Unpack_out_data_format_cntx1_ADDR32 93
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx1_SHAMT 20
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx1_MASK 0xf00000
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx1_RMW                                                     \
    THCON_SEC0_REG7_Unpack_out_data_format_cntx1_ADDR32, THCON_SEC0_REG7_Unpack_out_data_format_cntx1_SHAMT, \
        THCON_SEC0_REG7_Unpack_out_data_format_cntx1_MASK

#define THCON_SEC0_REG7_Unpack_data_format_cntx5_ADDR32 93
#define THCON_SEC0_REG7_Unpack_data_format_cntx5_SHAMT 24
#define THCON_SEC0_REG7_Unpack_data_format_cntx5_MASK 0xf000000
#define THCON_SEC0_REG7_Unpack_data_format_cntx5_RMW                                                 \
    THCON_SEC0_REG7_Unpack_data_format_cntx5_ADDR32, THCON_SEC0_REG7_Unpack_data_format_cntx5_SHAMT, \
        THCON_SEC0_REG7_Unpack_data_format_cntx5_MASK

#define THCON_SEC0_REG7_Unpack_out_data_format_cntx5_ADDR32 93
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx5_SHAMT 28
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx5_MASK 0xf0000000
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx5_RMW                                                     \
    THCON_SEC0_REG7_Unpack_out_data_format_cntx5_ADDR32, THCON_SEC0_REG7_Unpack_out_data_format_cntx5_SHAMT, \
        THCON_SEC0_REG7_Unpack_out_data_format_cntx5_MASK

#define THCON_SEC0_REG7_Offset_cntx2_address_ADDR32 94
#define THCON_SEC0_REG7_Offset_cntx2_address_SHAMT 0
#define THCON_SEC0_REG7_Offset_cntx2_address_MASK 0xffff
#define THCON_SEC0_REG7_Offset_cntx2_address_RMW                                             \
    THCON_SEC0_REG7_Offset_cntx2_address_ADDR32, THCON_SEC0_REG7_Offset_cntx2_address_SHAMT, \
        THCON_SEC0_REG7_Offset_cntx2_address_MASK

#define THCON_SEC0_REG7_Unpack_data_format_cntx2_ADDR32 94
#define THCON_SEC0_REG7_Unpack_data_format_cntx2_SHAMT 16
#define THCON_SEC0_REG7_Unpack_data_format_cntx2_MASK 0xf0000
#define THCON_SEC0_REG7_Unpack_data_format_cntx2_RMW                                                 \
    THCON_SEC0_REG7_Unpack_data_format_cntx2_ADDR32, THCON_SEC0_REG7_Unpack_data_format_cntx2_SHAMT, \
        THCON_SEC0_REG7_Unpack_data_format_cntx2_MASK

#define THCON_SEC0_REG7_Unpack_out_data_format_cntx2_ADDR32 94
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx2_SHAMT 20
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx2_MASK 0xf00000
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx2_RMW                                                     \
    THCON_SEC0_REG7_Unpack_out_data_format_cntx2_ADDR32, THCON_SEC0_REG7_Unpack_out_data_format_cntx2_SHAMT, \
        THCON_SEC0_REG7_Unpack_out_data_format_cntx2_MASK

#define THCON_SEC0_REG7_Unpack_data_format_cntx6_ADDR32 94
#define THCON_SEC0_REG7_Unpack_data_format_cntx6_SHAMT 24
#define THCON_SEC0_REG7_Unpack_data_format_cntx6_MASK 0xf000000
#define THCON_SEC0_REG7_Unpack_data_format_cntx6_RMW                                                 \
    THCON_SEC0_REG7_Unpack_data_format_cntx6_ADDR32, THCON_SEC0_REG7_Unpack_data_format_cntx6_SHAMT, \
        THCON_SEC0_REG7_Unpack_data_format_cntx6_MASK

#define THCON_SEC0_REG7_Unpack_out_data_format_cntx6_ADDR32 94
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx6_SHAMT 28
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx6_MASK 0xf0000000
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx6_RMW                                                     \
    THCON_SEC0_REG7_Unpack_out_data_format_cntx6_ADDR32, THCON_SEC0_REG7_Unpack_out_data_format_cntx6_SHAMT, \
        THCON_SEC0_REG7_Unpack_out_data_format_cntx6_MASK

#define THCON_SEC0_REG7_Offset_cntx3_address_ADDR32 95
#define THCON_SEC0_REG7_Offset_cntx3_address_SHAMT 0
#define THCON_SEC0_REG7_Offset_cntx3_address_MASK 0xffff
#define THCON_SEC0_REG7_Offset_cntx3_address_RMW                                             \
    THCON_SEC0_REG7_Offset_cntx3_address_ADDR32, THCON_SEC0_REG7_Offset_cntx3_address_SHAMT, \
        THCON_SEC0_REG7_Offset_cntx3_address_MASK

#define THCON_SEC0_REG7_Unpack_data_format_cntx3_ADDR32 95
#define THCON_SEC0_REG7_Unpack_data_format_cntx3_SHAMT 16
#define THCON_SEC0_REG7_Unpack_data_format_cntx3_MASK 0xf0000
#define THCON_SEC0_REG7_Unpack_data_format_cntx3_RMW                                                 \
    THCON_SEC0_REG7_Unpack_data_format_cntx3_ADDR32, THCON_SEC0_REG7_Unpack_data_format_cntx3_SHAMT, \
        THCON_SEC0_REG7_Unpack_data_format_cntx3_MASK

#define THCON_SEC0_REG7_Unpack_out_data_format_cntx3_ADDR32 95
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx3_SHAMT 20
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx3_MASK 0xf00000
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx3_RMW                                                     \
    THCON_SEC0_REG7_Unpack_out_data_format_cntx3_ADDR32, THCON_SEC0_REG7_Unpack_out_data_format_cntx3_SHAMT, \
        THCON_SEC0_REG7_Unpack_out_data_format_cntx3_MASK

#define THCON_SEC0_REG7_Unpack_data_format_cntx7_ADDR32 95
#define THCON_SEC0_REG7_Unpack_data_format_cntx7_SHAMT 24
#define THCON_SEC0_REG7_Unpack_data_format_cntx7_MASK 0xf000000
#define THCON_SEC0_REG7_Unpack_data_format_cntx7_RMW                                                 \
    THCON_SEC0_REG7_Unpack_data_format_cntx7_ADDR32, THCON_SEC0_REG7_Unpack_data_format_cntx7_SHAMT, \
        THCON_SEC0_REG7_Unpack_data_format_cntx7_MASK

#define THCON_SEC0_REG7_Unpack_out_data_format_cntx7_ADDR32 95
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx7_SHAMT 28
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx7_MASK 0xf0000000
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx7_RMW                                                     \
    THCON_SEC0_REG7_Unpack_out_data_format_cntx7_ADDR32, THCON_SEC0_REG7_Unpack_out_data_format_cntx7_SHAMT, \
        THCON_SEC0_REG7_Unpack_out_data_format_cntx7_MASK

#define THCON_SEC0_REG8_Row_start_section_size_ADDR32 96
#define THCON_SEC0_REG8_Row_start_section_size_SHAMT 0
#define THCON_SEC0_REG8_Row_start_section_size_MASK 0xffff
#define THCON_SEC0_REG8_Row_start_section_size_RMW                                               \
    THCON_SEC0_REG8_Row_start_section_size_ADDR32, THCON_SEC0_REG8_Row_start_section_size_SHAMT, \
        THCON_SEC0_REG8_Row_start_section_size_MASK

#define THCON_SEC0_REG8_Exp_section_size_ADDR32 96
#define THCON_SEC0_REG8_Exp_section_size_SHAMT 16
#define THCON_SEC0_REG8_Exp_section_size_MASK 0xffff0000
#define THCON_SEC0_REG8_Exp_section_size_RMW                                         \
    THCON_SEC0_REG8_Exp_section_size_ADDR32, THCON_SEC0_REG8_Exp_section_size_SHAMT, \
        THCON_SEC0_REG8_Exp_section_size_MASK

#define THCON_SEC0_REG8_L1_Dest_addr_ADDR32 97
#define THCON_SEC0_REG8_L1_Dest_addr_SHAMT 0
#define THCON_SEC0_REG8_L1_Dest_addr_MASK 0xffffffff
#define THCON_SEC0_REG8_L1_Dest_addr_RMW \
    THCON_SEC0_REG8_L1_Dest_addr_ADDR32, THCON_SEC0_REG8_L1_Dest_addr_SHAMT, THCON_SEC0_REG8_L1_Dest_addr_MASK

#define THCON_SEC0_REG8_Disable_zero_compress_ADDR32 98
#define THCON_SEC0_REG8_Disable_zero_compress_SHAMT 0
#define THCON_SEC0_REG8_Disable_zero_compress_MASK 0x1
#define THCON_SEC0_REG8_Disable_zero_compress_RMW                                              \
    THCON_SEC0_REG8_Disable_zero_compress_ADDR32, THCON_SEC0_REG8_Disable_zero_compress_SHAMT, \
        THCON_SEC0_REG8_Disable_zero_compress_MASK

#define THCON_SEC0_REG8_Add_l1_dest_addr_offset_ADDR32 98
#define THCON_SEC0_REG8_Add_l1_dest_addr_offset_SHAMT 1
#define THCON_SEC0_REG8_Add_l1_dest_addr_offset_MASK 0x2
#define THCON_SEC0_REG8_Add_l1_dest_addr_offset_RMW                                                \
    THCON_SEC0_REG8_Add_l1_dest_addr_offset_ADDR32, THCON_SEC0_REG8_Add_l1_dest_addr_offset_SHAMT, \
        THCON_SEC0_REG8_Add_l1_dest_addr_offset_MASK

#define THCON_SEC0_REG8_Disable_pack_zero_flags_ADDR32 98
#define THCON_SEC0_REG8_Disable_pack_zero_flags_SHAMT 2
#define THCON_SEC0_REG8_Disable_pack_zero_flags_MASK 0x4
#define THCON_SEC0_REG8_Disable_pack_zero_flags_RMW                                                \
    THCON_SEC0_REG8_Disable_pack_zero_flags_ADDR32, THCON_SEC0_REG8_Disable_pack_zero_flags_SHAMT, \
        THCON_SEC0_REG8_Disable_pack_zero_flags_MASK

#define THCON_SEC0_REG8_Unused1_ADDR32 98
#define THCON_SEC0_REG8_Unused1_SHAMT 3
#define THCON_SEC0_REG8_Unused1_MASK 0x8
#define THCON_SEC0_REG8_Unused1_RMW \
    THCON_SEC0_REG8_Unused1_ADDR32, THCON_SEC0_REG8_Unused1_SHAMT, THCON_SEC0_REG8_Unused1_MASK

#define THCON_SEC0_REG8_Out_data_format_ADDR32 98
#define THCON_SEC0_REG8_Out_data_format_SHAMT 4
#define THCON_SEC0_REG8_Out_data_format_MASK 0xf0
#define THCON_SEC0_REG8_Out_data_format_RMW \
    THCON_SEC0_REG8_Out_data_format_ADDR32, THCON_SEC0_REG8_Out_data_format_SHAMT, THCON_SEC0_REG8_Out_data_format_MASK

#define THCON_SEC0_REG8_In_data_format_ADDR32 98
#define THCON_SEC0_REG8_In_data_format_SHAMT 8
#define THCON_SEC0_REG8_In_data_format_MASK 0xf00
#define THCON_SEC0_REG8_In_data_format_RMW \
    THCON_SEC0_REG8_In_data_format_ADDR32, THCON_SEC0_REG8_In_data_format_SHAMT, THCON_SEC0_REG8_In_data_format_MASK

#define THCON_SEC0_REG8_Dis_shared_exp_assembler_ADDR32 98
#define THCON_SEC0_REG8_Dis_shared_exp_assembler_SHAMT 12
#define THCON_SEC0_REG8_Dis_shared_exp_assembler_MASK 0x1000
#define THCON_SEC0_REG8_Dis_shared_exp_assembler_RMW                                                 \
    THCON_SEC0_REG8_Dis_shared_exp_assembler_ADDR32, THCON_SEC0_REG8_Dis_shared_exp_assembler_SHAMT, \
        THCON_SEC0_REG8_Dis_shared_exp_assembler_MASK

#define THCON_SEC0_REG8_Auto_set_last_pacr_intf_sel_ADDR32 98
#define THCON_SEC0_REG8_Auto_set_last_pacr_intf_sel_SHAMT 13
#define THCON_SEC0_REG8_Auto_set_last_pacr_intf_sel_MASK 0x2000
#define THCON_SEC0_REG8_Auto_set_last_pacr_intf_sel_RMW                                                    \
    THCON_SEC0_REG8_Auto_set_last_pacr_intf_sel_ADDR32, THCON_SEC0_REG8_Auto_set_last_pacr_intf_sel_SHAMT, \
        THCON_SEC0_REG8_Auto_set_last_pacr_intf_sel_MASK

#define THCON_SEC0_REG8_Enable_out_fifo_ADDR32 98
#define THCON_SEC0_REG8_Enable_out_fifo_SHAMT 14
#define THCON_SEC0_REG8_Enable_out_fifo_MASK 0x4000
#define THCON_SEC0_REG8_Enable_out_fifo_RMW \
    THCON_SEC0_REG8_Enable_out_fifo_ADDR32, THCON_SEC0_REG8_Enable_out_fifo_SHAMT, THCON_SEC0_REG8_Enable_out_fifo_MASK

#define THCON_SEC0_REG8_Sub_l1_tile_header_size_ADDR32 98
#define THCON_SEC0_REG8_Sub_l1_tile_header_size_SHAMT 15
#define THCON_SEC0_REG8_Sub_l1_tile_header_size_MASK 0x8000
#define THCON_SEC0_REG8_Sub_l1_tile_header_size_RMW                                                \
    THCON_SEC0_REG8_Sub_l1_tile_header_size_ADDR32, THCON_SEC0_REG8_Sub_l1_tile_header_size_SHAMT, \
        THCON_SEC0_REG8_Sub_l1_tile_header_size_MASK

#define THCON_SEC0_REG8_Source_interface_selection_ADDR32 98
#define THCON_SEC0_REG8_Source_interface_selection_SHAMT 16
#define THCON_SEC0_REG8_Source_interface_selection_MASK 0x10000
#define THCON_SEC0_REG8_Source_interface_selection_RMW                                                   \
    THCON_SEC0_REG8_Source_interface_selection_ADDR32, THCON_SEC0_REG8_Source_interface_selection_SHAMT, \
        THCON_SEC0_REG8_Source_interface_selection_MASK

#define THCON_SEC0_REG8_Add_tile_header_size_ADDR32 98
#define THCON_SEC0_REG8_Add_tile_header_size_SHAMT 17
#define THCON_SEC0_REG8_Add_tile_header_size_MASK 0x20000
#define THCON_SEC0_REG8_Add_tile_header_size_RMW                                             \
    THCON_SEC0_REG8_Add_tile_header_size_ADDR32, THCON_SEC0_REG8_Add_tile_header_size_SHAMT, \
        THCON_SEC0_REG8_Add_tile_header_size_MASK

#define THCON_SEC0_REG8_pack_dis_y_pos_start_offset_ADDR32 98
#define THCON_SEC0_REG8_pack_dis_y_pos_start_offset_SHAMT 18
#define THCON_SEC0_REG8_pack_dis_y_pos_start_offset_MASK 0x40000
#define THCON_SEC0_REG8_pack_dis_y_pos_start_offset_RMW                                                    \
    THCON_SEC0_REG8_pack_dis_y_pos_start_offset_ADDR32, THCON_SEC0_REG8_pack_dis_y_pos_start_offset_SHAMT, \
        THCON_SEC0_REG8_pack_dis_y_pos_start_offset_MASK

#define THCON_SEC0_REG8_unpack_tile_offset_ADDR32 98
#define THCON_SEC0_REG8_unpack_tile_offset_SHAMT 19
#define THCON_SEC0_REG8_unpack_tile_offset_MASK 0xf80000
#define THCON_SEC0_REG8_unpack_tile_offset_RMW                                           \
    THCON_SEC0_REG8_unpack_tile_offset_ADDR32, THCON_SEC0_REG8_unpack_tile_offset_SHAMT, \
        THCON_SEC0_REG8_unpack_tile_offset_MASK

#define THCON_SEC0_REG8_L1_source_addr_ADDR32 98
#define THCON_SEC0_REG8_L1_source_addr_SHAMT 24
#define THCON_SEC0_REG8_L1_source_addr_MASK 0xff000000
#define THCON_SEC0_REG8_L1_source_addr_RMW \
    THCON_SEC0_REG8_L1_source_addr_ADDR32, THCON_SEC0_REG8_L1_source_addr_SHAMT, THCON_SEC0_REG8_L1_source_addr_MASK

#define THCON_SEC0_REG8_Downsample_mask_ADDR32 99
#define THCON_SEC0_REG8_Downsample_mask_SHAMT 0
#define THCON_SEC0_REG8_Downsample_mask_MASK 0xffff
#define THCON_SEC0_REG8_Downsample_mask_RMW \
    THCON_SEC0_REG8_Downsample_mask_ADDR32, THCON_SEC0_REG8_Downsample_mask_SHAMT, THCON_SEC0_REG8_Downsample_mask_MASK

#define THCON_SEC0_REG8_Downsample_rate_ADDR32 99
#define THCON_SEC0_REG8_Downsample_rate_SHAMT 16
#define THCON_SEC0_REG8_Downsample_rate_MASK 0x70000
#define THCON_SEC0_REG8_Downsample_rate_RMW \
    THCON_SEC0_REG8_Downsample_rate_ADDR32, THCON_SEC0_REG8_Downsample_rate_SHAMT, THCON_SEC0_REG8_Downsample_rate_MASK

#define THCON_SEC0_REG8_Pack_L1_Acc_ADDR32 99
#define THCON_SEC0_REG8_Pack_L1_Acc_SHAMT 19
#define THCON_SEC0_REG8_Pack_L1_Acc_MASK 0x80000
#define THCON_SEC0_REG8_Pack_L1_Acc_RMW \
    THCON_SEC0_REG8_Pack_L1_Acc_ADDR32, THCON_SEC0_REG8_Pack_L1_Acc_SHAMT, THCON_SEC0_REG8_Pack_L1_Acc_MASK

#define THCON_SEC0_REG8_Exp_threshold_en_ADDR32 99
#define THCON_SEC0_REG8_Exp_threshold_en_SHAMT 20
#define THCON_SEC0_REG8_Exp_threshold_en_MASK 0x100000
#define THCON_SEC0_REG8_Exp_threshold_en_RMW                                         \
    THCON_SEC0_REG8_Exp_threshold_en_ADDR32, THCON_SEC0_REG8_Exp_threshold_en_SHAMT, \
        THCON_SEC0_REG8_Exp_threshold_en_MASK

#define THCON_SEC0_REG8_Exp_threshold_ADDR32 99
#define THCON_SEC0_REG8_Exp_threshold_SHAMT 24
#define THCON_SEC0_REG8_Exp_threshold_MASK 0xff000000
#define THCON_SEC0_REG8_Exp_threshold_RMW \
    THCON_SEC0_REG8_Exp_threshold_ADDR32, THCON_SEC0_REG8_Exp_threshold_SHAMT, THCON_SEC0_REG8_Exp_threshold_MASK

#define THCON_SEC0_REG9_Pack_0_2_limit_address_ADDR32 100
#define THCON_SEC0_REG9_Pack_0_2_limit_address_SHAMT 0
#define THCON_SEC0_REG9_Pack_0_2_limit_address_MASK 0x1ffff
#define THCON_SEC0_REG9_Pack_0_2_limit_address_RMW                                               \
    THCON_SEC0_REG9_Pack_0_2_limit_address_ADDR32, THCON_SEC0_REG9_Pack_0_2_limit_address_SHAMT, \
        THCON_SEC0_REG9_Pack_0_2_limit_address_MASK

#define THCON_SEC0_REG9_Pack_0_2_fifo_size_ADDR32 101
#define THCON_SEC0_REG9_Pack_0_2_fifo_size_SHAMT 0
#define THCON_SEC0_REG9_Pack_0_2_fifo_size_MASK 0x1ffff
#define THCON_SEC0_REG9_Pack_0_2_fifo_size_RMW                                           \
    THCON_SEC0_REG9_Pack_0_2_fifo_size_ADDR32, THCON_SEC0_REG9_Pack_0_2_fifo_size_SHAMT, \
        THCON_SEC0_REG9_Pack_0_2_fifo_size_MASK

#define THCON_SEC0_REG9_Pack_1_3_limit_address_ADDR32 102
#define THCON_SEC0_REG9_Pack_1_3_limit_address_SHAMT 0
#define THCON_SEC0_REG9_Pack_1_3_limit_address_MASK 0x1ffff
#define THCON_SEC0_REG9_Pack_1_3_limit_address_RMW                                               \
    THCON_SEC0_REG9_Pack_1_3_limit_address_ADDR32, THCON_SEC0_REG9_Pack_1_3_limit_address_SHAMT, \
        THCON_SEC0_REG9_Pack_1_3_limit_address_MASK

#define THCON_SEC0_REG9_Pack_1_3_fifo_size_ADDR32 103
#define THCON_SEC0_REG9_Pack_1_3_fifo_size_SHAMT 0
#define THCON_SEC0_REG9_Pack_1_3_fifo_size_MASK 0x1ffff
#define THCON_SEC0_REG9_Pack_1_3_fifo_size_RMW                                           \
    THCON_SEC0_REG9_Pack_1_3_fifo_size_ADDR32, THCON_SEC0_REG9_Pack_1_3_fifo_size_SHAMT, \
        THCON_SEC0_REG9_Pack_1_3_fifo_size_MASK

#define THCON_SEC0_REG10_Unpack_limit_address_ADDR32 104
#define THCON_SEC0_REG10_Unpack_limit_address_SHAMT 0
#define THCON_SEC0_REG10_Unpack_limit_address_MASK 0x1ffff
#define THCON_SEC0_REG10_Unpack_limit_address_RMW                                              \
    THCON_SEC0_REG10_Unpack_limit_address_ADDR32, THCON_SEC0_REG10_Unpack_limit_address_SHAMT, \
        THCON_SEC0_REG10_Unpack_limit_address_MASK

#define THCON_SEC0_REG10_Unpack_fifo_size_ADDR32 105
#define THCON_SEC0_REG10_Unpack_fifo_size_SHAMT 0
#define THCON_SEC0_REG10_Unpack_fifo_size_MASK 0x1ffff
#define THCON_SEC0_REG10_Unpack_fifo_size_RMW                                          \
    THCON_SEC0_REG10_Unpack_fifo_size_ADDR32, THCON_SEC0_REG10_Unpack_fifo_size_SHAMT, \
        THCON_SEC0_REG10_Unpack_fifo_size_MASK

#define THCON_SEC0_REG10_Unpack_limit_address_en_ADDR32 105
#define THCON_SEC0_REG10_Unpack_limit_address_en_SHAMT 17
#define THCON_SEC0_REG10_Unpack_limit_address_en_MASK 0x20000
#define THCON_SEC0_REG10_Unpack_limit_address_en_RMW                                                 \
    THCON_SEC0_REG10_Unpack_limit_address_en_ADDR32, THCON_SEC0_REG10_Unpack_limit_address_en_SHAMT, \
        THCON_SEC0_REG10_Unpack_limit_address_en_MASK

#define THCON_SEC0_REG10_Unpacker_Reg_Wr_Addr_ADDR32 106
#define THCON_SEC0_REG10_Unpacker_Reg_Wr_Addr_SHAMT 0
#define THCON_SEC0_REG10_Unpacker_Reg_Wr_Addr_MASK 0xffffff
#define THCON_SEC0_REG10_Unpacker_Reg_Wr_Addr_RMW                                              \
    THCON_SEC0_REG10_Unpacker_Reg_Wr_Addr_ADDR32, THCON_SEC0_REG10_Unpacker_Reg_Wr_Addr_SHAMT, \
        THCON_SEC0_REG10_Unpacker_Reg_Wr_Addr_MASK

#define THCON_SEC0_REG10_Packer_Reg_Wr_Addr_ADDR32 107
#define THCON_SEC0_REG10_Packer_Reg_Wr_Addr_SHAMT 0
#define THCON_SEC0_REG10_Packer_Reg_Wr_Addr_MASK 0xffffff
#define THCON_SEC0_REG10_Packer_Reg_Wr_Addr_RMW                                            \
    THCON_SEC0_REG10_Packer_Reg_Wr_Addr_ADDR32, THCON_SEC0_REG10_Packer_Reg_Wr_Addr_SHAMT, \
        THCON_SEC0_REG10_Packer_Reg_Wr_Addr_MASK

#define THCON_SEC0_REG11_Metadata_l1_addr_ADDR32 108
#define THCON_SEC0_REG11_Metadata_l1_addr_SHAMT 0
#define THCON_SEC0_REG11_Metadata_l1_addr_MASK 0xffffffff
#define THCON_SEC0_REG11_Metadata_l1_addr_RMW                                          \
    THCON_SEC0_REG11_Metadata_l1_addr_ADDR32, THCON_SEC0_REG11_Metadata_l1_addr_SHAMT, \
        THCON_SEC0_REG11_Metadata_l1_addr_MASK

#define THCON_SEC0_REG11_Metadata_limit_addr_ADDR32 109
#define THCON_SEC0_REG11_Metadata_limit_addr_SHAMT 0
#define THCON_SEC0_REG11_Metadata_limit_addr_MASK 0xffffffff
#define THCON_SEC0_REG11_Metadata_limit_addr_RMW                                             \
    THCON_SEC0_REG11_Metadata_limit_addr_ADDR32, THCON_SEC0_REG11_Metadata_limit_addr_SHAMT, \
        THCON_SEC0_REG11_Metadata_limit_addr_MASK

#define THCON_SEC0_REG11_Metadata_fifo_size_ADDR32 110
#define THCON_SEC0_REG11_Metadata_fifo_size_SHAMT 0
#define THCON_SEC0_REG11_Metadata_fifo_size_MASK 0xffffffff
#define THCON_SEC0_REG11_Metadata_fifo_size_RMW                                            \
    THCON_SEC0_REG11_Metadata_fifo_size_ADDR32, THCON_SEC0_REG11_Metadata_fifo_size_SHAMT, \
        THCON_SEC0_REG11_Metadata_fifo_size_MASK

#define THCON_SEC0_REG11_Metadata_z_cntr_rst_unpacr_count_ADDR32 111
#define THCON_SEC0_REG11_Metadata_z_cntr_rst_unpacr_count_SHAMT 0
#define THCON_SEC0_REG11_Metadata_z_cntr_rst_unpacr_count_MASK 0xff
#define THCON_SEC0_REG11_Metadata_z_cntr_rst_unpacr_count_RMW                                                          \
    THCON_SEC0_REG11_Metadata_z_cntr_rst_unpacr_count_ADDR32, THCON_SEC0_REG11_Metadata_z_cntr_rst_unpacr_count_SHAMT, \
        THCON_SEC0_REG11_Metadata_z_cntr_rst_unpacr_count_MASK

#define THCON_SEC0_REG11_Metadata_cntxt_switch_unpacr_count_ADDR32 111
#define THCON_SEC0_REG11_Metadata_cntxt_switch_unpacr_count_SHAMT 8
#define THCON_SEC0_REG11_Metadata_cntxt_switch_unpacr_count_MASK 0xff00
#define THCON_SEC0_REG11_Metadata_cntxt_switch_unpacr_count_RMW    \
    THCON_SEC0_REG11_Metadata_cntxt_switch_unpacr_count_ADDR32,    \
        THCON_SEC0_REG11_Metadata_cntxt_switch_unpacr_count_SHAMT, \
        THCON_SEC0_REG11_Metadata_cntxt_switch_unpacr_count_MASK

#define THCON_SEC1_REG0_TileDescriptor_ADDR32 112
#define THCON_SEC1_REG0_TileDescriptor_SHAMT 0
#define THCON_SEC1_REG0_TileDescriptor_MASK 0xffffffffffffffffffffffffffffffff
#define THCON_SEC1_REG0_TileDescriptor_RMW \
    THCON_SEC1_REG0_TileDescriptor_ADDR32, THCON_SEC1_REG0_TileDescriptor_SHAMT, THCON_SEC1_REG0_TileDescriptor_MASK

#define THCON_SEC1_REG1_Row_start_section_size_ADDR32 116
#define THCON_SEC1_REG1_Row_start_section_size_SHAMT 0
#define THCON_SEC1_REG1_Row_start_section_size_MASK 0xffff
#define THCON_SEC1_REG1_Row_start_section_size_RMW                                               \
    THCON_SEC1_REG1_Row_start_section_size_ADDR32, THCON_SEC1_REG1_Row_start_section_size_SHAMT, \
        THCON_SEC1_REG1_Row_start_section_size_MASK

#define THCON_SEC1_REG1_Exp_section_size_ADDR32 116
#define THCON_SEC1_REG1_Exp_section_size_SHAMT 16
#define THCON_SEC1_REG1_Exp_section_size_MASK 0xffff0000
#define THCON_SEC1_REG1_Exp_section_size_RMW                                         \
    THCON_SEC1_REG1_Exp_section_size_ADDR32, THCON_SEC1_REG1_Exp_section_size_SHAMT, \
        THCON_SEC1_REG1_Exp_section_size_MASK

#define THCON_SEC1_REG1_L1_Dest_addr_ADDR32 117
#define THCON_SEC1_REG1_L1_Dest_addr_SHAMT 0
#define THCON_SEC1_REG1_L1_Dest_addr_MASK 0xffffffff
#define THCON_SEC1_REG1_L1_Dest_addr_RMW \
    THCON_SEC1_REG1_L1_Dest_addr_ADDR32, THCON_SEC1_REG1_L1_Dest_addr_SHAMT, THCON_SEC1_REG1_L1_Dest_addr_MASK

#define THCON_SEC1_REG1_Disable_zero_compress_ADDR32 118
#define THCON_SEC1_REG1_Disable_zero_compress_SHAMT 0
#define THCON_SEC1_REG1_Disable_zero_compress_MASK 0x1
#define THCON_SEC1_REG1_Disable_zero_compress_RMW                                              \
    THCON_SEC1_REG1_Disable_zero_compress_ADDR32, THCON_SEC1_REG1_Disable_zero_compress_SHAMT, \
        THCON_SEC1_REG1_Disable_zero_compress_MASK

#define THCON_SEC1_REG1_Add_l1_dest_addr_offset_ADDR32 118
#define THCON_SEC1_REG1_Add_l1_dest_addr_offset_SHAMT 1
#define THCON_SEC1_REG1_Add_l1_dest_addr_offset_MASK 0x2
#define THCON_SEC1_REG1_Add_l1_dest_addr_offset_RMW                                                \
    THCON_SEC1_REG1_Add_l1_dest_addr_offset_ADDR32, THCON_SEC1_REG1_Add_l1_dest_addr_offset_SHAMT, \
        THCON_SEC1_REG1_Add_l1_dest_addr_offset_MASK

#define THCON_SEC1_REG1_Disable_pack_zero_flags_ADDR32 118
#define THCON_SEC1_REG1_Disable_pack_zero_flags_SHAMT 2
#define THCON_SEC1_REG1_Disable_pack_zero_flags_MASK 0x4
#define THCON_SEC1_REG1_Disable_pack_zero_flags_RMW                                                \
    THCON_SEC1_REG1_Disable_pack_zero_flags_ADDR32, THCON_SEC1_REG1_Disable_pack_zero_flags_SHAMT, \
        THCON_SEC1_REG1_Disable_pack_zero_flags_MASK

#define THCON_SEC1_REG1_ovrd_default_throttle_mode_ADDR32 118
#define THCON_SEC1_REG1_ovrd_default_throttle_mode_SHAMT 3
#define THCON_SEC1_REG1_ovrd_default_throttle_mode_MASK 0x8
#define THCON_SEC1_REG1_ovrd_default_throttle_mode_RMW                                                   \
    THCON_SEC1_REG1_ovrd_default_throttle_mode_ADDR32, THCON_SEC1_REG1_ovrd_default_throttle_mode_SHAMT, \
        THCON_SEC1_REG1_ovrd_default_throttle_mode_MASK

#define THCON_SEC1_REG1_Out_data_format_ADDR32 118
#define THCON_SEC1_REG1_Out_data_format_SHAMT 4
#define THCON_SEC1_REG1_Out_data_format_MASK 0xf0
#define THCON_SEC1_REG1_Out_data_format_RMW \
    THCON_SEC1_REG1_Out_data_format_ADDR32, THCON_SEC1_REG1_Out_data_format_SHAMT, THCON_SEC1_REG1_Out_data_format_MASK

#define THCON_SEC1_REG1_In_data_format_ADDR32 118
#define THCON_SEC1_REG1_In_data_format_SHAMT 8
#define THCON_SEC1_REG1_In_data_format_MASK 0xf00
#define THCON_SEC1_REG1_In_data_format_RMW \
    THCON_SEC1_REG1_In_data_format_ADDR32, THCON_SEC1_REG1_In_data_format_SHAMT, THCON_SEC1_REG1_In_data_format_MASK

#define THCON_SEC1_REG1_Dis_shared_exp_assembler_ADDR32 118
#define THCON_SEC1_REG1_Dis_shared_exp_assembler_SHAMT 12
#define THCON_SEC1_REG1_Dis_shared_exp_assembler_MASK 0x1000
#define THCON_SEC1_REG1_Dis_shared_exp_assembler_RMW                                                 \
    THCON_SEC1_REG1_Dis_shared_exp_assembler_ADDR32, THCON_SEC1_REG1_Dis_shared_exp_assembler_SHAMT, \
        THCON_SEC1_REG1_Dis_shared_exp_assembler_MASK

#define THCON_SEC1_REG1_Auto_set_last_pacr_intf_sel_ADDR32 118
#define THCON_SEC1_REG1_Auto_set_last_pacr_intf_sel_SHAMT 13
#define THCON_SEC1_REG1_Auto_set_last_pacr_intf_sel_MASK 0x2000
#define THCON_SEC1_REG1_Auto_set_last_pacr_intf_sel_RMW                                                    \
    THCON_SEC1_REG1_Auto_set_last_pacr_intf_sel_ADDR32, THCON_SEC1_REG1_Auto_set_last_pacr_intf_sel_SHAMT, \
        THCON_SEC1_REG1_Auto_set_last_pacr_intf_sel_MASK

#define THCON_SEC1_REG1_Enable_out_fifo_ADDR32 118
#define THCON_SEC1_REG1_Enable_out_fifo_SHAMT 14
#define THCON_SEC1_REG1_Enable_out_fifo_MASK 0x4000
#define THCON_SEC1_REG1_Enable_out_fifo_RMW \
    THCON_SEC1_REG1_Enable_out_fifo_ADDR32, THCON_SEC1_REG1_Enable_out_fifo_SHAMT, THCON_SEC1_REG1_Enable_out_fifo_MASK

#define THCON_SEC1_REG1_Sub_l1_tile_header_size_ADDR32 118
#define THCON_SEC1_REG1_Sub_l1_tile_header_size_SHAMT 15
#define THCON_SEC1_REG1_Sub_l1_tile_header_size_MASK 0x8000
#define THCON_SEC1_REG1_Sub_l1_tile_header_size_RMW                                                \
    THCON_SEC1_REG1_Sub_l1_tile_header_size_ADDR32, THCON_SEC1_REG1_Sub_l1_tile_header_size_SHAMT, \
        THCON_SEC1_REG1_Sub_l1_tile_header_size_MASK

#define THCON_SEC1_REG1_Source_interface_selection_ADDR32 118
#define THCON_SEC1_REG1_Source_interface_selection_SHAMT 16
#define THCON_SEC1_REG1_Source_interface_selection_MASK 0x10000
#define THCON_SEC1_REG1_Source_interface_selection_RMW                                                   \
    THCON_SEC1_REG1_Source_interface_selection_ADDR32, THCON_SEC1_REG1_Source_interface_selection_SHAMT, \
        THCON_SEC1_REG1_Source_interface_selection_MASK

#define THCON_SEC1_REG1_pack_start_intf_pos_ADDR32 118
#define THCON_SEC1_REG1_pack_start_intf_pos_SHAMT 17
#define THCON_SEC1_REG1_pack_start_intf_pos_MASK 0x1e0000
#define THCON_SEC1_REG1_pack_start_intf_pos_RMW                                            \
    THCON_SEC1_REG1_pack_start_intf_pos_ADDR32, THCON_SEC1_REG1_pack_start_intf_pos_SHAMT, \
        THCON_SEC1_REG1_pack_start_intf_pos_MASK

#define THCON_SEC1_REG1_All_pack_disable_zero_compress_ovrd_ADDR32 118
#define THCON_SEC1_REG1_All_pack_disable_zero_compress_ovrd_SHAMT 21
#define THCON_SEC1_REG1_All_pack_disable_zero_compress_ovrd_MASK 0x200000
#define THCON_SEC1_REG1_All_pack_disable_zero_compress_ovrd_RMW    \
    THCON_SEC1_REG1_All_pack_disable_zero_compress_ovrd_ADDR32,    \
        THCON_SEC1_REG1_All_pack_disable_zero_compress_ovrd_SHAMT, \
        THCON_SEC1_REG1_All_pack_disable_zero_compress_ovrd_MASK

#define THCON_SEC1_REG1_Add_tile_header_size_ADDR32 118
#define THCON_SEC1_REG1_Add_tile_header_size_SHAMT 22
#define THCON_SEC1_REG1_Add_tile_header_size_MASK 0x400000
#define THCON_SEC1_REG1_Add_tile_header_size_RMW                                             \
    THCON_SEC1_REG1_Add_tile_header_size_ADDR32, THCON_SEC1_REG1_Add_tile_header_size_SHAMT, \
        THCON_SEC1_REG1_Add_tile_header_size_MASK

#define THCON_SEC1_REG1_pack_dis_y_pos_start_offset_ADDR32 118
#define THCON_SEC1_REG1_pack_dis_y_pos_start_offset_SHAMT 23
#define THCON_SEC1_REG1_pack_dis_y_pos_start_offset_MASK 0x800000
#define THCON_SEC1_REG1_pack_dis_y_pos_start_offset_RMW                                                    \
    THCON_SEC1_REG1_pack_dis_y_pos_start_offset_ADDR32, THCON_SEC1_REG1_pack_dis_y_pos_start_offset_SHAMT, \
        THCON_SEC1_REG1_pack_dis_y_pos_start_offset_MASK

#define THCON_SEC1_REG1_L1_source_addr_ADDR32 118
#define THCON_SEC1_REG1_L1_source_addr_SHAMT 24
#define THCON_SEC1_REG1_L1_source_addr_MASK 0xff000000
#define THCON_SEC1_REG1_L1_source_addr_RMW \
    THCON_SEC1_REG1_L1_source_addr_ADDR32, THCON_SEC1_REG1_L1_source_addr_SHAMT, THCON_SEC1_REG1_L1_source_addr_MASK

#define THCON_SEC1_REG1_Downsample_mask_ADDR32 119
#define THCON_SEC1_REG1_Downsample_mask_SHAMT 0
#define THCON_SEC1_REG1_Downsample_mask_MASK 0xffff
#define THCON_SEC1_REG1_Downsample_mask_RMW \
    THCON_SEC1_REG1_Downsample_mask_ADDR32, THCON_SEC1_REG1_Downsample_mask_SHAMT, THCON_SEC1_REG1_Downsample_mask_MASK

#define THCON_SEC1_REG1_Downsample_rate_ADDR32 119
#define THCON_SEC1_REG1_Downsample_rate_SHAMT 16
#define THCON_SEC1_REG1_Downsample_rate_MASK 0x70000
#define THCON_SEC1_REG1_Downsample_rate_RMW \
    THCON_SEC1_REG1_Downsample_rate_ADDR32, THCON_SEC1_REG1_Downsample_rate_SHAMT, THCON_SEC1_REG1_Downsample_rate_MASK

#define THCON_SEC1_REG1_Pack_L1_Acc_ADDR32 119
#define THCON_SEC1_REG1_Pack_L1_Acc_SHAMT 19
#define THCON_SEC1_REG1_Pack_L1_Acc_MASK 0x80000
#define THCON_SEC1_REG1_Pack_L1_Acc_RMW \
    THCON_SEC1_REG1_Pack_L1_Acc_ADDR32, THCON_SEC1_REG1_Pack_L1_Acc_SHAMT, THCON_SEC1_REG1_Pack_L1_Acc_MASK

#define THCON_SEC1_REG1_Exp_threshold_en_ADDR32 119
#define THCON_SEC1_REG1_Exp_threshold_en_SHAMT 20
#define THCON_SEC1_REG1_Exp_threshold_en_MASK 0x100000
#define THCON_SEC1_REG1_Exp_threshold_en_RMW                                         \
    THCON_SEC1_REG1_Exp_threshold_en_ADDR32, THCON_SEC1_REG1_Exp_threshold_en_SHAMT, \
        THCON_SEC1_REG1_Exp_threshold_en_MASK

#define THCON_SEC1_REG1_Unp_LF8_4b_exp_ADDR32 119
#define THCON_SEC1_REG1_Unp_LF8_4b_exp_SHAMT 22
#define THCON_SEC1_REG1_Unp_LF8_4b_exp_MASK 0x400000
#define THCON_SEC1_REG1_Unp_LF8_4b_exp_RMW \
    THCON_SEC1_REG1_Unp_LF8_4b_exp_ADDR32, THCON_SEC1_REG1_Unp_LF8_4b_exp_SHAMT, THCON_SEC1_REG1_Unp_LF8_4b_exp_MASK

#define THCON_SEC1_REG1_Pac_LF8_4b_exp_ADDR32 119
#define THCON_SEC1_REG1_Pac_LF8_4b_exp_SHAMT 23
#define THCON_SEC1_REG1_Pac_LF8_4b_exp_MASK 0x800000
#define THCON_SEC1_REG1_Pac_LF8_4b_exp_RMW \
    THCON_SEC1_REG1_Pac_LF8_4b_exp_ADDR32, THCON_SEC1_REG1_Pac_LF8_4b_exp_SHAMT, THCON_SEC1_REG1_Pac_LF8_4b_exp_MASK

#define THCON_SEC1_REG1_Exp_threshold_ADDR32 119
#define THCON_SEC1_REG1_Exp_threshold_SHAMT 24
#define THCON_SEC1_REG1_Exp_threshold_MASK 0xff000000
#define THCON_SEC1_REG1_Exp_threshold_RMW \
    THCON_SEC1_REG1_Exp_threshold_ADDR32, THCON_SEC1_REG1_Exp_threshold_SHAMT, THCON_SEC1_REG1_Exp_threshold_MASK

#define THCON_SEC1_REG2_Out_data_format_ADDR32 120
#define THCON_SEC1_REG2_Out_data_format_SHAMT 0
#define THCON_SEC1_REG2_Out_data_format_MASK 0xf
#define THCON_SEC1_REG2_Out_data_format_RMW \
    THCON_SEC1_REG2_Out_data_format_ADDR32, THCON_SEC1_REG2_Out_data_format_SHAMT, THCON_SEC1_REG2_Out_data_format_MASK

#define THCON_SEC1_REG2_Throttle_mode_ADDR32 120
#define THCON_SEC1_REG2_Throttle_mode_SHAMT 4
#define THCON_SEC1_REG2_Throttle_mode_MASK 0x30
#define THCON_SEC1_REG2_Throttle_mode_RMW \
    THCON_SEC1_REG2_Throttle_mode_ADDR32, THCON_SEC1_REG2_Throttle_mode_SHAMT, THCON_SEC1_REG2_Throttle_mode_MASK

#define THCON_SEC1_REG2_Context_count_ADDR32 120
#define THCON_SEC1_REG2_Context_count_SHAMT 6
#define THCON_SEC1_REG2_Context_count_MASK 0xc0
#define THCON_SEC1_REG2_Context_count_RMW \
    THCON_SEC1_REG2_Context_count_ADDR32, THCON_SEC1_REG2_Context_count_SHAMT, THCON_SEC1_REG2_Context_count_MASK

#define THCON_SEC1_REG2_Haloize_mode_ADDR32 120
#define THCON_SEC1_REG2_Haloize_mode_SHAMT 8
#define THCON_SEC1_REG2_Haloize_mode_MASK 0x100
#define THCON_SEC1_REG2_Haloize_mode_RMW \
    THCON_SEC1_REG2_Haloize_mode_ADDR32, THCON_SEC1_REG2_Haloize_mode_SHAMT, THCON_SEC1_REG2_Haloize_mode_MASK

#define THCON_SEC1_REG2_Tileize_mode_ADDR32 120
#define THCON_SEC1_REG2_Tileize_mode_SHAMT 9
#define THCON_SEC1_REG2_Tileize_mode_MASK 0x200
#define THCON_SEC1_REG2_Tileize_mode_RMW \
    THCON_SEC1_REG2_Tileize_mode_ADDR32, THCON_SEC1_REG2_Tileize_mode_SHAMT, THCON_SEC1_REG2_Tileize_mode_MASK

#define THCON_SEC1_REG2_Unpack_Src_Reg_Set_Upd_ADDR32 120
#define THCON_SEC1_REG2_Unpack_Src_Reg_Set_Upd_SHAMT 10
#define THCON_SEC1_REG2_Unpack_Src_Reg_Set_Upd_MASK 0x400
#define THCON_SEC1_REG2_Unpack_Src_Reg_Set_Upd_RMW                                               \
    THCON_SEC1_REG2_Unpack_Src_Reg_Set_Upd_ADDR32, THCON_SEC1_REG2_Unpack_Src_Reg_Set_Upd_SHAMT, \
        THCON_SEC1_REG2_Unpack_Src_Reg_Set_Upd_MASK

#define THCON_SEC1_REG2_Unpack_If_Sel_ADDR32 120
#define THCON_SEC1_REG2_Unpack_If_Sel_SHAMT 11
#define THCON_SEC1_REG2_Unpack_If_Sel_MASK 0x800
#define THCON_SEC1_REG2_Unpack_If_Sel_RMW \
    THCON_SEC1_REG2_Unpack_If_Sel_ADDR32, THCON_SEC1_REG2_Unpack_If_Sel_SHAMT, THCON_SEC1_REG2_Unpack_If_Sel_MASK

#define THCON_SEC1_REG2_Upsample_rate_ADDR32 120
#define THCON_SEC1_REG2_Upsample_rate_SHAMT 12
#define THCON_SEC1_REG2_Upsample_rate_MASK 0x3000
#define THCON_SEC1_REG2_Upsample_rate_RMW \
    THCON_SEC1_REG2_Upsample_rate_ADDR32, THCON_SEC1_REG2_Upsample_rate_SHAMT, THCON_SEC1_REG2_Upsample_rate_MASK

#define THCON_SEC1_REG2_Ovrd_data_format_ADDR32 120
#define THCON_SEC1_REG2_Ovrd_data_format_SHAMT 14
#define THCON_SEC1_REG2_Ovrd_data_format_MASK 0x4000
#define THCON_SEC1_REG2_Ovrd_data_format_RMW                                         \
    THCON_SEC1_REG2_Ovrd_data_format_ADDR32, THCON_SEC1_REG2_Ovrd_data_format_SHAMT, \
        THCON_SEC1_REG2_Ovrd_data_format_MASK

#define THCON_SEC1_REG2_Upsample_and_interleave_ADDR32 120
#define THCON_SEC1_REG2_Upsample_and_interleave_SHAMT 15
#define THCON_SEC1_REG2_Upsample_and_interleave_MASK 0x8000
#define THCON_SEC1_REG2_Upsample_and_interleave_RMW                                                \
    THCON_SEC1_REG2_Upsample_and_interleave_ADDR32, THCON_SEC1_REG2_Upsample_and_interleave_SHAMT, \
        THCON_SEC1_REG2_Upsample_and_interleave_MASK

#define THCON_SEC1_REG2_Shift_amount_cntx0_ADDR32 120
#define THCON_SEC1_REG2_Shift_amount_cntx0_SHAMT 16
#define THCON_SEC1_REG2_Shift_amount_cntx0_MASK 0xf0000
#define THCON_SEC1_REG2_Shift_amount_cntx0_RMW                                           \
    THCON_SEC1_REG2_Shift_amount_cntx0_ADDR32, THCON_SEC1_REG2_Shift_amount_cntx0_SHAMT, \
        THCON_SEC1_REG2_Shift_amount_cntx0_MASK

#define THCON_SEC1_REG2_Shift_amount_cntx1_ADDR32 120
#define THCON_SEC1_REG2_Shift_amount_cntx1_SHAMT 20
#define THCON_SEC1_REG2_Shift_amount_cntx1_MASK 0xf00000
#define THCON_SEC1_REG2_Shift_amount_cntx1_RMW                                           \
    THCON_SEC1_REG2_Shift_amount_cntx1_ADDR32, THCON_SEC1_REG2_Shift_amount_cntx1_SHAMT, \
        THCON_SEC1_REG2_Shift_amount_cntx1_MASK

#define THCON_SEC1_REG2_Shift_amount_cntx2_ADDR32 120
#define THCON_SEC1_REG2_Shift_amount_cntx2_SHAMT 24
#define THCON_SEC1_REG2_Shift_amount_cntx2_MASK 0xf000000
#define THCON_SEC1_REG2_Shift_amount_cntx2_RMW                                           \
    THCON_SEC1_REG2_Shift_amount_cntx2_ADDR32, THCON_SEC1_REG2_Shift_amount_cntx2_SHAMT, \
        THCON_SEC1_REG2_Shift_amount_cntx2_MASK

#define THCON_SEC1_REG2_Shift_amount_cntx3_ADDR32 120
#define THCON_SEC1_REG2_Shift_amount_cntx3_SHAMT 28
#define THCON_SEC1_REG2_Shift_amount_cntx3_MASK 0xf0000000
#define THCON_SEC1_REG2_Shift_amount_cntx3_RMW                                           \
    THCON_SEC1_REG2_Shift_amount_cntx3_ADDR32, THCON_SEC1_REG2_Shift_amount_cntx3_SHAMT, \
        THCON_SEC1_REG2_Shift_amount_cntx3_MASK

#define THCON_SEC1_REG2_Disable_zero_compress_cntx0_ADDR32 121
#define THCON_SEC1_REG2_Disable_zero_compress_cntx0_SHAMT 0
#define THCON_SEC1_REG2_Disable_zero_compress_cntx0_MASK 0x1
#define THCON_SEC1_REG2_Disable_zero_compress_cntx0_RMW                                                    \
    THCON_SEC1_REG2_Disable_zero_compress_cntx0_ADDR32, THCON_SEC1_REG2_Disable_zero_compress_cntx0_SHAMT, \
        THCON_SEC1_REG2_Disable_zero_compress_cntx0_MASK

#define THCON_SEC1_REG2_Disable_zero_compress_cntx1_ADDR32 121
#define THCON_SEC1_REG2_Disable_zero_compress_cntx1_SHAMT 1
#define THCON_SEC1_REG2_Disable_zero_compress_cntx1_MASK 0x2
#define THCON_SEC1_REG2_Disable_zero_compress_cntx1_RMW                                                    \
    THCON_SEC1_REG2_Disable_zero_compress_cntx1_ADDR32, THCON_SEC1_REG2_Disable_zero_compress_cntx1_SHAMT, \
        THCON_SEC1_REG2_Disable_zero_compress_cntx1_MASK

#define THCON_SEC1_REG2_Disable_zero_compress_cntx2_ADDR32 121
#define THCON_SEC1_REG2_Disable_zero_compress_cntx2_SHAMT 2
#define THCON_SEC1_REG2_Disable_zero_compress_cntx2_MASK 0x4
#define THCON_SEC1_REG2_Disable_zero_compress_cntx2_RMW                                                    \
    THCON_SEC1_REG2_Disable_zero_compress_cntx2_ADDR32, THCON_SEC1_REG2_Disable_zero_compress_cntx2_SHAMT, \
        THCON_SEC1_REG2_Disable_zero_compress_cntx2_MASK

#define THCON_SEC1_REG2_Disable_zero_compress_cntx3_ADDR32 121
#define THCON_SEC1_REG2_Disable_zero_compress_cntx3_SHAMT 3
#define THCON_SEC1_REG2_Disable_zero_compress_cntx3_MASK 0x8
#define THCON_SEC1_REG2_Disable_zero_compress_cntx3_RMW                                                    \
    THCON_SEC1_REG2_Disable_zero_compress_cntx3_ADDR32, THCON_SEC1_REG2_Disable_zero_compress_cntx3_SHAMT, \
        THCON_SEC1_REG2_Disable_zero_compress_cntx3_MASK

#define THCON_SEC1_REG2_Unpack_if_sel_cntx0_ADDR32 121
#define THCON_SEC1_REG2_Unpack_if_sel_cntx0_SHAMT 4
#define THCON_SEC1_REG2_Unpack_if_sel_cntx0_MASK 0x10
#define THCON_SEC1_REG2_Unpack_if_sel_cntx0_RMW                                            \
    THCON_SEC1_REG2_Unpack_if_sel_cntx0_ADDR32, THCON_SEC1_REG2_Unpack_if_sel_cntx0_SHAMT, \
        THCON_SEC1_REG2_Unpack_if_sel_cntx0_MASK

#define THCON_SEC1_REG2_Unpack_if_sel_cntx1_ADDR32 121
#define THCON_SEC1_REG2_Unpack_if_sel_cntx1_SHAMT 5
#define THCON_SEC1_REG2_Unpack_if_sel_cntx1_MASK 0x20
#define THCON_SEC1_REG2_Unpack_if_sel_cntx1_RMW                                            \
    THCON_SEC1_REG2_Unpack_if_sel_cntx1_ADDR32, THCON_SEC1_REG2_Unpack_if_sel_cntx1_SHAMT, \
        THCON_SEC1_REG2_Unpack_if_sel_cntx1_MASK

#define THCON_SEC1_REG2_Unpack_if_sel_cntx2_ADDR32 121
#define THCON_SEC1_REG2_Unpack_if_sel_cntx2_SHAMT 6
#define THCON_SEC1_REG2_Unpack_if_sel_cntx2_MASK 0x40
#define THCON_SEC1_REG2_Unpack_if_sel_cntx2_RMW                                            \
    THCON_SEC1_REG2_Unpack_if_sel_cntx2_ADDR32, THCON_SEC1_REG2_Unpack_if_sel_cntx2_SHAMT, \
        THCON_SEC1_REG2_Unpack_if_sel_cntx2_MASK

#define THCON_SEC1_REG2_Unpack_if_sel_cntx3_ADDR32 121
#define THCON_SEC1_REG2_Unpack_if_sel_cntx3_SHAMT 7
#define THCON_SEC1_REG2_Unpack_if_sel_cntx3_MASK 0x80
#define THCON_SEC1_REG2_Unpack_if_sel_cntx3_RMW                                            \
    THCON_SEC1_REG2_Unpack_if_sel_cntx3_ADDR32, THCON_SEC1_REG2_Unpack_if_sel_cntx3_SHAMT, \
        THCON_SEC1_REG2_Unpack_if_sel_cntx3_MASK

#define THCON_SEC1_REG2_Force_shared_exp_ADDR32 121
#define THCON_SEC1_REG2_Force_shared_exp_SHAMT 8
#define THCON_SEC1_REG2_Force_shared_exp_MASK 0x100
#define THCON_SEC1_REG2_Force_shared_exp_RMW                                         \
    THCON_SEC1_REG2_Force_shared_exp_ADDR32, THCON_SEC1_REG2_Force_shared_exp_SHAMT, \
        THCON_SEC1_REG2_Force_shared_exp_MASK

#define THCON_SEC1_REG2_Context_count_non_log2_ADDR32 121
#define THCON_SEC1_REG2_Context_count_non_log2_SHAMT 9
#define THCON_SEC1_REG2_Context_count_non_log2_MASK 0xe00
#define THCON_SEC1_REG2_Context_count_non_log2_RMW                                               \
    THCON_SEC1_REG2_Context_count_non_log2_ADDR32, THCON_SEC1_REG2_Context_count_non_log2_SHAMT, \
        THCON_SEC1_REG2_Context_count_non_log2_MASK

#define THCON_SEC1_REG2_Context_count_non_log2_en_ADDR32 121
#define THCON_SEC1_REG2_Context_count_non_log2_en_SHAMT 12
#define THCON_SEC1_REG2_Context_count_non_log2_en_MASK 0x1000
#define THCON_SEC1_REG2_Context_count_non_log2_en_RMW                                                  \
    THCON_SEC1_REG2_Context_count_non_log2_en_ADDR32, THCON_SEC1_REG2_Context_count_non_log2_en_SHAMT, \
        THCON_SEC1_REG2_Context_count_non_log2_en_MASK

#define THCON_SEC1_REG2_Disable_zero_compress_cntx4_ADDR32 121
#define THCON_SEC1_REG2_Disable_zero_compress_cntx4_SHAMT 16
#define THCON_SEC1_REG2_Disable_zero_compress_cntx4_MASK 0x10000
#define THCON_SEC1_REG2_Disable_zero_compress_cntx4_RMW                                                    \
    THCON_SEC1_REG2_Disable_zero_compress_cntx4_ADDR32, THCON_SEC1_REG2_Disable_zero_compress_cntx4_SHAMT, \
        THCON_SEC1_REG2_Disable_zero_compress_cntx4_MASK

#define THCON_SEC1_REG2_Disable_zero_compress_cntx5_ADDR32 121
#define THCON_SEC1_REG2_Disable_zero_compress_cntx5_SHAMT 17
#define THCON_SEC1_REG2_Disable_zero_compress_cntx5_MASK 0x20000
#define THCON_SEC1_REG2_Disable_zero_compress_cntx5_RMW                                                    \
    THCON_SEC1_REG2_Disable_zero_compress_cntx5_ADDR32, THCON_SEC1_REG2_Disable_zero_compress_cntx5_SHAMT, \
        THCON_SEC1_REG2_Disable_zero_compress_cntx5_MASK

#define THCON_SEC1_REG2_Disable_zero_compress_cntx6_ADDR32 121
#define THCON_SEC1_REG2_Disable_zero_compress_cntx6_SHAMT 18
#define THCON_SEC1_REG2_Disable_zero_compress_cntx6_MASK 0x40000
#define THCON_SEC1_REG2_Disable_zero_compress_cntx6_RMW                                                    \
    THCON_SEC1_REG2_Disable_zero_compress_cntx6_ADDR32, THCON_SEC1_REG2_Disable_zero_compress_cntx6_SHAMT, \
        THCON_SEC1_REG2_Disable_zero_compress_cntx6_MASK

#define THCON_SEC1_REG2_Disable_zero_compress_cntx7_ADDR32 121
#define THCON_SEC1_REG2_Disable_zero_compress_cntx7_SHAMT 19
#define THCON_SEC1_REG2_Disable_zero_compress_cntx7_MASK 0x80000
#define THCON_SEC1_REG2_Disable_zero_compress_cntx7_RMW                                                    \
    THCON_SEC1_REG2_Disable_zero_compress_cntx7_ADDR32, THCON_SEC1_REG2_Disable_zero_compress_cntx7_SHAMT, \
        THCON_SEC1_REG2_Disable_zero_compress_cntx7_MASK

#define THCON_SEC1_REG2_Unpack_if_sel_cntx4_ADDR32 121
#define THCON_SEC1_REG2_Unpack_if_sel_cntx4_SHAMT 20
#define THCON_SEC1_REG2_Unpack_if_sel_cntx4_MASK 0x100000
#define THCON_SEC1_REG2_Unpack_if_sel_cntx4_RMW                                            \
    THCON_SEC1_REG2_Unpack_if_sel_cntx4_ADDR32, THCON_SEC1_REG2_Unpack_if_sel_cntx4_SHAMT, \
        THCON_SEC1_REG2_Unpack_if_sel_cntx4_MASK

#define THCON_SEC1_REG2_Unpack_if_sel_cntx5_ADDR32 121
#define THCON_SEC1_REG2_Unpack_if_sel_cntx5_SHAMT 21
#define THCON_SEC1_REG2_Unpack_if_sel_cntx5_MASK 0x200000
#define THCON_SEC1_REG2_Unpack_if_sel_cntx5_RMW                                            \
    THCON_SEC1_REG2_Unpack_if_sel_cntx5_ADDR32, THCON_SEC1_REG2_Unpack_if_sel_cntx5_SHAMT, \
        THCON_SEC1_REG2_Unpack_if_sel_cntx5_MASK

#define THCON_SEC1_REG2_Unpack_if_sel_cntx6_ADDR32 121
#define THCON_SEC1_REG2_Unpack_if_sel_cntx6_SHAMT 22
#define THCON_SEC1_REG2_Unpack_if_sel_cntx6_MASK 0x400000
#define THCON_SEC1_REG2_Unpack_if_sel_cntx6_RMW                                            \
    THCON_SEC1_REG2_Unpack_if_sel_cntx6_ADDR32, THCON_SEC1_REG2_Unpack_if_sel_cntx6_SHAMT, \
        THCON_SEC1_REG2_Unpack_if_sel_cntx6_MASK

#define THCON_SEC1_REG2_Unpack_if_sel_cntx7_ADDR32 121
#define THCON_SEC1_REG2_Unpack_if_sel_cntx7_SHAMT 23
#define THCON_SEC1_REG2_Unpack_if_sel_cntx7_MASK 0x800000
#define THCON_SEC1_REG2_Unpack_if_sel_cntx7_RMW                                            \
    THCON_SEC1_REG2_Unpack_if_sel_cntx7_ADDR32, THCON_SEC1_REG2_Unpack_if_sel_cntx7_SHAMT, \
        THCON_SEC1_REG2_Unpack_if_sel_cntx7_MASK

#define THCON_SEC1_REG2_Metadata_x_end_ADDR32 121
#define THCON_SEC1_REG2_Metadata_x_end_SHAMT 24
#define THCON_SEC1_REG2_Metadata_x_end_MASK 0xff000000
#define THCON_SEC1_REG2_Metadata_x_end_RMW \
    THCON_SEC1_REG2_Metadata_x_end_ADDR32, THCON_SEC1_REG2_Metadata_x_end_SHAMT, THCON_SEC1_REG2_Metadata_x_end_MASK

#define THCON_SEC1_REG2_Unpack_limit_address_ADDR32 122
#define THCON_SEC1_REG2_Unpack_limit_address_SHAMT 0
#define THCON_SEC1_REG2_Unpack_limit_address_MASK 0x1ffff
#define THCON_SEC1_REG2_Unpack_limit_address_RMW                                             \
    THCON_SEC1_REG2_Unpack_limit_address_ADDR32, THCON_SEC1_REG2_Unpack_limit_address_SHAMT, \
        THCON_SEC1_REG2_Unpack_limit_address_MASK

#define THCON_SEC1_REG2_Unpack_fifo_size_ADDR32 123
#define THCON_SEC1_REG2_Unpack_fifo_size_SHAMT 0
#define THCON_SEC1_REG2_Unpack_fifo_size_MASK 0x1ffff
#define THCON_SEC1_REG2_Unpack_fifo_size_RMW                                         \
    THCON_SEC1_REG2_Unpack_fifo_size_ADDR32, THCON_SEC1_REG2_Unpack_fifo_size_SHAMT, \
        THCON_SEC1_REG2_Unpack_fifo_size_MASK

#define THCON_SEC1_REG3_Base_address_ADDR32 124
#define THCON_SEC1_REG3_Base_address_SHAMT 0
#define THCON_SEC1_REG3_Base_address_MASK 0xffffffff
#define THCON_SEC1_REG3_Base_address_RMW \
    THCON_SEC1_REG3_Base_address_ADDR32, THCON_SEC1_REG3_Base_address_SHAMT, THCON_SEC1_REG3_Base_address_MASK

#define THCON_SEC1_REG3_Base_cntx1_address_ADDR32 125
#define THCON_SEC1_REG3_Base_cntx1_address_SHAMT 0
#define THCON_SEC1_REG3_Base_cntx1_address_MASK 0xffffffff
#define THCON_SEC1_REG3_Base_cntx1_address_RMW                                           \
    THCON_SEC1_REG3_Base_cntx1_address_ADDR32, THCON_SEC1_REG3_Base_cntx1_address_SHAMT, \
        THCON_SEC1_REG3_Base_cntx1_address_MASK

#define THCON_SEC1_REG3_Base_cntx2_address_ADDR32 126
#define THCON_SEC1_REG3_Base_cntx2_address_SHAMT 0
#define THCON_SEC1_REG3_Base_cntx2_address_MASK 0xffffffff
#define THCON_SEC1_REG3_Base_cntx2_address_RMW                                           \
    THCON_SEC1_REG3_Base_cntx2_address_ADDR32, THCON_SEC1_REG3_Base_cntx2_address_SHAMT, \
        THCON_SEC1_REG3_Base_cntx2_address_MASK

#define THCON_SEC1_REG3_Base_cntx3_address_ADDR32 127
#define THCON_SEC1_REG3_Base_cntx3_address_SHAMT 0
#define THCON_SEC1_REG3_Base_cntx3_address_MASK 0xffffffff
#define THCON_SEC1_REG3_Base_cntx3_address_RMW                                           \
    THCON_SEC1_REG3_Base_cntx3_address_ADDR32, THCON_SEC1_REG3_Base_cntx3_address_SHAMT, \
        THCON_SEC1_REG3_Base_cntx3_address_MASK

#define THCON_SEC1_REG4_Base_cntx4_address_ADDR32 128
#define THCON_SEC1_REG4_Base_cntx4_address_SHAMT 0
#define THCON_SEC1_REG4_Base_cntx4_address_MASK 0xffffffff
#define THCON_SEC1_REG4_Base_cntx4_address_RMW                                           \
    THCON_SEC1_REG4_Base_cntx4_address_ADDR32, THCON_SEC1_REG4_Base_cntx4_address_SHAMT, \
        THCON_SEC1_REG4_Base_cntx4_address_MASK

#define THCON_SEC1_REG4_Base_cntx5_address_ADDR32 129
#define THCON_SEC1_REG4_Base_cntx5_address_SHAMT 0
#define THCON_SEC1_REG4_Base_cntx5_address_MASK 0xffffffff
#define THCON_SEC1_REG4_Base_cntx5_address_RMW                                           \
    THCON_SEC1_REG4_Base_cntx5_address_ADDR32, THCON_SEC1_REG4_Base_cntx5_address_SHAMT, \
        THCON_SEC1_REG4_Base_cntx5_address_MASK

#define THCON_SEC1_REG4_Base_cntx6_address_ADDR32 130
#define THCON_SEC1_REG4_Base_cntx6_address_SHAMT 0
#define THCON_SEC1_REG4_Base_cntx6_address_MASK 0xffffffff
#define THCON_SEC1_REG4_Base_cntx6_address_RMW                                           \
    THCON_SEC1_REG4_Base_cntx6_address_ADDR32, THCON_SEC1_REG4_Base_cntx6_address_SHAMT, \
        THCON_SEC1_REG4_Base_cntx6_address_MASK

#define THCON_SEC1_REG4_Base_cntx7_address_ADDR32 131
#define THCON_SEC1_REG4_Base_cntx7_address_SHAMT 0
#define THCON_SEC1_REG4_Base_cntx7_address_MASK 0xffffffff
#define THCON_SEC1_REG4_Base_cntx7_address_RMW                                           \
    THCON_SEC1_REG4_Base_cntx7_address_ADDR32, THCON_SEC1_REG4_Base_cntx7_address_SHAMT, \
        THCON_SEC1_REG4_Base_cntx7_address_MASK

#define THCON_SEC1_REG5_Dest_cntx0_address_ADDR32 132
#define THCON_SEC1_REG5_Dest_cntx0_address_SHAMT 0
#define THCON_SEC1_REG5_Dest_cntx0_address_MASK 0xffff
#define THCON_SEC1_REG5_Dest_cntx0_address_RMW                                           \
    THCON_SEC1_REG5_Dest_cntx0_address_ADDR32, THCON_SEC1_REG5_Dest_cntx0_address_SHAMT, \
        THCON_SEC1_REG5_Dest_cntx0_address_MASK

#define THCON_SEC1_REG5_Dest_cntx1_address_ADDR32 132
#define THCON_SEC1_REG5_Dest_cntx1_address_SHAMT 16
#define THCON_SEC1_REG5_Dest_cntx1_address_MASK 0xffff0000
#define THCON_SEC1_REG5_Dest_cntx1_address_RMW                                           \
    THCON_SEC1_REG5_Dest_cntx1_address_ADDR32, THCON_SEC1_REG5_Dest_cntx1_address_SHAMT, \
        THCON_SEC1_REG5_Dest_cntx1_address_MASK

#define THCON_SEC1_REG5_Dest_cntx2_address_ADDR32 133
#define THCON_SEC1_REG5_Dest_cntx2_address_SHAMT 0
#define THCON_SEC1_REG5_Dest_cntx2_address_MASK 0xffff
#define THCON_SEC1_REG5_Dest_cntx2_address_RMW                                           \
    THCON_SEC1_REG5_Dest_cntx2_address_ADDR32, THCON_SEC1_REG5_Dest_cntx2_address_SHAMT, \
        THCON_SEC1_REG5_Dest_cntx2_address_MASK

#define THCON_SEC1_REG5_Dest_cntx3_address_ADDR32 133
#define THCON_SEC1_REG5_Dest_cntx3_address_SHAMT 16
#define THCON_SEC1_REG5_Dest_cntx3_address_MASK 0xffff0000
#define THCON_SEC1_REG5_Dest_cntx3_address_RMW                                           \
    THCON_SEC1_REG5_Dest_cntx3_address_ADDR32, THCON_SEC1_REG5_Dest_cntx3_address_SHAMT, \
        THCON_SEC1_REG5_Dest_cntx3_address_MASK

#define THCON_SEC1_REG5_Tile_x_dim_cntx0_ADDR32 134
#define THCON_SEC1_REG5_Tile_x_dim_cntx0_SHAMT 0
#define THCON_SEC1_REG5_Tile_x_dim_cntx0_MASK 0xffff
#define THCON_SEC1_REG5_Tile_x_dim_cntx0_RMW                                         \
    THCON_SEC1_REG5_Tile_x_dim_cntx0_ADDR32, THCON_SEC1_REG5_Tile_x_dim_cntx0_SHAMT, \
        THCON_SEC1_REG5_Tile_x_dim_cntx0_MASK

#define THCON_SEC1_REG5_Tile_x_dim_cntx1_ADDR32 134
#define THCON_SEC1_REG5_Tile_x_dim_cntx1_SHAMT 16
#define THCON_SEC1_REG5_Tile_x_dim_cntx1_MASK 0xffff0000
#define THCON_SEC1_REG5_Tile_x_dim_cntx1_RMW                                         \
    THCON_SEC1_REG5_Tile_x_dim_cntx1_ADDR32, THCON_SEC1_REG5_Tile_x_dim_cntx1_SHAMT, \
        THCON_SEC1_REG5_Tile_x_dim_cntx1_MASK

#define THCON_SEC1_REG5_Tile_x_dim_cntx2_ADDR32 135
#define THCON_SEC1_REG5_Tile_x_dim_cntx2_SHAMT 0
#define THCON_SEC1_REG5_Tile_x_dim_cntx2_MASK 0xffff
#define THCON_SEC1_REG5_Tile_x_dim_cntx2_RMW                                         \
    THCON_SEC1_REG5_Tile_x_dim_cntx2_ADDR32, THCON_SEC1_REG5_Tile_x_dim_cntx2_SHAMT, \
        THCON_SEC1_REG5_Tile_x_dim_cntx2_MASK

#define THCON_SEC1_REG5_Tile_x_dim_cntx3_ADDR32 135
#define THCON_SEC1_REG5_Tile_x_dim_cntx3_SHAMT 16
#define THCON_SEC1_REG5_Tile_x_dim_cntx3_MASK 0xffff0000
#define THCON_SEC1_REG5_Tile_x_dim_cntx3_RMW                                         \
    THCON_SEC1_REG5_Tile_x_dim_cntx3_ADDR32, THCON_SEC1_REG5_Tile_x_dim_cntx3_SHAMT, \
        THCON_SEC1_REG5_Tile_x_dim_cntx3_MASK

#define THCON_SEC1_REG6_Source_address_ADDR32 136
#define THCON_SEC1_REG6_Source_address_SHAMT 0
#define THCON_SEC1_REG6_Source_address_MASK 0xffffffff
#define THCON_SEC1_REG6_Source_address_RMW \
    THCON_SEC1_REG6_Source_address_ADDR32, THCON_SEC1_REG6_Source_address_SHAMT, THCON_SEC1_REG6_Source_address_MASK

#define THCON_SEC1_REG6_Destination_address_ADDR32 137
#define THCON_SEC1_REG6_Destination_address_SHAMT 0
#define THCON_SEC1_REG6_Destination_address_MASK 0xffffffff
#define THCON_SEC1_REG6_Destination_address_RMW                                            \
    THCON_SEC1_REG6_Destination_address_ADDR32, THCON_SEC1_REG6_Destination_address_SHAMT, \
        THCON_SEC1_REG6_Destination_address_MASK

#define THCON_SEC1_REG6_Buffer_size_ADDR32 138
#define THCON_SEC1_REG6_Buffer_size_SHAMT 0
#define THCON_SEC1_REG6_Buffer_size_MASK 0x3fffffff
#define THCON_SEC1_REG6_Buffer_size_RMW \
    THCON_SEC1_REG6_Buffer_size_ADDR32, THCON_SEC1_REG6_Buffer_size_SHAMT, THCON_SEC1_REG6_Buffer_size_MASK

#define THCON_SEC1_REG6_Transfer_direction_ADDR32 138
#define THCON_SEC1_REG6_Transfer_direction_SHAMT 30
#define THCON_SEC1_REG6_Transfer_direction_MASK 0xc0000000
#define THCON_SEC1_REG6_Transfer_direction_RMW                                           \
    THCON_SEC1_REG6_Transfer_direction_ADDR32, THCON_SEC1_REG6_Transfer_direction_SHAMT, \
        THCON_SEC1_REG6_Transfer_direction_MASK

#define THCON_SEC1_REG6_Metadata_misc_ADDR32 139
#define THCON_SEC1_REG6_Metadata_misc_SHAMT 0
#define THCON_SEC1_REG6_Metadata_misc_MASK 0xffffffff
#define THCON_SEC1_REG6_Metadata_misc_RMW \
    THCON_SEC1_REG6_Metadata_misc_ADDR32, THCON_SEC1_REG6_Metadata_misc_SHAMT, THCON_SEC1_REG6_Metadata_misc_MASK

#define THCON_SEC1_REG7_Offset_address_ADDR32 140
#define THCON_SEC1_REG7_Offset_address_SHAMT 0
#define THCON_SEC1_REG7_Offset_address_MASK 0xffff
#define THCON_SEC1_REG7_Offset_address_RMW \
    THCON_SEC1_REG7_Offset_address_ADDR32, THCON_SEC1_REG7_Offset_address_SHAMT, THCON_SEC1_REG7_Offset_address_MASK

#define THCON_SEC1_REG7_Unpack_data_format_cntx0_ADDR32 140
#define THCON_SEC1_REG7_Unpack_data_format_cntx0_SHAMT 16
#define THCON_SEC1_REG7_Unpack_data_format_cntx0_MASK 0xf0000
#define THCON_SEC1_REG7_Unpack_data_format_cntx0_RMW                                                 \
    THCON_SEC1_REG7_Unpack_data_format_cntx0_ADDR32, THCON_SEC1_REG7_Unpack_data_format_cntx0_SHAMT, \
        THCON_SEC1_REG7_Unpack_data_format_cntx0_MASK

#define THCON_SEC1_REG7_Unpack_out_data_format_cntx0_ADDR32 140
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx0_SHAMT 20
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx0_MASK 0xf00000
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx0_RMW                                                     \
    THCON_SEC1_REG7_Unpack_out_data_format_cntx0_ADDR32, THCON_SEC1_REG7_Unpack_out_data_format_cntx0_SHAMT, \
        THCON_SEC1_REG7_Unpack_out_data_format_cntx0_MASK

#define THCON_SEC1_REG7_Unpack_data_format_cntx4_ADDR32 140
#define THCON_SEC1_REG7_Unpack_data_format_cntx4_SHAMT 24
#define THCON_SEC1_REG7_Unpack_data_format_cntx4_MASK 0xf000000
#define THCON_SEC1_REG7_Unpack_data_format_cntx4_RMW                                                 \
    THCON_SEC1_REG7_Unpack_data_format_cntx4_ADDR32, THCON_SEC1_REG7_Unpack_data_format_cntx4_SHAMT, \
        THCON_SEC1_REG7_Unpack_data_format_cntx4_MASK

#define THCON_SEC1_REG7_Unpack_out_data_format_cntx4_ADDR32 140
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx4_SHAMT 28
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx4_MASK 0xf0000000
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx4_RMW                                                     \
    THCON_SEC1_REG7_Unpack_out_data_format_cntx4_ADDR32, THCON_SEC1_REG7_Unpack_out_data_format_cntx4_SHAMT, \
        THCON_SEC1_REG7_Unpack_out_data_format_cntx4_MASK

#define THCON_SEC1_REG7_Offset_cntx1_address_ADDR32 141
#define THCON_SEC1_REG7_Offset_cntx1_address_SHAMT 0
#define THCON_SEC1_REG7_Offset_cntx1_address_MASK 0xffff
#define THCON_SEC1_REG7_Offset_cntx1_address_RMW                                             \
    THCON_SEC1_REG7_Offset_cntx1_address_ADDR32, THCON_SEC1_REG7_Offset_cntx1_address_SHAMT, \
        THCON_SEC1_REG7_Offset_cntx1_address_MASK

#define THCON_SEC1_REG7_Unpack_data_format_cntx1_ADDR32 141
#define THCON_SEC1_REG7_Unpack_data_format_cntx1_SHAMT 16
#define THCON_SEC1_REG7_Unpack_data_format_cntx1_MASK 0xf0000
#define THCON_SEC1_REG7_Unpack_data_format_cntx1_RMW                                                 \
    THCON_SEC1_REG7_Unpack_data_format_cntx1_ADDR32, THCON_SEC1_REG7_Unpack_data_format_cntx1_SHAMT, \
        THCON_SEC1_REG7_Unpack_data_format_cntx1_MASK

#define THCON_SEC1_REG7_Unpack_out_data_format_cntx1_ADDR32 141
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx1_SHAMT 20
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx1_MASK 0xf00000
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx1_RMW                                                     \
    THCON_SEC1_REG7_Unpack_out_data_format_cntx1_ADDR32, THCON_SEC1_REG7_Unpack_out_data_format_cntx1_SHAMT, \
        THCON_SEC1_REG7_Unpack_out_data_format_cntx1_MASK

#define THCON_SEC1_REG7_Unpack_data_format_cntx5_ADDR32 141
#define THCON_SEC1_REG7_Unpack_data_format_cntx5_SHAMT 24
#define THCON_SEC1_REG7_Unpack_data_format_cntx5_MASK 0xf000000
#define THCON_SEC1_REG7_Unpack_data_format_cntx5_RMW                                                 \
    THCON_SEC1_REG7_Unpack_data_format_cntx5_ADDR32, THCON_SEC1_REG7_Unpack_data_format_cntx5_SHAMT, \
        THCON_SEC1_REG7_Unpack_data_format_cntx5_MASK

#define THCON_SEC1_REG7_Unpack_out_data_format_cntx5_ADDR32 141
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx5_SHAMT 28
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx5_MASK 0xf0000000
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx5_RMW                                                     \
    THCON_SEC1_REG7_Unpack_out_data_format_cntx5_ADDR32, THCON_SEC1_REG7_Unpack_out_data_format_cntx5_SHAMT, \
        THCON_SEC1_REG7_Unpack_out_data_format_cntx5_MASK

#define THCON_SEC1_REG7_Offset_cntx2_address_ADDR32 142
#define THCON_SEC1_REG7_Offset_cntx2_address_SHAMT 0
#define THCON_SEC1_REG7_Offset_cntx2_address_MASK 0xffff
#define THCON_SEC1_REG7_Offset_cntx2_address_RMW                                             \
    THCON_SEC1_REG7_Offset_cntx2_address_ADDR32, THCON_SEC1_REG7_Offset_cntx2_address_SHAMT, \
        THCON_SEC1_REG7_Offset_cntx2_address_MASK

#define THCON_SEC1_REG7_Unpack_data_format_cntx2_ADDR32 142
#define THCON_SEC1_REG7_Unpack_data_format_cntx2_SHAMT 16
#define THCON_SEC1_REG7_Unpack_data_format_cntx2_MASK 0xf0000
#define THCON_SEC1_REG7_Unpack_data_format_cntx2_RMW                                                 \
    THCON_SEC1_REG7_Unpack_data_format_cntx2_ADDR32, THCON_SEC1_REG7_Unpack_data_format_cntx2_SHAMT, \
        THCON_SEC1_REG7_Unpack_data_format_cntx2_MASK

#define THCON_SEC1_REG7_Unpack_out_data_format_cntx2_ADDR32 142
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx2_SHAMT 20
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx2_MASK 0xf00000
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx2_RMW                                                     \
    THCON_SEC1_REG7_Unpack_out_data_format_cntx2_ADDR32, THCON_SEC1_REG7_Unpack_out_data_format_cntx2_SHAMT, \
        THCON_SEC1_REG7_Unpack_out_data_format_cntx2_MASK

#define THCON_SEC1_REG7_Unpack_data_format_cntx6_ADDR32 142
#define THCON_SEC1_REG7_Unpack_data_format_cntx6_SHAMT 24
#define THCON_SEC1_REG7_Unpack_data_format_cntx6_MASK 0xf000000
#define THCON_SEC1_REG7_Unpack_data_format_cntx6_RMW                                                 \
    THCON_SEC1_REG7_Unpack_data_format_cntx6_ADDR32, THCON_SEC1_REG7_Unpack_data_format_cntx6_SHAMT, \
        THCON_SEC1_REG7_Unpack_data_format_cntx6_MASK

#define THCON_SEC1_REG7_Unpack_out_data_format_cntx6_ADDR32 142
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx6_SHAMT 28
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx6_MASK 0xf0000000
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx6_RMW                                                     \
    THCON_SEC1_REG7_Unpack_out_data_format_cntx6_ADDR32, THCON_SEC1_REG7_Unpack_out_data_format_cntx6_SHAMT, \
        THCON_SEC1_REG7_Unpack_out_data_format_cntx6_MASK

#define THCON_SEC1_REG7_Offset_cntx3_address_ADDR32 143
#define THCON_SEC1_REG7_Offset_cntx3_address_SHAMT 0
#define THCON_SEC1_REG7_Offset_cntx3_address_MASK 0xffff
#define THCON_SEC1_REG7_Offset_cntx3_address_RMW                                             \
    THCON_SEC1_REG7_Offset_cntx3_address_ADDR32, THCON_SEC1_REG7_Offset_cntx3_address_SHAMT, \
        THCON_SEC1_REG7_Offset_cntx3_address_MASK

#define THCON_SEC1_REG7_Unpack_data_format_cntx3_ADDR32 143
#define THCON_SEC1_REG7_Unpack_data_format_cntx3_SHAMT 16
#define THCON_SEC1_REG7_Unpack_data_format_cntx3_MASK 0xf0000
#define THCON_SEC1_REG7_Unpack_data_format_cntx3_RMW                                                 \
    THCON_SEC1_REG7_Unpack_data_format_cntx3_ADDR32, THCON_SEC1_REG7_Unpack_data_format_cntx3_SHAMT, \
        THCON_SEC1_REG7_Unpack_data_format_cntx3_MASK

#define THCON_SEC1_REG7_Unpack_out_data_format_cntx3_ADDR32 143
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx3_SHAMT 20
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx3_MASK 0xf00000
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx3_RMW                                                     \
    THCON_SEC1_REG7_Unpack_out_data_format_cntx3_ADDR32, THCON_SEC1_REG7_Unpack_out_data_format_cntx3_SHAMT, \
        THCON_SEC1_REG7_Unpack_out_data_format_cntx3_MASK

#define THCON_SEC1_REG7_Unpack_data_format_cntx7_ADDR32 143
#define THCON_SEC1_REG7_Unpack_data_format_cntx7_SHAMT 24
#define THCON_SEC1_REG7_Unpack_data_format_cntx7_MASK 0xf000000
#define THCON_SEC1_REG7_Unpack_data_format_cntx7_RMW                                                 \
    THCON_SEC1_REG7_Unpack_data_format_cntx7_ADDR32, THCON_SEC1_REG7_Unpack_data_format_cntx7_SHAMT, \
        THCON_SEC1_REG7_Unpack_data_format_cntx7_MASK

#define THCON_SEC1_REG7_Unpack_out_data_format_cntx7_ADDR32 143
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx7_SHAMT 28
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx7_MASK 0xf0000000
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx7_RMW                                                     \
    THCON_SEC1_REG7_Unpack_out_data_format_cntx7_ADDR32, THCON_SEC1_REG7_Unpack_out_data_format_cntx7_SHAMT, \
        THCON_SEC1_REG7_Unpack_out_data_format_cntx7_MASK

#define THCON_SEC1_REG8_Row_start_section_size_ADDR32 144
#define THCON_SEC1_REG8_Row_start_section_size_SHAMT 0
#define THCON_SEC1_REG8_Row_start_section_size_MASK 0xffff
#define THCON_SEC1_REG8_Row_start_section_size_RMW                                               \
    THCON_SEC1_REG8_Row_start_section_size_ADDR32, THCON_SEC1_REG8_Row_start_section_size_SHAMT, \
        THCON_SEC1_REG8_Row_start_section_size_MASK

#define THCON_SEC1_REG8_Exp_section_size_ADDR32 144
#define THCON_SEC1_REG8_Exp_section_size_SHAMT 16
#define THCON_SEC1_REG8_Exp_section_size_MASK 0xffff0000
#define THCON_SEC1_REG8_Exp_section_size_RMW                                         \
    THCON_SEC1_REG8_Exp_section_size_ADDR32, THCON_SEC1_REG8_Exp_section_size_SHAMT, \
        THCON_SEC1_REG8_Exp_section_size_MASK

#define THCON_SEC1_REG8_L1_Dest_addr_ADDR32 145
#define THCON_SEC1_REG8_L1_Dest_addr_SHAMT 0
#define THCON_SEC1_REG8_L1_Dest_addr_MASK 0xffffffff
#define THCON_SEC1_REG8_L1_Dest_addr_RMW \
    THCON_SEC1_REG8_L1_Dest_addr_ADDR32, THCON_SEC1_REG8_L1_Dest_addr_SHAMT, THCON_SEC1_REG8_L1_Dest_addr_MASK

#define THCON_SEC1_REG8_Disable_zero_compress_ADDR32 146
#define THCON_SEC1_REG8_Disable_zero_compress_SHAMT 0
#define THCON_SEC1_REG8_Disable_zero_compress_MASK 0x1
#define THCON_SEC1_REG8_Disable_zero_compress_RMW                                              \
    THCON_SEC1_REG8_Disable_zero_compress_ADDR32, THCON_SEC1_REG8_Disable_zero_compress_SHAMT, \
        THCON_SEC1_REG8_Disable_zero_compress_MASK

#define THCON_SEC1_REG8_Add_l1_dest_addr_offset_ADDR32 146
#define THCON_SEC1_REG8_Add_l1_dest_addr_offset_SHAMT 1
#define THCON_SEC1_REG8_Add_l1_dest_addr_offset_MASK 0x2
#define THCON_SEC1_REG8_Add_l1_dest_addr_offset_RMW                                                \
    THCON_SEC1_REG8_Add_l1_dest_addr_offset_ADDR32, THCON_SEC1_REG8_Add_l1_dest_addr_offset_SHAMT, \
        THCON_SEC1_REG8_Add_l1_dest_addr_offset_MASK

#define THCON_SEC1_REG8_Disable_pack_zero_flags_ADDR32 146
#define THCON_SEC1_REG8_Disable_pack_zero_flags_SHAMT 2
#define THCON_SEC1_REG8_Disable_pack_zero_flags_MASK 0x4
#define THCON_SEC1_REG8_Disable_pack_zero_flags_RMW                                                \
    THCON_SEC1_REG8_Disable_pack_zero_flags_ADDR32, THCON_SEC1_REG8_Disable_pack_zero_flags_SHAMT, \
        THCON_SEC1_REG8_Disable_pack_zero_flags_MASK

#define THCON_SEC1_REG8_Unused1_ADDR32 146
#define THCON_SEC1_REG8_Unused1_SHAMT 3
#define THCON_SEC1_REG8_Unused1_MASK 0x8
#define THCON_SEC1_REG8_Unused1_RMW \
    THCON_SEC1_REG8_Unused1_ADDR32, THCON_SEC1_REG8_Unused1_SHAMT, THCON_SEC1_REG8_Unused1_MASK

#define THCON_SEC1_REG8_Out_data_format_ADDR32 146
#define THCON_SEC1_REG8_Out_data_format_SHAMT 4
#define THCON_SEC1_REG8_Out_data_format_MASK 0xf0
#define THCON_SEC1_REG8_Out_data_format_RMW \
    THCON_SEC1_REG8_Out_data_format_ADDR32, THCON_SEC1_REG8_Out_data_format_SHAMT, THCON_SEC1_REG8_Out_data_format_MASK

#define THCON_SEC1_REG8_In_data_format_ADDR32 146
#define THCON_SEC1_REG8_In_data_format_SHAMT 8
#define THCON_SEC1_REG8_In_data_format_MASK 0xf00
#define THCON_SEC1_REG8_In_data_format_RMW \
    THCON_SEC1_REG8_In_data_format_ADDR32, THCON_SEC1_REG8_In_data_format_SHAMT, THCON_SEC1_REG8_In_data_format_MASK

#define THCON_SEC1_REG8_Dis_shared_exp_assembler_ADDR32 146
#define THCON_SEC1_REG8_Dis_shared_exp_assembler_SHAMT 12
#define THCON_SEC1_REG8_Dis_shared_exp_assembler_MASK 0x1000
#define THCON_SEC1_REG8_Dis_shared_exp_assembler_RMW                                                 \
    THCON_SEC1_REG8_Dis_shared_exp_assembler_ADDR32, THCON_SEC1_REG8_Dis_shared_exp_assembler_SHAMT, \
        THCON_SEC1_REG8_Dis_shared_exp_assembler_MASK

#define THCON_SEC1_REG8_Auto_set_last_pacr_intf_sel_ADDR32 146
#define THCON_SEC1_REG8_Auto_set_last_pacr_intf_sel_SHAMT 13
#define THCON_SEC1_REG8_Auto_set_last_pacr_intf_sel_MASK 0x2000
#define THCON_SEC1_REG8_Auto_set_last_pacr_intf_sel_RMW                                                    \
    THCON_SEC1_REG8_Auto_set_last_pacr_intf_sel_ADDR32, THCON_SEC1_REG8_Auto_set_last_pacr_intf_sel_SHAMT, \
        THCON_SEC1_REG8_Auto_set_last_pacr_intf_sel_MASK

#define THCON_SEC1_REG8_Enable_out_fifo_ADDR32 146
#define THCON_SEC1_REG8_Enable_out_fifo_SHAMT 14
#define THCON_SEC1_REG8_Enable_out_fifo_MASK 0x4000
#define THCON_SEC1_REG8_Enable_out_fifo_RMW \
    THCON_SEC1_REG8_Enable_out_fifo_ADDR32, THCON_SEC1_REG8_Enable_out_fifo_SHAMT, THCON_SEC1_REG8_Enable_out_fifo_MASK

#define THCON_SEC1_REG8_Sub_l1_tile_header_size_ADDR32 146
#define THCON_SEC1_REG8_Sub_l1_tile_header_size_SHAMT 15
#define THCON_SEC1_REG8_Sub_l1_tile_header_size_MASK 0x8000
#define THCON_SEC1_REG8_Sub_l1_tile_header_size_RMW                                                \
    THCON_SEC1_REG8_Sub_l1_tile_header_size_ADDR32, THCON_SEC1_REG8_Sub_l1_tile_header_size_SHAMT, \
        THCON_SEC1_REG8_Sub_l1_tile_header_size_MASK

#define THCON_SEC1_REG8_Source_interface_selection_ADDR32 146
#define THCON_SEC1_REG8_Source_interface_selection_SHAMT 16
#define THCON_SEC1_REG8_Source_interface_selection_MASK 0x10000
#define THCON_SEC1_REG8_Source_interface_selection_RMW                                                   \
    THCON_SEC1_REG8_Source_interface_selection_ADDR32, THCON_SEC1_REG8_Source_interface_selection_SHAMT, \
        THCON_SEC1_REG8_Source_interface_selection_MASK

#define THCON_SEC1_REG8_Add_tile_header_size_ADDR32 146
#define THCON_SEC1_REG8_Add_tile_header_size_SHAMT 17
#define THCON_SEC1_REG8_Add_tile_header_size_MASK 0x20000
#define THCON_SEC1_REG8_Add_tile_header_size_RMW                                             \
    THCON_SEC1_REG8_Add_tile_header_size_ADDR32, THCON_SEC1_REG8_Add_tile_header_size_SHAMT, \
        THCON_SEC1_REG8_Add_tile_header_size_MASK

#define THCON_SEC1_REG8_pack_dis_y_pos_start_offset_ADDR32 146
#define THCON_SEC1_REG8_pack_dis_y_pos_start_offset_SHAMT 18
#define THCON_SEC1_REG8_pack_dis_y_pos_start_offset_MASK 0x40000
#define THCON_SEC1_REG8_pack_dis_y_pos_start_offset_RMW                                                    \
    THCON_SEC1_REG8_pack_dis_y_pos_start_offset_ADDR32, THCON_SEC1_REG8_pack_dis_y_pos_start_offset_SHAMT, \
        THCON_SEC1_REG8_pack_dis_y_pos_start_offset_MASK

#define THCON_SEC1_REG8_unpack_tile_offset_ADDR32 146
#define THCON_SEC1_REG8_unpack_tile_offset_SHAMT 19
#define THCON_SEC1_REG8_unpack_tile_offset_MASK 0xf80000
#define THCON_SEC1_REG8_unpack_tile_offset_RMW                                           \
    THCON_SEC1_REG8_unpack_tile_offset_ADDR32, THCON_SEC1_REG8_unpack_tile_offset_SHAMT, \
        THCON_SEC1_REG8_unpack_tile_offset_MASK

#define THCON_SEC1_REG8_L1_source_addr_ADDR32 146
#define THCON_SEC1_REG8_L1_source_addr_SHAMT 24
#define THCON_SEC1_REG8_L1_source_addr_MASK 0xff000000
#define THCON_SEC1_REG8_L1_source_addr_RMW \
    THCON_SEC1_REG8_L1_source_addr_ADDR32, THCON_SEC1_REG8_L1_source_addr_SHAMT, THCON_SEC1_REG8_L1_source_addr_MASK

#define THCON_SEC1_REG8_Downsample_mask_ADDR32 147
#define THCON_SEC1_REG8_Downsample_mask_SHAMT 0
#define THCON_SEC1_REG8_Downsample_mask_MASK 0xffff
#define THCON_SEC1_REG8_Downsample_mask_RMW \
    THCON_SEC1_REG8_Downsample_mask_ADDR32, THCON_SEC1_REG8_Downsample_mask_SHAMT, THCON_SEC1_REG8_Downsample_mask_MASK

#define THCON_SEC1_REG8_Downsample_rate_ADDR32 147
#define THCON_SEC1_REG8_Downsample_rate_SHAMT 16
#define THCON_SEC1_REG8_Downsample_rate_MASK 0x70000
#define THCON_SEC1_REG8_Downsample_rate_RMW \
    THCON_SEC1_REG8_Downsample_rate_ADDR32, THCON_SEC1_REG8_Downsample_rate_SHAMT, THCON_SEC1_REG8_Downsample_rate_MASK

#define THCON_SEC1_REG8_Pack_L1_Acc_ADDR32 147
#define THCON_SEC1_REG8_Pack_L1_Acc_SHAMT 19
#define THCON_SEC1_REG8_Pack_L1_Acc_MASK 0x80000
#define THCON_SEC1_REG8_Pack_L1_Acc_RMW \
    THCON_SEC1_REG8_Pack_L1_Acc_ADDR32, THCON_SEC1_REG8_Pack_L1_Acc_SHAMT, THCON_SEC1_REG8_Pack_L1_Acc_MASK

#define THCON_SEC1_REG8_Exp_threshold_en_ADDR32 147
#define THCON_SEC1_REG8_Exp_threshold_en_SHAMT 20
#define THCON_SEC1_REG8_Exp_threshold_en_MASK 0x100000
#define THCON_SEC1_REG8_Exp_threshold_en_RMW                                         \
    THCON_SEC1_REG8_Exp_threshold_en_ADDR32, THCON_SEC1_REG8_Exp_threshold_en_SHAMT, \
        THCON_SEC1_REG8_Exp_threshold_en_MASK

#define THCON_SEC1_REG8_Exp_threshold_ADDR32 147
#define THCON_SEC1_REG8_Exp_threshold_SHAMT 24
#define THCON_SEC1_REG8_Exp_threshold_MASK 0xff000000
#define THCON_SEC1_REG8_Exp_threshold_RMW \
    THCON_SEC1_REG8_Exp_threshold_ADDR32, THCON_SEC1_REG8_Exp_threshold_SHAMT, THCON_SEC1_REG8_Exp_threshold_MASK

#define THCON_SEC1_REG9_Pack_0_2_limit_address_ADDR32 148
#define THCON_SEC1_REG9_Pack_0_2_limit_address_SHAMT 0
#define THCON_SEC1_REG9_Pack_0_2_limit_address_MASK 0x1ffff
#define THCON_SEC1_REG9_Pack_0_2_limit_address_RMW                                               \
    THCON_SEC1_REG9_Pack_0_2_limit_address_ADDR32, THCON_SEC1_REG9_Pack_0_2_limit_address_SHAMT, \
        THCON_SEC1_REG9_Pack_0_2_limit_address_MASK

#define THCON_SEC1_REG9_Pack_0_2_fifo_size_ADDR32 149
#define THCON_SEC1_REG9_Pack_0_2_fifo_size_SHAMT 0
#define THCON_SEC1_REG9_Pack_0_2_fifo_size_MASK 0x1ffff
#define THCON_SEC1_REG9_Pack_0_2_fifo_size_RMW                                           \
    THCON_SEC1_REG9_Pack_0_2_fifo_size_ADDR32, THCON_SEC1_REG9_Pack_0_2_fifo_size_SHAMT, \
        THCON_SEC1_REG9_Pack_0_2_fifo_size_MASK

#define THCON_SEC1_REG9_Pack_1_3_limit_address_ADDR32 150
#define THCON_SEC1_REG9_Pack_1_3_limit_address_SHAMT 0
#define THCON_SEC1_REG9_Pack_1_3_limit_address_MASK 0x1ffff
#define THCON_SEC1_REG9_Pack_1_3_limit_address_RMW                                               \
    THCON_SEC1_REG9_Pack_1_3_limit_address_ADDR32, THCON_SEC1_REG9_Pack_1_3_limit_address_SHAMT, \
        THCON_SEC1_REG9_Pack_1_3_limit_address_MASK

#define THCON_SEC1_REG9_Pack_1_3_fifo_size_ADDR32 151
#define THCON_SEC1_REG9_Pack_1_3_fifo_size_SHAMT 0
#define THCON_SEC1_REG9_Pack_1_3_fifo_size_MASK 0x1ffff
#define THCON_SEC1_REG9_Pack_1_3_fifo_size_RMW                                           \
    THCON_SEC1_REG9_Pack_1_3_fifo_size_ADDR32, THCON_SEC1_REG9_Pack_1_3_fifo_size_SHAMT, \
        THCON_SEC1_REG9_Pack_1_3_fifo_size_MASK

#define THCON_SEC1_REG10_Unpack_limit_address_ADDR32 152
#define THCON_SEC1_REG10_Unpack_limit_address_SHAMT 0
#define THCON_SEC1_REG10_Unpack_limit_address_MASK 0x1ffff
#define THCON_SEC1_REG10_Unpack_limit_address_RMW                                              \
    THCON_SEC1_REG10_Unpack_limit_address_ADDR32, THCON_SEC1_REG10_Unpack_limit_address_SHAMT, \
        THCON_SEC1_REG10_Unpack_limit_address_MASK

#define THCON_SEC1_REG10_Unpack_fifo_size_ADDR32 153
#define THCON_SEC1_REG10_Unpack_fifo_size_SHAMT 0
#define THCON_SEC1_REG10_Unpack_fifo_size_MASK 0x1ffff
#define THCON_SEC1_REG10_Unpack_fifo_size_RMW                                          \
    THCON_SEC1_REG10_Unpack_fifo_size_ADDR32, THCON_SEC1_REG10_Unpack_fifo_size_SHAMT, \
        THCON_SEC1_REG10_Unpack_fifo_size_MASK

#define THCON_SEC1_REG10_Unpack_limit_address_en_ADDR32 153
#define THCON_SEC1_REG10_Unpack_limit_address_en_SHAMT 17
#define THCON_SEC1_REG10_Unpack_limit_address_en_MASK 0x20000
#define THCON_SEC1_REG10_Unpack_limit_address_en_RMW                                                 \
    THCON_SEC1_REG10_Unpack_limit_address_en_ADDR32, THCON_SEC1_REG10_Unpack_limit_address_en_SHAMT, \
        THCON_SEC1_REG10_Unpack_limit_address_en_MASK

#define THCON_SEC1_REG10_Unpacker_Reg_Wr_Addr_ADDR32 154
#define THCON_SEC1_REG10_Unpacker_Reg_Wr_Addr_SHAMT 0
#define THCON_SEC1_REG10_Unpacker_Reg_Wr_Addr_MASK 0xffffff
#define THCON_SEC1_REG10_Unpacker_Reg_Wr_Addr_RMW                                              \
    THCON_SEC1_REG10_Unpacker_Reg_Wr_Addr_ADDR32, THCON_SEC1_REG10_Unpacker_Reg_Wr_Addr_SHAMT, \
        THCON_SEC1_REG10_Unpacker_Reg_Wr_Addr_MASK

#define THCON_SEC1_REG10_Packer_Reg_Wr_Addr_ADDR32 155
#define THCON_SEC1_REG10_Packer_Reg_Wr_Addr_SHAMT 0
#define THCON_SEC1_REG10_Packer_Reg_Wr_Addr_MASK 0xffffff
#define THCON_SEC1_REG10_Packer_Reg_Wr_Addr_RMW                                            \
    THCON_SEC1_REG10_Packer_Reg_Wr_Addr_ADDR32, THCON_SEC1_REG10_Packer_Reg_Wr_Addr_SHAMT, \
        THCON_SEC1_REG10_Packer_Reg_Wr_Addr_MASK

#define THCON_SEC1_REG11_Metadata_l1_addr_ADDR32 156
#define THCON_SEC1_REG11_Metadata_l1_addr_SHAMT 0
#define THCON_SEC1_REG11_Metadata_l1_addr_MASK 0xffffffff
#define THCON_SEC1_REG11_Metadata_l1_addr_RMW                                          \
    THCON_SEC1_REG11_Metadata_l1_addr_ADDR32, THCON_SEC1_REG11_Metadata_l1_addr_SHAMT, \
        THCON_SEC1_REG11_Metadata_l1_addr_MASK

#define THCON_SEC1_REG11_Metadata_limit_addr_ADDR32 157
#define THCON_SEC1_REG11_Metadata_limit_addr_SHAMT 0
#define THCON_SEC1_REG11_Metadata_limit_addr_MASK 0xffffffff
#define THCON_SEC1_REG11_Metadata_limit_addr_RMW                                             \
    THCON_SEC1_REG11_Metadata_limit_addr_ADDR32, THCON_SEC1_REG11_Metadata_limit_addr_SHAMT, \
        THCON_SEC1_REG11_Metadata_limit_addr_MASK

#define THCON_SEC1_REG11_Metadata_fifo_size_ADDR32 158
#define THCON_SEC1_REG11_Metadata_fifo_size_SHAMT 0
#define THCON_SEC1_REG11_Metadata_fifo_size_MASK 0xffffffff
#define THCON_SEC1_REG11_Metadata_fifo_size_RMW                                            \
    THCON_SEC1_REG11_Metadata_fifo_size_ADDR32, THCON_SEC1_REG11_Metadata_fifo_size_SHAMT, \
        THCON_SEC1_REG11_Metadata_fifo_size_MASK

#define THCON_SEC1_REG11_Metadata_z_cntr_rst_unpacr_count_ADDR32 159
#define THCON_SEC1_REG11_Metadata_z_cntr_rst_unpacr_count_SHAMT 0
#define THCON_SEC1_REG11_Metadata_z_cntr_rst_unpacr_count_MASK 0xff
#define THCON_SEC1_REG11_Metadata_z_cntr_rst_unpacr_count_RMW                                                          \
    THCON_SEC1_REG11_Metadata_z_cntr_rst_unpacr_count_ADDR32, THCON_SEC1_REG11_Metadata_z_cntr_rst_unpacr_count_SHAMT, \
        THCON_SEC1_REG11_Metadata_z_cntr_rst_unpacr_count_MASK

#define THCON_SEC1_REG11_Metadata_cntxt_switch_unpacr_count_ADDR32 159
#define THCON_SEC1_REG11_Metadata_cntxt_switch_unpacr_count_SHAMT 8
#define THCON_SEC1_REG11_Metadata_cntxt_switch_unpacr_count_MASK 0xff00
#define THCON_SEC1_REG11_Metadata_cntxt_switch_unpacr_count_RMW    \
    THCON_SEC1_REG11_Metadata_cntxt_switch_unpacr_count_ADDR32,    \
        THCON_SEC1_REG11_Metadata_cntxt_switch_unpacr_count_SHAMT, \
        THCON_SEC1_REG11_Metadata_cntxt_switch_unpacr_count_MASK

////////////////////////////////////////////////////////////////////////
// Registers for GLOBAL
////////////////////////////////////////////////////////////////////////

#define GLOBAL_CFGREG_BASE_ADDR32 180

#define DEST_TARGET_REG_CFG_PACK_SEC0_Offset_ADDR32 180
#define DEST_TARGET_REG_CFG_PACK_SEC0_Offset_SHAMT 0
#define DEST_TARGET_REG_CFG_PACK_SEC0_Offset_MASK 0xfff
#define DEST_TARGET_REG_CFG_PACK_SEC0_Offset_RMW                                             \
    DEST_TARGET_REG_CFG_PACK_SEC0_Offset_ADDR32, DEST_TARGET_REG_CFG_PACK_SEC0_Offset_SHAMT, \
        DEST_TARGET_REG_CFG_PACK_SEC0_Offset_MASK

#define DEST_TARGET_REG_CFG_PACK_SEC0_ZOffset_ADDR32 180
#define DEST_TARGET_REG_CFG_PACK_SEC0_ZOffset_SHAMT 12
#define DEST_TARGET_REG_CFG_PACK_SEC0_ZOffset_MASK 0x3f000
#define DEST_TARGET_REG_CFG_PACK_SEC0_ZOffset_RMW                                              \
    DEST_TARGET_REG_CFG_PACK_SEC0_ZOffset_ADDR32, DEST_TARGET_REG_CFG_PACK_SEC0_ZOffset_SHAMT, \
        DEST_TARGET_REG_CFG_PACK_SEC0_ZOffset_MASK

#define DEST_TARGET_REG_CFG_PACK_SEC1_Offset_ADDR32 181
#define DEST_TARGET_REG_CFG_PACK_SEC1_Offset_SHAMT 0
#define DEST_TARGET_REG_CFG_PACK_SEC1_Offset_MASK 0xfff
#define DEST_TARGET_REG_CFG_PACK_SEC1_Offset_RMW                                             \
    DEST_TARGET_REG_CFG_PACK_SEC1_Offset_ADDR32, DEST_TARGET_REG_CFG_PACK_SEC1_Offset_SHAMT, \
        DEST_TARGET_REG_CFG_PACK_SEC1_Offset_MASK

#define DEST_TARGET_REG_CFG_PACK_SEC1_ZOffset_ADDR32 181
#define DEST_TARGET_REG_CFG_PACK_SEC1_ZOffset_SHAMT 12
#define DEST_TARGET_REG_CFG_PACK_SEC1_ZOffset_MASK 0x3f000
#define DEST_TARGET_REG_CFG_PACK_SEC1_ZOffset_RMW                                              \
    DEST_TARGET_REG_CFG_PACK_SEC1_ZOffset_ADDR32, DEST_TARGET_REG_CFG_PACK_SEC1_ZOffset_SHAMT, \
        DEST_TARGET_REG_CFG_PACK_SEC1_ZOffset_MASK

#define DEST_TARGET_REG_CFG_PACK_SEC2_Offset_ADDR32 182
#define DEST_TARGET_REG_CFG_PACK_SEC2_Offset_SHAMT 0
#define DEST_TARGET_REG_CFG_PACK_SEC2_Offset_MASK 0xfff
#define DEST_TARGET_REG_CFG_PACK_SEC2_Offset_RMW                                             \
    DEST_TARGET_REG_CFG_PACK_SEC2_Offset_ADDR32, DEST_TARGET_REG_CFG_PACK_SEC2_Offset_SHAMT, \
        DEST_TARGET_REG_CFG_PACK_SEC2_Offset_MASK

#define DEST_TARGET_REG_CFG_PACK_SEC2_ZOffset_ADDR32 182
#define DEST_TARGET_REG_CFG_PACK_SEC2_ZOffset_SHAMT 12
#define DEST_TARGET_REG_CFG_PACK_SEC2_ZOffset_MASK 0x3f000
#define DEST_TARGET_REG_CFG_PACK_SEC2_ZOffset_RMW                                              \
    DEST_TARGET_REG_CFG_PACK_SEC2_ZOffset_ADDR32, DEST_TARGET_REG_CFG_PACK_SEC2_ZOffset_SHAMT, \
        DEST_TARGET_REG_CFG_PACK_SEC2_ZOffset_MASK

#define DEST_TARGET_REG_CFG_PACK_SEC3_Offset_ADDR32 183
#define DEST_TARGET_REG_CFG_PACK_SEC3_Offset_SHAMT 0
#define DEST_TARGET_REG_CFG_PACK_SEC3_Offset_MASK 0xfff
#define DEST_TARGET_REG_CFG_PACK_SEC3_Offset_RMW                                             \
    DEST_TARGET_REG_CFG_PACK_SEC3_Offset_ADDR32, DEST_TARGET_REG_CFG_PACK_SEC3_Offset_SHAMT, \
        DEST_TARGET_REG_CFG_PACK_SEC3_Offset_MASK

#define DEST_TARGET_REG_CFG_PACK_SEC3_ZOffset_ADDR32 183
#define DEST_TARGET_REG_CFG_PACK_SEC3_ZOffset_SHAMT 12
#define DEST_TARGET_REG_CFG_PACK_SEC3_ZOffset_MASK 0x3f000
#define DEST_TARGET_REG_CFG_PACK_SEC3_ZOffset_RMW                                              \
    DEST_TARGET_REG_CFG_PACK_SEC3_ZOffset_ADDR32, DEST_TARGET_REG_CFG_PACK_SEC3_ZOffset_SHAMT, \
        DEST_TARGET_REG_CFG_PACK_SEC3_ZOffset_MASK

#define CG_SRC_PIPELINE_GateSrcAPipeEn_ADDR32 184
#define CG_SRC_PIPELINE_GateSrcAPipeEn_SHAMT 0
#define CG_SRC_PIPELINE_GateSrcAPipeEn_MASK 0x1
#define CG_SRC_PIPELINE_GateSrcAPipeEn_RMW \
    CG_SRC_PIPELINE_GateSrcAPipeEn_ADDR32, CG_SRC_PIPELINE_GateSrcAPipeEn_SHAMT, CG_SRC_PIPELINE_GateSrcAPipeEn_MASK

#define CG_SRC_PIPELINE_GateSrcBPipeEn_ADDR32 184
#define CG_SRC_PIPELINE_GateSrcBPipeEn_SHAMT 1
#define CG_SRC_PIPELINE_GateSrcBPipeEn_MASK 0x2
#define CG_SRC_PIPELINE_GateSrcBPipeEn_RMW \
    CG_SRC_PIPELINE_GateSrcBPipeEn_ADDR32, CG_SRC_PIPELINE_GateSrcBPipeEn_SHAMT, CG_SRC_PIPELINE_GateSrcBPipeEn_MASK

#define RISCV_IC_INVALIDATE_InvalidateAll_ADDR32 185
#define RISCV_IC_INVALIDATE_InvalidateAll_SHAMT 0
#define RISCV_IC_INVALIDATE_InvalidateAll_MASK 0x1f
#define RISCV_IC_INVALIDATE_InvalidateAll_RMW                                          \
    RISCV_IC_INVALIDATE_InvalidateAll_ADDR32, RISCV_IC_INVALIDATE_InvalidateAll_SHAMT, \
        RISCV_IC_INVALIDATE_InvalidateAll_MASK

#define PRNG_SEED_Seed_Val_ADDR32 186
#define PRNG_SEED_Seed_Val_SHAMT 0
#define PRNG_SEED_Seed_Val_MASK 0xffffffff
#define PRNG_SEED_Seed_Val_RMW PRNG_SEED_Seed_Val_ADDR32, PRNG_SEED_Seed_Val_SHAMT, PRNG_SEED_Seed_Val_MASK

#define INT_DESCALE_VALUES_SEC0_Value_ADDR32 187
#define INT_DESCALE_VALUES_SEC0_Value_SHAMT 0
#define INT_DESCALE_VALUES_SEC0_Value_MASK 0xffffffff
#define INT_DESCALE_VALUES_SEC0_Value_RMW \
    INT_DESCALE_VALUES_SEC0_Value_ADDR32, INT_DESCALE_VALUES_SEC0_Value_SHAMT, INT_DESCALE_VALUES_SEC0_Value_MASK

#define INT_DESCALE_VALUES_SEC1_Value_ADDR32 188
#define INT_DESCALE_VALUES_SEC1_Value_SHAMT 0
#define INT_DESCALE_VALUES_SEC1_Value_MASK 0xffffffff
#define INT_DESCALE_VALUES_SEC1_Value_RMW \
    INT_DESCALE_VALUES_SEC1_Value_ADDR32, INT_DESCALE_VALUES_SEC1_Value_SHAMT, INT_DESCALE_VALUES_SEC1_Value_MASK

#define INT_DESCALE_VALUES_SEC2_Value_ADDR32 189
#define INT_DESCALE_VALUES_SEC2_Value_SHAMT 0
#define INT_DESCALE_VALUES_SEC2_Value_MASK 0xffffffff
#define INT_DESCALE_VALUES_SEC2_Value_RMW \
    INT_DESCALE_VALUES_SEC2_Value_ADDR32, INT_DESCALE_VALUES_SEC2_Value_SHAMT, INT_DESCALE_VALUES_SEC2_Value_MASK

#define INT_DESCALE_VALUES_SEC3_Value_ADDR32 190
#define INT_DESCALE_VALUES_SEC3_Value_SHAMT 0
#define INT_DESCALE_VALUES_SEC3_Value_MASK 0xffffffff
#define INT_DESCALE_VALUES_SEC3_Value_RMW \
    INT_DESCALE_VALUES_SEC3_Value_ADDR32, INT_DESCALE_VALUES_SEC3_Value_SHAMT, INT_DESCALE_VALUES_SEC3_Value_MASK

#define INT_DESCALE_VALUES_SEC4_Value_ADDR32 191
#define INT_DESCALE_VALUES_SEC4_Value_SHAMT 0
#define INT_DESCALE_VALUES_SEC4_Value_MASK 0xffffffff
#define INT_DESCALE_VALUES_SEC4_Value_RMW \
    INT_DESCALE_VALUES_SEC4_Value_ADDR32, INT_DESCALE_VALUES_SEC4_Value_SHAMT, INT_DESCALE_VALUES_SEC4_Value_MASK

#define INT_DESCALE_VALUES_SEC5_Value_ADDR32 192
#define INT_DESCALE_VALUES_SEC5_Value_SHAMT 0
#define INT_DESCALE_VALUES_SEC5_Value_MASK 0xffffffff
#define INT_DESCALE_VALUES_SEC5_Value_RMW \
    INT_DESCALE_VALUES_SEC5_Value_ADDR32, INT_DESCALE_VALUES_SEC5_Value_SHAMT, INT_DESCALE_VALUES_SEC5_Value_MASK

#define INT_DESCALE_VALUES_SEC6_Value_ADDR32 193
#define INT_DESCALE_VALUES_SEC6_Value_SHAMT 0
#define INT_DESCALE_VALUES_SEC6_Value_MASK 0xffffffff
#define INT_DESCALE_VALUES_SEC6_Value_RMW \
    INT_DESCALE_VALUES_SEC6_Value_ADDR32, INT_DESCALE_VALUES_SEC6_Value_SHAMT, INT_DESCALE_VALUES_SEC6_Value_MASK

#define INT_DESCALE_VALUES_SEC7_Value_ADDR32 194
#define INT_DESCALE_VALUES_SEC7_Value_SHAMT 0
#define INT_DESCALE_VALUES_SEC7_Value_MASK 0xffffffff
#define INT_DESCALE_VALUES_SEC7_Value_RMW \
    INT_DESCALE_VALUES_SEC7_Value_ADDR32, INT_DESCALE_VALUES_SEC7_Value_SHAMT, INT_DESCALE_VALUES_SEC7_Value_MASK

#define INT_DESCALE_VALUES_SEC8_Value_ADDR32 195
#define INT_DESCALE_VALUES_SEC8_Value_SHAMT 0
#define INT_DESCALE_VALUES_SEC8_Value_MASK 0xffffffff
#define INT_DESCALE_VALUES_SEC8_Value_RMW \
    INT_DESCALE_VALUES_SEC8_Value_ADDR32, INT_DESCALE_VALUES_SEC8_Value_SHAMT, INT_DESCALE_VALUES_SEC8_Value_MASK

#define INT_DESCALE_VALUES_SEC9_Value_ADDR32 196
#define INT_DESCALE_VALUES_SEC9_Value_SHAMT 0
#define INT_DESCALE_VALUES_SEC9_Value_MASK 0xffffffff
#define INT_DESCALE_VALUES_SEC9_Value_RMW \
    INT_DESCALE_VALUES_SEC9_Value_ADDR32, INT_DESCALE_VALUES_SEC9_Value_SHAMT, INT_DESCALE_VALUES_SEC9_Value_MASK

#define INT_DESCALE_VALUES_SEC10_Value_ADDR32 197
#define INT_DESCALE_VALUES_SEC10_Value_SHAMT 0
#define INT_DESCALE_VALUES_SEC10_Value_MASK 0xffffffff
#define INT_DESCALE_VALUES_SEC10_Value_RMW \
    INT_DESCALE_VALUES_SEC10_Value_ADDR32, INT_DESCALE_VALUES_SEC10_Value_SHAMT, INT_DESCALE_VALUES_SEC10_Value_MASK

#define INT_DESCALE_VALUES_SEC11_Value_ADDR32 198
#define INT_DESCALE_VALUES_SEC11_Value_SHAMT 0
#define INT_DESCALE_VALUES_SEC11_Value_MASK 0xffffffff
#define INT_DESCALE_VALUES_SEC11_Value_RMW \
    INT_DESCALE_VALUES_SEC11_Value_ADDR32, INT_DESCALE_VALUES_SEC11_Value_SHAMT, INT_DESCALE_VALUES_SEC11_Value_MASK

#define INT_DESCALE_VALUES_SEC12_Value_ADDR32 199
#define INT_DESCALE_VALUES_SEC12_Value_SHAMT 0
#define INT_DESCALE_VALUES_SEC12_Value_MASK 0xffffffff
#define INT_DESCALE_VALUES_SEC12_Value_RMW \
    INT_DESCALE_VALUES_SEC12_Value_ADDR32, INT_DESCALE_VALUES_SEC12_Value_SHAMT, INT_DESCALE_VALUES_SEC12_Value_MASK

#define INT_DESCALE_VALUES_SEC13_Value_ADDR32 200
#define INT_DESCALE_VALUES_SEC13_Value_SHAMT 0
#define INT_DESCALE_VALUES_SEC13_Value_MASK 0xffffffff
#define INT_DESCALE_VALUES_SEC13_Value_RMW \
    INT_DESCALE_VALUES_SEC13_Value_ADDR32, INT_DESCALE_VALUES_SEC13_Value_SHAMT, INT_DESCALE_VALUES_SEC13_Value_MASK

#define INT_DESCALE_VALUES_SEC14_Value_ADDR32 201
#define INT_DESCALE_VALUES_SEC14_Value_SHAMT 0
#define INT_DESCALE_VALUES_SEC14_Value_MASK 0xffffffff
#define INT_DESCALE_VALUES_SEC14_Value_RMW \
    INT_DESCALE_VALUES_SEC14_Value_ADDR32, INT_DESCALE_VALUES_SEC14_Value_SHAMT, INT_DESCALE_VALUES_SEC14_Value_MASK

#define INT_DESCALE_VALUES_SEC15_Value_ADDR32 202
#define INT_DESCALE_VALUES_SEC15_Value_SHAMT 0
#define INT_DESCALE_VALUES_SEC15_Value_MASK 0xffffffff
#define INT_DESCALE_VALUES_SEC15_Value_RMW \
    INT_DESCALE_VALUES_SEC15_Value_ADDR32, INT_DESCALE_VALUES_SEC15_Value_SHAMT, INT_DESCALE_VALUES_SEC15_Value_MASK

#define TRISC_END_PC_SEC0_PC_ADDR32 203
#define TRISC_END_PC_SEC0_PC_SHAMT 0
#define TRISC_END_PC_SEC0_PC_MASK 0xffffffff
#define TRISC_END_PC_SEC0_PC_RMW TRISC_END_PC_SEC0_PC_ADDR32, TRISC_END_PC_SEC0_PC_SHAMT, TRISC_END_PC_SEC0_PC_MASK

#define TRISC_END_PC_SEC1_PC_ADDR32 204
#define TRISC_END_PC_SEC1_PC_SHAMT 0
#define TRISC_END_PC_SEC1_PC_MASK 0xffffffff
#define TRISC_END_PC_SEC1_PC_RMW TRISC_END_PC_SEC1_PC_ADDR32, TRISC_END_PC_SEC1_PC_SHAMT, TRISC_END_PC_SEC1_PC_MASK

#define TRISC_END_PC_SEC2_PC_ADDR32 205
#define TRISC_END_PC_SEC2_PC_SHAMT 0
#define TRISC_END_PC_SEC2_PC_MASK 0xffffffff
#define TRISC_END_PC_SEC2_PC_RMW TRISC_END_PC_SEC2_PC_ADDR32, TRISC_END_PC_SEC2_PC_SHAMT, TRISC_END_PC_SEC2_PC_MASK

#define BRISC_END_PC_PC_ADDR32 206
#define BRISC_END_PC_PC_SHAMT 0
#define BRISC_END_PC_PC_MASK 0xffffffff
#define BRISC_END_PC_PC_RMW BRISC_END_PC_PC_ADDR32, BRISC_END_PC_PC_SHAMT, BRISC_END_PC_PC_MASK

#define NOC_RISC_END_PC_PC_ADDR32 207
#define NOC_RISC_END_PC_PC_SHAMT 0
#define NOC_RISC_END_PC_PC_MASK 0xffffffff
#define NOC_RISC_END_PC_PC_RMW NOC_RISC_END_PC_PC_ADDR32, NOC_RISC_END_PC_PC_SHAMT, NOC_RISC_END_PC_PC_MASK

#define RISC_PREFETCH_CTRL_Enable_Trisc_ADDR32 208
#define RISC_PREFETCH_CTRL_Enable_Trisc_SHAMT 0
#define RISC_PREFETCH_CTRL_Enable_Trisc_MASK 0x7
#define RISC_PREFETCH_CTRL_Enable_Trisc_RMW \
    RISC_PREFETCH_CTRL_Enable_Trisc_ADDR32, RISC_PREFETCH_CTRL_Enable_Trisc_SHAMT, RISC_PREFETCH_CTRL_Enable_Trisc_MASK

#define RISC_PREFETCH_CTRL_Enable_Brisc_ADDR32 208
#define RISC_PREFETCH_CTRL_Enable_Brisc_SHAMT 3
#define RISC_PREFETCH_CTRL_Enable_Brisc_MASK 0x8
#define RISC_PREFETCH_CTRL_Enable_Brisc_RMW \
    RISC_PREFETCH_CTRL_Enable_Brisc_ADDR32, RISC_PREFETCH_CTRL_Enable_Brisc_SHAMT, RISC_PREFETCH_CTRL_Enable_Brisc_MASK

#define RISC_PREFETCH_CTRL_Enable_NocRisc_ADDR32 208
#define RISC_PREFETCH_CTRL_Enable_NocRisc_SHAMT 4
#define RISC_PREFETCH_CTRL_Enable_NocRisc_MASK 0x10
#define RISC_PREFETCH_CTRL_Enable_NocRisc_RMW                                          \
    RISC_PREFETCH_CTRL_Enable_NocRisc_ADDR32, RISC_PREFETCH_CTRL_Enable_NocRisc_SHAMT, \
        RISC_PREFETCH_CTRL_Enable_NocRisc_MASK

#define RISC_PREFETCH_CTRL_Max_Req_Count_ADDR32 208
#define RISC_PREFETCH_CTRL_Max_Req_Count_SHAMT 5
#define RISC_PREFETCH_CTRL_Max_Req_Count_MASK 0x1fe0
#define RISC_PREFETCH_CTRL_Max_Req_Count_RMW                                         \
    RISC_PREFETCH_CTRL_Max_Req_Count_ADDR32, RISC_PREFETCH_CTRL_Max_Req_Count_SHAMT, \
        RISC_PREFETCH_CTRL_Max_Req_Count_MASK

#define SCRATCH_SEC0_val_ADDR32 209
#define SCRATCH_SEC0_val_SHAMT 0
#define SCRATCH_SEC0_val_MASK 0xffffffff
#define SCRATCH_SEC0_val_RMW SCRATCH_SEC0_val_ADDR32, SCRATCH_SEC0_val_SHAMT, SCRATCH_SEC0_val_MASK

#define SCRATCH_SEC1_val_ADDR32 210
#define SCRATCH_SEC1_val_SHAMT 0
#define SCRATCH_SEC1_val_MASK 0xffffffff
#define SCRATCH_SEC1_val_RMW SCRATCH_SEC1_val_ADDR32, SCRATCH_SEC1_val_SHAMT, SCRATCH_SEC1_val_MASK

#define SCRATCH_SEC2_val_ADDR32 211
#define SCRATCH_SEC2_val_SHAMT 0
#define SCRATCH_SEC2_val_MASK 0xffffffff
#define SCRATCH_SEC2_val_RMW SCRATCH_SEC2_val_ADDR32, SCRATCH_SEC2_val_SHAMT, SCRATCH_SEC2_val_MASK

#define L1_CACHE_TAG_SEARCH_ACCEL_Search_Enable_ADDR32 212
#define L1_CACHE_TAG_SEARCH_ACCEL_Search_Enable_SHAMT 0
#define L1_CACHE_TAG_SEARCH_ACCEL_Search_Enable_MASK 0x1
#define L1_CACHE_TAG_SEARCH_ACCEL_Search_Enable_RMW                                                \
    L1_CACHE_TAG_SEARCH_ACCEL_Search_Enable_ADDR32, L1_CACHE_TAG_SEARCH_ACCEL_Search_Enable_SHAMT, \
        L1_CACHE_TAG_SEARCH_ACCEL_Search_Enable_MASK

#define L1_CACHE_TAG_SEARCH_ACCEL_Start_Addr_ADDR32 212
#define L1_CACHE_TAG_SEARCH_ACCEL_Start_Addr_SHAMT 1
#define L1_CACHE_TAG_SEARCH_ACCEL_Start_Addr_MASK 0x3fffe
#define L1_CACHE_TAG_SEARCH_ACCEL_Start_Addr_RMW                                             \
    L1_CACHE_TAG_SEARCH_ACCEL_Start_Addr_ADDR32, L1_CACHE_TAG_SEARCH_ACCEL_Start_Addr_SHAMT, \
        L1_CACHE_TAG_SEARCH_ACCEL_Start_Addr_MASK

#define L1_CACHE_TAG_SEARCH_ACCEL_End_Addr_ADDR32 213
#define L1_CACHE_TAG_SEARCH_ACCEL_End_Addr_SHAMT 0
#define L1_CACHE_TAG_SEARCH_ACCEL_End_Addr_MASK 0x1ffff
#define L1_CACHE_TAG_SEARCH_ACCEL_End_Addr_RMW                                           \
    L1_CACHE_TAG_SEARCH_ACCEL_End_Addr_ADDR32, L1_CACHE_TAG_SEARCH_ACCEL_End_Addr_SHAMT, \
        L1_CACHE_TAG_SEARCH_ACCEL_End_Addr_MASK

#define L1_CACHE_TAG_SEARCH_ACCEL_Tag_Value_low_ADDR32 214
#define L1_CACHE_TAG_SEARCH_ACCEL_Tag_Value_low_SHAMT 0
#define L1_CACHE_TAG_SEARCH_ACCEL_Tag_Value_low_MASK 0xffffffff
#define L1_CACHE_TAG_SEARCH_ACCEL_Tag_Value_low_RMW                                                \
    L1_CACHE_TAG_SEARCH_ACCEL_Tag_Value_low_ADDR32, L1_CACHE_TAG_SEARCH_ACCEL_Tag_Value_low_SHAMT, \
        L1_CACHE_TAG_SEARCH_ACCEL_Tag_Value_low_MASK

#define L1_CACHE_TAG_SEARCH_ACCEL_Tag_Value_high_ADDR32 215
#define L1_CACHE_TAG_SEARCH_ACCEL_Tag_Value_high_SHAMT 0
#define L1_CACHE_TAG_SEARCH_ACCEL_Tag_Value_high_MASK 0xffffffff
#define L1_CACHE_TAG_SEARCH_ACCEL_Tag_Value_high_RMW                                                 \
    L1_CACHE_TAG_SEARCH_ACCEL_Tag_Value_high_ADDR32, L1_CACHE_TAG_SEARCH_ACCEL_Tag_Value_high_SHAMT, \
        L1_CACHE_TAG_SEARCH_ACCEL_Tag_Value_high_MASK

#define L1_CACHE_TAG_SEARCH_ACCEL_Tag_Width_ADDR32 216
#define L1_CACHE_TAG_SEARCH_ACCEL_Tag_Width_SHAMT 0
#define L1_CACHE_TAG_SEARCH_ACCEL_Tag_Width_MASK 0x3
#define L1_CACHE_TAG_SEARCH_ACCEL_Tag_Width_RMW                                            \
    L1_CACHE_TAG_SEARCH_ACCEL_Tag_Width_ADDR32, L1_CACHE_TAG_SEARCH_ACCEL_Tag_Width_SHAMT, \
        L1_CACHE_TAG_SEARCH_ACCEL_Tag_Width_MASK

#define L1_CACHE_TAG_SEARCH_ACCEL_Valid_bit_section_start_addr_ADDR32 216
#define L1_CACHE_TAG_SEARCH_ACCEL_Valid_bit_section_start_addr_SHAMT 2
#define L1_CACHE_TAG_SEARCH_ACCEL_Valid_bit_section_start_addr_MASK 0x7fffc
#define L1_CACHE_TAG_SEARCH_ACCEL_Valid_bit_section_start_addr_RMW    \
    L1_CACHE_TAG_SEARCH_ACCEL_Valid_bit_section_start_addr_ADDR32,    \
        L1_CACHE_TAG_SEARCH_ACCEL_Valid_bit_section_start_addr_SHAMT, \
        L1_CACHE_TAG_SEARCH_ACCEL_Valid_bit_section_start_addr_MASK

#define L1_CACHE_TAG_SEARCH_ACCEL_Valid_bit_section_end_addr_ADDR32 217
#define L1_CACHE_TAG_SEARCH_ACCEL_Valid_bit_section_end_addr_SHAMT 0
#define L1_CACHE_TAG_SEARCH_ACCEL_Valid_bit_section_end_addr_MASK 0x1ffff
#define L1_CACHE_TAG_SEARCH_ACCEL_Valid_bit_section_end_addr_RMW    \
    L1_CACHE_TAG_SEARCH_ACCEL_Valid_bit_section_end_addr_ADDR32,    \
        L1_CACHE_TAG_SEARCH_ACCEL_Valid_bit_section_end_addr_SHAMT, \
        L1_CACHE_TAG_SEARCH_ACCEL_Valid_bit_section_end_addr_MASK

#define L1_CACHE_TAG_SEARCH_ACCEL_Data_Valid_bit_section_start_addr_ADDR32 218
#define L1_CACHE_TAG_SEARCH_ACCEL_Data_Valid_bit_section_start_addr_SHAMT 0
#define L1_CACHE_TAG_SEARCH_ACCEL_Data_Valid_bit_section_start_addr_MASK 0x1ffff
#define L1_CACHE_TAG_SEARCH_ACCEL_Data_Valid_bit_section_start_addr_RMW    \
    L1_CACHE_TAG_SEARCH_ACCEL_Data_Valid_bit_section_start_addr_ADDR32,    \
        L1_CACHE_TAG_SEARCH_ACCEL_Data_Valid_bit_section_start_addr_SHAMT, \
        L1_CACHE_TAG_SEARCH_ACCEL_Data_Valid_bit_section_start_addr_MASK

#define L1_CACHE_TAG_SEARCH_ACCEL_Data_Valid_chk_ADDR32 218
#define L1_CACHE_TAG_SEARCH_ACCEL_Data_Valid_chk_SHAMT 17
#define L1_CACHE_TAG_SEARCH_ACCEL_Data_Valid_chk_MASK 0x20000
#define L1_CACHE_TAG_SEARCH_ACCEL_Data_Valid_chk_RMW                                                 \
    L1_CACHE_TAG_SEARCH_ACCEL_Data_Valid_chk_ADDR32, L1_CACHE_TAG_SEARCH_ACCEL_Data_Valid_chk_SHAMT, \
        L1_CACHE_TAG_SEARCH_ACCEL_Data_Valid_chk_MASK

#define L1_CACHE_TAG_SEARCH_ACCEL_Data_Valid_offset_ADDR32 219
#define L1_CACHE_TAG_SEARCH_ACCEL_Data_Valid_offset_SHAMT 0
#define L1_CACHE_TAG_SEARCH_ACCEL_Data_Valid_offset_MASK 0xffffff
#define L1_CACHE_TAG_SEARCH_ACCEL_Data_Valid_offset_RMW                                                    \
    L1_CACHE_TAG_SEARCH_ACCEL_Data_Valid_offset_ADDR32, L1_CACHE_TAG_SEARCH_ACCEL_Data_Valid_offset_SHAMT, \
        L1_CACHE_TAG_SEARCH_ACCEL_Data_Valid_offset_MASK

#define L1_CACHE_TAG_SEARCH_ACCEL_Tag_inv_ADDR32 219
#define L1_CACHE_TAG_SEARCH_ACCEL_Tag_inv_SHAMT 24
#define L1_CACHE_TAG_SEARCH_ACCEL_Tag_inv_MASK 0x1000000
#define L1_CACHE_TAG_SEARCH_ACCEL_Tag_inv_RMW                                          \
    L1_CACHE_TAG_SEARCH_ACCEL_Tag_inv_ADDR32, L1_CACHE_TAG_SEARCH_ACCEL_Tag_inv_SHAMT, \
        L1_CACHE_TAG_SEARCH_ACCEL_Tag_inv_MASK

#define L1_CACHE_TAG_SEARCH_ACCEL_Tag_inv_all_ADDR32 219
#define L1_CACHE_TAG_SEARCH_ACCEL_Tag_inv_all_SHAMT 25
#define L1_CACHE_TAG_SEARCH_ACCEL_Tag_inv_all_MASK 0x2000000
#define L1_CACHE_TAG_SEARCH_ACCEL_Tag_inv_all_RMW                                              \
    L1_CACHE_TAG_SEARCH_ACCEL_Tag_inv_all_ADDR32, L1_CACHE_TAG_SEARCH_ACCEL_Tag_inv_all_SHAMT, \
        L1_CACHE_TAG_SEARCH_ACCEL_Tag_inv_all_MASK

#define L1_CACHE_TAG_SEARCH_ACCEL_Tag_alloc_ADDR32 219
#define L1_CACHE_TAG_SEARCH_ACCEL_Tag_alloc_SHAMT 26
#define L1_CACHE_TAG_SEARCH_ACCEL_Tag_alloc_MASK 0x4000000
#define L1_CACHE_TAG_SEARCH_ACCEL_Tag_alloc_RMW                                            \
    L1_CACHE_TAG_SEARCH_ACCEL_Tag_alloc_ADDR32, L1_CACHE_TAG_SEARCH_ACCEL_Tag_alloc_SHAMT, \
        L1_CACHE_TAG_SEARCH_ACCEL_Tag_alloc_MASK

#define DEST_ACCESS_CFG_swizzle_32b_ADDR32 220
#define DEST_ACCESS_CFG_swizzle_32b_SHAMT 0
#define DEST_ACCESS_CFG_swizzle_32b_MASK 0x1
#define DEST_ACCESS_CFG_swizzle_32b_RMW \
    DEST_ACCESS_CFG_swizzle_32b_ADDR32, DEST_ACCESS_CFG_swizzle_32b_SHAMT, DEST_ACCESS_CFG_swizzle_32b_MASK

#define DEST_ACCESS_CFG_remap_addrs_ADDR32 220
#define DEST_ACCESS_CFG_remap_addrs_SHAMT 1
#define DEST_ACCESS_CFG_remap_addrs_MASK 0x2
#define DEST_ACCESS_CFG_remap_addrs_RMW \
    DEST_ACCESS_CFG_remap_addrs_ADDR32, DEST_ACCESS_CFG_remap_addrs_SHAMT, DEST_ACCESS_CFG_remap_addrs_MASK

#define DEST_ACCESS_CFG_disable_full_write_dest_q_bypass_ADDR32 220
#define DEST_ACCESS_CFG_disable_full_write_dest_q_bypass_SHAMT 2
#define DEST_ACCESS_CFG_disable_full_write_dest_q_bypass_MASK 0x4
#define DEST_ACCESS_CFG_disable_full_write_dest_q_bypass_RMW                                                         \
    DEST_ACCESS_CFG_disable_full_write_dest_q_bypass_ADDR32, DEST_ACCESS_CFG_disable_full_write_dest_q_bypass_SHAMT, \
        DEST_ACCESS_CFG_disable_full_write_dest_q_bypass_MASK

#define DEST_ACCESS_CFG_zeroacc_absolute_tile_mode_ADDR32 220
#define DEST_ACCESS_CFG_zeroacc_absolute_tile_mode_SHAMT 3
#define DEST_ACCESS_CFG_zeroacc_absolute_tile_mode_MASK 0x8
#define DEST_ACCESS_CFG_zeroacc_absolute_tile_mode_RMW                                                   \
    DEST_ACCESS_CFG_zeroacc_absolute_tile_mode_ADDR32, DEST_ACCESS_CFG_zeroacc_absolute_tile_mode_SHAMT, \
        DEST_ACCESS_CFG_zeroacc_absolute_tile_mode_MASK

#define SRC_ACCESS_CFG_math_view_srca_as_one_bank_ADDR32 221
#define SRC_ACCESS_CFG_math_view_srca_as_one_bank_SHAMT 0
#define SRC_ACCESS_CFG_math_view_srca_as_one_bank_MASK 0x1
#define SRC_ACCESS_CFG_math_view_srca_as_one_bank_RMW                                                  \
    SRC_ACCESS_CFG_math_view_srca_as_one_bank_ADDR32, SRC_ACCESS_CFG_math_view_srca_as_one_bank_SHAMT, \
        SRC_ACCESS_CFG_math_view_srca_as_one_bank_MASK

#define SRC_ACCESS_CFG_math_view_srcb_as_one_bank_ADDR32 221
#define SRC_ACCESS_CFG_math_view_srcb_as_one_bank_SHAMT 1
#define SRC_ACCESS_CFG_math_view_srcb_as_one_bank_MASK 0x2
#define SRC_ACCESS_CFG_math_view_srcb_as_one_bank_RMW                                                  \
    SRC_ACCESS_CFG_math_view_srcb_as_one_bank_ADDR32, SRC_ACCESS_CFG_math_view_srcb_as_one_bank_SHAMT, \
        SRC_ACCESS_CFG_math_view_srcb_as_one_bank_MASK

#define SRC_ACCESS_CFG_disable_contig_srca_dvalid_phase_ADDR32 221
#define SRC_ACCESS_CFG_disable_contig_srca_dvalid_phase_SHAMT 2
#define SRC_ACCESS_CFG_disable_contig_srca_dvalid_phase_MASK 0x4
#define SRC_ACCESS_CFG_disable_contig_srca_dvalid_phase_RMW                                                        \
    SRC_ACCESS_CFG_disable_contig_srca_dvalid_phase_ADDR32, SRC_ACCESS_CFG_disable_contig_srca_dvalid_phase_SHAMT, \
        SRC_ACCESS_CFG_disable_contig_srca_dvalid_phase_MASK

#define SRC_ACCESS_CFG_disable_contig_srcb_dvalid_phase_ADDR32 221
#define SRC_ACCESS_CFG_disable_contig_srcb_dvalid_phase_SHAMT 3
#define SRC_ACCESS_CFG_disable_contig_srcb_dvalid_phase_MASK 0x8
#define SRC_ACCESS_CFG_disable_contig_srcb_dvalid_phase_RMW                                                        \
    SRC_ACCESS_CFG_disable_contig_srcb_dvalid_phase_ADDR32, SRC_ACCESS_CFG_disable_contig_srcb_dvalid_phase_SHAMT, \
        SRC_ACCESS_CFG_disable_contig_srcb_dvalid_phase_MASK

#define CHICKEN_BITS_sfpu_scbd_disable_ADDR32 222
#define CHICKEN_BITS_sfpu_scbd_disable_SHAMT 0
#define CHICKEN_BITS_sfpu_scbd_disable_MASK 0x1
#define CHICKEN_BITS_sfpu_scbd_disable_RMW \
    CHICKEN_BITS_sfpu_scbd_disable_ADDR32, CHICKEN_BITS_sfpu_scbd_disable_SHAMT, CHICKEN_BITS_sfpu_scbd_disable_MASK
