// SPDX-FileCopyrightText: © 2023 Tenstorrent Inc.
//
// SPDX-License-Identifier: Apache-2.0

////////////////////////////////////////////////////////////////////////
// File generated by
// ${ROOT}/src/meta/regspecs/src/genCfgRegs.py
// from
// ${ROOT}/src/meta/regspecs/yaml/local_regs_per_exu.yaml
//
// Constants for Tensix registers
//
////////////////////////////////////////////////////////////////////////

#pragma once

#define CFG_STATE_SIZE 47
#define THD_STATE_SIZE 57

////////////////////////////////////////////////////////////////////////
// Registers for THREAD
////////////////////////////////////////////////////////////////////////

#define THREAD_CFGREG_BASE_ADDR32 0

#define CFG_STATE_ID_StateID_ADDR32 0
#define CFG_STATE_ID_StateID_SHAMT 0
#define CFG_STATE_ID_StateID_MASK 0x1
#define CFG_STATE_ID_StateID_RMW CFG_STATE_ID_StateID_ADDR32, CFG_STATE_ID_StateID_SHAMT, CFG_STATE_ID_StateID_MASK

#define DEST_TARGET_REG_CFG_MATH_Offset_ADDR32 1
#define DEST_TARGET_REG_CFG_MATH_Offset_SHAMT 0
#define DEST_TARGET_REG_CFG_MATH_Offset_MASK 0xfff
#define DEST_TARGET_REG_CFG_MATH_Offset_RMW \
    DEST_TARGET_REG_CFG_MATH_Offset_ADDR32, DEST_TARGET_REG_CFG_MATH_Offset_SHAMT, DEST_TARGET_REG_CFG_MATH_Offset_MASK

#define ADDR_MOD_SET_Base_ADDR32 2
#define ADDR_MOD_SET_Base_SHAMT 0
#define ADDR_MOD_SET_Base_MASK 0x1
#define ADDR_MOD_SET_Base_RMW ADDR_MOD_SET_Base_ADDR32, ADDR_MOD_SET_Base_SHAMT, ADDR_MOD_SET_Base_MASK

#define SRCA_SET_Base_ADDR32 3
#define SRCA_SET_Base_SHAMT 0
#define SRCA_SET_Base_MASK 0x3
#define SRCA_SET_Base_RMW SRCA_SET_Base_ADDR32, SRCA_SET_Base_SHAMT, SRCA_SET_Base_MASK

#define SRCA_SET_SetOvrdWithAddr_ADDR32 3
#define SRCA_SET_SetOvrdWithAddr_SHAMT 2
#define SRCA_SET_SetOvrdWithAddr_MASK 0x4
#define SRCA_SET_SetOvrdWithAddr_RMW \
    SRCA_SET_SetOvrdWithAddr_ADDR32, SRCA_SET_SetOvrdWithAddr_SHAMT, SRCA_SET_SetOvrdWithAddr_MASK

#define SRCB_SET_Base_ADDR32 4
#define SRCB_SET_Base_SHAMT 0
#define SRCB_SET_Base_MASK 0x3
#define SRCB_SET_Base_RMW SRCB_SET_Base_ADDR32, SRCB_SET_Base_SHAMT, SRCB_SET_Base_MASK

#define CLR_DVALID_SrcA_Disable_ADDR32 5
#define CLR_DVALID_SrcA_Disable_SHAMT 0
#define CLR_DVALID_SrcA_Disable_MASK 0x1
#define CLR_DVALID_SrcA_Disable_RMW \
    CLR_DVALID_SrcA_Disable_ADDR32, CLR_DVALID_SrcA_Disable_SHAMT, CLR_DVALID_SrcA_Disable_MASK

#define CLR_DVALID_SrcB_Disable_ADDR32 5
#define CLR_DVALID_SrcB_Disable_SHAMT 1
#define CLR_DVALID_SrcB_Disable_MASK 0x2
#define CLR_DVALID_SrcB_Disable_RMW \
    CLR_DVALID_SrcB_Disable_ADDR32, CLR_DVALID_SrcB_Disable_SHAMT, CLR_DVALID_SrcB_Disable_MASK

#define FIDELITY_BASE_Phase_ADDR32 6
#define FIDELITY_BASE_Phase_SHAMT 0
#define FIDELITY_BASE_Phase_MASK 0x3
#define FIDELITY_BASE_Phase_RMW FIDELITY_BASE_Phase_ADDR32, FIDELITY_BASE_Phase_SHAMT, FIDELITY_BASE_Phase_MASK

#define ADDR_MOD_AB_SEC0_SrcAIncr_ADDR32 7
#define ADDR_MOD_AB_SEC0_SrcAIncr_SHAMT 0
#define ADDR_MOD_AB_SEC0_SrcAIncr_MASK 0x3f
#define ADDR_MOD_AB_SEC0_SrcAIncr_RMW \
    ADDR_MOD_AB_SEC0_SrcAIncr_ADDR32, ADDR_MOD_AB_SEC0_SrcAIncr_SHAMT, ADDR_MOD_AB_SEC0_SrcAIncr_MASK

#define ADDR_MOD_AB_SEC0_SrcACR_ADDR32 7
#define ADDR_MOD_AB_SEC0_SrcACR_SHAMT 6
#define ADDR_MOD_AB_SEC0_SrcACR_MASK 0x40
#define ADDR_MOD_AB_SEC0_SrcACR_RMW \
    ADDR_MOD_AB_SEC0_SrcACR_ADDR32, ADDR_MOD_AB_SEC0_SrcACR_SHAMT, ADDR_MOD_AB_SEC0_SrcACR_MASK

#define ADDR_MOD_AB_SEC0_SrcAClear_ADDR32 7
#define ADDR_MOD_AB_SEC0_SrcAClear_SHAMT 7
#define ADDR_MOD_AB_SEC0_SrcAClear_MASK 0x80
#define ADDR_MOD_AB_SEC0_SrcAClear_RMW \
    ADDR_MOD_AB_SEC0_SrcAClear_ADDR32, ADDR_MOD_AB_SEC0_SrcAClear_SHAMT, ADDR_MOD_AB_SEC0_SrcAClear_MASK

#define ADDR_MOD_AB_SEC0_SrcBIncr_ADDR32 7
#define ADDR_MOD_AB_SEC0_SrcBIncr_SHAMT 8
#define ADDR_MOD_AB_SEC0_SrcBIncr_MASK 0x3f00
#define ADDR_MOD_AB_SEC0_SrcBIncr_RMW \
    ADDR_MOD_AB_SEC0_SrcBIncr_ADDR32, ADDR_MOD_AB_SEC0_SrcBIncr_SHAMT, ADDR_MOD_AB_SEC0_SrcBIncr_MASK

#define ADDR_MOD_AB_SEC0_SrcBCR_ADDR32 7
#define ADDR_MOD_AB_SEC0_SrcBCR_SHAMT 14
#define ADDR_MOD_AB_SEC0_SrcBCR_MASK 0x4000
#define ADDR_MOD_AB_SEC0_SrcBCR_RMW \
    ADDR_MOD_AB_SEC0_SrcBCR_ADDR32, ADDR_MOD_AB_SEC0_SrcBCR_SHAMT, ADDR_MOD_AB_SEC0_SrcBCR_MASK

#define ADDR_MOD_AB_SEC0_SrcBClear_ADDR32 7
#define ADDR_MOD_AB_SEC0_SrcBClear_SHAMT 15
#define ADDR_MOD_AB_SEC0_SrcBClear_MASK 0x8000
#define ADDR_MOD_AB_SEC0_SrcBClear_RMW \
    ADDR_MOD_AB_SEC0_SrcBClear_ADDR32, ADDR_MOD_AB_SEC0_SrcBClear_SHAMT, ADDR_MOD_AB_SEC0_SrcBClear_MASK

#define ADDR_MOD_AB_SEC0_BiasCntIncr_ADDR32 8
#define ADDR_MOD_AB_SEC0_BiasCntIncr_SHAMT 0
#define ADDR_MOD_AB_SEC0_BiasCntIncr_MASK 0xf
#define ADDR_MOD_AB_SEC0_BiasCntIncr_RMW \
    ADDR_MOD_AB_SEC0_BiasCntIncr_ADDR32, ADDR_MOD_AB_SEC0_BiasCntIncr_SHAMT, ADDR_MOD_AB_SEC0_BiasCntIncr_MASK

#define ADDR_MOD_AB_SEC0_BiasCntClear_ADDR32 8
#define ADDR_MOD_AB_SEC0_BiasCntClear_SHAMT 4
#define ADDR_MOD_AB_SEC0_BiasCntClear_MASK 0x10
#define ADDR_MOD_AB_SEC0_BiasCntClear_RMW \
    ADDR_MOD_AB_SEC0_BiasCntClear_ADDR32, ADDR_MOD_AB_SEC0_BiasCntClear_SHAMT, ADDR_MOD_AB_SEC0_BiasCntClear_MASK

#define ADDR_MOD_AB_SEC1_SrcAIncr_ADDR32 9
#define ADDR_MOD_AB_SEC1_SrcAIncr_SHAMT 0
#define ADDR_MOD_AB_SEC1_SrcAIncr_MASK 0x3f
#define ADDR_MOD_AB_SEC1_SrcAIncr_RMW \
    ADDR_MOD_AB_SEC1_SrcAIncr_ADDR32, ADDR_MOD_AB_SEC1_SrcAIncr_SHAMT, ADDR_MOD_AB_SEC1_SrcAIncr_MASK

#define ADDR_MOD_AB_SEC1_SrcACR_ADDR32 9
#define ADDR_MOD_AB_SEC1_SrcACR_SHAMT 6
#define ADDR_MOD_AB_SEC1_SrcACR_MASK 0x40
#define ADDR_MOD_AB_SEC1_SrcACR_RMW \
    ADDR_MOD_AB_SEC1_SrcACR_ADDR32, ADDR_MOD_AB_SEC1_SrcACR_SHAMT, ADDR_MOD_AB_SEC1_SrcACR_MASK

#define ADDR_MOD_AB_SEC1_SrcAClear_ADDR32 9
#define ADDR_MOD_AB_SEC1_SrcAClear_SHAMT 7
#define ADDR_MOD_AB_SEC1_SrcAClear_MASK 0x80
#define ADDR_MOD_AB_SEC1_SrcAClear_RMW \
    ADDR_MOD_AB_SEC1_SrcAClear_ADDR32, ADDR_MOD_AB_SEC1_SrcAClear_SHAMT, ADDR_MOD_AB_SEC1_SrcAClear_MASK

#define ADDR_MOD_AB_SEC1_SrcBIncr_ADDR32 9
#define ADDR_MOD_AB_SEC1_SrcBIncr_SHAMT 8
#define ADDR_MOD_AB_SEC1_SrcBIncr_MASK 0x3f00
#define ADDR_MOD_AB_SEC1_SrcBIncr_RMW \
    ADDR_MOD_AB_SEC1_SrcBIncr_ADDR32, ADDR_MOD_AB_SEC1_SrcBIncr_SHAMT, ADDR_MOD_AB_SEC1_SrcBIncr_MASK

#define ADDR_MOD_AB_SEC1_SrcBCR_ADDR32 9
#define ADDR_MOD_AB_SEC1_SrcBCR_SHAMT 14
#define ADDR_MOD_AB_SEC1_SrcBCR_MASK 0x4000
#define ADDR_MOD_AB_SEC1_SrcBCR_RMW \
    ADDR_MOD_AB_SEC1_SrcBCR_ADDR32, ADDR_MOD_AB_SEC1_SrcBCR_SHAMT, ADDR_MOD_AB_SEC1_SrcBCR_MASK

#define ADDR_MOD_AB_SEC1_SrcBClear_ADDR32 9
#define ADDR_MOD_AB_SEC1_SrcBClear_SHAMT 15
#define ADDR_MOD_AB_SEC1_SrcBClear_MASK 0x8000
#define ADDR_MOD_AB_SEC1_SrcBClear_RMW \
    ADDR_MOD_AB_SEC1_SrcBClear_ADDR32, ADDR_MOD_AB_SEC1_SrcBClear_SHAMT, ADDR_MOD_AB_SEC1_SrcBClear_MASK

#define ADDR_MOD_AB_SEC1_BiasCntIncr_ADDR32 10
#define ADDR_MOD_AB_SEC1_BiasCntIncr_SHAMT 0
#define ADDR_MOD_AB_SEC1_BiasCntIncr_MASK 0xf
#define ADDR_MOD_AB_SEC1_BiasCntIncr_RMW \
    ADDR_MOD_AB_SEC1_BiasCntIncr_ADDR32, ADDR_MOD_AB_SEC1_BiasCntIncr_SHAMT, ADDR_MOD_AB_SEC1_BiasCntIncr_MASK

#define ADDR_MOD_AB_SEC1_BiasCntClear_ADDR32 10
#define ADDR_MOD_AB_SEC1_BiasCntClear_SHAMT 4
#define ADDR_MOD_AB_SEC1_BiasCntClear_MASK 0x10
#define ADDR_MOD_AB_SEC1_BiasCntClear_RMW \
    ADDR_MOD_AB_SEC1_BiasCntClear_ADDR32, ADDR_MOD_AB_SEC1_BiasCntClear_SHAMT, ADDR_MOD_AB_SEC1_BiasCntClear_MASK

#define ADDR_MOD_AB_SEC2_SrcAIncr_ADDR32 11
#define ADDR_MOD_AB_SEC2_SrcAIncr_SHAMT 0
#define ADDR_MOD_AB_SEC2_SrcAIncr_MASK 0x3f
#define ADDR_MOD_AB_SEC2_SrcAIncr_RMW \
    ADDR_MOD_AB_SEC2_SrcAIncr_ADDR32, ADDR_MOD_AB_SEC2_SrcAIncr_SHAMT, ADDR_MOD_AB_SEC2_SrcAIncr_MASK

#define ADDR_MOD_AB_SEC2_SrcACR_ADDR32 11
#define ADDR_MOD_AB_SEC2_SrcACR_SHAMT 6
#define ADDR_MOD_AB_SEC2_SrcACR_MASK 0x40
#define ADDR_MOD_AB_SEC2_SrcACR_RMW \
    ADDR_MOD_AB_SEC2_SrcACR_ADDR32, ADDR_MOD_AB_SEC2_SrcACR_SHAMT, ADDR_MOD_AB_SEC2_SrcACR_MASK

#define ADDR_MOD_AB_SEC2_SrcAClear_ADDR32 11
#define ADDR_MOD_AB_SEC2_SrcAClear_SHAMT 7
#define ADDR_MOD_AB_SEC2_SrcAClear_MASK 0x80
#define ADDR_MOD_AB_SEC2_SrcAClear_RMW \
    ADDR_MOD_AB_SEC2_SrcAClear_ADDR32, ADDR_MOD_AB_SEC2_SrcAClear_SHAMT, ADDR_MOD_AB_SEC2_SrcAClear_MASK

#define ADDR_MOD_AB_SEC2_SrcBIncr_ADDR32 11
#define ADDR_MOD_AB_SEC2_SrcBIncr_SHAMT 8
#define ADDR_MOD_AB_SEC2_SrcBIncr_MASK 0x3f00
#define ADDR_MOD_AB_SEC2_SrcBIncr_RMW \
    ADDR_MOD_AB_SEC2_SrcBIncr_ADDR32, ADDR_MOD_AB_SEC2_SrcBIncr_SHAMT, ADDR_MOD_AB_SEC2_SrcBIncr_MASK

#define ADDR_MOD_AB_SEC2_SrcBCR_ADDR32 11
#define ADDR_MOD_AB_SEC2_SrcBCR_SHAMT 14
#define ADDR_MOD_AB_SEC2_SrcBCR_MASK 0x4000
#define ADDR_MOD_AB_SEC2_SrcBCR_RMW \
    ADDR_MOD_AB_SEC2_SrcBCR_ADDR32, ADDR_MOD_AB_SEC2_SrcBCR_SHAMT, ADDR_MOD_AB_SEC2_SrcBCR_MASK

#define ADDR_MOD_AB_SEC2_SrcBClear_ADDR32 11
#define ADDR_MOD_AB_SEC2_SrcBClear_SHAMT 15
#define ADDR_MOD_AB_SEC2_SrcBClear_MASK 0x8000
#define ADDR_MOD_AB_SEC2_SrcBClear_RMW \
    ADDR_MOD_AB_SEC2_SrcBClear_ADDR32, ADDR_MOD_AB_SEC2_SrcBClear_SHAMT, ADDR_MOD_AB_SEC2_SrcBClear_MASK

#define ADDR_MOD_AB_SEC2_BiasCntIncr_ADDR32 12
#define ADDR_MOD_AB_SEC2_BiasCntIncr_SHAMT 0
#define ADDR_MOD_AB_SEC2_BiasCntIncr_MASK 0xf
#define ADDR_MOD_AB_SEC2_BiasCntIncr_RMW \
    ADDR_MOD_AB_SEC2_BiasCntIncr_ADDR32, ADDR_MOD_AB_SEC2_BiasCntIncr_SHAMT, ADDR_MOD_AB_SEC2_BiasCntIncr_MASK

#define ADDR_MOD_AB_SEC2_BiasCntClear_ADDR32 12
#define ADDR_MOD_AB_SEC2_BiasCntClear_SHAMT 4
#define ADDR_MOD_AB_SEC2_BiasCntClear_MASK 0x10
#define ADDR_MOD_AB_SEC2_BiasCntClear_RMW \
    ADDR_MOD_AB_SEC2_BiasCntClear_ADDR32, ADDR_MOD_AB_SEC2_BiasCntClear_SHAMT, ADDR_MOD_AB_SEC2_BiasCntClear_MASK

#define ADDR_MOD_AB_SEC3_SrcAIncr_ADDR32 13
#define ADDR_MOD_AB_SEC3_SrcAIncr_SHAMT 0
#define ADDR_MOD_AB_SEC3_SrcAIncr_MASK 0x3f
#define ADDR_MOD_AB_SEC3_SrcAIncr_RMW \
    ADDR_MOD_AB_SEC3_SrcAIncr_ADDR32, ADDR_MOD_AB_SEC3_SrcAIncr_SHAMT, ADDR_MOD_AB_SEC3_SrcAIncr_MASK

#define ADDR_MOD_AB_SEC3_SrcACR_ADDR32 13
#define ADDR_MOD_AB_SEC3_SrcACR_SHAMT 6
#define ADDR_MOD_AB_SEC3_SrcACR_MASK 0x40
#define ADDR_MOD_AB_SEC3_SrcACR_RMW \
    ADDR_MOD_AB_SEC3_SrcACR_ADDR32, ADDR_MOD_AB_SEC3_SrcACR_SHAMT, ADDR_MOD_AB_SEC3_SrcACR_MASK

#define ADDR_MOD_AB_SEC3_SrcAClear_ADDR32 13
#define ADDR_MOD_AB_SEC3_SrcAClear_SHAMT 7
#define ADDR_MOD_AB_SEC3_SrcAClear_MASK 0x80
#define ADDR_MOD_AB_SEC3_SrcAClear_RMW \
    ADDR_MOD_AB_SEC3_SrcAClear_ADDR32, ADDR_MOD_AB_SEC3_SrcAClear_SHAMT, ADDR_MOD_AB_SEC3_SrcAClear_MASK

#define ADDR_MOD_AB_SEC3_SrcBIncr_ADDR32 13
#define ADDR_MOD_AB_SEC3_SrcBIncr_SHAMT 8
#define ADDR_MOD_AB_SEC3_SrcBIncr_MASK 0x3f00
#define ADDR_MOD_AB_SEC3_SrcBIncr_RMW \
    ADDR_MOD_AB_SEC3_SrcBIncr_ADDR32, ADDR_MOD_AB_SEC3_SrcBIncr_SHAMT, ADDR_MOD_AB_SEC3_SrcBIncr_MASK

#define ADDR_MOD_AB_SEC3_SrcBCR_ADDR32 13
#define ADDR_MOD_AB_SEC3_SrcBCR_SHAMT 14
#define ADDR_MOD_AB_SEC3_SrcBCR_MASK 0x4000
#define ADDR_MOD_AB_SEC3_SrcBCR_RMW \
    ADDR_MOD_AB_SEC3_SrcBCR_ADDR32, ADDR_MOD_AB_SEC3_SrcBCR_SHAMT, ADDR_MOD_AB_SEC3_SrcBCR_MASK

#define ADDR_MOD_AB_SEC3_SrcBClear_ADDR32 13
#define ADDR_MOD_AB_SEC3_SrcBClear_SHAMT 15
#define ADDR_MOD_AB_SEC3_SrcBClear_MASK 0x8000
#define ADDR_MOD_AB_SEC3_SrcBClear_RMW \
    ADDR_MOD_AB_SEC3_SrcBClear_ADDR32, ADDR_MOD_AB_SEC3_SrcBClear_SHAMT, ADDR_MOD_AB_SEC3_SrcBClear_MASK

#define ADDR_MOD_AB_SEC3_BiasCntIncr_ADDR32 14
#define ADDR_MOD_AB_SEC3_BiasCntIncr_SHAMT 0
#define ADDR_MOD_AB_SEC3_BiasCntIncr_MASK 0xf
#define ADDR_MOD_AB_SEC3_BiasCntIncr_RMW \
    ADDR_MOD_AB_SEC3_BiasCntIncr_ADDR32, ADDR_MOD_AB_SEC3_BiasCntIncr_SHAMT, ADDR_MOD_AB_SEC3_BiasCntIncr_MASK

#define ADDR_MOD_AB_SEC3_BiasCntClear_ADDR32 14
#define ADDR_MOD_AB_SEC3_BiasCntClear_SHAMT 4
#define ADDR_MOD_AB_SEC3_BiasCntClear_MASK 0x10
#define ADDR_MOD_AB_SEC3_BiasCntClear_RMW \
    ADDR_MOD_AB_SEC3_BiasCntClear_ADDR32, ADDR_MOD_AB_SEC3_BiasCntClear_SHAMT, ADDR_MOD_AB_SEC3_BiasCntClear_MASK

#define ADDR_MOD_AB_SEC4_SrcAIncr_ADDR32 15
#define ADDR_MOD_AB_SEC4_SrcAIncr_SHAMT 0
#define ADDR_MOD_AB_SEC4_SrcAIncr_MASK 0x3f
#define ADDR_MOD_AB_SEC4_SrcAIncr_RMW \
    ADDR_MOD_AB_SEC4_SrcAIncr_ADDR32, ADDR_MOD_AB_SEC4_SrcAIncr_SHAMT, ADDR_MOD_AB_SEC4_SrcAIncr_MASK

#define ADDR_MOD_AB_SEC4_SrcACR_ADDR32 15
#define ADDR_MOD_AB_SEC4_SrcACR_SHAMT 6
#define ADDR_MOD_AB_SEC4_SrcACR_MASK 0x40
#define ADDR_MOD_AB_SEC4_SrcACR_RMW \
    ADDR_MOD_AB_SEC4_SrcACR_ADDR32, ADDR_MOD_AB_SEC4_SrcACR_SHAMT, ADDR_MOD_AB_SEC4_SrcACR_MASK

#define ADDR_MOD_AB_SEC4_SrcAClear_ADDR32 15
#define ADDR_MOD_AB_SEC4_SrcAClear_SHAMT 7
#define ADDR_MOD_AB_SEC4_SrcAClear_MASK 0x80
#define ADDR_MOD_AB_SEC4_SrcAClear_RMW \
    ADDR_MOD_AB_SEC4_SrcAClear_ADDR32, ADDR_MOD_AB_SEC4_SrcAClear_SHAMT, ADDR_MOD_AB_SEC4_SrcAClear_MASK

#define ADDR_MOD_AB_SEC4_SrcBIncr_ADDR32 15
#define ADDR_MOD_AB_SEC4_SrcBIncr_SHAMT 8
#define ADDR_MOD_AB_SEC4_SrcBIncr_MASK 0x3f00
#define ADDR_MOD_AB_SEC4_SrcBIncr_RMW \
    ADDR_MOD_AB_SEC4_SrcBIncr_ADDR32, ADDR_MOD_AB_SEC4_SrcBIncr_SHAMT, ADDR_MOD_AB_SEC4_SrcBIncr_MASK

#define ADDR_MOD_AB_SEC4_SrcBCR_ADDR32 15
#define ADDR_MOD_AB_SEC4_SrcBCR_SHAMT 14
#define ADDR_MOD_AB_SEC4_SrcBCR_MASK 0x4000
#define ADDR_MOD_AB_SEC4_SrcBCR_RMW \
    ADDR_MOD_AB_SEC4_SrcBCR_ADDR32, ADDR_MOD_AB_SEC4_SrcBCR_SHAMT, ADDR_MOD_AB_SEC4_SrcBCR_MASK

#define ADDR_MOD_AB_SEC4_SrcBClear_ADDR32 15
#define ADDR_MOD_AB_SEC4_SrcBClear_SHAMT 15
#define ADDR_MOD_AB_SEC4_SrcBClear_MASK 0x8000
#define ADDR_MOD_AB_SEC4_SrcBClear_RMW \
    ADDR_MOD_AB_SEC4_SrcBClear_ADDR32, ADDR_MOD_AB_SEC4_SrcBClear_SHAMT, ADDR_MOD_AB_SEC4_SrcBClear_MASK

#define ADDR_MOD_AB_SEC4_BiasCntIncr_ADDR32 16
#define ADDR_MOD_AB_SEC4_BiasCntIncr_SHAMT 0
#define ADDR_MOD_AB_SEC4_BiasCntIncr_MASK 0xf
#define ADDR_MOD_AB_SEC4_BiasCntIncr_RMW \
    ADDR_MOD_AB_SEC4_BiasCntIncr_ADDR32, ADDR_MOD_AB_SEC4_BiasCntIncr_SHAMT, ADDR_MOD_AB_SEC4_BiasCntIncr_MASK

#define ADDR_MOD_AB_SEC4_BiasCntClear_ADDR32 16
#define ADDR_MOD_AB_SEC4_BiasCntClear_SHAMT 4
#define ADDR_MOD_AB_SEC4_BiasCntClear_MASK 0x10
#define ADDR_MOD_AB_SEC4_BiasCntClear_RMW \
    ADDR_MOD_AB_SEC4_BiasCntClear_ADDR32, ADDR_MOD_AB_SEC4_BiasCntClear_SHAMT, ADDR_MOD_AB_SEC4_BiasCntClear_MASK

#define ADDR_MOD_AB_SEC5_SrcAIncr_ADDR32 17
#define ADDR_MOD_AB_SEC5_SrcAIncr_SHAMT 0
#define ADDR_MOD_AB_SEC5_SrcAIncr_MASK 0x3f
#define ADDR_MOD_AB_SEC5_SrcAIncr_RMW \
    ADDR_MOD_AB_SEC5_SrcAIncr_ADDR32, ADDR_MOD_AB_SEC5_SrcAIncr_SHAMT, ADDR_MOD_AB_SEC5_SrcAIncr_MASK

#define ADDR_MOD_AB_SEC5_SrcACR_ADDR32 17
#define ADDR_MOD_AB_SEC5_SrcACR_SHAMT 6
#define ADDR_MOD_AB_SEC5_SrcACR_MASK 0x40
#define ADDR_MOD_AB_SEC5_SrcACR_RMW \
    ADDR_MOD_AB_SEC5_SrcACR_ADDR32, ADDR_MOD_AB_SEC5_SrcACR_SHAMT, ADDR_MOD_AB_SEC5_SrcACR_MASK

#define ADDR_MOD_AB_SEC5_SrcAClear_ADDR32 17
#define ADDR_MOD_AB_SEC5_SrcAClear_SHAMT 7
#define ADDR_MOD_AB_SEC5_SrcAClear_MASK 0x80
#define ADDR_MOD_AB_SEC5_SrcAClear_RMW \
    ADDR_MOD_AB_SEC5_SrcAClear_ADDR32, ADDR_MOD_AB_SEC5_SrcAClear_SHAMT, ADDR_MOD_AB_SEC5_SrcAClear_MASK

#define ADDR_MOD_AB_SEC5_SrcBIncr_ADDR32 17
#define ADDR_MOD_AB_SEC5_SrcBIncr_SHAMT 8
#define ADDR_MOD_AB_SEC5_SrcBIncr_MASK 0x3f00
#define ADDR_MOD_AB_SEC5_SrcBIncr_RMW \
    ADDR_MOD_AB_SEC5_SrcBIncr_ADDR32, ADDR_MOD_AB_SEC5_SrcBIncr_SHAMT, ADDR_MOD_AB_SEC5_SrcBIncr_MASK

#define ADDR_MOD_AB_SEC5_SrcBCR_ADDR32 17
#define ADDR_MOD_AB_SEC5_SrcBCR_SHAMT 14
#define ADDR_MOD_AB_SEC5_SrcBCR_MASK 0x4000
#define ADDR_MOD_AB_SEC5_SrcBCR_RMW \
    ADDR_MOD_AB_SEC5_SrcBCR_ADDR32, ADDR_MOD_AB_SEC5_SrcBCR_SHAMT, ADDR_MOD_AB_SEC5_SrcBCR_MASK

#define ADDR_MOD_AB_SEC5_SrcBClear_ADDR32 17
#define ADDR_MOD_AB_SEC5_SrcBClear_SHAMT 15
#define ADDR_MOD_AB_SEC5_SrcBClear_MASK 0x8000
#define ADDR_MOD_AB_SEC5_SrcBClear_RMW \
    ADDR_MOD_AB_SEC5_SrcBClear_ADDR32, ADDR_MOD_AB_SEC5_SrcBClear_SHAMT, ADDR_MOD_AB_SEC5_SrcBClear_MASK

#define ADDR_MOD_AB_SEC5_BiasCntIncr_ADDR32 18
#define ADDR_MOD_AB_SEC5_BiasCntIncr_SHAMT 0
#define ADDR_MOD_AB_SEC5_BiasCntIncr_MASK 0xf
#define ADDR_MOD_AB_SEC5_BiasCntIncr_RMW \
    ADDR_MOD_AB_SEC5_BiasCntIncr_ADDR32, ADDR_MOD_AB_SEC5_BiasCntIncr_SHAMT, ADDR_MOD_AB_SEC5_BiasCntIncr_MASK

#define ADDR_MOD_AB_SEC5_BiasCntClear_ADDR32 18
#define ADDR_MOD_AB_SEC5_BiasCntClear_SHAMT 4
#define ADDR_MOD_AB_SEC5_BiasCntClear_MASK 0x10
#define ADDR_MOD_AB_SEC5_BiasCntClear_RMW \
    ADDR_MOD_AB_SEC5_BiasCntClear_ADDR32, ADDR_MOD_AB_SEC5_BiasCntClear_SHAMT, ADDR_MOD_AB_SEC5_BiasCntClear_MASK

#define ADDR_MOD_AB_SEC6_SrcAIncr_ADDR32 19
#define ADDR_MOD_AB_SEC6_SrcAIncr_SHAMT 0
#define ADDR_MOD_AB_SEC6_SrcAIncr_MASK 0x3f
#define ADDR_MOD_AB_SEC6_SrcAIncr_RMW \
    ADDR_MOD_AB_SEC6_SrcAIncr_ADDR32, ADDR_MOD_AB_SEC6_SrcAIncr_SHAMT, ADDR_MOD_AB_SEC6_SrcAIncr_MASK

#define ADDR_MOD_AB_SEC6_SrcACR_ADDR32 19
#define ADDR_MOD_AB_SEC6_SrcACR_SHAMT 6
#define ADDR_MOD_AB_SEC6_SrcACR_MASK 0x40
#define ADDR_MOD_AB_SEC6_SrcACR_RMW \
    ADDR_MOD_AB_SEC6_SrcACR_ADDR32, ADDR_MOD_AB_SEC6_SrcACR_SHAMT, ADDR_MOD_AB_SEC6_SrcACR_MASK

#define ADDR_MOD_AB_SEC6_SrcAClear_ADDR32 19
#define ADDR_MOD_AB_SEC6_SrcAClear_SHAMT 7
#define ADDR_MOD_AB_SEC6_SrcAClear_MASK 0x80
#define ADDR_MOD_AB_SEC6_SrcAClear_RMW \
    ADDR_MOD_AB_SEC6_SrcAClear_ADDR32, ADDR_MOD_AB_SEC6_SrcAClear_SHAMT, ADDR_MOD_AB_SEC6_SrcAClear_MASK

#define ADDR_MOD_AB_SEC6_SrcBIncr_ADDR32 19
#define ADDR_MOD_AB_SEC6_SrcBIncr_SHAMT 8
#define ADDR_MOD_AB_SEC6_SrcBIncr_MASK 0x3f00
#define ADDR_MOD_AB_SEC6_SrcBIncr_RMW \
    ADDR_MOD_AB_SEC6_SrcBIncr_ADDR32, ADDR_MOD_AB_SEC6_SrcBIncr_SHAMT, ADDR_MOD_AB_SEC6_SrcBIncr_MASK

#define ADDR_MOD_AB_SEC6_SrcBCR_ADDR32 19
#define ADDR_MOD_AB_SEC6_SrcBCR_SHAMT 14
#define ADDR_MOD_AB_SEC6_SrcBCR_MASK 0x4000
#define ADDR_MOD_AB_SEC6_SrcBCR_RMW \
    ADDR_MOD_AB_SEC6_SrcBCR_ADDR32, ADDR_MOD_AB_SEC6_SrcBCR_SHAMT, ADDR_MOD_AB_SEC6_SrcBCR_MASK

#define ADDR_MOD_AB_SEC6_SrcBClear_ADDR32 19
#define ADDR_MOD_AB_SEC6_SrcBClear_SHAMT 15
#define ADDR_MOD_AB_SEC6_SrcBClear_MASK 0x8000
#define ADDR_MOD_AB_SEC6_SrcBClear_RMW \
    ADDR_MOD_AB_SEC6_SrcBClear_ADDR32, ADDR_MOD_AB_SEC6_SrcBClear_SHAMT, ADDR_MOD_AB_SEC6_SrcBClear_MASK

#define ADDR_MOD_AB_SEC6_BiasCntIncr_ADDR32 20
#define ADDR_MOD_AB_SEC6_BiasCntIncr_SHAMT 0
#define ADDR_MOD_AB_SEC6_BiasCntIncr_MASK 0xf
#define ADDR_MOD_AB_SEC6_BiasCntIncr_RMW \
    ADDR_MOD_AB_SEC6_BiasCntIncr_ADDR32, ADDR_MOD_AB_SEC6_BiasCntIncr_SHAMT, ADDR_MOD_AB_SEC6_BiasCntIncr_MASK

#define ADDR_MOD_AB_SEC6_BiasCntClear_ADDR32 20
#define ADDR_MOD_AB_SEC6_BiasCntClear_SHAMT 4
#define ADDR_MOD_AB_SEC6_BiasCntClear_MASK 0x10
#define ADDR_MOD_AB_SEC6_BiasCntClear_RMW \
    ADDR_MOD_AB_SEC6_BiasCntClear_ADDR32, ADDR_MOD_AB_SEC6_BiasCntClear_SHAMT, ADDR_MOD_AB_SEC6_BiasCntClear_MASK

#define ADDR_MOD_AB_SEC7_SrcAIncr_ADDR32 21
#define ADDR_MOD_AB_SEC7_SrcAIncr_SHAMT 0
#define ADDR_MOD_AB_SEC7_SrcAIncr_MASK 0x3f
#define ADDR_MOD_AB_SEC7_SrcAIncr_RMW \
    ADDR_MOD_AB_SEC7_SrcAIncr_ADDR32, ADDR_MOD_AB_SEC7_SrcAIncr_SHAMT, ADDR_MOD_AB_SEC7_SrcAIncr_MASK

#define ADDR_MOD_AB_SEC7_SrcACR_ADDR32 21
#define ADDR_MOD_AB_SEC7_SrcACR_SHAMT 6
#define ADDR_MOD_AB_SEC7_SrcACR_MASK 0x40
#define ADDR_MOD_AB_SEC7_SrcACR_RMW \
    ADDR_MOD_AB_SEC7_SrcACR_ADDR32, ADDR_MOD_AB_SEC7_SrcACR_SHAMT, ADDR_MOD_AB_SEC7_SrcACR_MASK

#define ADDR_MOD_AB_SEC7_SrcAClear_ADDR32 21
#define ADDR_MOD_AB_SEC7_SrcAClear_SHAMT 7
#define ADDR_MOD_AB_SEC7_SrcAClear_MASK 0x80
#define ADDR_MOD_AB_SEC7_SrcAClear_RMW \
    ADDR_MOD_AB_SEC7_SrcAClear_ADDR32, ADDR_MOD_AB_SEC7_SrcAClear_SHAMT, ADDR_MOD_AB_SEC7_SrcAClear_MASK

#define ADDR_MOD_AB_SEC7_SrcBIncr_ADDR32 21
#define ADDR_MOD_AB_SEC7_SrcBIncr_SHAMT 8
#define ADDR_MOD_AB_SEC7_SrcBIncr_MASK 0x3f00
#define ADDR_MOD_AB_SEC7_SrcBIncr_RMW \
    ADDR_MOD_AB_SEC7_SrcBIncr_ADDR32, ADDR_MOD_AB_SEC7_SrcBIncr_SHAMT, ADDR_MOD_AB_SEC7_SrcBIncr_MASK

#define ADDR_MOD_AB_SEC7_SrcBCR_ADDR32 21
#define ADDR_MOD_AB_SEC7_SrcBCR_SHAMT 14
#define ADDR_MOD_AB_SEC7_SrcBCR_MASK 0x4000
#define ADDR_MOD_AB_SEC7_SrcBCR_RMW \
    ADDR_MOD_AB_SEC7_SrcBCR_ADDR32, ADDR_MOD_AB_SEC7_SrcBCR_SHAMT, ADDR_MOD_AB_SEC7_SrcBCR_MASK

#define ADDR_MOD_AB_SEC7_SrcBClear_ADDR32 21
#define ADDR_MOD_AB_SEC7_SrcBClear_SHAMT 15
#define ADDR_MOD_AB_SEC7_SrcBClear_MASK 0x8000
#define ADDR_MOD_AB_SEC7_SrcBClear_RMW \
    ADDR_MOD_AB_SEC7_SrcBClear_ADDR32, ADDR_MOD_AB_SEC7_SrcBClear_SHAMT, ADDR_MOD_AB_SEC7_SrcBClear_MASK

#define ADDR_MOD_AB_SEC7_BiasCntIncr_ADDR32 22
#define ADDR_MOD_AB_SEC7_BiasCntIncr_SHAMT 0
#define ADDR_MOD_AB_SEC7_BiasCntIncr_MASK 0xf
#define ADDR_MOD_AB_SEC7_BiasCntIncr_RMW \
    ADDR_MOD_AB_SEC7_BiasCntIncr_ADDR32, ADDR_MOD_AB_SEC7_BiasCntIncr_SHAMT, ADDR_MOD_AB_SEC7_BiasCntIncr_MASK

#define ADDR_MOD_AB_SEC7_BiasCntClear_ADDR32 22
#define ADDR_MOD_AB_SEC7_BiasCntClear_SHAMT 4
#define ADDR_MOD_AB_SEC7_BiasCntClear_MASK 0x10
#define ADDR_MOD_AB_SEC7_BiasCntClear_RMW \
    ADDR_MOD_AB_SEC7_BiasCntClear_ADDR32, ADDR_MOD_AB_SEC7_BiasCntClear_SHAMT, ADDR_MOD_AB_SEC7_BiasCntClear_MASK

#define ADDR_MOD_DST_SEC0_DestIncr_ADDR32 23
#define ADDR_MOD_DST_SEC0_DestIncr_SHAMT 0
#define ADDR_MOD_DST_SEC0_DestIncr_MASK 0x3ff
#define ADDR_MOD_DST_SEC0_DestIncr_RMW \
    ADDR_MOD_DST_SEC0_DestIncr_ADDR32, ADDR_MOD_DST_SEC0_DestIncr_SHAMT, ADDR_MOD_DST_SEC0_DestIncr_MASK

#define ADDR_MOD_DST_SEC0_DestCR_ADDR32 23
#define ADDR_MOD_DST_SEC0_DestCR_SHAMT 10
#define ADDR_MOD_DST_SEC0_DestCR_MASK 0x400
#define ADDR_MOD_DST_SEC0_DestCR_RMW \
    ADDR_MOD_DST_SEC0_DestCR_ADDR32, ADDR_MOD_DST_SEC0_DestCR_SHAMT, ADDR_MOD_DST_SEC0_DestCR_MASK

#define ADDR_MOD_DST_SEC0_DestClear_ADDR32 23
#define ADDR_MOD_DST_SEC0_DestClear_SHAMT 11
#define ADDR_MOD_DST_SEC0_DestClear_MASK 0x800
#define ADDR_MOD_DST_SEC0_DestClear_RMW \
    ADDR_MOD_DST_SEC0_DestClear_ADDR32, ADDR_MOD_DST_SEC0_DestClear_SHAMT, ADDR_MOD_DST_SEC0_DestClear_MASK

#define ADDR_MOD_DST_SEC0_DestCToCR_ADDR32 23
#define ADDR_MOD_DST_SEC0_DestCToCR_SHAMT 12
#define ADDR_MOD_DST_SEC0_DestCToCR_MASK 0x1000
#define ADDR_MOD_DST_SEC0_DestCToCR_RMW \
    ADDR_MOD_DST_SEC0_DestCToCR_ADDR32, ADDR_MOD_DST_SEC0_DestCToCR_SHAMT, ADDR_MOD_DST_SEC0_DestCToCR_MASK

#define ADDR_MOD_DST_SEC0_FidelityIncr_ADDR32 23
#define ADDR_MOD_DST_SEC0_FidelityIncr_SHAMT 13
#define ADDR_MOD_DST_SEC0_FidelityIncr_MASK 0x6000
#define ADDR_MOD_DST_SEC0_FidelityIncr_RMW \
    ADDR_MOD_DST_SEC0_FidelityIncr_ADDR32, ADDR_MOD_DST_SEC0_FidelityIncr_SHAMT, ADDR_MOD_DST_SEC0_FidelityIncr_MASK

#define ADDR_MOD_DST_SEC0_FidelityClear_ADDR32 23
#define ADDR_MOD_DST_SEC0_FidelityClear_SHAMT 15
#define ADDR_MOD_DST_SEC0_FidelityClear_MASK 0x8000
#define ADDR_MOD_DST_SEC0_FidelityClear_RMW \
    ADDR_MOD_DST_SEC0_FidelityClear_ADDR32, ADDR_MOD_DST_SEC0_FidelityClear_SHAMT, ADDR_MOD_DST_SEC0_FidelityClear_MASK

#define ADDR_MOD_DST_SEC1_DestIncr_ADDR32 24
#define ADDR_MOD_DST_SEC1_DestIncr_SHAMT 0
#define ADDR_MOD_DST_SEC1_DestIncr_MASK 0x3ff
#define ADDR_MOD_DST_SEC1_DestIncr_RMW \
    ADDR_MOD_DST_SEC1_DestIncr_ADDR32, ADDR_MOD_DST_SEC1_DestIncr_SHAMT, ADDR_MOD_DST_SEC1_DestIncr_MASK

#define ADDR_MOD_DST_SEC1_DestCR_ADDR32 24
#define ADDR_MOD_DST_SEC1_DestCR_SHAMT 10
#define ADDR_MOD_DST_SEC1_DestCR_MASK 0x400
#define ADDR_MOD_DST_SEC1_DestCR_RMW \
    ADDR_MOD_DST_SEC1_DestCR_ADDR32, ADDR_MOD_DST_SEC1_DestCR_SHAMT, ADDR_MOD_DST_SEC1_DestCR_MASK

#define ADDR_MOD_DST_SEC1_DestClear_ADDR32 24
#define ADDR_MOD_DST_SEC1_DestClear_SHAMT 11
#define ADDR_MOD_DST_SEC1_DestClear_MASK 0x800
#define ADDR_MOD_DST_SEC1_DestClear_RMW \
    ADDR_MOD_DST_SEC1_DestClear_ADDR32, ADDR_MOD_DST_SEC1_DestClear_SHAMT, ADDR_MOD_DST_SEC1_DestClear_MASK

#define ADDR_MOD_DST_SEC1_DestCToCR_ADDR32 24
#define ADDR_MOD_DST_SEC1_DestCToCR_SHAMT 12
#define ADDR_MOD_DST_SEC1_DestCToCR_MASK 0x1000
#define ADDR_MOD_DST_SEC1_DestCToCR_RMW \
    ADDR_MOD_DST_SEC1_DestCToCR_ADDR32, ADDR_MOD_DST_SEC1_DestCToCR_SHAMT, ADDR_MOD_DST_SEC1_DestCToCR_MASK

#define ADDR_MOD_DST_SEC1_FidelityIncr_ADDR32 24
#define ADDR_MOD_DST_SEC1_FidelityIncr_SHAMT 13
#define ADDR_MOD_DST_SEC1_FidelityIncr_MASK 0x6000
#define ADDR_MOD_DST_SEC1_FidelityIncr_RMW \
    ADDR_MOD_DST_SEC1_FidelityIncr_ADDR32, ADDR_MOD_DST_SEC1_FidelityIncr_SHAMT, ADDR_MOD_DST_SEC1_FidelityIncr_MASK

#define ADDR_MOD_DST_SEC1_FidelityClear_ADDR32 24
#define ADDR_MOD_DST_SEC1_FidelityClear_SHAMT 15
#define ADDR_MOD_DST_SEC1_FidelityClear_MASK 0x8000
#define ADDR_MOD_DST_SEC1_FidelityClear_RMW \
    ADDR_MOD_DST_SEC1_FidelityClear_ADDR32, ADDR_MOD_DST_SEC1_FidelityClear_SHAMT, ADDR_MOD_DST_SEC1_FidelityClear_MASK

#define ADDR_MOD_DST_SEC2_DestIncr_ADDR32 25
#define ADDR_MOD_DST_SEC2_DestIncr_SHAMT 0
#define ADDR_MOD_DST_SEC2_DestIncr_MASK 0x3ff
#define ADDR_MOD_DST_SEC2_DestIncr_RMW \
    ADDR_MOD_DST_SEC2_DestIncr_ADDR32, ADDR_MOD_DST_SEC2_DestIncr_SHAMT, ADDR_MOD_DST_SEC2_DestIncr_MASK

#define ADDR_MOD_DST_SEC2_DestCR_ADDR32 25
#define ADDR_MOD_DST_SEC2_DestCR_SHAMT 10
#define ADDR_MOD_DST_SEC2_DestCR_MASK 0x400
#define ADDR_MOD_DST_SEC2_DestCR_RMW \
    ADDR_MOD_DST_SEC2_DestCR_ADDR32, ADDR_MOD_DST_SEC2_DestCR_SHAMT, ADDR_MOD_DST_SEC2_DestCR_MASK

#define ADDR_MOD_DST_SEC2_DestClear_ADDR32 25
#define ADDR_MOD_DST_SEC2_DestClear_SHAMT 11
#define ADDR_MOD_DST_SEC2_DestClear_MASK 0x800
#define ADDR_MOD_DST_SEC2_DestClear_RMW \
    ADDR_MOD_DST_SEC2_DestClear_ADDR32, ADDR_MOD_DST_SEC2_DestClear_SHAMT, ADDR_MOD_DST_SEC2_DestClear_MASK

#define ADDR_MOD_DST_SEC2_DestCToCR_ADDR32 25
#define ADDR_MOD_DST_SEC2_DestCToCR_SHAMT 12
#define ADDR_MOD_DST_SEC2_DestCToCR_MASK 0x1000
#define ADDR_MOD_DST_SEC2_DestCToCR_RMW \
    ADDR_MOD_DST_SEC2_DestCToCR_ADDR32, ADDR_MOD_DST_SEC2_DestCToCR_SHAMT, ADDR_MOD_DST_SEC2_DestCToCR_MASK

#define ADDR_MOD_DST_SEC2_FidelityIncr_ADDR32 25
#define ADDR_MOD_DST_SEC2_FidelityIncr_SHAMT 13
#define ADDR_MOD_DST_SEC2_FidelityIncr_MASK 0x6000
#define ADDR_MOD_DST_SEC2_FidelityIncr_RMW \
    ADDR_MOD_DST_SEC2_FidelityIncr_ADDR32, ADDR_MOD_DST_SEC2_FidelityIncr_SHAMT, ADDR_MOD_DST_SEC2_FidelityIncr_MASK

#define ADDR_MOD_DST_SEC2_FidelityClear_ADDR32 25
#define ADDR_MOD_DST_SEC2_FidelityClear_SHAMT 15
#define ADDR_MOD_DST_SEC2_FidelityClear_MASK 0x8000
#define ADDR_MOD_DST_SEC2_FidelityClear_RMW \
    ADDR_MOD_DST_SEC2_FidelityClear_ADDR32, ADDR_MOD_DST_SEC2_FidelityClear_SHAMT, ADDR_MOD_DST_SEC2_FidelityClear_MASK

#define ADDR_MOD_DST_SEC3_DestIncr_ADDR32 26
#define ADDR_MOD_DST_SEC3_DestIncr_SHAMT 0
#define ADDR_MOD_DST_SEC3_DestIncr_MASK 0x3ff
#define ADDR_MOD_DST_SEC3_DestIncr_RMW \
    ADDR_MOD_DST_SEC3_DestIncr_ADDR32, ADDR_MOD_DST_SEC3_DestIncr_SHAMT, ADDR_MOD_DST_SEC3_DestIncr_MASK

#define ADDR_MOD_DST_SEC3_DestCR_ADDR32 26
#define ADDR_MOD_DST_SEC3_DestCR_SHAMT 10
#define ADDR_MOD_DST_SEC3_DestCR_MASK 0x400
#define ADDR_MOD_DST_SEC3_DestCR_RMW \
    ADDR_MOD_DST_SEC3_DestCR_ADDR32, ADDR_MOD_DST_SEC3_DestCR_SHAMT, ADDR_MOD_DST_SEC3_DestCR_MASK

#define ADDR_MOD_DST_SEC3_DestClear_ADDR32 26
#define ADDR_MOD_DST_SEC3_DestClear_SHAMT 11
#define ADDR_MOD_DST_SEC3_DestClear_MASK 0x800
#define ADDR_MOD_DST_SEC3_DestClear_RMW \
    ADDR_MOD_DST_SEC3_DestClear_ADDR32, ADDR_MOD_DST_SEC3_DestClear_SHAMT, ADDR_MOD_DST_SEC3_DestClear_MASK

#define ADDR_MOD_DST_SEC3_DestCToCR_ADDR32 26
#define ADDR_MOD_DST_SEC3_DestCToCR_SHAMT 12
#define ADDR_MOD_DST_SEC3_DestCToCR_MASK 0x1000
#define ADDR_MOD_DST_SEC3_DestCToCR_RMW \
    ADDR_MOD_DST_SEC3_DestCToCR_ADDR32, ADDR_MOD_DST_SEC3_DestCToCR_SHAMT, ADDR_MOD_DST_SEC3_DestCToCR_MASK

#define ADDR_MOD_DST_SEC3_FidelityIncr_ADDR32 26
#define ADDR_MOD_DST_SEC3_FidelityIncr_SHAMT 13
#define ADDR_MOD_DST_SEC3_FidelityIncr_MASK 0x6000
#define ADDR_MOD_DST_SEC3_FidelityIncr_RMW \
    ADDR_MOD_DST_SEC3_FidelityIncr_ADDR32, ADDR_MOD_DST_SEC3_FidelityIncr_SHAMT, ADDR_MOD_DST_SEC3_FidelityIncr_MASK

#define ADDR_MOD_DST_SEC3_FidelityClear_ADDR32 26
#define ADDR_MOD_DST_SEC3_FidelityClear_SHAMT 15
#define ADDR_MOD_DST_SEC3_FidelityClear_MASK 0x8000
#define ADDR_MOD_DST_SEC3_FidelityClear_RMW \
    ADDR_MOD_DST_SEC3_FidelityClear_ADDR32, ADDR_MOD_DST_SEC3_FidelityClear_SHAMT, ADDR_MOD_DST_SEC3_FidelityClear_MASK

#define ADDR_MOD_DST_SEC4_DestIncr_ADDR32 27
#define ADDR_MOD_DST_SEC4_DestIncr_SHAMT 0
#define ADDR_MOD_DST_SEC4_DestIncr_MASK 0x3ff
#define ADDR_MOD_DST_SEC4_DestIncr_RMW \
    ADDR_MOD_DST_SEC4_DestIncr_ADDR32, ADDR_MOD_DST_SEC4_DestIncr_SHAMT, ADDR_MOD_DST_SEC4_DestIncr_MASK

#define ADDR_MOD_DST_SEC4_DestCR_ADDR32 27
#define ADDR_MOD_DST_SEC4_DestCR_SHAMT 10
#define ADDR_MOD_DST_SEC4_DestCR_MASK 0x400
#define ADDR_MOD_DST_SEC4_DestCR_RMW \
    ADDR_MOD_DST_SEC4_DestCR_ADDR32, ADDR_MOD_DST_SEC4_DestCR_SHAMT, ADDR_MOD_DST_SEC4_DestCR_MASK

#define ADDR_MOD_DST_SEC4_DestClear_ADDR32 27
#define ADDR_MOD_DST_SEC4_DestClear_SHAMT 11
#define ADDR_MOD_DST_SEC4_DestClear_MASK 0x800
#define ADDR_MOD_DST_SEC4_DestClear_RMW \
    ADDR_MOD_DST_SEC4_DestClear_ADDR32, ADDR_MOD_DST_SEC4_DestClear_SHAMT, ADDR_MOD_DST_SEC4_DestClear_MASK

#define ADDR_MOD_DST_SEC4_DestCToCR_ADDR32 27
#define ADDR_MOD_DST_SEC4_DestCToCR_SHAMT 12
#define ADDR_MOD_DST_SEC4_DestCToCR_MASK 0x1000
#define ADDR_MOD_DST_SEC4_DestCToCR_RMW \
    ADDR_MOD_DST_SEC4_DestCToCR_ADDR32, ADDR_MOD_DST_SEC4_DestCToCR_SHAMT, ADDR_MOD_DST_SEC4_DestCToCR_MASK

#define ADDR_MOD_DST_SEC4_FidelityIncr_ADDR32 27
#define ADDR_MOD_DST_SEC4_FidelityIncr_SHAMT 13
#define ADDR_MOD_DST_SEC4_FidelityIncr_MASK 0x6000
#define ADDR_MOD_DST_SEC4_FidelityIncr_RMW \
    ADDR_MOD_DST_SEC4_FidelityIncr_ADDR32, ADDR_MOD_DST_SEC4_FidelityIncr_SHAMT, ADDR_MOD_DST_SEC4_FidelityIncr_MASK

#define ADDR_MOD_DST_SEC4_FidelityClear_ADDR32 27
#define ADDR_MOD_DST_SEC4_FidelityClear_SHAMT 15
#define ADDR_MOD_DST_SEC4_FidelityClear_MASK 0x8000
#define ADDR_MOD_DST_SEC4_FidelityClear_RMW \
    ADDR_MOD_DST_SEC4_FidelityClear_ADDR32, ADDR_MOD_DST_SEC4_FidelityClear_SHAMT, ADDR_MOD_DST_SEC4_FidelityClear_MASK

#define ADDR_MOD_DST_SEC5_DestIncr_ADDR32 28
#define ADDR_MOD_DST_SEC5_DestIncr_SHAMT 0
#define ADDR_MOD_DST_SEC5_DestIncr_MASK 0x3ff
#define ADDR_MOD_DST_SEC5_DestIncr_RMW \
    ADDR_MOD_DST_SEC5_DestIncr_ADDR32, ADDR_MOD_DST_SEC5_DestIncr_SHAMT, ADDR_MOD_DST_SEC5_DestIncr_MASK

#define ADDR_MOD_DST_SEC5_DestCR_ADDR32 28
#define ADDR_MOD_DST_SEC5_DestCR_SHAMT 10
#define ADDR_MOD_DST_SEC5_DestCR_MASK 0x400
#define ADDR_MOD_DST_SEC5_DestCR_RMW \
    ADDR_MOD_DST_SEC5_DestCR_ADDR32, ADDR_MOD_DST_SEC5_DestCR_SHAMT, ADDR_MOD_DST_SEC5_DestCR_MASK

#define ADDR_MOD_DST_SEC5_DestClear_ADDR32 28
#define ADDR_MOD_DST_SEC5_DestClear_SHAMT 11
#define ADDR_MOD_DST_SEC5_DestClear_MASK 0x800
#define ADDR_MOD_DST_SEC5_DestClear_RMW \
    ADDR_MOD_DST_SEC5_DestClear_ADDR32, ADDR_MOD_DST_SEC5_DestClear_SHAMT, ADDR_MOD_DST_SEC5_DestClear_MASK

#define ADDR_MOD_DST_SEC5_DestCToCR_ADDR32 28
#define ADDR_MOD_DST_SEC5_DestCToCR_SHAMT 12
#define ADDR_MOD_DST_SEC5_DestCToCR_MASK 0x1000
#define ADDR_MOD_DST_SEC5_DestCToCR_RMW \
    ADDR_MOD_DST_SEC5_DestCToCR_ADDR32, ADDR_MOD_DST_SEC5_DestCToCR_SHAMT, ADDR_MOD_DST_SEC5_DestCToCR_MASK

#define ADDR_MOD_DST_SEC5_FidelityIncr_ADDR32 28
#define ADDR_MOD_DST_SEC5_FidelityIncr_SHAMT 13
#define ADDR_MOD_DST_SEC5_FidelityIncr_MASK 0x6000
#define ADDR_MOD_DST_SEC5_FidelityIncr_RMW \
    ADDR_MOD_DST_SEC5_FidelityIncr_ADDR32, ADDR_MOD_DST_SEC5_FidelityIncr_SHAMT, ADDR_MOD_DST_SEC5_FidelityIncr_MASK

#define ADDR_MOD_DST_SEC5_FidelityClear_ADDR32 28
#define ADDR_MOD_DST_SEC5_FidelityClear_SHAMT 15
#define ADDR_MOD_DST_SEC5_FidelityClear_MASK 0x8000
#define ADDR_MOD_DST_SEC5_FidelityClear_RMW \
    ADDR_MOD_DST_SEC5_FidelityClear_ADDR32, ADDR_MOD_DST_SEC5_FidelityClear_SHAMT, ADDR_MOD_DST_SEC5_FidelityClear_MASK

#define ADDR_MOD_DST_SEC6_DestIncr_ADDR32 29
#define ADDR_MOD_DST_SEC6_DestIncr_SHAMT 0
#define ADDR_MOD_DST_SEC6_DestIncr_MASK 0x3ff
#define ADDR_MOD_DST_SEC6_DestIncr_RMW \
    ADDR_MOD_DST_SEC6_DestIncr_ADDR32, ADDR_MOD_DST_SEC6_DestIncr_SHAMT, ADDR_MOD_DST_SEC6_DestIncr_MASK

#define ADDR_MOD_DST_SEC6_DestCR_ADDR32 29
#define ADDR_MOD_DST_SEC6_DestCR_SHAMT 10
#define ADDR_MOD_DST_SEC6_DestCR_MASK 0x400
#define ADDR_MOD_DST_SEC6_DestCR_RMW \
    ADDR_MOD_DST_SEC6_DestCR_ADDR32, ADDR_MOD_DST_SEC6_DestCR_SHAMT, ADDR_MOD_DST_SEC6_DestCR_MASK

#define ADDR_MOD_DST_SEC6_DestClear_ADDR32 29
#define ADDR_MOD_DST_SEC6_DestClear_SHAMT 11
#define ADDR_MOD_DST_SEC6_DestClear_MASK 0x800
#define ADDR_MOD_DST_SEC6_DestClear_RMW \
    ADDR_MOD_DST_SEC6_DestClear_ADDR32, ADDR_MOD_DST_SEC6_DestClear_SHAMT, ADDR_MOD_DST_SEC6_DestClear_MASK

#define ADDR_MOD_DST_SEC6_DestCToCR_ADDR32 29
#define ADDR_MOD_DST_SEC6_DestCToCR_SHAMT 12
#define ADDR_MOD_DST_SEC6_DestCToCR_MASK 0x1000
#define ADDR_MOD_DST_SEC6_DestCToCR_RMW \
    ADDR_MOD_DST_SEC6_DestCToCR_ADDR32, ADDR_MOD_DST_SEC6_DestCToCR_SHAMT, ADDR_MOD_DST_SEC6_DestCToCR_MASK

#define ADDR_MOD_DST_SEC6_FidelityIncr_ADDR32 29
#define ADDR_MOD_DST_SEC6_FidelityIncr_SHAMT 13
#define ADDR_MOD_DST_SEC6_FidelityIncr_MASK 0x6000
#define ADDR_MOD_DST_SEC6_FidelityIncr_RMW \
    ADDR_MOD_DST_SEC6_FidelityIncr_ADDR32, ADDR_MOD_DST_SEC6_FidelityIncr_SHAMT, ADDR_MOD_DST_SEC6_FidelityIncr_MASK

#define ADDR_MOD_DST_SEC6_FidelityClear_ADDR32 29
#define ADDR_MOD_DST_SEC6_FidelityClear_SHAMT 15
#define ADDR_MOD_DST_SEC6_FidelityClear_MASK 0x8000
#define ADDR_MOD_DST_SEC6_FidelityClear_RMW \
    ADDR_MOD_DST_SEC6_FidelityClear_ADDR32, ADDR_MOD_DST_SEC6_FidelityClear_SHAMT, ADDR_MOD_DST_SEC6_FidelityClear_MASK

#define ADDR_MOD_DST_SEC7_DestIncr_ADDR32 30
#define ADDR_MOD_DST_SEC7_DestIncr_SHAMT 0
#define ADDR_MOD_DST_SEC7_DestIncr_MASK 0x3ff
#define ADDR_MOD_DST_SEC7_DestIncr_RMW \
    ADDR_MOD_DST_SEC7_DestIncr_ADDR32, ADDR_MOD_DST_SEC7_DestIncr_SHAMT, ADDR_MOD_DST_SEC7_DestIncr_MASK

#define ADDR_MOD_DST_SEC7_DestCR_ADDR32 30
#define ADDR_MOD_DST_SEC7_DestCR_SHAMT 10
#define ADDR_MOD_DST_SEC7_DestCR_MASK 0x400
#define ADDR_MOD_DST_SEC7_DestCR_RMW \
    ADDR_MOD_DST_SEC7_DestCR_ADDR32, ADDR_MOD_DST_SEC7_DestCR_SHAMT, ADDR_MOD_DST_SEC7_DestCR_MASK

#define ADDR_MOD_DST_SEC7_DestClear_ADDR32 30
#define ADDR_MOD_DST_SEC7_DestClear_SHAMT 11
#define ADDR_MOD_DST_SEC7_DestClear_MASK 0x800
#define ADDR_MOD_DST_SEC7_DestClear_RMW \
    ADDR_MOD_DST_SEC7_DestClear_ADDR32, ADDR_MOD_DST_SEC7_DestClear_SHAMT, ADDR_MOD_DST_SEC7_DestClear_MASK

#define ADDR_MOD_DST_SEC7_DestCToCR_ADDR32 30
#define ADDR_MOD_DST_SEC7_DestCToCR_SHAMT 12
#define ADDR_MOD_DST_SEC7_DestCToCR_MASK 0x1000
#define ADDR_MOD_DST_SEC7_DestCToCR_RMW \
    ADDR_MOD_DST_SEC7_DestCToCR_ADDR32, ADDR_MOD_DST_SEC7_DestCToCR_SHAMT, ADDR_MOD_DST_SEC7_DestCToCR_MASK

#define ADDR_MOD_DST_SEC7_FidelityIncr_ADDR32 30
#define ADDR_MOD_DST_SEC7_FidelityIncr_SHAMT 13
#define ADDR_MOD_DST_SEC7_FidelityIncr_MASK 0x6000
#define ADDR_MOD_DST_SEC7_FidelityIncr_RMW \
    ADDR_MOD_DST_SEC7_FidelityIncr_ADDR32, ADDR_MOD_DST_SEC7_FidelityIncr_SHAMT, ADDR_MOD_DST_SEC7_FidelityIncr_MASK

#define ADDR_MOD_DST_SEC7_FidelityClear_ADDR32 30
#define ADDR_MOD_DST_SEC7_FidelityClear_SHAMT 15
#define ADDR_MOD_DST_SEC7_FidelityClear_MASK 0x8000
#define ADDR_MOD_DST_SEC7_FidelityClear_RMW \
    ADDR_MOD_DST_SEC7_FidelityClear_ADDR32, ADDR_MOD_DST_SEC7_FidelityClear_SHAMT, ADDR_MOD_DST_SEC7_FidelityClear_MASK

#define ADDR_MOD_PACK_SEC0_YsrcIncr_ADDR32 31
#define ADDR_MOD_PACK_SEC0_YsrcIncr_SHAMT 0
#define ADDR_MOD_PACK_SEC0_YsrcIncr_MASK 0xf
#define ADDR_MOD_PACK_SEC0_YsrcIncr_RMW \
    ADDR_MOD_PACK_SEC0_YsrcIncr_ADDR32, ADDR_MOD_PACK_SEC0_YsrcIncr_SHAMT, ADDR_MOD_PACK_SEC0_YsrcIncr_MASK

#define ADDR_MOD_PACK_SEC0_YsrcCR_ADDR32 31
#define ADDR_MOD_PACK_SEC0_YsrcCR_SHAMT 4
#define ADDR_MOD_PACK_SEC0_YsrcCR_MASK 0x10
#define ADDR_MOD_PACK_SEC0_YsrcCR_RMW \
    ADDR_MOD_PACK_SEC0_YsrcCR_ADDR32, ADDR_MOD_PACK_SEC0_YsrcCR_SHAMT, ADDR_MOD_PACK_SEC0_YsrcCR_MASK

#define ADDR_MOD_PACK_SEC0_YsrcClear_ADDR32 31
#define ADDR_MOD_PACK_SEC0_YsrcClear_SHAMT 5
#define ADDR_MOD_PACK_SEC0_YsrcClear_MASK 0x20
#define ADDR_MOD_PACK_SEC0_YsrcClear_RMW \
    ADDR_MOD_PACK_SEC0_YsrcClear_ADDR32, ADDR_MOD_PACK_SEC0_YsrcClear_SHAMT, ADDR_MOD_PACK_SEC0_YsrcClear_MASK

#define ADDR_MOD_PACK_SEC0_YdstIncr_ADDR32 31
#define ADDR_MOD_PACK_SEC0_YdstIncr_SHAMT 6
#define ADDR_MOD_PACK_SEC0_YdstIncr_MASK 0x3c0
#define ADDR_MOD_PACK_SEC0_YdstIncr_RMW \
    ADDR_MOD_PACK_SEC0_YdstIncr_ADDR32, ADDR_MOD_PACK_SEC0_YdstIncr_SHAMT, ADDR_MOD_PACK_SEC0_YdstIncr_MASK

#define ADDR_MOD_PACK_SEC0_YdstCR_ADDR32 31
#define ADDR_MOD_PACK_SEC0_YdstCR_SHAMT 10
#define ADDR_MOD_PACK_SEC0_YdstCR_MASK 0x400
#define ADDR_MOD_PACK_SEC0_YdstCR_RMW \
    ADDR_MOD_PACK_SEC0_YdstCR_ADDR32, ADDR_MOD_PACK_SEC0_YdstCR_SHAMT, ADDR_MOD_PACK_SEC0_YdstCR_MASK

#define ADDR_MOD_PACK_SEC0_YdstClear_ADDR32 31
#define ADDR_MOD_PACK_SEC0_YdstClear_SHAMT 11
#define ADDR_MOD_PACK_SEC0_YdstClear_MASK 0x800
#define ADDR_MOD_PACK_SEC0_YdstClear_RMW \
    ADDR_MOD_PACK_SEC0_YdstClear_ADDR32, ADDR_MOD_PACK_SEC0_YdstClear_SHAMT, ADDR_MOD_PACK_SEC0_YdstClear_MASK

#define ADDR_MOD_PACK_SEC0_ZsrcIncr_ADDR32 31
#define ADDR_MOD_PACK_SEC0_ZsrcIncr_SHAMT 12
#define ADDR_MOD_PACK_SEC0_ZsrcIncr_MASK 0x1000
#define ADDR_MOD_PACK_SEC0_ZsrcIncr_RMW \
    ADDR_MOD_PACK_SEC0_ZsrcIncr_ADDR32, ADDR_MOD_PACK_SEC0_ZsrcIncr_SHAMT, ADDR_MOD_PACK_SEC0_ZsrcIncr_MASK

#define ADDR_MOD_PACK_SEC0_ZsrcClear_ADDR32 31
#define ADDR_MOD_PACK_SEC0_ZsrcClear_SHAMT 13
#define ADDR_MOD_PACK_SEC0_ZsrcClear_MASK 0x2000
#define ADDR_MOD_PACK_SEC0_ZsrcClear_RMW \
    ADDR_MOD_PACK_SEC0_ZsrcClear_ADDR32, ADDR_MOD_PACK_SEC0_ZsrcClear_SHAMT, ADDR_MOD_PACK_SEC0_ZsrcClear_MASK

#define ADDR_MOD_PACK_SEC0_ZdstIncr_ADDR32 31
#define ADDR_MOD_PACK_SEC0_ZdstIncr_SHAMT 14
#define ADDR_MOD_PACK_SEC0_ZdstIncr_MASK 0x4000
#define ADDR_MOD_PACK_SEC0_ZdstIncr_RMW \
    ADDR_MOD_PACK_SEC0_ZdstIncr_ADDR32, ADDR_MOD_PACK_SEC0_ZdstIncr_SHAMT, ADDR_MOD_PACK_SEC0_ZdstIncr_MASK

#define ADDR_MOD_PACK_SEC0_ZdstClear_ADDR32 31
#define ADDR_MOD_PACK_SEC0_ZdstClear_SHAMT 15
#define ADDR_MOD_PACK_SEC0_ZdstClear_MASK 0x8000
#define ADDR_MOD_PACK_SEC0_ZdstClear_RMW \
    ADDR_MOD_PACK_SEC0_ZdstClear_ADDR32, ADDR_MOD_PACK_SEC0_ZdstClear_SHAMT, ADDR_MOD_PACK_SEC0_ZdstClear_MASK

#define ADDR_MOD_PACK_SEC1_YsrcIncr_ADDR32 32
#define ADDR_MOD_PACK_SEC1_YsrcIncr_SHAMT 0
#define ADDR_MOD_PACK_SEC1_YsrcIncr_MASK 0xf
#define ADDR_MOD_PACK_SEC1_YsrcIncr_RMW \
    ADDR_MOD_PACK_SEC1_YsrcIncr_ADDR32, ADDR_MOD_PACK_SEC1_YsrcIncr_SHAMT, ADDR_MOD_PACK_SEC1_YsrcIncr_MASK

#define ADDR_MOD_PACK_SEC1_YsrcCR_ADDR32 32
#define ADDR_MOD_PACK_SEC1_YsrcCR_SHAMT 4
#define ADDR_MOD_PACK_SEC1_YsrcCR_MASK 0x10
#define ADDR_MOD_PACK_SEC1_YsrcCR_RMW \
    ADDR_MOD_PACK_SEC1_YsrcCR_ADDR32, ADDR_MOD_PACK_SEC1_YsrcCR_SHAMT, ADDR_MOD_PACK_SEC1_YsrcCR_MASK

#define ADDR_MOD_PACK_SEC1_YsrcClear_ADDR32 32
#define ADDR_MOD_PACK_SEC1_YsrcClear_SHAMT 5
#define ADDR_MOD_PACK_SEC1_YsrcClear_MASK 0x20
#define ADDR_MOD_PACK_SEC1_YsrcClear_RMW \
    ADDR_MOD_PACK_SEC1_YsrcClear_ADDR32, ADDR_MOD_PACK_SEC1_YsrcClear_SHAMT, ADDR_MOD_PACK_SEC1_YsrcClear_MASK

#define ADDR_MOD_PACK_SEC1_YdstIncr_ADDR32 32
#define ADDR_MOD_PACK_SEC1_YdstIncr_SHAMT 6
#define ADDR_MOD_PACK_SEC1_YdstIncr_MASK 0x3c0
#define ADDR_MOD_PACK_SEC1_YdstIncr_RMW \
    ADDR_MOD_PACK_SEC1_YdstIncr_ADDR32, ADDR_MOD_PACK_SEC1_YdstIncr_SHAMT, ADDR_MOD_PACK_SEC1_YdstIncr_MASK

#define ADDR_MOD_PACK_SEC1_YdstCR_ADDR32 32
#define ADDR_MOD_PACK_SEC1_YdstCR_SHAMT 10
#define ADDR_MOD_PACK_SEC1_YdstCR_MASK 0x400
#define ADDR_MOD_PACK_SEC1_YdstCR_RMW \
    ADDR_MOD_PACK_SEC1_YdstCR_ADDR32, ADDR_MOD_PACK_SEC1_YdstCR_SHAMT, ADDR_MOD_PACK_SEC1_YdstCR_MASK

#define ADDR_MOD_PACK_SEC1_YdstClear_ADDR32 32
#define ADDR_MOD_PACK_SEC1_YdstClear_SHAMT 11
#define ADDR_MOD_PACK_SEC1_YdstClear_MASK 0x800
#define ADDR_MOD_PACK_SEC1_YdstClear_RMW \
    ADDR_MOD_PACK_SEC1_YdstClear_ADDR32, ADDR_MOD_PACK_SEC1_YdstClear_SHAMT, ADDR_MOD_PACK_SEC1_YdstClear_MASK

#define ADDR_MOD_PACK_SEC1_ZsrcIncr_ADDR32 32
#define ADDR_MOD_PACK_SEC1_ZsrcIncr_SHAMT 12
#define ADDR_MOD_PACK_SEC1_ZsrcIncr_MASK 0x1000
#define ADDR_MOD_PACK_SEC1_ZsrcIncr_RMW \
    ADDR_MOD_PACK_SEC1_ZsrcIncr_ADDR32, ADDR_MOD_PACK_SEC1_ZsrcIncr_SHAMT, ADDR_MOD_PACK_SEC1_ZsrcIncr_MASK

#define ADDR_MOD_PACK_SEC1_ZsrcClear_ADDR32 32
#define ADDR_MOD_PACK_SEC1_ZsrcClear_SHAMT 13
#define ADDR_MOD_PACK_SEC1_ZsrcClear_MASK 0x2000
#define ADDR_MOD_PACK_SEC1_ZsrcClear_RMW \
    ADDR_MOD_PACK_SEC1_ZsrcClear_ADDR32, ADDR_MOD_PACK_SEC1_ZsrcClear_SHAMT, ADDR_MOD_PACK_SEC1_ZsrcClear_MASK

#define ADDR_MOD_PACK_SEC1_ZdstIncr_ADDR32 32
#define ADDR_MOD_PACK_SEC1_ZdstIncr_SHAMT 14
#define ADDR_MOD_PACK_SEC1_ZdstIncr_MASK 0x4000
#define ADDR_MOD_PACK_SEC1_ZdstIncr_RMW \
    ADDR_MOD_PACK_SEC1_ZdstIncr_ADDR32, ADDR_MOD_PACK_SEC1_ZdstIncr_SHAMT, ADDR_MOD_PACK_SEC1_ZdstIncr_MASK

#define ADDR_MOD_PACK_SEC1_ZdstClear_ADDR32 32
#define ADDR_MOD_PACK_SEC1_ZdstClear_SHAMT 15
#define ADDR_MOD_PACK_SEC1_ZdstClear_MASK 0x8000
#define ADDR_MOD_PACK_SEC1_ZdstClear_RMW \
    ADDR_MOD_PACK_SEC1_ZdstClear_ADDR32, ADDR_MOD_PACK_SEC1_ZdstClear_SHAMT, ADDR_MOD_PACK_SEC1_ZdstClear_MASK

#define ADDR_MOD_PACK_SEC2_YsrcIncr_ADDR32 33
#define ADDR_MOD_PACK_SEC2_YsrcIncr_SHAMT 0
#define ADDR_MOD_PACK_SEC2_YsrcIncr_MASK 0xf
#define ADDR_MOD_PACK_SEC2_YsrcIncr_RMW \
    ADDR_MOD_PACK_SEC2_YsrcIncr_ADDR32, ADDR_MOD_PACK_SEC2_YsrcIncr_SHAMT, ADDR_MOD_PACK_SEC2_YsrcIncr_MASK

#define ADDR_MOD_PACK_SEC2_YsrcCR_ADDR32 33
#define ADDR_MOD_PACK_SEC2_YsrcCR_SHAMT 4
#define ADDR_MOD_PACK_SEC2_YsrcCR_MASK 0x10
#define ADDR_MOD_PACK_SEC2_YsrcCR_RMW \
    ADDR_MOD_PACK_SEC2_YsrcCR_ADDR32, ADDR_MOD_PACK_SEC2_YsrcCR_SHAMT, ADDR_MOD_PACK_SEC2_YsrcCR_MASK

#define ADDR_MOD_PACK_SEC2_YsrcClear_ADDR32 33
#define ADDR_MOD_PACK_SEC2_YsrcClear_SHAMT 5
#define ADDR_MOD_PACK_SEC2_YsrcClear_MASK 0x20
#define ADDR_MOD_PACK_SEC2_YsrcClear_RMW \
    ADDR_MOD_PACK_SEC2_YsrcClear_ADDR32, ADDR_MOD_PACK_SEC2_YsrcClear_SHAMT, ADDR_MOD_PACK_SEC2_YsrcClear_MASK

#define ADDR_MOD_PACK_SEC2_YdstIncr_ADDR32 33
#define ADDR_MOD_PACK_SEC2_YdstIncr_SHAMT 6
#define ADDR_MOD_PACK_SEC2_YdstIncr_MASK 0x3c0
#define ADDR_MOD_PACK_SEC2_YdstIncr_RMW \
    ADDR_MOD_PACK_SEC2_YdstIncr_ADDR32, ADDR_MOD_PACK_SEC2_YdstIncr_SHAMT, ADDR_MOD_PACK_SEC2_YdstIncr_MASK

#define ADDR_MOD_PACK_SEC2_YdstCR_ADDR32 33
#define ADDR_MOD_PACK_SEC2_YdstCR_SHAMT 10
#define ADDR_MOD_PACK_SEC2_YdstCR_MASK 0x400
#define ADDR_MOD_PACK_SEC2_YdstCR_RMW \
    ADDR_MOD_PACK_SEC2_YdstCR_ADDR32, ADDR_MOD_PACK_SEC2_YdstCR_SHAMT, ADDR_MOD_PACK_SEC2_YdstCR_MASK

#define ADDR_MOD_PACK_SEC2_YdstClear_ADDR32 33
#define ADDR_MOD_PACK_SEC2_YdstClear_SHAMT 11
#define ADDR_MOD_PACK_SEC2_YdstClear_MASK 0x800
#define ADDR_MOD_PACK_SEC2_YdstClear_RMW \
    ADDR_MOD_PACK_SEC2_YdstClear_ADDR32, ADDR_MOD_PACK_SEC2_YdstClear_SHAMT, ADDR_MOD_PACK_SEC2_YdstClear_MASK

#define ADDR_MOD_PACK_SEC2_ZsrcIncr_ADDR32 33
#define ADDR_MOD_PACK_SEC2_ZsrcIncr_SHAMT 12
#define ADDR_MOD_PACK_SEC2_ZsrcIncr_MASK 0x1000
#define ADDR_MOD_PACK_SEC2_ZsrcIncr_RMW \
    ADDR_MOD_PACK_SEC2_ZsrcIncr_ADDR32, ADDR_MOD_PACK_SEC2_ZsrcIncr_SHAMT, ADDR_MOD_PACK_SEC2_ZsrcIncr_MASK

#define ADDR_MOD_PACK_SEC2_ZsrcClear_ADDR32 33
#define ADDR_MOD_PACK_SEC2_ZsrcClear_SHAMT 13
#define ADDR_MOD_PACK_SEC2_ZsrcClear_MASK 0x2000
#define ADDR_MOD_PACK_SEC2_ZsrcClear_RMW \
    ADDR_MOD_PACK_SEC2_ZsrcClear_ADDR32, ADDR_MOD_PACK_SEC2_ZsrcClear_SHAMT, ADDR_MOD_PACK_SEC2_ZsrcClear_MASK

#define ADDR_MOD_PACK_SEC2_ZdstIncr_ADDR32 33
#define ADDR_MOD_PACK_SEC2_ZdstIncr_SHAMT 14
#define ADDR_MOD_PACK_SEC2_ZdstIncr_MASK 0x4000
#define ADDR_MOD_PACK_SEC2_ZdstIncr_RMW \
    ADDR_MOD_PACK_SEC2_ZdstIncr_ADDR32, ADDR_MOD_PACK_SEC2_ZdstIncr_SHAMT, ADDR_MOD_PACK_SEC2_ZdstIncr_MASK

#define ADDR_MOD_PACK_SEC2_ZdstClear_ADDR32 33
#define ADDR_MOD_PACK_SEC2_ZdstClear_SHAMT 15
#define ADDR_MOD_PACK_SEC2_ZdstClear_MASK 0x8000
#define ADDR_MOD_PACK_SEC2_ZdstClear_RMW \
    ADDR_MOD_PACK_SEC2_ZdstClear_ADDR32, ADDR_MOD_PACK_SEC2_ZdstClear_SHAMT, ADDR_MOD_PACK_SEC2_ZdstClear_MASK

#define ADDR_MOD_PACK_SEC3_YsrcIncr_ADDR32 34
#define ADDR_MOD_PACK_SEC3_YsrcIncr_SHAMT 0
#define ADDR_MOD_PACK_SEC3_YsrcIncr_MASK 0xf
#define ADDR_MOD_PACK_SEC3_YsrcIncr_RMW \
    ADDR_MOD_PACK_SEC3_YsrcIncr_ADDR32, ADDR_MOD_PACK_SEC3_YsrcIncr_SHAMT, ADDR_MOD_PACK_SEC3_YsrcIncr_MASK

#define ADDR_MOD_PACK_SEC3_YsrcCR_ADDR32 34
#define ADDR_MOD_PACK_SEC3_YsrcCR_SHAMT 4
#define ADDR_MOD_PACK_SEC3_YsrcCR_MASK 0x10
#define ADDR_MOD_PACK_SEC3_YsrcCR_RMW \
    ADDR_MOD_PACK_SEC3_YsrcCR_ADDR32, ADDR_MOD_PACK_SEC3_YsrcCR_SHAMT, ADDR_MOD_PACK_SEC3_YsrcCR_MASK

#define ADDR_MOD_PACK_SEC3_YsrcClear_ADDR32 34
#define ADDR_MOD_PACK_SEC3_YsrcClear_SHAMT 5
#define ADDR_MOD_PACK_SEC3_YsrcClear_MASK 0x20
#define ADDR_MOD_PACK_SEC3_YsrcClear_RMW \
    ADDR_MOD_PACK_SEC3_YsrcClear_ADDR32, ADDR_MOD_PACK_SEC3_YsrcClear_SHAMT, ADDR_MOD_PACK_SEC3_YsrcClear_MASK

#define ADDR_MOD_PACK_SEC3_YdstIncr_ADDR32 34
#define ADDR_MOD_PACK_SEC3_YdstIncr_SHAMT 6
#define ADDR_MOD_PACK_SEC3_YdstIncr_MASK 0x3c0
#define ADDR_MOD_PACK_SEC3_YdstIncr_RMW \
    ADDR_MOD_PACK_SEC3_YdstIncr_ADDR32, ADDR_MOD_PACK_SEC3_YdstIncr_SHAMT, ADDR_MOD_PACK_SEC3_YdstIncr_MASK

#define ADDR_MOD_PACK_SEC3_YdstCR_ADDR32 34
#define ADDR_MOD_PACK_SEC3_YdstCR_SHAMT 10
#define ADDR_MOD_PACK_SEC3_YdstCR_MASK 0x400
#define ADDR_MOD_PACK_SEC3_YdstCR_RMW \
    ADDR_MOD_PACK_SEC3_YdstCR_ADDR32, ADDR_MOD_PACK_SEC3_YdstCR_SHAMT, ADDR_MOD_PACK_SEC3_YdstCR_MASK

#define ADDR_MOD_PACK_SEC3_YdstClear_ADDR32 34
#define ADDR_MOD_PACK_SEC3_YdstClear_SHAMT 11
#define ADDR_MOD_PACK_SEC3_YdstClear_MASK 0x800
#define ADDR_MOD_PACK_SEC3_YdstClear_RMW \
    ADDR_MOD_PACK_SEC3_YdstClear_ADDR32, ADDR_MOD_PACK_SEC3_YdstClear_SHAMT, ADDR_MOD_PACK_SEC3_YdstClear_MASK

#define ADDR_MOD_PACK_SEC3_ZsrcIncr_ADDR32 34
#define ADDR_MOD_PACK_SEC3_ZsrcIncr_SHAMT 12
#define ADDR_MOD_PACK_SEC3_ZsrcIncr_MASK 0x1000
#define ADDR_MOD_PACK_SEC3_ZsrcIncr_RMW \
    ADDR_MOD_PACK_SEC3_ZsrcIncr_ADDR32, ADDR_MOD_PACK_SEC3_ZsrcIncr_SHAMT, ADDR_MOD_PACK_SEC3_ZsrcIncr_MASK

#define ADDR_MOD_PACK_SEC3_ZsrcClear_ADDR32 34
#define ADDR_MOD_PACK_SEC3_ZsrcClear_SHAMT 13
#define ADDR_MOD_PACK_SEC3_ZsrcClear_MASK 0x2000
#define ADDR_MOD_PACK_SEC3_ZsrcClear_RMW \
    ADDR_MOD_PACK_SEC3_ZsrcClear_ADDR32, ADDR_MOD_PACK_SEC3_ZsrcClear_SHAMT, ADDR_MOD_PACK_SEC3_ZsrcClear_MASK

#define ADDR_MOD_PACK_SEC3_ZdstIncr_ADDR32 34
#define ADDR_MOD_PACK_SEC3_ZdstIncr_SHAMT 14
#define ADDR_MOD_PACK_SEC3_ZdstIncr_MASK 0x4000
#define ADDR_MOD_PACK_SEC3_ZdstIncr_RMW \
    ADDR_MOD_PACK_SEC3_ZdstIncr_ADDR32, ADDR_MOD_PACK_SEC3_ZdstIncr_SHAMT, ADDR_MOD_PACK_SEC3_ZdstIncr_MASK

#define ADDR_MOD_PACK_SEC3_ZdstClear_ADDR32 34
#define ADDR_MOD_PACK_SEC3_ZdstClear_SHAMT 15
#define ADDR_MOD_PACK_SEC3_ZdstClear_MASK 0x8000
#define ADDR_MOD_PACK_SEC3_ZdstClear_RMW \
    ADDR_MOD_PACK_SEC3_ZdstClear_ADDR32, ADDR_MOD_PACK_SEC3_ZdstClear_SHAMT, ADDR_MOD_PACK_SEC3_ZdstClear_MASK

#define ADDR_MOD_PACK_SEC4_YsrcIncr_ADDR32 35
#define ADDR_MOD_PACK_SEC4_YsrcIncr_SHAMT 0
#define ADDR_MOD_PACK_SEC4_YsrcIncr_MASK 0xf
#define ADDR_MOD_PACK_SEC4_YsrcIncr_RMW \
    ADDR_MOD_PACK_SEC4_YsrcIncr_ADDR32, ADDR_MOD_PACK_SEC4_YsrcIncr_SHAMT, ADDR_MOD_PACK_SEC4_YsrcIncr_MASK

#define ADDR_MOD_PACK_SEC4_YsrcCR_ADDR32 35
#define ADDR_MOD_PACK_SEC4_YsrcCR_SHAMT 4
#define ADDR_MOD_PACK_SEC4_YsrcCR_MASK 0x10
#define ADDR_MOD_PACK_SEC4_YsrcCR_RMW \
    ADDR_MOD_PACK_SEC4_YsrcCR_ADDR32, ADDR_MOD_PACK_SEC4_YsrcCR_SHAMT, ADDR_MOD_PACK_SEC4_YsrcCR_MASK

#define ADDR_MOD_PACK_SEC4_YsrcClear_ADDR32 35
#define ADDR_MOD_PACK_SEC4_YsrcClear_SHAMT 5
#define ADDR_MOD_PACK_SEC4_YsrcClear_MASK 0x20
#define ADDR_MOD_PACK_SEC4_YsrcClear_RMW \
    ADDR_MOD_PACK_SEC4_YsrcClear_ADDR32, ADDR_MOD_PACK_SEC4_YsrcClear_SHAMT, ADDR_MOD_PACK_SEC4_YsrcClear_MASK

#define ADDR_MOD_PACK_SEC4_YdstIncr_ADDR32 35
#define ADDR_MOD_PACK_SEC4_YdstIncr_SHAMT 6
#define ADDR_MOD_PACK_SEC4_YdstIncr_MASK 0x3c0
#define ADDR_MOD_PACK_SEC4_YdstIncr_RMW \
    ADDR_MOD_PACK_SEC4_YdstIncr_ADDR32, ADDR_MOD_PACK_SEC4_YdstIncr_SHAMT, ADDR_MOD_PACK_SEC4_YdstIncr_MASK

#define ADDR_MOD_PACK_SEC4_YdstCR_ADDR32 35
#define ADDR_MOD_PACK_SEC4_YdstCR_SHAMT 10
#define ADDR_MOD_PACK_SEC4_YdstCR_MASK 0x400
#define ADDR_MOD_PACK_SEC4_YdstCR_RMW \
    ADDR_MOD_PACK_SEC4_YdstCR_ADDR32, ADDR_MOD_PACK_SEC4_YdstCR_SHAMT, ADDR_MOD_PACK_SEC4_YdstCR_MASK

#define ADDR_MOD_PACK_SEC4_YdstClear_ADDR32 35
#define ADDR_MOD_PACK_SEC4_YdstClear_SHAMT 11
#define ADDR_MOD_PACK_SEC4_YdstClear_MASK 0x800
#define ADDR_MOD_PACK_SEC4_YdstClear_RMW \
    ADDR_MOD_PACK_SEC4_YdstClear_ADDR32, ADDR_MOD_PACK_SEC4_YdstClear_SHAMT, ADDR_MOD_PACK_SEC4_YdstClear_MASK

#define ADDR_MOD_PACK_SEC4_ZsrcIncr_ADDR32 35
#define ADDR_MOD_PACK_SEC4_ZsrcIncr_SHAMT 12
#define ADDR_MOD_PACK_SEC4_ZsrcIncr_MASK 0x1000
#define ADDR_MOD_PACK_SEC4_ZsrcIncr_RMW \
    ADDR_MOD_PACK_SEC4_ZsrcIncr_ADDR32, ADDR_MOD_PACK_SEC4_ZsrcIncr_SHAMT, ADDR_MOD_PACK_SEC4_ZsrcIncr_MASK

#define ADDR_MOD_PACK_SEC4_ZsrcClear_ADDR32 35
#define ADDR_MOD_PACK_SEC4_ZsrcClear_SHAMT 13
#define ADDR_MOD_PACK_SEC4_ZsrcClear_MASK 0x2000
#define ADDR_MOD_PACK_SEC4_ZsrcClear_RMW \
    ADDR_MOD_PACK_SEC4_ZsrcClear_ADDR32, ADDR_MOD_PACK_SEC4_ZsrcClear_SHAMT, ADDR_MOD_PACK_SEC4_ZsrcClear_MASK

#define ADDR_MOD_PACK_SEC4_ZdstIncr_ADDR32 35
#define ADDR_MOD_PACK_SEC4_ZdstIncr_SHAMT 14
#define ADDR_MOD_PACK_SEC4_ZdstIncr_MASK 0x4000
#define ADDR_MOD_PACK_SEC4_ZdstIncr_RMW \
    ADDR_MOD_PACK_SEC4_ZdstIncr_ADDR32, ADDR_MOD_PACK_SEC4_ZdstIncr_SHAMT, ADDR_MOD_PACK_SEC4_ZdstIncr_MASK

#define ADDR_MOD_PACK_SEC4_ZdstClear_ADDR32 35
#define ADDR_MOD_PACK_SEC4_ZdstClear_SHAMT 15
#define ADDR_MOD_PACK_SEC4_ZdstClear_MASK 0x8000
#define ADDR_MOD_PACK_SEC4_ZdstClear_RMW \
    ADDR_MOD_PACK_SEC4_ZdstClear_ADDR32, ADDR_MOD_PACK_SEC4_ZdstClear_SHAMT, ADDR_MOD_PACK_SEC4_ZdstClear_MASK

#define ADDR_MOD_PACK_SEC5_YsrcIncr_ADDR32 36
#define ADDR_MOD_PACK_SEC5_YsrcIncr_SHAMT 0
#define ADDR_MOD_PACK_SEC5_YsrcIncr_MASK 0xf
#define ADDR_MOD_PACK_SEC5_YsrcIncr_RMW \
    ADDR_MOD_PACK_SEC5_YsrcIncr_ADDR32, ADDR_MOD_PACK_SEC5_YsrcIncr_SHAMT, ADDR_MOD_PACK_SEC5_YsrcIncr_MASK

#define ADDR_MOD_PACK_SEC5_YsrcCR_ADDR32 36
#define ADDR_MOD_PACK_SEC5_YsrcCR_SHAMT 4
#define ADDR_MOD_PACK_SEC5_YsrcCR_MASK 0x10
#define ADDR_MOD_PACK_SEC5_YsrcCR_RMW \
    ADDR_MOD_PACK_SEC5_YsrcCR_ADDR32, ADDR_MOD_PACK_SEC5_YsrcCR_SHAMT, ADDR_MOD_PACK_SEC5_YsrcCR_MASK

#define ADDR_MOD_PACK_SEC5_YsrcClear_ADDR32 36
#define ADDR_MOD_PACK_SEC5_YsrcClear_SHAMT 5
#define ADDR_MOD_PACK_SEC5_YsrcClear_MASK 0x20
#define ADDR_MOD_PACK_SEC5_YsrcClear_RMW \
    ADDR_MOD_PACK_SEC5_YsrcClear_ADDR32, ADDR_MOD_PACK_SEC5_YsrcClear_SHAMT, ADDR_MOD_PACK_SEC5_YsrcClear_MASK

#define ADDR_MOD_PACK_SEC5_YdstIncr_ADDR32 36
#define ADDR_MOD_PACK_SEC5_YdstIncr_SHAMT 6
#define ADDR_MOD_PACK_SEC5_YdstIncr_MASK 0x3c0
#define ADDR_MOD_PACK_SEC5_YdstIncr_RMW \
    ADDR_MOD_PACK_SEC5_YdstIncr_ADDR32, ADDR_MOD_PACK_SEC5_YdstIncr_SHAMT, ADDR_MOD_PACK_SEC5_YdstIncr_MASK

#define ADDR_MOD_PACK_SEC5_YdstCR_ADDR32 36
#define ADDR_MOD_PACK_SEC5_YdstCR_SHAMT 10
#define ADDR_MOD_PACK_SEC5_YdstCR_MASK 0x400
#define ADDR_MOD_PACK_SEC5_YdstCR_RMW \
    ADDR_MOD_PACK_SEC5_YdstCR_ADDR32, ADDR_MOD_PACK_SEC5_YdstCR_SHAMT, ADDR_MOD_PACK_SEC5_YdstCR_MASK

#define ADDR_MOD_PACK_SEC5_YdstClear_ADDR32 36
#define ADDR_MOD_PACK_SEC5_YdstClear_SHAMT 11
#define ADDR_MOD_PACK_SEC5_YdstClear_MASK 0x800
#define ADDR_MOD_PACK_SEC5_YdstClear_RMW \
    ADDR_MOD_PACK_SEC5_YdstClear_ADDR32, ADDR_MOD_PACK_SEC5_YdstClear_SHAMT, ADDR_MOD_PACK_SEC5_YdstClear_MASK

#define ADDR_MOD_PACK_SEC5_ZsrcIncr_ADDR32 36
#define ADDR_MOD_PACK_SEC5_ZsrcIncr_SHAMT 12
#define ADDR_MOD_PACK_SEC5_ZsrcIncr_MASK 0x1000
#define ADDR_MOD_PACK_SEC5_ZsrcIncr_RMW \
    ADDR_MOD_PACK_SEC5_ZsrcIncr_ADDR32, ADDR_MOD_PACK_SEC5_ZsrcIncr_SHAMT, ADDR_MOD_PACK_SEC5_ZsrcIncr_MASK

#define ADDR_MOD_PACK_SEC5_ZsrcClear_ADDR32 36
#define ADDR_MOD_PACK_SEC5_ZsrcClear_SHAMT 13
#define ADDR_MOD_PACK_SEC5_ZsrcClear_MASK 0x2000
#define ADDR_MOD_PACK_SEC5_ZsrcClear_RMW \
    ADDR_MOD_PACK_SEC5_ZsrcClear_ADDR32, ADDR_MOD_PACK_SEC5_ZsrcClear_SHAMT, ADDR_MOD_PACK_SEC5_ZsrcClear_MASK

#define ADDR_MOD_PACK_SEC5_ZdstIncr_ADDR32 36
#define ADDR_MOD_PACK_SEC5_ZdstIncr_SHAMT 14
#define ADDR_MOD_PACK_SEC5_ZdstIncr_MASK 0x4000
#define ADDR_MOD_PACK_SEC5_ZdstIncr_RMW \
    ADDR_MOD_PACK_SEC5_ZdstIncr_ADDR32, ADDR_MOD_PACK_SEC5_ZdstIncr_SHAMT, ADDR_MOD_PACK_SEC5_ZdstIncr_MASK

#define ADDR_MOD_PACK_SEC5_ZdstClear_ADDR32 36
#define ADDR_MOD_PACK_SEC5_ZdstClear_SHAMT 15
#define ADDR_MOD_PACK_SEC5_ZdstClear_MASK 0x8000
#define ADDR_MOD_PACK_SEC5_ZdstClear_RMW \
    ADDR_MOD_PACK_SEC5_ZdstClear_ADDR32, ADDR_MOD_PACK_SEC5_ZdstClear_SHAMT, ADDR_MOD_PACK_SEC5_ZdstClear_MASK

#define ADDR_MOD_PACK_SEC6_YsrcIncr_ADDR32 37
#define ADDR_MOD_PACK_SEC6_YsrcIncr_SHAMT 0
#define ADDR_MOD_PACK_SEC6_YsrcIncr_MASK 0xf
#define ADDR_MOD_PACK_SEC6_YsrcIncr_RMW \
    ADDR_MOD_PACK_SEC6_YsrcIncr_ADDR32, ADDR_MOD_PACK_SEC6_YsrcIncr_SHAMT, ADDR_MOD_PACK_SEC6_YsrcIncr_MASK

#define ADDR_MOD_PACK_SEC6_YsrcCR_ADDR32 37
#define ADDR_MOD_PACK_SEC6_YsrcCR_SHAMT 4
#define ADDR_MOD_PACK_SEC6_YsrcCR_MASK 0x10
#define ADDR_MOD_PACK_SEC6_YsrcCR_RMW \
    ADDR_MOD_PACK_SEC6_YsrcCR_ADDR32, ADDR_MOD_PACK_SEC6_YsrcCR_SHAMT, ADDR_MOD_PACK_SEC6_YsrcCR_MASK

#define ADDR_MOD_PACK_SEC6_YsrcClear_ADDR32 37
#define ADDR_MOD_PACK_SEC6_YsrcClear_SHAMT 5
#define ADDR_MOD_PACK_SEC6_YsrcClear_MASK 0x20
#define ADDR_MOD_PACK_SEC6_YsrcClear_RMW \
    ADDR_MOD_PACK_SEC6_YsrcClear_ADDR32, ADDR_MOD_PACK_SEC6_YsrcClear_SHAMT, ADDR_MOD_PACK_SEC6_YsrcClear_MASK

#define ADDR_MOD_PACK_SEC6_YdstIncr_ADDR32 37
#define ADDR_MOD_PACK_SEC6_YdstIncr_SHAMT 6
#define ADDR_MOD_PACK_SEC6_YdstIncr_MASK 0x3c0
#define ADDR_MOD_PACK_SEC6_YdstIncr_RMW \
    ADDR_MOD_PACK_SEC6_YdstIncr_ADDR32, ADDR_MOD_PACK_SEC6_YdstIncr_SHAMT, ADDR_MOD_PACK_SEC6_YdstIncr_MASK

#define ADDR_MOD_PACK_SEC6_YdstCR_ADDR32 37
#define ADDR_MOD_PACK_SEC6_YdstCR_SHAMT 10
#define ADDR_MOD_PACK_SEC6_YdstCR_MASK 0x400
#define ADDR_MOD_PACK_SEC6_YdstCR_RMW \
    ADDR_MOD_PACK_SEC6_YdstCR_ADDR32, ADDR_MOD_PACK_SEC6_YdstCR_SHAMT, ADDR_MOD_PACK_SEC6_YdstCR_MASK

#define ADDR_MOD_PACK_SEC6_YdstClear_ADDR32 37
#define ADDR_MOD_PACK_SEC6_YdstClear_SHAMT 11
#define ADDR_MOD_PACK_SEC6_YdstClear_MASK 0x800
#define ADDR_MOD_PACK_SEC6_YdstClear_RMW \
    ADDR_MOD_PACK_SEC6_YdstClear_ADDR32, ADDR_MOD_PACK_SEC6_YdstClear_SHAMT, ADDR_MOD_PACK_SEC6_YdstClear_MASK

#define ADDR_MOD_PACK_SEC6_ZsrcIncr_ADDR32 37
#define ADDR_MOD_PACK_SEC6_ZsrcIncr_SHAMT 12
#define ADDR_MOD_PACK_SEC6_ZsrcIncr_MASK 0x1000
#define ADDR_MOD_PACK_SEC6_ZsrcIncr_RMW \
    ADDR_MOD_PACK_SEC6_ZsrcIncr_ADDR32, ADDR_MOD_PACK_SEC6_ZsrcIncr_SHAMT, ADDR_MOD_PACK_SEC6_ZsrcIncr_MASK

#define ADDR_MOD_PACK_SEC6_ZsrcClear_ADDR32 37
#define ADDR_MOD_PACK_SEC6_ZsrcClear_SHAMT 13
#define ADDR_MOD_PACK_SEC6_ZsrcClear_MASK 0x2000
#define ADDR_MOD_PACK_SEC6_ZsrcClear_RMW \
    ADDR_MOD_PACK_SEC6_ZsrcClear_ADDR32, ADDR_MOD_PACK_SEC6_ZsrcClear_SHAMT, ADDR_MOD_PACK_SEC6_ZsrcClear_MASK

#define ADDR_MOD_PACK_SEC6_ZdstIncr_ADDR32 37
#define ADDR_MOD_PACK_SEC6_ZdstIncr_SHAMT 14
#define ADDR_MOD_PACK_SEC6_ZdstIncr_MASK 0x4000
#define ADDR_MOD_PACK_SEC6_ZdstIncr_RMW \
    ADDR_MOD_PACK_SEC6_ZdstIncr_ADDR32, ADDR_MOD_PACK_SEC6_ZdstIncr_SHAMT, ADDR_MOD_PACK_SEC6_ZdstIncr_MASK

#define ADDR_MOD_PACK_SEC6_ZdstClear_ADDR32 37
#define ADDR_MOD_PACK_SEC6_ZdstClear_SHAMT 15
#define ADDR_MOD_PACK_SEC6_ZdstClear_MASK 0x8000
#define ADDR_MOD_PACK_SEC6_ZdstClear_RMW \
    ADDR_MOD_PACK_SEC6_ZdstClear_ADDR32, ADDR_MOD_PACK_SEC6_ZdstClear_SHAMT, ADDR_MOD_PACK_SEC6_ZdstClear_MASK

#define ADDR_MOD_PACK_SEC7_YsrcIncr_ADDR32 38
#define ADDR_MOD_PACK_SEC7_YsrcIncr_SHAMT 0
#define ADDR_MOD_PACK_SEC7_YsrcIncr_MASK 0xf
#define ADDR_MOD_PACK_SEC7_YsrcIncr_RMW \
    ADDR_MOD_PACK_SEC7_YsrcIncr_ADDR32, ADDR_MOD_PACK_SEC7_YsrcIncr_SHAMT, ADDR_MOD_PACK_SEC7_YsrcIncr_MASK

#define ADDR_MOD_PACK_SEC7_YsrcCR_ADDR32 38
#define ADDR_MOD_PACK_SEC7_YsrcCR_SHAMT 4
#define ADDR_MOD_PACK_SEC7_YsrcCR_MASK 0x10
#define ADDR_MOD_PACK_SEC7_YsrcCR_RMW \
    ADDR_MOD_PACK_SEC7_YsrcCR_ADDR32, ADDR_MOD_PACK_SEC7_YsrcCR_SHAMT, ADDR_MOD_PACK_SEC7_YsrcCR_MASK

#define ADDR_MOD_PACK_SEC7_YsrcClear_ADDR32 38
#define ADDR_MOD_PACK_SEC7_YsrcClear_SHAMT 5
#define ADDR_MOD_PACK_SEC7_YsrcClear_MASK 0x20
#define ADDR_MOD_PACK_SEC7_YsrcClear_RMW \
    ADDR_MOD_PACK_SEC7_YsrcClear_ADDR32, ADDR_MOD_PACK_SEC7_YsrcClear_SHAMT, ADDR_MOD_PACK_SEC7_YsrcClear_MASK

#define ADDR_MOD_PACK_SEC7_YdstIncr_ADDR32 38
#define ADDR_MOD_PACK_SEC7_YdstIncr_SHAMT 6
#define ADDR_MOD_PACK_SEC7_YdstIncr_MASK 0x3c0
#define ADDR_MOD_PACK_SEC7_YdstIncr_RMW \
    ADDR_MOD_PACK_SEC7_YdstIncr_ADDR32, ADDR_MOD_PACK_SEC7_YdstIncr_SHAMT, ADDR_MOD_PACK_SEC7_YdstIncr_MASK

#define ADDR_MOD_PACK_SEC7_YdstCR_ADDR32 38
#define ADDR_MOD_PACK_SEC7_YdstCR_SHAMT 10
#define ADDR_MOD_PACK_SEC7_YdstCR_MASK 0x400
#define ADDR_MOD_PACK_SEC7_YdstCR_RMW \
    ADDR_MOD_PACK_SEC7_YdstCR_ADDR32, ADDR_MOD_PACK_SEC7_YdstCR_SHAMT, ADDR_MOD_PACK_SEC7_YdstCR_MASK

#define ADDR_MOD_PACK_SEC7_YdstClear_ADDR32 38
#define ADDR_MOD_PACK_SEC7_YdstClear_SHAMT 11
#define ADDR_MOD_PACK_SEC7_YdstClear_MASK 0x800
#define ADDR_MOD_PACK_SEC7_YdstClear_RMW \
    ADDR_MOD_PACK_SEC7_YdstClear_ADDR32, ADDR_MOD_PACK_SEC7_YdstClear_SHAMT, ADDR_MOD_PACK_SEC7_YdstClear_MASK

#define ADDR_MOD_PACK_SEC7_ZsrcIncr_ADDR32 38
#define ADDR_MOD_PACK_SEC7_ZsrcIncr_SHAMT 12
#define ADDR_MOD_PACK_SEC7_ZsrcIncr_MASK 0x1000
#define ADDR_MOD_PACK_SEC7_ZsrcIncr_RMW \
    ADDR_MOD_PACK_SEC7_ZsrcIncr_ADDR32, ADDR_MOD_PACK_SEC7_ZsrcIncr_SHAMT, ADDR_MOD_PACK_SEC7_ZsrcIncr_MASK

#define ADDR_MOD_PACK_SEC7_ZsrcClear_ADDR32 38
#define ADDR_MOD_PACK_SEC7_ZsrcClear_SHAMT 13
#define ADDR_MOD_PACK_SEC7_ZsrcClear_MASK 0x2000
#define ADDR_MOD_PACK_SEC7_ZsrcClear_RMW \
    ADDR_MOD_PACK_SEC7_ZsrcClear_ADDR32, ADDR_MOD_PACK_SEC7_ZsrcClear_SHAMT, ADDR_MOD_PACK_SEC7_ZsrcClear_MASK

#define ADDR_MOD_PACK_SEC7_ZdstIncr_ADDR32 38
#define ADDR_MOD_PACK_SEC7_ZdstIncr_SHAMT 14
#define ADDR_MOD_PACK_SEC7_ZdstIncr_MASK 0x4000
#define ADDR_MOD_PACK_SEC7_ZdstIncr_RMW \
    ADDR_MOD_PACK_SEC7_ZdstIncr_ADDR32, ADDR_MOD_PACK_SEC7_ZdstIncr_SHAMT, ADDR_MOD_PACK_SEC7_ZdstIncr_MASK

#define ADDR_MOD_PACK_SEC7_ZdstClear_ADDR32 38
#define ADDR_MOD_PACK_SEC7_ZdstClear_SHAMT 15
#define ADDR_MOD_PACK_SEC7_ZdstClear_MASK 0x8000
#define ADDR_MOD_PACK_SEC7_ZdstClear_RMW \
    ADDR_MOD_PACK_SEC7_ZdstClear_ADDR32, ADDR_MOD_PACK_SEC7_ZdstClear_SHAMT, ADDR_MOD_PACK_SEC7_ZdstClear_MASK

#define UNPACK_MISC_CFG_CfgContextOffset_0_ADDR32 39
#define UNPACK_MISC_CFG_CfgContextOffset_0_SHAMT 0
#define UNPACK_MISC_CFG_CfgContextOffset_0_MASK 0xf
#define UNPACK_MISC_CFG_CfgContextOffset_0_RMW                                           \
    UNPACK_MISC_CFG_CfgContextOffset_0_ADDR32, UNPACK_MISC_CFG_CfgContextOffset_0_SHAMT, \
        UNPACK_MISC_CFG_CfgContextOffset_0_MASK

#define UNPACK_MISC_CFG_CfgContextCntReset_0_ADDR32 39
#define UNPACK_MISC_CFG_CfgContextCntReset_0_SHAMT 4
#define UNPACK_MISC_CFG_CfgContextCntReset_0_MASK 0x10
#define UNPACK_MISC_CFG_CfgContextCntReset_0_RMW                                             \
    UNPACK_MISC_CFG_CfgContextCntReset_0_ADDR32, UNPACK_MISC_CFG_CfgContextCntReset_0_SHAMT, \
        UNPACK_MISC_CFG_CfgContextCntReset_0_MASK

#define UNPACK_MISC_CFG_CfgContextCntInc_0_ADDR32 39
#define UNPACK_MISC_CFG_CfgContextCntInc_0_SHAMT 5
#define UNPACK_MISC_CFG_CfgContextCntInc_0_MASK 0x20
#define UNPACK_MISC_CFG_CfgContextCntInc_0_RMW                                           \
    UNPACK_MISC_CFG_CfgContextCntInc_0_ADDR32, UNPACK_MISC_CFG_CfgContextCntInc_0_SHAMT, \
        UNPACK_MISC_CFG_CfgContextCntInc_0_MASK

#define UNPACK_MISC_CFG_CfgContextOffset_1_ADDR32 39
#define UNPACK_MISC_CFG_CfgContextOffset_1_SHAMT 8
#define UNPACK_MISC_CFG_CfgContextOffset_1_MASK 0xf00
#define UNPACK_MISC_CFG_CfgContextOffset_1_RMW                                           \
    UNPACK_MISC_CFG_CfgContextOffset_1_ADDR32, UNPACK_MISC_CFG_CfgContextOffset_1_SHAMT, \
        UNPACK_MISC_CFG_CfgContextOffset_1_MASK

#define UNPACK_MISC_CFG_CfgContextCntReset_1_ADDR32 39
#define UNPACK_MISC_CFG_CfgContextCntReset_1_SHAMT 12
#define UNPACK_MISC_CFG_CfgContextCntReset_1_MASK 0x1000
#define UNPACK_MISC_CFG_CfgContextCntReset_1_RMW                                             \
    UNPACK_MISC_CFG_CfgContextCntReset_1_ADDR32, UNPACK_MISC_CFG_CfgContextCntReset_1_SHAMT, \
        UNPACK_MISC_CFG_CfgContextCntReset_1_MASK

#define UNPACK_MISC_CFG_CfgContextCntInc_1_ADDR32 39
#define UNPACK_MISC_CFG_CfgContextCntInc_1_SHAMT 13
#define UNPACK_MISC_CFG_CfgContextCntInc_1_MASK 0x2000
#define UNPACK_MISC_CFG_CfgContextCntInc_1_RMW                                           \
    UNPACK_MISC_CFG_CfgContextCntInc_1_ADDR32, UNPACK_MISC_CFG_CfgContextCntInc_1_SHAMT, \
        UNPACK_MISC_CFG_CfgContextCntInc_1_MASK

#define NOC_OVERLAY_MSG_CLEAR_StreamId_0_ADDR32 40
#define NOC_OVERLAY_MSG_CLEAR_StreamId_0_SHAMT 0
#define NOC_OVERLAY_MSG_CLEAR_StreamId_0_MASK 0x3f
#define NOC_OVERLAY_MSG_CLEAR_StreamId_0_RMW                                         \
    NOC_OVERLAY_MSG_CLEAR_StreamId_0_ADDR32, NOC_OVERLAY_MSG_CLEAR_StreamId_0_SHAMT, \
        NOC_OVERLAY_MSG_CLEAR_StreamId_0_MASK

#define NOC_OVERLAY_MSG_CLEAR_MsgNum_0_ADDR32 40
#define NOC_OVERLAY_MSG_CLEAR_MsgNum_0_SHAMT 8
#define NOC_OVERLAY_MSG_CLEAR_MsgNum_0_MASK 0x700
#define NOC_OVERLAY_MSG_CLEAR_MsgNum_0_RMW \
    NOC_OVERLAY_MSG_CLEAR_MsgNum_0_ADDR32, NOC_OVERLAY_MSG_CLEAR_MsgNum_0_SHAMT, NOC_OVERLAY_MSG_CLEAR_MsgNum_0_MASK

#define NOC_OVERLAY_MSG_CLEAR_StreamId_1_ADDR32 41
#define NOC_OVERLAY_MSG_CLEAR_StreamId_1_SHAMT 0
#define NOC_OVERLAY_MSG_CLEAR_StreamId_1_MASK 0x3f
#define NOC_OVERLAY_MSG_CLEAR_StreamId_1_RMW                                         \
    NOC_OVERLAY_MSG_CLEAR_StreamId_1_ADDR32, NOC_OVERLAY_MSG_CLEAR_StreamId_1_SHAMT, \
        NOC_OVERLAY_MSG_CLEAR_StreamId_1_MASK

#define NOC_OVERLAY_MSG_CLEAR_MsgNum_1_ADDR32 41
#define NOC_OVERLAY_MSG_CLEAR_MsgNum_1_SHAMT 8
#define NOC_OVERLAY_MSG_CLEAR_MsgNum_1_MASK 0x700
#define NOC_OVERLAY_MSG_CLEAR_MsgNum_1_RMW \
    NOC_OVERLAY_MSG_CLEAR_MsgNum_1_ADDR32, NOC_OVERLAY_MSG_CLEAR_MsgNum_1_SHAMT, NOC_OVERLAY_MSG_CLEAR_MsgNum_1_MASK

#define CG_CTRL_EN_Regblocks_ADDR32 42
#define CG_CTRL_EN_Regblocks_SHAMT 0
#define CG_CTRL_EN_Regblocks_MASK 0x1
#define CG_CTRL_EN_Regblocks_RMW CG_CTRL_EN_Regblocks_ADDR32, CG_CTRL_EN_Regblocks_SHAMT, CG_CTRL_EN_Regblocks_MASK

#define CG_CTRL_EN_Fpu_ADDR32 42
#define CG_CTRL_EN_Fpu_SHAMT 1
#define CG_CTRL_EN_Fpu_MASK 0x2
#define CG_CTRL_EN_Fpu_RMW CG_CTRL_EN_Fpu_ADDR32, CG_CTRL_EN_Fpu_SHAMT, CG_CTRL_EN_Fpu_MASK

#define CG_CTRL_EN_Fpu_mtile_ADDR32 42
#define CG_CTRL_EN_Fpu_mtile_SHAMT 2
#define CG_CTRL_EN_Fpu_mtile_MASK 0x4
#define CG_CTRL_EN_Fpu_mtile_RMW CG_CTRL_EN_Fpu_mtile_ADDR32, CG_CTRL_EN_Fpu_mtile_SHAMT, CG_CTRL_EN_Fpu_mtile_MASK

#define CG_CTRL_EN_Fpu_sfpu_ADDR32 42
#define CG_CTRL_EN_Fpu_sfpu_SHAMT 3
#define CG_CTRL_EN_Fpu_sfpu_MASK 0x8
#define CG_CTRL_EN_Fpu_sfpu_RMW CG_CTRL_EN_Fpu_sfpu_ADDR32, CG_CTRL_EN_Fpu_sfpu_SHAMT, CG_CTRL_EN_Fpu_sfpu_MASK

#define CG_CTRL_EN_Move_ADDR32 42
#define CG_CTRL_EN_Move_SHAMT 4
#define CG_CTRL_EN_Move_MASK 0x10
#define CG_CTRL_EN_Move_RMW CG_CTRL_EN_Move_ADDR32, CG_CTRL_EN_Move_SHAMT, CG_CTRL_EN_Move_MASK

#define CG_CTRL_EN_Packer_ADDR32 42
#define CG_CTRL_EN_Packer_SHAMT 5
#define CG_CTRL_EN_Packer_MASK 0x1e0
#define CG_CTRL_EN_Packer_RMW CG_CTRL_EN_Packer_ADDR32, CG_CTRL_EN_Packer_SHAMT, CG_CTRL_EN_Packer_MASK

#define CG_CTRL_EN_Unpacker_ADDR32 42
#define CG_CTRL_EN_Unpacker_SHAMT 9
#define CG_CTRL_EN_Unpacker_MASK 0x600
#define CG_CTRL_EN_Unpacker_RMW CG_CTRL_EN_Unpacker_ADDR32, CG_CTRL_EN_Unpacker_SHAMT, CG_CTRL_EN_Unpacker_MASK

#define CG_CTRL_EN_Xsearch_ADDR32 42
#define CG_CTRL_EN_Xsearch_SHAMT 11
#define CG_CTRL_EN_Xsearch_MASK 0x800
#define CG_CTRL_EN_Xsearch_RMW CG_CTRL_EN_Xsearch_ADDR32, CG_CTRL_EN_Xsearch_SHAMT, CG_CTRL_EN_Xsearch_MASK

#define CG_CTRL_EN_Thcon_ADDR32 42
#define CG_CTRL_EN_Thcon_SHAMT 12
#define CG_CTRL_EN_Thcon_MASK 0x1000
#define CG_CTRL_EN_Thcon_RMW CG_CTRL_EN_Thcon_ADDR32, CG_CTRL_EN_Thcon_SHAMT, CG_CTRL_EN_Thcon_MASK

#define CG_CTRL_EN_Trisc_ADDR32 42
#define CG_CTRL_EN_Trisc_SHAMT 13
#define CG_CTRL_EN_Trisc_MASK 0x2000
#define CG_CTRL_EN_Trisc_RMW CG_CTRL_EN_Trisc_ADDR32, CG_CTRL_EN_Trisc_SHAMT, CG_CTRL_EN_Trisc_MASK

#define CG_CTRL_EN_Retmux_ADDR32 42
#define CG_CTRL_EN_Retmux_SHAMT 14
#define CG_CTRL_EN_Retmux_MASK 0x4000
#define CG_CTRL_EN_Retmux_RMW CG_CTRL_EN_Retmux_ADDR32, CG_CTRL_EN_Retmux_SHAMT, CG_CTRL_EN_Retmux_MASK

#define CG_CTRL_EN_Ithread_ADDR32 42
#define CG_CTRL_EN_Ithread_SHAMT 15
#define CG_CTRL_EN_Ithread_MASK 0x8000
#define CG_CTRL_EN_Ithread_RMW CG_CTRL_EN_Ithread_ADDR32, CG_CTRL_EN_Ithread_SHAMT, CG_CTRL_EN_Ithread_MASK

#define CG_CTRL_EN_Hyst_ADDR32 43
#define CG_CTRL_EN_Hyst_SHAMT 2
#define CG_CTRL_EN_Hyst_MASK 0x1fc
#define CG_CTRL_EN_Hyst_RMW CG_CTRL_EN_Hyst_ADDR32, CG_CTRL_EN_Hyst_SHAMT, CG_CTRL_EN_Hyst_MASK

#define CG_CTRL_KICK_Regblocks_ADDR32 44
#define CG_CTRL_KICK_Regblocks_SHAMT 0
#define CG_CTRL_KICK_Regblocks_MASK 0x1
#define CG_CTRL_KICK_Regblocks_RMW \
    CG_CTRL_KICK_Regblocks_ADDR32, CG_CTRL_KICK_Regblocks_SHAMT, CG_CTRL_KICK_Regblocks_MASK

#define CG_CTRL_KICK_Fpu_ADDR32 44
#define CG_CTRL_KICK_Fpu_SHAMT 1
#define CG_CTRL_KICK_Fpu_MASK 0x2
#define CG_CTRL_KICK_Fpu_RMW CG_CTRL_KICK_Fpu_ADDR32, CG_CTRL_KICK_Fpu_SHAMT, CG_CTRL_KICK_Fpu_MASK

#define CG_CTRL_KICK_Move_ADDR32 44
#define CG_CTRL_KICK_Move_SHAMT 2
#define CG_CTRL_KICK_Move_MASK 0x4
#define CG_CTRL_KICK_Move_RMW CG_CTRL_KICK_Move_ADDR32, CG_CTRL_KICK_Move_SHAMT, CG_CTRL_KICK_Move_MASK

#define CG_CTRL_KICK_Packer_ADDR32 44
#define CG_CTRL_KICK_Packer_SHAMT 3
#define CG_CTRL_KICK_Packer_MASK 0x78
#define CG_CTRL_KICK_Packer_RMW CG_CTRL_KICK_Packer_ADDR32, CG_CTRL_KICK_Packer_SHAMT, CG_CTRL_KICK_Packer_MASK

#define CG_CTRL_KICK_Unpacker_ADDR32 44
#define CG_CTRL_KICK_Unpacker_SHAMT 7
#define CG_CTRL_KICK_Unpacker_MASK 0x180
#define CG_CTRL_KICK_Unpacker_RMW CG_CTRL_KICK_Unpacker_ADDR32, CG_CTRL_KICK_Unpacker_SHAMT, CG_CTRL_KICK_Unpacker_MASK

#define CG_CTRL_KICK_Xsearch_ADDR32 44
#define CG_CTRL_KICK_Xsearch_SHAMT 9
#define CG_CTRL_KICK_Xsearch_MASK 0x200
#define CG_CTRL_KICK_Xsearch_RMW CG_CTRL_KICK_Xsearch_ADDR32, CG_CTRL_KICK_Xsearch_SHAMT, CG_CTRL_KICK_Xsearch_MASK

#define CG_CTRL_KICK_Thcon_ADDR32 44
#define CG_CTRL_KICK_Thcon_SHAMT 10
#define CG_CTRL_KICK_Thcon_MASK 0x400
#define CG_CTRL_KICK_Thcon_RMW CG_CTRL_KICK_Thcon_ADDR32, CG_CTRL_KICK_Thcon_SHAMT, CG_CTRL_KICK_Thcon_MASK

#define CG_CTRL_KICK_Trisc_ADDR32 44
#define CG_CTRL_KICK_Trisc_SHAMT 11
#define CG_CTRL_KICK_Trisc_MASK 0x800
#define CG_CTRL_KICK_Trisc_RMW CG_CTRL_KICK_Trisc_ADDR32, CG_CTRL_KICK_Trisc_SHAMT, CG_CTRL_KICK_Trisc_MASK

#define CG_CTRL_KICK_Retmux_ADDR32 44
#define CG_CTRL_KICK_Retmux_SHAMT 12
#define CG_CTRL_KICK_Retmux_MASK 0x1000
#define CG_CTRL_KICK_Retmux_RMW CG_CTRL_KICK_Retmux_ADDR32, CG_CTRL_KICK_Retmux_SHAMT, CG_CTRL_KICK_Retmux_MASK

#define CG_CTRL_KICK_Ithread_ADDR32 44
#define CG_CTRL_KICK_Ithread_SHAMT 13
#define CG_CTRL_KICK_Ithread_MASK 0x2000
#define CG_CTRL_KICK_Ithread_RMW CG_CTRL_KICK_Ithread_ADDR32, CG_CTRL_KICK_Ithread_SHAMT, CG_CTRL_KICK_Ithread_MASK

#define PERF_CNT_CMD_Cmd0Start_ADDR32 45
#define PERF_CNT_CMD_Cmd0Start_SHAMT 0
#define PERF_CNT_CMD_Cmd0Start_MASK 0x1
#define PERF_CNT_CMD_Cmd0Start_RMW \
    PERF_CNT_CMD_Cmd0Start_ADDR32, PERF_CNT_CMD_Cmd0Start_SHAMT, PERF_CNT_CMD_Cmd0Start_MASK

#define PERF_CNT_CMD_Cmd0Stop_ADDR32 45
#define PERF_CNT_CMD_Cmd0Stop_SHAMT 1
#define PERF_CNT_CMD_Cmd0Stop_MASK 0x2
#define PERF_CNT_CMD_Cmd0Stop_RMW PERF_CNT_CMD_Cmd0Stop_ADDR32, PERF_CNT_CMD_Cmd0Stop_SHAMT, PERF_CNT_CMD_Cmd0Stop_MASK

#define PERF_CNT_CMD_Cmd1Start_ADDR32 45
#define PERF_CNT_CMD_Cmd1Start_SHAMT 2
#define PERF_CNT_CMD_Cmd1Start_MASK 0x4
#define PERF_CNT_CMD_Cmd1Start_RMW \
    PERF_CNT_CMD_Cmd1Start_ADDR32, PERF_CNT_CMD_Cmd1Start_SHAMT, PERF_CNT_CMD_Cmd1Start_MASK

#define PERF_CNT_CMD_Cmd1Stop_ADDR32 45
#define PERF_CNT_CMD_Cmd1Stop_SHAMT 3
#define PERF_CNT_CMD_Cmd1Stop_MASK 0x8
#define PERF_CNT_CMD_Cmd1Stop_RMW PERF_CNT_CMD_Cmd1Stop_ADDR32, PERF_CNT_CMD_Cmd1Stop_SHAMT, PERF_CNT_CMD_Cmd1Stop_MASK

#define PERF_CNT_CMD_Cmd2Start_ADDR32 45
#define PERF_CNT_CMD_Cmd2Start_SHAMT 4
#define PERF_CNT_CMD_Cmd2Start_MASK 0x10
#define PERF_CNT_CMD_Cmd2Start_RMW \
    PERF_CNT_CMD_Cmd2Start_ADDR32, PERF_CNT_CMD_Cmd2Start_SHAMT, PERF_CNT_CMD_Cmd2Start_MASK

#define PERF_CNT_CMD_Cmd2Stop_ADDR32 45
#define PERF_CNT_CMD_Cmd2Stop_SHAMT 5
#define PERF_CNT_CMD_Cmd2Stop_MASK 0x20
#define PERF_CNT_CMD_Cmd2Stop_RMW PERF_CNT_CMD_Cmd2Stop_ADDR32, PERF_CNT_CMD_Cmd2Stop_SHAMT, PERF_CNT_CMD_Cmd2Stop_MASK

#define PERF_CNT_CMD_Cmd3Start_ADDR32 45
#define PERF_CNT_CMD_Cmd3Start_SHAMT 6
#define PERF_CNT_CMD_Cmd3Start_MASK 0x40
#define PERF_CNT_CMD_Cmd3Start_RMW \
    PERF_CNT_CMD_Cmd3Start_ADDR32, PERF_CNT_CMD_Cmd3Start_SHAMT, PERF_CNT_CMD_Cmd3Start_MASK

#define PERF_CNT_CMD_Cmd3Stop_ADDR32 45
#define PERF_CNT_CMD_Cmd3Stop_SHAMT 7
#define PERF_CNT_CMD_Cmd3Stop_MASK 0x80
#define PERF_CNT_CMD_Cmd3Stop_RMW PERF_CNT_CMD_Cmd3Stop_ADDR32, PERF_CNT_CMD_Cmd3Stop_SHAMT, PERF_CNT_CMD_Cmd3Stop_MASK

#define ENABLE_ACC_STATS_Enable_ADDR32 46
#define ENABLE_ACC_STATS_Enable_SHAMT 0
#define ENABLE_ACC_STATS_Enable_MASK 0x1
#define ENABLE_ACC_STATS_Enable_RMW \
    ENABLE_ACC_STATS_Enable_ADDR32, ENABLE_ACC_STATS_Enable_SHAMT, ENABLE_ACC_STATS_Enable_MASK

#define FPU_BIAS_SEL_Pointer_ADDR32 47
#define FPU_BIAS_SEL_Pointer_SHAMT 0
#define FPU_BIAS_SEL_Pointer_MASK 0x1
#define FPU_BIAS_SEL_Pointer_RMW FPU_BIAS_SEL_Pointer_ADDR32, FPU_BIAS_SEL_Pointer_SHAMT, FPU_BIAS_SEL_Pointer_MASK

#define ADDR_MOD_BIAS_SEC0_BiasIncr_ADDR32 48
#define ADDR_MOD_BIAS_SEC0_BiasIncr_SHAMT 0
#define ADDR_MOD_BIAS_SEC0_BiasIncr_MASK 0xf
#define ADDR_MOD_BIAS_SEC0_BiasIncr_RMW \
    ADDR_MOD_BIAS_SEC0_BiasIncr_ADDR32, ADDR_MOD_BIAS_SEC0_BiasIncr_SHAMT, ADDR_MOD_BIAS_SEC0_BiasIncr_MASK

#define ADDR_MOD_BIAS_SEC0_BiasClear_ADDR32 48
#define ADDR_MOD_BIAS_SEC0_BiasClear_SHAMT 4
#define ADDR_MOD_BIAS_SEC0_BiasClear_MASK 0x10
#define ADDR_MOD_BIAS_SEC0_BiasClear_RMW \
    ADDR_MOD_BIAS_SEC0_BiasClear_ADDR32, ADDR_MOD_BIAS_SEC0_BiasClear_SHAMT, ADDR_MOD_BIAS_SEC0_BiasClear_MASK

#define ADDR_MOD_BIAS_SEC1_BiasIncr_ADDR32 49
#define ADDR_MOD_BIAS_SEC1_BiasIncr_SHAMT 0
#define ADDR_MOD_BIAS_SEC1_BiasIncr_MASK 0xf
#define ADDR_MOD_BIAS_SEC1_BiasIncr_RMW \
    ADDR_MOD_BIAS_SEC1_BiasIncr_ADDR32, ADDR_MOD_BIAS_SEC1_BiasIncr_SHAMT, ADDR_MOD_BIAS_SEC1_BiasIncr_MASK

#define ADDR_MOD_BIAS_SEC1_BiasClear_ADDR32 49
#define ADDR_MOD_BIAS_SEC1_BiasClear_SHAMT 4
#define ADDR_MOD_BIAS_SEC1_BiasClear_MASK 0x10
#define ADDR_MOD_BIAS_SEC1_BiasClear_RMW \
    ADDR_MOD_BIAS_SEC1_BiasClear_ADDR32, ADDR_MOD_BIAS_SEC1_BiasClear_SHAMT, ADDR_MOD_BIAS_SEC1_BiasClear_MASK

#define ADDR_MOD_BIAS_SEC2_BiasIncr_ADDR32 50
#define ADDR_MOD_BIAS_SEC2_BiasIncr_SHAMT 0
#define ADDR_MOD_BIAS_SEC2_BiasIncr_MASK 0xf
#define ADDR_MOD_BIAS_SEC2_BiasIncr_RMW \
    ADDR_MOD_BIAS_SEC2_BiasIncr_ADDR32, ADDR_MOD_BIAS_SEC2_BiasIncr_SHAMT, ADDR_MOD_BIAS_SEC2_BiasIncr_MASK

#define ADDR_MOD_BIAS_SEC2_BiasClear_ADDR32 50
#define ADDR_MOD_BIAS_SEC2_BiasClear_SHAMT 4
#define ADDR_MOD_BIAS_SEC2_BiasClear_MASK 0x10
#define ADDR_MOD_BIAS_SEC2_BiasClear_RMW \
    ADDR_MOD_BIAS_SEC2_BiasClear_ADDR32, ADDR_MOD_BIAS_SEC2_BiasClear_SHAMT, ADDR_MOD_BIAS_SEC2_BiasClear_MASK

#define ADDR_MOD_BIAS_SEC3_BiasIncr_ADDR32 51
#define ADDR_MOD_BIAS_SEC3_BiasIncr_SHAMT 0
#define ADDR_MOD_BIAS_SEC3_BiasIncr_MASK 0xf
#define ADDR_MOD_BIAS_SEC3_BiasIncr_RMW \
    ADDR_MOD_BIAS_SEC3_BiasIncr_ADDR32, ADDR_MOD_BIAS_SEC3_BiasIncr_SHAMT, ADDR_MOD_BIAS_SEC3_BiasIncr_MASK

#define ADDR_MOD_BIAS_SEC3_BiasClear_ADDR32 51
#define ADDR_MOD_BIAS_SEC3_BiasClear_SHAMT 4
#define ADDR_MOD_BIAS_SEC3_BiasClear_MASK 0x10
#define ADDR_MOD_BIAS_SEC3_BiasClear_RMW \
    ADDR_MOD_BIAS_SEC3_BiasClear_ADDR32, ADDR_MOD_BIAS_SEC3_BiasClear_SHAMT, ADDR_MOD_BIAS_SEC3_BiasClear_MASK

#define ADDR_MOD_BIAS_SEC4_BiasIncr_ADDR32 52
#define ADDR_MOD_BIAS_SEC4_BiasIncr_SHAMT 0
#define ADDR_MOD_BIAS_SEC4_BiasIncr_MASK 0xf
#define ADDR_MOD_BIAS_SEC4_BiasIncr_RMW \
    ADDR_MOD_BIAS_SEC4_BiasIncr_ADDR32, ADDR_MOD_BIAS_SEC4_BiasIncr_SHAMT, ADDR_MOD_BIAS_SEC4_BiasIncr_MASK

#define ADDR_MOD_BIAS_SEC4_BiasClear_ADDR32 52
#define ADDR_MOD_BIAS_SEC4_BiasClear_SHAMT 4
#define ADDR_MOD_BIAS_SEC4_BiasClear_MASK 0x10
#define ADDR_MOD_BIAS_SEC4_BiasClear_RMW \
    ADDR_MOD_BIAS_SEC4_BiasClear_ADDR32, ADDR_MOD_BIAS_SEC4_BiasClear_SHAMT, ADDR_MOD_BIAS_SEC4_BiasClear_MASK

#define ADDR_MOD_BIAS_SEC5_BiasIncr_ADDR32 53
#define ADDR_MOD_BIAS_SEC5_BiasIncr_SHAMT 0
#define ADDR_MOD_BIAS_SEC5_BiasIncr_MASK 0xf
#define ADDR_MOD_BIAS_SEC5_BiasIncr_RMW \
    ADDR_MOD_BIAS_SEC5_BiasIncr_ADDR32, ADDR_MOD_BIAS_SEC5_BiasIncr_SHAMT, ADDR_MOD_BIAS_SEC5_BiasIncr_MASK

#define ADDR_MOD_BIAS_SEC5_BiasClear_ADDR32 53
#define ADDR_MOD_BIAS_SEC5_BiasClear_SHAMT 4
#define ADDR_MOD_BIAS_SEC5_BiasClear_MASK 0x10
#define ADDR_MOD_BIAS_SEC5_BiasClear_RMW \
    ADDR_MOD_BIAS_SEC5_BiasClear_ADDR32, ADDR_MOD_BIAS_SEC5_BiasClear_SHAMT, ADDR_MOD_BIAS_SEC5_BiasClear_MASK

#define ADDR_MOD_BIAS_SEC6_BiasIncr_ADDR32 54
#define ADDR_MOD_BIAS_SEC6_BiasIncr_SHAMT 0
#define ADDR_MOD_BIAS_SEC6_BiasIncr_MASK 0xf
#define ADDR_MOD_BIAS_SEC6_BiasIncr_RMW \
    ADDR_MOD_BIAS_SEC6_BiasIncr_ADDR32, ADDR_MOD_BIAS_SEC6_BiasIncr_SHAMT, ADDR_MOD_BIAS_SEC6_BiasIncr_MASK

#define ADDR_MOD_BIAS_SEC6_BiasClear_ADDR32 54
#define ADDR_MOD_BIAS_SEC6_BiasClear_SHAMT 4
#define ADDR_MOD_BIAS_SEC6_BiasClear_MASK 0x10
#define ADDR_MOD_BIAS_SEC6_BiasClear_RMW \
    ADDR_MOD_BIAS_SEC6_BiasClear_ADDR32, ADDR_MOD_BIAS_SEC6_BiasClear_SHAMT, ADDR_MOD_BIAS_SEC6_BiasClear_MASK

#define ADDR_MOD_BIAS_SEC7_BiasIncr_ADDR32 55
#define ADDR_MOD_BIAS_SEC7_BiasIncr_SHAMT 0
#define ADDR_MOD_BIAS_SEC7_BiasIncr_MASK 0xf
#define ADDR_MOD_BIAS_SEC7_BiasIncr_RMW \
    ADDR_MOD_BIAS_SEC7_BiasIncr_ADDR32, ADDR_MOD_BIAS_SEC7_BiasIncr_SHAMT, ADDR_MOD_BIAS_SEC7_BiasIncr_MASK

#define ADDR_MOD_BIAS_SEC7_BiasClear_ADDR32 55
#define ADDR_MOD_BIAS_SEC7_BiasClear_SHAMT 4
#define ADDR_MOD_BIAS_SEC7_BiasClear_MASK 0x10
#define ADDR_MOD_BIAS_SEC7_BiasClear_RMW \
    ADDR_MOD_BIAS_SEC7_BiasClear_ADDR32, ADDR_MOD_BIAS_SEC7_BiasClear_SHAMT, ADDR_MOD_BIAS_SEC7_BiasClear_MASK

#define FP16A_FORCE_Enable_ADDR32 56
#define FP16A_FORCE_Enable_SHAMT 0
#define FP16A_FORCE_Enable_MASK 0x1
#define FP16A_FORCE_Enable_RMW FP16A_FORCE_Enable_ADDR32, FP16A_FORCE_Enable_SHAMT, FP16A_FORCE_Enable_MASK

////////////////////////////////////////////////////////////////////////
// Registers for ALU
////////////////////////////////////////////////////////////////////////

#define ALU_CFGREG_BASE_ADDR32 0

#define ALU_FORMAT_SPEC_REG_SrcA_val_ADDR32 0
#define ALU_FORMAT_SPEC_REG_SrcA_val_SHAMT 0
#define ALU_FORMAT_SPEC_REG_SrcA_val_MASK 0xf
#define ALU_FORMAT_SPEC_REG_SrcA_val_RMW \
    ALU_FORMAT_SPEC_REG_SrcA_val_ADDR32, ALU_FORMAT_SPEC_REG_SrcA_val_SHAMT, ALU_FORMAT_SPEC_REG_SrcA_val_MASK

#define ALU_FORMAT_SPEC_REG_SrcA_override_ADDR32 0
#define ALU_FORMAT_SPEC_REG_SrcA_override_SHAMT 4
#define ALU_FORMAT_SPEC_REG_SrcA_override_MASK 0x10
#define ALU_FORMAT_SPEC_REG_SrcA_override_RMW                                          \
    ALU_FORMAT_SPEC_REG_SrcA_override_ADDR32, ALU_FORMAT_SPEC_REG_SrcA_override_SHAMT, \
        ALU_FORMAT_SPEC_REG_SrcA_override_MASK

#define ALU_FORMAT_SPEC_REG_SrcB_val_ADDR32 0
#define ALU_FORMAT_SPEC_REG_SrcB_val_SHAMT 5
#define ALU_FORMAT_SPEC_REG_SrcB_val_MASK 0x1e0
#define ALU_FORMAT_SPEC_REG_SrcB_val_RMW \
    ALU_FORMAT_SPEC_REG_SrcB_val_ADDR32, ALU_FORMAT_SPEC_REG_SrcB_val_SHAMT, ALU_FORMAT_SPEC_REG_SrcB_val_MASK

#define ALU_FORMAT_SPEC_REG_SrcB_override_ADDR32 0
#define ALU_FORMAT_SPEC_REG_SrcB_override_SHAMT 9
#define ALU_FORMAT_SPEC_REG_SrcB_override_MASK 0x200
#define ALU_FORMAT_SPEC_REG_SrcB_override_RMW                                          \
    ALU_FORMAT_SPEC_REG_SrcB_override_ADDR32, ALU_FORMAT_SPEC_REG_SrcB_override_SHAMT, \
        ALU_FORMAT_SPEC_REG_SrcB_override_MASK

#define ALU_FORMAT_SPEC_REG_Dstacc_val_ADDR32 0
#define ALU_FORMAT_SPEC_REG_Dstacc_val_SHAMT 10
#define ALU_FORMAT_SPEC_REG_Dstacc_val_MASK 0x3c00
#define ALU_FORMAT_SPEC_REG_Dstacc_val_RMW \
    ALU_FORMAT_SPEC_REG_Dstacc_val_ADDR32, ALU_FORMAT_SPEC_REG_Dstacc_val_SHAMT, ALU_FORMAT_SPEC_REG_Dstacc_val_MASK

#define ALU_FORMAT_SPEC_REG_Dstacc_override_ADDR32 0
#define ALU_FORMAT_SPEC_REG_Dstacc_override_SHAMT 14
#define ALU_FORMAT_SPEC_REG_Dstacc_override_MASK 0x4000
#define ALU_FORMAT_SPEC_REG_Dstacc_override_RMW                                            \
    ALU_FORMAT_SPEC_REG_Dstacc_override_ADDR32, ALU_FORMAT_SPEC_REG_Dstacc_override_SHAMT, \
        ALU_FORMAT_SPEC_REG_Dstacc_override_MASK

#define ALU_ROUNDING_MODE_Fpu_srnd_en_ADDR32 1
#define ALU_ROUNDING_MODE_Fpu_srnd_en_SHAMT 0
#define ALU_ROUNDING_MODE_Fpu_srnd_en_MASK 0x1
#define ALU_ROUNDING_MODE_Fpu_srnd_en_RMW \
    ALU_ROUNDING_MODE_Fpu_srnd_en_ADDR32, ALU_ROUNDING_MODE_Fpu_srnd_en_SHAMT, ALU_ROUNDING_MODE_Fpu_srnd_en_MASK

#define ALU_ROUNDING_MODE_Gasket_srnd_en_ADDR32 1
#define ALU_ROUNDING_MODE_Gasket_srnd_en_SHAMT 1
#define ALU_ROUNDING_MODE_Gasket_srnd_en_MASK 0x2
#define ALU_ROUNDING_MODE_Gasket_srnd_en_RMW                                         \
    ALU_ROUNDING_MODE_Gasket_srnd_en_ADDR32, ALU_ROUNDING_MODE_Gasket_srnd_en_SHAMT, \
        ALU_ROUNDING_MODE_Gasket_srnd_en_MASK

#define ALU_ROUNDING_MODE_Packer_srnd_en_ADDR32 1
#define ALU_ROUNDING_MODE_Packer_srnd_en_SHAMT 2
#define ALU_ROUNDING_MODE_Packer_srnd_en_MASK 0x4
#define ALU_ROUNDING_MODE_Packer_srnd_en_RMW                                         \
    ALU_ROUNDING_MODE_Packer_srnd_en_ADDR32, ALU_ROUNDING_MODE_Packer_srnd_en_SHAMT, \
        ALU_ROUNDING_MODE_Packer_srnd_en_MASK

#define ALU_ROUNDING_MODE_Padding_ADDR32 1
#define ALU_ROUNDING_MODE_Padding_SHAMT 3
#define ALU_ROUNDING_MODE_Padding_MASK 0x1ff8
#define ALU_ROUNDING_MODE_Padding_RMW \
    ALU_ROUNDING_MODE_Padding_ADDR32, ALU_ROUNDING_MODE_Padding_SHAMT, ALU_ROUNDING_MODE_Padding_MASK

#define ALU_ROUNDING_MODE_GS_LF_ADDR32 1
#define ALU_ROUNDING_MODE_GS_LF_SHAMT 13
#define ALU_ROUNDING_MODE_GS_LF_MASK 0x2000
#define ALU_ROUNDING_MODE_GS_LF_RMW \
    ALU_ROUNDING_MODE_GS_LF_ADDR32, ALU_ROUNDING_MODE_GS_LF_SHAMT, ALU_ROUNDING_MODE_GS_LF_MASK

#define ALU_ROUNDING_MODE_Bfp8_HF_ADDR32 1
#define ALU_ROUNDING_MODE_Bfp8_HF_SHAMT 14
#define ALU_ROUNDING_MODE_Bfp8_HF_MASK 0x4000
#define ALU_ROUNDING_MODE_Bfp8_HF_RMW \
    ALU_ROUNDING_MODE_Bfp8_HF_ADDR32, ALU_ROUNDING_MODE_Bfp8_HF_SHAMT, ALU_ROUNDING_MODE_Bfp8_HF_MASK

#define ALU_FORMAT_SPEC_REG0_SrcAUnsigned_ADDR32 1
#define ALU_FORMAT_SPEC_REG0_SrcAUnsigned_SHAMT 15
#define ALU_FORMAT_SPEC_REG0_SrcAUnsigned_MASK 0x8000
#define ALU_FORMAT_SPEC_REG0_SrcAUnsigned_RMW                                          \
    ALU_FORMAT_SPEC_REG0_SrcAUnsigned_ADDR32, ALU_FORMAT_SPEC_REG0_SrcAUnsigned_SHAMT, \
        ALU_FORMAT_SPEC_REG0_SrcAUnsigned_MASK

#define ALU_FORMAT_SPEC_REG0_SrcBUnsigned_ADDR32 1
#define ALU_FORMAT_SPEC_REG0_SrcBUnsigned_SHAMT 16
#define ALU_FORMAT_SPEC_REG0_SrcBUnsigned_MASK 0x10000
#define ALU_FORMAT_SPEC_REG0_SrcBUnsigned_RMW                                          \
    ALU_FORMAT_SPEC_REG0_SrcBUnsigned_ADDR32, ALU_FORMAT_SPEC_REG0_SrcBUnsigned_SHAMT, \
        ALU_FORMAT_SPEC_REG0_SrcBUnsigned_MASK

#define ALU_FORMAT_SPEC_REG0_SrcA_ADDR32 1
#define ALU_FORMAT_SPEC_REG0_SrcA_SHAMT 17
#define ALU_FORMAT_SPEC_REG0_SrcA_MASK 0x1e0000
#define ALU_FORMAT_SPEC_REG0_SrcA_RMW \
    ALU_FORMAT_SPEC_REG0_SrcA_ADDR32, ALU_FORMAT_SPEC_REG0_SrcA_SHAMT, ALU_FORMAT_SPEC_REG0_SrcA_MASK

#define ALU_FORMAT_SPEC_REG1_SrcB_ADDR32 1
#define ALU_FORMAT_SPEC_REG1_SrcB_SHAMT 21
#define ALU_FORMAT_SPEC_REG1_SrcB_MASK 0x1e00000
#define ALU_FORMAT_SPEC_REG1_SrcB_RMW \
    ALU_FORMAT_SPEC_REG1_SrcB_ADDR32, ALU_FORMAT_SPEC_REG1_SrcB_SHAMT, ALU_FORMAT_SPEC_REG1_SrcB_MASK

#define ALU_FORMAT_SPEC_REG2_Dstacc_ADDR32 1
#define ALU_FORMAT_SPEC_REG2_Dstacc_SHAMT 25
#define ALU_FORMAT_SPEC_REG2_Dstacc_MASK 0x1e000000
#define ALU_FORMAT_SPEC_REG2_Dstacc_RMW \
    ALU_FORMAT_SPEC_REG2_Dstacc_ADDR32, ALU_FORMAT_SPEC_REG2_Dstacc_SHAMT, ALU_FORMAT_SPEC_REG2_Dstacc_MASK

#define ALU_ACC_CTRL_Fp32_enabled_ADDR32 1
#define ALU_ACC_CTRL_Fp32_enabled_SHAMT 29
#define ALU_ACC_CTRL_Fp32_enabled_MASK 0x20000000
#define ALU_ACC_CTRL_Fp32_enabled_RMW \
    ALU_ACC_CTRL_Fp32_enabled_ADDR32, ALU_ACC_CTRL_Fp32_enabled_SHAMT, ALU_ACC_CTRL_Fp32_enabled_MASK

#define ALU_ACC_CTRL_SFPU_Fp32_enabled_ADDR32 1
#define ALU_ACC_CTRL_SFPU_Fp32_enabled_SHAMT 30
#define ALU_ACC_CTRL_SFPU_Fp32_enabled_MASK 0x40000000
#define ALU_ACC_CTRL_SFPU_Fp32_enabled_RMW \
    ALU_ACC_CTRL_SFPU_Fp32_enabled_ADDR32, ALU_ACC_CTRL_SFPU_Fp32_enabled_SHAMT, ALU_ACC_CTRL_SFPU_Fp32_enabled_MASK

#define ALU_ACC_CTRL_INT8_math_enabled_ADDR32 1
#define ALU_ACC_CTRL_INT8_math_enabled_SHAMT 31
#define ALU_ACC_CTRL_INT8_math_enabled_MASK 0x80000000
#define ALU_ACC_CTRL_INT8_math_enabled_RMW \
    ALU_ACC_CTRL_INT8_math_enabled_ADDR32, ALU_ACC_CTRL_INT8_math_enabled_SHAMT, ALU_ACC_CTRL_INT8_math_enabled_MASK

#define ALU_ACC_CTRL_Zero_Flag_disabled_src_ADDR32 2
#define ALU_ACC_CTRL_Zero_Flag_disabled_src_SHAMT 0
#define ALU_ACC_CTRL_Zero_Flag_disabled_src_MASK 0x1
#define ALU_ACC_CTRL_Zero_Flag_disabled_src_RMW                                            \
    ALU_ACC_CTRL_Zero_Flag_disabled_src_ADDR32, ALU_ACC_CTRL_Zero_Flag_disabled_src_SHAMT, \
        ALU_ACC_CTRL_Zero_Flag_disabled_src_MASK

#define ALU_ACC_CTRL_Zero_Flag_disabled_dst_ADDR32 2
#define ALU_ACC_CTRL_Zero_Flag_disabled_dst_SHAMT 1
#define ALU_ACC_CTRL_Zero_Flag_disabled_dst_MASK 0x2
#define ALU_ACC_CTRL_Zero_Flag_disabled_dst_RMW                                            \
    ALU_ACC_CTRL_Zero_Flag_disabled_dst_ADDR32, ALU_ACC_CTRL_Zero_Flag_disabled_dst_SHAMT, \
        ALU_ACC_CTRL_Zero_Flag_disabled_dst_MASK

#define STACC_RELU_ApplyRelu_ADDR32 2
#define STACC_RELU_ApplyRelu_SHAMT 2
#define STACC_RELU_ApplyRelu_MASK 0x3c
#define STACC_RELU_ApplyRelu_RMW STACC_RELU_ApplyRelu_ADDR32, STACC_RELU_ApplyRelu_SHAMT, STACC_RELU_ApplyRelu_MASK

#define STACC_RELU_ReluThreshold_ADDR32 2
#define STACC_RELU_ReluThreshold_SHAMT 6
#define STACC_RELU_ReluThreshold_MASK 0x3fffc0
#define STACC_RELU_ReluThreshold_RMW \
    STACC_RELU_ReluThreshold_ADDR32, STACC_RELU_ReluThreshold_SHAMT, STACC_RELU_ReluThreshold_MASK

#define DISABLE_RISC_BP_Disable_main_ADDR32 2
#define DISABLE_RISC_BP_Disable_main_SHAMT 22
#define DISABLE_RISC_BP_Disable_main_MASK 0x400000
#define DISABLE_RISC_BP_Disable_main_RMW \
    DISABLE_RISC_BP_Disable_main_ADDR32, DISABLE_RISC_BP_Disable_main_SHAMT, DISABLE_RISC_BP_Disable_main_MASK

#define DISABLE_RISC_BP_Disable_trisc_ADDR32 2
#define DISABLE_RISC_BP_Disable_trisc_SHAMT 23
#define DISABLE_RISC_BP_Disable_trisc_MASK 0x3800000
#define DISABLE_RISC_BP_Disable_trisc_RMW \
    DISABLE_RISC_BP_Disable_trisc_ADDR32, DISABLE_RISC_BP_Disable_trisc_SHAMT, DISABLE_RISC_BP_Disable_trisc_MASK

#define DISABLE_RISC_BP_Disable_ncrisc_ADDR32 2
#define DISABLE_RISC_BP_Disable_ncrisc_SHAMT 26
#define DISABLE_RISC_BP_Disable_ncrisc_MASK 0x4000000
#define DISABLE_RISC_BP_Disable_ncrisc_RMW \
    DISABLE_RISC_BP_Disable_ncrisc_ADDR32, DISABLE_RISC_BP_Disable_ncrisc_SHAMT, DISABLE_RISC_BP_Disable_ncrisc_MASK

#define DISABLE_RISC_BP_Disable_bmp_clear_main_ADDR32 2
#define DISABLE_RISC_BP_Disable_bmp_clear_main_SHAMT 27
#define DISABLE_RISC_BP_Disable_bmp_clear_main_MASK 0x8000000
#define DISABLE_RISC_BP_Disable_bmp_clear_main_RMW                                               \
    DISABLE_RISC_BP_Disable_bmp_clear_main_ADDR32, DISABLE_RISC_BP_Disable_bmp_clear_main_SHAMT, \
        DISABLE_RISC_BP_Disable_bmp_clear_main_MASK

#define DISABLE_RISC_BP_Disable_bmp_clear_trisc_ADDR32 2
#define DISABLE_RISC_BP_Disable_bmp_clear_trisc_SHAMT 28
#define DISABLE_RISC_BP_Disable_bmp_clear_trisc_MASK 0x70000000
#define DISABLE_RISC_BP_Disable_bmp_clear_trisc_RMW                                                \
    DISABLE_RISC_BP_Disable_bmp_clear_trisc_ADDR32, DISABLE_RISC_BP_Disable_bmp_clear_trisc_SHAMT, \
        DISABLE_RISC_BP_Disable_bmp_clear_trisc_MASK

#define DISABLE_RISC_BP_Disable_bmp_clear_ncrisc_ADDR32 2
#define DISABLE_RISC_BP_Disable_bmp_clear_ncrisc_SHAMT 31
#define DISABLE_RISC_BP_Disable_bmp_clear_ncrisc_MASK 0x80000000
#define DISABLE_RISC_BP_Disable_bmp_clear_ncrisc_RMW                                                 \
    DISABLE_RISC_BP_Disable_bmp_clear_ncrisc_ADDR32, DISABLE_RISC_BP_Disable_bmp_clear_ncrisc_SHAMT, \
        DISABLE_RISC_BP_Disable_bmp_clear_ncrisc_MASK

#define ECC_SCRUBBER_Enable_ADDR32 3
#define ECC_SCRUBBER_Enable_SHAMT 0
#define ECC_SCRUBBER_Enable_MASK 0x1
#define ECC_SCRUBBER_Enable_RMW ECC_SCRUBBER_Enable_ADDR32, ECC_SCRUBBER_Enable_SHAMT, ECC_SCRUBBER_Enable_MASK

#define ECC_SCRUBBER_Scrub_On_Error_ADDR32 3
#define ECC_SCRUBBER_Scrub_On_Error_SHAMT 1
#define ECC_SCRUBBER_Scrub_On_Error_MASK 0x2
#define ECC_SCRUBBER_Scrub_On_Error_RMW \
    ECC_SCRUBBER_Scrub_On_Error_ADDR32, ECC_SCRUBBER_Scrub_On_Error_SHAMT, ECC_SCRUBBER_Scrub_On_Error_MASK

#define ECC_SCRUBBER_Scrub_On_Error_Immediately_ADDR32 3
#define ECC_SCRUBBER_Scrub_On_Error_Immediately_SHAMT 2
#define ECC_SCRUBBER_Scrub_On_Error_Immediately_MASK 0x4
#define ECC_SCRUBBER_Scrub_On_Error_Immediately_RMW                                                \
    ECC_SCRUBBER_Scrub_On_Error_Immediately_ADDR32, ECC_SCRUBBER_Scrub_On_Error_Immediately_SHAMT, \
        ECC_SCRUBBER_Scrub_On_Error_Immediately_MASK

#define ECC_SCRUBBER_Delay_ADDR32 3
#define ECC_SCRUBBER_Delay_SHAMT 3
#define ECC_SCRUBBER_Delay_MASK 0x3ff8
#define ECC_SCRUBBER_Delay_RMW ECC_SCRUBBER_Delay_ADDR32, ECC_SCRUBBER_Delay_SHAMT, ECC_SCRUBBER_Delay_MASK

#define STATE_RESET_EN_ADDR32 4
#define STATE_RESET_EN_SHAMT 0
#define STATE_RESET_EN_MASK 0x1
#define STATE_RESET_EN_RMW STATE_RESET_EN_ADDR32, STATE_RESET_EN_SHAMT, STATE_RESET_EN_MASK

#define DEST_OFFSET_Enable_ADDR32 5
#define DEST_OFFSET_Enable_SHAMT 0
#define DEST_OFFSET_Enable_MASK 0x1
#define DEST_OFFSET_Enable_RMW DEST_OFFSET_Enable_ADDR32, DEST_OFFSET_Enable_SHAMT, DEST_OFFSET_Enable_MASK

#define DEST_REGW_BASE_Base_ADDR32 6
#define DEST_REGW_BASE_Base_SHAMT 0
#define DEST_REGW_BASE_Base_MASK 0xffff
#define DEST_REGW_BASE_Base_RMW DEST_REGW_BASE_Base_ADDR32, DEST_REGW_BASE_Base_SHAMT, DEST_REGW_BASE_Base_MASK

#define INT_DESCALE_Enable_ADDR32 7
#define INT_DESCALE_Enable_SHAMT 0
#define INT_DESCALE_Enable_MASK 0x1
#define INT_DESCALE_Enable_RMW INT_DESCALE_Enable_ADDR32, INT_DESCALE_Enable_SHAMT, INT_DESCALE_Enable_MASK

#define INT_DESCALE_Mode_ADDR32 7
#define INT_DESCALE_Mode_SHAMT 1
#define INT_DESCALE_Mode_MASK 0x2
#define INT_DESCALE_Mode_RMW INT_DESCALE_Mode_ADDR32, INT_DESCALE_Mode_SHAMT, INT_DESCALE_Mode_MASK

////////////////////////////////////////////////////////////////////////
// Registers for PACK0
////////////////////////////////////////////////////////////////////////

#define PACK0_CFGREG_BASE_ADDR32 8

#define PCK0_ADDR_CTRL_XY_REG_0_Xstride_ADDR32 8
#define PCK0_ADDR_CTRL_XY_REG_0_Xstride_SHAMT 0
#define PCK0_ADDR_CTRL_XY_REG_0_Xstride_MASK 0xfff
#define PCK0_ADDR_CTRL_XY_REG_0_Xstride_RMW \
    PCK0_ADDR_CTRL_XY_REG_0_Xstride_ADDR32, PCK0_ADDR_CTRL_XY_REG_0_Xstride_SHAMT, PCK0_ADDR_CTRL_XY_REG_0_Xstride_MASK

#define PCK0_ADDR_CTRL_XY_REG_0_Ystride_ADDR32 8
#define PCK0_ADDR_CTRL_XY_REG_0_Ystride_SHAMT 12
#define PCK0_ADDR_CTRL_XY_REG_0_Ystride_MASK 0xfff000
#define PCK0_ADDR_CTRL_XY_REG_0_Ystride_RMW \
    PCK0_ADDR_CTRL_XY_REG_0_Ystride_ADDR32, PCK0_ADDR_CTRL_XY_REG_0_Ystride_SHAMT, PCK0_ADDR_CTRL_XY_REG_0_Ystride_MASK

#define PCK0_ADDR_CTRL_ZW_REG_0_Zstride_ADDR32 9
#define PCK0_ADDR_CTRL_ZW_REG_0_Zstride_SHAMT 0
#define PCK0_ADDR_CTRL_ZW_REG_0_Zstride_MASK 0xfff
#define PCK0_ADDR_CTRL_ZW_REG_0_Zstride_RMW \
    PCK0_ADDR_CTRL_ZW_REG_0_Zstride_ADDR32, PCK0_ADDR_CTRL_ZW_REG_0_Zstride_SHAMT, PCK0_ADDR_CTRL_ZW_REG_0_Zstride_MASK

#define PCK0_ADDR_CTRL_ZW_REG_0_Wstride_ADDR32 9
#define PCK0_ADDR_CTRL_ZW_REG_0_Wstride_SHAMT 12
#define PCK0_ADDR_CTRL_ZW_REG_0_Wstride_MASK 0xffff000
#define PCK0_ADDR_CTRL_ZW_REG_0_Wstride_RMW \
    PCK0_ADDR_CTRL_ZW_REG_0_Wstride_ADDR32, PCK0_ADDR_CTRL_ZW_REG_0_Wstride_SHAMT, PCK0_ADDR_CTRL_ZW_REG_0_Wstride_MASK

#define PCK0_ADDR_CTRL_XY_REG_1_Xstride_ADDR32 10
#define PCK0_ADDR_CTRL_XY_REG_1_Xstride_SHAMT 0
#define PCK0_ADDR_CTRL_XY_REG_1_Xstride_MASK 0xfff
#define PCK0_ADDR_CTRL_XY_REG_1_Xstride_RMW \
    PCK0_ADDR_CTRL_XY_REG_1_Xstride_ADDR32, PCK0_ADDR_CTRL_XY_REG_1_Xstride_SHAMT, PCK0_ADDR_CTRL_XY_REG_1_Xstride_MASK

#define PCK0_ADDR_CTRL_XY_REG_1_Ystride_ADDR32 10
#define PCK0_ADDR_CTRL_XY_REG_1_Ystride_SHAMT 12
#define PCK0_ADDR_CTRL_XY_REG_1_Ystride_MASK 0xfff000
#define PCK0_ADDR_CTRL_XY_REG_1_Ystride_RMW \
    PCK0_ADDR_CTRL_XY_REG_1_Ystride_ADDR32, PCK0_ADDR_CTRL_XY_REG_1_Ystride_SHAMT, PCK0_ADDR_CTRL_XY_REG_1_Ystride_MASK

#define PCK0_ADDR_CTRL_ZW_REG_1_Zstride_ADDR32 11
#define PCK0_ADDR_CTRL_ZW_REG_1_Zstride_SHAMT 0
#define PCK0_ADDR_CTRL_ZW_REG_1_Zstride_MASK 0xfff
#define PCK0_ADDR_CTRL_ZW_REG_1_Zstride_RMW \
    PCK0_ADDR_CTRL_ZW_REG_1_Zstride_ADDR32, PCK0_ADDR_CTRL_ZW_REG_1_Zstride_SHAMT, PCK0_ADDR_CTRL_ZW_REG_1_Zstride_MASK

#define PCK0_ADDR_CTRL_ZW_REG_1_Wstride_ADDR32 11
#define PCK0_ADDR_CTRL_ZW_REG_1_Wstride_SHAMT 12
#define PCK0_ADDR_CTRL_ZW_REG_1_Wstride_MASK 0xffff000
#define PCK0_ADDR_CTRL_ZW_REG_1_Wstride_RMW \
    PCK0_ADDR_CTRL_ZW_REG_1_Wstride_ADDR32, PCK0_ADDR_CTRL_ZW_REG_1_Wstride_SHAMT, PCK0_ADDR_CTRL_ZW_REG_1_Wstride_MASK

#define PCK0_ADDR_BASE_REG_0_Base_ADDR32 12
#define PCK0_ADDR_BASE_REG_0_Base_SHAMT 0
#define PCK0_ADDR_BASE_REG_0_Base_MASK 0xffff
#define PCK0_ADDR_BASE_REG_0_Base_RMW \
    PCK0_ADDR_BASE_REG_0_Base_ADDR32, PCK0_ADDR_BASE_REG_0_Base_SHAMT, PCK0_ADDR_BASE_REG_0_Base_MASK

#define PCK0_ADDR_BASE_REG_1_Base_ADDR32 13
#define PCK0_ADDR_BASE_REG_1_Base_SHAMT 0
#define PCK0_ADDR_BASE_REG_1_Base_MASK 0xffff
#define PCK0_ADDR_BASE_REG_1_Base_RMW \
    PCK0_ADDR_BASE_REG_1_Base_ADDR32, PCK0_ADDR_BASE_REG_1_Base_SHAMT, PCK0_ADDR_BASE_REG_1_Base_MASK

#define PCK_DEST_RD_CTRL_Read_32b_data_ADDR32 14
#define PCK_DEST_RD_CTRL_Read_32b_data_SHAMT 0
#define PCK_DEST_RD_CTRL_Read_32b_data_MASK 0x1
#define PCK_DEST_RD_CTRL_Read_32b_data_RMW \
    PCK_DEST_RD_CTRL_Read_32b_data_ADDR32, PCK_DEST_RD_CTRL_Read_32b_data_SHAMT, PCK_DEST_RD_CTRL_Read_32b_data_MASK

#define PCK_DEST_RD_CTRL_Read_unsigned_ADDR32 14
#define PCK_DEST_RD_CTRL_Read_unsigned_SHAMT 1
#define PCK_DEST_RD_CTRL_Read_unsigned_MASK 0x2
#define PCK_DEST_RD_CTRL_Read_unsigned_RMW \
    PCK_DEST_RD_CTRL_Read_unsigned_ADDR32, PCK_DEST_RD_CTRL_Read_unsigned_SHAMT, PCK_DEST_RD_CTRL_Read_unsigned_MASK

#define PCK_DEST_RD_CTRL_Read_int8_ADDR32 14
#define PCK_DEST_RD_CTRL_Read_int8_SHAMT 2
#define PCK_DEST_RD_CTRL_Read_int8_MASK 0x4
#define PCK_DEST_RD_CTRL_Read_int8_RMW \
    PCK_DEST_RD_CTRL_Read_int8_ADDR32, PCK_DEST_RD_CTRL_Read_int8_SHAMT, PCK_DEST_RD_CTRL_Read_int8_MASK

#define PCK_DEST_RD_CTRL_Round_10b_mant_ADDR32 14
#define PCK_DEST_RD_CTRL_Round_10b_mant_SHAMT 3
#define PCK_DEST_RD_CTRL_Round_10b_mant_MASK 0x8
#define PCK_DEST_RD_CTRL_Round_10b_mant_RMW \
    PCK_DEST_RD_CTRL_Round_10b_mant_ADDR32, PCK_DEST_RD_CTRL_Round_10b_mant_SHAMT, PCK_DEST_RD_CTRL_Round_10b_mant_MASK

#define PCK_EDGE_TILE_FACE_SET_SELECT_select_ADDR32 15
#define PCK_EDGE_TILE_FACE_SET_SELECT_select_SHAMT 0
#define PCK_EDGE_TILE_FACE_SET_SELECT_select_MASK 0xff
#define PCK_EDGE_TILE_FACE_SET_SELECT_select_RMW                                             \
    PCK_EDGE_TILE_FACE_SET_SELECT_select_ADDR32, PCK_EDGE_TILE_FACE_SET_SELECT_select_SHAMT, \
        PCK_EDGE_TILE_FACE_SET_SELECT_select_MASK

#define PCK_EDGE_TILE_FACE_SET_SELECT_enable_ADDR32 15
#define PCK_EDGE_TILE_FACE_SET_SELECT_enable_SHAMT 8
#define PCK_EDGE_TILE_FACE_SET_SELECT_enable_MASK 0x100
#define PCK_EDGE_TILE_FACE_SET_SELECT_enable_RMW                                             \
    PCK_EDGE_TILE_FACE_SET_SELECT_enable_ADDR32, PCK_EDGE_TILE_FACE_SET_SELECT_enable_SHAMT, \
        PCK_EDGE_TILE_FACE_SET_SELECT_enable_MASK

#define TILE_ROW_SET_MAPPING_0_row_set_mapping_0_ADDR32 16
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_0_SHAMT 0
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_0_MASK 0x3
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_0_RMW                                                 \
    TILE_ROW_SET_MAPPING_0_row_set_mapping_0_ADDR32, TILE_ROW_SET_MAPPING_0_row_set_mapping_0_SHAMT, \
        TILE_ROW_SET_MAPPING_0_row_set_mapping_0_MASK

#define TILE_ROW_SET_MAPPING_0_row_set_mapping_1_ADDR32 16
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_1_SHAMT 2
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_1_MASK 0xc
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_1_RMW                                                 \
    TILE_ROW_SET_MAPPING_0_row_set_mapping_1_ADDR32, TILE_ROW_SET_MAPPING_0_row_set_mapping_1_SHAMT, \
        TILE_ROW_SET_MAPPING_0_row_set_mapping_1_MASK

#define TILE_ROW_SET_MAPPING_0_row_set_mapping_2_ADDR32 16
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_2_SHAMT 4
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_2_MASK 0x30
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_2_RMW                                                 \
    TILE_ROW_SET_MAPPING_0_row_set_mapping_2_ADDR32, TILE_ROW_SET_MAPPING_0_row_set_mapping_2_SHAMT, \
        TILE_ROW_SET_MAPPING_0_row_set_mapping_2_MASK

#define TILE_ROW_SET_MAPPING_0_row_set_mapping_3_ADDR32 16
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_3_SHAMT 6
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_3_MASK 0xc0
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_3_RMW                                                 \
    TILE_ROW_SET_MAPPING_0_row_set_mapping_3_ADDR32, TILE_ROW_SET_MAPPING_0_row_set_mapping_3_SHAMT, \
        TILE_ROW_SET_MAPPING_0_row_set_mapping_3_MASK

#define TILE_ROW_SET_MAPPING_0_row_set_mapping_4_ADDR32 16
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_4_SHAMT 8
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_4_MASK 0x300
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_4_RMW                                                 \
    TILE_ROW_SET_MAPPING_0_row_set_mapping_4_ADDR32, TILE_ROW_SET_MAPPING_0_row_set_mapping_4_SHAMT, \
        TILE_ROW_SET_MAPPING_0_row_set_mapping_4_MASK

#define TILE_ROW_SET_MAPPING_0_row_set_mapping_5_ADDR32 16
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_5_SHAMT 10
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_5_MASK 0xc00
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_5_RMW                                                 \
    TILE_ROW_SET_MAPPING_0_row_set_mapping_5_ADDR32, TILE_ROW_SET_MAPPING_0_row_set_mapping_5_SHAMT, \
        TILE_ROW_SET_MAPPING_0_row_set_mapping_5_MASK

#define TILE_ROW_SET_MAPPING_0_row_set_mapping_6_ADDR32 16
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_6_SHAMT 12
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_6_MASK 0x3000
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_6_RMW                                                 \
    TILE_ROW_SET_MAPPING_0_row_set_mapping_6_ADDR32, TILE_ROW_SET_MAPPING_0_row_set_mapping_6_SHAMT, \
        TILE_ROW_SET_MAPPING_0_row_set_mapping_6_MASK

#define TILE_ROW_SET_MAPPING_0_row_set_mapping_7_ADDR32 16
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_7_SHAMT 14
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_7_MASK 0xc000
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_7_RMW                                                 \
    TILE_ROW_SET_MAPPING_0_row_set_mapping_7_ADDR32, TILE_ROW_SET_MAPPING_0_row_set_mapping_7_SHAMT, \
        TILE_ROW_SET_MAPPING_0_row_set_mapping_7_MASK

#define TILE_ROW_SET_MAPPING_0_row_set_mapping_8_ADDR32 16
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_8_SHAMT 16
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_8_MASK 0x30000
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_8_RMW                                                 \
    TILE_ROW_SET_MAPPING_0_row_set_mapping_8_ADDR32, TILE_ROW_SET_MAPPING_0_row_set_mapping_8_SHAMT, \
        TILE_ROW_SET_MAPPING_0_row_set_mapping_8_MASK

#define TILE_ROW_SET_MAPPING_0_row_set_mapping_9_ADDR32 16
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_9_SHAMT 18
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_9_MASK 0xc0000
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_9_RMW                                                 \
    TILE_ROW_SET_MAPPING_0_row_set_mapping_9_ADDR32, TILE_ROW_SET_MAPPING_0_row_set_mapping_9_SHAMT, \
        TILE_ROW_SET_MAPPING_0_row_set_mapping_9_MASK

#define TILE_ROW_SET_MAPPING_0_row_set_mapping_10_ADDR32 16
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_10_SHAMT 20
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_10_MASK 0x300000
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_10_RMW                                                  \
    TILE_ROW_SET_MAPPING_0_row_set_mapping_10_ADDR32, TILE_ROW_SET_MAPPING_0_row_set_mapping_10_SHAMT, \
        TILE_ROW_SET_MAPPING_0_row_set_mapping_10_MASK

#define TILE_ROW_SET_MAPPING_0_row_set_mapping_11_ADDR32 16
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_11_SHAMT 22
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_11_MASK 0xc00000
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_11_RMW                                                  \
    TILE_ROW_SET_MAPPING_0_row_set_mapping_11_ADDR32, TILE_ROW_SET_MAPPING_0_row_set_mapping_11_SHAMT, \
        TILE_ROW_SET_MAPPING_0_row_set_mapping_11_MASK

#define TILE_ROW_SET_MAPPING_0_row_set_mapping_12_ADDR32 16
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_12_SHAMT 24
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_12_MASK 0x3000000
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_12_RMW                                                  \
    TILE_ROW_SET_MAPPING_0_row_set_mapping_12_ADDR32, TILE_ROW_SET_MAPPING_0_row_set_mapping_12_SHAMT, \
        TILE_ROW_SET_MAPPING_0_row_set_mapping_12_MASK

#define TILE_ROW_SET_MAPPING_0_row_set_mapping_13_ADDR32 16
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_13_SHAMT 26
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_13_MASK 0xc000000
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_13_RMW                                                  \
    TILE_ROW_SET_MAPPING_0_row_set_mapping_13_ADDR32, TILE_ROW_SET_MAPPING_0_row_set_mapping_13_SHAMT, \
        TILE_ROW_SET_MAPPING_0_row_set_mapping_13_MASK

#define TILE_ROW_SET_MAPPING_0_row_set_mapping_14_ADDR32 16
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_14_SHAMT 28
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_14_MASK 0x30000000
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_14_RMW                                                  \
    TILE_ROW_SET_MAPPING_0_row_set_mapping_14_ADDR32, TILE_ROW_SET_MAPPING_0_row_set_mapping_14_SHAMT, \
        TILE_ROW_SET_MAPPING_0_row_set_mapping_14_MASK

#define TILE_ROW_SET_MAPPING_0_row_set_mapping_15_ADDR32 16
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_15_SHAMT 30
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_15_MASK 0xc0000000
#define TILE_ROW_SET_MAPPING_0_row_set_mapping_15_RMW                                                  \
    TILE_ROW_SET_MAPPING_0_row_set_mapping_15_ADDR32, TILE_ROW_SET_MAPPING_0_row_set_mapping_15_SHAMT, \
        TILE_ROW_SET_MAPPING_0_row_set_mapping_15_MASK

#define TILE_ROW_SET_MAPPING_1_row_set_mapping_0_ADDR32 17
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_0_SHAMT 0
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_0_MASK 0x3
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_0_RMW                                                 \
    TILE_ROW_SET_MAPPING_1_row_set_mapping_0_ADDR32, TILE_ROW_SET_MAPPING_1_row_set_mapping_0_SHAMT, \
        TILE_ROW_SET_MAPPING_1_row_set_mapping_0_MASK

#define TILE_ROW_SET_MAPPING_1_row_set_mapping_1_ADDR32 17
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_1_SHAMT 2
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_1_MASK 0xc
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_1_RMW                                                 \
    TILE_ROW_SET_MAPPING_1_row_set_mapping_1_ADDR32, TILE_ROW_SET_MAPPING_1_row_set_mapping_1_SHAMT, \
        TILE_ROW_SET_MAPPING_1_row_set_mapping_1_MASK

#define TILE_ROW_SET_MAPPING_1_row_set_mapping_2_ADDR32 17
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_2_SHAMT 4
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_2_MASK 0x30
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_2_RMW                                                 \
    TILE_ROW_SET_MAPPING_1_row_set_mapping_2_ADDR32, TILE_ROW_SET_MAPPING_1_row_set_mapping_2_SHAMT, \
        TILE_ROW_SET_MAPPING_1_row_set_mapping_2_MASK

#define TILE_ROW_SET_MAPPING_1_row_set_mapping_3_ADDR32 17
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_3_SHAMT 6
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_3_MASK 0xc0
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_3_RMW                                                 \
    TILE_ROW_SET_MAPPING_1_row_set_mapping_3_ADDR32, TILE_ROW_SET_MAPPING_1_row_set_mapping_3_SHAMT, \
        TILE_ROW_SET_MAPPING_1_row_set_mapping_3_MASK

#define TILE_ROW_SET_MAPPING_1_row_set_mapping_4_ADDR32 17
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_4_SHAMT 8
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_4_MASK 0x300
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_4_RMW                                                 \
    TILE_ROW_SET_MAPPING_1_row_set_mapping_4_ADDR32, TILE_ROW_SET_MAPPING_1_row_set_mapping_4_SHAMT, \
        TILE_ROW_SET_MAPPING_1_row_set_mapping_4_MASK

#define TILE_ROW_SET_MAPPING_1_row_set_mapping_5_ADDR32 17
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_5_SHAMT 10
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_5_MASK 0xc00
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_5_RMW                                                 \
    TILE_ROW_SET_MAPPING_1_row_set_mapping_5_ADDR32, TILE_ROW_SET_MAPPING_1_row_set_mapping_5_SHAMT, \
        TILE_ROW_SET_MAPPING_1_row_set_mapping_5_MASK

#define TILE_ROW_SET_MAPPING_1_row_set_mapping_6_ADDR32 17
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_6_SHAMT 12
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_6_MASK 0x3000
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_6_RMW                                                 \
    TILE_ROW_SET_MAPPING_1_row_set_mapping_6_ADDR32, TILE_ROW_SET_MAPPING_1_row_set_mapping_6_SHAMT, \
        TILE_ROW_SET_MAPPING_1_row_set_mapping_6_MASK

#define TILE_ROW_SET_MAPPING_1_row_set_mapping_7_ADDR32 17
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_7_SHAMT 14
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_7_MASK 0xc000
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_7_RMW                                                 \
    TILE_ROW_SET_MAPPING_1_row_set_mapping_7_ADDR32, TILE_ROW_SET_MAPPING_1_row_set_mapping_7_SHAMT, \
        TILE_ROW_SET_MAPPING_1_row_set_mapping_7_MASK

#define TILE_ROW_SET_MAPPING_1_row_set_mapping_8_ADDR32 17
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_8_SHAMT 16
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_8_MASK 0x30000
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_8_RMW                                                 \
    TILE_ROW_SET_MAPPING_1_row_set_mapping_8_ADDR32, TILE_ROW_SET_MAPPING_1_row_set_mapping_8_SHAMT, \
        TILE_ROW_SET_MAPPING_1_row_set_mapping_8_MASK

#define TILE_ROW_SET_MAPPING_1_row_set_mapping_9_ADDR32 17
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_9_SHAMT 18
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_9_MASK 0xc0000
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_9_RMW                                                 \
    TILE_ROW_SET_MAPPING_1_row_set_mapping_9_ADDR32, TILE_ROW_SET_MAPPING_1_row_set_mapping_9_SHAMT, \
        TILE_ROW_SET_MAPPING_1_row_set_mapping_9_MASK

#define TILE_ROW_SET_MAPPING_1_row_set_mapping_10_ADDR32 17
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_10_SHAMT 20
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_10_MASK 0x300000
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_10_RMW                                                  \
    TILE_ROW_SET_MAPPING_1_row_set_mapping_10_ADDR32, TILE_ROW_SET_MAPPING_1_row_set_mapping_10_SHAMT, \
        TILE_ROW_SET_MAPPING_1_row_set_mapping_10_MASK

#define TILE_ROW_SET_MAPPING_1_row_set_mapping_11_ADDR32 17
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_11_SHAMT 22
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_11_MASK 0xc00000
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_11_RMW                                                  \
    TILE_ROW_SET_MAPPING_1_row_set_mapping_11_ADDR32, TILE_ROW_SET_MAPPING_1_row_set_mapping_11_SHAMT, \
        TILE_ROW_SET_MAPPING_1_row_set_mapping_11_MASK

#define TILE_ROW_SET_MAPPING_1_row_set_mapping_12_ADDR32 17
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_12_SHAMT 24
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_12_MASK 0x3000000
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_12_RMW                                                  \
    TILE_ROW_SET_MAPPING_1_row_set_mapping_12_ADDR32, TILE_ROW_SET_MAPPING_1_row_set_mapping_12_SHAMT, \
        TILE_ROW_SET_MAPPING_1_row_set_mapping_12_MASK

#define TILE_ROW_SET_MAPPING_1_row_set_mapping_13_ADDR32 17
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_13_SHAMT 26
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_13_MASK 0xc000000
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_13_RMW                                                  \
    TILE_ROW_SET_MAPPING_1_row_set_mapping_13_ADDR32, TILE_ROW_SET_MAPPING_1_row_set_mapping_13_SHAMT, \
        TILE_ROW_SET_MAPPING_1_row_set_mapping_13_MASK

#define TILE_ROW_SET_MAPPING_1_row_set_mapping_14_ADDR32 17
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_14_SHAMT 28
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_14_MASK 0x30000000
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_14_RMW                                                  \
    TILE_ROW_SET_MAPPING_1_row_set_mapping_14_ADDR32, TILE_ROW_SET_MAPPING_1_row_set_mapping_14_SHAMT, \
        TILE_ROW_SET_MAPPING_1_row_set_mapping_14_MASK

#define TILE_ROW_SET_MAPPING_1_row_set_mapping_15_ADDR32 17
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_15_SHAMT 30
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_15_MASK 0xc0000000
#define TILE_ROW_SET_MAPPING_1_row_set_mapping_15_RMW                                                  \
    TILE_ROW_SET_MAPPING_1_row_set_mapping_15_ADDR32, TILE_ROW_SET_MAPPING_1_row_set_mapping_15_SHAMT, \
        TILE_ROW_SET_MAPPING_1_row_set_mapping_15_MASK

#define TILE_ROW_SET_MAPPING_2_row_set_mapping_0_ADDR32 18
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_0_SHAMT 0
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_0_MASK 0x3
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_0_RMW                                                 \
    TILE_ROW_SET_MAPPING_2_row_set_mapping_0_ADDR32, TILE_ROW_SET_MAPPING_2_row_set_mapping_0_SHAMT, \
        TILE_ROW_SET_MAPPING_2_row_set_mapping_0_MASK

#define TILE_ROW_SET_MAPPING_2_row_set_mapping_1_ADDR32 18
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_1_SHAMT 2
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_1_MASK 0xc
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_1_RMW                                                 \
    TILE_ROW_SET_MAPPING_2_row_set_mapping_1_ADDR32, TILE_ROW_SET_MAPPING_2_row_set_mapping_1_SHAMT, \
        TILE_ROW_SET_MAPPING_2_row_set_mapping_1_MASK

#define TILE_ROW_SET_MAPPING_2_row_set_mapping_2_ADDR32 18
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_2_SHAMT 4
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_2_MASK 0x30
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_2_RMW                                                 \
    TILE_ROW_SET_MAPPING_2_row_set_mapping_2_ADDR32, TILE_ROW_SET_MAPPING_2_row_set_mapping_2_SHAMT, \
        TILE_ROW_SET_MAPPING_2_row_set_mapping_2_MASK

#define TILE_ROW_SET_MAPPING_2_row_set_mapping_3_ADDR32 18
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_3_SHAMT 6
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_3_MASK 0xc0
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_3_RMW                                                 \
    TILE_ROW_SET_MAPPING_2_row_set_mapping_3_ADDR32, TILE_ROW_SET_MAPPING_2_row_set_mapping_3_SHAMT, \
        TILE_ROW_SET_MAPPING_2_row_set_mapping_3_MASK

#define TILE_ROW_SET_MAPPING_2_row_set_mapping_4_ADDR32 18
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_4_SHAMT 8
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_4_MASK 0x300
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_4_RMW                                                 \
    TILE_ROW_SET_MAPPING_2_row_set_mapping_4_ADDR32, TILE_ROW_SET_MAPPING_2_row_set_mapping_4_SHAMT, \
        TILE_ROW_SET_MAPPING_2_row_set_mapping_4_MASK

#define TILE_ROW_SET_MAPPING_2_row_set_mapping_5_ADDR32 18
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_5_SHAMT 10
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_5_MASK 0xc00
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_5_RMW                                                 \
    TILE_ROW_SET_MAPPING_2_row_set_mapping_5_ADDR32, TILE_ROW_SET_MAPPING_2_row_set_mapping_5_SHAMT, \
        TILE_ROW_SET_MAPPING_2_row_set_mapping_5_MASK

#define TILE_ROW_SET_MAPPING_2_row_set_mapping_6_ADDR32 18
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_6_SHAMT 12
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_6_MASK 0x3000
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_6_RMW                                                 \
    TILE_ROW_SET_MAPPING_2_row_set_mapping_6_ADDR32, TILE_ROW_SET_MAPPING_2_row_set_mapping_6_SHAMT, \
        TILE_ROW_SET_MAPPING_2_row_set_mapping_6_MASK

#define TILE_ROW_SET_MAPPING_2_row_set_mapping_7_ADDR32 18
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_7_SHAMT 14
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_7_MASK 0xc000
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_7_RMW                                                 \
    TILE_ROW_SET_MAPPING_2_row_set_mapping_7_ADDR32, TILE_ROW_SET_MAPPING_2_row_set_mapping_7_SHAMT, \
        TILE_ROW_SET_MAPPING_2_row_set_mapping_7_MASK

#define TILE_ROW_SET_MAPPING_2_row_set_mapping_8_ADDR32 18
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_8_SHAMT 16
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_8_MASK 0x30000
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_8_RMW                                                 \
    TILE_ROW_SET_MAPPING_2_row_set_mapping_8_ADDR32, TILE_ROW_SET_MAPPING_2_row_set_mapping_8_SHAMT, \
        TILE_ROW_SET_MAPPING_2_row_set_mapping_8_MASK

#define TILE_ROW_SET_MAPPING_2_row_set_mapping_9_ADDR32 18
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_9_SHAMT 18
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_9_MASK 0xc0000
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_9_RMW                                                 \
    TILE_ROW_SET_MAPPING_2_row_set_mapping_9_ADDR32, TILE_ROW_SET_MAPPING_2_row_set_mapping_9_SHAMT, \
        TILE_ROW_SET_MAPPING_2_row_set_mapping_9_MASK

#define TILE_ROW_SET_MAPPING_2_row_set_mapping_10_ADDR32 18
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_10_SHAMT 20
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_10_MASK 0x300000
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_10_RMW                                                  \
    TILE_ROW_SET_MAPPING_2_row_set_mapping_10_ADDR32, TILE_ROW_SET_MAPPING_2_row_set_mapping_10_SHAMT, \
        TILE_ROW_SET_MAPPING_2_row_set_mapping_10_MASK

#define TILE_ROW_SET_MAPPING_2_row_set_mapping_11_ADDR32 18
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_11_SHAMT 22
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_11_MASK 0xc00000
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_11_RMW                                                  \
    TILE_ROW_SET_MAPPING_2_row_set_mapping_11_ADDR32, TILE_ROW_SET_MAPPING_2_row_set_mapping_11_SHAMT, \
        TILE_ROW_SET_MAPPING_2_row_set_mapping_11_MASK

#define TILE_ROW_SET_MAPPING_2_row_set_mapping_12_ADDR32 18
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_12_SHAMT 24
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_12_MASK 0x3000000
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_12_RMW                                                  \
    TILE_ROW_SET_MAPPING_2_row_set_mapping_12_ADDR32, TILE_ROW_SET_MAPPING_2_row_set_mapping_12_SHAMT, \
        TILE_ROW_SET_MAPPING_2_row_set_mapping_12_MASK

#define TILE_ROW_SET_MAPPING_2_row_set_mapping_13_ADDR32 18
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_13_SHAMT 26
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_13_MASK 0xc000000
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_13_RMW                                                  \
    TILE_ROW_SET_MAPPING_2_row_set_mapping_13_ADDR32, TILE_ROW_SET_MAPPING_2_row_set_mapping_13_SHAMT, \
        TILE_ROW_SET_MAPPING_2_row_set_mapping_13_MASK

#define TILE_ROW_SET_MAPPING_2_row_set_mapping_14_ADDR32 18
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_14_SHAMT 28
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_14_MASK 0x30000000
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_14_RMW                                                  \
    TILE_ROW_SET_MAPPING_2_row_set_mapping_14_ADDR32, TILE_ROW_SET_MAPPING_2_row_set_mapping_14_SHAMT, \
        TILE_ROW_SET_MAPPING_2_row_set_mapping_14_MASK

#define TILE_ROW_SET_MAPPING_2_row_set_mapping_15_ADDR32 18
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_15_SHAMT 30
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_15_MASK 0xc0000000
#define TILE_ROW_SET_MAPPING_2_row_set_mapping_15_RMW                                                  \
    TILE_ROW_SET_MAPPING_2_row_set_mapping_15_ADDR32, TILE_ROW_SET_MAPPING_2_row_set_mapping_15_SHAMT, \
        TILE_ROW_SET_MAPPING_2_row_set_mapping_15_MASK

#define TILE_ROW_SET_MAPPING_3_row_set_mapping_0_ADDR32 19
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_0_SHAMT 0
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_0_MASK 0x3
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_0_RMW                                                 \
    TILE_ROW_SET_MAPPING_3_row_set_mapping_0_ADDR32, TILE_ROW_SET_MAPPING_3_row_set_mapping_0_SHAMT, \
        TILE_ROW_SET_MAPPING_3_row_set_mapping_0_MASK

#define TILE_ROW_SET_MAPPING_3_row_set_mapping_1_ADDR32 19
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_1_SHAMT 2
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_1_MASK 0xc
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_1_RMW                                                 \
    TILE_ROW_SET_MAPPING_3_row_set_mapping_1_ADDR32, TILE_ROW_SET_MAPPING_3_row_set_mapping_1_SHAMT, \
        TILE_ROW_SET_MAPPING_3_row_set_mapping_1_MASK

#define TILE_ROW_SET_MAPPING_3_row_set_mapping_2_ADDR32 19
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_2_SHAMT 4
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_2_MASK 0x30
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_2_RMW                                                 \
    TILE_ROW_SET_MAPPING_3_row_set_mapping_2_ADDR32, TILE_ROW_SET_MAPPING_3_row_set_mapping_2_SHAMT, \
        TILE_ROW_SET_MAPPING_3_row_set_mapping_2_MASK

#define TILE_ROW_SET_MAPPING_3_row_set_mapping_3_ADDR32 19
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_3_SHAMT 6
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_3_MASK 0xc0
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_3_RMW                                                 \
    TILE_ROW_SET_MAPPING_3_row_set_mapping_3_ADDR32, TILE_ROW_SET_MAPPING_3_row_set_mapping_3_SHAMT, \
        TILE_ROW_SET_MAPPING_3_row_set_mapping_3_MASK

#define TILE_ROW_SET_MAPPING_3_row_set_mapping_4_ADDR32 19
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_4_SHAMT 8
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_4_MASK 0x300
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_4_RMW                                                 \
    TILE_ROW_SET_MAPPING_3_row_set_mapping_4_ADDR32, TILE_ROW_SET_MAPPING_3_row_set_mapping_4_SHAMT, \
        TILE_ROW_SET_MAPPING_3_row_set_mapping_4_MASK

#define TILE_ROW_SET_MAPPING_3_row_set_mapping_5_ADDR32 19
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_5_SHAMT 10
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_5_MASK 0xc00
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_5_RMW                                                 \
    TILE_ROW_SET_MAPPING_3_row_set_mapping_5_ADDR32, TILE_ROW_SET_MAPPING_3_row_set_mapping_5_SHAMT, \
        TILE_ROW_SET_MAPPING_3_row_set_mapping_5_MASK

#define TILE_ROW_SET_MAPPING_3_row_set_mapping_6_ADDR32 19
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_6_SHAMT 12
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_6_MASK 0x3000
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_6_RMW                                                 \
    TILE_ROW_SET_MAPPING_3_row_set_mapping_6_ADDR32, TILE_ROW_SET_MAPPING_3_row_set_mapping_6_SHAMT, \
        TILE_ROW_SET_MAPPING_3_row_set_mapping_6_MASK

#define TILE_ROW_SET_MAPPING_3_row_set_mapping_7_ADDR32 19
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_7_SHAMT 14
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_7_MASK 0xc000
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_7_RMW                                                 \
    TILE_ROW_SET_MAPPING_3_row_set_mapping_7_ADDR32, TILE_ROW_SET_MAPPING_3_row_set_mapping_7_SHAMT, \
        TILE_ROW_SET_MAPPING_3_row_set_mapping_7_MASK

#define TILE_ROW_SET_MAPPING_3_row_set_mapping_8_ADDR32 19
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_8_SHAMT 16
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_8_MASK 0x30000
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_8_RMW                                                 \
    TILE_ROW_SET_MAPPING_3_row_set_mapping_8_ADDR32, TILE_ROW_SET_MAPPING_3_row_set_mapping_8_SHAMT, \
        TILE_ROW_SET_MAPPING_3_row_set_mapping_8_MASK

#define TILE_ROW_SET_MAPPING_3_row_set_mapping_9_ADDR32 19
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_9_SHAMT 18
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_9_MASK 0xc0000
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_9_RMW                                                 \
    TILE_ROW_SET_MAPPING_3_row_set_mapping_9_ADDR32, TILE_ROW_SET_MAPPING_3_row_set_mapping_9_SHAMT, \
        TILE_ROW_SET_MAPPING_3_row_set_mapping_9_MASK

#define TILE_ROW_SET_MAPPING_3_row_set_mapping_10_ADDR32 19
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_10_SHAMT 20
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_10_MASK 0x300000
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_10_RMW                                                  \
    TILE_ROW_SET_MAPPING_3_row_set_mapping_10_ADDR32, TILE_ROW_SET_MAPPING_3_row_set_mapping_10_SHAMT, \
        TILE_ROW_SET_MAPPING_3_row_set_mapping_10_MASK

#define TILE_ROW_SET_MAPPING_3_row_set_mapping_11_ADDR32 19
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_11_SHAMT 22
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_11_MASK 0xc00000
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_11_RMW                                                  \
    TILE_ROW_SET_MAPPING_3_row_set_mapping_11_ADDR32, TILE_ROW_SET_MAPPING_3_row_set_mapping_11_SHAMT, \
        TILE_ROW_SET_MAPPING_3_row_set_mapping_11_MASK

#define TILE_ROW_SET_MAPPING_3_row_set_mapping_12_ADDR32 19
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_12_SHAMT 24
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_12_MASK 0x3000000
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_12_RMW                                                  \
    TILE_ROW_SET_MAPPING_3_row_set_mapping_12_ADDR32, TILE_ROW_SET_MAPPING_3_row_set_mapping_12_SHAMT, \
        TILE_ROW_SET_MAPPING_3_row_set_mapping_12_MASK

#define TILE_ROW_SET_MAPPING_3_row_set_mapping_13_ADDR32 19
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_13_SHAMT 26
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_13_MASK 0xc000000
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_13_RMW                                                  \
    TILE_ROW_SET_MAPPING_3_row_set_mapping_13_ADDR32, TILE_ROW_SET_MAPPING_3_row_set_mapping_13_SHAMT, \
        TILE_ROW_SET_MAPPING_3_row_set_mapping_13_MASK

#define TILE_ROW_SET_MAPPING_3_row_set_mapping_14_ADDR32 19
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_14_SHAMT 28
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_14_MASK 0x30000000
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_14_RMW                                                  \
    TILE_ROW_SET_MAPPING_3_row_set_mapping_14_ADDR32, TILE_ROW_SET_MAPPING_3_row_set_mapping_14_SHAMT, \
        TILE_ROW_SET_MAPPING_3_row_set_mapping_14_MASK

#define TILE_ROW_SET_MAPPING_3_row_set_mapping_15_ADDR32 19
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_15_SHAMT 30
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_15_MASK 0xc0000000
#define TILE_ROW_SET_MAPPING_3_row_set_mapping_15_RMW                                                  \
    TILE_ROW_SET_MAPPING_3_row_set_mapping_15_ADDR32, TILE_ROW_SET_MAPPING_3_row_set_mapping_15_SHAMT, \
        TILE_ROW_SET_MAPPING_3_row_set_mapping_15_MASK

#define PCK_EDGE_OFFSET_SEC0_mask_ADDR32 20
#define PCK_EDGE_OFFSET_SEC0_mask_SHAMT 0
#define PCK_EDGE_OFFSET_SEC0_mask_MASK 0xffff
#define PCK_EDGE_OFFSET_SEC0_mask_RMW \
    PCK_EDGE_OFFSET_SEC0_mask_ADDR32, PCK_EDGE_OFFSET_SEC0_mask_SHAMT, PCK_EDGE_OFFSET_SEC0_mask_MASK

#define PCK_EDGE_MODE_mode_ADDR32 20
#define PCK_EDGE_MODE_mode_SHAMT 16
#define PCK_EDGE_MODE_mode_MASK 0x10000
#define PCK_EDGE_MODE_mode_RMW PCK_EDGE_MODE_mode_ADDR32, PCK_EDGE_MODE_mode_SHAMT, PCK_EDGE_MODE_mode_MASK

#define PCK_EDGE_TILE_ROW_SET_SELECT_select_ADDR32 20
#define PCK_EDGE_TILE_ROW_SET_SELECT_select_SHAMT 17
#define PCK_EDGE_TILE_ROW_SET_SELECT_select_MASK 0x1fe0000
#define PCK_EDGE_TILE_ROW_SET_SELECT_select_RMW                                            \
    PCK_EDGE_TILE_ROW_SET_SELECT_select_ADDR32, PCK_EDGE_TILE_ROW_SET_SELECT_select_SHAMT, \
        PCK_EDGE_TILE_ROW_SET_SELECT_select_MASK

#define PCK_EDGE_OFFSET_SEC1_mask_ADDR32 21
#define PCK_EDGE_OFFSET_SEC1_mask_SHAMT 0
#define PCK_EDGE_OFFSET_SEC1_mask_MASK 0xffff
#define PCK_EDGE_OFFSET_SEC1_mask_RMW \
    PCK_EDGE_OFFSET_SEC1_mask_ADDR32, PCK_EDGE_OFFSET_SEC1_mask_SHAMT, PCK_EDGE_OFFSET_SEC1_mask_MASK

#define PCK_EDGE_OFFSET_SEC2_mask_ADDR32 22
#define PCK_EDGE_OFFSET_SEC2_mask_SHAMT 0
#define PCK_EDGE_OFFSET_SEC2_mask_MASK 0xffff
#define PCK_EDGE_OFFSET_SEC2_mask_RMW \
    PCK_EDGE_OFFSET_SEC2_mask_ADDR32, PCK_EDGE_OFFSET_SEC2_mask_SHAMT, PCK_EDGE_OFFSET_SEC2_mask_MASK

#define PCK_EDGE_OFFSET_SEC3_mask_ADDR32 23
#define PCK_EDGE_OFFSET_SEC3_mask_SHAMT 0
#define PCK_EDGE_OFFSET_SEC3_mask_MASK 0xffff
#define PCK_EDGE_OFFSET_SEC3_mask_RMW \
    PCK_EDGE_OFFSET_SEC3_mask_ADDR32, PCK_EDGE_OFFSET_SEC3_mask_SHAMT, PCK_EDGE_OFFSET_SEC3_mask_MASK

#define PACK_COUNTERS_SEC0_pack_per_xy_plane_ADDR32 24
#define PACK_COUNTERS_SEC0_pack_per_xy_plane_SHAMT 0
#define PACK_COUNTERS_SEC0_pack_per_xy_plane_MASK 0xff
#define PACK_COUNTERS_SEC0_pack_per_xy_plane_RMW                                             \
    PACK_COUNTERS_SEC0_pack_per_xy_plane_ADDR32, PACK_COUNTERS_SEC0_pack_per_xy_plane_SHAMT, \
        PACK_COUNTERS_SEC0_pack_per_xy_plane_MASK

#define PACK_COUNTERS_SEC0_pack_reads_per_xy_plane_ADDR32 24
#define PACK_COUNTERS_SEC0_pack_reads_per_xy_plane_SHAMT 8
#define PACK_COUNTERS_SEC0_pack_reads_per_xy_plane_MASK 0xff00
#define PACK_COUNTERS_SEC0_pack_reads_per_xy_plane_RMW                                                   \
    PACK_COUNTERS_SEC0_pack_reads_per_xy_plane_ADDR32, PACK_COUNTERS_SEC0_pack_reads_per_xy_plane_SHAMT, \
        PACK_COUNTERS_SEC0_pack_reads_per_xy_plane_MASK

#define PACK_COUNTERS_SEC0_pack_xys_per_tile_ADDR32 24
#define PACK_COUNTERS_SEC0_pack_xys_per_tile_SHAMT 16
#define PACK_COUNTERS_SEC0_pack_xys_per_tile_MASK 0x7f0000
#define PACK_COUNTERS_SEC0_pack_xys_per_tile_RMW                                             \
    PACK_COUNTERS_SEC0_pack_xys_per_tile_ADDR32, PACK_COUNTERS_SEC0_pack_xys_per_tile_SHAMT, \
        PACK_COUNTERS_SEC0_pack_xys_per_tile_MASK

#define PACK_COUNTERS_SEC0_pack_yz_transposed_ADDR32 24
#define PACK_COUNTERS_SEC0_pack_yz_transposed_SHAMT 23
#define PACK_COUNTERS_SEC0_pack_yz_transposed_MASK 0x800000
#define PACK_COUNTERS_SEC0_pack_yz_transposed_RMW                                              \
    PACK_COUNTERS_SEC0_pack_yz_transposed_ADDR32, PACK_COUNTERS_SEC0_pack_yz_transposed_SHAMT, \
        PACK_COUNTERS_SEC0_pack_yz_transposed_MASK

#define PACK_COUNTERS_SEC0_pack_per_xy_plane_offset_ADDR32 24
#define PACK_COUNTERS_SEC0_pack_per_xy_plane_offset_SHAMT 24
#define PACK_COUNTERS_SEC0_pack_per_xy_plane_offset_MASK 0xff000000
#define PACK_COUNTERS_SEC0_pack_per_xy_plane_offset_RMW                                                    \
    PACK_COUNTERS_SEC0_pack_per_xy_plane_offset_ADDR32, PACK_COUNTERS_SEC0_pack_per_xy_plane_offset_SHAMT, \
        PACK_COUNTERS_SEC0_pack_per_xy_plane_offset_MASK

#define PACK_COUNTERS_SEC1_pack_per_xy_plane_ADDR32 25
#define PACK_COUNTERS_SEC1_pack_per_xy_plane_SHAMT 0
#define PACK_COUNTERS_SEC1_pack_per_xy_plane_MASK 0xff
#define PACK_COUNTERS_SEC1_pack_per_xy_plane_RMW                                             \
    PACK_COUNTERS_SEC1_pack_per_xy_plane_ADDR32, PACK_COUNTERS_SEC1_pack_per_xy_plane_SHAMT, \
        PACK_COUNTERS_SEC1_pack_per_xy_plane_MASK

#define PACK_COUNTERS_SEC1_pack_reads_per_xy_plane_ADDR32 25
#define PACK_COUNTERS_SEC1_pack_reads_per_xy_plane_SHAMT 8
#define PACK_COUNTERS_SEC1_pack_reads_per_xy_plane_MASK 0xff00
#define PACK_COUNTERS_SEC1_pack_reads_per_xy_plane_RMW                                                   \
    PACK_COUNTERS_SEC1_pack_reads_per_xy_plane_ADDR32, PACK_COUNTERS_SEC1_pack_reads_per_xy_plane_SHAMT, \
        PACK_COUNTERS_SEC1_pack_reads_per_xy_plane_MASK

#define PACK_COUNTERS_SEC1_pack_xys_per_tile_ADDR32 25
#define PACK_COUNTERS_SEC1_pack_xys_per_tile_SHAMT 16
#define PACK_COUNTERS_SEC1_pack_xys_per_tile_MASK 0x7f0000
#define PACK_COUNTERS_SEC1_pack_xys_per_tile_RMW                                             \
    PACK_COUNTERS_SEC1_pack_xys_per_tile_ADDR32, PACK_COUNTERS_SEC1_pack_xys_per_tile_SHAMT, \
        PACK_COUNTERS_SEC1_pack_xys_per_tile_MASK

#define PACK_COUNTERS_SEC1_pack_yz_transposed_ADDR32 25
#define PACK_COUNTERS_SEC1_pack_yz_transposed_SHAMT 23
#define PACK_COUNTERS_SEC1_pack_yz_transposed_MASK 0x800000
#define PACK_COUNTERS_SEC1_pack_yz_transposed_RMW                                              \
    PACK_COUNTERS_SEC1_pack_yz_transposed_ADDR32, PACK_COUNTERS_SEC1_pack_yz_transposed_SHAMT, \
        PACK_COUNTERS_SEC1_pack_yz_transposed_MASK

#define PACK_COUNTERS_SEC1_pack_per_xy_plane_offset_ADDR32 25
#define PACK_COUNTERS_SEC1_pack_per_xy_plane_offset_SHAMT 24
#define PACK_COUNTERS_SEC1_pack_per_xy_plane_offset_MASK 0xff000000
#define PACK_COUNTERS_SEC1_pack_per_xy_plane_offset_RMW                                                    \
    PACK_COUNTERS_SEC1_pack_per_xy_plane_offset_ADDR32, PACK_COUNTERS_SEC1_pack_per_xy_plane_offset_SHAMT, \
        PACK_COUNTERS_SEC1_pack_per_xy_plane_offset_MASK

#define PACK_COUNTERS_SEC2_pack_per_xy_plane_ADDR32 26
#define PACK_COUNTERS_SEC2_pack_per_xy_plane_SHAMT 0
#define PACK_COUNTERS_SEC2_pack_per_xy_plane_MASK 0xff
#define PACK_COUNTERS_SEC2_pack_per_xy_plane_RMW                                             \
    PACK_COUNTERS_SEC2_pack_per_xy_plane_ADDR32, PACK_COUNTERS_SEC2_pack_per_xy_plane_SHAMT, \
        PACK_COUNTERS_SEC2_pack_per_xy_plane_MASK

#define PACK_COUNTERS_SEC2_pack_reads_per_xy_plane_ADDR32 26
#define PACK_COUNTERS_SEC2_pack_reads_per_xy_plane_SHAMT 8
#define PACK_COUNTERS_SEC2_pack_reads_per_xy_plane_MASK 0xff00
#define PACK_COUNTERS_SEC2_pack_reads_per_xy_plane_RMW                                                   \
    PACK_COUNTERS_SEC2_pack_reads_per_xy_plane_ADDR32, PACK_COUNTERS_SEC2_pack_reads_per_xy_plane_SHAMT, \
        PACK_COUNTERS_SEC2_pack_reads_per_xy_plane_MASK

#define PACK_COUNTERS_SEC2_pack_xys_per_tile_ADDR32 26
#define PACK_COUNTERS_SEC2_pack_xys_per_tile_SHAMT 16
#define PACK_COUNTERS_SEC2_pack_xys_per_tile_MASK 0x7f0000
#define PACK_COUNTERS_SEC2_pack_xys_per_tile_RMW                                             \
    PACK_COUNTERS_SEC2_pack_xys_per_tile_ADDR32, PACK_COUNTERS_SEC2_pack_xys_per_tile_SHAMT, \
        PACK_COUNTERS_SEC2_pack_xys_per_tile_MASK

#define PACK_COUNTERS_SEC2_pack_yz_transposed_ADDR32 26
#define PACK_COUNTERS_SEC2_pack_yz_transposed_SHAMT 23
#define PACK_COUNTERS_SEC2_pack_yz_transposed_MASK 0x800000
#define PACK_COUNTERS_SEC2_pack_yz_transposed_RMW                                              \
    PACK_COUNTERS_SEC2_pack_yz_transposed_ADDR32, PACK_COUNTERS_SEC2_pack_yz_transposed_SHAMT, \
        PACK_COUNTERS_SEC2_pack_yz_transposed_MASK

#define PACK_COUNTERS_SEC2_pack_per_xy_plane_offset_ADDR32 26
#define PACK_COUNTERS_SEC2_pack_per_xy_plane_offset_SHAMT 24
#define PACK_COUNTERS_SEC2_pack_per_xy_plane_offset_MASK 0xff000000
#define PACK_COUNTERS_SEC2_pack_per_xy_plane_offset_RMW                                                    \
    PACK_COUNTERS_SEC2_pack_per_xy_plane_offset_ADDR32, PACK_COUNTERS_SEC2_pack_per_xy_plane_offset_SHAMT, \
        PACK_COUNTERS_SEC2_pack_per_xy_plane_offset_MASK

#define PACK_COUNTERS_SEC3_pack_per_xy_plane_ADDR32 27
#define PACK_COUNTERS_SEC3_pack_per_xy_plane_SHAMT 0
#define PACK_COUNTERS_SEC3_pack_per_xy_plane_MASK 0xff
#define PACK_COUNTERS_SEC3_pack_per_xy_plane_RMW                                             \
    PACK_COUNTERS_SEC3_pack_per_xy_plane_ADDR32, PACK_COUNTERS_SEC3_pack_per_xy_plane_SHAMT, \
        PACK_COUNTERS_SEC3_pack_per_xy_plane_MASK

#define PACK_COUNTERS_SEC3_pack_reads_per_xy_plane_ADDR32 27
#define PACK_COUNTERS_SEC3_pack_reads_per_xy_plane_SHAMT 8
#define PACK_COUNTERS_SEC3_pack_reads_per_xy_plane_MASK 0xff00
#define PACK_COUNTERS_SEC3_pack_reads_per_xy_plane_RMW                                                   \
    PACK_COUNTERS_SEC3_pack_reads_per_xy_plane_ADDR32, PACK_COUNTERS_SEC3_pack_reads_per_xy_plane_SHAMT, \
        PACK_COUNTERS_SEC3_pack_reads_per_xy_plane_MASK

#define PACK_COUNTERS_SEC3_pack_xys_per_tile_ADDR32 27
#define PACK_COUNTERS_SEC3_pack_xys_per_tile_SHAMT 16
#define PACK_COUNTERS_SEC3_pack_xys_per_tile_MASK 0x7f0000
#define PACK_COUNTERS_SEC3_pack_xys_per_tile_RMW                                             \
    PACK_COUNTERS_SEC3_pack_xys_per_tile_ADDR32, PACK_COUNTERS_SEC3_pack_xys_per_tile_SHAMT, \
        PACK_COUNTERS_SEC3_pack_xys_per_tile_MASK

#define PACK_COUNTERS_SEC3_pack_yz_transposed_ADDR32 27
#define PACK_COUNTERS_SEC3_pack_yz_transposed_SHAMT 23
#define PACK_COUNTERS_SEC3_pack_yz_transposed_MASK 0x800000
#define PACK_COUNTERS_SEC3_pack_yz_transposed_RMW                                              \
    PACK_COUNTERS_SEC3_pack_yz_transposed_ADDR32, PACK_COUNTERS_SEC3_pack_yz_transposed_SHAMT, \
        PACK_COUNTERS_SEC3_pack_yz_transposed_MASK

#define PACK_COUNTERS_SEC3_pack_per_xy_plane_offset_ADDR32 27
#define PACK_COUNTERS_SEC3_pack_per_xy_plane_offset_SHAMT 24
#define PACK_COUNTERS_SEC3_pack_per_xy_plane_offset_MASK 0xff000000
#define PACK_COUNTERS_SEC3_pack_per_xy_plane_offset_RMW                                                    \
    PACK_COUNTERS_SEC3_pack_per_xy_plane_offset_ADDR32, PACK_COUNTERS_SEC3_pack_per_xy_plane_offset_SHAMT, \
        PACK_COUNTERS_SEC3_pack_per_xy_plane_offset_MASK

#define PACK_CONCAT_MASK_SEC0_pack_concat_mask_ADDR32 28
#define PACK_CONCAT_MASK_SEC0_pack_concat_mask_SHAMT 0
#define PACK_CONCAT_MASK_SEC0_pack_concat_mask_MASK 0xffff
#define PACK_CONCAT_MASK_SEC0_pack_concat_mask_RMW                                               \
    PACK_CONCAT_MASK_SEC0_pack_concat_mask_ADDR32, PACK_CONCAT_MASK_SEC0_pack_concat_mask_SHAMT, \
        PACK_CONCAT_MASK_SEC0_pack_concat_mask_MASK

#define PACK_CONCAT_MASK_SEC1_pack_concat_mask_ADDR32 29
#define PACK_CONCAT_MASK_SEC1_pack_concat_mask_SHAMT 0
#define PACK_CONCAT_MASK_SEC1_pack_concat_mask_MASK 0xffff
#define PACK_CONCAT_MASK_SEC1_pack_concat_mask_RMW                                               \
    PACK_CONCAT_MASK_SEC1_pack_concat_mask_ADDR32, PACK_CONCAT_MASK_SEC1_pack_concat_mask_SHAMT, \
        PACK_CONCAT_MASK_SEC1_pack_concat_mask_MASK

#define PACK_CONCAT_MASK_SEC2_pack_concat_mask_ADDR32 30
#define PACK_CONCAT_MASK_SEC2_pack_concat_mask_SHAMT 0
#define PACK_CONCAT_MASK_SEC2_pack_concat_mask_MASK 0xffff
#define PACK_CONCAT_MASK_SEC2_pack_concat_mask_RMW                                               \
    PACK_CONCAT_MASK_SEC2_pack_concat_mask_ADDR32, PACK_CONCAT_MASK_SEC2_pack_concat_mask_SHAMT, \
        PACK_CONCAT_MASK_SEC2_pack_concat_mask_MASK

#define PACK_CONCAT_MASK_SEC3_pack_concat_mask_ADDR32 31
#define PACK_CONCAT_MASK_SEC3_pack_concat_mask_SHAMT 0
#define PACK_CONCAT_MASK_SEC3_pack_concat_mask_MASK 0xffff
#define PACK_CONCAT_MASK_SEC3_pack_concat_mask_RMW                                               \
    PACK_CONCAT_MASK_SEC3_pack_concat_mask_ADDR32, PACK_CONCAT_MASK_SEC3_pack_concat_mask_SHAMT, \
        PACK_CONCAT_MASK_SEC3_pack_concat_mask_MASK

#define TILE_FACE_SET_MAPPING_0_face_set_mapping_0_ADDR32 32
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_0_SHAMT 0
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_0_MASK 0x3
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_0_RMW                                                   \
    TILE_FACE_SET_MAPPING_0_face_set_mapping_0_ADDR32, TILE_FACE_SET_MAPPING_0_face_set_mapping_0_SHAMT, \
        TILE_FACE_SET_MAPPING_0_face_set_mapping_0_MASK

#define TILE_FACE_SET_MAPPING_0_face_set_mapping_1_ADDR32 32
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_1_SHAMT 2
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_1_MASK 0xc
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_1_RMW                                                   \
    TILE_FACE_SET_MAPPING_0_face_set_mapping_1_ADDR32, TILE_FACE_SET_MAPPING_0_face_set_mapping_1_SHAMT, \
        TILE_FACE_SET_MAPPING_0_face_set_mapping_1_MASK

#define TILE_FACE_SET_MAPPING_0_face_set_mapping_2_ADDR32 32
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_2_SHAMT 4
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_2_MASK 0x30
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_2_RMW                                                   \
    TILE_FACE_SET_MAPPING_0_face_set_mapping_2_ADDR32, TILE_FACE_SET_MAPPING_0_face_set_mapping_2_SHAMT, \
        TILE_FACE_SET_MAPPING_0_face_set_mapping_2_MASK

#define TILE_FACE_SET_MAPPING_0_face_set_mapping_3_ADDR32 32
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_3_SHAMT 6
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_3_MASK 0xc0
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_3_RMW                                                   \
    TILE_FACE_SET_MAPPING_0_face_set_mapping_3_ADDR32, TILE_FACE_SET_MAPPING_0_face_set_mapping_3_SHAMT, \
        TILE_FACE_SET_MAPPING_0_face_set_mapping_3_MASK

#define TILE_FACE_SET_MAPPING_0_face_set_mapping_4_ADDR32 32
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_4_SHAMT 8
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_4_MASK 0x300
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_4_RMW                                                   \
    TILE_FACE_SET_MAPPING_0_face_set_mapping_4_ADDR32, TILE_FACE_SET_MAPPING_0_face_set_mapping_4_SHAMT, \
        TILE_FACE_SET_MAPPING_0_face_set_mapping_4_MASK

#define TILE_FACE_SET_MAPPING_0_face_set_mapping_5_ADDR32 32
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_5_SHAMT 10
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_5_MASK 0xc00
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_5_RMW                                                   \
    TILE_FACE_SET_MAPPING_0_face_set_mapping_5_ADDR32, TILE_FACE_SET_MAPPING_0_face_set_mapping_5_SHAMT, \
        TILE_FACE_SET_MAPPING_0_face_set_mapping_5_MASK

#define TILE_FACE_SET_MAPPING_0_face_set_mapping_6_ADDR32 32
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_6_SHAMT 12
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_6_MASK 0x3000
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_6_RMW                                                   \
    TILE_FACE_SET_MAPPING_0_face_set_mapping_6_ADDR32, TILE_FACE_SET_MAPPING_0_face_set_mapping_6_SHAMT, \
        TILE_FACE_SET_MAPPING_0_face_set_mapping_6_MASK

#define TILE_FACE_SET_MAPPING_0_face_set_mapping_7_ADDR32 32
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_7_SHAMT 14
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_7_MASK 0xc000
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_7_RMW                                                   \
    TILE_FACE_SET_MAPPING_0_face_set_mapping_7_ADDR32, TILE_FACE_SET_MAPPING_0_face_set_mapping_7_SHAMT, \
        TILE_FACE_SET_MAPPING_0_face_set_mapping_7_MASK

#define TILE_FACE_SET_MAPPING_0_face_set_mapping_8_ADDR32 32
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_8_SHAMT 16
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_8_MASK 0x30000
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_8_RMW                                                   \
    TILE_FACE_SET_MAPPING_0_face_set_mapping_8_ADDR32, TILE_FACE_SET_MAPPING_0_face_set_mapping_8_SHAMT, \
        TILE_FACE_SET_MAPPING_0_face_set_mapping_8_MASK

#define TILE_FACE_SET_MAPPING_0_face_set_mapping_9_ADDR32 32
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_9_SHAMT 18
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_9_MASK 0xc0000
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_9_RMW                                                   \
    TILE_FACE_SET_MAPPING_0_face_set_mapping_9_ADDR32, TILE_FACE_SET_MAPPING_0_face_set_mapping_9_SHAMT, \
        TILE_FACE_SET_MAPPING_0_face_set_mapping_9_MASK

#define TILE_FACE_SET_MAPPING_0_face_set_mapping_10_ADDR32 32
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_10_SHAMT 20
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_10_MASK 0x300000
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_10_RMW                                                    \
    TILE_FACE_SET_MAPPING_0_face_set_mapping_10_ADDR32, TILE_FACE_SET_MAPPING_0_face_set_mapping_10_SHAMT, \
        TILE_FACE_SET_MAPPING_0_face_set_mapping_10_MASK

#define TILE_FACE_SET_MAPPING_0_face_set_mapping_11_ADDR32 32
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_11_SHAMT 22
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_11_MASK 0xc00000
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_11_RMW                                                    \
    TILE_FACE_SET_MAPPING_0_face_set_mapping_11_ADDR32, TILE_FACE_SET_MAPPING_0_face_set_mapping_11_SHAMT, \
        TILE_FACE_SET_MAPPING_0_face_set_mapping_11_MASK

#define TILE_FACE_SET_MAPPING_0_face_set_mapping_12_ADDR32 32
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_12_SHAMT 24
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_12_MASK 0x3000000
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_12_RMW                                                    \
    TILE_FACE_SET_MAPPING_0_face_set_mapping_12_ADDR32, TILE_FACE_SET_MAPPING_0_face_set_mapping_12_SHAMT, \
        TILE_FACE_SET_MAPPING_0_face_set_mapping_12_MASK

#define TILE_FACE_SET_MAPPING_0_face_set_mapping_13_ADDR32 32
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_13_SHAMT 26
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_13_MASK 0xc000000
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_13_RMW                                                    \
    TILE_FACE_SET_MAPPING_0_face_set_mapping_13_ADDR32, TILE_FACE_SET_MAPPING_0_face_set_mapping_13_SHAMT, \
        TILE_FACE_SET_MAPPING_0_face_set_mapping_13_MASK

#define TILE_FACE_SET_MAPPING_0_face_set_mapping_14_ADDR32 32
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_14_SHAMT 28
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_14_MASK 0x30000000
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_14_RMW                                                    \
    TILE_FACE_SET_MAPPING_0_face_set_mapping_14_ADDR32, TILE_FACE_SET_MAPPING_0_face_set_mapping_14_SHAMT, \
        TILE_FACE_SET_MAPPING_0_face_set_mapping_14_MASK

#define TILE_FACE_SET_MAPPING_0_face_set_mapping_15_ADDR32 32
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_15_SHAMT 30
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_15_MASK 0xc0000000
#define TILE_FACE_SET_MAPPING_0_face_set_mapping_15_RMW                                                    \
    TILE_FACE_SET_MAPPING_0_face_set_mapping_15_ADDR32, TILE_FACE_SET_MAPPING_0_face_set_mapping_15_SHAMT, \
        TILE_FACE_SET_MAPPING_0_face_set_mapping_15_MASK

#define TILE_FACE_SET_MAPPING_1_face_set_mapping_0_ADDR32 33
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_0_SHAMT 0
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_0_MASK 0x3
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_0_RMW                                                   \
    TILE_FACE_SET_MAPPING_1_face_set_mapping_0_ADDR32, TILE_FACE_SET_MAPPING_1_face_set_mapping_0_SHAMT, \
        TILE_FACE_SET_MAPPING_1_face_set_mapping_0_MASK

#define TILE_FACE_SET_MAPPING_1_face_set_mapping_1_ADDR32 33
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_1_SHAMT 2
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_1_MASK 0xc
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_1_RMW                                                   \
    TILE_FACE_SET_MAPPING_1_face_set_mapping_1_ADDR32, TILE_FACE_SET_MAPPING_1_face_set_mapping_1_SHAMT, \
        TILE_FACE_SET_MAPPING_1_face_set_mapping_1_MASK

#define TILE_FACE_SET_MAPPING_1_face_set_mapping_2_ADDR32 33
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_2_SHAMT 4
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_2_MASK 0x30
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_2_RMW                                                   \
    TILE_FACE_SET_MAPPING_1_face_set_mapping_2_ADDR32, TILE_FACE_SET_MAPPING_1_face_set_mapping_2_SHAMT, \
        TILE_FACE_SET_MAPPING_1_face_set_mapping_2_MASK

#define TILE_FACE_SET_MAPPING_1_face_set_mapping_3_ADDR32 33
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_3_SHAMT 6
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_3_MASK 0xc0
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_3_RMW                                                   \
    TILE_FACE_SET_MAPPING_1_face_set_mapping_3_ADDR32, TILE_FACE_SET_MAPPING_1_face_set_mapping_3_SHAMT, \
        TILE_FACE_SET_MAPPING_1_face_set_mapping_3_MASK

#define TILE_FACE_SET_MAPPING_1_face_set_mapping_4_ADDR32 33
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_4_SHAMT 8
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_4_MASK 0x300
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_4_RMW                                                   \
    TILE_FACE_SET_MAPPING_1_face_set_mapping_4_ADDR32, TILE_FACE_SET_MAPPING_1_face_set_mapping_4_SHAMT, \
        TILE_FACE_SET_MAPPING_1_face_set_mapping_4_MASK

#define TILE_FACE_SET_MAPPING_1_face_set_mapping_5_ADDR32 33
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_5_SHAMT 10
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_5_MASK 0xc00
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_5_RMW                                                   \
    TILE_FACE_SET_MAPPING_1_face_set_mapping_5_ADDR32, TILE_FACE_SET_MAPPING_1_face_set_mapping_5_SHAMT, \
        TILE_FACE_SET_MAPPING_1_face_set_mapping_5_MASK

#define TILE_FACE_SET_MAPPING_1_face_set_mapping_6_ADDR32 33
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_6_SHAMT 12
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_6_MASK 0x3000
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_6_RMW                                                   \
    TILE_FACE_SET_MAPPING_1_face_set_mapping_6_ADDR32, TILE_FACE_SET_MAPPING_1_face_set_mapping_6_SHAMT, \
        TILE_FACE_SET_MAPPING_1_face_set_mapping_6_MASK

#define TILE_FACE_SET_MAPPING_1_face_set_mapping_7_ADDR32 33
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_7_SHAMT 14
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_7_MASK 0xc000
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_7_RMW                                                   \
    TILE_FACE_SET_MAPPING_1_face_set_mapping_7_ADDR32, TILE_FACE_SET_MAPPING_1_face_set_mapping_7_SHAMT, \
        TILE_FACE_SET_MAPPING_1_face_set_mapping_7_MASK

#define TILE_FACE_SET_MAPPING_1_face_set_mapping_8_ADDR32 33
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_8_SHAMT 16
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_8_MASK 0x30000
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_8_RMW                                                   \
    TILE_FACE_SET_MAPPING_1_face_set_mapping_8_ADDR32, TILE_FACE_SET_MAPPING_1_face_set_mapping_8_SHAMT, \
        TILE_FACE_SET_MAPPING_1_face_set_mapping_8_MASK

#define TILE_FACE_SET_MAPPING_1_face_set_mapping_9_ADDR32 33
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_9_SHAMT 18
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_9_MASK 0xc0000
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_9_RMW                                                   \
    TILE_FACE_SET_MAPPING_1_face_set_mapping_9_ADDR32, TILE_FACE_SET_MAPPING_1_face_set_mapping_9_SHAMT, \
        TILE_FACE_SET_MAPPING_1_face_set_mapping_9_MASK

#define TILE_FACE_SET_MAPPING_1_face_set_mapping_10_ADDR32 33
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_10_SHAMT 20
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_10_MASK 0x300000
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_10_RMW                                                    \
    TILE_FACE_SET_MAPPING_1_face_set_mapping_10_ADDR32, TILE_FACE_SET_MAPPING_1_face_set_mapping_10_SHAMT, \
        TILE_FACE_SET_MAPPING_1_face_set_mapping_10_MASK

#define TILE_FACE_SET_MAPPING_1_face_set_mapping_11_ADDR32 33
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_11_SHAMT 22
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_11_MASK 0xc00000
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_11_RMW                                                    \
    TILE_FACE_SET_MAPPING_1_face_set_mapping_11_ADDR32, TILE_FACE_SET_MAPPING_1_face_set_mapping_11_SHAMT, \
        TILE_FACE_SET_MAPPING_1_face_set_mapping_11_MASK

#define TILE_FACE_SET_MAPPING_1_face_set_mapping_12_ADDR32 33
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_12_SHAMT 24
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_12_MASK 0x3000000
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_12_RMW                                                    \
    TILE_FACE_SET_MAPPING_1_face_set_mapping_12_ADDR32, TILE_FACE_SET_MAPPING_1_face_set_mapping_12_SHAMT, \
        TILE_FACE_SET_MAPPING_1_face_set_mapping_12_MASK

#define TILE_FACE_SET_MAPPING_1_face_set_mapping_13_ADDR32 33
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_13_SHAMT 26
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_13_MASK 0xc000000
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_13_RMW                                                    \
    TILE_FACE_SET_MAPPING_1_face_set_mapping_13_ADDR32, TILE_FACE_SET_MAPPING_1_face_set_mapping_13_SHAMT, \
        TILE_FACE_SET_MAPPING_1_face_set_mapping_13_MASK

#define TILE_FACE_SET_MAPPING_1_face_set_mapping_14_ADDR32 33
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_14_SHAMT 28
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_14_MASK 0x30000000
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_14_RMW                                                    \
    TILE_FACE_SET_MAPPING_1_face_set_mapping_14_ADDR32, TILE_FACE_SET_MAPPING_1_face_set_mapping_14_SHAMT, \
        TILE_FACE_SET_MAPPING_1_face_set_mapping_14_MASK

#define TILE_FACE_SET_MAPPING_1_face_set_mapping_15_ADDR32 33
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_15_SHAMT 30
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_15_MASK 0xc0000000
#define TILE_FACE_SET_MAPPING_1_face_set_mapping_15_RMW                                                    \
    TILE_FACE_SET_MAPPING_1_face_set_mapping_15_ADDR32, TILE_FACE_SET_MAPPING_1_face_set_mapping_15_SHAMT, \
        TILE_FACE_SET_MAPPING_1_face_set_mapping_15_MASK

#define TILE_FACE_SET_MAPPING_2_face_set_mapping_0_ADDR32 34
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_0_SHAMT 0
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_0_MASK 0x3
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_0_RMW                                                   \
    TILE_FACE_SET_MAPPING_2_face_set_mapping_0_ADDR32, TILE_FACE_SET_MAPPING_2_face_set_mapping_0_SHAMT, \
        TILE_FACE_SET_MAPPING_2_face_set_mapping_0_MASK

#define TILE_FACE_SET_MAPPING_2_face_set_mapping_1_ADDR32 34
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_1_SHAMT 2
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_1_MASK 0xc
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_1_RMW                                                   \
    TILE_FACE_SET_MAPPING_2_face_set_mapping_1_ADDR32, TILE_FACE_SET_MAPPING_2_face_set_mapping_1_SHAMT, \
        TILE_FACE_SET_MAPPING_2_face_set_mapping_1_MASK

#define TILE_FACE_SET_MAPPING_2_face_set_mapping_2_ADDR32 34
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_2_SHAMT 4
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_2_MASK 0x30
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_2_RMW                                                   \
    TILE_FACE_SET_MAPPING_2_face_set_mapping_2_ADDR32, TILE_FACE_SET_MAPPING_2_face_set_mapping_2_SHAMT, \
        TILE_FACE_SET_MAPPING_2_face_set_mapping_2_MASK

#define TILE_FACE_SET_MAPPING_2_face_set_mapping_3_ADDR32 34
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_3_SHAMT 6
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_3_MASK 0xc0
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_3_RMW                                                   \
    TILE_FACE_SET_MAPPING_2_face_set_mapping_3_ADDR32, TILE_FACE_SET_MAPPING_2_face_set_mapping_3_SHAMT, \
        TILE_FACE_SET_MAPPING_2_face_set_mapping_3_MASK

#define TILE_FACE_SET_MAPPING_2_face_set_mapping_4_ADDR32 34
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_4_SHAMT 8
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_4_MASK 0x300
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_4_RMW                                                   \
    TILE_FACE_SET_MAPPING_2_face_set_mapping_4_ADDR32, TILE_FACE_SET_MAPPING_2_face_set_mapping_4_SHAMT, \
        TILE_FACE_SET_MAPPING_2_face_set_mapping_4_MASK

#define TILE_FACE_SET_MAPPING_2_face_set_mapping_5_ADDR32 34
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_5_SHAMT 10
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_5_MASK 0xc00
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_5_RMW                                                   \
    TILE_FACE_SET_MAPPING_2_face_set_mapping_5_ADDR32, TILE_FACE_SET_MAPPING_2_face_set_mapping_5_SHAMT, \
        TILE_FACE_SET_MAPPING_2_face_set_mapping_5_MASK

#define TILE_FACE_SET_MAPPING_2_face_set_mapping_6_ADDR32 34
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_6_SHAMT 12
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_6_MASK 0x3000
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_6_RMW                                                   \
    TILE_FACE_SET_MAPPING_2_face_set_mapping_6_ADDR32, TILE_FACE_SET_MAPPING_2_face_set_mapping_6_SHAMT, \
        TILE_FACE_SET_MAPPING_2_face_set_mapping_6_MASK

#define TILE_FACE_SET_MAPPING_2_face_set_mapping_7_ADDR32 34
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_7_SHAMT 14
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_7_MASK 0xc000
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_7_RMW                                                   \
    TILE_FACE_SET_MAPPING_2_face_set_mapping_7_ADDR32, TILE_FACE_SET_MAPPING_2_face_set_mapping_7_SHAMT, \
        TILE_FACE_SET_MAPPING_2_face_set_mapping_7_MASK

#define TILE_FACE_SET_MAPPING_2_face_set_mapping_8_ADDR32 34
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_8_SHAMT 16
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_8_MASK 0x30000
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_8_RMW                                                   \
    TILE_FACE_SET_MAPPING_2_face_set_mapping_8_ADDR32, TILE_FACE_SET_MAPPING_2_face_set_mapping_8_SHAMT, \
        TILE_FACE_SET_MAPPING_2_face_set_mapping_8_MASK

#define TILE_FACE_SET_MAPPING_2_face_set_mapping_9_ADDR32 34
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_9_SHAMT 18
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_9_MASK 0xc0000
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_9_RMW                                                   \
    TILE_FACE_SET_MAPPING_2_face_set_mapping_9_ADDR32, TILE_FACE_SET_MAPPING_2_face_set_mapping_9_SHAMT, \
        TILE_FACE_SET_MAPPING_2_face_set_mapping_9_MASK

#define TILE_FACE_SET_MAPPING_2_face_set_mapping_10_ADDR32 34
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_10_SHAMT 20
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_10_MASK 0x300000
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_10_RMW                                                    \
    TILE_FACE_SET_MAPPING_2_face_set_mapping_10_ADDR32, TILE_FACE_SET_MAPPING_2_face_set_mapping_10_SHAMT, \
        TILE_FACE_SET_MAPPING_2_face_set_mapping_10_MASK

#define TILE_FACE_SET_MAPPING_2_face_set_mapping_11_ADDR32 34
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_11_SHAMT 22
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_11_MASK 0xc00000
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_11_RMW                                                    \
    TILE_FACE_SET_MAPPING_2_face_set_mapping_11_ADDR32, TILE_FACE_SET_MAPPING_2_face_set_mapping_11_SHAMT, \
        TILE_FACE_SET_MAPPING_2_face_set_mapping_11_MASK

#define TILE_FACE_SET_MAPPING_2_face_set_mapping_12_ADDR32 34
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_12_SHAMT 24
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_12_MASK 0x3000000
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_12_RMW                                                    \
    TILE_FACE_SET_MAPPING_2_face_set_mapping_12_ADDR32, TILE_FACE_SET_MAPPING_2_face_set_mapping_12_SHAMT, \
        TILE_FACE_SET_MAPPING_2_face_set_mapping_12_MASK

#define TILE_FACE_SET_MAPPING_2_face_set_mapping_13_ADDR32 34
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_13_SHAMT 26
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_13_MASK 0xc000000
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_13_RMW                                                    \
    TILE_FACE_SET_MAPPING_2_face_set_mapping_13_ADDR32, TILE_FACE_SET_MAPPING_2_face_set_mapping_13_SHAMT, \
        TILE_FACE_SET_MAPPING_2_face_set_mapping_13_MASK

#define TILE_FACE_SET_MAPPING_2_face_set_mapping_14_ADDR32 34
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_14_SHAMT 28
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_14_MASK 0x30000000
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_14_RMW                                                    \
    TILE_FACE_SET_MAPPING_2_face_set_mapping_14_ADDR32, TILE_FACE_SET_MAPPING_2_face_set_mapping_14_SHAMT, \
        TILE_FACE_SET_MAPPING_2_face_set_mapping_14_MASK

#define TILE_FACE_SET_MAPPING_2_face_set_mapping_15_ADDR32 34
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_15_SHAMT 30
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_15_MASK 0xc0000000
#define TILE_FACE_SET_MAPPING_2_face_set_mapping_15_RMW                                                    \
    TILE_FACE_SET_MAPPING_2_face_set_mapping_15_ADDR32, TILE_FACE_SET_MAPPING_2_face_set_mapping_15_SHAMT, \
        TILE_FACE_SET_MAPPING_2_face_set_mapping_15_MASK

#define TILE_FACE_SET_MAPPING_3_face_set_mapping_0_ADDR32 35
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_0_SHAMT 0
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_0_MASK 0x3
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_0_RMW                                                   \
    TILE_FACE_SET_MAPPING_3_face_set_mapping_0_ADDR32, TILE_FACE_SET_MAPPING_3_face_set_mapping_0_SHAMT, \
        TILE_FACE_SET_MAPPING_3_face_set_mapping_0_MASK

#define TILE_FACE_SET_MAPPING_3_face_set_mapping_1_ADDR32 35
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_1_SHAMT 2
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_1_MASK 0xc
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_1_RMW                                                   \
    TILE_FACE_SET_MAPPING_3_face_set_mapping_1_ADDR32, TILE_FACE_SET_MAPPING_3_face_set_mapping_1_SHAMT, \
        TILE_FACE_SET_MAPPING_3_face_set_mapping_1_MASK

#define TILE_FACE_SET_MAPPING_3_face_set_mapping_2_ADDR32 35
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_2_SHAMT 4
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_2_MASK 0x30
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_2_RMW                                                   \
    TILE_FACE_SET_MAPPING_3_face_set_mapping_2_ADDR32, TILE_FACE_SET_MAPPING_3_face_set_mapping_2_SHAMT, \
        TILE_FACE_SET_MAPPING_3_face_set_mapping_2_MASK

#define TILE_FACE_SET_MAPPING_3_face_set_mapping_3_ADDR32 35
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_3_SHAMT 6
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_3_MASK 0xc0
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_3_RMW                                                   \
    TILE_FACE_SET_MAPPING_3_face_set_mapping_3_ADDR32, TILE_FACE_SET_MAPPING_3_face_set_mapping_3_SHAMT, \
        TILE_FACE_SET_MAPPING_3_face_set_mapping_3_MASK

#define TILE_FACE_SET_MAPPING_3_face_set_mapping_4_ADDR32 35
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_4_SHAMT 8
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_4_MASK 0x300
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_4_RMW                                                   \
    TILE_FACE_SET_MAPPING_3_face_set_mapping_4_ADDR32, TILE_FACE_SET_MAPPING_3_face_set_mapping_4_SHAMT, \
        TILE_FACE_SET_MAPPING_3_face_set_mapping_4_MASK

#define TILE_FACE_SET_MAPPING_3_face_set_mapping_5_ADDR32 35
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_5_SHAMT 10
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_5_MASK 0xc00
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_5_RMW                                                   \
    TILE_FACE_SET_MAPPING_3_face_set_mapping_5_ADDR32, TILE_FACE_SET_MAPPING_3_face_set_mapping_5_SHAMT, \
        TILE_FACE_SET_MAPPING_3_face_set_mapping_5_MASK

#define TILE_FACE_SET_MAPPING_3_face_set_mapping_6_ADDR32 35
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_6_SHAMT 12
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_6_MASK 0x3000
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_6_RMW                                                   \
    TILE_FACE_SET_MAPPING_3_face_set_mapping_6_ADDR32, TILE_FACE_SET_MAPPING_3_face_set_mapping_6_SHAMT, \
        TILE_FACE_SET_MAPPING_3_face_set_mapping_6_MASK

#define TILE_FACE_SET_MAPPING_3_face_set_mapping_7_ADDR32 35
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_7_SHAMT 14
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_7_MASK 0xc000
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_7_RMW                                                   \
    TILE_FACE_SET_MAPPING_3_face_set_mapping_7_ADDR32, TILE_FACE_SET_MAPPING_3_face_set_mapping_7_SHAMT, \
        TILE_FACE_SET_MAPPING_3_face_set_mapping_7_MASK

#define TILE_FACE_SET_MAPPING_3_face_set_mapping_8_ADDR32 35
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_8_SHAMT 16
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_8_MASK 0x30000
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_8_RMW                                                   \
    TILE_FACE_SET_MAPPING_3_face_set_mapping_8_ADDR32, TILE_FACE_SET_MAPPING_3_face_set_mapping_8_SHAMT, \
        TILE_FACE_SET_MAPPING_3_face_set_mapping_8_MASK

#define TILE_FACE_SET_MAPPING_3_face_set_mapping_9_ADDR32 35
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_9_SHAMT 18
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_9_MASK 0xc0000
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_9_RMW                                                   \
    TILE_FACE_SET_MAPPING_3_face_set_mapping_9_ADDR32, TILE_FACE_SET_MAPPING_3_face_set_mapping_9_SHAMT, \
        TILE_FACE_SET_MAPPING_3_face_set_mapping_9_MASK

#define TILE_FACE_SET_MAPPING_3_face_set_mapping_10_ADDR32 35
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_10_SHAMT 20
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_10_MASK 0x300000
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_10_RMW                                                    \
    TILE_FACE_SET_MAPPING_3_face_set_mapping_10_ADDR32, TILE_FACE_SET_MAPPING_3_face_set_mapping_10_SHAMT, \
        TILE_FACE_SET_MAPPING_3_face_set_mapping_10_MASK

#define TILE_FACE_SET_MAPPING_3_face_set_mapping_11_ADDR32 35
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_11_SHAMT 22
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_11_MASK 0xc00000
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_11_RMW                                                    \
    TILE_FACE_SET_MAPPING_3_face_set_mapping_11_ADDR32, TILE_FACE_SET_MAPPING_3_face_set_mapping_11_SHAMT, \
        TILE_FACE_SET_MAPPING_3_face_set_mapping_11_MASK

#define TILE_FACE_SET_MAPPING_3_face_set_mapping_12_ADDR32 35
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_12_SHAMT 24
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_12_MASK 0x3000000
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_12_RMW                                                    \
    TILE_FACE_SET_MAPPING_3_face_set_mapping_12_ADDR32, TILE_FACE_SET_MAPPING_3_face_set_mapping_12_SHAMT, \
        TILE_FACE_SET_MAPPING_3_face_set_mapping_12_MASK

#define TILE_FACE_SET_MAPPING_3_face_set_mapping_13_ADDR32 35
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_13_SHAMT 26
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_13_MASK 0xc000000
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_13_RMW                                                    \
    TILE_FACE_SET_MAPPING_3_face_set_mapping_13_ADDR32, TILE_FACE_SET_MAPPING_3_face_set_mapping_13_SHAMT, \
        TILE_FACE_SET_MAPPING_3_face_set_mapping_13_MASK

#define TILE_FACE_SET_MAPPING_3_face_set_mapping_14_ADDR32 35
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_14_SHAMT 28
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_14_MASK 0x30000000
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_14_RMW                                                    \
    TILE_FACE_SET_MAPPING_3_face_set_mapping_14_ADDR32, TILE_FACE_SET_MAPPING_3_face_set_mapping_14_SHAMT, \
        TILE_FACE_SET_MAPPING_3_face_set_mapping_14_MASK

#define TILE_FACE_SET_MAPPING_3_face_set_mapping_15_ADDR32 35
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_15_SHAMT 30
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_15_MASK 0xc0000000
#define TILE_FACE_SET_MAPPING_3_face_set_mapping_15_RMW                                                    \
    TILE_FACE_SET_MAPPING_3_face_set_mapping_15_ADDR32, TILE_FACE_SET_MAPPING_3_face_set_mapping_15_SHAMT, \
        TILE_FACE_SET_MAPPING_3_face_set_mapping_15_MASK

////////////////////////////////////////////////////////////////////////
// Registers for UNPACK0
////////////////////////////////////////////////////////////////////////

#define UNPACK0_CFGREG_BASE_ADDR32 36

#define UNP0_ADDR_CTRL_XY_REG_0_Xstride_ADDR32 36
#define UNP0_ADDR_CTRL_XY_REG_0_Xstride_SHAMT 0
#define UNP0_ADDR_CTRL_XY_REG_0_Xstride_MASK 0xfff
#define UNP0_ADDR_CTRL_XY_REG_0_Xstride_RMW \
    UNP0_ADDR_CTRL_XY_REG_0_Xstride_ADDR32, UNP0_ADDR_CTRL_XY_REG_0_Xstride_SHAMT, UNP0_ADDR_CTRL_XY_REG_0_Xstride_MASK

#define UNP0_ADDR_CTRL_XY_REG_0_Ystride_ADDR32 36
#define UNP0_ADDR_CTRL_XY_REG_0_Ystride_SHAMT 12
#define UNP0_ADDR_CTRL_XY_REG_0_Ystride_MASK 0xfff000
#define UNP0_ADDR_CTRL_XY_REG_0_Ystride_RMW \
    UNP0_ADDR_CTRL_XY_REG_0_Ystride_ADDR32, UNP0_ADDR_CTRL_XY_REG_0_Ystride_SHAMT, UNP0_ADDR_CTRL_XY_REG_0_Ystride_MASK

#define UNP0_ADDR_CTRL_ZW_REG_0_Zstride_ADDR32 37
#define UNP0_ADDR_CTRL_ZW_REG_0_Zstride_SHAMT 0
#define UNP0_ADDR_CTRL_ZW_REG_0_Zstride_MASK 0xfff
#define UNP0_ADDR_CTRL_ZW_REG_0_Zstride_RMW \
    UNP0_ADDR_CTRL_ZW_REG_0_Zstride_ADDR32, UNP0_ADDR_CTRL_ZW_REG_0_Zstride_SHAMT, UNP0_ADDR_CTRL_ZW_REG_0_Zstride_MASK

#define UNP0_ADDR_CTRL_ZW_REG_0_Wstride_ADDR32 37
#define UNP0_ADDR_CTRL_ZW_REG_0_Wstride_SHAMT 12
#define UNP0_ADDR_CTRL_ZW_REG_0_Wstride_MASK 0xffff000
#define UNP0_ADDR_CTRL_ZW_REG_0_Wstride_RMW \
    UNP0_ADDR_CTRL_ZW_REG_0_Wstride_ADDR32, UNP0_ADDR_CTRL_ZW_REG_0_Wstride_SHAMT, UNP0_ADDR_CTRL_ZW_REG_0_Wstride_MASK

#define UNP1_ADDR_CTRL_XY_REG_0_Xstride_ADDR32 38
#define UNP1_ADDR_CTRL_XY_REG_0_Xstride_SHAMT 0
#define UNP1_ADDR_CTRL_XY_REG_0_Xstride_MASK 0xfff
#define UNP1_ADDR_CTRL_XY_REG_0_Xstride_RMW \
    UNP1_ADDR_CTRL_XY_REG_0_Xstride_ADDR32, UNP1_ADDR_CTRL_XY_REG_0_Xstride_SHAMT, UNP1_ADDR_CTRL_XY_REG_0_Xstride_MASK

#define UNP1_ADDR_CTRL_XY_REG_0_Ystride_ADDR32 38
#define UNP1_ADDR_CTRL_XY_REG_0_Ystride_SHAMT 12
#define UNP1_ADDR_CTRL_XY_REG_0_Ystride_MASK 0xfff000
#define UNP1_ADDR_CTRL_XY_REG_0_Ystride_RMW \
    UNP1_ADDR_CTRL_XY_REG_0_Ystride_ADDR32, UNP1_ADDR_CTRL_XY_REG_0_Ystride_SHAMT, UNP1_ADDR_CTRL_XY_REG_0_Ystride_MASK

#define UNP1_ADDR_CTRL_ZW_REG_0_Zstride_ADDR32 39
#define UNP1_ADDR_CTRL_ZW_REG_0_Zstride_SHAMT 0
#define UNP1_ADDR_CTRL_ZW_REG_0_Zstride_MASK 0xfff
#define UNP1_ADDR_CTRL_ZW_REG_0_Zstride_RMW \
    UNP1_ADDR_CTRL_ZW_REG_0_Zstride_ADDR32, UNP1_ADDR_CTRL_ZW_REG_0_Zstride_SHAMT, UNP1_ADDR_CTRL_ZW_REG_0_Zstride_MASK

#define UNP1_ADDR_CTRL_ZW_REG_0_Wstride_ADDR32 39
#define UNP1_ADDR_CTRL_ZW_REG_0_Wstride_SHAMT 12
#define UNP1_ADDR_CTRL_ZW_REG_0_Wstride_MASK 0xffff000
#define UNP1_ADDR_CTRL_ZW_REG_0_Wstride_RMW \
    UNP1_ADDR_CTRL_ZW_REG_0_Wstride_ADDR32, UNP1_ADDR_CTRL_ZW_REG_0_Wstride_SHAMT, UNP1_ADDR_CTRL_ZW_REG_0_Wstride_MASK

#define UNP0_ADDR_BASE_REG_0_Base_ADDR32 40
#define UNP0_ADDR_BASE_REG_0_Base_SHAMT 0
#define UNP0_ADDR_BASE_REG_0_Base_MASK 0xffff
#define UNP0_ADDR_BASE_REG_0_Base_RMW \
    UNP0_ADDR_BASE_REG_0_Base_ADDR32, UNP0_ADDR_BASE_REG_0_Base_SHAMT, UNP0_ADDR_BASE_REG_0_Base_MASK

#define UNP0_ADDR_BASE_REG_1_Base_ADDR32 40
#define UNP0_ADDR_BASE_REG_1_Base_SHAMT 16
#define UNP0_ADDR_BASE_REG_1_Base_MASK 0xffff0000
#define UNP0_ADDR_BASE_REG_1_Base_RMW \
    UNP0_ADDR_BASE_REG_1_Base_ADDR32, UNP0_ADDR_BASE_REG_1_Base_SHAMT, UNP0_ADDR_BASE_REG_1_Base_MASK

#define UNP0_FORCED_SHARED_EXP_shared_exp_ADDR32 41
#define UNP0_FORCED_SHARED_EXP_shared_exp_SHAMT 0
#define UNP0_FORCED_SHARED_EXP_shared_exp_MASK 0xff
#define UNP0_FORCED_SHARED_EXP_shared_exp_RMW                                          \
    UNP0_FORCED_SHARED_EXP_shared_exp_ADDR32, UNP0_FORCED_SHARED_EXP_shared_exp_SHAMT, \
        UNP0_FORCED_SHARED_EXP_shared_exp_MASK

#define UNP0_ADD_DEST_ADDR_CNTR_add_dest_addr_cntr_ADDR32 41
#define UNP0_ADD_DEST_ADDR_CNTR_add_dest_addr_cntr_SHAMT 8
#define UNP0_ADD_DEST_ADDR_CNTR_add_dest_addr_cntr_MASK 0x100
#define UNP0_ADD_DEST_ADDR_CNTR_add_dest_addr_cntr_RMW                                                   \
    UNP0_ADD_DEST_ADDR_CNTR_add_dest_addr_cntr_ADDR32, UNP0_ADD_DEST_ADDR_CNTR_add_dest_addr_cntr_SHAMT, \
        UNP0_ADD_DEST_ADDR_CNTR_add_dest_addr_cntr_MASK

#define UNP0_BLOBS_Y_START_CNTX_01_blobs_y_start_ADDR32 42
#define UNP0_BLOBS_Y_START_CNTX_01_blobs_y_start_SHAMT 0
#define UNP0_BLOBS_Y_START_CNTX_01_blobs_y_start_MASK 0xffffffff
#define UNP0_BLOBS_Y_START_CNTX_01_blobs_y_start_RMW                                                 \
    UNP0_BLOBS_Y_START_CNTX_01_blobs_y_start_ADDR32, UNP0_BLOBS_Y_START_CNTX_01_blobs_y_start_SHAMT, \
        UNP0_BLOBS_Y_START_CNTX_01_blobs_y_start_MASK

#define UNP0_BLOBS_Y_START_CNTX_23_blobs_y_start_ADDR32 43
#define UNP0_BLOBS_Y_START_CNTX_23_blobs_y_start_SHAMT 0
#define UNP0_BLOBS_Y_START_CNTX_23_blobs_y_start_MASK 0xffffffff
#define UNP0_BLOBS_Y_START_CNTX_23_blobs_y_start_RMW                                                 \
    UNP0_BLOBS_Y_START_CNTX_23_blobs_y_start_ADDR32, UNP0_BLOBS_Y_START_CNTX_23_blobs_y_start_SHAMT, \
        UNP0_BLOBS_Y_START_CNTX_23_blobs_y_start_MASK

////////////////////////////////////////////////////////////////////////
// Registers for UNPACK1
////////////////////////////////////////////////////////////////////////

#define UNPACK1_CFGREG_BASE_ADDR32 44

#define UNP0_ADDR_CTRL_XY_REG_1_Xstride_ADDR32 44
#define UNP0_ADDR_CTRL_XY_REG_1_Xstride_SHAMT 0
#define UNP0_ADDR_CTRL_XY_REG_1_Xstride_MASK 0xfff
#define UNP0_ADDR_CTRL_XY_REG_1_Xstride_RMW \
    UNP0_ADDR_CTRL_XY_REG_1_Xstride_ADDR32, UNP0_ADDR_CTRL_XY_REG_1_Xstride_SHAMT, UNP0_ADDR_CTRL_XY_REG_1_Xstride_MASK

#define UNP0_ADDR_CTRL_XY_REG_1_Ystride_ADDR32 44
#define UNP0_ADDR_CTRL_XY_REG_1_Ystride_SHAMT 12
#define UNP0_ADDR_CTRL_XY_REG_1_Ystride_MASK 0xfff000
#define UNP0_ADDR_CTRL_XY_REG_1_Ystride_RMW \
    UNP0_ADDR_CTRL_XY_REG_1_Ystride_ADDR32, UNP0_ADDR_CTRL_XY_REG_1_Ystride_SHAMT, UNP0_ADDR_CTRL_XY_REG_1_Ystride_MASK

#define UNP0_ADDR_CTRL_ZW_REG_1_Zstride_ADDR32 45
#define UNP0_ADDR_CTRL_ZW_REG_1_Zstride_SHAMT 0
#define UNP0_ADDR_CTRL_ZW_REG_1_Zstride_MASK 0xfff
#define UNP0_ADDR_CTRL_ZW_REG_1_Zstride_RMW \
    UNP0_ADDR_CTRL_ZW_REG_1_Zstride_ADDR32, UNP0_ADDR_CTRL_ZW_REG_1_Zstride_SHAMT, UNP0_ADDR_CTRL_ZW_REG_1_Zstride_MASK

#define UNP0_ADDR_CTRL_ZW_REG_1_Wstride_ADDR32 45
#define UNP0_ADDR_CTRL_ZW_REG_1_Wstride_SHAMT 12
#define UNP0_ADDR_CTRL_ZW_REG_1_Wstride_MASK 0xffff000
#define UNP0_ADDR_CTRL_ZW_REG_1_Wstride_RMW \
    UNP0_ADDR_CTRL_ZW_REG_1_Wstride_ADDR32, UNP0_ADDR_CTRL_ZW_REG_1_Wstride_SHAMT, UNP0_ADDR_CTRL_ZW_REG_1_Wstride_MASK

#define UNP1_ADDR_CTRL_XY_REG_1_Xstride_ADDR32 46
#define UNP1_ADDR_CTRL_XY_REG_1_Xstride_SHAMT 0
#define UNP1_ADDR_CTRL_XY_REG_1_Xstride_MASK 0xfff
#define UNP1_ADDR_CTRL_XY_REG_1_Xstride_RMW \
    UNP1_ADDR_CTRL_XY_REG_1_Xstride_ADDR32, UNP1_ADDR_CTRL_XY_REG_1_Xstride_SHAMT, UNP1_ADDR_CTRL_XY_REG_1_Xstride_MASK

#define UNP1_ADDR_CTRL_XY_REG_1_Ystride_ADDR32 46
#define UNP1_ADDR_CTRL_XY_REG_1_Ystride_SHAMT 12
#define UNP1_ADDR_CTRL_XY_REG_1_Ystride_MASK 0xfff000
#define UNP1_ADDR_CTRL_XY_REG_1_Ystride_RMW \
    UNP1_ADDR_CTRL_XY_REG_1_Ystride_ADDR32, UNP1_ADDR_CTRL_XY_REG_1_Ystride_SHAMT, UNP1_ADDR_CTRL_XY_REG_1_Ystride_MASK

#define UNP1_ADDR_CTRL_ZW_REG_1_Zstride_ADDR32 47
#define UNP1_ADDR_CTRL_ZW_REG_1_Zstride_SHAMT 0
#define UNP1_ADDR_CTRL_ZW_REG_1_Zstride_MASK 0xfff
#define UNP1_ADDR_CTRL_ZW_REG_1_Zstride_RMW \
    UNP1_ADDR_CTRL_ZW_REG_1_Zstride_ADDR32, UNP1_ADDR_CTRL_ZW_REG_1_Zstride_SHAMT, UNP1_ADDR_CTRL_ZW_REG_1_Zstride_MASK

#define UNP1_ADDR_CTRL_ZW_REG_1_Wstride_ADDR32 47
#define UNP1_ADDR_CTRL_ZW_REG_1_Wstride_SHAMT 12
#define UNP1_ADDR_CTRL_ZW_REG_1_Wstride_MASK 0xffff000
#define UNP1_ADDR_CTRL_ZW_REG_1_Wstride_RMW \
    UNP1_ADDR_CTRL_ZW_REG_1_Wstride_ADDR32, UNP1_ADDR_CTRL_ZW_REG_1_Wstride_SHAMT, UNP1_ADDR_CTRL_ZW_REG_1_Wstride_MASK

#define UNP1_ADDR_BASE_REG_0_Base_ADDR32 48
#define UNP1_ADDR_BASE_REG_0_Base_SHAMT 0
#define UNP1_ADDR_BASE_REG_0_Base_MASK 0xffff
#define UNP1_ADDR_BASE_REG_0_Base_RMW \
    UNP1_ADDR_BASE_REG_0_Base_ADDR32, UNP1_ADDR_BASE_REG_0_Base_SHAMT, UNP1_ADDR_BASE_REG_0_Base_MASK

#define UNP1_ADDR_BASE_REG_1_Base_ADDR32 48
#define UNP1_ADDR_BASE_REG_1_Base_SHAMT 16
#define UNP1_ADDR_BASE_REG_1_Base_MASK 0xffff0000
#define UNP1_ADDR_BASE_REG_1_Base_RMW \
    UNP1_ADDR_BASE_REG_1_Base_ADDR32, UNP1_ADDR_BASE_REG_1_Base_SHAMT, UNP1_ADDR_BASE_REG_1_Base_MASK

#define UNP1_FORCED_SHARED_EXP_shared_exp_ADDR32 49
#define UNP1_FORCED_SHARED_EXP_shared_exp_SHAMT 0
#define UNP1_FORCED_SHARED_EXP_shared_exp_MASK 0xff
#define UNP1_FORCED_SHARED_EXP_shared_exp_RMW                                          \
    UNP1_FORCED_SHARED_EXP_shared_exp_ADDR32, UNP1_FORCED_SHARED_EXP_shared_exp_SHAMT, \
        UNP1_FORCED_SHARED_EXP_shared_exp_MASK

#define UNP1_ADD_DEST_ADDR_CNTR_add_dest_addr_cntr_ADDR32 49
#define UNP1_ADD_DEST_ADDR_CNTR_add_dest_addr_cntr_SHAMT 8
#define UNP1_ADD_DEST_ADDR_CNTR_add_dest_addr_cntr_MASK 0x100
#define UNP1_ADD_DEST_ADDR_CNTR_add_dest_addr_cntr_RMW                                                   \
    UNP1_ADD_DEST_ADDR_CNTR_add_dest_addr_cntr_ADDR32, UNP1_ADD_DEST_ADDR_CNTR_add_dest_addr_cntr_SHAMT, \
        UNP1_ADD_DEST_ADDR_CNTR_add_dest_addr_cntr_MASK

////////////////////////////////////////////////////////////////////////
// Registers for THCON
////////////////////////////////////////////////////////////////////////

#define THCON_CFGREG_BASE_ADDR32 52

#define THCON_SEC0_REG0_TileDescriptor_ADDR32 52
#define THCON_SEC0_REG0_TileDescriptor_SHAMT 0
#define THCON_SEC0_REG0_TileDescriptor_MASK 0xffffffffffffffffffffffffffffffff
#define THCON_SEC0_REG0_TileDescriptor_RMW \
    THCON_SEC0_REG0_TileDescriptor_ADDR32, THCON_SEC0_REG0_TileDescriptor_SHAMT, THCON_SEC0_REG0_TileDescriptor_MASK

#define THCON_SEC0_REG1_Row_start_section_size_ADDR32 56
#define THCON_SEC0_REG1_Row_start_section_size_SHAMT 0
#define THCON_SEC0_REG1_Row_start_section_size_MASK 0xffff
#define THCON_SEC0_REG1_Row_start_section_size_RMW                                               \
    THCON_SEC0_REG1_Row_start_section_size_ADDR32, THCON_SEC0_REG1_Row_start_section_size_SHAMT, \
        THCON_SEC0_REG1_Row_start_section_size_MASK

#define THCON_SEC0_REG1_Exp_section_size_ADDR32 56
#define THCON_SEC0_REG1_Exp_section_size_SHAMT 16
#define THCON_SEC0_REG1_Exp_section_size_MASK 0xffff0000
#define THCON_SEC0_REG1_Exp_section_size_RMW                                         \
    THCON_SEC0_REG1_Exp_section_size_ADDR32, THCON_SEC0_REG1_Exp_section_size_SHAMT, \
        THCON_SEC0_REG1_Exp_section_size_MASK

#define THCON_SEC0_REG1_L1_Dest_addr_ADDR32 57
#define THCON_SEC0_REG1_L1_Dest_addr_SHAMT 0
#define THCON_SEC0_REG1_L1_Dest_addr_MASK 0xffffffff
#define THCON_SEC0_REG1_L1_Dest_addr_RMW \
    THCON_SEC0_REG1_L1_Dest_addr_ADDR32, THCON_SEC0_REG1_L1_Dest_addr_SHAMT, THCON_SEC0_REG1_L1_Dest_addr_MASK

#define THCON_SEC0_REG1_Disable_zero_compress_ADDR32 58
#define THCON_SEC0_REG1_Disable_zero_compress_SHAMT 0
#define THCON_SEC0_REG1_Disable_zero_compress_MASK 0x1
#define THCON_SEC0_REG1_Disable_zero_compress_RMW                                              \
    THCON_SEC0_REG1_Disable_zero_compress_ADDR32, THCON_SEC0_REG1_Disable_zero_compress_SHAMT, \
        THCON_SEC0_REG1_Disable_zero_compress_MASK

#define THCON_SEC0_REG1_Add_l1_dest_addr_offset_ADDR32 58
#define THCON_SEC0_REG1_Add_l1_dest_addr_offset_SHAMT 1
#define THCON_SEC0_REG1_Add_l1_dest_addr_offset_MASK 0x2
#define THCON_SEC0_REG1_Add_l1_dest_addr_offset_RMW                                                \
    THCON_SEC0_REG1_Add_l1_dest_addr_offset_ADDR32, THCON_SEC0_REG1_Add_l1_dest_addr_offset_SHAMT, \
        THCON_SEC0_REG1_Add_l1_dest_addr_offset_MASK

#define THCON_SEC0_REG1_Addr_cnt_context_ADDR32 58
#define THCON_SEC0_REG1_Addr_cnt_context_SHAMT 2
#define THCON_SEC0_REG1_Addr_cnt_context_MASK 0xc
#define THCON_SEC0_REG1_Addr_cnt_context_RMW                                         \
    THCON_SEC0_REG1_Addr_cnt_context_ADDR32, THCON_SEC0_REG1_Addr_cnt_context_SHAMT, \
        THCON_SEC0_REG1_Addr_cnt_context_MASK

#define THCON_SEC0_REG1_Out_data_format_ADDR32 58
#define THCON_SEC0_REG1_Out_data_format_SHAMT 4
#define THCON_SEC0_REG1_Out_data_format_MASK 0xf0
#define THCON_SEC0_REG1_Out_data_format_RMW \
    THCON_SEC0_REG1_Out_data_format_ADDR32, THCON_SEC0_REG1_Out_data_format_SHAMT, THCON_SEC0_REG1_Out_data_format_MASK

#define THCON_SEC0_REG1_In_data_format_ADDR32 58
#define THCON_SEC0_REG1_In_data_format_SHAMT 8
#define THCON_SEC0_REG1_In_data_format_MASK 0xf00
#define THCON_SEC0_REG1_In_data_format_RMW \
    THCON_SEC0_REG1_In_data_format_ADDR32, THCON_SEC0_REG1_In_data_format_SHAMT, THCON_SEC0_REG1_In_data_format_MASK

#define THCON_SEC0_REG1_Dis_shared_exp_assembler_ADDR32 58
#define THCON_SEC0_REG1_Dis_shared_exp_assembler_SHAMT 12
#define THCON_SEC0_REG1_Dis_shared_exp_assembler_MASK 0x1000
#define THCON_SEC0_REG1_Dis_shared_exp_assembler_RMW                                                 \
    THCON_SEC0_REG1_Dis_shared_exp_assembler_ADDR32, THCON_SEC0_REG1_Dis_shared_exp_assembler_SHAMT, \
        THCON_SEC0_REG1_Dis_shared_exp_assembler_MASK

#define THCON_SEC0_REG1_Force_pack_per_max_xy_plane_ADDR32 58
#define THCON_SEC0_REG1_Force_pack_per_max_xy_plane_SHAMT 13
#define THCON_SEC0_REG1_Force_pack_per_max_xy_plane_MASK 0x2000
#define THCON_SEC0_REG1_Force_pack_per_max_xy_plane_RMW                                                    \
    THCON_SEC0_REG1_Force_pack_per_max_xy_plane_ADDR32, THCON_SEC0_REG1_Force_pack_per_max_xy_plane_SHAMT, \
        THCON_SEC0_REG1_Force_pack_per_max_xy_plane_MASK

#define THCON_SEC0_REG1_Enable_out_fifo_ADDR32 58
#define THCON_SEC0_REG1_Enable_out_fifo_SHAMT 14
#define THCON_SEC0_REG1_Enable_out_fifo_MASK 0x4000
#define THCON_SEC0_REG1_Enable_out_fifo_RMW \
    THCON_SEC0_REG1_Enable_out_fifo_ADDR32, THCON_SEC0_REG1_Enable_out_fifo_SHAMT, THCON_SEC0_REG1_Enable_out_fifo_MASK

#define THCON_SEC0_REG1_Sub_l1_tile_header_size_ADDR32 58
#define THCON_SEC0_REG1_Sub_l1_tile_header_size_SHAMT 15
#define THCON_SEC0_REG1_Sub_l1_tile_header_size_MASK 0x8000
#define THCON_SEC0_REG1_Sub_l1_tile_header_size_RMW                                                \
    THCON_SEC0_REG1_Sub_l1_tile_header_size_ADDR32, THCON_SEC0_REG1_Sub_l1_tile_header_size_SHAMT, \
        THCON_SEC0_REG1_Sub_l1_tile_header_size_MASK

#define THCON_SEC0_REG1_Source_interface_selection_ADDR32 58
#define THCON_SEC0_REG1_Source_interface_selection_SHAMT 16
#define THCON_SEC0_REG1_Source_interface_selection_MASK 0x10000
#define THCON_SEC0_REG1_Source_interface_selection_RMW                                                   \
    THCON_SEC0_REG1_Source_interface_selection_ADDR32, THCON_SEC0_REG1_Source_interface_selection_SHAMT, \
        THCON_SEC0_REG1_Source_interface_selection_MASK

#define THCON_SEC0_REG1_All_pack_disable_zero_compress_ADDR32 58
#define THCON_SEC0_REG1_All_pack_disable_zero_compress_SHAMT 17
#define THCON_SEC0_REG1_All_pack_disable_zero_compress_MASK 0x1e0000
#define THCON_SEC0_REG1_All_pack_disable_zero_compress_RMW                                                       \
    THCON_SEC0_REG1_All_pack_disable_zero_compress_ADDR32, THCON_SEC0_REG1_All_pack_disable_zero_compress_SHAMT, \
        THCON_SEC0_REG1_All_pack_disable_zero_compress_MASK

#define THCON_SEC0_REG1_All_pack_disable_zero_compress_ovrd_ADDR32 58
#define THCON_SEC0_REG1_All_pack_disable_zero_compress_ovrd_SHAMT 21
#define THCON_SEC0_REG1_All_pack_disable_zero_compress_ovrd_MASK 0x200000
#define THCON_SEC0_REG1_All_pack_disable_zero_compress_ovrd_RMW    \
    THCON_SEC0_REG1_All_pack_disable_zero_compress_ovrd_ADDR32,    \
        THCON_SEC0_REG1_All_pack_disable_zero_compress_ovrd_SHAMT, \
        THCON_SEC0_REG1_All_pack_disable_zero_compress_ovrd_MASK

#define THCON_SEC0_REG1_Add_tile_header_size_ADDR32 58
#define THCON_SEC0_REG1_Add_tile_header_size_SHAMT 22
#define THCON_SEC0_REG1_Add_tile_header_size_MASK 0x400000
#define THCON_SEC0_REG1_Add_tile_header_size_RMW                                             \
    THCON_SEC0_REG1_Add_tile_header_size_ADDR32, THCON_SEC0_REG1_Add_tile_header_size_SHAMT, \
        THCON_SEC0_REG1_Add_tile_header_size_MASK

#define THCON_SEC0_REG1_L1_source_addr_ADDR32 58
#define THCON_SEC0_REG1_L1_source_addr_SHAMT 24
#define THCON_SEC0_REG1_L1_source_addr_MASK 0xff000000
#define THCON_SEC0_REG1_L1_source_addr_RMW \
    THCON_SEC0_REG1_L1_source_addr_ADDR32, THCON_SEC0_REG1_L1_source_addr_SHAMT, THCON_SEC0_REG1_L1_source_addr_MASK

#define THCON_SEC0_REG1_Downsample_mask_ADDR32 59
#define THCON_SEC0_REG1_Downsample_mask_SHAMT 0
#define THCON_SEC0_REG1_Downsample_mask_MASK 0xffff
#define THCON_SEC0_REG1_Downsample_mask_RMW \
    THCON_SEC0_REG1_Downsample_mask_ADDR32, THCON_SEC0_REG1_Downsample_mask_SHAMT, THCON_SEC0_REG1_Downsample_mask_MASK

#define THCON_SEC0_REG1_Downsample_rate_ADDR32 59
#define THCON_SEC0_REG1_Downsample_rate_SHAMT 16
#define THCON_SEC0_REG1_Downsample_rate_MASK 0x70000
#define THCON_SEC0_REG1_Downsample_rate_RMW \
    THCON_SEC0_REG1_Downsample_rate_ADDR32, THCON_SEC0_REG1_Downsample_rate_SHAMT, THCON_SEC0_REG1_Downsample_rate_MASK

#define THCON_SEC0_REG1_Read_mode_ADDR32 59
#define THCON_SEC0_REG1_Read_mode_SHAMT 19
#define THCON_SEC0_REG1_Read_mode_MASK 0x80000
#define THCON_SEC0_REG1_Read_mode_RMW \
    THCON_SEC0_REG1_Read_mode_ADDR32, THCON_SEC0_REG1_Read_mode_SHAMT, THCON_SEC0_REG1_Read_mode_MASK

#define THCON_SEC0_REG1_Exp_threshold_en_ADDR32 59
#define THCON_SEC0_REG1_Exp_threshold_en_SHAMT 20
#define THCON_SEC0_REG1_Exp_threshold_en_MASK 0x100000
#define THCON_SEC0_REG1_Exp_threshold_en_RMW                                         \
    THCON_SEC0_REG1_Exp_threshold_en_ADDR32, THCON_SEC0_REG1_Exp_threshold_en_SHAMT, \
        THCON_SEC0_REG1_Exp_threshold_en_MASK

#define THCON_SEC0_REG1_Pack_L1_Acc_ADDR32 59
#define THCON_SEC0_REG1_Pack_L1_Acc_SHAMT 21
#define THCON_SEC0_REG1_Pack_L1_Acc_MASK 0x200000
#define THCON_SEC0_REG1_Pack_L1_Acc_RMW \
    THCON_SEC0_REG1_Pack_L1_Acc_ADDR32, THCON_SEC0_REG1_Pack_L1_Acc_SHAMT, THCON_SEC0_REG1_Pack_L1_Acc_MASK

#define THCON_SEC0_REG1_Disable_pack_zero_flags_ADDR32 59
#define THCON_SEC0_REG1_Disable_pack_zero_flags_SHAMT 22
#define THCON_SEC0_REG1_Disable_pack_zero_flags_MASK 0x400000
#define THCON_SEC0_REG1_Disable_pack_zero_flags_RMW                                                \
    THCON_SEC0_REG1_Disable_pack_zero_flags_ADDR32, THCON_SEC0_REG1_Disable_pack_zero_flags_SHAMT, \
        THCON_SEC0_REG1_Disable_pack_zero_flags_MASK

#define THCON_SEC0_REG1_Exp_threshold_ADDR32 59
#define THCON_SEC0_REG1_Exp_threshold_SHAMT 24
#define THCON_SEC0_REG1_Exp_threshold_MASK 0xff000000
#define THCON_SEC0_REG1_Exp_threshold_RMW \
    THCON_SEC0_REG1_Exp_threshold_ADDR32, THCON_SEC0_REG1_Exp_threshold_SHAMT, THCON_SEC0_REG1_Exp_threshold_MASK

#define THCON_SEC0_REG2_Out_data_format_ADDR32 60
#define THCON_SEC0_REG2_Out_data_format_SHAMT 0
#define THCON_SEC0_REG2_Out_data_format_MASK 0xf
#define THCON_SEC0_REG2_Out_data_format_RMW \
    THCON_SEC0_REG2_Out_data_format_ADDR32, THCON_SEC0_REG2_Out_data_format_SHAMT, THCON_SEC0_REG2_Out_data_format_MASK

#define THCON_SEC0_REG2_Throttle_mode_ADDR32 60
#define THCON_SEC0_REG2_Throttle_mode_SHAMT 4
#define THCON_SEC0_REG2_Throttle_mode_MASK 0x30
#define THCON_SEC0_REG2_Throttle_mode_RMW \
    THCON_SEC0_REG2_Throttle_mode_ADDR32, THCON_SEC0_REG2_Throttle_mode_SHAMT, THCON_SEC0_REG2_Throttle_mode_MASK

#define THCON_SEC0_REG2_Context_count_ADDR32 60
#define THCON_SEC0_REG2_Context_count_SHAMT 6
#define THCON_SEC0_REG2_Context_count_MASK 0xc0
#define THCON_SEC0_REG2_Context_count_RMW \
    THCON_SEC0_REG2_Context_count_ADDR32, THCON_SEC0_REG2_Context_count_SHAMT, THCON_SEC0_REG2_Context_count_MASK

#define THCON_SEC0_REG2_Haloize_mode_ADDR32 60
#define THCON_SEC0_REG2_Haloize_mode_SHAMT 8
#define THCON_SEC0_REG2_Haloize_mode_MASK 0x100
#define THCON_SEC0_REG2_Haloize_mode_RMW \
    THCON_SEC0_REG2_Haloize_mode_ADDR32, THCON_SEC0_REG2_Haloize_mode_SHAMT, THCON_SEC0_REG2_Haloize_mode_MASK

#define THCON_SEC0_REG2_Tileize_mode_ADDR32 60
#define THCON_SEC0_REG2_Tileize_mode_SHAMT 9
#define THCON_SEC0_REG2_Tileize_mode_MASK 0x200
#define THCON_SEC0_REG2_Tileize_mode_RMW \
    THCON_SEC0_REG2_Tileize_mode_ADDR32, THCON_SEC0_REG2_Tileize_mode_SHAMT, THCON_SEC0_REG2_Tileize_mode_MASK

#define THCON_SEC0_REG2_Unpack_Src_Reg_Set_Upd_ADDR32 60
#define THCON_SEC0_REG2_Unpack_Src_Reg_Set_Upd_SHAMT 10
#define THCON_SEC0_REG2_Unpack_Src_Reg_Set_Upd_MASK 0x400
#define THCON_SEC0_REG2_Unpack_Src_Reg_Set_Upd_RMW                                               \
    THCON_SEC0_REG2_Unpack_Src_Reg_Set_Upd_ADDR32, THCON_SEC0_REG2_Unpack_Src_Reg_Set_Upd_SHAMT, \
        THCON_SEC0_REG2_Unpack_Src_Reg_Set_Upd_MASK

#define THCON_SEC0_REG2_Unpack_If_Sel_ADDR32 60
#define THCON_SEC0_REG2_Unpack_If_Sel_SHAMT 11
#define THCON_SEC0_REG2_Unpack_If_Sel_MASK 0x800
#define THCON_SEC0_REG2_Unpack_If_Sel_RMW \
    THCON_SEC0_REG2_Unpack_If_Sel_ADDR32, THCON_SEC0_REG2_Unpack_If_Sel_SHAMT, THCON_SEC0_REG2_Unpack_If_Sel_MASK

#define THCON_SEC0_REG2_Upsample_rate_ADDR32 60
#define THCON_SEC0_REG2_Upsample_rate_SHAMT 12
#define THCON_SEC0_REG2_Upsample_rate_MASK 0x3000
#define THCON_SEC0_REG2_Upsample_rate_RMW \
    THCON_SEC0_REG2_Upsample_rate_ADDR32, THCON_SEC0_REG2_Upsample_rate_SHAMT, THCON_SEC0_REG2_Upsample_rate_MASK

#define THCON_SEC0_REG2_Ovrd_data_format_ADDR32 60
#define THCON_SEC0_REG2_Ovrd_data_format_SHAMT 14
#define THCON_SEC0_REG2_Ovrd_data_format_MASK 0x4000
#define THCON_SEC0_REG2_Ovrd_data_format_RMW                                         \
    THCON_SEC0_REG2_Ovrd_data_format_ADDR32, THCON_SEC0_REG2_Ovrd_data_format_SHAMT, \
        THCON_SEC0_REG2_Ovrd_data_format_MASK

#define THCON_SEC0_REG2_Upsample_and_interleave_ADDR32 60
#define THCON_SEC0_REG2_Upsample_and_interleave_SHAMT 15
#define THCON_SEC0_REG2_Upsample_and_interleave_MASK 0x8000
#define THCON_SEC0_REG2_Upsample_and_interleave_RMW                                                \
    THCON_SEC0_REG2_Upsample_and_interleave_ADDR32, THCON_SEC0_REG2_Upsample_and_interleave_SHAMT, \
        THCON_SEC0_REG2_Upsample_and_interleave_MASK

#define THCON_SEC0_REG2_Shift_amount_cntx0_ADDR32 60
#define THCON_SEC0_REG2_Shift_amount_cntx0_SHAMT 16
#define THCON_SEC0_REG2_Shift_amount_cntx0_MASK 0xf0000
#define THCON_SEC0_REG2_Shift_amount_cntx0_RMW                                           \
    THCON_SEC0_REG2_Shift_amount_cntx0_ADDR32, THCON_SEC0_REG2_Shift_amount_cntx0_SHAMT, \
        THCON_SEC0_REG2_Shift_amount_cntx0_MASK

#define THCON_SEC0_REG2_Shift_amount_cntx1_ADDR32 60
#define THCON_SEC0_REG2_Shift_amount_cntx1_SHAMT 20
#define THCON_SEC0_REG2_Shift_amount_cntx1_MASK 0xf00000
#define THCON_SEC0_REG2_Shift_amount_cntx1_RMW                                           \
    THCON_SEC0_REG2_Shift_amount_cntx1_ADDR32, THCON_SEC0_REG2_Shift_amount_cntx1_SHAMT, \
        THCON_SEC0_REG2_Shift_amount_cntx1_MASK

#define THCON_SEC0_REG2_Shift_amount_cntx2_ADDR32 60
#define THCON_SEC0_REG2_Shift_amount_cntx2_SHAMT 24
#define THCON_SEC0_REG2_Shift_amount_cntx2_MASK 0xf000000
#define THCON_SEC0_REG2_Shift_amount_cntx2_RMW                                           \
    THCON_SEC0_REG2_Shift_amount_cntx2_ADDR32, THCON_SEC0_REG2_Shift_amount_cntx2_SHAMT, \
        THCON_SEC0_REG2_Shift_amount_cntx2_MASK

#define THCON_SEC0_REG2_Shift_amount_cntx3_ADDR32 60
#define THCON_SEC0_REG2_Shift_amount_cntx3_SHAMT 28
#define THCON_SEC0_REG2_Shift_amount_cntx3_MASK 0xf0000000
#define THCON_SEC0_REG2_Shift_amount_cntx3_RMW                                           \
    THCON_SEC0_REG2_Shift_amount_cntx3_ADDR32, THCON_SEC0_REG2_Shift_amount_cntx3_SHAMT, \
        THCON_SEC0_REG2_Shift_amount_cntx3_MASK

#define THCON_SEC0_REG2_Disable_zero_compress_cntx0_ADDR32 61
#define THCON_SEC0_REG2_Disable_zero_compress_cntx0_SHAMT 0
#define THCON_SEC0_REG2_Disable_zero_compress_cntx0_MASK 0x1
#define THCON_SEC0_REG2_Disable_zero_compress_cntx0_RMW                                                    \
    THCON_SEC0_REG2_Disable_zero_compress_cntx0_ADDR32, THCON_SEC0_REG2_Disable_zero_compress_cntx0_SHAMT, \
        THCON_SEC0_REG2_Disable_zero_compress_cntx0_MASK

#define THCON_SEC0_REG2_Disable_zero_compress_cntx1_ADDR32 61
#define THCON_SEC0_REG2_Disable_zero_compress_cntx1_SHAMT 1
#define THCON_SEC0_REG2_Disable_zero_compress_cntx1_MASK 0x2
#define THCON_SEC0_REG2_Disable_zero_compress_cntx1_RMW                                                    \
    THCON_SEC0_REG2_Disable_zero_compress_cntx1_ADDR32, THCON_SEC0_REG2_Disable_zero_compress_cntx1_SHAMT, \
        THCON_SEC0_REG2_Disable_zero_compress_cntx1_MASK

#define THCON_SEC0_REG2_Disable_zero_compress_cntx2_ADDR32 61
#define THCON_SEC0_REG2_Disable_zero_compress_cntx2_SHAMT 2
#define THCON_SEC0_REG2_Disable_zero_compress_cntx2_MASK 0x4
#define THCON_SEC0_REG2_Disable_zero_compress_cntx2_RMW                                                    \
    THCON_SEC0_REG2_Disable_zero_compress_cntx2_ADDR32, THCON_SEC0_REG2_Disable_zero_compress_cntx2_SHAMT, \
        THCON_SEC0_REG2_Disable_zero_compress_cntx2_MASK

#define THCON_SEC0_REG2_Disable_zero_compress_cntx3_ADDR32 61
#define THCON_SEC0_REG2_Disable_zero_compress_cntx3_SHAMT 3
#define THCON_SEC0_REG2_Disable_zero_compress_cntx3_MASK 0x8
#define THCON_SEC0_REG2_Disable_zero_compress_cntx3_RMW                                                    \
    THCON_SEC0_REG2_Disable_zero_compress_cntx3_ADDR32, THCON_SEC0_REG2_Disable_zero_compress_cntx3_SHAMT, \
        THCON_SEC0_REG2_Disable_zero_compress_cntx3_MASK

#define THCON_SEC0_REG2_Unpack_if_sel_cntx0_ADDR32 61
#define THCON_SEC0_REG2_Unpack_if_sel_cntx0_SHAMT 4
#define THCON_SEC0_REG2_Unpack_if_sel_cntx0_MASK 0x10
#define THCON_SEC0_REG2_Unpack_if_sel_cntx0_RMW                                            \
    THCON_SEC0_REG2_Unpack_if_sel_cntx0_ADDR32, THCON_SEC0_REG2_Unpack_if_sel_cntx0_SHAMT, \
        THCON_SEC0_REG2_Unpack_if_sel_cntx0_MASK

#define THCON_SEC0_REG2_Unpack_if_sel_cntx1_ADDR32 61
#define THCON_SEC0_REG2_Unpack_if_sel_cntx1_SHAMT 5
#define THCON_SEC0_REG2_Unpack_if_sel_cntx1_MASK 0x20
#define THCON_SEC0_REG2_Unpack_if_sel_cntx1_RMW                                            \
    THCON_SEC0_REG2_Unpack_if_sel_cntx1_ADDR32, THCON_SEC0_REG2_Unpack_if_sel_cntx1_SHAMT, \
        THCON_SEC0_REG2_Unpack_if_sel_cntx1_MASK

#define THCON_SEC0_REG2_Unpack_if_sel_cntx2_ADDR32 61
#define THCON_SEC0_REG2_Unpack_if_sel_cntx2_SHAMT 6
#define THCON_SEC0_REG2_Unpack_if_sel_cntx2_MASK 0x40
#define THCON_SEC0_REG2_Unpack_if_sel_cntx2_RMW                                            \
    THCON_SEC0_REG2_Unpack_if_sel_cntx2_ADDR32, THCON_SEC0_REG2_Unpack_if_sel_cntx2_SHAMT, \
        THCON_SEC0_REG2_Unpack_if_sel_cntx2_MASK

#define THCON_SEC0_REG2_Unpack_if_sel_cntx3_ADDR32 61
#define THCON_SEC0_REG2_Unpack_if_sel_cntx3_SHAMT 7
#define THCON_SEC0_REG2_Unpack_if_sel_cntx3_MASK 0x80
#define THCON_SEC0_REG2_Unpack_if_sel_cntx3_RMW                                            \
    THCON_SEC0_REG2_Unpack_if_sel_cntx3_ADDR32, THCON_SEC0_REG2_Unpack_if_sel_cntx3_SHAMT, \
        THCON_SEC0_REG2_Unpack_if_sel_cntx3_MASK

#define THCON_SEC0_REG2_Force_shared_exp_ADDR32 61
#define THCON_SEC0_REG2_Force_shared_exp_SHAMT 8
#define THCON_SEC0_REG2_Force_shared_exp_MASK 0x100
#define THCON_SEC0_REG2_Force_shared_exp_RMW                                         \
    THCON_SEC0_REG2_Force_shared_exp_ADDR32, THCON_SEC0_REG2_Force_shared_exp_SHAMT, \
        THCON_SEC0_REG2_Force_shared_exp_MASK

#define THCON_SEC0_REG2_Disable_zero_compress_cntx4_ADDR32 61
#define THCON_SEC0_REG2_Disable_zero_compress_cntx4_SHAMT 16
#define THCON_SEC0_REG2_Disable_zero_compress_cntx4_MASK 0x10000
#define THCON_SEC0_REG2_Disable_zero_compress_cntx4_RMW                                                    \
    THCON_SEC0_REG2_Disable_zero_compress_cntx4_ADDR32, THCON_SEC0_REG2_Disable_zero_compress_cntx4_SHAMT, \
        THCON_SEC0_REG2_Disable_zero_compress_cntx4_MASK

#define THCON_SEC0_REG2_Disable_zero_compress_cntx5_ADDR32 61
#define THCON_SEC0_REG2_Disable_zero_compress_cntx5_SHAMT 17
#define THCON_SEC0_REG2_Disable_zero_compress_cntx5_MASK 0x20000
#define THCON_SEC0_REG2_Disable_zero_compress_cntx5_RMW                                                    \
    THCON_SEC0_REG2_Disable_zero_compress_cntx5_ADDR32, THCON_SEC0_REG2_Disable_zero_compress_cntx5_SHAMT, \
        THCON_SEC0_REG2_Disable_zero_compress_cntx5_MASK

#define THCON_SEC0_REG2_Disable_zero_compress_cntx6_ADDR32 61
#define THCON_SEC0_REG2_Disable_zero_compress_cntx6_SHAMT 18
#define THCON_SEC0_REG2_Disable_zero_compress_cntx6_MASK 0x40000
#define THCON_SEC0_REG2_Disable_zero_compress_cntx6_RMW                                                    \
    THCON_SEC0_REG2_Disable_zero_compress_cntx6_ADDR32, THCON_SEC0_REG2_Disable_zero_compress_cntx6_SHAMT, \
        THCON_SEC0_REG2_Disable_zero_compress_cntx6_MASK

#define THCON_SEC0_REG2_Disable_zero_compress_cntx7_ADDR32 61
#define THCON_SEC0_REG2_Disable_zero_compress_cntx7_SHAMT 19
#define THCON_SEC0_REG2_Disable_zero_compress_cntx7_MASK 0x80000
#define THCON_SEC0_REG2_Disable_zero_compress_cntx7_RMW                                                    \
    THCON_SEC0_REG2_Disable_zero_compress_cntx7_ADDR32, THCON_SEC0_REG2_Disable_zero_compress_cntx7_SHAMT, \
        THCON_SEC0_REG2_Disable_zero_compress_cntx7_MASK

#define THCON_SEC0_REG2_Unpack_if_sel_cntx4_ADDR32 61
#define THCON_SEC0_REG2_Unpack_if_sel_cntx4_SHAMT 20
#define THCON_SEC0_REG2_Unpack_if_sel_cntx4_MASK 0x100000
#define THCON_SEC0_REG2_Unpack_if_sel_cntx4_RMW                                            \
    THCON_SEC0_REG2_Unpack_if_sel_cntx4_ADDR32, THCON_SEC0_REG2_Unpack_if_sel_cntx4_SHAMT, \
        THCON_SEC0_REG2_Unpack_if_sel_cntx4_MASK

#define THCON_SEC0_REG2_Unpack_if_sel_cntx5_ADDR32 61
#define THCON_SEC0_REG2_Unpack_if_sel_cntx5_SHAMT 21
#define THCON_SEC0_REG2_Unpack_if_sel_cntx5_MASK 0x200000
#define THCON_SEC0_REG2_Unpack_if_sel_cntx5_RMW                                            \
    THCON_SEC0_REG2_Unpack_if_sel_cntx5_ADDR32, THCON_SEC0_REG2_Unpack_if_sel_cntx5_SHAMT, \
        THCON_SEC0_REG2_Unpack_if_sel_cntx5_MASK

#define THCON_SEC0_REG2_Unpack_if_sel_cntx6_ADDR32 61
#define THCON_SEC0_REG2_Unpack_if_sel_cntx6_SHAMT 22
#define THCON_SEC0_REG2_Unpack_if_sel_cntx6_MASK 0x400000
#define THCON_SEC0_REG2_Unpack_if_sel_cntx6_RMW                                            \
    THCON_SEC0_REG2_Unpack_if_sel_cntx6_ADDR32, THCON_SEC0_REG2_Unpack_if_sel_cntx6_SHAMT, \
        THCON_SEC0_REG2_Unpack_if_sel_cntx6_MASK

#define THCON_SEC0_REG2_Unpack_if_sel_cntx7_ADDR32 61
#define THCON_SEC0_REG2_Unpack_if_sel_cntx7_SHAMT 23
#define THCON_SEC0_REG2_Unpack_if_sel_cntx7_MASK 0x800000
#define THCON_SEC0_REG2_Unpack_if_sel_cntx7_RMW                                            \
    THCON_SEC0_REG2_Unpack_if_sel_cntx7_ADDR32, THCON_SEC0_REG2_Unpack_if_sel_cntx7_SHAMT, \
        THCON_SEC0_REG2_Unpack_if_sel_cntx7_MASK

#define THCON_SEC0_REG2_Unpack_limit_address_ADDR32 62
#define THCON_SEC0_REG2_Unpack_limit_address_SHAMT 0
#define THCON_SEC0_REG2_Unpack_limit_address_MASK 0x1ffff
#define THCON_SEC0_REG2_Unpack_limit_address_RMW                                             \
    THCON_SEC0_REG2_Unpack_limit_address_ADDR32, THCON_SEC0_REG2_Unpack_limit_address_SHAMT, \
        THCON_SEC0_REG2_Unpack_limit_address_MASK

#define THCON_SEC0_REG2_Unpack_fifo_size_ADDR32 63
#define THCON_SEC0_REG2_Unpack_fifo_size_SHAMT 0
#define THCON_SEC0_REG2_Unpack_fifo_size_MASK 0x1ffff
#define THCON_SEC0_REG2_Unpack_fifo_size_RMW                                         \
    THCON_SEC0_REG2_Unpack_fifo_size_ADDR32, THCON_SEC0_REG2_Unpack_fifo_size_SHAMT, \
        THCON_SEC0_REG2_Unpack_fifo_size_MASK

#define THCON_SEC0_REG3_Base_address_ADDR32 64
#define THCON_SEC0_REG3_Base_address_SHAMT 0
#define THCON_SEC0_REG3_Base_address_MASK 0xffffffff
#define THCON_SEC0_REG3_Base_address_RMW \
    THCON_SEC0_REG3_Base_address_ADDR32, THCON_SEC0_REG3_Base_address_SHAMT, THCON_SEC0_REG3_Base_address_MASK

#define THCON_SEC0_REG3_Base_cntx1_address_ADDR32 65
#define THCON_SEC0_REG3_Base_cntx1_address_SHAMT 0
#define THCON_SEC0_REG3_Base_cntx1_address_MASK 0xffffffff
#define THCON_SEC0_REG3_Base_cntx1_address_RMW                                           \
    THCON_SEC0_REG3_Base_cntx1_address_ADDR32, THCON_SEC0_REG3_Base_cntx1_address_SHAMT, \
        THCON_SEC0_REG3_Base_cntx1_address_MASK

#define THCON_SEC0_REG3_Base_cntx2_address_ADDR32 66
#define THCON_SEC0_REG3_Base_cntx2_address_SHAMT 0
#define THCON_SEC0_REG3_Base_cntx2_address_MASK 0xffffffff
#define THCON_SEC0_REG3_Base_cntx2_address_RMW                                           \
    THCON_SEC0_REG3_Base_cntx2_address_ADDR32, THCON_SEC0_REG3_Base_cntx2_address_SHAMT, \
        THCON_SEC0_REG3_Base_cntx2_address_MASK

#define THCON_SEC0_REG3_Base_cntx3_address_ADDR32 67
#define THCON_SEC0_REG3_Base_cntx3_address_SHAMT 0
#define THCON_SEC0_REG3_Base_cntx3_address_MASK 0xffffffff
#define THCON_SEC0_REG3_Base_cntx3_address_RMW                                           \
    THCON_SEC0_REG3_Base_cntx3_address_ADDR32, THCON_SEC0_REG3_Base_cntx3_address_SHAMT, \
        THCON_SEC0_REG3_Base_cntx3_address_MASK

#define THCON_SEC0_REG4_Base_cntx4_address_ADDR32 68
#define THCON_SEC0_REG4_Base_cntx4_address_SHAMT 0
#define THCON_SEC0_REG4_Base_cntx4_address_MASK 0xffffffff
#define THCON_SEC0_REG4_Base_cntx4_address_RMW                                           \
    THCON_SEC0_REG4_Base_cntx4_address_ADDR32, THCON_SEC0_REG4_Base_cntx4_address_SHAMT, \
        THCON_SEC0_REG4_Base_cntx4_address_MASK

#define THCON_SEC0_REG4_Base_cntx5_address_ADDR32 69
#define THCON_SEC0_REG4_Base_cntx5_address_SHAMT 0
#define THCON_SEC0_REG4_Base_cntx5_address_MASK 0xffffffff
#define THCON_SEC0_REG4_Base_cntx5_address_RMW                                           \
    THCON_SEC0_REG4_Base_cntx5_address_ADDR32, THCON_SEC0_REG4_Base_cntx5_address_SHAMT, \
        THCON_SEC0_REG4_Base_cntx5_address_MASK

#define THCON_SEC0_REG4_Base_cntx6_address_ADDR32 70
#define THCON_SEC0_REG4_Base_cntx6_address_SHAMT 0
#define THCON_SEC0_REG4_Base_cntx6_address_MASK 0xffffffff
#define THCON_SEC0_REG4_Base_cntx6_address_RMW                                           \
    THCON_SEC0_REG4_Base_cntx6_address_ADDR32, THCON_SEC0_REG4_Base_cntx6_address_SHAMT, \
        THCON_SEC0_REG4_Base_cntx6_address_MASK

#define THCON_SEC0_REG4_Base_cntx7_address_ADDR32 71
#define THCON_SEC0_REG4_Base_cntx7_address_SHAMT 0
#define THCON_SEC0_REG4_Base_cntx7_address_MASK 0xffffffff
#define THCON_SEC0_REG4_Base_cntx7_address_RMW                                           \
    THCON_SEC0_REG4_Base_cntx7_address_ADDR32, THCON_SEC0_REG4_Base_cntx7_address_SHAMT, \
        THCON_SEC0_REG4_Base_cntx7_address_MASK

#define THCON_SEC0_REG5_Dest_cntx0_address_ADDR32 72
#define THCON_SEC0_REG5_Dest_cntx0_address_SHAMT 0
#define THCON_SEC0_REG5_Dest_cntx0_address_MASK 0xffff
#define THCON_SEC0_REG5_Dest_cntx0_address_RMW                                           \
    THCON_SEC0_REG5_Dest_cntx0_address_ADDR32, THCON_SEC0_REG5_Dest_cntx0_address_SHAMT, \
        THCON_SEC0_REG5_Dest_cntx0_address_MASK

#define THCON_SEC0_REG5_Dest_cntx1_address_ADDR32 72
#define THCON_SEC0_REG5_Dest_cntx1_address_SHAMT 16
#define THCON_SEC0_REG5_Dest_cntx1_address_MASK 0xffff0000
#define THCON_SEC0_REG5_Dest_cntx1_address_RMW                                           \
    THCON_SEC0_REG5_Dest_cntx1_address_ADDR32, THCON_SEC0_REG5_Dest_cntx1_address_SHAMT, \
        THCON_SEC0_REG5_Dest_cntx1_address_MASK

#define THCON_SEC0_REG5_Dest_cntx2_address_ADDR32 73
#define THCON_SEC0_REG5_Dest_cntx2_address_SHAMT 0
#define THCON_SEC0_REG5_Dest_cntx2_address_MASK 0xffff
#define THCON_SEC0_REG5_Dest_cntx2_address_RMW                                           \
    THCON_SEC0_REG5_Dest_cntx2_address_ADDR32, THCON_SEC0_REG5_Dest_cntx2_address_SHAMT, \
        THCON_SEC0_REG5_Dest_cntx2_address_MASK

#define THCON_SEC0_REG5_Dest_cntx3_address_ADDR32 73
#define THCON_SEC0_REG5_Dest_cntx3_address_SHAMT 16
#define THCON_SEC0_REG5_Dest_cntx3_address_MASK 0xffff0000
#define THCON_SEC0_REG5_Dest_cntx3_address_RMW                                           \
    THCON_SEC0_REG5_Dest_cntx3_address_ADDR32, THCON_SEC0_REG5_Dest_cntx3_address_SHAMT, \
        THCON_SEC0_REG5_Dest_cntx3_address_MASK

#define THCON_SEC0_REG5_Tile_x_dim_cntx0_ADDR32 74
#define THCON_SEC0_REG5_Tile_x_dim_cntx0_SHAMT 0
#define THCON_SEC0_REG5_Tile_x_dim_cntx0_MASK 0xffff
#define THCON_SEC0_REG5_Tile_x_dim_cntx0_RMW                                         \
    THCON_SEC0_REG5_Tile_x_dim_cntx0_ADDR32, THCON_SEC0_REG5_Tile_x_dim_cntx0_SHAMT, \
        THCON_SEC0_REG5_Tile_x_dim_cntx0_MASK

#define THCON_SEC0_REG5_Tile_x_dim_cntx1_ADDR32 74
#define THCON_SEC0_REG5_Tile_x_dim_cntx1_SHAMT 16
#define THCON_SEC0_REG5_Tile_x_dim_cntx1_MASK 0xffff0000
#define THCON_SEC0_REG5_Tile_x_dim_cntx1_RMW                                         \
    THCON_SEC0_REG5_Tile_x_dim_cntx1_ADDR32, THCON_SEC0_REG5_Tile_x_dim_cntx1_SHAMT, \
        THCON_SEC0_REG5_Tile_x_dim_cntx1_MASK

#define THCON_SEC0_REG5_Tile_x_dim_cntx2_ADDR32 75
#define THCON_SEC0_REG5_Tile_x_dim_cntx2_SHAMT 0
#define THCON_SEC0_REG5_Tile_x_dim_cntx2_MASK 0xffff
#define THCON_SEC0_REG5_Tile_x_dim_cntx2_RMW                                         \
    THCON_SEC0_REG5_Tile_x_dim_cntx2_ADDR32, THCON_SEC0_REG5_Tile_x_dim_cntx2_SHAMT, \
        THCON_SEC0_REG5_Tile_x_dim_cntx2_MASK

#define THCON_SEC0_REG5_Tile_x_dim_cntx3_ADDR32 75
#define THCON_SEC0_REG5_Tile_x_dim_cntx3_SHAMT 16
#define THCON_SEC0_REG5_Tile_x_dim_cntx3_MASK 0xffff0000
#define THCON_SEC0_REG5_Tile_x_dim_cntx3_RMW                                         \
    THCON_SEC0_REG5_Tile_x_dim_cntx3_ADDR32, THCON_SEC0_REG5_Tile_x_dim_cntx3_SHAMT, \
        THCON_SEC0_REG5_Tile_x_dim_cntx3_MASK

#define THCON_SEC0_REG6_Source_address_ADDR32 76
#define THCON_SEC0_REG6_Source_address_SHAMT 0
#define THCON_SEC0_REG6_Source_address_MASK 0xffffffff
#define THCON_SEC0_REG6_Source_address_RMW \
    THCON_SEC0_REG6_Source_address_ADDR32, THCON_SEC0_REG6_Source_address_SHAMT, THCON_SEC0_REG6_Source_address_MASK

#define THCON_SEC0_REG6_Destination_address_ADDR32 77
#define THCON_SEC0_REG6_Destination_address_SHAMT 0
#define THCON_SEC0_REG6_Destination_address_MASK 0xffffffff
#define THCON_SEC0_REG6_Destination_address_RMW                                            \
    THCON_SEC0_REG6_Destination_address_ADDR32, THCON_SEC0_REG6_Destination_address_SHAMT, \
        THCON_SEC0_REG6_Destination_address_MASK

#define THCON_SEC0_REG6_Buffer_size_ADDR32 78
#define THCON_SEC0_REG6_Buffer_size_SHAMT 0
#define THCON_SEC0_REG6_Buffer_size_MASK 0x3fffffff
#define THCON_SEC0_REG6_Buffer_size_RMW \
    THCON_SEC0_REG6_Buffer_size_ADDR32, THCON_SEC0_REG6_Buffer_size_SHAMT, THCON_SEC0_REG6_Buffer_size_MASK

#define THCON_SEC0_REG6_Transfer_direction_ADDR32 78
#define THCON_SEC0_REG6_Transfer_direction_SHAMT 30
#define THCON_SEC0_REG6_Transfer_direction_MASK 0xc0000000
#define THCON_SEC0_REG6_Transfer_direction_RMW                                           \
    THCON_SEC0_REG6_Transfer_direction_ADDR32, THCON_SEC0_REG6_Transfer_direction_SHAMT, \
        THCON_SEC0_REG6_Transfer_direction_MASK

#define THCON_SEC0_REG7_Offset_address_ADDR32 80
#define THCON_SEC0_REG7_Offset_address_SHAMT 0
#define THCON_SEC0_REG7_Offset_address_MASK 0xffff
#define THCON_SEC0_REG7_Offset_address_RMW \
    THCON_SEC0_REG7_Offset_address_ADDR32, THCON_SEC0_REG7_Offset_address_SHAMT, THCON_SEC0_REG7_Offset_address_MASK

#define THCON_SEC0_REG7_Unpack_data_format_cntx0_ADDR32 80
#define THCON_SEC0_REG7_Unpack_data_format_cntx0_SHAMT 16
#define THCON_SEC0_REG7_Unpack_data_format_cntx0_MASK 0xf0000
#define THCON_SEC0_REG7_Unpack_data_format_cntx0_RMW                                                 \
    THCON_SEC0_REG7_Unpack_data_format_cntx0_ADDR32, THCON_SEC0_REG7_Unpack_data_format_cntx0_SHAMT, \
        THCON_SEC0_REG7_Unpack_data_format_cntx0_MASK

#define THCON_SEC0_REG7_Unpack_out_data_format_cntx0_ADDR32 80
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx0_SHAMT 20
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx0_MASK 0xf00000
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx0_RMW                                                     \
    THCON_SEC0_REG7_Unpack_out_data_format_cntx0_ADDR32, THCON_SEC0_REG7_Unpack_out_data_format_cntx0_SHAMT, \
        THCON_SEC0_REG7_Unpack_out_data_format_cntx0_MASK

#define THCON_SEC0_REG7_Unpack_data_format_cntx4_ADDR32 80
#define THCON_SEC0_REG7_Unpack_data_format_cntx4_SHAMT 24
#define THCON_SEC0_REG7_Unpack_data_format_cntx4_MASK 0xf000000
#define THCON_SEC0_REG7_Unpack_data_format_cntx4_RMW                                                 \
    THCON_SEC0_REG7_Unpack_data_format_cntx4_ADDR32, THCON_SEC0_REG7_Unpack_data_format_cntx4_SHAMT, \
        THCON_SEC0_REG7_Unpack_data_format_cntx4_MASK

#define THCON_SEC0_REG7_Unpack_out_data_format_cntx4_ADDR32 80
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx4_SHAMT 28
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx4_MASK 0xf0000000
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx4_RMW                                                     \
    THCON_SEC0_REG7_Unpack_out_data_format_cntx4_ADDR32, THCON_SEC0_REG7_Unpack_out_data_format_cntx4_SHAMT, \
        THCON_SEC0_REG7_Unpack_out_data_format_cntx4_MASK

#define THCON_SEC0_REG7_Offset_cntx1_address_ADDR32 81
#define THCON_SEC0_REG7_Offset_cntx1_address_SHAMT 0
#define THCON_SEC0_REG7_Offset_cntx1_address_MASK 0xffff
#define THCON_SEC0_REG7_Offset_cntx1_address_RMW                                             \
    THCON_SEC0_REG7_Offset_cntx1_address_ADDR32, THCON_SEC0_REG7_Offset_cntx1_address_SHAMT, \
        THCON_SEC0_REG7_Offset_cntx1_address_MASK

#define THCON_SEC0_REG7_Unpack_data_format_cntx1_ADDR32 81
#define THCON_SEC0_REG7_Unpack_data_format_cntx1_SHAMT 16
#define THCON_SEC0_REG7_Unpack_data_format_cntx1_MASK 0xf0000
#define THCON_SEC0_REG7_Unpack_data_format_cntx1_RMW                                                 \
    THCON_SEC0_REG7_Unpack_data_format_cntx1_ADDR32, THCON_SEC0_REG7_Unpack_data_format_cntx1_SHAMT, \
        THCON_SEC0_REG7_Unpack_data_format_cntx1_MASK

#define THCON_SEC0_REG7_Unpack_out_data_format_cntx1_ADDR32 81
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx1_SHAMT 20
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx1_MASK 0xf00000
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx1_RMW                                                     \
    THCON_SEC0_REG7_Unpack_out_data_format_cntx1_ADDR32, THCON_SEC0_REG7_Unpack_out_data_format_cntx1_SHAMT, \
        THCON_SEC0_REG7_Unpack_out_data_format_cntx1_MASK

#define THCON_SEC0_REG7_Unpack_data_format_cntx5_ADDR32 81
#define THCON_SEC0_REG7_Unpack_data_format_cntx5_SHAMT 24
#define THCON_SEC0_REG7_Unpack_data_format_cntx5_MASK 0xf000000
#define THCON_SEC0_REG7_Unpack_data_format_cntx5_RMW                                                 \
    THCON_SEC0_REG7_Unpack_data_format_cntx5_ADDR32, THCON_SEC0_REG7_Unpack_data_format_cntx5_SHAMT, \
        THCON_SEC0_REG7_Unpack_data_format_cntx5_MASK

#define THCON_SEC0_REG7_Unpack_out_data_format_cntx5_ADDR32 81
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx5_SHAMT 28
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx5_MASK 0xf0000000
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx5_RMW                                                     \
    THCON_SEC0_REG7_Unpack_out_data_format_cntx5_ADDR32, THCON_SEC0_REG7_Unpack_out_data_format_cntx5_SHAMT, \
        THCON_SEC0_REG7_Unpack_out_data_format_cntx5_MASK

#define THCON_SEC0_REG7_Offset_cntx2_address_ADDR32 82
#define THCON_SEC0_REG7_Offset_cntx2_address_SHAMT 0
#define THCON_SEC0_REG7_Offset_cntx2_address_MASK 0xffff
#define THCON_SEC0_REG7_Offset_cntx2_address_RMW                                             \
    THCON_SEC0_REG7_Offset_cntx2_address_ADDR32, THCON_SEC0_REG7_Offset_cntx2_address_SHAMT, \
        THCON_SEC0_REG7_Offset_cntx2_address_MASK

#define THCON_SEC0_REG7_Unpack_data_format_cntx2_ADDR32 82
#define THCON_SEC0_REG7_Unpack_data_format_cntx2_SHAMT 16
#define THCON_SEC0_REG7_Unpack_data_format_cntx2_MASK 0xf0000
#define THCON_SEC0_REG7_Unpack_data_format_cntx2_RMW                                                 \
    THCON_SEC0_REG7_Unpack_data_format_cntx2_ADDR32, THCON_SEC0_REG7_Unpack_data_format_cntx2_SHAMT, \
        THCON_SEC0_REG7_Unpack_data_format_cntx2_MASK

#define THCON_SEC0_REG7_Unpack_out_data_format_cntx2_ADDR32 82
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx2_SHAMT 20
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx2_MASK 0xf00000
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx2_RMW                                                     \
    THCON_SEC0_REG7_Unpack_out_data_format_cntx2_ADDR32, THCON_SEC0_REG7_Unpack_out_data_format_cntx2_SHAMT, \
        THCON_SEC0_REG7_Unpack_out_data_format_cntx2_MASK

#define THCON_SEC0_REG7_Unpack_data_format_cntx6_ADDR32 82
#define THCON_SEC0_REG7_Unpack_data_format_cntx6_SHAMT 24
#define THCON_SEC0_REG7_Unpack_data_format_cntx6_MASK 0xf000000
#define THCON_SEC0_REG7_Unpack_data_format_cntx6_RMW                                                 \
    THCON_SEC0_REG7_Unpack_data_format_cntx6_ADDR32, THCON_SEC0_REG7_Unpack_data_format_cntx6_SHAMT, \
        THCON_SEC0_REG7_Unpack_data_format_cntx6_MASK

#define THCON_SEC0_REG7_Unpack_out_data_format_cntx6_ADDR32 82
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx6_SHAMT 28
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx6_MASK 0xf0000000
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx6_RMW                                                     \
    THCON_SEC0_REG7_Unpack_out_data_format_cntx6_ADDR32, THCON_SEC0_REG7_Unpack_out_data_format_cntx6_SHAMT, \
        THCON_SEC0_REG7_Unpack_out_data_format_cntx6_MASK

#define THCON_SEC0_REG7_Offset_cntx3_address_ADDR32 83
#define THCON_SEC0_REG7_Offset_cntx3_address_SHAMT 0
#define THCON_SEC0_REG7_Offset_cntx3_address_MASK 0xffff
#define THCON_SEC0_REG7_Offset_cntx3_address_RMW                                             \
    THCON_SEC0_REG7_Offset_cntx3_address_ADDR32, THCON_SEC0_REG7_Offset_cntx3_address_SHAMT, \
        THCON_SEC0_REG7_Offset_cntx3_address_MASK

#define THCON_SEC0_REG7_Unpack_data_format_cntx3_ADDR32 83
#define THCON_SEC0_REG7_Unpack_data_format_cntx3_SHAMT 16
#define THCON_SEC0_REG7_Unpack_data_format_cntx3_MASK 0xf0000
#define THCON_SEC0_REG7_Unpack_data_format_cntx3_RMW                                                 \
    THCON_SEC0_REG7_Unpack_data_format_cntx3_ADDR32, THCON_SEC0_REG7_Unpack_data_format_cntx3_SHAMT, \
        THCON_SEC0_REG7_Unpack_data_format_cntx3_MASK

#define THCON_SEC0_REG7_Unpack_out_data_format_cntx3_ADDR32 83
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx3_SHAMT 20
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx3_MASK 0xf00000
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx3_RMW                                                     \
    THCON_SEC0_REG7_Unpack_out_data_format_cntx3_ADDR32, THCON_SEC0_REG7_Unpack_out_data_format_cntx3_SHAMT, \
        THCON_SEC0_REG7_Unpack_out_data_format_cntx3_MASK

#define THCON_SEC0_REG7_Unpack_data_format_cntx7_ADDR32 83
#define THCON_SEC0_REG7_Unpack_data_format_cntx7_SHAMT 24
#define THCON_SEC0_REG7_Unpack_data_format_cntx7_MASK 0xf000000
#define THCON_SEC0_REG7_Unpack_data_format_cntx7_RMW                                                 \
    THCON_SEC0_REG7_Unpack_data_format_cntx7_ADDR32, THCON_SEC0_REG7_Unpack_data_format_cntx7_SHAMT, \
        THCON_SEC0_REG7_Unpack_data_format_cntx7_MASK

#define THCON_SEC0_REG7_Unpack_out_data_format_cntx7_ADDR32 83
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx7_SHAMT 28
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx7_MASK 0xf0000000
#define THCON_SEC0_REG7_Unpack_out_data_format_cntx7_RMW                                                     \
    THCON_SEC0_REG7_Unpack_out_data_format_cntx7_ADDR32, THCON_SEC0_REG7_Unpack_out_data_format_cntx7_SHAMT, \
        THCON_SEC0_REG7_Unpack_out_data_format_cntx7_MASK

#define THCON_SEC0_REG8_Row_start_section_size_ADDR32 84
#define THCON_SEC0_REG8_Row_start_section_size_SHAMT 0
#define THCON_SEC0_REG8_Row_start_section_size_MASK 0xffff
#define THCON_SEC0_REG8_Row_start_section_size_RMW                                               \
    THCON_SEC0_REG8_Row_start_section_size_ADDR32, THCON_SEC0_REG8_Row_start_section_size_SHAMT, \
        THCON_SEC0_REG8_Row_start_section_size_MASK

#define THCON_SEC0_REG8_Exp_section_size_ADDR32 84
#define THCON_SEC0_REG8_Exp_section_size_SHAMT 16
#define THCON_SEC0_REG8_Exp_section_size_MASK 0xffff0000
#define THCON_SEC0_REG8_Exp_section_size_RMW                                         \
    THCON_SEC0_REG8_Exp_section_size_ADDR32, THCON_SEC0_REG8_Exp_section_size_SHAMT, \
        THCON_SEC0_REG8_Exp_section_size_MASK

#define THCON_SEC0_REG8_L1_Dest_addr_ADDR32 85
#define THCON_SEC0_REG8_L1_Dest_addr_SHAMT 0
#define THCON_SEC0_REG8_L1_Dest_addr_MASK 0xffffffff
#define THCON_SEC0_REG8_L1_Dest_addr_RMW \
    THCON_SEC0_REG8_L1_Dest_addr_ADDR32, THCON_SEC0_REG8_L1_Dest_addr_SHAMT, THCON_SEC0_REG8_L1_Dest_addr_MASK

#define THCON_SEC0_REG8_Disable_zero_compress_ADDR32 86
#define THCON_SEC0_REG8_Disable_zero_compress_SHAMT 0
#define THCON_SEC0_REG8_Disable_zero_compress_MASK 0x1
#define THCON_SEC0_REG8_Disable_zero_compress_RMW                                              \
    THCON_SEC0_REG8_Disable_zero_compress_ADDR32, THCON_SEC0_REG8_Disable_zero_compress_SHAMT, \
        THCON_SEC0_REG8_Disable_zero_compress_MASK

#define THCON_SEC0_REG8_Add_l1_dest_addr_offset_ADDR32 86
#define THCON_SEC0_REG8_Add_l1_dest_addr_offset_SHAMT 1
#define THCON_SEC0_REG8_Add_l1_dest_addr_offset_MASK 0x2
#define THCON_SEC0_REG8_Add_l1_dest_addr_offset_RMW                                                \
    THCON_SEC0_REG8_Add_l1_dest_addr_offset_ADDR32, THCON_SEC0_REG8_Add_l1_dest_addr_offset_SHAMT, \
        THCON_SEC0_REG8_Add_l1_dest_addr_offset_MASK

#define THCON_SEC0_REG8_Addr_cnt_context_ADDR32 86
#define THCON_SEC0_REG8_Addr_cnt_context_SHAMT 2
#define THCON_SEC0_REG8_Addr_cnt_context_MASK 0xc
#define THCON_SEC0_REG8_Addr_cnt_context_RMW                                         \
    THCON_SEC0_REG8_Addr_cnt_context_ADDR32, THCON_SEC0_REG8_Addr_cnt_context_SHAMT, \
        THCON_SEC0_REG8_Addr_cnt_context_MASK

#define THCON_SEC0_REG8_Out_data_format_ADDR32 86
#define THCON_SEC0_REG8_Out_data_format_SHAMT 4
#define THCON_SEC0_REG8_Out_data_format_MASK 0xf0
#define THCON_SEC0_REG8_Out_data_format_RMW \
    THCON_SEC0_REG8_Out_data_format_ADDR32, THCON_SEC0_REG8_Out_data_format_SHAMT, THCON_SEC0_REG8_Out_data_format_MASK

#define THCON_SEC0_REG8_In_data_format_ADDR32 86
#define THCON_SEC0_REG8_In_data_format_SHAMT 8
#define THCON_SEC0_REG8_In_data_format_MASK 0xf00
#define THCON_SEC0_REG8_In_data_format_RMW \
    THCON_SEC0_REG8_In_data_format_ADDR32, THCON_SEC0_REG8_In_data_format_SHAMT, THCON_SEC0_REG8_In_data_format_MASK

#define THCON_SEC0_REG8_Dis_shared_exp_assembler_ADDR32 86
#define THCON_SEC0_REG8_Dis_shared_exp_assembler_SHAMT 12
#define THCON_SEC0_REG8_Dis_shared_exp_assembler_MASK 0x1000
#define THCON_SEC0_REG8_Dis_shared_exp_assembler_RMW                                                 \
    THCON_SEC0_REG8_Dis_shared_exp_assembler_ADDR32, THCON_SEC0_REG8_Dis_shared_exp_assembler_SHAMT, \
        THCON_SEC0_REG8_Dis_shared_exp_assembler_MASK

#define THCON_SEC0_REG8_Force_pack_per_max_xy_plane_ADDR32 86
#define THCON_SEC0_REG8_Force_pack_per_max_xy_plane_SHAMT 13
#define THCON_SEC0_REG8_Force_pack_per_max_xy_plane_MASK 0x2000
#define THCON_SEC0_REG8_Force_pack_per_max_xy_plane_RMW                                                    \
    THCON_SEC0_REG8_Force_pack_per_max_xy_plane_ADDR32, THCON_SEC0_REG8_Force_pack_per_max_xy_plane_SHAMT, \
        THCON_SEC0_REG8_Force_pack_per_max_xy_plane_MASK

#define THCON_SEC0_REG8_Enable_out_fifo_ADDR32 86
#define THCON_SEC0_REG8_Enable_out_fifo_SHAMT 14
#define THCON_SEC0_REG8_Enable_out_fifo_MASK 0x4000
#define THCON_SEC0_REG8_Enable_out_fifo_RMW \
    THCON_SEC0_REG8_Enable_out_fifo_ADDR32, THCON_SEC0_REG8_Enable_out_fifo_SHAMT, THCON_SEC0_REG8_Enable_out_fifo_MASK

#define THCON_SEC0_REG8_Sub_l1_tile_header_size_ADDR32 86
#define THCON_SEC0_REG8_Sub_l1_tile_header_size_SHAMT 15
#define THCON_SEC0_REG8_Sub_l1_tile_header_size_MASK 0x8000
#define THCON_SEC0_REG8_Sub_l1_tile_header_size_RMW                                                \
    THCON_SEC0_REG8_Sub_l1_tile_header_size_ADDR32, THCON_SEC0_REG8_Sub_l1_tile_header_size_SHAMT, \
        THCON_SEC0_REG8_Sub_l1_tile_header_size_MASK

#define THCON_SEC0_REG8_Source_interface_selection_ADDR32 86
#define THCON_SEC0_REG8_Source_interface_selection_SHAMT 16
#define THCON_SEC0_REG8_Source_interface_selection_MASK 0x10000
#define THCON_SEC0_REG8_Source_interface_selection_RMW                                                   \
    THCON_SEC0_REG8_Source_interface_selection_ADDR32, THCON_SEC0_REG8_Source_interface_selection_SHAMT, \
        THCON_SEC0_REG8_Source_interface_selection_MASK

#define THCON_SEC0_REG8_Add_tile_header_size_ADDR32 86
#define THCON_SEC0_REG8_Add_tile_header_size_SHAMT 17
#define THCON_SEC0_REG8_Add_tile_header_size_MASK 0x20000
#define THCON_SEC0_REG8_Add_tile_header_size_RMW                                             \
    THCON_SEC0_REG8_Add_tile_header_size_ADDR32, THCON_SEC0_REG8_Add_tile_header_size_SHAMT, \
        THCON_SEC0_REG8_Add_tile_header_size_MASK

#define THCON_SEC0_REG8_L1_source_addr_ADDR32 86
#define THCON_SEC0_REG8_L1_source_addr_SHAMT 24
#define THCON_SEC0_REG8_L1_source_addr_MASK 0xff000000
#define THCON_SEC0_REG8_L1_source_addr_RMW \
    THCON_SEC0_REG8_L1_source_addr_ADDR32, THCON_SEC0_REG8_L1_source_addr_SHAMT, THCON_SEC0_REG8_L1_source_addr_MASK

#define THCON_SEC0_REG8_Downsample_mask_ADDR32 87
#define THCON_SEC0_REG8_Downsample_mask_SHAMT 0
#define THCON_SEC0_REG8_Downsample_mask_MASK 0xffff
#define THCON_SEC0_REG8_Downsample_mask_RMW \
    THCON_SEC0_REG8_Downsample_mask_ADDR32, THCON_SEC0_REG8_Downsample_mask_SHAMT, THCON_SEC0_REG8_Downsample_mask_MASK

#define THCON_SEC0_REG8_Downsample_rate_ADDR32 87
#define THCON_SEC0_REG8_Downsample_rate_SHAMT 16
#define THCON_SEC0_REG8_Downsample_rate_MASK 0x70000
#define THCON_SEC0_REG8_Downsample_rate_RMW \
    THCON_SEC0_REG8_Downsample_rate_ADDR32, THCON_SEC0_REG8_Downsample_rate_SHAMT, THCON_SEC0_REG8_Downsample_rate_MASK

#define THCON_SEC0_REG8_Read_mode_ADDR32 87
#define THCON_SEC0_REG8_Read_mode_SHAMT 19
#define THCON_SEC0_REG8_Read_mode_MASK 0x80000
#define THCON_SEC0_REG8_Read_mode_RMW \
    THCON_SEC0_REG8_Read_mode_ADDR32, THCON_SEC0_REG8_Read_mode_SHAMT, THCON_SEC0_REG8_Read_mode_MASK

#define THCON_SEC0_REG8_Exp_threshold_en_ADDR32 87
#define THCON_SEC0_REG8_Exp_threshold_en_SHAMT 20
#define THCON_SEC0_REG8_Exp_threshold_en_MASK 0x100000
#define THCON_SEC0_REG8_Exp_threshold_en_RMW                                         \
    THCON_SEC0_REG8_Exp_threshold_en_ADDR32, THCON_SEC0_REG8_Exp_threshold_en_SHAMT, \
        THCON_SEC0_REG8_Exp_threshold_en_MASK

#define THCON_SEC0_REG8_Pack_L1_Acc_ADDR32 87
#define THCON_SEC0_REG8_Pack_L1_Acc_SHAMT 21
#define THCON_SEC0_REG8_Pack_L1_Acc_MASK 0x200000
#define THCON_SEC0_REG8_Pack_L1_Acc_RMW \
    THCON_SEC0_REG8_Pack_L1_Acc_ADDR32, THCON_SEC0_REG8_Pack_L1_Acc_SHAMT, THCON_SEC0_REG8_Pack_L1_Acc_MASK

#define THCON_SEC0_REG8_Disable_pack_zero_flags_ADDR32 87
#define THCON_SEC0_REG8_Disable_pack_zero_flags_SHAMT 22
#define THCON_SEC0_REG8_Disable_pack_zero_flags_MASK 0x400000
#define THCON_SEC0_REG8_Disable_pack_zero_flags_RMW                                                \
    THCON_SEC0_REG8_Disable_pack_zero_flags_ADDR32, THCON_SEC0_REG8_Disable_pack_zero_flags_SHAMT, \
        THCON_SEC0_REG8_Disable_pack_zero_flags_MASK

#define THCON_SEC0_REG8_Exp_threshold_ADDR32 87
#define THCON_SEC0_REG8_Exp_threshold_SHAMT 24
#define THCON_SEC0_REG8_Exp_threshold_MASK 0xff000000
#define THCON_SEC0_REG8_Exp_threshold_RMW \
    THCON_SEC0_REG8_Exp_threshold_ADDR32, THCON_SEC0_REG8_Exp_threshold_SHAMT, THCON_SEC0_REG8_Exp_threshold_MASK

#define THCON_SEC0_REG9_Pack_0_2_limit_address_ADDR32 88
#define THCON_SEC0_REG9_Pack_0_2_limit_address_SHAMT 0
#define THCON_SEC0_REG9_Pack_0_2_limit_address_MASK 0x1ffff
#define THCON_SEC0_REG9_Pack_0_2_limit_address_RMW                                               \
    THCON_SEC0_REG9_Pack_0_2_limit_address_ADDR32, THCON_SEC0_REG9_Pack_0_2_limit_address_SHAMT, \
        THCON_SEC0_REG9_Pack_0_2_limit_address_MASK

#define THCON_SEC0_REG9_Pack_0_2_fifo_size_ADDR32 89
#define THCON_SEC0_REG9_Pack_0_2_fifo_size_SHAMT 0
#define THCON_SEC0_REG9_Pack_0_2_fifo_size_MASK 0x1ffff
#define THCON_SEC0_REG9_Pack_0_2_fifo_size_RMW                                           \
    THCON_SEC0_REG9_Pack_0_2_fifo_size_ADDR32, THCON_SEC0_REG9_Pack_0_2_fifo_size_SHAMT, \
        THCON_SEC0_REG9_Pack_0_2_fifo_size_MASK

#define THCON_SEC0_REG9_Pack_1_3_limit_address_ADDR32 90
#define THCON_SEC0_REG9_Pack_1_3_limit_address_SHAMT 0
#define THCON_SEC0_REG9_Pack_1_3_limit_address_MASK 0x1ffff
#define THCON_SEC0_REG9_Pack_1_3_limit_address_RMW                                               \
    THCON_SEC0_REG9_Pack_1_3_limit_address_ADDR32, THCON_SEC0_REG9_Pack_1_3_limit_address_SHAMT, \
        THCON_SEC0_REG9_Pack_1_3_limit_address_MASK

#define THCON_SEC0_REG9_Pack_1_3_fifo_size_ADDR32 91
#define THCON_SEC0_REG9_Pack_1_3_fifo_size_SHAMT 0
#define THCON_SEC0_REG9_Pack_1_3_fifo_size_MASK 0x1ffff
#define THCON_SEC0_REG9_Pack_1_3_fifo_size_RMW                                           \
    THCON_SEC0_REG9_Pack_1_3_fifo_size_ADDR32, THCON_SEC0_REG9_Pack_1_3_fifo_size_SHAMT, \
        THCON_SEC0_REG9_Pack_1_3_fifo_size_MASK

#define THCON_SEC1_REG0_TileDescriptor_ADDR32 92
#define THCON_SEC1_REG0_TileDescriptor_SHAMT 0
#define THCON_SEC1_REG0_TileDescriptor_MASK 0xffffffffffffffffffffffffffffffff
#define THCON_SEC1_REG0_TileDescriptor_RMW \
    THCON_SEC1_REG0_TileDescriptor_ADDR32, THCON_SEC1_REG0_TileDescriptor_SHAMT, THCON_SEC1_REG0_TileDescriptor_MASK

#define THCON_SEC1_REG1_Row_start_section_size_ADDR32 96
#define THCON_SEC1_REG1_Row_start_section_size_SHAMT 0
#define THCON_SEC1_REG1_Row_start_section_size_MASK 0xffff
#define THCON_SEC1_REG1_Row_start_section_size_RMW                                               \
    THCON_SEC1_REG1_Row_start_section_size_ADDR32, THCON_SEC1_REG1_Row_start_section_size_SHAMT, \
        THCON_SEC1_REG1_Row_start_section_size_MASK

#define THCON_SEC1_REG1_Exp_section_size_ADDR32 96
#define THCON_SEC1_REG1_Exp_section_size_SHAMT 16
#define THCON_SEC1_REG1_Exp_section_size_MASK 0xffff0000
#define THCON_SEC1_REG1_Exp_section_size_RMW                                         \
    THCON_SEC1_REG1_Exp_section_size_ADDR32, THCON_SEC1_REG1_Exp_section_size_SHAMT, \
        THCON_SEC1_REG1_Exp_section_size_MASK

#define THCON_SEC1_REG1_L1_Dest_addr_ADDR32 97
#define THCON_SEC1_REG1_L1_Dest_addr_SHAMT 0
#define THCON_SEC1_REG1_L1_Dest_addr_MASK 0xffffffff
#define THCON_SEC1_REG1_L1_Dest_addr_RMW \
    THCON_SEC1_REG1_L1_Dest_addr_ADDR32, THCON_SEC1_REG1_L1_Dest_addr_SHAMT, THCON_SEC1_REG1_L1_Dest_addr_MASK

#define THCON_SEC1_REG1_Disable_zero_compress_ADDR32 98
#define THCON_SEC1_REG1_Disable_zero_compress_SHAMT 0
#define THCON_SEC1_REG1_Disable_zero_compress_MASK 0x1
#define THCON_SEC1_REG1_Disable_zero_compress_RMW                                              \
    THCON_SEC1_REG1_Disable_zero_compress_ADDR32, THCON_SEC1_REG1_Disable_zero_compress_SHAMT, \
        THCON_SEC1_REG1_Disable_zero_compress_MASK

#define THCON_SEC1_REG1_Add_l1_dest_addr_offset_ADDR32 98
#define THCON_SEC1_REG1_Add_l1_dest_addr_offset_SHAMT 1
#define THCON_SEC1_REG1_Add_l1_dest_addr_offset_MASK 0x2
#define THCON_SEC1_REG1_Add_l1_dest_addr_offset_RMW                                                \
    THCON_SEC1_REG1_Add_l1_dest_addr_offset_ADDR32, THCON_SEC1_REG1_Add_l1_dest_addr_offset_SHAMT, \
        THCON_SEC1_REG1_Add_l1_dest_addr_offset_MASK

#define THCON_SEC1_REG1_Addr_cnt_context_ADDR32 98
#define THCON_SEC1_REG1_Addr_cnt_context_SHAMT 2
#define THCON_SEC1_REG1_Addr_cnt_context_MASK 0xc
#define THCON_SEC1_REG1_Addr_cnt_context_RMW                                         \
    THCON_SEC1_REG1_Addr_cnt_context_ADDR32, THCON_SEC1_REG1_Addr_cnt_context_SHAMT, \
        THCON_SEC1_REG1_Addr_cnt_context_MASK

#define THCON_SEC1_REG1_Out_data_format_ADDR32 98
#define THCON_SEC1_REG1_Out_data_format_SHAMT 4
#define THCON_SEC1_REG1_Out_data_format_MASK 0xf0
#define THCON_SEC1_REG1_Out_data_format_RMW \
    THCON_SEC1_REG1_Out_data_format_ADDR32, THCON_SEC1_REG1_Out_data_format_SHAMT, THCON_SEC1_REG1_Out_data_format_MASK

#define THCON_SEC1_REG1_In_data_format_ADDR32 98
#define THCON_SEC1_REG1_In_data_format_SHAMT 8
#define THCON_SEC1_REG1_In_data_format_MASK 0xf00
#define THCON_SEC1_REG1_In_data_format_RMW \
    THCON_SEC1_REG1_In_data_format_ADDR32, THCON_SEC1_REG1_In_data_format_SHAMT, THCON_SEC1_REG1_In_data_format_MASK

#define THCON_SEC1_REG1_Dis_shared_exp_assembler_ADDR32 98
#define THCON_SEC1_REG1_Dis_shared_exp_assembler_SHAMT 12
#define THCON_SEC1_REG1_Dis_shared_exp_assembler_MASK 0x1000
#define THCON_SEC1_REG1_Dis_shared_exp_assembler_RMW                                                 \
    THCON_SEC1_REG1_Dis_shared_exp_assembler_ADDR32, THCON_SEC1_REG1_Dis_shared_exp_assembler_SHAMT, \
        THCON_SEC1_REG1_Dis_shared_exp_assembler_MASK

#define THCON_SEC1_REG1_Force_pack_per_max_xy_plane_ADDR32 98
#define THCON_SEC1_REG1_Force_pack_per_max_xy_plane_SHAMT 13
#define THCON_SEC1_REG1_Force_pack_per_max_xy_plane_MASK 0x2000
#define THCON_SEC1_REG1_Force_pack_per_max_xy_plane_RMW                                                    \
    THCON_SEC1_REG1_Force_pack_per_max_xy_plane_ADDR32, THCON_SEC1_REG1_Force_pack_per_max_xy_plane_SHAMT, \
        THCON_SEC1_REG1_Force_pack_per_max_xy_plane_MASK

#define THCON_SEC1_REG1_Enable_out_fifo_ADDR32 98
#define THCON_SEC1_REG1_Enable_out_fifo_SHAMT 14
#define THCON_SEC1_REG1_Enable_out_fifo_MASK 0x4000
#define THCON_SEC1_REG1_Enable_out_fifo_RMW \
    THCON_SEC1_REG1_Enable_out_fifo_ADDR32, THCON_SEC1_REG1_Enable_out_fifo_SHAMT, THCON_SEC1_REG1_Enable_out_fifo_MASK

#define THCON_SEC1_REG1_Sub_l1_tile_header_size_ADDR32 98
#define THCON_SEC1_REG1_Sub_l1_tile_header_size_SHAMT 15
#define THCON_SEC1_REG1_Sub_l1_tile_header_size_MASK 0x8000
#define THCON_SEC1_REG1_Sub_l1_tile_header_size_RMW                                                \
    THCON_SEC1_REG1_Sub_l1_tile_header_size_ADDR32, THCON_SEC1_REG1_Sub_l1_tile_header_size_SHAMT, \
        THCON_SEC1_REG1_Sub_l1_tile_header_size_MASK

#define THCON_SEC1_REG1_Source_interface_selection_ADDR32 98
#define THCON_SEC1_REG1_Source_interface_selection_SHAMT 16
#define THCON_SEC1_REG1_Source_interface_selection_MASK 0x10000
#define THCON_SEC1_REG1_Source_interface_selection_RMW                                                   \
    THCON_SEC1_REG1_Source_interface_selection_ADDR32, THCON_SEC1_REG1_Source_interface_selection_SHAMT, \
        THCON_SEC1_REG1_Source_interface_selection_MASK

#define THCON_SEC1_REG1_All_pack_disable_zero_compress_ADDR32 98
#define THCON_SEC1_REG1_All_pack_disable_zero_compress_SHAMT 17
#define THCON_SEC1_REG1_All_pack_disable_zero_compress_MASK 0x1e0000
#define THCON_SEC1_REG1_All_pack_disable_zero_compress_RMW                                                       \
    THCON_SEC1_REG1_All_pack_disable_zero_compress_ADDR32, THCON_SEC1_REG1_All_pack_disable_zero_compress_SHAMT, \
        THCON_SEC1_REG1_All_pack_disable_zero_compress_MASK

#define THCON_SEC1_REG1_All_pack_disable_zero_compress_ovrd_ADDR32 98
#define THCON_SEC1_REG1_All_pack_disable_zero_compress_ovrd_SHAMT 21
#define THCON_SEC1_REG1_All_pack_disable_zero_compress_ovrd_MASK 0x200000
#define THCON_SEC1_REG1_All_pack_disable_zero_compress_ovrd_RMW    \
    THCON_SEC1_REG1_All_pack_disable_zero_compress_ovrd_ADDR32,    \
        THCON_SEC1_REG1_All_pack_disable_zero_compress_ovrd_SHAMT, \
        THCON_SEC1_REG1_All_pack_disable_zero_compress_ovrd_MASK

#define THCON_SEC1_REG1_Add_tile_header_size_ADDR32 98
#define THCON_SEC1_REG1_Add_tile_header_size_SHAMT 22
#define THCON_SEC1_REG1_Add_tile_header_size_MASK 0x400000
#define THCON_SEC1_REG1_Add_tile_header_size_RMW                                             \
    THCON_SEC1_REG1_Add_tile_header_size_ADDR32, THCON_SEC1_REG1_Add_tile_header_size_SHAMT, \
        THCON_SEC1_REG1_Add_tile_header_size_MASK

#define THCON_SEC1_REG1_L1_source_addr_ADDR32 98
#define THCON_SEC1_REG1_L1_source_addr_SHAMT 24
#define THCON_SEC1_REG1_L1_source_addr_MASK 0xff000000
#define THCON_SEC1_REG1_L1_source_addr_RMW \
    THCON_SEC1_REG1_L1_source_addr_ADDR32, THCON_SEC1_REG1_L1_source_addr_SHAMT, THCON_SEC1_REG1_L1_source_addr_MASK

#define THCON_SEC1_REG1_Downsample_mask_ADDR32 99
#define THCON_SEC1_REG1_Downsample_mask_SHAMT 0
#define THCON_SEC1_REG1_Downsample_mask_MASK 0xffff
#define THCON_SEC1_REG1_Downsample_mask_RMW \
    THCON_SEC1_REG1_Downsample_mask_ADDR32, THCON_SEC1_REG1_Downsample_mask_SHAMT, THCON_SEC1_REG1_Downsample_mask_MASK

#define THCON_SEC1_REG1_Downsample_rate_ADDR32 99
#define THCON_SEC1_REG1_Downsample_rate_SHAMT 16
#define THCON_SEC1_REG1_Downsample_rate_MASK 0x70000
#define THCON_SEC1_REG1_Downsample_rate_RMW \
    THCON_SEC1_REG1_Downsample_rate_ADDR32, THCON_SEC1_REG1_Downsample_rate_SHAMT, THCON_SEC1_REG1_Downsample_rate_MASK

#define THCON_SEC1_REG1_Read_mode_ADDR32 99
#define THCON_SEC1_REG1_Read_mode_SHAMT 19
#define THCON_SEC1_REG1_Read_mode_MASK 0x80000
#define THCON_SEC1_REG1_Read_mode_RMW \
    THCON_SEC1_REG1_Read_mode_ADDR32, THCON_SEC1_REG1_Read_mode_SHAMT, THCON_SEC1_REG1_Read_mode_MASK

#define THCON_SEC1_REG1_Exp_threshold_en_ADDR32 99
#define THCON_SEC1_REG1_Exp_threshold_en_SHAMT 20
#define THCON_SEC1_REG1_Exp_threshold_en_MASK 0x100000
#define THCON_SEC1_REG1_Exp_threshold_en_RMW                                         \
    THCON_SEC1_REG1_Exp_threshold_en_ADDR32, THCON_SEC1_REG1_Exp_threshold_en_SHAMT, \
        THCON_SEC1_REG1_Exp_threshold_en_MASK

#define THCON_SEC1_REG1_Pack_L1_Acc_ADDR32 99
#define THCON_SEC1_REG1_Pack_L1_Acc_SHAMT 21
#define THCON_SEC1_REG1_Pack_L1_Acc_MASK 0x200000
#define THCON_SEC1_REG1_Pack_L1_Acc_RMW \
    THCON_SEC1_REG1_Pack_L1_Acc_ADDR32, THCON_SEC1_REG1_Pack_L1_Acc_SHAMT, THCON_SEC1_REG1_Pack_L1_Acc_MASK

#define THCON_SEC1_REG1_Disable_pack_zero_flags_ADDR32 99
#define THCON_SEC1_REG1_Disable_pack_zero_flags_SHAMT 22
#define THCON_SEC1_REG1_Disable_pack_zero_flags_MASK 0x400000
#define THCON_SEC1_REG1_Disable_pack_zero_flags_RMW                                                \
    THCON_SEC1_REG1_Disable_pack_zero_flags_ADDR32, THCON_SEC1_REG1_Disable_pack_zero_flags_SHAMT, \
        THCON_SEC1_REG1_Disable_pack_zero_flags_MASK

#define THCON_SEC1_REG1_Exp_threshold_ADDR32 99
#define THCON_SEC1_REG1_Exp_threshold_SHAMT 24
#define THCON_SEC1_REG1_Exp_threshold_MASK 0xff000000
#define THCON_SEC1_REG1_Exp_threshold_RMW \
    THCON_SEC1_REG1_Exp_threshold_ADDR32, THCON_SEC1_REG1_Exp_threshold_SHAMT, THCON_SEC1_REG1_Exp_threshold_MASK

#define THCON_SEC1_REG2_Out_data_format_ADDR32 100
#define THCON_SEC1_REG2_Out_data_format_SHAMT 0
#define THCON_SEC1_REG2_Out_data_format_MASK 0xf
#define THCON_SEC1_REG2_Out_data_format_RMW \
    THCON_SEC1_REG2_Out_data_format_ADDR32, THCON_SEC1_REG2_Out_data_format_SHAMT, THCON_SEC1_REG2_Out_data_format_MASK

#define THCON_SEC1_REG2_Throttle_mode_ADDR32 100
#define THCON_SEC1_REG2_Throttle_mode_SHAMT 4
#define THCON_SEC1_REG2_Throttle_mode_MASK 0x30
#define THCON_SEC1_REG2_Throttle_mode_RMW \
    THCON_SEC1_REG2_Throttle_mode_ADDR32, THCON_SEC1_REG2_Throttle_mode_SHAMT, THCON_SEC1_REG2_Throttle_mode_MASK

#define THCON_SEC1_REG2_Context_count_ADDR32 100
#define THCON_SEC1_REG2_Context_count_SHAMT 6
#define THCON_SEC1_REG2_Context_count_MASK 0xc0
#define THCON_SEC1_REG2_Context_count_RMW \
    THCON_SEC1_REG2_Context_count_ADDR32, THCON_SEC1_REG2_Context_count_SHAMT, THCON_SEC1_REG2_Context_count_MASK

#define THCON_SEC1_REG2_Haloize_mode_ADDR32 100
#define THCON_SEC1_REG2_Haloize_mode_SHAMT 8
#define THCON_SEC1_REG2_Haloize_mode_MASK 0x100
#define THCON_SEC1_REG2_Haloize_mode_RMW \
    THCON_SEC1_REG2_Haloize_mode_ADDR32, THCON_SEC1_REG2_Haloize_mode_SHAMT, THCON_SEC1_REG2_Haloize_mode_MASK

#define THCON_SEC1_REG2_Tileize_mode_ADDR32 100
#define THCON_SEC1_REG2_Tileize_mode_SHAMT 9
#define THCON_SEC1_REG2_Tileize_mode_MASK 0x200
#define THCON_SEC1_REG2_Tileize_mode_RMW \
    THCON_SEC1_REG2_Tileize_mode_ADDR32, THCON_SEC1_REG2_Tileize_mode_SHAMT, THCON_SEC1_REG2_Tileize_mode_MASK

#define THCON_SEC1_REG2_Unpack_Src_Reg_Set_Upd_ADDR32 100
#define THCON_SEC1_REG2_Unpack_Src_Reg_Set_Upd_SHAMT 10
#define THCON_SEC1_REG2_Unpack_Src_Reg_Set_Upd_MASK 0x400
#define THCON_SEC1_REG2_Unpack_Src_Reg_Set_Upd_RMW                                               \
    THCON_SEC1_REG2_Unpack_Src_Reg_Set_Upd_ADDR32, THCON_SEC1_REG2_Unpack_Src_Reg_Set_Upd_SHAMT, \
        THCON_SEC1_REG2_Unpack_Src_Reg_Set_Upd_MASK

#define THCON_SEC1_REG2_Unpack_If_Sel_ADDR32 100
#define THCON_SEC1_REG2_Unpack_If_Sel_SHAMT 11
#define THCON_SEC1_REG2_Unpack_If_Sel_MASK 0x800
#define THCON_SEC1_REG2_Unpack_If_Sel_RMW \
    THCON_SEC1_REG2_Unpack_If_Sel_ADDR32, THCON_SEC1_REG2_Unpack_If_Sel_SHAMT, THCON_SEC1_REG2_Unpack_If_Sel_MASK

#define THCON_SEC1_REG2_Upsample_rate_ADDR32 100
#define THCON_SEC1_REG2_Upsample_rate_SHAMT 12
#define THCON_SEC1_REG2_Upsample_rate_MASK 0x3000
#define THCON_SEC1_REG2_Upsample_rate_RMW \
    THCON_SEC1_REG2_Upsample_rate_ADDR32, THCON_SEC1_REG2_Upsample_rate_SHAMT, THCON_SEC1_REG2_Upsample_rate_MASK

#define THCON_SEC1_REG2_Ovrd_data_format_ADDR32 100
#define THCON_SEC1_REG2_Ovrd_data_format_SHAMT 14
#define THCON_SEC1_REG2_Ovrd_data_format_MASK 0x4000
#define THCON_SEC1_REG2_Ovrd_data_format_RMW                                         \
    THCON_SEC1_REG2_Ovrd_data_format_ADDR32, THCON_SEC1_REG2_Ovrd_data_format_SHAMT, \
        THCON_SEC1_REG2_Ovrd_data_format_MASK

#define THCON_SEC1_REG2_Upsample_and_interleave_ADDR32 100
#define THCON_SEC1_REG2_Upsample_and_interleave_SHAMT 15
#define THCON_SEC1_REG2_Upsample_and_interleave_MASK 0x8000
#define THCON_SEC1_REG2_Upsample_and_interleave_RMW                                                \
    THCON_SEC1_REG2_Upsample_and_interleave_ADDR32, THCON_SEC1_REG2_Upsample_and_interleave_SHAMT, \
        THCON_SEC1_REG2_Upsample_and_interleave_MASK

#define THCON_SEC1_REG2_Shift_amount_cntx0_ADDR32 100
#define THCON_SEC1_REG2_Shift_amount_cntx0_SHAMT 16
#define THCON_SEC1_REG2_Shift_amount_cntx0_MASK 0xf0000
#define THCON_SEC1_REG2_Shift_amount_cntx0_RMW                                           \
    THCON_SEC1_REG2_Shift_amount_cntx0_ADDR32, THCON_SEC1_REG2_Shift_amount_cntx0_SHAMT, \
        THCON_SEC1_REG2_Shift_amount_cntx0_MASK

#define THCON_SEC1_REG2_Shift_amount_cntx1_ADDR32 100
#define THCON_SEC1_REG2_Shift_amount_cntx1_SHAMT 20
#define THCON_SEC1_REG2_Shift_amount_cntx1_MASK 0xf00000
#define THCON_SEC1_REG2_Shift_amount_cntx1_RMW                                           \
    THCON_SEC1_REG2_Shift_amount_cntx1_ADDR32, THCON_SEC1_REG2_Shift_amount_cntx1_SHAMT, \
        THCON_SEC1_REG2_Shift_amount_cntx1_MASK

#define THCON_SEC1_REG2_Shift_amount_cntx2_ADDR32 100
#define THCON_SEC1_REG2_Shift_amount_cntx2_SHAMT 24
#define THCON_SEC1_REG2_Shift_amount_cntx2_MASK 0xf000000
#define THCON_SEC1_REG2_Shift_amount_cntx2_RMW                                           \
    THCON_SEC1_REG2_Shift_amount_cntx2_ADDR32, THCON_SEC1_REG2_Shift_amount_cntx2_SHAMT, \
        THCON_SEC1_REG2_Shift_amount_cntx2_MASK

#define THCON_SEC1_REG2_Shift_amount_cntx3_ADDR32 100
#define THCON_SEC1_REG2_Shift_amount_cntx3_SHAMT 28
#define THCON_SEC1_REG2_Shift_amount_cntx3_MASK 0xf0000000
#define THCON_SEC1_REG2_Shift_amount_cntx3_RMW                                           \
    THCON_SEC1_REG2_Shift_amount_cntx3_ADDR32, THCON_SEC1_REG2_Shift_amount_cntx3_SHAMT, \
        THCON_SEC1_REG2_Shift_amount_cntx3_MASK

#define THCON_SEC1_REG2_Disable_zero_compress_cntx0_ADDR32 101
#define THCON_SEC1_REG2_Disable_zero_compress_cntx0_SHAMT 0
#define THCON_SEC1_REG2_Disable_zero_compress_cntx0_MASK 0x1
#define THCON_SEC1_REG2_Disable_zero_compress_cntx0_RMW                                                    \
    THCON_SEC1_REG2_Disable_zero_compress_cntx0_ADDR32, THCON_SEC1_REG2_Disable_zero_compress_cntx0_SHAMT, \
        THCON_SEC1_REG2_Disable_zero_compress_cntx0_MASK

#define THCON_SEC1_REG2_Disable_zero_compress_cntx1_ADDR32 101
#define THCON_SEC1_REG2_Disable_zero_compress_cntx1_SHAMT 1
#define THCON_SEC1_REG2_Disable_zero_compress_cntx1_MASK 0x2
#define THCON_SEC1_REG2_Disable_zero_compress_cntx1_RMW                                                    \
    THCON_SEC1_REG2_Disable_zero_compress_cntx1_ADDR32, THCON_SEC1_REG2_Disable_zero_compress_cntx1_SHAMT, \
        THCON_SEC1_REG2_Disable_zero_compress_cntx1_MASK

#define THCON_SEC1_REG2_Disable_zero_compress_cntx2_ADDR32 101
#define THCON_SEC1_REG2_Disable_zero_compress_cntx2_SHAMT 2
#define THCON_SEC1_REG2_Disable_zero_compress_cntx2_MASK 0x4
#define THCON_SEC1_REG2_Disable_zero_compress_cntx2_RMW                                                    \
    THCON_SEC1_REG2_Disable_zero_compress_cntx2_ADDR32, THCON_SEC1_REG2_Disable_zero_compress_cntx2_SHAMT, \
        THCON_SEC1_REG2_Disable_zero_compress_cntx2_MASK

#define THCON_SEC1_REG2_Disable_zero_compress_cntx3_ADDR32 101
#define THCON_SEC1_REG2_Disable_zero_compress_cntx3_SHAMT 3
#define THCON_SEC1_REG2_Disable_zero_compress_cntx3_MASK 0x8
#define THCON_SEC1_REG2_Disable_zero_compress_cntx3_RMW                                                    \
    THCON_SEC1_REG2_Disable_zero_compress_cntx3_ADDR32, THCON_SEC1_REG2_Disable_zero_compress_cntx3_SHAMT, \
        THCON_SEC1_REG2_Disable_zero_compress_cntx3_MASK

#define THCON_SEC1_REG2_Unpack_if_sel_cntx0_ADDR32 101
#define THCON_SEC1_REG2_Unpack_if_sel_cntx0_SHAMT 4
#define THCON_SEC1_REG2_Unpack_if_sel_cntx0_MASK 0x10
#define THCON_SEC1_REG2_Unpack_if_sel_cntx0_RMW                                            \
    THCON_SEC1_REG2_Unpack_if_sel_cntx0_ADDR32, THCON_SEC1_REG2_Unpack_if_sel_cntx0_SHAMT, \
        THCON_SEC1_REG2_Unpack_if_sel_cntx0_MASK

#define THCON_SEC1_REG2_Unpack_if_sel_cntx1_ADDR32 101
#define THCON_SEC1_REG2_Unpack_if_sel_cntx1_SHAMT 5
#define THCON_SEC1_REG2_Unpack_if_sel_cntx1_MASK 0x20
#define THCON_SEC1_REG2_Unpack_if_sel_cntx1_RMW                                            \
    THCON_SEC1_REG2_Unpack_if_sel_cntx1_ADDR32, THCON_SEC1_REG2_Unpack_if_sel_cntx1_SHAMT, \
        THCON_SEC1_REG2_Unpack_if_sel_cntx1_MASK

#define THCON_SEC1_REG2_Unpack_if_sel_cntx2_ADDR32 101
#define THCON_SEC1_REG2_Unpack_if_sel_cntx2_SHAMT 6
#define THCON_SEC1_REG2_Unpack_if_sel_cntx2_MASK 0x40
#define THCON_SEC1_REG2_Unpack_if_sel_cntx2_RMW                                            \
    THCON_SEC1_REG2_Unpack_if_sel_cntx2_ADDR32, THCON_SEC1_REG2_Unpack_if_sel_cntx2_SHAMT, \
        THCON_SEC1_REG2_Unpack_if_sel_cntx2_MASK

#define THCON_SEC1_REG2_Unpack_if_sel_cntx3_ADDR32 101
#define THCON_SEC1_REG2_Unpack_if_sel_cntx3_SHAMT 7
#define THCON_SEC1_REG2_Unpack_if_sel_cntx3_MASK 0x80
#define THCON_SEC1_REG2_Unpack_if_sel_cntx3_RMW                                            \
    THCON_SEC1_REG2_Unpack_if_sel_cntx3_ADDR32, THCON_SEC1_REG2_Unpack_if_sel_cntx3_SHAMT, \
        THCON_SEC1_REG2_Unpack_if_sel_cntx3_MASK

#define THCON_SEC1_REG2_Force_shared_exp_ADDR32 101
#define THCON_SEC1_REG2_Force_shared_exp_SHAMT 8
#define THCON_SEC1_REG2_Force_shared_exp_MASK 0x100
#define THCON_SEC1_REG2_Force_shared_exp_RMW                                         \
    THCON_SEC1_REG2_Force_shared_exp_ADDR32, THCON_SEC1_REG2_Force_shared_exp_SHAMT, \
        THCON_SEC1_REG2_Force_shared_exp_MASK

#define THCON_SEC1_REG2_Disable_zero_compress_cntx4_ADDR32 101
#define THCON_SEC1_REG2_Disable_zero_compress_cntx4_SHAMT 16
#define THCON_SEC1_REG2_Disable_zero_compress_cntx4_MASK 0x10000
#define THCON_SEC1_REG2_Disable_zero_compress_cntx4_RMW                                                    \
    THCON_SEC1_REG2_Disable_zero_compress_cntx4_ADDR32, THCON_SEC1_REG2_Disable_zero_compress_cntx4_SHAMT, \
        THCON_SEC1_REG2_Disable_zero_compress_cntx4_MASK

#define THCON_SEC1_REG2_Disable_zero_compress_cntx5_ADDR32 101
#define THCON_SEC1_REG2_Disable_zero_compress_cntx5_SHAMT 17
#define THCON_SEC1_REG2_Disable_zero_compress_cntx5_MASK 0x20000
#define THCON_SEC1_REG2_Disable_zero_compress_cntx5_RMW                                                    \
    THCON_SEC1_REG2_Disable_zero_compress_cntx5_ADDR32, THCON_SEC1_REG2_Disable_zero_compress_cntx5_SHAMT, \
        THCON_SEC1_REG2_Disable_zero_compress_cntx5_MASK

#define THCON_SEC1_REG2_Disable_zero_compress_cntx6_ADDR32 101
#define THCON_SEC1_REG2_Disable_zero_compress_cntx6_SHAMT 18
#define THCON_SEC1_REG2_Disable_zero_compress_cntx6_MASK 0x40000
#define THCON_SEC1_REG2_Disable_zero_compress_cntx6_RMW                                                    \
    THCON_SEC1_REG2_Disable_zero_compress_cntx6_ADDR32, THCON_SEC1_REG2_Disable_zero_compress_cntx6_SHAMT, \
        THCON_SEC1_REG2_Disable_zero_compress_cntx6_MASK

#define THCON_SEC1_REG2_Disable_zero_compress_cntx7_ADDR32 101
#define THCON_SEC1_REG2_Disable_zero_compress_cntx7_SHAMT 19
#define THCON_SEC1_REG2_Disable_zero_compress_cntx7_MASK 0x80000
#define THCON_SEC1_REG2_Disable_zero_compress_cntx7_RMW                                                    \
    THCON_SEC1_REG2_Disable_zero_compress_cntx7_ADDR32, THCON_SEC1_REG2_Disable_zero_compress_cntx7_SHAMT, \
        THCON_SEC1_REG2_Disable_zero_compress_cntx7_MASK

#define THCON_SEC1_REG2_Unpack_if_sel_cntx4_ADDR32 101
#define THCON_SEC1_REG2_Unpack_if_sel_cntx4_SHAMT 20
#define THCON_SEC1_REG2_Unpack_if_sel_cntx4_MASK 0x100000
#define THCON_SEC1_REG2_Unpack_if_sel_cntx4_RMW                                            \
    THCON_SEC1_REG2_Unpack_if_sel_cntx4_ADDR32, THCON_SEC1_REG2_Unpack_if_sel_cntx4_SHAMT, \
        THCON_SEC1_REG2_Unpack_if_sel_cntx4_MASK

#define THCON_SEC1_REG2_Unpack_if_sel_cntx5_ADDR32 101
#define THCON_SEC1_REG2_Unpack_if_sel_cntx5_SHAMT 21
#define THCON_SEC1_REG2_Unpack_if_sel_cntx5_MASK 0x200000
#define THCON_SEC1_REG2_Unpack_if_sel_cntx5_RMW                                            \
    THCON_SEC1_REG2_Unpack_if_sel_cntx5_ADDR32, THCON_SEC1_REG2_Unpack_if_sel_cntx5_SHAMT, \
        THCON_SEC1_REG2_Unpack_if_sel_cntx5_MASK

#define THCON_SEC1_REG2_Unpack_if_sel_cntx6_ADDR32 101
#define THCON_SEC1_REG2_Unpack_if_sel_cntx6_SHAMT 22
#define THCON_SEC1_REG2_Unpack_if_sel_cntx6_MASK 0x400000
#define THCON_SEC1_REG2_Unpack_if_sel_cntx6_RMW                                            \
    THCON_SEC1_REG2_Unpack_if_sel_cntx6_ADDR32, THCON_SEC1_REG2_Unpack_if_sel_cntx6_SHAMT, \
        THCON_SEC1_REG2_Unpack_if_sel_cntx6_MASK

#define THCON_SEC1_REG2_Unpack_if_sel_cntx7_ADDR32 101
#define THCON_SEC1_REG2_Unpack_if_sel_cntx7_SHAMT 23
#define THCON_SEC1_REG2_Unpack_if_sel_cntx7_MASK 0x800000
#define THCON_SEC1_REG2_Unpack_if_sel_cntx7_RMW                                            \
    THCON_SEC1_REG2_Unpack_if_sel_cntx7_ADDR32, THCON_SEC1_REG2_Unpack_if_sel_cntx7_SHAMT, \
        THCON_SEC1_REG2_Unpack_if_sel_cntx7_MASK

#define THCON_SEC1_REG2_Unpack_limit_address_ADDR32 102
#define THCON_SEC1_REG2_Unpack_limit_address_SHAMT 0
#define THCON_SEC1_REG2_Unpack_limit_address_MASK 0x1ffff
#define THCON_SEC1_REG2_Unpack_limit_address_RMW                                             \
    THCON_SEC1_REG2_Unpack_limit_address_ADDR32, THCON_SEC1_REG2_Unpack_limit_address_SHAMT, \
        THCON_SEC1_REG2_Unpack_limit_address_MASK

#define THCON_SEC1_REG2_Unpack_fifo_size_ADDR32 103
#define THCON_SEC1_REG2_Unpack_fifo_size_SHAMT 0
#define THCON_SEC1_REG2_Unpack_fifo_size_MASK 0x1ffff
#define THCON_SEC1_REG2_Unpack_fifo_size_RMW                                         \
    THCON_SEC1_REG2_Unpack_fifo_size_ADDR32, THCON_SEC1_REG2_Unpack_fifo_size_SHAMT, \
        THCON_SEC1_REG2_Unpack_fifo_size_MASK

#define THCON_SEC1_REG3_Base_address_ADDR32 104
#define THCON_SEC1_REG3_Base_address_SHAMT 0
#define THCON_SEC1_REG3_Base_address_MASK 0xffffffff
#define THCON_SEC1_REG3_Base_address_RMW \
    THCON_SEC1_REG3_Base_address_ADDR32, THCON_SEC1_REG3_Base_address_SHAMT, THCON_SEC1_REG3_Base_address_MASK

#define THCON_SEC1_REG3_Base_cntx1_address_ADDR32 105
#define THCON_SEC1_REG3_Base_cntx1_address_SHAMT 0
#define THCON_SEC1_REG3_Base_cntx1_address_MASK 0xffffffff
#define THCON_SEC1_REG3_Base_cntx1_address_RMW                                           \
    THCON_SEC1_REG3_Base_cntx1_address_ADDR32, THCON_SEC1_REG3_Base_cntx1_address_SHAMT, \
        THCON_SEC1_REG3_Base_cntx1_address_MASK

#define THCON_SEC1_REG3_Base_cntx2_address_ADDR32 106
#define THCON_SEC1_REG3_Base_cntx2_address_SHAMT 0
#define THCON_SEC1_REG3_Base_cntx2_address_MASK 0xffffffff
#define THCON_SEC1_REG3_Base_cntx2_address_RMW                                           \
    THCON_SEC1_REG3_Base_cntx2_address_ADDR32, THCON_SEC1_REG3_Base_cntx2_address_SHAMT, \
        THCON_SEC1_REG3_Base_cntx2_address_MASK

#define THCON_SEC1_REG3_Base_cntx3_address_ADDR32 107
#define THCON_SEC1_REG3_Base_cntx3_address_SHAMT 0
#define THCON_SEC1_REG3_Base_cntx3_address_MASK 0xffffffff
#define THCON_SEC1_REG3_Base_cntx3_address_RMW                                           \
    THCON_SEC1_REG3_Base_cntx3_address_ADDR32, THCON_SEC1_REG3_Base_cntx3_address_SHAMT, \
        THCON_SEC1_REG3_Base_cntx3_address_MASK

#define THCON_SEC1_REG4_Base_cntx4_address_ADDR32 108
#define THCON_SEC1_REG4_Base_cntx4_address_SHAMT 0
#define THCON_SEC1_REG4_Base_cntx4_address_MASK 0xffffffff
#define THCON_SEC1_REG4_Base_cntx4_address_RMW                                           \
    THCON_SEC1_REG4_Base_cntx4_address_ADDR32, THCON_SEC1_REG4_Base_cntx4_address_SHAMT, \
        THCON_SEC1_REG4_Base_cntx4_address_MASK

#define THCON_SEC1_REG4_Base_cntx5_address_ADDR32 109
#define THCON_SEC1_REG4_Base_cntx5_address_SHAMT 0
#define THCON_SEC1_REG4_Base_cntx5_address_MASK 0xffffffff
#define THCON_SEC1_REG4_Base_cntx5_address_RMW                                           \
    THCON_SEC1_REG4_Base_cntx5_address_ADDR32, THCON_SEC1_REG4_Base_cntx5_address_SHAMT, \
        THCON_SEC1_REG4_Base_cntx5_address_MASK

#define THCON_SEC1_REG4_Base_cntx6_address_ADDR32 110
#define THCON_SEC1_REG4_Base_cntx6_address_SHAMT 0
#define THCON_SEC1_REG4_Base_cntx6_address_MASK 0xffffffff
#define THCON_SEC1_REG4_Base_cntx6_address_RMW                                           \
    THCON_SEC1_REG4_Base_cntx6_address_ADDR32, THCON_SEC1_REG4_Base_cntx6_address_SHAMT, \
        THCON_SEC1_REG4_Base_cntx6_address_MASK

#define THCON_SEC1_REG4_Base_cntx7_address_ADDR32 111
#define THCON_SEC1_REG4_Base_cntx7_address_SHAMT 0
#define THCON_SEC1_REG4_Base_cntx7_address_MASK 0xffffffff
#define THCON_SEC1_REG4_Base_cntx7_address_RMW                                           \
    THCON_SEC1_REG4_Base_cntx7_address_ADDR32, THCON_SEC1_REG4_Base_cntx7_address_SHAMT, \
        THCON_SEC1_REG4_Base_cntx7_address_MASK

#define THCON_SEC1_REG5_Dest_cntx0_address_ADDR32 112
#define THCON_SEC1_REG5_Dest_cntx0_address_SHAMT 0
#define THCON_SEC1_REG5_Dest_cntx0_address_MASK 0xffff
#define THCON_SEC1_REG5_Dest_cntx0_address_RMW                                           \
    THCON_SEC1_REG5_Dest_cntx0_address_ADDR32, THCON_SEC1_REG5_Dest_cntx0_address_SHAMT, \
        THCON_SEC1_REG5_Dest_cntx0_address_MASK

#define THCON_SEC1_REG5_Dest_cntx1_address_ADDR32 112
#define THCON_SEC1_REG5_Dest_cntx1_address_SHAMT 16
#define THCON_SEC1_REG5_Dest_cntx1_address_MASK 0xffff0000
#define THCON_SEC1_REG5_Dest_cntx1_address_RMW                                           \
    THCON_SEC1_REG5_Dest_cntx1_address_ADDR32, THCON_SEC1_REG5_Dest_cntx1_address_SHAMT, \
        THCON_SEC1_REG5_Dest_cntx1_address_MASK

#define THCON_SEC1_REG5_Dest_cntx2_address_ADDR32 113
#define THCON_SEC1_REG5_Dest_cntx2_address_SHAMT 0
#define THCON_SEC1_REG5_Dest_cntx2_address_MASK 0xffff
#define THCON_SEC1_REG5_Dest_cntx2_address_RMW                                           \
    THCON_SEC1_REG5_Dest_cntx2_address_ADDR32, THCON_SEC1_REG5_Dest_cntx2_address_SHAMT, \
        THCON_SEC1_REG5_Dest_cntx2_address_MASK

#define THCON_SEC1_REG5_Dest_cntx3_address_ADDR32 113
#define THCON_SEC1_REG5_Dest_cntx3_address_SHAMT 16
#define THCON_SEC1_REG5_Dest_cntx3_address_MASK 0xffff0000
#define THCON_SEC1_REG5_Dest_cntx3_address_RMW                                           \
    THCON_SEC1_REG5_Dest_cntx3_address_ADDR32, THCON_SEC1_REG5_Dest_cntx3_address_SHAMT, \
        THCON_SEC1_REG5_Dest_cntx3_address_MASK

#define THCON_SEC1_REG5_Tile_x_dim_cntx0_ADDR32 114
#define THCON_SEC1_REG5_Tile_x_dim_cntx0_SHAMT 0
#define THCON_SEC1_REG5_Tile_x_dim_cntx0_MASK 0xffff
#define THCON_SEC1_REG5_Tile_x_dim_cntx0_RMW                                         \
    THCON_SEC1_REG5_Tile_x_dim_cntx0_ADDR32, THCON_SEC1_REG5_Tile_x_dim_cntx0_SHAMT, \
        THCON_SEC1_REG5_Tile_x_dim_cntx0_MASK

#define THCON_SEC1_REG5_Tile_x_dim_cntx1_ADDR32 114
#define THCON_SEC1_REG5_Tile_x_dim_cntx1_SHAMT 16
#define THCON_SEC1_REG5_Tile_x_dim_cntx1_MASK 0xffff0000
#define THCON_SEC1_REG5_Tile_x_dim_cntx1_RMW                                         \
    THCON_SEC1_REG5_Tile_x_dim_cntx1_ADDR32, THCON_SEC1_REG5_Tile_x_dim_cntx1_SHAMT, \
        THCON_SEC1_REG5_Tile_x_dim_cntx1_MASK

#define THCON_SEC1_REG5_Tile_x_dim_cntx2_ADDR32 115
#define THCON_SEC1_REG5_Tile_x_dim_cntx2_SHAMT 0
#define THCON_SEC1_REG5_Tile_x_dim_cntx2_MASK 0xffff
#define THCON_SEC1_REG5_Tile_x_dim_cntx2_RMW                                         \
    THCON_SEC1_REG5_Tile_x_dim_cntx2_ADDR32, THCON_SEC1_REG5_Tile_x_dim_cntx2_SHAMT, \
        THCON_SEC1_REG5_Tile_x_dim_cntx2_MASK

#define THCON_SEC1_REG5_Tile_x_dim_cntx3_ADDR32 115
#define THCON_SEC1_REG5_Tile_x_dim_cntx3_SHAMT 16
#define THCON_SEC1_REG5_Tile_x_dim_cntx3_MASK 0xffff0000
#define THCON_SEC1_REG5_Tile_x_dim_cntx3_RMW                                         \
    THCON_SEC1_REG5_Tile_x_dim_cntx3_ADDR32, THCON_SEC1_REG5_Tile_x_dim_cntx3_SHAMT, \
        THCON_SEC1_REG5_Tile_x_dim_cntx3_MASK

#define THCON_SEC1_REG6_Source_address_ADDR32 116
#define THCON_SEC1_REG6_Source_address_SHAMT 0
#define THCON_SEC1_REG6_Source_address_MASK 0xffffffff
#define THCON_SEC1_REG6_Source_address_RMW \
    THCON_SEC1_REG6_Source_address_ADDR32, THCON_SEC1_REG6_Source_address_SHAMT, THCON_SEC1_REG6_Source_address_MASK

#define THCON_SEC1_REG6_Destination_address_ADDR32 117
#define THCON_SEC1_REG6_Destination_address_SHAMT 0
#define THCON_SEC1_REG6_Destination_address_MASK 0xffffffff
#define THCON_SEC1_REG6_Destination_address_RMW                                            \
    THCON_SEC1_REG6_Destination_address_ADDR32, THCON_SEC1_REG6_Destination_address_SHAMT, \
        THCON_SEC1_REG6_Destination_address_MASK

#define THCON_SEC1_REG6_Buffer_size_ADDR32 118
#define THCON_SEC1_REG6_Buffer_size_SHAMT 0
#define THCON_SEC1_REG6_Buffer_size_MASK 0x3fffffff
#define THCON_SEC1_REG6_Buffer_size_RMW \
    THCON_SEC1_REG6_Buffer_size_ADDR32, THCON_SEC1_REG6_Buffer_size_SHAMT, THCON_SEC1_REG6_Buffer_size_MASK

#define THCON_SEC1_REG6_Transfer_direction_ADDR32 118
#define THCON_SEC1_REG6_Transfer_direction_SHAMT 30
#define THCON_SEC1_REG6_Transfer_direction_MASK 0xc0000000
#define THCON_SEC1_REG6_Transfer_direction_RMW                                           \
    THCON_SEC1_REG6_Transfer_direction_ADDR32, THCON_SEC1_REG6_Transfer_direction_SHAMT, \
        THCON_SEC1_REG6_Transfer_direction_MASK

#define THCON_SEC1_REG7_Offset_address_ADDR32 120
#define THCON_SEC1_REG7_Offset_address_SHAMT 0
#define THCON_SEC1_REG7_Offset_address_MASK 0xffff
#define THCON_SEC1_REG7_Offset_address_RMW \
    THCON_SEC1_REG7_Offset_address_ADDR32, THCON_SEC1_REG7_Offset_address_SHAMT, THCON_SEC1_REG7_Offset_address_MASK

#define THCON_SEC1_REG7_Unpack_data_format_cntx0_ADDR32 120
#define THCON_SEC1_REG7_Unpack_data_format_cntx0_SHAMT 16
#define THCON_SEC1_REG7_Unpack_data_format_cntx0_MASK 0xf0000
#define THCON_SEC1_REG7_Unpack_data_format_cntx0_RMW                                                 \
    THCON_SEC1_REG7_Unpack_data_format_cntx0_ADDR32, THCON_SEC1_REG7_Unpack_data_format_cntx0_SHAMT, \
        THCON_SEC1_REG7_Unpack_data_format_cntx0_MASK

#define THCON_SEC1_REG7_Unpack_out_data_format_cntx0_ADDR32 120
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx0_SHAMT 20
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx0_MASK 0xf00000
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx0_RMW                                                     \
    THCON_SEC1_REG7_Unpack_out_data_format_cntx0_ADDR32, THCON_SEC1_REG7_Unpack_out_data_format_cntx0_SHAMT, \
        THCON_SEC1_REG7_Unpack_out_data_format_cntx0_MASK

#define THCON_SEC1_REG7_Unpack_data_format_cntx4_ADDR32 120
#define THCON_SEC1_REG7_Unpack_data_format_cntx4_SHAMT 24
#define THCON_SEC1_REG7_Unpack_data_format_cntx4_MASK 0xf000000
#define THCON_SEC1_REG7_Unpack_data_format_cntx4_RMW                                                 \
    THCON_SEC1_REG7_Unpack_data_format_cntx4_ADDR32, THCON_SEC1_REG7_Unpack_data_format_cntx4_SHAMT, \
        THCON_SEC1_REG7_Unpack_data_format_cntx4_MASK

#define THCON_SEC1_REG7_Unpack_out_data_format_cntx4_ADDR32 120
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx4_SHAMT 28
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx4_MASK 0xf0000000
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx4_RMW                                                     \
    THCON_SEC1_REG7_Unpack_out_data_format_cntx4_ADDR32, THCON_SEC1_REG7_Unpack_out_data_format_cntx4_SHAMT, \
        THCON_SEC1_REG7_Unpack_out_data_format_cntx4_MASK

#define THCON_SEC1_REG7_Offset_cntx1_address_ADDR32 121
#define THCON_SEC1_REG7_Offset_cntx1_address_SHAMT 0
#define THCON_SEC1_REG7_Offset_cntx1_address_MASK 0xffff
#define THCON_SEC1_REG7_Offset_cntx1_address_RMW                                             \
    THCON_SEC1_REG7_Offset_cntx1_address_ADDR32, THCON_SEC1_REG7_Offset_cntx1_address_SHAMT, \
        THCON_SEC1_REG7_Offset_cntx1_address_MASK

#define THCON_SEC1_REG7_Unpack_data_format_cntx1_ADDR32 121
#define THCON_SEC1_REG7_Unpack_data_format_cntx1_SHAMT 16
#define THCON_SEC1_REG7_Unpack_data_format_cntx1_MASK 0xf0000
#define THCON_SEC1_REG7_Unpack_data_format_cntx1_RMW                                                 \
    THCON_SEC1_REG7_Unpack_data_format_cntx1_ADDR32, THCON_SEC1_REG7_Unpack_data_format_cntx1_SHAMT, \
        THCON_SEC1_REG7_Unpack_data_format_cntx1_MASK

#define THCON_SEC1_REG7_Unpack_out_data_format_cntx1_ADDR32 121
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx1_SHAMT 20
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx1_MASK 0xf00000
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx1_RMW                                                     \
    THCON_SEC1_REG7_Unpack_out_data_format_cntx1_ADDR32, THCON_SEC1_REG7_Unpack_out_data_format_cntx1_SHAMT, \
        THCON_SEC1_REG7_Unpack_out_data_format_cntx1_MASK

#define THCON_SEC1_REG7_Unpack_data_format_cntx5_ADDR32 121
#define THCON_SEC1_REG7_Unpack_data_format_cntx5_SHAMT 24
#define THCON_SEC1_REG7_Unpack_data_format_cntx5_MASK 0xf000000
#define THCON_SEC1_REG7_Unpack_data_format_cntx5_RMW                                                 \
    THCON_SEC1_REG7_Unpack_data_format_cntx5_ADDR32, THCON_SEC1_REG7_Unpack_data_format_cntx5_SHAMT, \
        THCON_SEC1_REG7_Unpack_data_format_cntx5_MASK

#define THCON_SEC1_REG7_Unpack_out_data_format_cntx5_ADDR32 121
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx5_SHAMT 28
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx5_MASK 0xf0000000
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx5_RMW                                                     \
    THCON_SEC1_REG7_Unpack_out_data_format_cntx5_ADDR32, THCON_SEC1_REG7_Unpack_out_data_format_cntx5_SHAMT, \
        THCON_SEC1_REG7_Unpack_out_data_format_cntx5_MASK

#define THCON_SEC1_REG7_Offset_cntx2_address_ADDR32 122
#define THCON_SEC1_REG7_Offset_cntx2_address_SHAMT 0
#define THCON_SEC1_REG7_Offset_cntx2_address_MASK 0xffff
#define THCON_SEC1_REG7_Offset_cntx2_address_RMW                                             \
    THCON_SEC1_REG7_Offset_cntx2_address_ADDR32, THCON_SEC1_REG7_Offset_cntx2_address_SHAMT, \
        THCON_SEC1_REG7_Offset_cntx2_address_MASK

#define THCON_SEC1_REG7_Unpack_data_format_cntx2_ADDR32 122
#define THCON_SEC1_REG7_Unpack_data_format_cntx2_SHAMT 16
#define THCON_SEC1_REG7_Unpack_data_format_cntx2_MASK 0xf0000
#define THCON_SEC1_REG7_Unpack_data_format_cntx2_RMW                                                 \
    THCON_SEC1_REG7_Unpack_data_format_cntx2_ADDR32, THCON_SEC1_REG7_Unpack_data_format_cntx2_SHAMT, \
        THCON_SEC1_REG7_Unpack_data_format_cntx2_MASK

#define THCON_SEC1_REG7_Unpack_out_data_format_cntx2_ADDR32 122
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx2_SHAMT 20
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx2_MASK 0xf00000
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx2_RMW                                                     \
    THCON_SEC1_REG7_Unpack_out_data_format_cntx2_ADDR32, THCON_SEC1_REG7_Unpack_out_data_format_cntx2_SHAMT, \
        THCON_SEC1_REG7_Unpack_out_data_format_cntx2_MASK

#define THCON_SEC1_REG7_Unpack_data_format_cntx6_ADDR32 122
#define THCON_SEC1_REG7_Unpack_data_format_cntx6_SHAMT 24
#define THCON_SEC1_REG7_Unpack_data_format_cntx6_MASK 0xf000000
#define THCON_SEC1_REG7_Unpack_data_format_cntx6_RMW                                                 \
    THCON_SEC1_REG7_Unpack_data_format_cntx6_ADDR32, THCON_SEC1_REG7_Unpack_data_format_cntx6_SHAMT, \
        THCON_SEC1_REG7_Unpack_data_format_cntx6_MASK

#define THCON_SEC1_REG7_Unpack_out_data_format_cntx6_ADDR32 122
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx6_SHAMT 28
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx6_MASK 0xf0000000
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx6_RMW                                                     \
    THCON_SEC1_REG7_Unpack_out_data_format_cntx6_ADDR32, THCON_SEC1_REG7_Unpack_out_data_format_cntx6_SHAMT, \
        THCON_SEC1_REG7_Unpack_out_data_format_cntx6_MASK

#define THCON_SEC1_REG7_Offset_cntx3_address_ADDR32 123
#define THCON_SEC1_REG7_Offset_cntx3_address_SHAMT 0
#define THCON_SEC1_REG7_Offset_cntx3_address_MASK 0xffff
#define THCON_SEC1_REG7_Offset_cntx3_address_RMW                                             \
    THCON_SEC1_REG7_Offset_cntx3_address_ADDR32, THCON_SEC1_REG7_Offset_cntx3_address_SHAMT, \
        THCON_SEC1_REG7_Offset_cntx3_address_MASK

#define THCON_SEC1_REG7_Unpack_data_format_cntx3_ADDR32 123
#define THCON_SEC1_REG7_Unpack_data_format_cntx3_SHAMT 16
#define THCON_SEC1_REG7_Unpack_data_format_cntx3_MASK 0xf0000
#define THCON_SEC1_REG7_Unpack_data_format_cntx3_RMW                                                 \
    THCON_SEC1_REG7_Unpack_data_format_cntx3_ADDR32, THCON_SEC1_REG7_Unpack_data_format_cntx3_SHAMT, \
        THCON_SEC1_REG7_Unpack_data_format_cntx3_MASK

#define THCON_SEC1_REG7_Unpack_out_data_format_cntx3_ADDR32 123
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx3_SHAMT 20
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx3_MASK 0xf00000
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx3_RMW                                                     \
    THCON_SEC1_REG7_Unpack_out_data_format_cntx3_ADDR32, THCON_SEC1_REG7_Unpack_out_data_format_cntx3_SHAMT, \
        THCON_SEC1_REG7_Unpack_out_data_format_cntx3_MASK

#define THCON_SEC1_REG7_Unpack_data_format_cntx7_ADDR32 123
#define THCON_SEC1_REG7_Unpack_data_format_cntx7_SHAMT 24
#define THCON_SEC1_REG7_Unpack_data_format_cntx7_MASK 0xf000000
#define THCON_SEC1_REG7_Unpack_data_format_cntx7_RMW                                                 \
    THCON_SEC1_REG7_Unpack_data_format_cntx7_ADDR32, THCON_SEC1_REG7_Unpack_data_format_cntx7_SHAMT, \
        THCON_SEC1_REG7_Unpack_data_format_cntx7_MASK

#define THCON_SEC1_REG7_Unpack_out_data_format_cntx7_ADDR32 123
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx7_SHAMT 28
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx7_MASK 0xf0000000
#define THCON_SEC1_REG7_Unpack_out_data_format_cntx7_RMW                                                     \
    THCON_SEC1_REG7_Unpack_out_data_format_cntx7_ADDR32, THCON_SEC1_REG7_Unpack_out_data_format_cntx7_SHAMT, \
        THCON_SEC1_REG7_Unpack_out_data_format_cntx7_MASK

#define THCON_SEC1_REG8_Row_start_section_size_ADDR32 124
#define THCON_SEC1_REG8_Row_start_section_size_SHAMT 0
#define THCON_SEC1_REG8_Row_start_section_size_MASK 0xffff
#define THCON_SEC1_REG8_Row_start_section_size_RMW                                               \
    THCON_SEC1_REG8_Row_start_section_size_ADDR32, THCON_SEC1_REG8_Row_start_section_size_SHAMT, \
        THCON_SEC1_REG8_Row_start_section_size_MASK

#define THCON_SEC1_REG8_Exp_section_size_ADDR32 124
#define THCON_SEC1_REG8_Exp_section_size_SHAMT 16
#define THCON_SEC1_REG8_Exp_section_size_MASK 0xffff0000
#define THCON_SEC1_REG8_Exp_section_size_RMW                                         \
    THCON_SEC1_REG8_Exp_section_size_ADDR32, THCON_SEC1_REG8_Exp_section_size_SHAMT, \
        THCON_SEC1_REG8_Exp_section_size_MASK

#define THCON_SEC1_REG8_L1_Dest_addr_ADDR32 125
#define THCON_SEC1_REG8_L1_Dest_addr_SHAMT 0
#define THCON_SEC1_REG8_L1_Dest_addr_MASK 0xffffffff
#define THCON_SEC1_REG8_L1_Dest_addr_RMW \
    THCON_SEC1_REG8_L1_Dest_addr_ADDR32, THCON_SEC1_REG8_L1_Dest_addr_SHAMT, THCON_SEC1_REG8_L1_Dest_addr_MASK

#define THCON_SEC1_REG8_Disable_zero_compress_ADDR32 126
#define THCON_SEC1_REG8_Disable_zero_compress_SHAMT 0
#define THCON_SEC1_REG8_Disable_zero_compress_MASK 0x1
#define THCON_SEC1_REG8_Disable_zero_compress_RMW                                              \
    THCON_SEC1_REG8_Disable_zero_compress_ADDR32, THCON_SEC1_REG8_Disable_zero_compress_SHAMT, \
        THCON_SEC1_REG8_Disable_zero_compress_MASK

#define THCON_SEC1_REG8_Add_l1_dest_addr_offset_ADDR32 126
#define THCON_SEC1_REG8_Add_l1_dest_addr_offset_SHAMT 1
#define THCON_SEC1_REG8_Add_l1_dest_addr_offset_MASK 0x2
#define THCON_SEC1_REG8_Add_l1_dest_addr_offset_RMW                                                \
    THCON_SEC1_REG8_Add_l1_dest_addr_offset_ADDR32, THCON_SEC1_REG8_Add_l1_dest_addr_offset_SHAMT, \
        THCON_SEC1_REG8_Add_l1_dest_addr_offset_MASK

#define THCON_SEC1_REG8_Addr_cnt_context_ADDR32 126
#define THCON_SEC1_REG8_Addr_cnt_context_SHAMT 2
#define THCON_SEC1_REG8_Addr_cnt_context_MASK 0xc
#define THCON_SEC1_REG8_Addr_cnt_context_RMW                                         \
    THCON_SEC1_REG8_Addr_cnt_context_ADDR32, THCON_SEC1_REG8_Addr_cnt_context_SHAMT, \
        THCON_SEC1_REG8_Addr_cnt_context_MASK

#define THCON_SEC1_REG8_Out_data_format_ADDR32 126
#define THCON_SEC1_REG8_Out_data_format_SHAMT 4
#define THCON_SEC1_REG8_Out_data_format_MASK 0xf0
#define THCON_SEC1_REG8_Out_data_format_RMW \
    THCON_SEC1_REG8_Out_data_format_ADDR32, THCON_SEC1_REG8_Out_data_format_SHAMT, THCON_SEC1_REG8_Out_data_format_MASK

#define THCON_SEC1_REG8_In_data_format_ADDR32 126
#define THCON_SEC1_REG8_In_data_format_SHAMT 8
#define THCON_SEC1_REG8_In_data_format_MASK 0xf00
#define THCON_SEC1_REG8_In_data_format_RMW \
    THCON_SEC1_REG8_In_data_format_ADDR32, THCON_SEC1_REG8_In_data_format_SHAMT, THCON_SEC1_REG8_In_data_format_MASK

#define THCON_SEC1_REG8_Dis_shared_exp_assembler_ADDR32 126
#define THCON_SEC1_REG8_Dis_shared_exp_assembler_SHAMT 12
#define THCON_SEC1_REG8_Dis_shared_exp_assembler_MASK 0x1000
#define THCON_SEC1_REG8_Dis_shared_exp_assembler_RMW                                                 \
    THCON_SEC1_REG8_Dis_shared_exp_assembler_ADDR32, THCON_SEC1_REG8_Dis_shared_exp_assembler_SHAMT, \
        THCON_SEC1_REG8_Dis_shared_exp_assembler_MASK

#define THCON_SEC1_REG8_Force_pack_per_max_xy_plane_ADDR32 126
#define THCON_SEC1_REG8_Force_pack_per_max_xy_plane_SHAMT 13
#define THCON_SEC1_REG8_Force_pack_per_max_xy_plane_MASK 0x2000
#define THCON_SEC1_REG8_Force_pack_per_max_xy_plane_RMW                                                    \
    THCON_SEC1_REG8_Force_pack_per_max_xy_plane_ADDR32, THCON_SEC1_REG8_Force_pack_per_max_xy_plane_SHAMT, \
        THCON_SEC1_REG8_Force_pack_per_max_xy_plane_MASK

#define THCON_SEC1_REG8_Enable_out_fifo_ADDR32 126
#define THCON_SEC1_REG8_Enable_out_fifo_SHAMT 14
#define THCON_SEC1_REG8_Enable_out_fifo_MASK 0x4000
#define THCON_SEC1_REG8_Enable_out_fifo_RMW \
    THCON_SEC1_REG8_Enable_out_fifo_ADDR32, THCON_SEC1_REG8_Enable_out_fifo_SHAMT, THCON_SEC1_REG8_Enable_out_fifo_MASK

#define THCON_SEC1_REG8_Sub_l1_tile_header_size_ADDR32 126
#define THCON_SEC1_REG8_Sub_l1_tile_header_size_SHAMT 15
#define THCON_SEC1_REG8_Sub_l1_tile_header_size_MASK 0x8000
#define THCON_SEC1_REG8_Sub_l1_tile_header_size_RMW                                                \
    THCON_SEC1_REG8_Sub_l1_tile_header_size_ADDR32, THCON_SEC1_REG8_Sub_l1_tile_header_size_SHAMT, \
        THCON_SEC1_REG8_Sub_l1_tile_header_size_MASK

#define THCON_SEC1_REG8_Source_interface_selection_ADDR32 126
#define THCON_SEC1_REG8_Source_interface_selection_SHAMT 16
#define THCON_SEC1_REG8_Source_interface_selection_MASK 0x10000
#define THCON_SEC1_REG8_Source_interface_selection_RMW                                                   \
    THCON_SEC1_REG8_Source_interface_selection_ADDR32, THCON_SEC1_REG8_Source_interface_selection_SHAMT, \
        THCON_SEC1_REG8_Source_interface_selection_MASK

#define THCON_SEC1_REG8_Add_tile_header_size_ADDR32 126
#define THCON_SEC1_REG8_Add_tile_header_size_SHAMT 17
#define THCON_SEC1_REG8_Add_tile_header_size_MASK 0x20000
#define THCON_SEC1_REG8_Add_tile_header_size_RMW                                             \
    THCON_SEC1_REG8_Add_tile_header_size_ADDR32, THCON_SEC1_REG8_Add_tile_header_size_SHAMT, \
        THCON_SEC1_REG8_Add_tile_header_size_MASK

#define THCON_SEC1_REG8_L1_source_addr_ADDR32 126
#define THCON_SEC1_REG8_L1_source_addr_SHAMT 24
#define THCON_SEC1_REG8_L1_source_addr_MASK 0xff000000
#define THCON_SEC1_REG8_L1_source_addr_RMW \
    THCON_SEC1_REG8_L1_source_addr_ADDR32, THCON_SEC1_REG8_L1_source_addr_SHAMT, THCON_SEC1_REG8_L1_source_addr_MASK

#define THCON_SEC1_REG8_Downsample_mask_ADDR32 127
#define THCON_SEC1_REG8_Downsample_mask_SHAMT 0
#define THCON_SEC1_REG8_Downsample_mask_MASK 0xffff
#define THCON_SEC1_REG8_Downsample_mask_RMW \
    THCON_SEC1_REG8_Downsample_mask_ADDR32, THCON_SEC1_REG8_Downsample_mask_SHAMT, THCON_SEC1_REG8_Downsample_mask_MASK

#define THCON_SEC1_REG8_Downsample_rate_ADDR32 127
#define THCON_SEC1_REG8_Downsample_rate_SHAMT 16
#define THCON_SEC1_REG8_Downsample_rate_MASK 0x70000
#define THCON_SEC1_REG8_Downsample_rate_RMW \
    THCON_SEC1_REG8_Downsample_rate_ADDR32, THCON_SEC1_REG8_Downsample_rate_SHAMT, THCON_SEC1_REG8_Downsample_rate_MASK

#define THCON_SEC1_REG8_Read_mode_ADDR32 127
#define THCON_SEC1_REG8_Read_mode_SHAMT 19
#define THCON_SEC1_REG8_Read_mode_MASK 0x80000
#define THCON_SEC1_REG8_Read_mode_RMW \
    THCON_SEC1_REG8_Read_mode_ADDR32, THCON_SEC1_REG8_Read_mode_SHAMT, THCON_SEC1_REG8_Read_mode_MASK

#define THCON_SEC1_REG8_Exp_threshold_en_ADDR32 127
#define THCON_SEC1_REG8_Exp_threshold_en_SHAMT 20
#define THCON_SEC1_REG8_Exp_threshold_en_MASK 0x100000
#define THCON_SEC1_REG8_Exp_threshold_en_RMW                                         \
    THCON_SEC1_REG8_Exp_threshold_en_ADDR32, THCON_SEC1_REG8_Exp_threshold_en_SHAMT, \
        THCON_SEC1_REG8_Exp_threshold_en_MASK

#define THCON_SEC1_REG8_Pack_L1_Acc_ADDR32 127
#define THCON_SEC1_REG8_Pack_L1_Acc_SHAMT 21
#define THCON_SEC1_REG8_Pack_L1_Acc_MASK 0x200000
#define THCON_SEC1_REG8_Pack_L1_Acc_RMW \
    THCON_SEC1_REG8_Pack_L1_Acc_ADDR32, THCON_SEC1_REG8_Pack_L1_Acc_SHAMT, THCON_SEC1_REG8_Pack_L1_Acc_MASK

#define THCON_SEC1_REG8_Disable_pack_zero_flags_ADDR32 127
#define THCON_SEC1_REG8_Disable_pack_zero_flags_SHAMT 22
#define THCON_SEC1_REG8_Disable_pack_zero_flags_MASK 0x400000
#define THCON_SEC1_REG8_Disable_pack_zero_flags_RMW                                                \
    THCON_SEC1_REG8_Disable_pack_zero_flags_ADDR32, THCON_SEC1_REG8_Disable_pack_zero_flags_SHAMT, \
        THCON_SEC1_REG8_Disable_pack_zero_flags_MASK

#define THCON_SEC1_REG8_Exp_threshold_ADDR32 127
#define THCON_SEC1_REG8_Exp_threshold_SHAMT 24
#define THCON_SEC1_REG8_Exp_threshold_MASK 0xff000000
#define THCON_SEC1_REG8_Exp_threshold_RMW \
    THCON_SEC1_REG8_Exp_threshold_ADDR32, THCON_SEC1_REG8_Exp_threshold_SHAMT, THCON_SEC1_REG8_Exp_threshold_MASK

#define THCON_SEC1_REG9_Pack_0_2_limit_address_ADDR32 128
#define THCON_SEC1_REG9_Pack_0_2_limit_address_SHAMT 0
#define THCON_SEC1_REG9_Pack_0_2_limit_address_MASK 0x1ffff
#define THCON_SEC1_REG9_Pack_0_2_limit_address_RMW                                               \
    THCON_SEC1_REG9_Pack_0_2_limit_address_ADDR32, THCON_SEC1_REG9_Pack_0_2_limit_address_SHAMT, \
        THCON_SEC1_REG9_Pack_0_2_limit_address_MASK

#define THCON_SEC1_REG9_Pack_0_2_fifo_size_ADDR32 129
#define THCON_SEC1_REG9_Pack_0_2_fifo_size_SHAMT 0
#define THCON_SEC1_REG9_Pack_0_2_fifo_size_MASK 0x1ffff
#define THCON_SEC1_REG9_Pack_0_2_fifo_size_RMW                                           \
    THCON_SEC1_REG9_Pack_0_2_fifo_size_ADDR32, THCON_SEC1_REG9_Pack_0_2_fifo_size_SHAMT, \
        THCON_SEC1_REG9_Pack_0_2_fifo_size_MASK

#define THCON_SEC1_REG9_Pack_1_3_limit_address_ADDR32 130
#define THCON_SEC1_REG9_Pack_1_3_limit_address_SHAMT 0
#define THCON_SEC1_REG9_Pack_1_3_limit_address_MASK 0x1ffff
#define THCON_SEC1_REG9_Pack_1_3_limit_address_RMW                                               \
    THCON_SEC1_REG9_Pack_1_3_limit_address_ADDR32, THCON_SEC1_REG9_Pack_1_3_limit_address_SHAMT, \
        THCON_SEC1_REG9_Pack_1_3_limit_address_MASK

#define THCON_SEC1_REG9_Pack_1_3_fifo_size_ADDR32 131
#define THCON_SEC1_REG9_Pack_1_3_fifo_size_SHAMT 0
#define THCON_SEC1_REG9_Pack_1_3_fifo_size_MASK 0x1ffff
#define THCON_SEC1_REG9_Pack_1_3_fifo_size_RMW                                           \
    THCON_SEC1_REG9_Pack_1_3_fifo_size_ADDR32, THCON_SEC1_REG9_Pack_1_3_fifo_size_SHAMT, \
        THCON_SEC1_REG9_Pack_1_3_fifo_size_MASK

////////////////////////////////////////////////////////////////////////
// Registers for GLOBAL
////////////////////////////////////////////////////////////////////////

#define GLOBAL_CFGREG_BASE_ADDR32 152

#define DEST_TARGET_REG_CFG_PACK_SEC0_Offset_ADDR32 152
#define DEST_TARGET_REG_CFG_PACK_SEC0_Offset_SHAMT 0
#define DEST_TARGET_REG_CFG_PACK_SEC0_Offset_MASK 0xfff
#define DEST_TARGET_REG_CFG_PACK_SEC0_Offset_RMW                                             \
    DEST_TARGET_REG_CFG_PACK_SEC0_Offset_ADDR32, DEST_TARGET_REG_CFG_PACK_SEC0_Offset_SHAMT, \
        DEST_TARGET_REG_CFG_PACK_SEC0_Offset_MASK

#define DEST_TARGET_REG_CFG_PACK_SEC0_ZOffset_ADDR32 152
#define DEST_TARGET_REG_CFG_PACK_SEC0_ZOffset_SHAMT 12
#define DEST_TARGET_REG_CFG_PACK_SEC0_ZOffset_MASK 0x3f000
#define DEST_TARGET_REG_CFG_PACK_SEC0_ZOffset_RMW                                              \
    DEST_TARGET_REG_CFG_PACK_SEC0_ZOffset_ADDR32, DEST_TARGET_REG_CFG_PACK_SEC0_ZOffset_SHAMT, \
        DEST_TARGET_REG_CFG_PACK_SEC0_ZOffset_MASK

#define DEST_TARGET_REG_CFG_PACK_SEC1_Offset_ADDR32 153
#define DEST_TARGET_REG_CFG_PACK_SEC1_Offset_SHAMT 0
#define DEST_TARGET_REG_CFG_PACK_SEC1_Offset_MASK 0xfff
#define DEST_TARGET_REG_CFG_PACK_SEC1_Offset_RMW                                             \
    DEST_TARGET_REG_CFG_PACK_SEC1_Offset_ADDR32, DEST_TARGET_REG_CFG_PACK_SEC1_Offset_SHAMT, \
        DEST_TARGET_REG_CFG_PACK_SEC1_Offset_MASK

#define DEST_TARGET_REG_CFG_PACK_SEC1_ZOffset_ADDR32 153
#define DEST_TARGET_REG_CFG_PACK_SEC1_ZOffset_SHAMT 12
#define DEST_TARGET_REG_CFG_PACK_SEC1_ZOffset_MASK 0x3f000
#define DEST_TARGET_REG_CFG_PACK_SEC1_ZOffset_RMW                                              \
    DEST_TARGET_REG_CFG_PACK_SEC1_ZOffset_ADDR32, DEST_TARGET_REG_CFG_PACK_SEC1_ZOffset_SHAMT, \
        DEST_TARGET_REG_CFG_PACK_SEC1_ZOffset_MASK

#define DEST_TARGET_REG_CFG_PACK_SEC2_Offset_ADDR32 154
#define DEST_TARGET_REG_CFG_PACK_SEC2_Offset_SHAMT 0
#define DEST_TARGET_REG_CFG_PACK_SEC2_Offset_MASK 0xfff
#define DEST_TARGET_REG_CFG_PACK_SEC2_Offset_RMW                                             \
    DEST_TARGET_REG_CFG_PACK_SEC2_Offset_ADDR32, DEST_TARGET_REG_CFG_PACK_SEC2_Offset_SHAMT, \
        DEST_TARGET_REG_CFG_PACK_SEC2_Offset_MASK

#define DEST_TARGET_REG_CFG_PACK_SEC2_ZOffset_ADDR32 154
#define DEST_TARGET_REG_CFG_PACK_SEC2_ZOffset_SHAMT 12
#define DEST_TARGET_REG_CFG_PACK_SEC2_ZOffset_MASK 0x3f000
#define DEST_TARGET_REG_CFG_PACK_SEC2_ZOffset_RMW                                              \
    DEST_TARGET_REG_CFG_PACK_SEC2_ZOffset_ADDR32, DEST_TARGET_REG_CFG_PACK_SEC2_ZOffset_SHAMT, \
        DEST_TARGET_REG_CFG_PACK_SEC2_ZOffset_MASK

#define DEST_TARGET_REG_CFG_PACK_SEC3_Offset_ADDR32 155
#define DEST_TARGET_REG_CFG_PACK_SEC3_Offset_SHAMT 0
#define DEST_TARGET_REG_CFG_PACK_SEC3_Offset_MASK 0xfff
#define DEST_TARGET_REG_CFG_PACK_SEC3_Offset_RMW                                             \
    DEST_TARGET_REG_CFG_PACK_SEC3_Offset_ADDR32, DEST_TARGET_REG_CFG_PACK_SEC3_Offset_SHAMT, \
        DEST_TARGET_REG_CFG_PACK_SEC3_Offset_MASK

#define DEST_TARGET_REG_CFG_PACK_SEC3_ZOffset_ADDR32 155
#define DEST_TARGET_REG_CFG_PACK_SEC3_ZOffset_SHAMT 12
#define DEST_TARGET_REG_CFG_PACK_SEC3_ZOffset_MASK 0x3f000
#define DEST_TARGET_REG_CFG_PACK_SEC3_ZOffset_RMW                                              \
    DEST_TARGET_REG_CFG_PACK_SEC3_ZOffset_ADDR32, DEST_TARGET_REG_CFG_PACK_SEC3_ZOffset_SHAMT, \
        DEST_TARGET_REG_CFG_PACK_SEC3_ZOffset_MASK

#define CG_SRC_PIPELINE_GateSrcAPipeEn_ADDR32 156
#define CG_SRC_PIPELINE_GateSrcAPipeEn_SHAMT 0
#define CG_SRC_PIPELINE_GateSrcAPipeEn_MASK 0x1
#define CG_SRC_PIPELINE_GateSrcAPipeEn_RMW \
    CG_SRC_PIPELINE_GateSrcAPipeEn_ADDR32, CG_SRC_PIPELINE_GateSrcAPipeEn_SHAMT, CG_SRC_PIPELINE_GateSrcAPipeEn_MASK

#define CG_SRC_PIPELINE_GateSrcBPipeEn_ADDR32 156
#define CG_SRC_PIPELINE_GateSrcBPipeEn_SHAMT 1
#define CG_SRC_PIPELINE_GateSrcBPipeEn_MASK 0x2
#define CG_SRC_PIPELINE_GateSrcBPipeEn_RMW \
    CG_SRC_PIPELINE_GateSrcBPipeEn_ADDR32, CG_SRC_PIPELINE_GateSrcBPipeEn_SHAMT, CG_SRC_PIPELINE_GateSrcBPipeEn_MASK

#define RISCV_IC_INVALIDATE_InvalidateAll_ADDR32 157
#define RISCV_IC_INVALIDATE_InvalidateAll_SHAMT 0
#define RISCV_IC_INVALIDATE_InvalidateAll_MASK 0x1f
#define RISCV_IC_INVALIDATE_InvalidateAll_RMW                                          \
    RISCV_IC_INVALIDATE_InvalidateAll_ADDR32, RISCV_IC_INVALIDATE_InvalidateAll_SHAMT, \
        RISCV_IC_INVALIDATE_InvalidateAll_MASK

#define TRISC_RESET_PC_SEC0_PC_ADDR32 158
#define TRISC_RESET_PC_SEC0_PC_SHAMT 0
#define TRISC_RESET_PC_SEC0_PC_MASK 0xffffffff
#define TRISC_RESET_PC_SEC0_PC_RMW \
    TRISC_RESET_PC_SEC0_PC_ADDR32, TRISC_RESET_PC_SEC0_PC_SHAMT, TRISC_RESET_PC_SEC0_PC_MASK

#define TRISC_RESET_PC_SEC1_PC_ADDR32 159
#define TRISC_RESET_PC_SEC1_PC_SHAMT 0
#define TRISC_RESET_PC_SEC1_PC_MASK 0xffffffff
#define TRISC_RESET_PC_SEC1_PC_RMW \
    TRISC_RESET_PC_SEC1_PC_ADDR32, TRISC_RESET_PC_SEC1_PC_SHAMT, TRISC_RESET_PC_SEC1_PC_MASK

#define TRISC_RESET_PC_SEC2_PC_ADDR32 160
#define TRISC_RESET_PC_SEC2_PC_SHAMT 0
#define TRISC_RESET_PC_SEC2_PC_MASK 0xffffffff
#define TRISC_RESET_PC_SEC2_PC_RMW \
    TRISC_RESET_PC_SEC2_PC_ADDR32, TRISC_RESET_PC_SEC2_PC_SHAMT, TRISC_RESET_PC_SEC2_PC_MASK

#define TRISC_RESET_PC_OVERRIDE_Reset_PC_Override_en_ADDR32 161
#define TRISC_RESET_PC_OVERRIDE_Reset_PC_Override_en_SHAMT 0
#define TRISC_RESET_PC_OVERRIDE_Reset_PC_Override_en_MASK 0x7
#define TRISC_RESET_PC_OVERRIDE_Reset_PC_Override_en_RMW                                                     \
    TRISC_RESET_PC_OVERRIDE_Reset_PC_Override_en_ADDR32, TRISC_RESET_PC_OVERRIDE_Reset_PC_Override_en_SHAMT, \
        TRISC_RESET_PC_OVERRIDE_Reset_PC_Override_en_MASK

#define NCRISC_RESET_PC_PC_ADDR32 162
#define NCRISC_RESET_PC_PC_SHAMT 0
#define NCRISC_RESET_PC_PC_MASK 0xffffffff
#define NCRISC_RESET_PC_PC_RMW NCRISC_RESET_PC_PC_ADDR32, NCRISC_RESET_PC_PC_SHAMT, NCRISC_RESET_PC_PC_MASK

#define NCRISC_RESET_PC_OVERRIDE_Reset_PC_Override_en_ADDR32 163
#define NCRISC_RESET_PC_OVERRIDE_Reset_PC_Override_en_SHAMT 0
#define NCRISC_RESET_PC_OVERRIDE_Reset_PC_Override_en_MASK 0x1
#define NCRISC_RESET_PC_OVERRIDE_Reset_PC_Override_en_RMW                                                      \
    NCRISC_RESET_PC_OVERRIDE_Reset_PC_Override_en_ADDR32, NCRISC_RESET_PC_OVERRIDE_Reset_PC_Override_en_SHAMT, \
        NCRISC_RESET_PC_OVERRIDE_Reset_PC_Override_en_MASK

#define PRNG_SEED_Seed_Val_ADDR32 164
#define PRNG_SEED_Seed_Val_SHAMT 0
#define PRNG_SEED_Seed_Val_MASK 0xffffffff
#define PRNG_SEED_Seed_Val_RMW PRNG_SEED_Seed_Val_ADDR32, PRNG_SEED_Seed_Val_SHAMT, PRNG_SEED_Seed_Val_MASK

#define INT_DESCALE_VALUES_SEC0_Value_ADDR32 165
#define INT_DESCALE_VALUES_SEC0_Value_SHAMT 0
#define INT_DESCALE_VALUES_SEC0_Value_MASK 0xffffffff
#define INT_DESCALE_VALUES_SEC0_Value_RMW \
    INT_DESCALE_VALUES_SEC0_Value_ADDR32, INT_DESCALE_VALUES_SEC0_Value_SHAMT, INT_DESCALE_VALUES_SEC0_Value_MASK

#define INT_DESCALE_VALUES_SEC1_Value_ADDR32 166
#define INT_DESCALE_VALUES_SEC1_Value_SHAMT 0
#define INT_DESCALE_VALUES_SEC1_Value_MASK 0xffffffff
#define INT_DESCALE_VALUES_SEC1_Value_RMW \
    INT_DESCALE_VALUES_SEC1_Value_ADDR32, INT_DESCALE_VALUES_SEC1_Value_SHAMT, INT_DESCALE_VALUES_SEC1_Value_MASK

#define INT_DESCALE_VALUES_SEC2_Value_ADDR32 167
#define INT_DESCALE_VALUES_SEC2_Value_SHAMT 0
#define INT_DESCALE_VALUES_SEC2_Value_MASK 0xffffffff
#define INT_DESCALE_VALUES_SEC2_Value_RMW \
    INT_DESCALE_VALUES_SEC2_Value_ADDR32, INT_DESCALE_VALUES_SEC2_Value_SHAMT, INT_DESCALE_VALUES_SEC2_Value_MASK

#define INT_DESCALE_VALUES_SEC3_Value_ADDR32 168
#define INT_DESCALE_VALUES_SEC3_Value_SHAMT 0
#define INT_DESCALE_VALUES_SEC3_Value_MASK 0xffffffff
#define INT_DESCALE_VALUES_SEC3_Value_RMW \
    INT_DESCALE_VALUES_SEC3_Value_ADDR32, INT_DESCALE_VALUES_SEC3_Value_SHAMT, INT_DESCALE_VALUES_SEC3_Value_MASK

#define INT_DESCALE_VALUES_SEC4_Value_ADDR32 169
#define INT_DESCALE_VALUES_SEC4_Value_SHAMT 0
#define INT_DESCALE_VALUES_SEC4_Value_MASK 0xffffffff
#define INT_DESCALE_VALUES_SEC4_Value_RMW \
    INT_DESCALE_VALUES_SEC4_Value_ADDR32, INT_DESCALE_VALUES_SEC4_Value_SHAMT, INT_DESCALE_VALUES_SEC4_Value_MASK

#define INT_DESCALE_VALUES_SEC5_Value_ADDR32 170
#define INT_DESCALE_VALUES_SEC5_Value_SHAMT 0
#define INT_DESCALE_VALUES_SEC5_Value_MASK 0xffffffff
#define INT_DESCALE_VALUES_SEC5_Value_RMW \
    INT_DESCALE_VALUES_SEC5_Value_ADDR32, INT_DESCALE_VALUES_SEC5_Value_SHAMT, INT_DESCALE_VALUES_SEC5_Value_MASK

#define INT_DESCALE_VALUES_SEC6_Value_ADDR32 171
#define INT_DESCALE_VALUES_SEC6_Value_SHAMT 0
#define INT_DESCALE_VALUES_SEC6_Value_MASK 0xffffffff
#define INT_DESCALE_VALUES_SEC6_Value_RMW \
    INT_DESCALE_VALUES_SEC6_Value_ADDR32, INT_DESCALE_VALUES_SEC6_Value_SHAMT, INT_DESCALE_VALUES_SEC6_Value_MASK

#define INT_DESCALE_VALUES_SEC7_Value_ADDR32 172
#define INT_DESCALE_VALUES_SEC7_Value_SHAMT 0
#define INT_DESCALE_VALUES_SEC7_Value_MASK 0xffffffff
#define INT_DESCALE_VALUES_SEC7_Value_RMW \
    INT_DESCALE_VALUES_SEC7_Value_ADDR32, INT_DESCALE_VALUES_SEC7_Value_SHAMT, INT_DESCALE_VALUES_SEC7_Value_MASK

#define INT_DESCALE_VALUES_SEC8_Value_ADDR32 173
#define INT_DESCALE_VALUES_SEC8_Value_SHAMT 0
#define INT_DESCALE_VALUES_SEC8_Value_MASK 0xffffffff
#define INT_DESCALE_VALUES_SEC8_Value_RMW \
    INT_DESCALE_VALUES_SEC8_Value_ADDR32, INT_DESCALE_VALUES_SEC8_Value_SHAMT, INT_DESCALE_VALUES_SEC8_Value_MASK

#define INT_DESCALE_VALUES_SEC9_Value_ADDR32 174
#define INT_DESCALE_VALUES_SEC9_Value_SHAMT 0
#define INT_DESCALE_VALUES_SEC9_Value_MASK 0xffffffff
#define INT_DESCALE_VALUES_SEC9_Value_RMW \
    INT_DESCALE_VALUES_SEC9_Value_ADDR32, INT_DESCALE_VALUES_SEC9_Value_SHAMT, INT_DESCALE_VALUES_SEC9_Value_MASK

#define INT_DESCALE_VALUES_SEC10_Value_ADDR32 175
#define INT_DESCALE_VALUES_SEC10_Value_SHAMT 0
#define INT_DESCALE_VALUES_SEC10_Value_MASK 0xffffffff
#define INT_DESCALE_VALUES_SEC10_Value_RMW \
    INT_DESCALE_VALUES_SEC10_Value_ADDR32, INT_DESCALE_VALUES_SEC10_Value_SHAMT, INT_DESCALE_VALUES_SEC10_Value_MASK

#define INT_DESCALE_VALUES_SEC11_Value_ADDR32 176
#define INT_DESCALE_VALUES_SEC11_Value_SHAMT 0
#define INT_DESCALE_VALUES_SEC11_Value_MASK 0xffffffff
#define INT_DESCALE_VALUES_SEC11_Value_RMW \
    INT_DESCALE_VALUES_SEC11_Value_ADDR32, INT_DESCALE_VALUES_SEC11_Value_SHAMT, INT_DESCALE_VALUES_SEC11_Value_MASK

#define INT_DESCALE_VALUES_SEC12_Value_ADDR32 177
#define INT_DESCALE_VALUES_SEC12_Value_SHAMT 0
#define INT_DESCALE_VALUES_SEC12_Value_MASK 0xffffffff
#define INT_DESCALE_VALUES_SEC12_Value_RMW \
    INT_DESCALE_VALUES_SEC12_Value_ADDR32, INT_DESCALE_VALUES_SEC12_Value_SHAMT, INT_DESCALE_VALUES_SEC12_Value_MASK

#define INT_DESCALE_VALUES_SEC13_Value_ADDR32 178
#define INT_DESCALE_VALUES_SEC13_Value_SHAMT 0
#define INT_DESCALE_VALUES_SEC13_Value_MASK 0xffffffff
#define INT_DESCALE_VALUES_SEC13_Value_RMW \
    INT_DESCALE_VALUES_SEC13_Value_ADDR32, INT_DESCALE_VALUES_SEC13_Value_SHAMT, INT_DESCALE_VALUES_SEC13_Value_MASK

#define INT_DESCALE_VALUES_SEC14_Value_ADDR32 179
#define INT_DESCALE_VALUES_SEC14_Value_SHAMT 0
#define INT_DESCALE_VALUES_SEC14_Value_MASK 0xffffffff
#define INT_DESCALE_VALUES_SEC14_Value_RMW \
    INT_DESCALE_VALUES_SEC14_Value_ADDR32, INT_DESCALE_VALUES_SEC14_Value_SHAMT, INT_DESCALE_VALUES_SEC14_Value_MASK

#define INT_DESCALE_VALUES_SEC15_Value_ADDR32 180
#define INT_DESCALE_VALUES_SEC15_Value_SHAMT 0
#define INT_DESCALE_VALUES_SEC15_Value_MASK 0xffffffff
#define INT_DESCALE_VALUES_SEC15_Value_RMW \
    INT_DESCALE_VALUES_SEC15_Value_ADDR32, INT_DESCALE_VALUES_SEC15_Value_SHAMT, INT_DESCALE_VALUES_SEC15_Value_MASK

#define TRISC_END_PC_SEC0_PC_ADDR32 181
#define TRISC_END_PC_SEC0_PC_SHAMT 0
#define TRISC_END_PC_SEC0_PC_MASK 0xffffffff
#define TRISC_END_PC_SEC0_PC_RMW TRISC_END_PC_SEC0_PC_ADDR32, TRISC_END_PC_SEC0_PC_SHAMT, TRISC_END_PC_SEC0_PC_MASK

#define TRISC_END_PC_SEC1_PC_ADDR32 182
#define TRISC_END_PC_SEC1_PC_SHAMT 0
#define TRISC_END_PC_SEC1_PC_MASK 0xffffffff
#define TRISC_END_PC_SEC1_PC_RMW TRISC_END_PC_SEC1_PC_ADDR32, TRISC_END_PC_SEC1_PC_SHAMT, TRISC_END_PC_SEC1_PC_MASK

#define TRISC_END_PC_SEC2_PC_ADDR32 183
#define TRISC_END_PC_SEC2_PC_SHAMT 0
#define TRISC_END_PC_SEC2_PC_MASK 0xffffffff
#define TRISC_END_PC_SEC2_PC_RMW TRISC_END_PC_SEC2_PC_ADDR32, TRISC_END_PC_SEC2_PC_SHAMT, TRISC_END_PC_SEC2_PC_MASK

#define BRISC_END_PC_PC_ADDR32 184
#define BRISC_END_PC_PC_SHAMT 0
#define BRISC_END_PC_PC_MASK 0xffffffff
#define BRISC_END_PC_PC_RMW BRISC_END_PC_PC_ADDR32, BRISC_END_PC_PC_SHAMT, BRISC_END_PC_PC_MASK

#define NOC_RISC_END_PC_PC_ADDR32 185
#define NOC_RISC_END_PC_PC_SHAMT 0
#define NOC_RISC_END_PC_PC_MASK 0xffffffff
#define NOC_RISC_END_PC_PC_RMW NOC_RISC_END_PC_PC_ADDR32, NOC_RISC_END_PC_PC_SHAMT, NOC_RISC_END_PC_PC_MASK

#define RISC_PREFETCH_CTRL_Enable_Trisc_ADDR32 186
#define RISC_PREFETCH_CTRL_Enable_Trisc_SHAMT 0
#define RISC_PREFETCH_CTRL_Enable_Trisc_MASK 0x7
#define RISC_PREFETCH_CTRL_Enable_Trisc_RMW \
    RISC_PREFETCH_CTRL_Enable_Trisc_ADDR32, RISC_PREFETCH_CTRL_Enable_Trisc_SHAMT, RISC_PREFETCH_CTRL_Enable_Trisc_MASK

#define RISC_PREFETCH_CTRL_Enable_Brisc_ADDR32 186
#define RISC_PREFETCH_CTRL_Enable_Brisc_SHAMT 3
#define RISC_PREFETCH_CTRL_Enable_Brisc_MASK 0x8
#define RISC_PREFETCH_CTRL_Enable_Brisc_RMW \
    RISC_PREFETCH_CTRL_Enable_Brisc_ADDR32, RISC_PREFETCH_CTRL_Enable_Brisc_SHAMT, RISC_PREFETCH_CTRL_Enable_Brisc_MASK

#define RISC_PREFETCH_CTRL_Enable_NocRisc_ADDR32 186
#define RISC_PREFETCH_CTRL_Enable_NocRisc_SHAMT 4
#define RISC_PREFETCH_CTRL_Enable_NocRisc_MASK 0x10
#define RISC_PREFETCH_CTRL_Enable_NocRisc_RMW                                          \
    RISC_PREFETCH_CTRL_Enable_NocRisc_ADDR32, RISC_PREFETCH_CTRL_Enable_NocRisc_SHAMT, \
        RISC_PREFETCH_CTRL_Enable_NocRisc_MASK

#define RISC_PREFETCH_CTRL_Max_Req_Count_ADDR32 186
#define RISC_PREFETCH_CTRL_Max_Req_Count_SHAMT 5
#define RISC_PREFETCH_CTRL_Max_Req_Count_MASK 0x1fe0
#define RISC_PREFETCH_CTRL_Max_Req_Count_RMW                                         \
    RISC_PREFETCH_CTRL_Max_Req_Count_ADDR32, RISC_PREFETCH_CTRL_Max_Req_Count_SHAMT, \
        RISC_PREFETCH_CTRL_Max_Req_Count_MASK
